diff -pruN 1.5.6.2-2/asciidoctor.gemspec 1.5.7-1/asciidoctor.gemspec
--- 1.5.6.2-2/asciidoctor.gemspec	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/asciidoctor.gemspec	2018-05-05 22:54:38.000000000 +0000
@@ -11,13 +11,19 @@ Gem::Specification.new do |s|
   s.email = ['dan.j.allen@gmail.com']
   s.homepage = 'http://asciidoctor.org'
   s.license = 'MIT'
+  s.metadata = {
+    'bug_tracker_uri' => 'https://github.com/asciidoctor/asciidoctor/issues',
+    'changelog_uri' => 'https://github.com/asciidoctor/asciidoctor/blob/master/CHANGELOG.adoc',
+    'mailing_list_uri' => 'http://discuss.asciidoctor.org',
+    'source_code_uri' => 'https://github.com/asciidoctor/asciidoctor'
+  }
 
   files = begin
     (result = Open3.popen3('git ls-files -z') {|_, out| out.read }.split %(\0)).empty? ? Dir['**/*'] : result
   rescue
     Dir['**/*']
   end
-  s.files = files.grep(/^(?:(?:data|lib|man)\/.+|Gemfile|Rakefile|LICENSE|(?:CHANGELOG|CONTRIBUTINGREADME(?:-\w+)?)\.adoc|#{s.name}\.gemspec)$/)
+  s.files = files.grep(/^(?:(?:data|lib|man)\/.+|Gemfile|Rakefile|LICENSE|(?:CHANGELOG|CONTRIBUTING|README(?:-\w+)?)\.adoc|#{s.name}\.gemspec)$/)
   s.executables = files.grep(/^bin\//).map {|f| File.basename f }
   s.require_paths = ['lib']
   s.test_files = files.grep(/^(?:(?:features|test)\/.+)$/)
diff -pruN 1.5.6.2-2/CHANGELOG.adoc 1.5.7-1/CHANGELOG.adoc
--- 1.5.6.2-2/CHANGELOG.adoc	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/CHANGELOG.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -13,6 +13,183 @@ endif::[]
 This document provides a high-level view of the changes introduced in Asciidoctor by release.
 For a detailed view of what has changed, refer to the {uri-repo}/commits/master[commit history] on GitHub.
 
+== 1.5.7 (2018-05-02) - @mojavelinux
+
+Enhancements::
+
+  * BREAKING: drop XML tags, character refs, and non-word characters (except hyphen, dot, and space) when auto-generating section IDs (#794)
+   ** hyphen, dot, and space are replaced with value of idseparator, if set; otherwise, spaces are dropped
+  * allow attribute names to contain any word character defined by Unicode (#2376, PR #2393)
+  * route all processor messages through a logger instead of using Kernel#warn (#44, PR #2660)
+  * add MemoryLogger for capturing messages sent to logger into memory (#44, PR #2660)
+  * add NullLogger to prevent messages from being logged (#44, PR #2660)
+  * log message containing source location / cursor as an object; provides more context (#44, PR #2660)
+  * pass cursor for include file to `:include_location` key in message context (PR #2729)
+  * add `:logger` option to API to set logger instance (#44, PR #2660)
+  * add `--failure-level=LEVEL` option to CLI to force non-zero exit code if specified logging level is reached (#2003, PR #2674)
+  * parse text of xref macro as attributes if attribute signature found (equal sign) (#2381)
+  * allow xrefstyle to be specified per xref by assigning the xrefstyle attribute on the xref macro (#2365)
+  * recognize target with .adoc extension in xref macro as an interdocument xref
+  * resolve nested includes in remote documents relative to URI (#2506, PR #2511)
+  * allow `relfilesuffix` attribute to control file extension used for interdoc xrefs (#1273)
+  * support `!name@` (preferred), `!name=@`, `name!@`, and `name!=@` syntax to soft unset attribute from API or CLI (#642, PR #2649)
+  * allow modifier to be placed at end of name to soft set an attribute (e.g., `icons@=font`) (#642, PR #2649)
+  * interpret `false` attribute value defined using API as a soft unset (#642, PR #2649)
+  * number parts if `partnums` attribute is set (#2298)
+  * allow footnote macro to define or reference footnote reference (footnoteref macro now deprecated) (#2347, PR #2362)
+  * allow custom converter to be used with custom templates; converter must declare that it supports templates (#2619)
+  * allow manpage path for manpage help topic to be specified using ASCIIDOCTOR_MANPAGE_PATH environment variable (PR #2653) (*@aerostitch*)
+  * if manpage cannot be found in default path inside gem, use `man -w asciidoctor` to resolve installed path (PR #2653)
+  * uncompress contents of manpage for manpage help topic if path ends with .gz (PR #2653) (*@aerostitch*)
+  * define source and manual refmiscinfo entries in manpage output if manual and source attributes are defined (PR #2636) (*@tiwai*)
+  * add syntax for adding hard line breaks in block AsciiMath equations (#2497, PR #2579) (*@dimztimz*)
+  * add positioning option to sectanchors attribute (sectanchors=before or sectanchors=after) (#2485, PR #2486)
+  * allow table striping to be configured using stripes attribute (even, odd, all, or none) or stripes roles on table (#1365, PR #2588)
+  * recognize `ends` as an alias to `topbot` for configuring the table frame
+  * add rel=nofollow property to links (text or image) when nofollow option is set (#2605, PR #2692)
+  * populate Document#source_location when sourcemap option is enabled (#2478, PR #2488)
+  * populate source_location property on list items when sourcemap option is set on document (PR #2069) (*@mogztter*)
+  * populate Table::Cell#source_location when sourcemap option is enabled (#2705)
+  * allow local include to be flagged as optional by setting optional option (#2389, PR #2413)
+  * allow block title to begin with a period (#2358, PR #2359)
+  * catalog inline anchor at start of list items in ordered and unordered lists, description list terms, and table cells (#2257)
+  * register document in catalog if id is set; assign reftext to document attributes if specified in a block attribute line (#2301, PR #2428)
+  * allow automatic width to be applied to individual columns in a table using the special value `~` (#1844)
+  * use the quote element in DocBook converter to represent smart quotes (#2272, PR #2356) (@bk2204)
+  * parse and pass all manpage names to output document master (i.e., shadow man pages) (#1811, #2543, PR #2414)
+  * parse credit line of shorthand quote block as block attributes; apply normal subs to credit line in shorthand quote blocks (#1667, PR #2452)
+  * populate copyright element in DocBook output from value of copyright attribute (#2728)
+  * preserve directories if source dir and destination dir are set (#1394, PR #2421)
+  * allow linkcss to be unset from API or CLI when safe mode is secure
+  * convert quote to epigraph element in DocBook output if block has epigraph role (#1195, PR #2664) (*@bk2204*)
+  * number special sections in addition to regular sections when sectnums=all (#661, PR #2463)
+  * upgrade to Font Awesome 4.7.0 (#2569)
+  * upgrade to MathJax 4.7.4
+
+Bug fixes::
+
+  * set `:to_dir` option value correctly when output file is specified (#2382)
+  * preserve leading indentation in contents of AsciiDoc table cell if contents starts with a newline (#2712)
+  * the shorthand syntax on the style to set block attributes (id, roles, options) no longer resets block style (#2174)
+  * match include tags anywhere on line as long as offset by word boundary on left and space or newline on right (#2369, PR #2683)
+  * warn if an include tag specified in the include directive is unclosed in the included file (#2361, PR #2696)
+  * use correct parse mode when parsing blocks attached to list item (#1926)
+  * fix typo in gemspec that removed README and CONTRIBUTING files from the generated gem (PR #2650) (*@aerostitch*)
+  * preserve id, role, title, and reftext on open block when converting to DocBook; wrap in `<para>` or `<formalpara>` (#2276)
+  * don't turn bare URI scheme (no host) into a link (#2609, PR #2611)
+  * don't convert inter-document xref to internal anchor unless entire target file is included into current file (#2200)
+  * fix em dash replacement in manpage converter (#2604, PR #2607)
+  * don't output e-mail address twice when replacing bare e-mail address in manpage output (#2654, PR #2665)
+  * use alternate macro for monospaced text in manpage output to not conflict w/ AsciiDoc macros (#2751)
+  * enforce that absolute start path passed to PathResolver#system_path is inside of jail path (#2642, PR #2644)
+  * fix behavior of PathResolver#descends_from? when base path equals / (#2642, PR #2644)
+  * automatically recover if start path passed to PathResolver#system_path is outside of jail path (#2642, PR #2644)
+  * re-enable left justification after invoking tmac URL macro (#2400, PR #2409)
+  * don't report warning about same level 0 section multiple times (#2572)
+  * record timings when calling convert and write on Document (#2574, PR #2575)
+  * duplicate header attributes when restoring; allows header attributes to be restored an arbitrary number of times (#2567, PR #2570)
+  * propagate `:catalog_assets` option to nested document (#2564, PR #2565)
+  * preserve newlines in quoted CSV data (#2041)
+  * allow opening quote around quoted CSV field to be on a line by itself
+  * output table footer after body rows (#2556, PR #2566) (*@PauloFrancaLacerda*)
+  * move @page outside of @media print in default stylesheet (#2531, PR #2532)
+  * don't throw exception if text of dd node is nil (#2529, PR #2530)
+  * don't double escape ampersand in manpage output (#2525) (*@dimztimz*)
+  * fix crash when author_1 attribute is assigned directly (#2481, PR #2487)
+  * fix CSS for highlighted source block inside colist (#2474, PR #2490)
+  * don't append file extension to data uri of admonition icon (#2465, PR #2466)
+  * fix race condition in Helpers.mkdir_p (#2457, PR #2458)
+  * correctly process nested passthrough inside unconstrained monospaced (#2442, PR #2443)
+  * add test to ensure ampersand in author line is not double escaped (#2439, PR #2440)
+  * prevent footnote ID from clashing with auto-generated footnote IDs (#2019)
+  * fix alignment of icons in footnote (#2415, PR #2416)
+  * add graceful fallback if pygments.rb fails to return a value (#2341, PR #2342)
+  * escape specialchars in source if pygments fails to highlight (#2341)
+  * do not recognize attribute entry line if name contains colon (PR #2377)
+  * allow flow indexterm to be enclosed in round brackets (#2363, PR #2364)
+  * set outfilesuffix to match file extension of output file (#2258, PR #2367)
+  * add block title to dlist in manpage output (#1611, PR #2434)
+  * scale text to 80% in print styles (#1484, PR #2576)
+  * fix alignment of abstract title when using default stylesheet (PR #2732)
+  * only set nowrap style on table caption for auto-width table (#2392)
+  * output non-breaking space for man manual if absent in DocBook output (PR #2636)
+  * don't crash if stem type is not recognized (instead, fallback to asciimath)
+
+Improvements / Refactoring::
+
+  * BREAKING: rename table spread role to stretch (#2589, PR #2591)
+  * use cursor marks to track lines more accurately; record cursor at the start of each block, list item, or table cell (PR #2701, PR #2547) (*@seikichi*)
+  * log a warning message if an unterminated delimited block is detected (#1133, PR #2612)
+  * log a warning when nested section is found inside special section that doesn't support nested sections (#2433, PR #2672)
+  * read files in binary mode to disable automatic endline coercion (then explicitly coerce to UTF-8) (PR #2583, PR #2694)
+  * resolve / expand parent references in start path passed to PathResolver#system_path (#2642, PR #2644)
+  * update PathResolver#expand_path to resolve parent references (#2642, PR #2644)
+  * allow start path passed to PathResolver#system_path to be outside jail if target brings resolved path back inside jail (#2642, PR #2644)
+  * don't run File.expand_path on Dir.pwd (assume Dir.pwd is absolute) (#2642, PR #2644)
+  * posixify working_dir passed to PathResolver constructor if absolute (#2642, PR #2644)
+  * optimize detection for footnote* and indexterm* macros (#2347, PR #2362)
+  * log a warning if a footnote reference cannot be resolved (#2669)
+  * set logger level to DEBUG when verbose is enabled
+  * coerce value of `:template_dirs` option to an Array (PR #2621)
+  * make block roles specified using shorthand syntax additive (#2174)
+  * allow paragraph to masquerade as open block (PR #2412)
+  * move callouts into document catalog (PR #2394)
+  * document ID defined in block attribute line takes precedence over ID defined inside document title line
+  * don't look for link and window attributes on document when resolving these attributes for an image
+  * when linkattrs is set, only parse attributes in link macro if equals is present
+  * skip line comments in name section of manpage (#2584, PR #2585)
+  * always activate extension registry passed to processor (PR #2379)
+  * skip extension registry activation if no groups are registered (PR #2373)
+  * don't apply lead styling to first paragraph if role is present (#2624, PR #2625)
+  * raise clearer exception when extension class cannot be resolved (#2622, PR #2623)
+  * add methods to read results from timings (#2578, PR #2580)
+  * collapse bottom margin of last block in AsciiDoc table cell (#2568, PR #2593)
+  * set authorcount to 0 if there are no authors (#2519, PR #2520)
+  * validate fragment of interdoc xref that resolves to current doc (#2448, PR #2449)
+  * put id attribute on tag around phrase instead of preceding anchor (#2445, PR #2446)
+  * add .plist extension to XML circumfix comment family (#2430, PR #2431) (*@akosma*)
+  * alias Document#title method to no args Document#doctitle method (#2429, PR #2432)
+  * upgrade missing or unreadable include file to an error (#2424, PR #2426)
+  * add compliance setting to disable natural cross references (#2405, PR #2460)
+  * make hash in inter-document xref target optional if target has extension (#2404, PR #2406)
+  * add CSS class to part that matches role (#2401, PR #2402)
+  * add fit-content class to auto-width table (#2392)
+  * automatically assign parent reference when adding node to parent (#2398, PR #2403)
+  * leave inline anchor in section title as is if section has ID (#2243, PR #2427)
+  * align and improve error message about invalid use of partintro between HTML5 and DocBook converters
+  * rephrase warning when level 0 sections are found and the doctype is not book
+  * report correct line number when duplicate bibliography anchor is found
+  * only warn if thread_safe gem is missing when using built-in template cache
+  * rename enumerate_section to assign_numeral; update API docs
+  * drop deprecated compact option from CLI; remove from manpage
+  * use more robust mechanism for lazy loading the asciimath gem
+  * use consistent phrase to indicate the processor is automatically recovering from a problem
+  * change Reader#skip_comment_lines to not return skipped lines
+  * add styles to default stylesheet for display on Kindle (kf8) devices (PR #2475)
+  * purge render method from test suite (except to verify alias)
+
+Documentation::
+
+  * translate 'section-refsig' for German language (PR #2633) (*@ahus1*)
+  * synchronize French README with English version (PR #2637) (*@flashcode*)
+
+Build / Infrastructure::
+
+  * create an official logo for the project (#48) (*@mmajko*)
+  * update Ruby versions in appveyor build matrix (PR #2388) (*@miltador*)
+  * add mailinglist, changelog, source, and issues URI to gem spec
+  * allow blocks and substitutions tests to be run directly
+  * asciidoctor formula now available for Homebrew (*@zmwangx*)
+
+Distribution Packages::
+
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
+  * https://pkgs.alpinelinux.org/packages?name=asciidoctor[Alpine Linux (asciidoctor)]
+  * https://software.opensuse.org/package/rubygem-asciidoctor[OpenSUSE (rubygem-asciidoctor)]
+
 // tag::compact[]
 == 1.5.6.2 (2018-03-20) - @mojavelinux
 
@@ -26,7 +203,7 @@ Improvements / Refactoring::
   * resolve include target correctly in browser (xmlhttprequest IO module) (#2599, #2602)
   * extract method to resolve include path (allowing Asciidoctor.js to override) (#2610)
   * don't expand docdir value passed to API (#2518)
-  * check mandatory attributes when creating an image block (#2349)
+  * check mandatory attributes when creating an image block (#2349, PR #2355) (*@mogztter*)
   * drop is_ prefix from boolean methods in PathResolver (PR #2587)
   * change Reader#replace_next_line to return true
   * organize methods in AbstractNode
@@ -35,14 +212,15 @@ Build / Infrastructure::
 
   * clean up dependencies
   * add Ruby 2.5.0 to CI build matrix (PR #2528)
-  * update nokogiri to 1.8.0 for ruby >= 2.1 (PR #2380)
+  * update nokogiri to 1.8.0 for ruby >= 2.1 (PR #2380) (*@miltador*)
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
+  * https://pkgs.alpinelinux.org/packages?name=asciidoctor[Alpine Linux (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.6.2[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.6.2[git tag] |
@@ -51,6 +229,10 @@ https://github.com/asciidoctor/asciidoct
 
 == 1.5.6.1 (2017-07-23) - @mojavelinux
 
+Enhancements::
+
+  * Don't include title of special section in DocBook output if untitled option is set (e.g., dedication%untitled)
+
 Bug fixes::
 
   * continue to read blocks inside a delimited block after content is skipped (PR #2318)
@@ -91,14 +273,16 @@ Build / Infrastructure::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
+  * https://pkgs.alpinelinux.org/packages?name=asciidoctor[Alpine Linux (asciidoctor)]
+  * https://software.opensuse.org/package/rubygem-asciidoctor[OpenSUSE (rubygem-asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.6.1[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.6.1[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.6...v1.5.6.1[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.6\...v1.5.6.1[full diff]
 
 == 1.5.6 (2017-07-12) - @mojavelinux
 
@@ -115,7 +299,7 @@ Enhancements::
   * allow extension groups to be unregistered individually (#1701)
   * catalog bibliography anchors and capture reftext (#560, #1562)
   * automatically add bibliography style to unordered list in bibliography section (#1924)
-  * disable startinline option when highlighting PHP if mixed option is set on source block (PR #2015) (@ricpelo)
+  * disable startinline option when highlighting PHP if mixed option is set on source block (PR #2015) (*@ricpelo*)
   * configure Slim to resolve includes in specified template dirs (#2214)
   * dump manpage when -h manpage flag is passed to CLI (#2302)
   * add resolves_attributes method to DSL for macros (#2122)
@@ -143,7 +327,7 @@ Improvements::
   * process include directive inside text of short form preprocessor conditional (#2146)
   * add support for include tags in languages that only support only circumfix comments (#1729)
   * allow spaces in target of block image; target must start and end with non-space (#1943)
-  * add warning in verbose mode if xref is not found (@fap-) (#2268)
+  * add warning in verbose mode if xref is not found (#2268) (*@fapdash*)
   * add warning if duplicate ID is detected (#2244)
   * validate that output file will not overwrite input file (#1956)
   * include docfile in warning when stylesheet cannot be read (#2089)
@@ -179,7 +363,7 @@ Improvements::
   * be more precise about splitting kbd characters (#1660)
   * rename limit method on String to limit_bytesize (#1889)
   * leverage Ruby's match? method to speed up non-capturing regexps (PR #1938)
-  * preserve inline break in manpages (@letheed)
+  * preserve inline break in manpages (*@letheed*)
   * check for presence of SOURCE_DATE_EPOCH instead of value; fail if value is malformed
   * add Rows#by_section method to return table sections (#2219)
   * cache which template engines have been loaded to avoid unnecessary processing
@@ -247,6 +431,7 @@ Bug fixes::
   * don't allow table borders to cascade to nested tables (#2151)
   * escape special characters in reftext of anchor (#1694)
   * sanitize content of authors meta tag in HTML output (#2112)
+  * use correct line number in warning for invalid callout item reference (#2275)
   * fix stray marks added when unescaping unconstrained passthroughs (PR #2079)
   * don't confuse escaped quotes in CSV data as enclosing quotes (#2008)
   * don't activate implicit header if cell in first line of table contains a blank line (#1284, #644)
@@ -259,7 +444,7 @@ Bug fixes::
   * fix regression of not matching short form of custom block macro
   * encode double quotes in image alt text when used in an attribute (#2061)
   * encode double quote and strip XML tags in value of xreflabel attribute in DocBook converter (PR #2220)
-  * fix typo in base64 data (PR #2094) (@mogztter)
+  * fix typo in base64 data (PR #2094) (*@mogztter*)
   * permit pass macro to surround a multi-line attribute value with hard line breaks (#2211)
   * fix sequential inline anchor macros with empty reftext (#1689)
   * don't mangle compound names when document has multiple authors (#663)
@@ -269,8 +454,8 @@ Bug fixes::
   * remove max-width on the callout number icon (#1895)
   * eagerly add hljs class for highlight.js (#2221)
   * fix SOURCE_DATE_EPOCH lookup in Opal
-  * fix paths with file URI scheme are inevitably absolute (PR #1925) (@mogztter)
-  * only resolve file URLs when JavaScript IO module is xmlhttprequest (PR #1898) (@mogztter)
+  * fix paths with file URI scheme are inevitably absolute (PR #1925) (*@mogztter*)
+  * only resolve file URLs when JavaScript IO module is xmlhttprequest (PR #1898) (*@mogztter*)
   * fix formatting of video title in manpage converter
   * don't increment line number if peek_lines overruns buffer (fixes some cases when line number is off)
   * freeze extension processor instance, not class
@@ -279,54 +464,55 @@ Bug fixes::
 
 Documentation::
   * enable admonition icons in README when displayed on GitHub
-  * add German translation of chapter-label (PR #1920) (@fap-)
-  * add Ukrainian translation of built-in attributes (PR #1955) (@hedrok)
-  * add Norwegian Nynorsk translation; updated Norwegian Bokmål translation of built-in attributes (PR #2142) (@huftis)
-  * add Polish translation of built-in attributes (PR #2131) (@ldziedziul)
-  * add Romanian translation of built-in attributes (PR #2125) (@vitaliel)
-  * fix Japanese translation of built-in attributes (PR #2116) (@haradats)
-  * add Bahasa Indonesia translation of built-in labels (@triyanwn)
+  * add German translation of chapter-label (PR #1920) (*@fapdash*)
+  * add Ukrainian translation of built-in attributes (PR #1955) (*@hedrok*)
+  * add Norwegian Nynorsk translation; updated Norwegian Bokmål translation of built-in attributes (PR #2142) (*@huftis*)
+  * add Polish translation of built-in attributes (PR #2131) (*@ldziedziul*)
+  * add Romanian translation of built-in attributes (PR #2125) (*@vitaliel*)
+  * fix Japanese translation of built-in attributes (PR #2116) (*@haradats*)
+  * add Bahasa Indonesia translation of built-in labels (*@triyanwn*)
 
 Build / Infrastructure::
   * upgrade highlight.js to 9.12.0 (#1652)
-  * include entire test suite in gem (PR #1952) (@voxik)
-  * upgrade Slim development dependency to 3.0.x (PR #1953) (@voxik)
+  * include entire test suite in gem (PR #1952) (*@voxik*)
+  * upgrade Slim development dependency to 3.0.x (PR #1953) (*@voxik*)
   * upgrade Haml development dependency to 5.0.x
   * upgrade Nokogiri to 1.6.x (except on Ruby 1.8) (PR #1213)
   * add Ruby 2.4 to CI test matrix (PR #1980)
   * upgrade cucumber and JRuby in CI build (PR #2005)
-  * fix reference to documentation in attributes.adoc (PR #1901) (@stonio)
+  * fix reference to documentation in attributes.adoc (PR #1901) (*@stonio*)
   * trap and verify all warnings when tests are run with warnings enabled
   * set default task in build to test:all
   * configure run-tests.sh script to run all tests
   * configure feature tests to only show progress
   * configure Slim in feature tests to use html as format instead of deprecated html5
   * lock version of yard to fix invalid byte sequence in Ruby 1.9.3
-  * modify rake build to trigger dependent builds (specifically, Asciidoctor.js) (@mogztter) (PR #2305)
+  * modify rake build to trigger dependent builds (specifically, Asciidoctor.js) (PR #2305) (*@mogztter*)
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
+  * https://pkgs.alpinelinux.org/packages?name=asciidoctor[Alpine Linux (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.6[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.6[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.5...v1.5.6[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.5\...v1.5.6[full diff]
 
 == 1.5.5 (2016-10-05) - @mojavelinux
 
 Enhancements::
   * Add preference to limit the maximum size of an attribute value (#1861)
-  * Honor SOURCE_DATE_EPOCH environment variable to accomodate reproducible builds (@JojoBoulix) (#1721)
+  * Honor SOURCE_DATE_EPOCH environment variable to accomodate reproducible builds (#1721) (*@JojoBoulix*)
   * Add reversed attribute to ordered list if reversed option is enabled (#1830)
   * Add support for additional docinfo locations (e.g., :header)
   * Configure default stylesheet to break monospace word if exceeds length of line; add roles to prevent breaks (#1814)
-  * Introduce translation file for built-in labels (@ciampix)
-  * Provide translations for built-in labels (@JmyL - kr, @ciampix - it, @ivannov - bg, @maxandersen - da, @radcortez - pt, @eddumelendez - es, @leathersole - jp, @aslakknutsen - no, @shahryareiv - fa, @AlexanderZobkov - ru, @dongwq - zh, @rmpestano - pt_BR, @ncomet - fr, @lgvz - fi, @patoi - hu, @BojanStipic - sr, @fwilhe - de, @rahmanusta - tr, @abelsromero - ca, @aboullaite - ar, @roelvs - nl)
-  * Translate README to Chinese (@diguage)
-  * Translate README to Japanese (@Mizuho32)
+  * Introduce translation file for built-in labels (*@ciampix*)
+  * Provide translations for built-in labels (*@JmyL* - kr, *@ciampix* - it, *@ivannov* - bg, *@maxandersen* - da, *@radcortez* - pt, *@eddumelendez* - es, *@leathersole* - jp, *@aslakknutsen* - no, *@shahryareiv* - fa, *@AlexanderZobkov* - ru, *@dongwq* - zh, *@rmpestano* - pt_BR, *@ncomet* - fr, *@lgvz* - fi, *@patoi* - hu, *@BojanStipic* - sr, *@fwilhe* - de, *@rahmanusta* - tr, *@abelsromero* - ca, *@aboullaite* - ar, *@roelvs* - nl)
+  * Translate README to Chinese (*@diguage*)
+  * Translate README to Japanese (*@Mizuho32*)
 
 Improvements::
   * Style nested emphasized phrases properly when using default stylesheet (#1691)
@@ -338,12 +524,12 @@ Improvements::
   * Enable font smoothing on Firefox on OSX (#1837)
   * Support combined use of sectanchors and sectlinks in HTML5 output (#1806)
   * fix API docs for find_by
-  * Upgrade to Font Awesome 4.6.3 (@allenan, @mogztter) (#1723)
+  * Upgrade to Font Awesome 4.6.3 (#1723) (*@allenan*, *@mogztter*)
   * README: add install instructions for Alpine Linux
   * README: Switch yum commands to dnf in README
   * README: Mention Mint as a Debian distro that packages Asciidoctor
-  * README: Add caution advising against using gem update to update a system-managed gem (@oddhack)
-  * README: sync French version with English version (@flashcode)
+  * README: Add caution advising against using gem update to update a system-managed gem (*@oddhack*)
+  * README: sync French version with English version (*@flashcode*)
   * Add missing endline after title element when converting open block to HTML
   * Move list_marker_keyword method from AbstractNode to AbstractBlock
   * Rename definition list to description list internally
@@ -366,23 +552,24 @@ Bug fixes::
 
 Infrastructure::
   * Build gem properly in the absense of a git workspace, make compatible with JRuby (#1779)
-  * Run tests in CI using latest versions of Ruby, including Ruby 2.3 (@ferdinandrosario)
+  * Run tests in CI using latest versions of Ruby, including Ruby 2.3 (*@ferdinandrosario*)
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
+  * https://pkgs.alpinelinux.org/packages?name=asciidoctor[Alpine Linux (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.5[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.5[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.4...v1.5.5[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.4\...v1.5.5[full diff]
 
 == 1.5.4 (2016-01-03) - @mojavelinux
 
 Enhancements::
-  * translate README into French (@anthonny, @mogztter, @gscheibel, @mgreau) (#1630)
+  * translate README into French (#1630) (*@anthonny*, *@mogztter*, *@gscheibel*, *@mgreau*)
   * allow linkstyle in manpage output to be configured (#1610)
 
 Improvements::
@@ -390,9 +577,9 @@ Improvements::
   * upgrade to Font Awesome 4.5.0
   * disable toc if document has no sections (#1633)
   * convert inline asciimath to MathML (using asciimath gem) in DocBook converter (#1622)
-  * add attribute to control build reproducibility (@bk2204) (#1453)
+  * add attribute to control build reproducibility (#1453) (*@bk2204*)
   * recognize \file:/// as a file root in Opal browser env (#1561)
-  * honor icon attribute on admonition block when font-based icons are enabled (@robertpanzer) (#1593)
+  * honor icon attribute on admonition block when font-based icons are enabled (#1593) (*@robertpanzer*)
   * resolve custom icon relative to iconsdir; add file extension if absent (#1634)
   * allow asciidoctor cli to resolve library path when invoked without leading ./
 
@@ -408,13 +595,13 @@ Bug fixes::
   * don't swallow trailing line when include file is not readable (#1602)
   * change xlink namespace to xl in DocBook 5 output to prevent parse error (#1597)
   * make callouts globally unique within document, including AsciiDoc table cells (#1626)
-  * initialize Slim-related attributes regardless of when Slim was loaded (@terceiro) (#1576)
-  * differentiate literal backslash from escape sequence in manpage output (@ds26gte) (#1604)
-  * don't mistake line beginning with \. for troff macro in manpage output (@ds26gte) (#1589)
-  * escape leading dots so user content doesn't trigger troff macros in manpage output (@ds26gte) (#1631)
-  * use \c after .URL macro to remove extraneous space in manpage output (@ds26gte) (#1590)
+  * initialize Slim-related attributes regardless of when Slim was loaded (#1576) (*@terceiro*)
+  * differentiate literal backslash from escape sequence in manpage output (#1604) (*@ds26gte*)
+  * don't mistake line beginning with \. for troff macro in manpage output (#1589) (*@ds26gte*)
+  * escape leading dots so user content doesn't trigger troff macros in manpage output (#1631) (*@ds26gte*)
+  * use \c after .URL macro to remove extraneous space in manpage output (#1590) (*@ds26gte*)
   * fix missing endline after .URL macro in manpage output (#1613)
-  * properly handle spacing around .URL/.MTO macro in manpage output (@ds26gte) (#1641)
+  * properly handle spacing around .URL/.MTO macro in manpage output (#1641) (*@ds26gte*)
   * don't swallow doctitle attribute followed by block title (#1587)
   * change strategy for splitting names of author; fixes bug in Opal/Asciidoctor.js
   * don't fail if library is loaded more than once
@@ -429,36 +616,36 @@ Infrastructure::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.4[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.4[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.3...v1.5.4[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.3\...v1.5.4[full diff]
 
 == 1.5.3 (2015-10-31) - @mojavelinux
 
 Enhancements::
   * add support for interactive & inline SVGs (#1301, #1224)
-  * add built-in manpage backend (@davidgamba) (#651)
-  * create Mallard backend; asciidoctor/asciidoctor-mallard (@bk2204) (#425)
-  * add AsciiMath to MathML converter to support AsciiMath in DocBook converter (@pepijnve) (#954)
+  * add built-in manpage backend (#651) (*@davidgamba*)
+  * create Mallard backend; asciidoctor/asciidoctor-mallard (#425) (*@bk2204*)
+  * add AsciiMath to MathML converter to support AsciiMath in DocBook converter (#954) (*@pepijnve*)
   * allow text of selected lines to be highlighted in source block by Pygments or CodeRay (#1429)
   * use value of `docinfo` attribute to control docinfo behavior (#1510)
-  * add `docinfosubs` attribute to control which substitutions are performed on docinfo files (@mogztter) (#405)
-  * drop ability to specify multiple attributes with a single `-a` flag when using the CLI (@mogztter) (#405)
-  * make subtitle separator chars for document title configurable (@rmannibucau) (#1350)
+  * add `docinfosubs` attribute to control which substitutions are performed on docinfo files (#405) (*@mogztter*)
+  * drop ability to specify multiple attributes with a single `-a` flag when using the CLI (#405) (*@mogztter*)
+  * make subtitle separator chars for document title configurable (#1350) (*@rmannibucau*)
   * make XrefInlineRx regexp more permissive (Mathieu Boespflug) (#844)
 
 Improvements::
-  * load JavaScript and CSS at bottom of HTML document (@mogztter) (#1238)
-  * list available backends in help text (@plaindocs) (#1271)
+  * load JavaScript and CSS at bottom of HTML document (#1238) (*@mogztter*)
+  * list available backends in help text (#1271) (*@plaindocs*)
   * properly expand tabs in literal text (#1170, #841)
-  * add `source-indent` as document attribute (@mogztter) (#1169)
+  * add `source-indent` as document attribute (#1169) (*@mogztter*)
   * upgrade MathJax to 2.5.3 (#1329)
-  * upgrade Font Awesome to 4.4.0 (@mogztter) (#1465)
+  * upgrade Font Awesome to 4.4.0 (#1465) (*@mogztter*)
   * upgrade highlight.js to 8.6 (now 8.9.1) (#1390)
   * don't abort if syntax highlighter isn't available (#1253)
   * insert docinfo footer below footer div (#1503)
@@ -467,10 +654,10 @@ Improvements::
   * restore attributes to header attributes after parse (#1255)
   * allow docdate and doctime to be overridden (#1495)
   * add CSS class `.center` for center block alignment (#1456)
-  * recognize U+2022 (bullet) as alternative marker for unordered lists (@mogztter) (#1177)
+  * recognize U+2022 (bullet) as alternative marker for unordered lists (#1177) (*@mogztter*)
   * allow videos to work for local files by prepending asset-uri-scheme (Chris) (#1320)
   * always assign playlist param when loop option is enabled for YouTube video
-  * parse isolated version in revision line (@bk2204) (#790)
+  * parse isolated version in revision line (#790) (*@bk2204*)
   * autoload Tilt when template converter is instantiated (#1313)
   * don't overwrite existing id entry in references table (#1256)
   * use outfilesuffix attribute defined in header when resolving outfile (#1412)
@@ -481,15 +668,15 @@ Improvements::
   * load Droid Sans Mono 700 in default stylesheet
   * set line height of table cells used for syntax highlighting
   * set font-family of kbd; refine styling (#1423)
-  * extract condition into `quote_lines?` method (@mogztter)
-  * extract inline code into `read_paragraph` method (@mogztter)
+  * extract condition into `quote_lines?` method (*@mogztter*)
+  * extract inline code into `read_paragraph` method (*@mogztter*)
   * parent of block in ListItem should be ListItem (#1359)
   * add helper methods to List and ListItem (#1551)
-  * add method `AbstractNode#add_role` and `AbstractNode#remove_role` (@robertpanzer) (#1366)
+  * add method `AbstractNode#add_role` and `AbstractNode#remove_role` (#1366) (*@robertpanzer*)
   * introduce helper methods for sniffing URIs (#1422)
   * add helper to calculate basename without file extension
-  * document `-I` and `-r` options in the manual page (@bk2204)
-  * fix `+--help+` output text for `-I` (@bk2204)
+  * document `-I` and `-r` options in the manual page (*@bk2204*)
+  * fix `+--help+` output text for `-I` (*@bk2204*)
   * don't require open-uri-cached if already loaded
   * do not attempt to scan pattern of non-existent directory in template converter
   * prevent CodeRay from bolding every 10th line number
@@ -504,7 +691,7 @@ Compliance::
 
 Bug fixes::
   * don't truncate exception stack in `Asciidoctor.load` (#1248)
-  * don't fail to save cause of Java exception (@robertpanzer) (#1458)
+  * don't fail to save cause of Java exception (#1458) (*@robertpanzer*)
   * fix precision error in timings report (#1342)
   * resolve regexp for inline macro lazily (#1336)
   * block argument to `find_by` should filter results (#1393)
@@ -521,7 +708,7 @@ Bug fixes::
   * fix invalid color value in default CodeRay theme
   * built-in writer no longer fails if output is nil (#1544)
   * custom template engine options should take precedence
-  * fallback to require with a non-relative path to support Debian package (@mogztter)
+  * fallback to require with a non-relative path to support Debian package (*@mogztter*)
   * pass opts to recursive invocations of `PathResolver#system_path`
   * fix and test external links in docbook backend
   * use format symbol `:html` instead of `:html5` for Slim to fix warnings
@@ -537,28 +724,28 @@ Infrastructure::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.3[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.3[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.2...v1.5.3[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.2\...v1.5.3[full diff]
 
 == 1.5.2 (2014-11-27) - @mojavelinux
 
 Enhancements::
 
-  * add docinfo extension (@mogztter) (#1162)
-  * allow docinfo to be in separate directory from content, specified by `docinfodir` attribute (@mogztter) (#511)
-  * enable TeX equation auto-numbering if `eqnums` attribute is set (@jxxcarlson) (#1110)
+  * add docinfo extension (#1162) (*@mogztter*)
+  * allow docinfo to be in separate directory from content, specified by `docinfodir` attribute (#511) (*@mogztter*)
+  * enable TeX equation auto-numbering if `eqnums` attribute is set (#1110) (*@jxxcarlson*)
 
 Improvements::
 
   * recognize `--` as valid line comment for callout numbers; make line comment configurable (#1068)
   * upgrade highlight.js to version 8.4 (#1216)
-  * upgrade Font Awesome to version 4.2.0 (@clojens) (#1201)
+  * upgrade Font Awesome to version 4.2.0 (#1201) (*@clojens*)
   * define JAVASCRIPT_PLATFORM constant to simplify conditional logic in the JavaScript environment (#897)
   * provide access to destination directory, outfile and outdir via Document object (#1203)
   * print encoding information in version report produced by `asciidoctor -v` (#1210)
@@ -569,13 +756,13 @@ Improvements::
   * make start number for unique id generation configurable (#1148)
   * normalize and force UTF-8 encoding of docinfo content (#831)
   * allow subs and default_subs to be specified in Block constructor (#749)
-  * enhance error message when reading binary input files (@mogztter) (#1158)
+  * enhance error message when reading binary input files (#1158) (*@mogztter*)
   * add `append` method as alias to `<<` method on AbstractBlock (#1085)
   * assign value of `preface-title` as title of preface node (#1090)
   * fix spacing around checkbox in checklist (#1138)
-  * automatically load Slim's include plugin when using slim templates (@jirutka) (#1151)
-  * mixin Slim helpers into execution scope of slim templates (@jirutka) (#1143)
-  * improve DocBook output for manpage doctype (@bk2204) (#1134, #1142)
+  * automatically load Slim's include plugin when using slim templates (#1151) (*@jirutka*)
+  * mixin Slim helpers into execution scope of slim templates (#1143) (*@jirutka*)
+  * improve DocBook output for manpage doctype (#1134, #1142) (*@bk2204*)
 
 Compliance::
 
@@ -591,14 +778,14 @@ Bug fixes::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.2[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.2[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.1...v1.5.2[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.1\...v1.5.2[full diff]
 
 == 1.5.1 (2014-09-29) - @mojavelinux
 
@@ -622,14 +809,14 @@ Improvements::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?q=milestone%3Av1.5.1[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.1[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v1.5.0...v1.5.1[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v1.5.0\...v1.5.1[full diff]
 
 == 1.5.0 (2014-08-12) - @mojavelinux
 
@@ -651,10 +838,10 @@ Enhancements::
   * {star} switch to open source fonts (Open Sans, Noto Serif and Droid Sans Mono) in default stylesheet, major refinements to theme (#879)
   * {star} embed remote images when data-uri and allow-uri-read attributes are set (#612)
   * {star} support leveloffset on include directive and honor relative leveloffset values (#530)
-  * {star} switch default docbook backend to docbook5 (@bk2204) (#554)
+  * {star} switch default docbook backend to docbook5 (#554) (*@bk2204*)
   * {star} added hide-uri-scheme attribute to hide uri scheme in automatic links (#800)
   * {star} allow substitutions to be incrementally added & removed (#522)
-  * {star} add compatibility with Opal, add shim compat library, use compatibility regexp, require libraries properly (@mogztter) (#679, #836, #846)
+  * {star} add compatibility with Opal, add shim compat library, use compatibility regexp, require libraries properly (#679, #836, #846) (*@mogztter*)
   * {star} output XHTML when backend is xhtml or xhtml5 (#494)
   * {star} add shorthand subs and specialchars as an alias for specialcharacters (#579)
   * {star} deprecate toc2 attribute in favor of position and placement values on toc attribute (e.g., toc=left) (#706)
@@ -677,9 +864,9 @@ Improvements::
 
   * {star} don't select lines that contain a tag directive when including tagged lines, make tag regexp more strict (#1027)
   * {star} use https scheme for assets by default
-  * {star} upgrade to Font Awesome 4.1 (@mogztter) (#752)
-  * {star} improve print styles, add print styles for book doctype (@leif81) (#997, #952)
-  * {star} add proper grid and frame styles for tables (@leif81) (#569)
+  * {star} upgrade to Font Awesome 4.1 (#752) (*@mogztter*)
+  * {star} improve print styles, add print styles for book doctype (#997, #952) (*@leif81*)
+  * {star} add proper grid and frame styles for tables (#569) (*@leif81*)
   * {star} use glyphs for checkboxes when not using font icons (#878)
   * {star} prefer source-language attribute over language attribute for defining default source language (#888)
   * {star} pass document as first argument to process method on Preprocessor
@@ -692,15 +879,15 @@ Improvements::
   * constrain subscript & superscript markup (#564, #936)
   * match cell specs when cell separator is customized (#985)
   * use stylesheet to set default table width (#975)
-  * display nested elements correctly in toc (@kenfinnigan) (#967)
-  * add support for id attribute on links (@mogztter) (#935)
-  * add support for title attribute on links (@aslakknutsen)
-  * add -t flag to cli to control output of timing information (@mogztter) (#909)
+  * display nested elements correctly in toc (#967) (*@kenfinnigan*)
+  * add support for id attribute on links (#935) (*@mogztter*)
+  * add support for title attribute on links (*@aslakknutsen*)
+  * add -t flag to cli to control output of timing information (#909) (*@mogztter*)
   * rewrite converter API (#778)
   * rewrite extensions to support extension instances for AsciidoctorJ (#804)
   * integrate thread_safe gem (#638)
   * allow inline macro extensions that define a custom regexp to be matched (#792)
-  * make Reader#push_include work with default file, path and dir (@bk2204) (#743)
+  * make Reader#push_include work with default file, path and dir (#743) (*@bk2204*)
   * honor custom outfilesuffix and introduce relfileprefix (#801)
   * add author and copyright to meta in HTML5 backend (#838)
   * output attribution in front of citetitle for quote and verse blocks
@@ -712,7 +899,7 @@ Improvements::
   * remove trailing endlines from source data (#727)
   * add flag to cli to suppress warnings (#557)
   * emit warning if tag(s) not found in include file (#639)
-  * use <th> element for vertical table headers instead of header class (@davidgamba) (#738)
+  * use <th> element for vertical table headers instead of header class (#738) (*@davidgamba*)
   * share select references between AsciiDoc-style cell & main document (#729)
   * number chapters sequentially, always (#685)
   * add vbar attribute, make brvbar resolve properly (#643)
@@ -720,20 +907,20 @@ Improvements::
   * enable sidebar toc for small screens (#628)
   * add square brackets around button in HTML output (#631)
   * make language hover text work for all languages in listing block
-  * set background color on toc2 to cover scrolling content (@neher)
+  * set background color on toc2 to cover scrolling content (*@neher*)
   * make document parsing a discrete step, make Reader accessible as property on Document
   * allow custom converter to set backend info such as outfilesuffix and htmlsyntax
-  * report an informative error message when a converter cannot be resolved (@mogztter)
+  * report an informative error message when a converter cannot be resolved (*@mogztter*)
   * add conum class to b element when icons are disabled, make conum CSS selector more specific
-  * expose Document object to extension point IncludeProcessor (@aslakknutsen)
+  * expose Document object to extension point IncludeProcessor (*@aslakknutsen*)
   * style audioblock title, simplify rules for block titles
   * alias :name_attributes to :positional_attributes in extension DSL
-  * upgrade to highlight.js 7.4 (and later 8.0) (@mogztter) (#756)
+  * upgrade to highlight.js 7.4 (and later 8.0) (#756) (*@mogztter*)
 
 Compliance::
 
   * only include xmlns in docbook45 backend if xmlns attribute is specified (#929)
-  * add xmlns attribute for xhtml output (@bk2204)
+  * add xmlns attribute for xhtml output (*@bk2204*)
   * warn if table without a body is converted to DocBook (#961)
   * wrap <para> around admonition inside example block in DocBook 4.5 (#931)
   * use <informalfigure> if block image doesn't have a title (#927)
@@ -742,20 +929,20 @@ Compliance::
   * add compliance setting to control use of shorthand property syntax (#789)
   * wrap top-level content inside preamble in DocBook backend when doctype is book (#971)
   * escape special chars in image alt text (#972)
-  * set starting number in ordered list for docbook (@megathaum) (#925)
+  * set starting number in ordered list for docbook (#925) (*@megathaum*)
   * match word characters in regular expressions as defined by Unicode (#892)
   * put source language class names on child code element of pre element (#921)
   * ignore case of attribute in conditional directives (#903)
   * allow attribute entry to reset / reseed counter (#870)
   * allow doctype to be set in AsciiDoc table cell (#863)
-  * match URL macro following entity (@jmbruel) (#819)
+  * match URL macro following entity (#819) (*@jmbruel*)
   * handle BOM when normalizing source (#824)
   * don't output revhistory if revdate is not set (#802)
   * perform normal subs on verse content (#799)
   * automatically wrap part intro content in partintro block, emit warning if part is invalid (#768)
   * force encoding of docinfo content to UTF-8 (#773)
   * add scaling & alignment attributes to block image in DocBook backend (#763)
-  * add support for pass:[anchor:<id>[<reftext>\]] macro (#531)
+  * add support for \anchor:<id>[<reftext>] macro (#531)
   * substitute anchor and xref macros in footnotes (#676)
   * remove all string mutation operations for compatibility with Opal (#735)
   * honor reftext defined in embedded section title anchor (#697)
@@ -789,18 +976,18 @@ Bug Fixes::
   * fixed broken passthroughs caused by source highlighting (#720)
   * copy custom stylesheet if linkcss is set (#300)
   * honor list continuations for indented, nested list items (#664)
-  * fix syntax errors in converters (@jljouannic)
+  * fix syntax errors in converters (*@jljouannic*)
   * fix iconfont-remote setting
-  * fix syntax error (target -> node.target) in Docbook 5 converter (@jf647)
+  * fix syntax error (target -> node.target) in Docbook 5 converter (*@jf647*)
   * output and style HTML for toc macro correctly
 
 Infrastructure::
 
   * add Ruby 2.1 to list of supported platforms
   * reenable rbx in Travis build
-  * switch tests to minitest (@ktdreyer)
-  * update RPM for Fedora Rawhide (@ktdreyer)
-  * refactor unit tests so they work in RubyMine (@cmoulliard)
+  * switch tests to minitest (*@ktdreyer*)
+  * update RPM for Fedora Rawhide (*@ktdreyer*)
+  * refactor unit tests so they work in RubyMine (*@cmoulliard*)
   * add preliminary benchmark files to repository (#1021)
   * clean out old fixtures from test suite (#960)
   * add initial Cucumber test infrastructure (#731)
@@ -808,18 +995,18 @@ Infrastructure::
   * build gemspec files using git ls-tree (#653)
   * use in-process web server for URI tests
   * update manpage to reflect updates in 1.5.0
-  * rework README (@mogztter) (#651)
+  * rework README (#651) (*@mogztter*)
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?milestone=8&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v1.5.0[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.1.4...v1.5.0[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.1.4\...v1.5.0[full diff]
 
 == 0.1.4 (2013-09-05) - @mojavelinux
 
@@ -854,11 +1041,11 @@ Enhancements::
   * ignore front matter used by static site generators if skip-front-matter attribute is set (#502)
   * sanitize contents of HTML title element in html5 backend (#504)
   * support toc position for toc2 (#467)
-  * cli accepts multiple files as input (@lordofthejars) (#227)
+  * cli accepts multiple files as input (#227) (*@lordofthejars*)
   * added Markdown-style horizontal rules and pass Markdown tests (#455)
   * added float clearing classes (.clearfix, .float-group) (#602)
   * don't disable syntax highlighting when explicit subs is used on listing block
-  * asciidoctor package now available in Debian Sid and Ubuntu Saucy (@avtobiff) (#216)
+  * asciidoctor package now available in Debian Sid and Ubuntu Saucy (#216) (*@avtobiff*)
 
 Compliance::
 
@@ -917,7 +1104,7 @@ Improvements::
   * output multiple authors in HTML backend (#399)
   * allow multiple template directories to be specified, document in usage and manpage (#437)
   * added option to cli to specify template engine (#406)
-  * added support for external video hosting services in video block macro (@xcoulon) (#587)
+  * added support for external video hosting services in video block macro (#587) (*@xcoulon*)
   * strip leading separator(s) on section id if idprefix is blank (#551)
   * customized styling of toc placed inside body content (#507)
   * consolidate toc attribute so toc with or without toc-position can make sidebar toc (#618)
@@ -946,14 +1133,14 @@ Improvements::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
-  * http://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
-  * http://packages.ubuntu.com/saucy/asciidoctor[Ubuntu (asciidoctor)]
+  * https://packages.debian.org/sid/asciidoctor[Debian (asciidoctor)]
+  * https://packages.ubuntu.com/search?keywords=asciidoctor[Ubuntu (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?milestone=7&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v0.1.4[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.1.3...v0.1.4[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.1.3\...v0.1.4[full diff]
 
 == 0.1.3 (2013-05-30) - @mojavelinux
 
@@ -970,8 +1157,8 @@ Enhancements::
   * support Markdown-style quote blocks
   * added section level 5 (maps to h6 element in the html5 backend) (#334)
   * added btn inline macro (#259)
-  * added menu inline menu to identify a menu selection (@bleathem) (#173)
-  * added kbd inline macro to identify a key or key combination (@bleathem) (#172)
+  * added menu inline menu to identify a menu selection (#173) (*@bleathem*)
+  * added kbd inline macro to identify a key or key combination (#172) (*@bleathem*)
   * support alternative quote forms (#196)
   * added indent attribute to verbatim blocks (#365)
   * added prettify source-highlighter (#202)
@@ -998,7 +1185,7 @@ Compliance::
   * assign caption even if no title (#321)
   * horizontal dlist layout in docbook backend (#298)
   * set doctitle attribute (#337)
-  * allow any backend to be specified in cli (@lightguard) (#320)
+  * allow any backend to be specified in cli (#320) (*@lightguard*)
   * support for abstract and partintro (#297)
 
 Bug Fixes::
@@ -1012,17 +1199,17 @@ Bug Fixes::
 Improvements::
 
   * added tests for all special sections (#80)
-  * added test for attributes defined as string or string array (@lightguard) (#291)
+  * added test for attributes defined as string or string array (#291) (*@lightguard*)
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
   * https://apps.fedoraproject.org/packages/rubygem-asciidoctor[Fedora (rubygem-asciidoctor)]
 
 http://asciidoctor.org/news/2013/05/31/asciidoctor-0-1-3-released[release notes] |
 https://github.com/asciidoctor/asciidoctor/issues?milestone=4&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v0.1.3[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.1.2...v0.1.3[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.1.2\...v0.1.3[full diff]
 
 == 0.1.2 (2013-04-25) - @mojavelinux
 
@@ -1072,12 +1259,12 @@ Bug Fixes::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
 
 http://asciidoctor.org/news/2013/04/25/asciidoctor-0-1-2-released[release notes] |
 https://github.com/asciidoctor/asciidoctor/issues?milestone=3&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v0.1.2[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.1.1...v0.1.2[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.1.1\...v0.1.2[full diff]
 
 == 0.1.1 (2013-02-26) - @erebor
 
@@ -1128,11 +1315,11 @@ Improvements::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?milestone=1&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v0.1.1[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.1.0...v0.1.1[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.1.0\...v0.1.1[full diff]
 
 == 0.1.0 (2013-02-04) - @erebor
 
@@ -1180,11 +1367,11 @@ Improvements::
 
 Distribution Packages::
 
-  * http://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
+  * https://rubygems.org/gems/asciidoctor[RubyGem (asciidoctor)]
 
 https://github.com/asciidoctor/asciidoctor/issues?milestone=12&state=closed[issues resolved] |
 https://github.com/asciidoctor/asciidoctor/releases/tag/v0.1.0[git tag] |
-https://github.com/asciidoctor/asciidoctor/compare/v0.0.9...v0.1.0[full diff]
+https://github.com/asciidoctor/asciidoctor/compare/v0.0.9\...v0.1.0[full diff]
 
 == Older releases (pre-0.0.1)
 
diff -pruN 1.5.6.2-2/data/locale/attributes.adoc 1.5.7-1/data/locale/attributes.adoc
--- 1.5.6.2-2/data/locale/attributes.adoc	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/data/locale/attributes.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -1,652 +1,11 @@
-// This file provides translations for all built-in attributes in Asciidoctor that output localized content.
-// See http://asciidoctor.org/docs/user-manual/#customizing-labels to learn how to use it.
+// This directory provides translations for all built-in attributes in Asciidoctor that emit translatable strings.
+// See http://asciidoctor.org/docs/user-manual/#customizing-labels to learn how to apply this file.
 //
-// NOTE: Please use a line comment in front of the listing-caption and preface-title entries.
-// These attributes should not be set by default.
+// If you're introducing a new translation, create a file named attributes-<iana-subtag>.adoc, where <iana-subtag> is the IANA subtag for the language.
+// Next, assign a translation for each attribute, using attributes-en.adoc as a reference.
 //
-// IMPORTANT: Do not add any blank lines.
+// IMPORTANT: Do not include any blank lines in the transation file.
 //
-// Arabic translation, courtesy of Aboullaite Mohammed <aboullaite.mohammed@gmail.com>
-ifeval::["{lang}" == "ar"]
-:appendix-caption: ملحق
-:appendix-refsig: {appendix-caption}
-:caution-caption: تنبيه
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: مثال
-:figure-caption: الشكل
-:important-caption: مهم
-:last-update-label: اخر تحديث
-//:listing-caption: قائمة
-:manname-title: اسم
-:note-caption: ملاحظة
-//:preface-title: تمهيد
-//:section-refsig: ???
-:table-caption: جدول
-:tip-caption: تلميح
-:toc-title: فهرس
-:untitled-label: بدون عنوان
-:version-label: نسخة
-:warning-caption: تحذير
-endif::[]
-// Bulgarian translation, courtesy of Ivan St. Ivanov <ivan.st.ivanov@gmail.com>
-ifeval::["{lang}" == "bg"]
-:appendix-caption: Приложение
-:appendix-refsig: {appendix-caption}
-:caution-caption: Внимание
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Пример
-:figure-caption: Фигура
-:important-caption: Важно
-:last-update-label: Последно обновен
-//:listing-caption: Листинг
-:manname-title: ИМЕ
-:note-caption: Забележка
-//:preface-title: Предговор
-//:section-refsig: ???
-:table-caption: Таблица
-:tip-caption: Подсказка
-:toc-title: Съдържание
-:untitled-label: Без заглавие
-:version-label: Версия
-:warning-caption: Внимание
-endif::[]
-// Catalan translation, courtesy of Abel Salgado Romero <abelromero@gmail.com> and Alex Soto
-ifeval::["{lang}" == "ca"]
-:appendix-caption: Apendix
-:appendix-refsig: {appendix-caption}
-:caution-caption: Atenció
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Exemple
-:figure-caption: Figura
-:important-caption: Important
-:last-update-label: Última actualització
-//:listing-caption: Llista
-:manname-title: NOM
-:note-caption: Nota
-//:preface-title: Prefaci
-//:section-refsig: ???
-:table-caption: Taula
-:tip-caption: Suggeriment
-:toc-title: Índex
-:untitled-label: Sense títol
-:version-label: Versió
-:warning-caption: Advertència
-endif::[]
-// Danish translation, courtesy of Max Rydahl Andersen <manderse@redhat.com>
-ifeval::["{lang}" == "da"]
-:appendix-caption: Appendix
-:appendix-refsig: {appendix-caption}
-:caution-caption: Forsigtig
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Eksempel
-:figure-caption: Figur
-:important-caption: Vigtig
-:last-update-label: Sidst opdateret
-//:listing-caption: List
-:manname-title: NAVN
-:note-caption: Notat
-//:preface-title:
-//:section-refsig: ???
-:table-caption: Tabel
-:tip-caption: Tips
-:toc-title: Indholdsfortegnelse
-:untitled-label: Unavngivet
-:version-label: Version
-:warning-caption: Advarsel
-endif::[]
-// German translation, courtesy of Florian Wilhelm
-ifeval::["{lang}" == "de"]
-:appendix-caption: Anhang
-:appendix-refsig: {appendix-caption}
-:caution-caption: Achtung
-:chapter-label: Kapitel
-:chapter-refsig: {chapter-label}
-:example-caption: Beispiel
-:figure-caption: Abbildung
-:important-caption: Wichtig
-:last-update-label: Zuletzt aktualisiert
-//:listing-caption: Listing
-:manname-title: BEZEICHNUNG
-:note-caption: Anmerkung
-//:preface-title: Vorwort
-//:section-refsig: ???
-:table-caption: Tabelle
-:tip-caption: Hinweis
-:toc-title: Inhalt
-:untitled-label: Ohne Titel
-:version-label: Version
-:warning-caption: Warnung
-endif::[]
-// Spanish translation, courtesy of Eddú Meléndez <eddu.melendez@gmail.com>
-ifeval::["{lang}" == "es"]
-:appendix-caption: Apéndice
-:appendix-refsig: {appendix-caption}
-:caution-caption: Precaución
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Ejemplo
-:figure-caption: Figura
-:important-caption: Importante
-:last-update-label: Ultima actualización
-//:listing-caption: Lista
-:manname-title: NOMBRE
-:note-caption: Nota
-//:preface-title: Prefacio
-//:section-refsig: ???
-:table-caption: Tabla
-:tip-caption: Sugerencia
-:toc-title: Tabla de Contenido
-:untitled-label: Sin título
-:version-label: Versión
-:warning-caption: Aviso
-endif::[]
-// Persian (Farsi) translation, courtesy of Shahryar Eivazzadeh <shahryareiv@gmail.com>
-ifeval::["{lang}" == "fa"]
-:appendix-caption: پیوست
-:appendix-refsig: {appendix-caption}
-:caution-caption: گوشزد
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: نمونه
-:figure-caption: نمودار
-:important-caption: مهم
-:last-update-label: آخرین به روز رسانی
-//:listing-caption: فهرست
-:manname-title: نام
-:note-caption: یادداشت
-//:preface-title: پیشگفتار
-//:section-refsig: ???
-:table-caption: جدول
-:tip-caption: نکته
-:toc-title: فهرست مطالب
-:untitled-label: بی‌نام
-:version-label: نگارش
-:warning-caption: هشدار
-endif::[]
-// Finnish translation by Tero Hänninen
-ifeval::["{lang}" == "fi"]
-:appendix-caption: Liitteet
-:appendix-refsig: {appendix-caption}
-:caution-caption: Huom
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Esimerkki
-:figure-caption: Kuvio
-:important-caption: Tärkeää
-:last-update-label: Viimeksi päivitetty
-//:listing-caption: Listaus
-:manname-title: NIMI
-:note-caption: Huomio
-//:preface-title: Esipuhe
-//:section-refsig: ???
-:table-caption: Taulukko
-:tip-caption: Vinkki
-:toc-title: Sisällysluettelo
-:untitled-label: Nimetön
-:version-label: Versio
-:warning-caption: Varoitus
-endif::[]
-// French translation, courtesy of Nicolas Comet <nicolas.comet@gmail.com>
-ifeval::["{lang}" == "fr"]
-:appendix-caption: Appendice
-:appendix-refsig: {appendix-caption}
-:caution-caption: Avertissement
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Exemple
-:figure-caption: Figure
-:important-caption: Important
-:last-update-label: Dernière mise à jour
-//:listing-caption: Liste
-:manname-title: NOM
-:note-caption: Note
-//:preface-title: Préface
-//:section-refsig: ???
-:table-caption: Tableau
-:tip-caption: Astuce
-:toc-title: Table des matières
-:untitled-label: Sans titre
-:version-label: Version
-:warning-caption: Attention
-endif::[]
-// Hungarian translation, courtesy of István Pató <istvan.pato@gmail.com>
-ifeval::["{lang}" == "hu"]
-:appendix-caption: függelék
-:appendix-refsig: {appendix-caption}
-:caution-caption: Figyelmeztetés
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Példa
-:figure-caption: Ábra
-:important-caption: Fontos
-:last-update-label: Utolsó frissítés
-//:listing-caption: Lista
-:manname-title: NÉV
-:note-caption: Megjegyzés
-//:preface-title: Előszó
-//:section-refsig: ???
-:table-caption: Táblázat
-:tip-caption: Tipp
-:toc-title: Tartalomjegyzék
-:untitled-label: Névtelen
-:version-label: Verzió
-:warning-caption: Figyelem
-endif::[]
-// Bahasa Indonesia, courtesy of Triyan W. Nugroho <triyan.wn@gmail.com>
-ifeval::["{lang}" == "id"]
-:appendix-caption: Lampiran
-:appendix-refsig: {appendix-caption}
-:caution-caption: Perhatian
-:chapter-label: Bab
-:chapter-refsig: {chapter-label}
-:example-caption: Contoh
-:figure-caption: Gambar
-:important-caption: Penting
-:last-update-label: Pembaruan terakhir
-//:listing-caption: Daftar
-:manname-title: NAMA
-:note-caption: Catatan
-//:preface-title:
-//:section-refsig: ???
-:table-caption: Tabel
-:tip-caption: Tips
-:toc-title: Daftar Isi
-:untitled-label: Tak Berjudul
-:version-label: Versi
-:warning-caption: Peringatan
-endif::[]
-// Italian translation, courtesy of Marco Ciampa <ciampix@libero.it>
-ifeval::["{lang}" == "it"]
-:appendix-caption: Appendice
-:appendix-refsig: {appendix-caption}
-:caution-caption: Attenzione
-:chapter-label: Capitolo
-:chapter-refsig: {chapter-label}
-:example-caption: Esempio
-:figure-caption: Figura
-:important-caption: Importante
-:last-update-label: Ultimo aggiornamento
-//:listing-caption: Elenco
-:manname-title: NOME
-:note-caption: Nota
-//:preface-title: Prefazione
-//:section-refsig: ???
-:table-caption: Tabella
-:tip-caption: Suggerimento
-:toc-title: Indice
-:untitled-label: Senza titolo
-:version-label: Versione
-:warning-caption: Attenzione
-endif::[]
-// Japanese translation, courtesy of Takayuki Konishi <seannos.takayuki@gmail.com>
-ifeval::["{lang}" == "ja"]
-:appendix-caption: 付録
-:appendix-refsig: {appendix-caption}
-:caution-caption: 注意
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: 例
-:figure-caption: 図
-:important-caption: 重要
-:last-update-label: 最終更新
-//:listing-caption: リスト
-:manname-title: 名前
-:note-caption: 注記
-//:preface-title: まえがき
-//:section-refsig: ???
-:table-caption: 表
-:tip-caption: ヒント
-:toc-title: 目次
-:untitled-label: 無題
-:version-label: バージョン
-:warning-caption: 警告
-endif::[]
-// Korean translation, courtesy of Sungsik Nam <jmyl@me.com>
-ifeval::["{lang}" == "kr"]
-:appendix-caption: 부록
-:appendix-refsig: {appendix-caption}
-:caution-caption: 주의
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: 예시
-:figure-caption: 그림
-:important-caption: 중요
-:last-update-label: 마지막 업데이트
-//:listing-caption: 목록
-:manname-title: 이름
-:note-caption: 노트
-//:preface-title: 머리말
-//:section-refsig: ???
-:table-caption: 표
-:tip-caption: 힌트
-:toc-title: 차례
-:untitled-label: 익명
-:version-label: 버전
-:warning-caption: 경고
-endif::[]
-// Dutch translation, courtesy of Roel Van Steenberghe <roel.vansteenberghe@gmail.com>
-ifeval::["{lang}" == "nl"]
-:appendix-caption: Bijlage
-:appendix-refsig: {appendix-caption}
-:caution-caption: Opgelet
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Voorbeeld
-:figure-caption: Figuur
-:important-caption: Belangrijk
-:last-update-label: Laatste aanpassing
-//:listing-caption: Lijst
-:manname-title: NAAM
-:note-caption: Noot
-//:preface-title: Inleiding
-//:section-refsig: ???
-:table-caption: Tabel
-:tip-caption: Tip
-:toc-title: Ínhoudsopgave
-:untitled-label: Naamloos
-:version-label: Versie
-:warning-caption: Waarschuwing
-endif::[]
-// Norwegian Bokmål, courtesy of Aslak Knutsen <aslak@4fs.no>, with updates from Karl Ove Hufthammer <karl@huftis.org>
-ifeval::["{lang}" == "nb"]
-:appendix-caption: Vedlegg
-:appendix-refsig: {appendix-caption}
-:caution-caption: OBS
-:chapter-label: Kapittel
-:chapter-refsig: {chapter-label}
-:example-caption: Eksempel
-:figure-caption: Figur
-:important-caption: Viktig
-:last-update-label: Sist oppdatert
-//:listing-caption: Programkode
-:manname-title: NAVN
-:note-caption: Merk
-//:preface-title: Forord
-//:section-refsig: ???
-:table-caption: Tabell
-:tip-caption: Tips
-:toc-title: Innhold
-:untitled-label: Navnløs
-:version-label: Versjon
-:warning-caption: Advarsel
-endif::[]
-// Norwegian Nynorsk, courtesy of Karl Ove Hufthammer <karl@huftis.org>
-ifeval::["{lang}" == "nn"]
-:appendix-caption: Vedlegg
-:appendix-refsig: {appendix-caption}
-:caution-caption: OBS
-:chapter-label: Kapittel
-:chapter-refsig: {chapter-label}
-:example-caption: Eksempel
-:figure-caption: Figur
-:important-caption: Viktig
-:last-update-label: Sist oppdatert
-//:listing-caption: Programkode
-:manname-title: NAMN
-:note-caption: Merk
-//:preface-title: Forord
-//:section-refsig: ???
-:table-caption: Tabell
-:tip-caption: Tips
-:toc-title: Innhald
-:untitled-label: Namnlaus
-:version-label: Versjon
-:warning-caption: Åtvaring
-endif::[]
-// Polish translation, courtesy of Łukasz Dziedziul <l.dziedziul@gmail.com>
-ifeval::["{lang}" == "pl"]
-:appendix-caption: Dodatek
-:appendix-refsig: {appendix-caption}
-:caution-caption: Uwaga
-:chapter-label: Rozdział
-:chapter-refsig: {chapter-label}
-:example-caption: Przykład
-:figure-caption: Rysunek
-:important-caption: Ważne
-:last-update-label: Ostatnio zmodyfikowany
-//:listing-caption:
-:manname-title: NAZWA
-:note-caption: Notka
-//:preface-title:
-//:section-refsig: ???
-:table-caption: Tabela
-:tip-caption: Sugestia
-:toc-title: Spis treści
-:untitled-label: Bez tytułu
-:version-label: Wersja
-:warning-caption: Ostrzeżenie
-endif::[]
-// Portuguese translation, courtesy of Roberto Cortez <radcortez@yahoo.com>
-ifeval::["{lang}" == "pt"]
-:appendix-caption: Apêndice
-:appendix-refsig: {appendix-caption}
-:caution-caption: Atenção
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Exemplo
-:figure-caption: Figura
-:important-caption: Importante
-:last-update-label: Última actualização
-//:listing-caption: Listagem
-:manname-title: NOME
-:note-caption: Nota
-//:preface-title: Prefácio
-//:section-refsig: ???
-:table-caption: Tabela
-:tip-caption: Sugestão
-:toc-title: Índice
-:untitled-label: Sem título
-:version-label: Versão
-:warning-caption: Aviso
-endif::[]
-// Brazilian Portuguese translation, courtesy of Rafael Pestano <rmpestano@gmail.com>
-ifeval::["{lang}" == "pt_BR"]
-:appendix-caption: Apêndice
-:appendix-refsig: {appendix-caption}
-:caution-caption: Cuidado
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Exemplo
-:figure-caption: Figura
-:important-caption: Importante
-:last-update-label: Última atualização
-//:listing-caption: Listagem
-:manname-title: NOME
-:note-caption: Nota
-//:preface-title: Prefácio
-//:section-refsig: ???
-:table-caption: Tabela
-:tip-caption: Dica
-:toc-title: Índice
-:untitled-label: Sem título
-:version-label: Versão
-:warning-caption: Aviso
-endif::[]
-// Romanian translation, courtesy of Vitalie Lazu <vitalie.lazu@gmail.com>
-ifeval::["{lang}" == "ro"]
-:appendix-caption: Apendix
-:appendix-refsig: {appendix-caption}
-:caution-caption: Precauție
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Exemplu
-:figure-caption: Figură
-:important-caption: Important
-:last-update-label: Ultima actualizare
-//:listing-caption: Listare
-:manname-title: NUME
-:note-caption: Notă
-//:preface-title: Prefață
-//:section-refsig: ???
-:table-caption: Tabela
-:tip-caption: Sfat
-:toc-title: Cuprins
-:untitled-label: Fără denumire
-:version-label: Versiunea
-:warning-caption: Atenție
-endif::[]
-// Russian translation, courtesy of Alexander Zobkov <alexander.zobkov@gmail.com>
-ifeval::["{lang}" == "ru"]
-:appendix-caption: Приложение
-:appendix-refsig: {appendix-caption}
-:caution-caption: Внимание
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Пример
-:figure-caption: Рисунок
-:important-caption: Важно
-:last-update-label: Последний раз обновлено
-//:listing-caption: Листинг
-:manname-title: НАЗВАНИЕ
-:note-caption: Примечание
-//:preface-title: Предисловие
-//:section-refsig: ???
-:table-caption: Таблица
-:tip-caption: Подсказка
-:toc-title: Содержание
-:untitled-label: Без названия
-:version-label: Версия
-:warning-caption: Предупреждение
-endif::[]
-// Serbian Cyrillic translation, courtesy of Bojan Stipic <bojan-7@live.com>
-ifeval::["{lang}" == "sr"]
-:appendix-caption: Додатак
-:appendix-refsig: {appendix-caption}
-:caution-caption: Опрез
-:chapter-label: Поглавље
-:chapter-refsig: {chapter-label}
-:example-caption: Пример
-:figure-caption: Слика
-:important-caption: Важно
-:last-update-label: Последње ажурирано
-//:listing-caption: Списак
-:manname-title: НАЗИВ
-:note-caption: Белешка
-//:preface-title: Предговор
-//:section-refsig: ???
-:table-caption: Табела
-:tip-caption: Савет
-:toc-title: Садржај
-:untitled-label: Без назива
-:version-label: Верзија
-:warning-caption: Упозорење
-endif::[]
-// Serbian Latin translation, courtesy of Bojan Stipic <bojan-7@live.com>
-ifeval::["{lang}" == "sr_Latn"]
-:appendix-caption: Dodatak
-:appendix-refsig: {appendix-caption}
-:caution-caption: Oprez
-:chapter-label: Poglavlje
-:chapter-refsig: {chapter-label}
-:example-caption: Primer
-:figure-caption: Slika
-:important-caption: Važno
-:last-update-label: Poslednje ažurirano
-//:listing-caption: Spisak
-:manname-title: NAZIV
-:note-caption: Beleška
-//:preface-title: Predgovor
-//:section-refsig: ???
-:table-caption: Tabela
-:tip-caption: Savet
-:toc-title: Sadržaj
-:untitled-label: Bez naziva
-:version-label: Verzija
-:warning-caption: Upozorenje
-endif::[]
-// Turkish translation, courtesy of Rahman Usta <rahman.usta.88@gmail.com>
-ifeval::["{lang}" == "tr"]
-:appendix-caption: Ek bölüm
-:appendix-refsig: {appendix-caption}
-:caution-caption: Dikkat
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Örnek
-:figure-caption: Görsel
-:important-caption: Önemli
-:last-update-label: Son güncelleme
-//:listing-caption: Listeleme
-:manname-title: İSİM
-:note-caption: Not
-//:preface-title: Ön söz
-//:section-refsig: ???
-:table-caption: Tablo
-:tip-caption: İpucu
-:toc-title: İçindekiler
-:untitled-label: İsimsiz
-:version-label: Versiyon
-:warning-caption: Uyarı
-endif::[]
-// Ukrainian translation, courtesy of Kyrylo Yatsenko <hedrok@gmail.com>
-ifeval::["{lang}" == "uk"]
-:appendix-caption: Додаток
-:appendix-refsig: {appendix-caption}
-:caution-caption: Обережно
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: Приклад
-:figure-caption: Зображення
-:important-caption: Важливо
-:last-update-label: Востаннє оновлено
-//:listing-caption: Лістинг
-:manname-title: НАЗВА
-:note-caption: Зауваження
-//:preface-title: Передмова
-//:section-refsig: ???
-:table-caption: Таблиця
-:tip-caption: Підказка
-:toc-title: Зміст
-:untitled-label: Без назви
-:version-label: Версія
-:warning-caption: Попередження
-endif::[]
-// Simplified Chinese translation, courtesy of John Dong <dongwqs@gmail.com>
-ifeval::["{lang}" == "zh_CN"]
-:appendix-caption: 附录
-:appendix-refsig: {appendix-caption}
-:caution-caption: 注意
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: 示例
-:figure-caption: 图表
-:important-caption: 重要
-:last-update-label: 最后更新
-//:listing-caption: 列表
-:manname-title: 名称
-:note-caption: 笔记
-//:preface-title: 序言
-//:section-refsig: ???
-:table-caption: 表格
-:tip-caption: 提示
-:toc-title: 目录
-:untitled-label: 暂无标题
-:version-label: 版本
-:warning-caption: 警告
-endif::[]
-// Traditional Chinese translation, courtesy of John Dong <dongwqs@gmail.com>
-ifeval::["{lang}" == "zh_TW"]
-:appendix-caption: 附錄
-:appendix-refsig: {appendix-caption}
-:caution-caption: 注意
-//:chapter-label: ???
-//:chapter-refsig: {chapter-label}
-:example-caption: 示例
-:figure-caption: 圖表
-:important-caption: 重要
-:last-update-label: 最後更新
-//:listing-caption: 列表
-:manname-title: 名稱
-:note-caption: 筆記
-//:preface-title: 序言
-//:section-refsig: ???
-:table-caption: 表格
-:tip-caption: 提示
-:toc-title: 目錄
-:untitled-label: 暫無標題
-:version-label: 版本
-:warning-caption: 警告
-endif::[]
+// NOTE: Please wrap the listing-caption and preface-title entries in a preprocessor conditional directive.
+// These attributes should only be updated if set explicitly by the user.
+ifdef::lang[include::attributes-{lang}.adoc[]]
diff -pruN 1.5.6.2-2/data/locale/attributes-ar.adoc 1.5.7-1/data/locale/attributes-ar.adoc
--- 1.5.6.2-2/data/locale/attributes-ar.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-ar.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Arabic translation, courtesy of Aboullaite Mohammed <aboullaite.mohammed@gmail.com>
+:appendix-caption: ملحق
+:appendix-refsig: {appendix-caption}
+:caution-caption: تنبيه
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: مثال
+:figure-caption: الشكل
+:important-caption: مهم
+:last-update-label: اخر تحديث
+ifdef::listing-caption[:listing-caption: قائمة]
+//:manname-title: اسم
+:note-caption: ملاحظة
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: تمهيد]
+//:section-refsig: ???
+:table-caption: جدول
+:tip-caption: تلميح
+:toc-title: فهرس
+:untitled-label: بدون عنوان
+:version-label: نسخة
+:warning-caption: تحذير
diff -pruN 1.5.6.2-2/data/locale/attributes-bg.adoc 1.5.7-1/data/locale/attributes-bg.adoc
--- 1.5.6.2-2/data/locale/attributes-bg.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-bg.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Bulgarian translation, courtesy of Ivan St. Ivanov <ivan.st.ivanov@gmail.com>
+:appendix-caption: Приложение
+:appendix-refsig: {appendix-caption}
+:caution-caption: Внимание
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Пример
+:figure-caption: Фигура
+:important-caption: Важно
+:last-update-label: Последно обновен
+ifdef::listing-caption[:listing-caption: Листинг]
+//:manname-title: ИМЕ
+:note-caption: Забележка
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Предговор]
+//:section-refsig: ???
+:table-caption: Таблица
+:tip-caption: Подсказка
+:toc-title: Съдържание
+:untitled-label: Без заглавие
+:version-label: Версия
+:warning-caption: Внимание
diff -pruN 1.5.6.2-2/data/locale/attributes-ca.adoc 1.5.7-1/data/locale/attributes-ca.adoc
--- 1.5.6.2-2/data/locale/attributes-ca.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-ca.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Catalan translation, courtesy of Abel Salgado Romero <abelromero@gmail.com> and Alex Soto
+:appendix-caption: Apendix
+:appendix-refsig: {appendix-caption}
+:caution-caption: Atenció
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Exemple
+:figure-caption: Figura
+:important-caption: Important
+:last-update-label: Última actualització
+ifdef::listing-caption[:listing-caption: Llista]
+//:manname-title: NOM
+:note-caption: Nota
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefaci]
+//:section-refsig: ???
+:table-caption: Taula
+:tip-caption: Suggeriment
+:toc-title: Índex
+:untitled-label: Sense títol
+:version-label: Versió
+:warning-caption: Advertència
diff -pruN 1.5.6.2-2/data/locale/attributes-cs.adoc 1.5.7-1/data/locale/attributes-cs.adoc
--- 1.5.6.2-2/data/locale/attributes-cs.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-cs.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// czech translation, for reference only; matches the built-in behavior of core
+:appendix-caption: Příloha
+:appendix-refsig: {appendix-caption}
+:caution-caption: Upozornění
+:chapter-label: Kapitola
+:chapter-refsig: {chapter-label}
+:example-caption: Příklad
+:figure-caption: Obrázek
+:important-caption: Důležité
+:last-update-label: Změněno
+ifdef::listing-caption[:listing-caption: Seznam]
+//:manname-title: Název
+:note-caption: Poznámka
+:part-refsig: Část
+ifdef::preface-title[:preface-title: Úvod]
+:section-refsig: Oddíl
+:table-caption: Tabulka
+:tip-caption: Tip
+:toc-title: Obsah
+:untitled-label: Nepojmenovaný
+:version-label: Verze
+:warning-caption: Varování
diff -pruN 1.5.6.2-2/data/locale/attributes-da.adoc 1.5.7-1/data/locale/attributes-da.adoc
--- 1.5.6.2-2/data/locale/attributes-da.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-da.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Danish translation, courtesy of Max Rydahl Andersen <manderse@redhat.com>
+:appendix-caption: Appendix
+:appendix-refsig: {appendix-caption}
+:caution-caption: Forsigtig
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Eksempel
+:figure-caption: Figur
+:important-caption: Vigtig
+:last-update-label: Sidst opdateret
+ifdef::listing-caption[:listing-caption: List]
+//:manname-title: NAVN
+:note-caption: Notat
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Forord]
+//:section-refsig: ???
+:table-caption: Tabel
+:tip-caption: Tips
+:toc-title: Indholdsfortegnelse
+:untitled-label: Unavngivet
+:version-label: Version
+:warning-caption: Advarsel
diff -pruN 1.5.6.2-2/data/locale/attributes-de.adoc 1.5.7-1/data/locale/attributes-de.adoc
--- 1.5.6.2-2/data/locale/attributes-de.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-de.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// German translation, courtesy of Florian Wilhelm
+:appendix-caption: Anhang
+:appendix-refsig: {appendix-caption}
+:caution-caption: Achtung
+:chapter-label: Kapitel
+:chapter-refsig: {chapter-label}
+:example-caption: Beispiel
+:figure-caption: Abbildung
+:important-caption: Wichtig
+:last-update-label: Zuletzt aktualisiert
+//ifdef::listing-caption[:listing-caption: ???]
+//:manname-title: BEZEICHNUNG
+:note-caption: Anmerkung
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Vorwort]
+:section-refsig: Abschnitt
+:table-caption: Tabelle
+:tip-caption: Hinweis
+:toc-title: Inhalt
+:untitled-label: Ohne Titel
+:version-label: Version
+:warning-caption: Warnung
diff -pruN 1.5.6.2-2/data/locale/attributes-en.adoc 1.5.7-1/data/locale/attributes-en.adoc
--- 1.5.6.2-2/data/locale/attributes-en.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-en.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,23 @@
+// English translation, for reference only; matches the built-in behavior of core
+:appendix-caption: Appendix
+:appendix-refsig: {appendix-caption}
+:caution-caption: Caution
+:chapter-label: Chapter
+:chapter-refsig: {chapter-label}
+:example-caption: Example
+:figure-caption: Figure
+:important-caption: Important
+:last-update-label: Last updated
+ifdef::listing-caption[:listing-caption: Listing]
+//:manname-title: Name
+:note-caption: Note
+:part-label: Part
+:part-refsig: {part-label}
+ifdef::preface-title[:preface-title: Preface]
+:section-refsig: Section
+:table-caption: Table
+:tip-caption: Tip
+:toc-title: Table of Contents
+:untitled-label: Untitled
+:version-label: Version
+:warning-caption: Warning
diff -pruN 1.5.6.2-2/data/locale/attributes-es.adoc 1.5.7-1/data/locale/attributes-es.adoc
--- 1.5.6.2-2/data/locale/attributes-es.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-es.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Spanish translation, courtesy of Eddú Meléndez <eddu.melendez@gmail.com>
+:appendix-caption: Apéndice
+:appendix-refsig: {appendix-caption}
+:caution-caption: Precaución
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Ejemplo
+:figure-caption: Figura
+:important-caption: Importante
+:last-update-label: Ultima actualización
+ifdef::listing-caption[:listing-caption: Lista]
+//:manname-title: NOMBRE
+:note-caption: Nota
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefacio]
+//:section-refsig: ???
+:table-caption: Tabla
+:tip-caption: Sugerencia
+:toc-title: Tabla de Contenido
+:untitled-label: Sin título
+:version-label: Versión
+:warning-caption: Aviso
diff -pruN 1.5.6.2-2/data/locale/attributes-fa.adoc 1.5.7-1/data/locale/attributes-fa.adoc
--- 1.5.6.2-2/data/locale/attributes-fa.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-fa.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Persian (Farsi) translation, courtesy of Shahryar Eivazzadeh <shahryareiv@gmail.com>
+:appendix-caption: پیوست
+:appendix-refsig: {appendix-caption}
+:caution-caption: گوشزد
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: نمونه
+:figure-caption: نمودار
+:important-caption: مهم
+:last-update-label: آخرین به روز رسانی
+ifdef::listing-caption[:listing-caption: فهرست]
+//:manname-title: نام
+:note-caption: یادداشت
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: پیشگفتار]
+//:section-refsig: ???
+:table-caption: جدول
+:tip-caption: نکته
+:toc-title: فهرست مطالب
+:untitled-label: بی‌نام
+:version-label: نگارش
+:warning-caption: هشدار
diff -pruN 1.5.6.2-2/data/locale/attributes-fi.adoc 1.5.7-1/data/locale/attributes-fi.adoc
--- 1.5.6.2-2/data/locale/attributes-fi.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-fi.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Finnish translation by Tero Hänninen
+:appendix-caption: Liitteet
+:appendix-refsig: {appendix-caption}
+:caution-caption: Huom
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Esimerkki
+:figure-caption: Kuvio
+:important-caption: Tärkeää
+:last-update-label: Viimeksi päivitetty
+ifdef::listing-caption[:listing-caption: Listaus]
+//:manname-title: NIMI
+:note-caption: Huomio
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Esipuhe]
+//:section-refsig: ???
+:table-caption: Taulukko
+:tip-caption: Vinkki
+:toc-title: Sisällysluettelo
+:untitled-label: Nimetön
+:version-label: Versio
+:warning-caption: Varoitus
diff -pruN 1.5.6.2-2/data/locale/attributes-fr.adoc 1.5.7-1/data/locale/attributes-fr.adoc
--- 1.5.6.2-2/data/locale/attributes-fr.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-fr.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// French translation, courtesy of Nicolas Comet <nicolas.comet@gmail.com>
+:appendix-caption: Annexe
+:appendix-refsig: {appendix-caption}
+:caution-caption: Avertissement
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Exemple
+:figure-caption: Figure
+:important-caption: Important
+:last-update-label: Dernière mise à jour
+ifdef::listing-caption[:listing-caption: Liste]
+//:manname-title: NOM
+:note-caption: Note
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Préface]
+//:section-refsig: ???
+:table-caption: Tableau
+:tip-caption: Astuce
+:toc-title: Table des matières
+:untitled-label: Sans titre
+:version-label: Version
+:warning-caption: Attention
diff -pruN 1.5.6.2-2/data/locale/attributes-hu.adoc 1.5.7-1/data/locale/attributes-hu.adoc
--- 1.5.6.2-2/data/locale/attributes-hu.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-hu.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Hungarian translation, courtesy of István Pató <istvan.pato@gmail.com>
+:appendix-caption: függelék
+:appendix-refsig: {appendix-caption}
+:caution-caption: Figyelmeztetés
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Példa
+:figure-caption: Ábra
+:important-caption: Fontos
+:last-update-label: Utolsó frissítés
+ifdef::listing-caption[:listing-caption: Lista]
+//:manname-title: NÉV
+:note-caption: Megjegyzés
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Előszó]
+//:section-refsig: ???
+:table-caption: Táblázat
+:tip-caption: Tipp
+:toc-title: Tartalomjegyzék
+:untitled-label: Névtelen
+:version-label: Verzió
+:warning-caption: Figyelem
diff -pruN 1.5.6.2-2/data/locale/attributes-id.adoc 1.5.7-1/data/locale/attributes-id.adoc
--- 1.5.6.2-2/data/locale/attributes-id.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-id.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Bahasa Indonesia, courtesy of Triyan W. Nugroho <triyan.wn@gmail.com>
+:appendix-caption: Lampiran
+:appendix-refsig: {appendix-caption}
+:caution-caption: Perhatian
+:chapter-label: Bab
+:chapter-refsig: {chapter-label}
+:example-caption: Contoh
+:figure-caption: Gambar
+:important-caption: Penting
+:last-update-label: Pembaruan terakhir
+ifdef::listing-caption[:listing-caption: Daftar]
+//:manname-title: NAMA
+:note-caption: Catatan
+//:part-refsig: ???
+//ifdef::preface-title[:preface-title: ???]
+//:section-refsig: ???
+:table-caption: Tabel
+:tip-caption: Tips
+:toc-title: Daftar Isi
+:untitled-label: Tak Berjudul
+:version-label: Versi
+:warning-caption: Peringatan
diff -pruN 1.5.6.2-2/data/locale/attributes-it.adoc 1.5.7-1/data/locale/attributes-it.adoc
--- 1.5.6.2-2/data/locale/attributes-it.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-it.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Italian translation, courtesy of Marco Ciampa <ciampix@libero.it>
+:appendix-caption: Appendice
+:appendix-refsig: {appendix-caption}
+:caution-caption: Attenzione
+:chapter-label: Capitolo
+:chapter-refsig: {chapter-label}
+:example-caption: Esempio
+:figure-caption: Figura
+:important-caption: Importante
+:last-update-label: Ultimo aggiornamento
+ifdef::listing-caption[:listing-caption: Elenco]
+//:manname-title: NOME
+:note-caption: Nota
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefazione]
+//:section-refsig: ???
+:table-caption: Tabella
+:tip-caption: Suggerimento
+:toc-title: Indice
+:untitled-label: Senza titolo
+:version-label: Versione
+:warning-caption: Attenzione
diff -pruN 1.5.6.2-2/data/locale/attributes-ja.adoc 1.5.7-1/data/locale/attributes-ja.adoc
--- 1.5.6.2-2/data/locale/attributes-ja.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-ja.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Japanese translation, courtesy of Takayuki Konishi <seannos.takayuki@gmail.com>
+:appendix-caption: 付録
+:appendix-refsig: {appendix-caption}
+:caution-caption: 注意
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: 例
+:figure-caption: 図
+:important-caption: 重要
+:last-update-label: 最終更新
+ifdef::listing-caption[:listing-caption: リスト]
+//:manname-title: 名前
+:note-caption: 注記
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: まえがき]
+//:section-refsig: ???
+:table-caption: 表
+:tip-caption: ヒント
+:toc-title: 目次
+:untitled-label: 無題
+:version-label: バージョン
+:warning-caption: 警告
diff -pruN 1.5.6.2-2/data/locale/attributes-kr.adoc 1.5.7-1/data/locale/attributes-kr.adoc
--- 1.5.6.2-2/data/locale/attributes-kr.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-kr.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Korean translation, courtesy of Sungsik Nam <jmyl@me.com>
+:appendix-caption: 부록
+:appendix-refsig: {appendix-caption}
+:caution-caption: 주의
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: 예시
+:figure-caption: 그림
+:important-caption: 중요
+:last-update-label: 마지막 업데이트
+ifdef::listing-caption[:listing-caption: 목록]
+//:manname-title: 이름
+:note-caption: 노트
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: 머리말]
+//:section-refsig: ???
+:table-caption: 표
+:tip-caption: 힌트
+:toc-title: 차례
+:untitled-label: 익명
+:version-label: 버전
+:warning-caption: 경고
diff -pruN 1.5.6.2-2/data/locale/attributes-nb.adoc 1.5.7-1/data/locale/attributes-nb.adoc
--- 1.5.6.2-2/data/locale/attributes-nb.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-nb.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Norwegian Bokmål, courtesy of Aslak Knutsen <aslak@4fs.no>, with updates from Karl Ove Hufthammer <karl@huftis.org>
+:appendix-caption: Vedlegg
+:appendix-refsig: {appendix-caption}
+:caution-caption: OBS
+:chapter-label: Kapittel
+:chapter-refsig: {chapter-label}
+:example-caption: Eksempel
+:figure-caption: Figur
+:important-caption: Viktig
+:last-update-label: Sist oppdatert
+ifdef::listing-caption[:listing-caption: Programkode]
+//:manname-title: NAVN
+:note-caption: Merk
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Forord]
+//:section-refsig: ???
+:table-caption: Tabell
+:tip-caption: Tips
+:toc-title: Innhold
+:untitled-label: Navnløs
+:version-label: Versjon
+:warning-caption: Advarsel
diff -pruN 1.5.6.2-2/data/locale/attributes-nl.adoc 1.5.7-1/data/locale/attributes-nl.adoc
--- 1.5.6.2-2/data/locale/attributes-nl.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-nl.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Dutch translation, courtesy of Roel Van Steenberghe <roel.vansteenberghe@gmail.com>
+:appendix-caption: Bijlage
+:appendix-refsig: {appendix-caption}
+:caution-caption: Opgelet
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Voorbeeld
+:figure-caption: Figuur
+:important-caption: Belangrijk
+:last-update-label: Laatste aanpassing
+ifdef::listing-caption[:listing-caption: Lijst]
+//:manname-title: NAAM
+:note-caption: Noot
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Inleiding]
+//:section-refsig: ???
+:table-caption: Tabel
+:tip-caption: Tip
+:toc-title: Ínhoudsopgave
+:untitled-label: Naamloos
+:version-label: Versie
+:warning-caption: Waarschuwing
diff -pruN 1.5.6.2-2/data/locale/attributes-nn.adoc 1.5.7-1/data/locale/attributes-nn.adoc
--- 1.5.6.2-2/data/locale/attributes-nn.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-nn.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Norwegian Nynorsk, courtesy of Karl Ove Hufthammer <karl@huftis.org>
+:appendix-caption: Vedlegg
+:appendix-refsig: {appendix-caption}
+:caution-caption: OBS
+:chapter-label: Kapittel
+:chapter-refsig: {chapter-label}
+:example-caption: Eksempel
+:figure-caption: Figur
+:important-caption: Viktig
+:last-update-label: Sist oppdatert
+ifdef::listing-caption[:listing-caption: Programkode]
+//:manname-title: NAMN
+:note-caption: Merk
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Forord]
+//:section-refsig: ???
+:table-caption: Tabell
+:tip-caption: Tips
+:toc-title: Innhald
+:untitled-label: Namnlaus
+:version-label: Versjon
+:warning-caption: Åtvaring
diff -pruN 1.5.6.2-2/data/locale/attributes-pl.adoc 1.5.7-1/data/locale/attributes-pl.adoc
--- 1.5.6.2-2/data/locale/attributes-pl.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-pl.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Polish translation, courtesy of Łukasz Dziedziul <l.dziedziul@gmail.com>
+:appendix-caption: Dodatek
+:appendix-refsig: {appendix-caption}
+:caution-caption: Uwaga
+:chapter-label: Rozdział
+:chapter-refsig: {chapter-label}
+:example-caption: Przykład
+:figure-caption: Rysunek
+:important-caption: Ważne
+:last-update-label: Ostatnio zmodyfikowany
+//ifdef::listing-caption[:listing-caption: ???]
+//:manname-title: NAZWA
+:note-caption: Notka
+//:part-refsig: ???
+//ifdef::preface-title[:preface-title: ???]
+//:section-refsig: ???
+:table-caption: Tabela
+:tip-caption: Sugestia
+:toc-title: Spis treści
+:untitled-label: Bez tytułu
+:version-label: Wersja
+:warning-caption: Ostrzeżenie
diff -pruN 1.5.6.2-2/data/locale/attributes-pt.adoc 1.5.7-1/data/locale/attributes-pt.adoc
--- 1.5.6.2-2/data/locale/attributes-pt.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-pt.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Portuguese translation, courtesy of Roberto Cortez <radcortez@yahoo.com>
+:appendix-caption: Apêndice
+:appendix-refsig: {appendix-caption}
+:caution-caption: Atenção
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Exemplo
+:figure-caption: Figura
+:important-caption: Importante
+:last-update-label: Última actualização
+ifdef::listing-caption[:listing-caption: Listagem]
+//:manname-title: NOME
+:note-caption: Nota
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefácio]
+//:section-refsig: ???
+:table-caption: Tabela
+:tip-caption: Sugestão
+:toc-title: Índice
+:untitled-label: Sem título
+:version-label: Versão
+:warning-caption: Aviso
diff -pruN 1.5.6.2-2/data/locale/attributes-pt_BR.adoc 1.5.7-1/data/locale/attributes-pt_BR.adoc
--- 1.5.6.2-2/data/locale/attributes-pt_BR.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-pt_BR.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Brazilian Portuguese translation, courtesy of Rafael Pestano <rmpestano@gmail.com>
+:appendix-caption: Apêndice
+:appendix-refsig: {appendix-caption}
+:caution-caption: Cuidado
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Exemplo
+:figure-caption: Figura
+:important-caption: Importante
+:last-update-label: Última atualização
+ifdef::listing-caption[:listing-caption: Listagem]
+//:manname-title: NOME
+:note-caption: Nota
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefácio]
+//:section-refsig: ???
+:table-caption: Tabela
+:tip-caption: Dica
+:toc-title: Índice
+:untitled-label: Sem título
+:version-label: Versão
+:warning-caption: Aviso
diff -pruN 1.5.6.2-2/data/locale/attributes-ro.adoc 1.5.7-1/data/locale/attributes-ro.adoc
--- 1.5.6.2-2/data/locale/attributes-ro.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-ro.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Romanian translation, courtesy of Vitalie Lazu <vitalie.lazu@gmail.com>
+:appendix-caption: Apendix
+:appendix-refsig: {appendix-caption}
+:caution-caption: Precauție
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Exemplu
+:figure-caption: Figură
+:important-caption: Important
+:last-update-label: Ultima actualizare
+ifdef::listing-caption[:listing-caption: Listare]
+//:manname-title: NUME
+:note-caption: Notă
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Prefață]
+//:section-refsig: ???
+:table-caption: Tabela
+:tip-caption: Sfat
+:toc-title: Cuprins
+:untitled-label: Fără denumire
+:version-label: Versiunea
+:warning-caption: Atenție
diff -pruN 1.5.6.2-2/data/locale/attributes-ru.adoc 1.5.7-1/data/locale/attributes-ru.adoc
--- 1.5.6.2-2/data/locale/attributes-ru.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-ru.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Russian translation, courtesy of Alexander Zobkov <alexander.zobkov@gmail.com>
+:appendix-caption: Приложение
+:appendix-refsig: {appendix-caption}
+:caution-caption: Внимание
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Пример
+:figure-caption: Рисунок
+:important-caption: Важно
+:last-update-label: Последний раз обновлено
+ifdef::listing-caption[:listing-caption: Листинг]
+//:manname-title: НАЗВАНИЕ
+:note-caption: Примечание
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Предисловие]
+//:section-refsig: ???
+:table-caption: Таблица
+:tip-caption: Подсказка
+:toc-title: Содержание
+:untitled-label: Без названия
+:version-label: Версия
+:warning-caption: Предупреждение
diff -pruN 1.5.6.2-2/data/locale/attributes-sr.adoc 1.5.7-1/data/locale/attributes-sr.adoc
--- 1.5.6.2-2/data/locale/attributes-sr.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-sr.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Serbian Cyrillic translation, courtesy of Bojan Stipic <bojan-7@live.com>
+:appendix-caption: Додатак
+:appendix-refsig: {appendix-caption}
+:caution-caption: Опрез
+:chapter-label: Поглавље
+:chapter-refsig: {chapter-label}
+:example-caption: Пример
+:figure-caption: Слика
+:important-caption: Важно
+:last-update-label: Последње ажурирано
+ifdef::listing-caption[:listing-caption: Списак]
+//:manname-title: НАЗИВ
+:note-caption: Белешка
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Предговор]
+//:section-refsig: ???
+:table-caption: Табела
+:tip-caption: Савет
+:toc-title: Садржај
+:untitled-label: Без назива
+:version-label: Верзија
+:warning-caption: Упозорење
diff -pruN 1.5.6.2-2/data/locale/attributes-sr_Latn.adoc 1.5.7-1/data/locale/attributes-sr_Latn.adoc
--- 1.5.6.2-2/data/locale/attributes-sr_Latn.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-sr_Latn.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Serbian Latin translation, courtesy of Bojan Stipic <bojan-7@live.com>
+:appendix-caption: Dodatak
+:appendix-refsig: {appendix-caption}
+:caution-caption: Oprez
+:chapter-label: Poglavlje
+:chapter-refsig: {chapter-label}
+:example-caption: Primer
+:figure-caption: Slika
+:important-caption: Važno
+:last-update-label: Poslednje ažurirano
+ifdef::listing-caption[:listing-caption: Spisak]
+//:manname-title: NAZIV
+:note-caption: Beleška
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Predgovor]
+//:section-refsig: ???
+:table-caption: Tabela
+:tip-caption: Savet
+:toc-title: Sadržaj
+:untitled-label: Bez naziva
+:version-label: Verzija
+:warning-caption: Upozorenje
diff -pruN 1.5.6.2-2/data/locale/attributes-tr.adoc 1.5.7-1/data/locale/attributes-tr.adoc
--- 1.5.6.2-2/data/locale/attributes-tr.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-tr.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Turkish translation, courtesy of Rahman Usta <rahman.usta.88@gmail.com>
+:appendix-caption: Ek bölüm
+:appendix-refsig: {appendix-caption}
+:caution-caption: Dikkat
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Örnek
+:figure-caption: Görsel
+:important-caption: Önemli
+:last-update-label: Son güncelleme
+ifdef::listing-caption[:listing-caption: Listeleme]
+//:manname-title: İSİM
+:note-caption: Not
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Ön söz]
+//:section-refsig: ???
+:table-caption: Tablo
+:tip-caption: İpucu
+:toc-title: İçindekiler
+:untitled-label: İsimsiz
+:version-label: Versiyon
+:warning-caption: Uyarı
diff -pruN 1.5.6.2-2/data/locale/attributes-uk.adoc 1.5.7-1/data/locale/attributes-uk.adoc
--- 1.5.6.2-2/data/locale/attributes-uk.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-uk.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Ukrainian translation, courtesy of Kyrylo Yatsenko <hedrok@gmail.com>
+:appendix-caption: Додаток
+:appendix-refsig: {appendix-caption}
+:caution-caption: Обережно
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: Приклад
+:figure-caption: Зображення
+:important-caption: Важливо
+:last-update-label: Востаннє оновлено
+ifdef::listing-caption[:listing-caption: Лістинг]
+//:manname-title: НАЗВА
+:note-caption: Зауваження
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: Передмова]
+//:section-refsig: ???
+:table-caption: Таблиця
+:tip-caption: Підказка
+:toc-title: Зміст
+:untitled-label: Без назви
+:version-label: Версія
+:warning-caption: Попередження
diff -pruN 1.5.6.2-2/data/locale/attributes-zh_CN.adoc 1.5.7-1/data/locale/attributes-zh_CN.adoc
--- 1.5.6.2-2/data/locale/attributes-zh_CN.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-zh_CN.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Simplified Chinese translation, courtesy of John Dong <dongwqs@gmail.com>
+:appendix-caption: 附录
+:appendix-refsig: {appendix-caption}
+:caution-caption: 注意
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: 示例
+:figure-caption: 图表
+:important-caption: 重要
+:last-update-label: 最后更新
+ifdef::listing-caption[:listing-caption: 列表]
+//:manname-title: 名称
+:note-caption: 笔记
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: 序言]
+//:section-refsig: ???
+:table-caption: 表格
+:tip-caption: 提示
+:toc-title: 目录
+:untitled-label: 暂无标题
+:version-label: 版本
+:warning-caption: 警告
diff -pruN 1.5.6.2-2/data/locale/attributes-zh_TW.adoc 1.5.7-1/data/locale/attributes-zh_TW.adoc
--- 1.5.6.2-2/data/locale/attributes-zh_TW.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/data/locale/attributes-zh_TW.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,22 @@
+// Traditional Chinese translation, courtesy of John Dong <dongwqs@gmail.com>
+:appendix-caption: 附錄
+:appendix-refsig: {appendix-caption}
+:caution-caption: 注意
+//:chapter-label: ???
+//:chapter-refsig: {chapter-label}
+:example-caption: 示例
+:figure-caption: 圖表
+:important-caption: 重要
+:last-update-label: 最後更新
+ifdef::listing-caption[:listing-caption: 列表]
+//:manname-title: 名稱
+:note-caption: 筆記
+//:part-refsig: ???
+ifdef::preface-title[:preface-title: 序言]
+//:section-refsig: ???
+:table-caption: 表格
+:tip-caption: 提示
+:toc-title: 目錄
+:untitled-label: 暫無標題
+:version-label: 版本
+:warning-caption: 警告
diff -pruN 1.5.6.2-2/data/stylesheets/asciidoctor-default.css 1.5.7-1/data/stylesheets/asciidoctor-default.css
--- 1.5.6.2-2/data/stylesheets/asciidoctor-default.css	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/data/stylesheets/asciidoctor-default.css	2018-05-05 22:54:38.000000000 +0000
@@ -1,10 +1,9 @@
 /* Asciidoctor default stylesheet | MIT License | http://asciidoctor.org */
-/* Remove comment around @import statement below when using as a custom stylesheet */
+/* Uncomment @import statement below to use as custom stylesheet */
 /*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
 article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section,summary{display:block}
 audio,canvas,video{display:inline-block}
 audio:not([controls]){display:none;height:0}
-[hidden],template{display:none}
 script{display:none!important}
 html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
 a{background:transparent}
@@ -34,12 +33,10 @@ button,select{text-transform:none}
 button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
 button[disabled],html input[disabled]{cursor:default}
 input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
-input[type="search"]{-webkit-appearance:textfield;-moz-box-sizing:content-box;-webkit-box-sizing:content-box;box-sizing:content-box}
-input[type="search"]::-webkit-search-cancel-button,input[type="search"]::-webkit-search-decoration{-webkit-appearance:none}
 button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
 textarea{overflow:auto;vertical-align:top}
 table{border-collapse:collapse;border-spacing:0}
-*,*:before,*:after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
+*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
 html,body{font-size:100%}
 body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
 a:hover{cursor:pointer}
@@ -57,8 +54,7 @@ img,object,svg{display:inline-block;vert
 textarea{height:auto;min-height:50px}
 select{width:100%}
 .center{margin-left:auto;margin-right:auto}
-.spread{width:100%}
-p.lead,.paragraph.lead>p,#preamble>.sectionbody>.paragraph:first-of-type p{font-size:1.21875em;line-height:1.6}
+.stretch{width:100%}
 .subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
 div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0;direction:ltr}
 a{color:#2156a5;text-decoration:underline;line-height:inherit}
@@ -92,24 +88,24 @@ abbr,acronym{text-transform:uppercase;fo
 abbr{text-transform:none}
 blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
 blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
-blockquote cite:before{content:"\2014 \0020"}
+blockquote cite::before{content:"\2014 \0020"}
 blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
 blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
-@media only screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
+@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
 h1{font-size:2.75em}
 h2{font-size:2.3125em}
 h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
 h4{font-size:1.4375em}}
 table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede}
-table thead,table tfoot{background:#f7f8f7;font-weight:bold}
+table thead,table tfoot{background:#f7f8f7}
 table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
 table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
 table tr.even,table tr.alt,table tr:nth-of-type(even){background:#f8f8f7}
 table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
 h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
 h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
-.clearfix:before,.clearfix:after,.float-group:before,.float-group:after{content:" ";display:table}
-.clearfix:after,.float-group:after{clear:both}
+.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
+.clearfix::after,.float-group::after{clear:both}
 *:not(pre)>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background-color:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed;word-wrap:break-word}
 *:not(pre)>code.nobreak{word-wrap:normal}
 *:not(pre)>code.nowrap{white-space:nowrap}
@@ -125,15 +121,15 @@ kbd{font-family:"Droid Sans Mono","DejaV
 .menuseq{word-spacing:-.02em}
 .menuseq b.caret{font-size:1.25em;line-height:.8}
 .menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
-b.button:before,b.button:after{position:relative;top:-1px;font-weight:400}
-b.button:before{content:"[";padding:0 3px 0 2px}
-b.button:after{content:"]";padding:0 2px 0 3px}
+b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
+b.button::before{content:"[";padding:0 3px 0 2px}
+b.button::after{content:"]";padding:0 2px 0 3px}
 p a>code:hover{color:rgba(0,0,0,.9)}
 #header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
-#header:before,#header:after,#content:before,#content:after,#footnotes:before,#footnotes:after,#footer:before,#footer:after{content:" ";display:table}
-#header:after,#content:after,#footnotes:after,#footer:after{clear:both}
+#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
+#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
 #content{margin-top:1.25em}
-#content:before{content:none}
+#content::before{content:none}
 #header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
 #header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #ddddd8}
 #header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #ddddd8;padding-bottom:8px}
@@ -141,11 +137,11 @@ p a>code:hover{color:rgba(0,0,0,.9)}
 #header .details span:first-child{margin-left:-.125em}
 #header .details span.email a{color:rgba(0,0,0,.85)}
 #header .details br{display:none}
-#header .details br+span:before{content:"\00a0\2013\00a0"}
-#header .details br+span.author:before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
-#header .details br+span#revremark:before{content:"\00a0|\00a0"}
+#header .details br+span::before{content:"\00a0\2013\00a0"}
+#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
+#header .details br+span#revremark::before{content:"\00a0|\00a0"}
 #header #revnumber{text-transform:capitalize}
-#header #revnumber:after{content:"\00a0"}
+#header #revnumber::after{content:"\00a0"}
 #content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #ddddd8;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
 #toc{border-bottom:1px solid #efefed;padding-bottom:.5em}
 #toc>ul{margin-left:.125em}
@@ -156,7 +152,7 @@ p a>code:hover{color:rgba(0,0,0,.9)}
 #toc a{text-decoration:none}
 #toc a:active{text-decoration:underline}
 #toctitle{color:#7a2518;font-size:1.2em}
-@media only screen and (min-width:768px){#toctitle{font-size:1.375em}
+@media screen and (min-width:768px){#toctitle{font-size:1.375em}
 body.toc2{padding-left:15em;padding-right:0}
 #toc.toc2{margin-top:0!important;background-color:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #efefed;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
 #toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
@@ -165,7 +161,7 @@ body.toc2{padding-left:15em;padding-righ
 #toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
 body.toc2.toc-right{padding-left:0;padding-right:15em}
 body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #efefed;left:auto;right:0}}
-@media only screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
+@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
 #toc.toc2{width:20em}
 #toc.toc2 #toctitle{font-size:1.375em}
 #toc.toc2>ul{font-size:.95em}
@@ -176,22 +172,25 @@ body.toc2.toc-right{padding-left:0;paddi
 #content #toc>:last-child{margin-bottom:0}
 #footer{max-width:100%;background-color:rgba(0,0,0,.8);padding:1.25em}
 #footer-text{color:rgba(255,255,255,.8);line-height:1.44}
+#content{margin-bottom:.625em}
 .sect1{padding-bottom:.625em}
-@media only screen and (min-width:768px){.sect1{padding-bottom:1.25em}}
+@media screen and (min-width:768px){#content{margin-bottom:1.25em}
+.sect1{padding-bottom:1.25em}}
+.sect1:last-child{padding-bottom:0}
 .sect1+.sect1{border-top:1px solid #efefed}
 #content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
-#content h1>a.anchor:before,h2>a.anchor:before,h3>a.anchor:before,#toctitle>a.anchor:before,.sidebarblock>.content>.title>a.anchor:before,h4>a.anchor:before,h5>a.anchor:before,h6>a.anchor:before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
+#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
 #content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
 #content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
 #content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
 .audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
 .admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
-table.tableblock>caption.title{white-space:nowrap;overflow:visible;max-width:0}
-.paragraph.lead>p,#preamble>.sectionbody>.paragraph:first-of-type p{color:rgba(0,0,0,.85)}
+table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
+.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
 table.tableblock #preamble>.sectionbody>.paragraph:first-of-type p{font-size:inherit}
 .admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
 .admonitionblock>table td.icon{text-align:center;width:80px}
-.admonitionblock>table td.icon img{max-width:initial}
+.admonitionblock>table td.icon img{max-width:none}
 .admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
 .admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #ddddd8;color:rgba(0,0,0,.6)}
 .admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
@@ -207,17 +206,17 @@ table.tableblock #preamble>.sectionbody>
 .sidebarblock .literalblock pre,.sidebarblock .listingblock pre:not(.highlight),.sidebarblock .listingblock pre[class="highlight"],.sidebarblock .listingblock pre[class^="highlight "],.sidebarblock .listingblock pre.CodeRay,.sidebarblock .listingblock pre.prettyprint{background:#f2f1f1}
 .literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{-webkit-border-radius:4px;border-radius:4px;word-wrap:break-word;padding:1em;font-size:.8125em}
 .literalblock pre.nowrap,.literalblock pre[class].nowrap,.listingblock pre.nowrap,.listingblock pre[class].nowrap{overflow-x:auto;white-space:pre;word-wrap:normal}
-@media only screen and (min-width:768px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:.90625em}}
-@media only screen and (min-width:1280px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:1em}}
+@media screen and (min-width:768px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:.90625em}}
+@media screen and (min-width:1280px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:1em}}
 .literalblock.output pre{color:#f7f7f8;background-color:rgba(0,0,0,.9)}
 .listingblock pre.highlightjs{padding:0}
 .listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
 .listingblock pre.prettyprint{border-width:0}
 .listingblock>.content{position:relative}
-.listingblock code[data-lang]:before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:#999}
-.listingblock:hover code[data-lang]:before{display:block}
-.listingblock.terminal pre .command:before{content:attr(data-prompt);padding-right:.5em;color:#999}
-.listingblock.terminal pre .command:not([data-prompt]):before{content:"$"}
+.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:#999}
+.listingblock:hover code[data-lang]::before{display:block}
+.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:#999}
+.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
 table.pyhltable{border-collapse:separate;border:0;margin-bottom:0;background:none}
 table.pyhltable td{vertical-align:top;padding-top:0;padding-bottom:0;line-height:1.45}
 table.pyhltable td.code{padding-left:.75em;padding-right:0}
@@ -228,35 +227,39 @@ table.pyhltable .linenodiv{background:no
 .quoteblock>.title{margin-left:-1.5em;margin-bottom:.75em}
 .quoteblock blockquote,.quoteblock blockquote p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
 .quoteblock blockquote{margin:0;padding:0;border:0}
-.quoteblock blockquote:before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
+.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
 .quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
 .quoteblock .attribution{margin-top:.5em;margin-right:.5ex;text-align:right}
 .quoteblock .quoteblock{margin-left:0;margin-right:0;padding:.5em 0;border-left:3px solid rgba(0,0,0,.6)}
 .quoteblock .quoteblock blockquote{padding:0 0 0 .75em}
-.quoteblock .quoteblock blockquote:before{display:none}
-.verseblock{margin:0 1em 1.25em 1em}
+.quoteblock .quoteblock blockquote::before{display:none}
+.verseblock{margin:0 1em 1.25em}
 .verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
 .verseblock pre strong{font-weight:400}
 .verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
 .quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
 .quoteblock .attribution br,.verseblock .attribution br{display:none}
 .quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
-.quoteblock.abstract{margin:0 0 1.25em 0;display:block}
-.quoteblock.abstract blockquote,.quoteblock.abstract blockquote p{text-align:left;word-spacing:0}
-.quoteblock.abstract blockquote:before,.quoteblock.abstract blockquote p:first-of-type:before{display:none}
+.quoteblock.abstract{margin:0 1em 1.25em;display:block}
+.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
+.quoteblock.abstract blockquote,.quoteblock.abstract blockquote p{word-spacing:0;line-height:1.6}
+.quoteblock.abstract blockquote::before,.quoteblock.abstract p::before{display:none}
 table.tableblock{max-width:100%;border-collapse:separate}
-table.tableblock td>.paragraph:last-child p>p:last-child,table.tableblock th>p:last-child,table.tableblock td>p:last-child{margin-bottom:0}
+p.tableblock:last-child{margin-bottom:0}
+td.tableblock>.content{margin-bottom:-1.25em}
 table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
 table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
 table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
 table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
-table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px 0}
-table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0 0}
+table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
+table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
 table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
 table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
 table.frame-all{border-width:1px}
 table.frame-sides{border-width:0 1px}
-table.frame-topbot{border-width:1px 0}
+table.frame-topbot,table.frame-ends{border-width:1px 0}
+table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd){background:#f8f8f7}
+table.stripes-none tr,table.stripes-odd tr:nth-of-type(even){background:none}
 th.halign-left,td.halign-left{text-align:left}
 th.halign-right,td.halign-right{text-align:right}
 th.halign-center,td.halign-center{text-align:center}
@@ -280,9 +283,8 @@ ul.unstyled,ol.unstyled{margin-left:0}
 ul.checklist{margin-left:.625em}
 ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
 ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
-ul.inline{margin:0 auto .625em auto;margin-left:-1.375em;margin-right:0;padding:0;list-style:none;overflow:hidden}
-ul.inline>li{list-style:none;float:left;margin-left:1.375em;display:block}
-ul.inline>li>*{display:block}
+ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
+ul.inline>li{margin-left:1.25em}
 .unstyled dl dt{font-weight:400;font-style:normal}
 ol.arabic{list-style-type:decimal}
 ol.decimal{list-style-type:decimal-leading-zero}
@@ -296,9 +298,9 @@ ol.lowergreek{list-style-type:lower-gree
 td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
 td.hdlist1{font-weight:bold;padding-bottom:1.25em}
 .literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
-.colist>table tr>td:first-of-type{padding:.4em .75em 0 .75em;line-height:1;vertical-align:top}
-.colist>table tr>td:first-of-type img{max-width:initial}
-.colist>table tr>td:last-of-type{padding:.25em 0}
+.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
+.colist td:not([class]):first-child img{max-width:none}
+.colist td:not([class]):last-child{padding:.25em 0}
 .thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
 .imageblock.left,.imageblock[style*="float: left"]{margin:.25em .625em 1.25em 0}
 .imageblock.right,.imageblock[style*="float: right"]{margin:.25em 0 1.25em .625em}
@@ -314,9 +316,9 @@ sup.footnote,sup.footnoteref{font-size:.
 sup.footnote a,sup.footnoteref a{text-decoration:none}
 sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
 #footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
-#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em 0;border-width:1px 0 0 0}
-#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;text-indent:-1.05em;margin-bottom:.2em}
-#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none}
+#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
+#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
+#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
 #footnotes .footnote:last-of-type{margin-bottom:0}
 #content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
 .gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
@@ -362,15 +364,15 @@ div.unbreakable{page-break-inside:avoid}
 span.icon>.fa{cursor:default}
 a span.icon>.fa{cursor:inherit}
 .admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
-.admonitionblock td.icon .icon-note:before{content:"\f05a";color:#19407c}
-.admonitionblock td.icon .icon-tip:before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
-.admonitionblock td.icon .icon-warning:before{content:"\f071";color:#bf6900}
-.admonitionblock td.icon .icon-caution:before{content:"\f06d";color:#bf3400}
-.admonitionblock td.icon .icon-important:before{content:"\f06a";color:#bf0000}
+.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
+.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
+.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
+.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
+.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
 .conum[data-value]{display:inline-block;color:#fff!important;background-color:rgba(0,0,0,.8);-webkit-border-radius:100px;border-radius:100px;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
 .conum[data-value] *{color:#fff!important}
 .conum[data-value]+b{display:none}
-.conum[data-value]:after{content:attr(data-value)}
+.conum[data-value]::after{content:attr(data-value)}
 pre .conum[data-value]{position:relative;top:-.125em}
 b.conum *{color:inherit!important}
 .conum:not([data-value]):empty{display:none}
@@ -382,12 +384,13 @@ p{margin-bottom:1.25rem}
 .sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
 .exampleblock>.content{background-color:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
 .print-only{display:none!important}
-@media print{@page{margin:1.25cm .75cm}
-*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
+@page{margin:1.25cm .75cm}
+@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
+html{font-size:80%}
 a{color:inherit!important;text-decoration:underline!important}
 a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
-a[href^="http:"]:not(.bare):after,a[href^="https:"]:not(.bare):after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
-abbr[title]:after{content:" (" attr(title) ")"}
+a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
+abbr[title]::after{content:" (" attr(title) ")"}
 pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
 thead{display:table-header-group}
 svg{max-width:100%}
@@ -395,21 +398,23 @@ p,blockquote,dt,td.content{font-size:1em
 h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
 #toc,.sidebarblock,.exampleblock>.content{background:none!important}
 #toc{border-bottom:1px solid #ddddd8!important;padding-bottom:0!important}
-.sect1{padding-bottom:0!important}
-.sect1+.sect1{border:0!important}
-#header>h1:first-child{margin-top:1.25rem}
 body.book #header{text-align:center}
-body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em 0}
+body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
 body.book #header .details{border:0!important;display:block;padding:0!important}
 body.book #header .details span:first-child{margin-left:0!important}
 body.book #header .details br{display:block}
-body.book #header .details br+span:before{content:none!important}
+body.book #header .details br+span::before{content:none!important}
 body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
 body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
-.listingblock code[data-lang]:before{display:block}
-#footer{background:none!important;padding:0 .9375em}
-#footer-text{color:rgba(0,0,0,.6)!important;font-size:.9em}
+.listingblock code[data-lang]::before{display:block}
+#footer{padding:0 .9375em}
 .hide-on-print{display:none!important}
 .print-only{display:block!important}
 .hide-for-print{display:none!important}
 .show-for-print{display:inherit!important}}
+@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
+.sect1{padding:0!important}
+.sect1+.sect1{border:0}
+#footer{background:none}
+#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
+@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
diff -pruN 1.5.6.2-2/debian/changelog 1.5.7-1/debian/changelog
--- 1.5.6.2-2/debian/changelog	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/changelog	2018-05-06 08:14:29.000000000 +0000
@@ -1,3 +1,18 @@
+asciidoctor (1.5.7-1) unstable; urgency=low
+
+  * New upstream version 1.5.7 (Closes: #895186, #895187)
+  * remove fix-manpage-topic.patch merged upstream
+  * remove re-add_README.patch merged upstream
+  * remove skip-asciimath-test.patch as obsolete thanks to upstream change
+  * refresh quilt patches against the new version
+  * d/rules: use ASCIIDOCTOR_MANPAGE_PATH to avoid issues during the tests
+  * d/ruby-tests.rake: add ASCIIDOCTOR_MANPAGE_PATH to autopkgtests
+  * Update the privacy breach patch with the latest version requirements
+  * Change the lib_directory_in_tests.patch to be forwardable upstream
+  * Make package-version.patch forwardable to upstream
+
+ -- Joseph Herlant <herlantj@gmail.com>  Sun, 06 May 2018 01:14:29 -0700
+
 asciidoctor (1.5.6.2-2) unstable; urgency=low
 
   * Force the install of data files even when DH_CONFIG_ACT_ON_PACKAGES is set
diff -pruN 1.5.6.2-2/debian/patches/data_path.patch 1.5.7-1/debian/patches/data_path.patch
--- 1.5.6.2-2/debian/patches/data_path.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/data_path.patch	2018-05-06 08:14:29.000000000 +0000
@@ -3,7 +3,7 @@ Subject: Load data from /usr/share/ascii
 Bug-Debian: https://bugs.debian.org/788052
 --- a/lib/asciidoctor.rb
 +++ b/lib/asciidoctor.rb
-@@ -189,7 +189,7 @@
+@@ -197,7 +197,7 @@
    #LIB_PATH = ::File.join ROOT_PATH, 'lib'
  
    # The absolute data path of the Asciidoctor RubyGem
diff -pruN 1.5.6.2-2/debian/patches/disable_badge_in_README.patch 1.5.7-1/debian/patches/disable_badge_in_README.patch
--- 1.5.6.2-2/debian/patches/disable_badge_in_README.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/disable_badge_in_README.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-Description: Remove the badge in the readme to avoid lintian complaining about
- privacy-breach-generic
-Author: Joseph Herlant <herlantj@gmail.com>
-Forwarded: not-needed
-Last-Update: 2018-04-11
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- a/README.adoc
-+++ b/README.adoc
-@@ -397,7 +397,6 @@
- 
- Discussion list (Nabble):: {uri-discuss}
- Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] hashtag or https://twitter.com/asciidoctor[@asciidoctor] mention
--Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
- ////
- Chat (IRC):: {uri-irc}[#asciidoctor] on FreeNode IRC
- ////
diff -pruN 1.5.6.2-2/debian/patches/fix-manpage-topic.patch 1.5.7-1/debian/patches/fix-manpage-topic.patch
--- 1.5.6.2-2/debian/patches/fix-manpage-topic.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/fix-manpage-topic.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,32 +0,0 @@
-Description: Fix issues when running the tests on the help for the manpage topic
- and when reading help in an environment installed via distro package
-Author: Joseph Herlant <herlantj@gmail.com>
-Forwarded: https://github.com/asciidoctor/asciidoctor/pull/2653
-Last-Update: 2018-04-08
-
---- a/test/options_test.rb
-+++ b/test/options_test.rb
-@@ -23,6 +23,7 @@
-   end
- 
-   test 'should dump man page and return error code 0 when help topic is manpage' do
-+    skip 'this test should run only in a gem install context' if ENV['ASCIIDOCTOR_MANPAGE_ABSENT_FROM_TEST']
-     exitval, output = redirect_streams do |out, _|
-       [Asciidoctor::Cli::Options.parse!(%w(-h manpage)), out.string]
-     end
-@@ -31,6 +32,15 @@
-     assert_includes output, '.TH "ASCIIDOCTOR"'
-   end
- 
-+  test 'should print a message and return error code 1 when help topic is manpage' do
-+    skip 'this test should run outside of the gem context' unless ENV['ASCIIDOCTOR_MANPAGE_ABSENT_FROM_TEST']
-+    redirect_streams do |out, stderr|
-+      exitval = Asciidoctor::Cli::Options.parse!(%w(-h manpage))
-+      assert_equal 1, exitval
-+      assert_equal 'asciidoctor: FAILED: man page not found; try `man asciidoctor`', stderr.string.chomp
-+    end
-+  end
-+
-   test 'should return error code 1 when invalid option present' do
-     redirect_streams do |stdout, stderr|
-       exitval = Asciidoctor::Cli::Options.parse!(%w(--foobar))
diff -pruN 1.5.6.2-2/debian/patches/lib_directory_in_tests.patch 1.5.7-1/debian/patches/lib_directory_in_tests.patch
--- 1.5.6.2-2/debian/patches/lib_directory_in_tests.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/lib_directory_in_tests.patch	2018-05-06 08:14:29.000000000 +0000
@@ -1,24 +1,23 @@
-From: Guillaume Grossetie <ggrossetie@gmail.com>
-Subject: Exclude lib/ directory from tests
---- a/Rakefile
-+++ b/Rakefile
-@@ -20,7 +20,7 @@
-   Rake::TestTask.new(:test) do |t|
-     prepare_test_env
-     puts %(LANG: #{ENV['LANG']}) if ENV.key? 'TRAVIS_BUILD_ID'
--    t.libs << 'test'
-+    t.libs = ['test']
-     t.pattern = 'test/**/*_test.rb'
-     t.verbose = true
-     t.warning = true
+From: Joseph Herlant <herlantj@gmail.com>
+Subject: Make the asciidoc lib dir available via environment variable for better
+ flexibility
+Forwarded: https://github.com/asciidoctor/asciidoctor/pull/2758
 --- a/test/test_helper.rb
 +++ b/test/test_helper.rb
-@@ -8,7 +8,7 @@
+@@ -1,6 +1,7 @@
+ # encoding: UTF-8
+ ASCIIDOCTOR_TEST_DIR = File.expand_path File.dirname __FILE__
+ ASCIIDOCTOR_PROJECT_DIR = File.dirname ASCIIDOCTOR_TEST_DIR
++ASCIIDOCTOR_LIB_DIR = ENV['ASCIIDOCTOR_LIB_DIR'] || File.join(ASCIIDOCTOR_PROJECT_DIR, 'lib')
+ Dir.chdir ASCIIDOCTOR_PROJECT_DIR
+ 
+ if RUBY_VERSION < '1.9'
+@@ -9,7 +10,7 @@
  
  require 'simplecov' if ENV['COVERAGE'] == 'true'
  
 -require File.join(ASCIIDOCTOR_PROJECT_DIR, 'lib', 'asciidoctor')
-+require 'asciidoctor'
++require File.join(ASCIIDOCTOR_LIB_DIR, 'asciidoctor')
  
  require 'socket'
  require 'nokogiri'
diff -pruN 1.5.6.2-2/debian/patches/package-version.patch 1.5.7-1/debian/patches/package-version.patch
--- 1.5.6.2-2/debian/patches/package-version.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/package-version.patch	2018-05-06 08:14:29.000000000 +0000
@@ -1,27 +1,46 @@
 Description: gemspec: load asciidoctor/version from system is not available locally
  This fixes running tests under autopkgtest
-Author: Antonio Terceiro <terceiro@debian.org>
-Origin: vendor
-Forwarded: no
-Last-Update: 2015-11-17
+Author: Joseph Herlant <herlantj@gmail.com>
+Forwarded: https://github.com/asciidoctor/asciidoctor/pull/2760
+Last-Update: 2018-05-06
 ---
 This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
 --- a/asciidoctor.gemspec
 +++ b/asciidoctor.gemspec
-@@ -1,5 +1,6 @@
+@@ -1,5 +1,10 @@
  # encoding: UTF-8
 -require File.expand_path '../lib/asciidoctor/version', __FILE__
-+$LOAD_PATH << File.expand_path('../lib', __FILE__)
-+require 'asciidoctor/version'
++begin
++  require 'asciidoctor/version'
++rescue LoadError
++  require File.expand_path '../lib/asciidoctor/version', __FILE__
++end
++
  require 'open3' unless defined? Open3
  
  Gem::Specification.new do |s|
 --- a/Rakefile
 +++ b/Rakefile
-@@ -1,4 +1,5 @@
+@@ -1,5 +1,3 @@
 -require File.expand_path '../lib/asciidoctor/version', __FILE__
-+$LOAD_PATH << File.expand_path('../lib', __FILE__)
-+require 'asciidoctor/version'
- 
+-
  def prepare_test_env
    # rather than hardcoding gc settings in test task,
+   # could use https://gist.github.com/benders/788695
+@@ -65,16 +63,6 @@
+ 
+ begin
+   require 'bundler/gem_tasks'
+-
+-  # Enhance the release task to create an explicit commit for the release
+-  #Rake::Task[:release].enhance [:commit_release]
+-
+-  # NOTE you don't need to push after updating version and committing locally
+-  # WARNING no longer works; it's now necessary to get master in a state ready for tagging
+-  task :commit_release do
+-    Bundler::GemHelper.new.send(:guard_clean)
+-    sh "git commit --allow-empty -a -m 'Release #{Asciidoctor::VERSION}'"
+-  end
+ rescue LoadError
+ end
+ 
diff -pruN 1.5.6.2-2/debian/patches/privacy_breach.patch 1.5.7-1/debian/patches/privacy_breach.patch
--- 1.5.6.2-2/debian/patches/privacy_breach.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/debian/patches/privacy_breach.patch	2018-05-06 08:14:29.000000000 +0000
@@ -0,0 +1,58 @@
+Description: Remove the badge in the readme to avoid lintian complaining about
+ privacy-breach-generic
+Author: Joseph Herlant <herlantj@gmail.com>
+Forwarded: not-needed
+Last-Update: 2018-05-05
+---
+This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
+--- a/README.adoc
++++ b/README.adoc
+@@ -94,10 +94,6 @@
+ We want to recognize our generous sponsors, without whose support Asciidoctor would not be possible.
+ Thank you sponsors for your dedication to improving the state of technical documentation!
+ 
+-image:https://www.okta.com/sites/all/themes/Okta/images/blog/Logos/Okta_Logo_BrightBlue_Medium.png[Okta,280,link=https://developer.okta.com/signup?utm_source=asciidoctor&utm_medium=logo&utm_campaign=sponsor,title="Add User Auth to Your Apps in Minutes with Okta"]
+-&nbsp; &nbsp; &nbsp;
+-image:https://secure.gravatar.com/avatar/823717a797dbd78ceff7b26aa397f383.png?size=200[OpenDevise,100,link=https://opendevise.com,title="Let the Creators of Asciidoctor and Antora Help You to Accelerate Your Docs"]
+-
+ Major funding for Asciidoctor is provided by our *Change Makers*, https://developer.okta.com/signup?utm_source=asciidoctor&utm_medium=text-link&utm_campaign=sponsor[Okta] and https://opendevise.com[OpenDevise], and our *Strategy Sponsors*, Khronos Group and Linda Roberts.
+ Additional funding is provided by our https://asciidoctor.org/supporters[Community Backers].
+ 
+@@ -412,7 +408,6 @@
+ 
+ Discussion list (Nabble):: {uri-discuss}
+ Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] hashtag or https://twitter.com/asciidoctor[@asciidoctor] mention
+-Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+ ////
+ Chat (IRC):: {uri-irc}[#asciidoctor] on FreeNode IRC
+ ////
+--- a/README-fr.adoc
++++ b/README-fr.adoc
+@@ -399,7 +399,6 @@
+ 
+ Mailing list:: {uri-discuss}
+ Twitter:: hashtag https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] ou la mention https://twitter.com/asciidoctor[@asciidoctor]
+-Gitter (Chat):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+ ////
+ IRC (Chat):: {uri-irc}[#asciidoctor] sur FreeNode IRC
+ ////
+--- a/README-jp.adoc
++++ b/README-jp.adoc
+@@ -379,7 +379,6 @@
+ 
+ Discussion list (Nabble):: {uri-discuss}
+ Twitter:: #asciidoctor hashtag or @asciidoctor mention
+-Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+ 
+ ifdef::env-github[]
+ 以下のプロジェクトサイトに、Asciidoctorに関するさらに詳しい情報やドキュメントがあります。
+--- a/README-zh_CN.adoc
++++ b/README-zh_CN.adoc
+@@ -395,7 +395,6 @@
+ 
+ 讨论组 (Nabble):: {uri-discuss}
+ Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] 来加入话题 或 https://twitter.com/asciidoctor[@asciidoctor] at并提醒我们
+-聊天 (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+ 
+ ifdef::env-github[]
+ Further information and documentation about Asciidoctor can be found on the project's website.
diff -pruN 1.5.6.2-2/debian/patches/re-add_README.patch 1.5.7-1/debian/patches/re-add_README.patch
--- 1.5.6.2-2/debian/patches/re-add_README.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/re-add_README.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,460 +0,0 @@
-Description: Due to an upstream typo the README*.adoc files are not included in
- the current release. This fix re-adds the base one.
-Author: Joseph Herlant <herlantj@gmail.com>
-Forwarded: https://github.com/asciidoctor/asciidoctor/pull/2650
-Last-Update: 2018-04-08
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- /dev/null
-+++ b/README.adoc
-@@ -0,0 +1,439 @@
-+= Asciidoctor
-+Dan Allen <https://github.com/mojavelinux[@mojavelinux]>; Sarah White <https://github.com/graphitefriction[@graphitefriction]>; Ryan Waldron <https://github.com/erebor[@erebor]>
-+// settings:
-+:idprefix:
-+:idseparator: -
-+:source-language: ruby
-+:language: {source-language}
-+ifndef::env-github[:icons: font]
-+ifdef::env-github[]
-+:status:
-+:outfilesuffix: .adoc
-+:caution-caption: :fire:
-+:important-caption: :exclamation:
-+:note-caption: :paperclip:
-+:tip-caption: :bulb:
-+:warning-caption: :warning:
-+endif::[]
-+// Variables:
-+:release-version: 1.5.6.2
-+// URIs:
-+:uri-org: https://github.com/asciidoctor
-+:uri-repo: {uri-org}/asciidoctor
-+:uri-asciidoctorj: {uri-org}/asciidoctorj
-+:uri-asciidoctorjs: {uri-org}/asciidoctor.js
-+:uri-project: https://asciidoctor.org
-+ifdef::env-site[:uri-project: link:]
-+:uri-docs: {uri-project}/docs
-+:uri-news: {uri-project}/news
-+:uri-manpage: {uri-project}/man/asciidoctor
-+:uri-issues: {uri-repo}/issues
-+:uri-contributors: {uri-repo}/graphs/contributors
-+:uri-rel-file-base: link:
-+:uri-rel-tree-base: link:
-+ifdef::env-site[]
-+:uri-rel-file-base: {uri-repo}/blob/master/
-+:uri-rel-tree-base: {uri-repo}/tree/master/
-+endif::[]
-+:uri-changelog: {uri-rel-file-base}CHANGELOG.adoc
-+:uri-contribute: {uri-rel-file-base}CONTRIBUTING.adoc
-+:uri-license: {uri-rel-file-base}LICENSE
-+:uri-tests: {uri-rel-tree-base}test
-+:uri-discuss: http://discuss.asciidoctor.org
-+:uri-irc: irc://irc.freenode.org/#asciidoctor
-+:uri-rubygem: https://rubygems.org/gems/asciidoctor
-+:uri-what-is-asciidoc: {uri-docs}/what-is-asciidoc
-+:uri-user-manual: {uri-docs}/user-manual
-+:uri-install-docker: https://github.com/asciidoctor/docker-asciidoctor
-+//:uri-install-doc: {uri-docs}/install-toolchain
-+:uri-install-macos-doc: {uri-docs}/install-asciidoctor-macos
-+:uri-render-doc: {uri-docs}/render-documents
-+:uri-themes-doc: {uri-docs}/produce-custom-themes-using-asciidoctor-stylesheet-factory
-+:uri-gitscm-repo: https://github.com/git/git-scm.com
-+:uri-prototype: {uri-gitscm-repo}/commits/master/lib/asciidoc.rb
-+:uri-freesoftware: https://www.gnu.org/philosophy/free-sw.html
-+:uri-foundation: https://foundation.zurb.com
-+:uri-tilt: https://github.com/rtomayko/tilt
-+:uri-ruby: https://www.ruby-lang.org
-+// images:
-+:image-uri-screenshot: https://raw.githubusercontent.com/asciidoctor/asciidoctor/master/screenshot.png
-+
-+{uri-project}/[Asciidoctor] is a _fast_ text processor and publishing toolchain for converting {uri-what-is-asciidoc}[AsciiDoc] content to HTML5, DocBook 5 (or 4.5) and other formats.
-+Asciidoctor is written in Ruby, packaged as a RubyGem and published to {uri-rubygem}[RubyGems.org].
-+The gem is also included in several Linux distributions, including Fedora, Debian, Ubuntu, and Alpine.
-+Asciidoctor is open source, {uri-repo}[hosted on GitHub] and released under {uri-license}[the MIT license].
-+
-+ifndef::env-site[]
-+Translations of this document are available in the following languages:
-+
-+* {uri-rel-file-base}README-zh_CN.adoc[汉语]
-+* {uri-rel-file-base}README-fr.adoc[Français]
-+* {uri-rel-file-base}README-jp.adoc[日本語]
-+endif::[]
-+
-+.Key documentation
-+[.compact]
-+* {uri-docs}/what-is-asciidoc[What is Asciidoc?]
-+* {uri-docs}/asciidoc-writers-guide[AsciiDoc Writer's Guide]
-+* {uri-docs}/asciidoc-syntax-quick-reference[AsciiDoc Syntax Reference]
-+* {uri-docs}/user-manual[Asciidoctor User Manual]
-+
-+.Where Ruby goes, Asciidoctor follows
-+****
-+You can run Asciidoctor on the JVM using JRuby.
-+To invoke the Asciidoctor API directly from Java and other JVM languages, use {uri-asciidoctorj}[AsciidoctorJ].
-+There are plugins available, based on AsciidoctorJ, that integrate the Asciidoctor processor into Apache Maven, Gradle or Javadoc builds.
-+
-+Asciidoctor also runs in JavaScript.
-+We use https://opalrb.com[Opal] to transcompile the Ruby source to JavaScript to produce {uri-asciidoctorjs}[Asciidoctor.js], a fully-functional version of Asciidoctor that works in any JavaScript environment, such as a web browser or Node.js.
-+Asciidoctor.js is used to power the AsciiDoc preview extensions for Chrome, Atom, Brackets and other web-based tooling.
-+****
-+
-+ifdef::status[]
-+.*Project health*
-+image:https://img.shields.io/travis/asciidoctor/asciidoctor/master.svg[Build Status (Travis CI), link=https://travis-ci.org/asciidoctor/asciidoctor]
-+image:https://ci.appveyor.com/api/projects/status/ifplu67oxvgn6ceq/branch/master?svg=true&amp;passingText=green%20bar&amp;failingText=%23fail&amp;pendingText=building%2E%2E%2E[Build Status (AppVeyor), link=https://ci.appveyor.com/project/asciidoctor/asciidoctor]
-+//image:https://img.shields.io/coveralls/asciidoctor/asciidoctor/master.svg[Coverage Status, link=https://coveralls.io/r/asciidoctor/asciidoctor]
-+//image:https://codeclimate.com/github/asciidoctor/asciidoctor/badges/gpa.svg[Code Climate, link="https://codeclimate.com/github/asciidoctor/asciidoctor"]
-+image:https://inch-ci.org/github/asciidoctor/asciidoctor.svg?branch=master[Inline docs, link="https://inch-ci.org/github/asciidoctor/asciidoctor"]
-+endif::[]
-+
-+== The Big Picture
-+
-+Asciidoctor reads content written in plain text, as shown in the panel on the left in the image below, and converts it to HTML5, as shown rendered in the right panel.
-+Asciidoctor applies a default stylesheet to the HTML5 document to provide a pleasant out-of-the-box experience.
-+
-+image::{image-uri-screenshot}[Preview of AsciiDoc source and corresponding rendered HTML]
-+
-+== AsciiDoc Processing
-+
-+Asciidoctor reads and parses text written in the AsciiDoc syntax, then feeds the parse tree to a set of built-in converters to produce HTML5, DocBook 5 (or 4.5) or man(ual) page output.
-+You have the option of using your own converter or loading {uri-tilt}[Tilt]-supported templates to customize the generated output or produce additional formats.
-+
-+NOTE: Asciidoctor is a drop-in replacement for the original AsciiDoc Python processor (`asciidoc.py`).
-+The Asciidoctor test suite has {uri-tests}[> 1,900 tests] to ensure compatibility with the AsciiDoc syntax.
-+
-+In addition to the classic AsciiDoc syntax, Asciidoctor recognizes additional markup and formatting options, such as font-based icons (e.g., `+icon:fire[]+`) and UI elements (e.g., `+button:[Save]+`).
-+Asciidoctor also offers a modern, responsive theme based on {uri-foundation}[Foundation] to style the HTML5 output.
-+
-+== Requirements
-+
-+Asciidoctor works on Linux, macOS and Windows and requires one of the following implementations of {uri-ruby}[Ruby]:
-+
-+* Ruby (MRI/CRuby 1.8.7 - 2.5)
-+* JRuby (1.7 in Ruby 1.8 and 1.9 modes, 9000)
-+* Rubinius 2.2.x
-+* Opal (JavaScript)
-+
-+We welcome your help testing Asciidoctor on these and other platforms.
-+Refer to the <<Contributing>> section to learn how to get involved.
-+
-+[CAUTION]
-+====
-+If you're using a non-English Windows environment, you may bump into an `Encoding::UndefinedConversionError` when invoking Asciidoctor.
-+To solve this issue, we recommend changing the active code page in your console to UTF-8:
-+
-+ chcp 65001
-+
-+Once you make this change, all your Unicode headaches will be behind you.
-+If you're using an IDE like Eclipse, make sure you set the encoding to UTF-8 there as well.
-+Asciidoctor works best when you use UTF-8 everywhere.
-+====
-+
-+== Installation
-+
-+Asciidoctor can be installed using (a) the `gem install` command, (b) Bundler, (c) package managers for popular Linux distributions, or (d) Homebrew for macOS.
-+
-+TIP: The benefit of using a Linux package manager to install the gem is that it handles installing Ruby and the RubyGems library if those packages are not already installed on your machine.
-+The drawback is that the package may not be available immediately after the release of the gem.
-+If you need the latest version, you can always fallback to using the `gem` command.
-+
-+=== (a) gem install
-+
-+Open a terminal and type (excluding the leading `$`):
-+
-+ $ gem install asciidoctor
-+
-+If you want to install a pre-release version (e.g., a release candidate), use:
-+
-+ $ gem install asciidoctor --pre
-+
-+.Upgrading your installation
-+[TIP]
-+====
-+If you have an earlier version of Asciidoctor installed, you can update it using:
-+
-+ $ gem update asciidoctor
-+
-+If you install a new version of the gem using `gem install` instead of gem update, you'll have multiple versions installed.
-+If that's the case, use the following gem command to remove the old versions:
-+
-+ $ gem cleanup asciidoctor
-+====
-+
-+=== (b) Bundler
-+
-+. Create a Gemfile in the root folder of your project (or the current directory)
-+. Add the `asciidoctor` gem to your Gemfile as follows:
-++
-+[source,subs=attributes+]
-+----
-+source 'https://rubygems.org'
-+gem 'asciidoctor'
-+# or specify the version explicitly
-+# gem 'asciidoctor', '{release-version}'
-+----
-+
-+. Save the Gemfile
-+. Open a terminal and install the gem using:
-+
-+ $ bundle
-+
-+To upgrade the gem, specify the new version in the Gemfile and run `bundle` again.
-+Using `bundle update` is *not* recommended as it will also update other gems, which may not be the desired result.
-+
-+=== (c) Linux package managers
-+
-+==== DNF (Fedora 21 or greater)
-+
-+To install the gem on Fedora 21 or greater using dnf, open a terminal and type:
-+
-+ $ sudo dnf install -y asciidoctor
-+
-+To upgrade the gem, use:
-+
-+ $ sudo dnf update -y asciidoctor
-+
-+TIP: Your system may be configured to automatically update rpm packages, in which case no action is required by you to update the gem.
-+
-+==== apt-get (Debian, Ubuntu, or Mint)
-+
-+To install the gem on Debian, Ubuntu or Mint, open a terminal and type:
-+
-+ $ sudo apt-get install -y asciidoctor
-+
-+To upgrade the gem, use:
-+
-+ $ sudo apt-get upgrade -y asciidoctor
-+
-+TIP: Your system may be configured to automatically update deb packages, in which case no action is required by you to update the gem.
-+
-+The version of Asciidoctor installed by the package manager (apt-get) may not match the latest release of Asciidoctor.
-+Consult the package repository for your distribution to find out which version is packaged per distribution release.
-+
-+* https://packages.debian.org/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Debian release]
-+* https://packages.ubuntu.com/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Ubuntu release]
-+* https://community.linuxmint.com/software/view/asciidoctor[asciidoctor package by Mint release]
-+
-+[CAUTION]
-+====
-+You're advised against using the `gem update` command to update a gem managed by the package manager.
-+Doing so puts the system into an inconsistent state as the package manager can no longer track the files (which get installed under /usr/local).
-+Simply put, system gems should only be managed by the package manager.
-+
-+If you want to use a version of Asciidoctor that is newer than what is installed by the package manager, you should use https://rvm.io[RVM] to install Ruby in your home directory (i.e., user space).
-+Then, you can safely use the `gem` command to install or update the Asciidoctor gem.
-+When using RVM, gems are installed in a location isolated from the system.
-+====
-+
-+==== apk (Alpine Linux)
-+
-+To install the gem on Alpine Linux, open a terminal and type:
-+
-+ $ sudo apk add asciidoctor
-+
-+To upgrade the gem, use:
-+
-+ $ sudo apk add -u asciidoctor
-+
-+TIP: Your system may be configured to automatically update apk packages, in which case no action is required by you to update the gem.
-+
-+=== (d) Homebrew (macOS)
-+
-+You can use Homebrew to install Asciidoctor on macOS.
-+If you haven't yet installed Homebrew, follow the instructions at https://brew.sh/[brew.sh].
-+
-+Once Homebrew is installed, you can install the `asciidoctor` gem using the http://brewformulas.org/Asciidoctor[asciidoctor] package.
-+To do so, open a terminal and type:
-+
-+ $ brew install asciidoctor
-+
-+To upgrade the gem, use:
-+
-+ $ brew update
-+ $ brew upgrade asciidoctor
-+
-+TIP: Homebrew installs the `asciidoctor` gem into an exclusive prefix that's independent of system gems.
-+
-+=== Other installation options
-+
-+* {uri-install-docker}[Installing Asciidoctor using Docker]
-+* {uri-install-macos-doc}[Installing Asciidoctor on macOS]
-+// at the moment, the following entry is just a reiteration of the information in this README
-+//* {uri-install-doc}[Installing the Asciidoctor toolchain]
-+
-+== Usage
-+
-+If the Asciidoctor gem installed successfully, the `asciidoctor` command line interface (CLI) will be available on your PATH.
-+To verify it's available, run the following in your terminal:
-+
-+ $ asciidoctor --version
-+
-+You should see information about the Asciidoctor version and your Ruby environment printed in the terminal.
-+
-+[.output,subs=attributes+]
-+....
-+Asciidoctor {release-version} [https://asciidoctor.org]
-+Runtime Environment (ruby 2.4.1p111 [x86_64-linux]) (lc:UTF-8 fs:UTF-8 in:- ex:UTF-8)
-+....
-+
-+Asciidoctor also provides an API.
-+The API is intended for integration with other Ruby software, such as Rails, Sinatra and GitHub, and other languages, such as Java (via {uri-asciidoctorj}[AsciidoctorJ]) and JavaScript (via {uri-asciidoctorjs}[Asciidoctor.js]).
-+
-+=== Command line interface (CLI)
-+
-+The `asciidoctor` command allows you to invoke Asciidoctor from the command line (i.e., a terminal).
-+
-+The following command converts the file README.adoc to HTML and saves the result to the file README.html in the same directory.
-+The name of the generated HTML file is derived from the source file by changing its file extension to `.html`.
-+
-+ $ asciidoctor README.adoc
-+
-+You can control the Asciidoctor processor by adding various flags and switches, which you can learn about using:
-+
-+ $ asciidoctor --help
-+
-+For instance, to write the file to a different directory, use:
-+
-+ $ asciidoctor -D output README.adoc
-+
-+The `asciidoctor` {uri-manpage}[man page] provides a complete reference of the command line interface.
-+
-+Refer to the following resources to learn more about how to use the `asciidoctor` command.
-+
-+* {uri-render-doc}[How do I convert a document?]
-+* {uri-themes-doc}[How do I use the Asciidoctor stylesheet factory to produce custom themes?]
-+
-+=== Ruby API
-+
-+To use Asciidoctor in your application, you first need to require the gem:
-+
-+[source]
-+require 'asciidoctor'
-+
-+You can then convert an AsciiDoc source file to an HTML file using:
-+
-+[source]
-+Asciidoctor.convert_file 'README.adoc', to_file: true, safe: :safe
-+
-+WARNING: When using Asciidoctor via the API, the default safe mode is `:secure`.
-+In secure mode, several core features are disabled, including the `include` directive.
-+If you want to enable these features, you'll need to explicitly set the safe mode to `:server` (recommended) or `:safe`.
-+
-+You can also convert an AsciiDoc string to embeddable HTML (for inserting in an HTML page) using:
-+
-+[source]
-+----
-+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
-+Asciidoctor.convert content, safe: :safe
-+----
-+
-+If you want the full HTML document, enable the `header_footer` option as follows:
-+
-+[source]
-+----
-+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
-+html = Asciidoctor.convert content, header_footer: true, safe: :safe
-+----
-+
-+If you need access to the parsed document, you can split the conversion into discrete steps:
-+
-+[source]
-+----
-+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
-+document = Asciidoctor.load content, header_footer: true, safe: :safe
-+puts document.doctitle
-+html = document.convert
-+----
-+
-+Keep in mind that if you don't like the output Asciidoctor produces, _you can change it!_
-+Asciidoctor supports custom converters that can handle converting from the parsed document to the generated output.
-+
-+One easy way to customize the output piecemeal is by using the template converter.
-+The template converter allows you to supply a {uri-tilt}[Tilt]-supported template file to handle converting any node in the document.
-+
-+However you go about it, you _can_ have 100% control over the output.
-+For more information about how to use the API or to customize the output, refer to the {uri-user-manual}[user manual].
-+
-+== Contributing
-+
-+In the spirit of {uri-freesoftware}[free software], _everyone_ is encouraged to help improve this project.
-+If you discover errors or omissions in the source code, documentation, or website content, please don't hesitate to submit an issue or open a pull request with a fix.
-+New contributors are always welcome!
-+
-+Here are some ways *you* can contribute:
-+
-+* by using prerelease (alpha, beta or preview) versions
-+* by reporting bugs
-+* by suggesting new features
-+* by writing or editing documentation
-+* by writing specifications
-+* by writing code -- _No patch is too small._
-+** fix typos
-+** add comments
-+** clean up inconsistent whitespace
-+** write tests!
-+* by refactoring code
-+* by fixing {uri-issues}[issues]
-+* by reviewing patches
-+
-+The {uri-contribute}[Contributing] guide provides information on how to create, style, and submit issues, feature requests, code, and documentation to the Asciidoctor Project.
-+
-+== Getting Help
-+
-+The Asciidoctor project is developed to help you easily write and publish your content.
-+But we can't do it without your feedback!
-+We encourage you to ask questions and discuss any aspects of the project on the discussion list, on Twitter or in the chat room.
-+
-+Discussion list (Nabble):: {uri-discuss}
-+Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] hashtag or https://twitter.com/asciidoctor[@asciidoctor] mention
-+Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
-+////
-+Chat (IRC):: {uri-irc}[#asciidoctor] on FreeNode IRC
-+////
-+
-+ifdef::env-github[]
-+Further information and documentation about Asciidoctor can be found on the project's website.
-+
-+{uri-project}/[Home] | {uri-news}[News] | {uri-docs}[Docs]
-+endif::[]
-+
-+The Asciidoctor organization on GitHub hosts the project's source code, issue tracker, and sub-projects.
-+
-+Source repository (git):: {uri-repo}
-+Issue tracker:: {uri-issues}
-+Asciidoctor organization on GitHub:: {uri-org}
-+
-+== Copyright and Licensing
-+
-+Copyright (C) 2012-2018 Dan Allen, Ryan Waldron and the Asciidoctor Project.
-+Free use of this software is granted under the terms of the MIT License.
-+
-+See the {uri-license}[LICENSE] file for details.
-+
-+== Authors
-+
-+*Asciidoctor* is led by https://github.com/mojavelinux[Dan Allen] and https://github.com/graphitefriction[Sarah White] and has received contributions from {uri-contributors}[many other individuals] in Asciidoctor's awesome community.
-+The project was initiated in 2012 by https://github.com/erebor[Ryan Waldron] and based on {uri-prototype}[a prototype] written by https://github.com/nickh[Nick Hengeveld].
-+
-+*AsciiDoc* was started by Stuart Rackham and has received contributions from many other individuals in the AsciiDoc community.
-+
-+ifndef::env-site[]
-+== Changelog
-+
-+ifeval::[{safe-mode-level} < 20]
-+include::CHANGELOG.adoc[tag=compact,leveloffset=+1]
-+endif::[]
-+
-+Refer to the {uri-changelog}[CHANGELOG] for a complete list of changes in older releases.
-+endif::[]
---- a/asciidoctor.gemspec
-+++ b/asciidoctor.gemspec
-@@ -18,7 +18,7 @@
-   rescue
-     Dir['**/*']
-   end
--  s.files = files.grep(/^(?:(?:data|lib|man)\/.+|Gemfile|Rakefile|LICENSE|(?:CHANGELOG|CONTRIBUTINGREADME(?:-\w+)?)\.adoc|#{s.name}\.gemspec)$/)
-+  s.files = files.grep(/^(?:(?:data|lib|man)\/.+|Gemfile|Rakefile|LICENSE|(?:CHANGELOG|CONTRIBUTING|README(?:-\w+)?)\.adoc|#{s.name}\.gemspec)$/)
-   s.executables = files.grep(/^bin\//).map {|f| File.basename f }
-   s.require_paths = ['lib']
-   s.test_files = files.grep(/^(?:(?:features|test)\/.+)$/)
diff -pruN 1.5.6.2-2/debian/patches/series 1.5.7-1/debian/patches/series
--- 1.5.6.2-2/debian/patches/series	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/series	2018-05-06 08:14:29.000000000 +0000
@@ -1,8 +1,5 @@
 data_path.patch
 lib_directory_in_tests.patch
-skip-asciimath-test.patch
 package-version.patch
 skip-unreadable-file.patch
-re-add_README.patch
-fix-manpage-topic.patch
-disable_badge_in_README.patch
+privacy_breach.patch
diff -pruN 1.5.6.2-2/debian/patches/skip-asciimath-test.patch 1.5.7-1/debian/patches/skip-asciimath-test.patch
--- 1.5.6.2-2/debian/patches/skip-asciimath-test.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/skip-asciimath-test.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,27 +0,0 @@
-Description: Skip test that depends on unpackaged optional library
-Author: Antonio Terceiro <terceiro@debian.org>
-Origin: vendor
-Forwarded: not-needed
-Last-Update: 2015-11-17
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- a/test/blocks_test.rb
-+++ b/test/blocks_test.rb
-@@ -1322,6 +1322,7 @@
-     end
- 
-     test 'should render asciimath block in textobject of equation in DocBook backend' do
-+      skip 'depends on unpackaged dependency'
-       input = <<-'EOS'
- [asciimath]
- ++++
---- a/test/substitutions_test.rb
-+++ b/test/substitutions_test.rb
-@@ -1594,6 +1594,7 @@
-       #end
- 
-       test 'should convert asciimath macro content to MathML when asciimath gem is available' do
-+        skip 'depends on unpackaged dependency'
-         input = 'asciimath:[a < b]'
-         para = block_from_string input, :backend => :docbook
-         assert_equal '<inlineequation><mml:math xmlns:mml="http://www.w3.org/1998/Math/MathML"><mml:mi>a</mml:mi><mml:mo>&#x003C;</mml:mo><mml:mi>b</mml:mi></mml:math></inlineequation>', para.content
diff -pruN 1.5.6.2-2/debian/patches/skip-unreadable-file.patch 1.5.7-1/debian/patches/skip-unreadable-file.patch
--- 1.5.6.2-2/debian/patches/skip-unreadable-file.patch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/patches/skip-unreadable-file.patch	2018-05-06 08:14:29.000000000 +0000
@@ -7,7 +7,7 @@ Forwarded: no
 This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
 --- a/test/reader_test.rb
 +++ b/test/reader_test.rb
-@@ -627,6 +627,7 @@
+@@ -738,6 +738,7 @@
        end
  
        test 'unreadable file referenced by include directive is replaced by warning' do
diff -pruN 1.5.6.2-2/debian/ruby-tests.rake 1.5.7-1/debian/ruby-tests.rake
--- 1.5.6.2-2/debian/ruby-tests.rake	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/ruby-tests.rake	2018-05-06 08:14:29.000000000 +0000
@@ -1,3 +1,4 @@
-ENV['ASCIIDOCTOR_MANPAGE_ABSENT_FROM_TEST'] = 1.to_s
+ENV['ASCIIDOCTOR_MANPAGE_PATH'] ||= '/usr/share/man/man1/asciidoctor.1.gz'
+ENV['ASCIIDOCTOR_LIB_DIR'] ||= '/usr/lib/ruby/vendor_ruby'
 load 'Rakefile'
 task :default => 'test:all'
diff -pruN 1.5.6.2-2/debian/rules 1.5.7-1/debian/rules
--- 1.5.6.2-2/debian/rules	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/rules	2018-05-06 08:14:29.000000000 +0000
@@ -1,7 +1,8 @@
 #!/usr/bin/make -f
 
 export GEM2DEB_TEST_RUNNER = --check-dependencies
-export ASCIIDOCTOR_MANPAGE_ABSENT_FROM_TEST = 1
+export ASCIIDOCTOR_MANPAGE_PATH = $(CURDIR)/man/asciidoctor.1
+export ASCIIDOCTOR_LIB_DIR = $(CURDIR)/debian/ruby-asciidoctor/usr/lib/ruby/vendor_ruby
 
 %:
 	dh $@ --buildsystem=ruby --with ruby
diff -pruN 1.5.6.2-2/debian/watch 1.5.7-1/debian/watch
--- 1.5.6.2-2/debian/watch	2018-04-13 15:33:20.000000000 +0000
+++ 1.5.7-1/debian/watch	2018-05-06 08:14:29.000000000 +0000
@@ -1,2 +1,2 @@
 version=3
-https://pkg-ruby-extras.alioth.debian.org/cgi-bin/gemwatch/asciidoctor .*/asciidoctor-(.*).tar.gz
+https://gemwatch.debian.net/asciidoctor .*/asciidoctor-(.*).tar.gz
diff -pruN 1.5.6.2-2/features/xref.feature 1.5.7-1/features/xref.feature
--- 1.5.6.2-2/features/xref.feature	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/features/xref.feature	2018-05-05 22:54:38.000000000 +0000
@@ -263,6 +263,147 @@ Feature: Cross References
     |to find a complete list of features.
     """
 
+  Scenario: Create a full cross reference to a numbered part
+  Given the AsciiDoc source
+    """
+    :doctype: book
+    :sectnums:
+    :partnums:
+    :xrefstyle: full
+
+    [preface]
+    = Preface
+
+    See <<p1>> for an introduction to the language.
+
+    [#p1]
+    = Language
+
+    == Syntax
+
+    This chapter covers the syntax.
+    """
+  When it is converted to html
+  Then the result should contain the HTML structure
+    """
+    |See
+    a<> href='#p1' Part I, &#8220;Language&#8221;
+    |for an introduction to the language.
+    """
+
+  Scenario: Create a short cross reference to a numbered part
+  Given the AsciiDoc source
+    """
+    :doctype: book
+    :sectnums:
+    :partnums:
+    :xrefstyle: short
+
+    [preface]
+    = Preface
+
+    See <<p1>> for an introduction to the language.
+
+    [#p1]
+    = Language
+
+    == Syntax
+
+    This chapter covers the syntax.
+    """
+  When it is converted to html
+  Then the result should contain the HTML structure
+    """
+    |See
+    a<> href='#p1' Part I
+    |for an introduction to the language.
+    """
+
+  Scenario: Create a basic cross reference to a numbered part
+  Given the AsciiDoc source
+    """
+    :doctype: book
+    :sectnums:
+    :partnums:
+    :xrefstyle: basic
+
+    [preface]
+    = Preface
+
+    See <<p1>> for an introduction to the language.
+
+    [#p1]
+    = Language
+
+    == Syntax
+
+    This chapter covers the syntax.
+    """
+  When it is converted to html
+  Then the result should contain the HTML structure
+    """
+    |See
+    a<> href='#p1' Language
+    |for an introduction to the language.
+    """
+
+  Scenario: Create a basic cross reference to an unnumbered part
+  Given the AsciiDoc source
+    """
+    :doctype: book
+    :sectnums:
+    :xrefstyle: full
+
+    [preface]
+    = Preface
+
+    See <<p1>> for an introduction to the language.
+
+    [#p1]
+    = Language
+
+    == Syntax
+
+    This chapter covers the syntax.
+    """
+  When it is converted to html
+  Then the result should contain the HTML structure
+    """
+    |See
+    a<> href='#p1' Language
+    |for an introduction to the language.
+    """
+
+  @wip
+  Scenario: Create a cross reference to a part using a custom part reference signifier
+  Given the AsciiDoc source
+    """
+    :doctype: book
+    :sectnums:
+    :partnums:
+    :xrefstyle: full
+    :part-refsig: P
+
+    [preface]
+    = Preface
+
+    See <<p1>> for an introduction to the language.
+
+    [#p1]
+    = Language
+
+    == Syntax
+
+    This chapter covers the syntax.
+    """
+  When it is converted to html
+  Then the result should contain the HTML structure
+    """
+    |See
+    a<> href='#p1' P I, &#8220;Language&#8221;
+    |for an introduction to the language.
+    """
+
   Scenario: Create a full cross reference to a numbered appendix
   Given the AsciiDoc source
     """
@@ -577,13 +718,13 @@ Feature: Cross References
   When it is converted to html
   Then the result should match the HTML structure
     """
-    table.tableblock.frame-all.grid-all.spread
+    table.tableblock.frame-all.grid-all.stretch
       colgroup
         col style='width: 100%;'
       tbody
         tr
           td.tableblock.halign-left.valign-top
-            div
+            div.content
               .paragraph: p
                 |See
                 a< href='#_install' Install
@@ -593,7 +734,7 @@ Feature: Cross References
         .paragraph: p Instructions go here.
     """
 
-    Scenario: Create a cross reference using the target section title
+    Scenario: Create a cross reference using the title of the target section
     Given the AsciiDoc source
       """
       == Section One
@@ -617,7 +758,7 @@ Feature: Cross References
           a< href='#_section_one' Section One
       """
 
-    Scenario: Create a natural cross reference using the reftext of the target section
+    Scenario: Create a cross reference using the reftext of the target section
     Given the AsciiDoc source
       """
       [reftext="the first section"]
@@ -654,7 +795,7 @@ Feature: Cross References
           xref< linkend='_section_one'/
       """
 
-    Scenario: Create a cross reference using the formatted target title
+    Scenario: Create a cross reference using the formatted title of the target section
     Given the AsciiDoc source
       """
       == Section *One*
@@ -669,12 +810,230 @@ Feature: Cross References
     Then the result should match the HTML structure
       """
       .sect1
-        h2#_section_strong_one_strong
+        h2#_section_one
           |Section <strong>One</strong>
         .sectionbody: .paragraph: p content
       .sect1
         h2#_section_two Section Two
         .sectionbody: .paragraph: p
           |refer to
-          a< href='#_section_strong_one_strong' Section <strong>One</strong>
+          a< href='#_section_one' Section <strong>One</strong>
+      """
+
+    Scenario: Does not process a natural cross reference in compat mode
+    Given the AsciiDoc source
+      """
+      :compat-mode:
+
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to <<Section One>>
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#Section One' [Section One]
+      """
+
+    Scenario: Parses text of xref macro as attributes if attribute signature found
+    Given the AsciiDoc source
+      """
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to xref:_section_one[role=next]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_section_one' class='next' Section One
+      """
+
+    Scenario: Does not parse text of xref macro as attribute if attribute signature not found
+    Given the AsciiDoc source
+      """
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to xref:_section_one[One, Section One]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_section_one' One, Section One
+      """
+
+    Scenario: Uses whole text of xref macro as link text if attribute signature found and text is enclosed in double quotes
+    Given the AsciiDoc source
+      """
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to xref:_section_one["Section One == Starting Point"]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_section_one'
+            |Section One == Starting Point
+      """
+
+    Scenario: Does not parse text of xref macro as text if enclosed in double quotes but attribute signature not found
+    Given the AsciiDoc source
+      """
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to xref:_section_one["The Premier Section"]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_section_one' "The Premier Section"
+      """
+
+    Scenario: Can escape double quotes in text of xref macro using backslashes when text is parsed as attributes
+    Given the AsciiDoc source
+      """
+      == Section One
+
+      content
+
+      == Section Two
+
+      refer to xref:_section_one["\"The Premier Section\"",role=spotlight]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_section_one
+          |Section One
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_section_two Section Two
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_section_one' class='spotlight' "The Premier Section"
+      """
+
+    Scenario: Override xrefstyle for a given part of the document
+    Given the AsciiDoc source
+      """
+      :xrefstyle: full
+      :doctype: book
+      :sectnums:
+
+      == Foo
+
+      refer to <<#_bar>>
+
+      == Bar
+      :xrefstyle: short
+
+      refer to xref:#_foo[xrefstyle=short]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_foo 1. Foo
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_bar' Chapter 2, <em>Bar</em>
+      .sect1
+        h2#_bar 2. Bar
+        .sectionbody: .paragraph: p
+          |refer to
+          a< href='#_foo' Chapter 1
+      """
+
+    Scenario: Override xrefstyle for a specific reference by assigning the xrefstyle attribute on the xref macro
+    Given the AsciiDoc source
+      """
+      :xrefstyle: full
+      :doctype: book
+      :sectnums:
+
+      == Foo
+
+      content
+
+      == Bar
+
+      refer to <<#_foo>>
+
+      refer to xref:#_foo[xrefstyle=short]
+      """
+    When it is converted to html
+    Then the result should match the HTML structure
+      """
+      .sect1
+        h2#_foo 1. Foo
+        .sectionbody: .paragraph: p content
+      .sect1
+        h2#_bar 2. Bar
+        .sectionbody
+          .paragraph: p
+            |refer to
+            a< href='#_foo' Chapter 1, <em>Foo</em>
+          .paragraph: p
+            |refer to
+            a< href='#_foo' Chapter 1
       """
diff -pruN 1.5.6.2-2/lib/asciidoctor/abstract_block.rb 1.5.7-1/lib/asciidoctor/abstract_block.rb
--- 1.5.6.2-2/lib/asciidoctor/abstract_block.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/abstract_block.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,24 +1,18 @@
 # encoding: UTF-8
 module Asciidoctor
 class AbstractBlock < AbstractNode
-  # Public: The types of content that this block can accomodate
-  attr_accessor :content_model
-
-  # Public: Substitutions to be applied to content in this block
-  attr_reader :subs
-
   # Public: Get the Array of Asciidoctor::AbstractBlock sub-blocks for this block
   attr_reader :blocks
 
-  # Public: Set the Integer level of this Section or the Section level in which this Block resides
-  attr_accessor :level
-
-  # Public: Get/Set the String style (block type qualifier) for this block.
-  attr_accessor :style
-
   # Public: Set the caption for this block
   attr_writer :caption
 
+  # Public: The types of content that this block can accomodate
+  attr_accessor :content_model
+
+  # Public: Set the Integer level of this Section or the Section level in which this Block resides
+  attr_accessor :level
+
   # Public: Get/Set the number of this block (if section, relative to parent, otherwise absolute)
   # Only assigned to section if automatic section numbering is enabled
   # Only assigned to formal block (block with title) if corresponding caption attribute is present
@@ -27,6 +21,12 @@ class AbstractBlock < AbstractNode
   # Public: Gets/Sets the location in the AsciiDoc source where this block begins
   attr_accessor :source_location
 
+  # Public: Get/Set the String style (block type qualifier) for this block.
+  attr_accessor :style
+
+  # Public: Substitutions to be applied to content in this block
+  attr_reader :subs
+
   def initialize parent, context, opts = {}
     super
     @content_model = :compound
@@ -52,13 +52,14 @@ class AbstractBlock < AbstractNode
     false
   end
 
-  # Public: Update the context of this block.
-  #
-  # This method changes the context of this block. It also
-  # updates the node name accordingly.
-  def context=(context)
-    @context = context
-    @node_name = context.to_s
+  # Public: Get the source file where this block started
+  def file
+    @source_location && @source_location.file
+  end
+
+  # Public: Get the source line number where this block started
+  def lineno
+    @source_location && @source_location.lineno
   end
 
   # Public: Get the converted String content for this Block.  If the block
@@ -79,147 +80,15 @@ class AbstractBlock < AbstractNode
     @blocks.map {|b| b.convert } * LF
   end
 
-  # Public: Get the source file where this block started
-  def file
-    @source_location ? @source_location.file : nil
-  end
-
-  # Public: Get the source line number where this block started
-  def lineno
-    @source_location ? @source_location.lineno : nil
-  end
-
-  # Public: A convenience method that checks whether the specified
-  # substitution is enabled for this block.
-  #
-  # name - The Symbol substitution name
-  #
-  # Returns A Boolean indicating whether the specified substitution is
-  # enabled for this block
-  def sub? name
-    @subs.include? name
-  end
-
-  # Public: A convenience method that checks whether the title of this block is defined.
-  #
-  # Returns a [Boolean] indicating whether this block has a title.
-  def title?
-    @title ? true : false
-  end
-
-  # Public: Get the String title of this Block with title substitions applied
-  #
-  # The following substitutions are applied to block and section titles:
-  #
-  # :specialcharacters, :quotes, :replacements, :macros, :attributes and :post_replacements
-  #
-  # Examples
-  #
-  #   block.title = "Foo 3^ # {two-colons} Bar(1)"
-  #   block.title
-  #   => "Foo 3^ # :: Bar(1)"
-  #
-  # Returns the converted String title for this Block, or nil if the source title is falsy
-  def title
-    # prevent substitutions from being applied to title multiple times
-    @title_converted ? @converted_title : (@converted_title = (@title_converted = true) && @title && (apply_title_subs @title))
-  end
-
-  # Public: Set the String block title.
-  #
-  # Returns the new String title assigned to this Block
-  def title= val
-    @title, @title_converted = val, nil
-  end
-
-  # Gets the caption for this block.
-  #
-  # This method routes the deprecated use of the caption method on an
-  # admonition block to the textlabel attribute.
-  #
-  # Returns the [String] caption for this block (or the value of the textlabel
-  # attribute if this is an admonition block).
-  def caption
-    @context == :admonition ? @attributes['textlabel'] : @caption
-  end
-
-  # Public: Convenience method that returns the interpreted title of the Block
-  # with the caption prepended.
-  #
-  # Concatenates the value of this Block's caption instance variable and the
-  # return value of this Block's title method. No space is added between the
-  # two values. If the Block does not have a caption, the interpreted title is
-  # returned.
-  #
-  # Returns the converted String title prefixed with the caption, or just the
-  # converted String title if no caption is set
-  def captioned_title
-    %(#{@caption}#{title})
-  end
-
-  # Public: Returns the converted alt text for this block image.
-  #
-  # Returns the [String] value of the alt attribute with XML special character
-  # and replacement substitutions applied.
-  def alt
-    if (text = @attributes['alt'])
-      if text == @attributes['default-alt']
-        sub_specialchars text
-      else
-        text = sub_specialchars text
-        (ReplaceableTextRx.match? text) ? (sub_replacements text) : text
-      end
-    end
-  end
-
-  # Public: Generate cross reference text (xreftext) that can be used to refer
-  # to this block.
-  #
-  # Use the explicit reftext for this block, if specified, retrieved from the
-  # {#reftext} method. Otherwise, if this is a section or captioned block (a
-  # block with both a title and caption), generate the xreftext according to
-  # the value of the xrefstyle argument (e.g., full, short). This logic may
-  # leverage the {Substitutors#sub_quotes} method to apply formatting to the
-  # text. If this is not a captioned block, return the title, if present, or
-  # nil otherwise.
+  # Public: Update the context of this block.
   #
-  # xrefstyle - An optional String that specifies the style to use to format
-  #             the xreftext ('full', 'short', or 'basic') (default: nil).
+  # This method changes the context of this block. It also updates the node name accordingly.
   #
-  # Returns the generated [String] xreftext used to refer to this block or
-  # nothing if there isn't sufficient information to generate one.
-  def xreftext xrefstyle = nil
-    if (val = reftext) && !val.empty?
-      val
-    # NOTE xrefstyle only applies to blocks with a title and a caption or number
-    elsif xrefstyle && @title && @caption
-      case xrefstyle
-      when 'full'
-        quoted_title = sprintf sub_quotes(@document.compat_mode ? %q(``%s'') : '"`%s`"'), title
-        if @number && (prefix = @document.attributes[@context == :image ? 'figure-caption' : %(#{@context}-caption)])
-          %(#{prefix} #{@number}, #{quoted_title})
-        else
-          %(#{@caption.chomp '. '}, #{quoted_title})
-        end
-      when 'short'
-        if @number && (prefix = @document.attributes[@context == :image ? 'figure-caption' : %(#{@context}-caption)])
-          %(#{prefix} #{@number})
-        else
-          @caption.chomp '. '
-        end
-      else # 'basic'
-        title
-      end
-    else
-      title
-    end
-  end
-
-  # Public: Determine whether this Block contains block content
+  # context - the context Symbol context to assign to this block
   #
-  # Returns A Boolean indicating whether this Block has block content
-  def blocks?
-    !@blocks.empty?
+  # Returns the new context Symbol assigned to this block
+  def context= context
+    @node_name = (@context = context).to_s
   end
 
   # Public: Append a content block to this block's list of blocks.
@@ -239,8 +108,7 @@ class AbstractBlock < AbstractNode
   #
   # Returns The parent Block
   def << block
-    # parent assignment pending refactor
-    #block.parent = self
+    block.parent = self unless block.parent == self
     @blocks << block
     self
   end
@@ -248,30 +116,11 @@ class AbstractBlock < AbstractNode
   # NOTE append alias required for adapting to a Java API
   alias append <<
 
-  # Public: Get the Array of child Section objects
-  #
-  # Only applies to Document and Section instances
-  #
-  # Examples
-  #
-  #   doc << (sect1 = Section.new doc, 1, false)
-  #   sect1.title = 'Section 1'
-  #   para1 = Block.new sect1, :paragraph, :source => 'Paragraph 1'
-  #   para2 = Block.new sect1, :paragraph, :source => 'Paragraph 2'
-  #   sect1 << para1 << para2
-  #   sect1 << (sect1_1 = Section.new sect1, 2, false)
-  #   sect1_1.title = 'Section 1.1'
-  #   sect1_1 << (Block.new sect1_1, :paragraph, :source => 'Paragraph 3')
-  #   sect1.blocks?
-  #   # => true
-  #   sect1.blocks.size
-  #   # => 3
-  #   sect1.sections.size
-  #   # => 1
+  # Public: Determine whether this Block contains block content
   #
-  # Returns an [Array] of Section objects
-  def sections
-    @blocks.select {|block| block.context == :section }
+  # Returns A Boolean indicating whether this Block has block content
+  def blocks?
+    !@blocks.empty?
   end
 
   # Public: Check whether this block has any child Section objects.
@@ -283,37 +132,6 @@ class AbstractBlock < AbstractNode
     @next_section_index > 0
   end
 
-# stage the Enumerable mixin until we're sure we've got it right
-=begin
-  include ::Enumerable
-
-  # Public: Yield the block on this block node and all its descendant
-  # block node children to satisfy the Enumerable contract.
-  #
-  # Returns nothing
-  def each &block
-    # yucky, dlist is a special case
-    if @context == :dlist
-      @blocks.flatten.each &block
-    else
-      #yield self.header if @context == :document && header?
-      @blocks.each &block
-    end
-  end
-
-  #--
-  # TODO is there a way to make this lazy?
-  def each_recursive &block
-    block = lambda {|node| node } unless block_given?
-    results = []
-    self.each do |node|
-      results << block.call(node)
-      results.concat(node.each_recursive(&block)) if ::Enumerable === node
-    end
-    block_given? ? results : results.to_enum
-  end
-=end
-
   # Public: Query for all descendant block-level nodes in the document tree
   # that match the specified selector (context, style, id, and/or role). If a
   # Ruby block is given, it's used as an additional filter. If no selector or
@@ -377,6 +195,7 @@ class AbstractBlock < AbstractNode
     end
     result
   end
+
   alias query find_by
 
   # Move to the next adjacent block in document order. If the current block is the last
@@ -385,6 +204,126 @@ class AbstractBlock < AbstractNode
     (sib = (p = parent).blocks[(p.blocks.find_index self) + 1]) ? sib : p.next_adjacent_block unless @context == :document
   end
 
+  # Public: Get the Array of child Section objects
+  #
+  # Only applies to Document and Section instances
+  #
+  # Examples
+  #
+  #   doc << (sect1 = Section.new doc, 1)
+  #   sect1.title = 'Section 1'
+  #   para1 = Block.new sect1, :paragraph, :source => 'Paragraph 1'
+  #   para2 = Block.new sect1, :paragraph, :source => 'Paragraph 2'
+  #   sect1 << para1 << para2
+  #   sect1 << (sect1_1 = Section.new sect1, 2)
+  #   sect1_1.title = 'Section 1.1'
+  #   sect1_1 << (Block.new sect1_1, :paragraph, :source => 'Paragraph 3')
+  #   sect1.blocks?
+  #   # => true
+  #   sect1.blocks.size
+  #   # => 3
+  #   sect1.sections.size
+  #   # => 1
+  #
+  # Returns an [Array] of Section objects
+  def sections
+    @blocks.select {|block| block.context == :section }
+  end
+
+  # Public: Returns the converted alt text for this block image.
+  #
+  # Returns the [String] value of the alt attribute with XML special character
+  # and replacement substitutions applied.
+  def alt
+    if (text = @attributes['alt'])
+      if text == @attributes['default-alt']
+        sub_specialchars text
+      else
+        text = sub_specialchars text
+        (ReplaceableTextRx.match? text) ? (sub_replacements text) : text
+      end
+    end
+  end
+
+  # Gets the caption for this block.
+  #
+  # This method routes the deprecated use of the caption method on an
+  # admonition block to the textlabel attribute.
+  #
+  # Returns the [String] caption for this block (or the value of the textlabel
+  # attribute if this is an admonition block).
+  def caption
+    @context == :admonition ? @attributes['textlabel'] : @caption
+  end
+
+  # Public: Convenience method that returns the interpreted title of the Block
+  # with the caption prepended.
+  #
+  # Concatenates the value of this Block's caption instance variable and the
+  # return value of this Block's title method. No space is added between the
+  # two values. If the Block does not have a caption, the interpreted title is
+  # returned.
+  #
+  # Returns the converted String title prefixed with the caption, or just the
+  # converted String title if no caption is set
+  def captioned_title
+    %(#{@caption}#{title})
+  end
+
+  # Public: Retrieve the list marker keyword for the specified list type.
+  #
+  # For use in the HTML type attribute.
+  #
+  # list_type - the type of list; default to the @style if not specified
+  #
+  # Returns the single-character [String] keyword that represents the marker for the specified list type
+  def list_marker_keyword list_type = nil
+    ORDERED_LIST_KEYWORDS[list_type || @style]
+  end
+
+  # Public: Get the String title of this Block with title substitions applied
+  #
+  # The following substitutions are applied to block and section titles:
+  #
+  # :specialcharacters, :quotes, :replacements, :macros, :attributes and :post_replacements
+  #
+  # Examples
+  #
+  #   block.title = "Foo 3^ # {two-colons} Bar(1)"
+  #   block.title
+  #   => "Foo 3^ # :: Bar(1)"
+  #
+  # Returns the converted String title for this Block, or nil if the source title is falsy
+  def title
+    # prevent substitutions from being applied to title multiple times
+    @title_converted ? @converted_title : (@converted_title = (@title_converted = true) && @title && (apply_title_subs @title))
+  end
+
+  # Public: A convenience method that checks whether the title of this block is defined.
+  #
+  # Returns a [Boolean] indicating whether this block has a title.
+  def title?
+    @title ? true : false
+  end
+
+  # Public: Set the String block title.
+  #
+  # Returns the new String title assigned to this Block
+  def title= val
+    @title, @title_converted = val, nil
+  end
+
+  # Public: A convenience method that checks whether the specified
+  # substitution is enabled for this block.
+  #
+  # name - The Symbol substitution name
+  #
+  # Returns A Boolean indicating whether the specified substitution is
+  # enabled for this block
+  def sub? name
+    @subs.include? name
+  end
+
   # Public: Remove a substitution from this block
   #
   # sub  - The Symbol substitution name
@@ -395,6 +334,49 @@ class AbstractBlock < AbstractNode
     nil
   end
 
+  # Public: Generate cross reference text (xreftext) that can be used to refer
+  # to this block.
+  #
+  # Use the explicit reftext for this block, if specified, retrieved from the
+  # {#reftext} method. Otherwise, if this is a section or captioned block (a
+  # block with both a title and caption), generate the xreftext according to
+  # the value of the xrefstyle argument (e.g., full, short). This logic may
+  # leverage the {Substitutors#sub_quotes} method to apply formatting to the
+  # text. If this is not a captioned block, return the title, if present, or
+  # nil otherwise.
+  #
+  # xrefstyle - An optional String that specifies the style to use to format
+  #             the xreftext ('full', 'short', or 'basic') (default: nil).
+  #
+  # Returns the generated [String] xreftext used to refer to this block or
+  # nothing if there isn't sufficient information to generate one.
+  def xreftext xrefstyle = nil
+    if (val = reftext) && !val.empty?
+      val
+    # NOTE xrefstyle only applies to blocks with a title and a caption or number
+    elsif xrefstyle && @title && @caption
+      case xrefstyle
+      when 'full'
+        quoted_title = sprintf sub_quotes(@document.compat_mode ? %q(``%s'') : '"`%s`"'), title
+        if @number && (prefix = @document.attributes[@context == :image ? 'figure-caption' : %(#{@context}-caption)])
+          %(#{prefix} #{@number}, #{quoted_title})
+        else
+          %(#{@caption.chomp '. '}, #{quoted_title})
+        end
+      when 'short'
+        if @number && (prefix = @document.attributes[@context == :image ? 'figure-caption' : %(#{@context}-caption)])
+          %(#{prefix} #{@number})
+        else
+          @caption.chomp '. '
+        end
+      else # 'basic'
+        title
+      end
+    else
+      title
+    end
+  end
+
   # Public: Generate and assign caption to block if not already assigned.
   #
   # If the block has a title and a caption prefix is available for this block,
@@ -421,41 +403,36 @@ class AbstractBlock < AbstractNode
     end
   end
 
-  # Internal: Assign the next index (0-based) and number (1-based) to the section
+  # Internal: Assign the next index (0-based) and numeral (1-based) to the section.
+  # If the section is an appendix, the numeral is a letter (starting with A). This
+  # method also assigns the appendix caption.
+  #
+  # section - The section to which to assign the next index and numeral.
   #
   # Assign to the specified section the next index and, if the section is
-  # numbered, number within this block (its parent).
+  # numbered, the numeral within this block (its parent).
   #
   # Returns nothing
-  def enumerate_section section
+  def assign_numeral section
     @next_section_index = (section.index = @next_section_index) + 1
-    if (sectname = section.sectname) == 'appendix'
-      section.number = @document.counter 'appendix-number', 'A'
-      if (caption = @document.attributes['appendix-caption'])
-        section.caption = %(#{caption} #{section.number}: )
+    if (like = section.numbered)
+      if (sectname = section.sectname) == 'appendix'
+        section.number = @document.counter 'appendix-number', 'A'
+        if (caption = @document.attributes['appendix-caption'])
+          section.caption = %(#{caption} #{section.number}: )
+        else
+          section.caption = %(#{section.number}. )
+        end
+      # NOTE currently chapters in a book doctype are sequential even for multi-part books (see #979)
+      elsif sectname == 'chapter' || like == :chapter
+        section.number = @document.counter 'chapter-number', 1
       else
-        section.caption = %(#{section.number}. )
+        @next_section_number = (section.number = @next_section_number) + 1
       end
-    # NOTE currently chapters in a book doctype are sequential even for multi-part books (see #979)
-    elsif sectname == 'chapter'
-      section.number = @document.counter 'chapter-number', 1
-    else
-      @next_section_number = (section.number = @next_section_number) + 1
-    end if section.numbered
+    end
     nil
   end
 
-  # Public: Retrieve the list marker keyword for the specified list type.
-  #
-  # For use in the HTML type attribute.
-  #
-  # list_type - the type of list; default to the @style if not specified
-  #
-  # Returns the single-character [String] keyword that represents the marker for the specified list type
-  def list_marker_keyword list_type = nil
-    ORDERED_LIST_KEYWORDS[list_type || @style]
-  end
-
   # Internal: Reassign the section indexes
   #
   # Walk the descendents of the current Document or Section
@@ -471,10 +448,41 @@ class AbstractBlock < AbstractNode
     @next_section_number = 1
     @blocks.each do |block|
       if block.context == :section
-        enumerate_section block
+        assign_numeral block
         block.reindex_sections
       end
     end
   end
+
+# stage the Enumerable mixin until we're sure we've got it right
+=begin
+  include ::Enumerable
+
+  # Public: Yield the block on this block node and all its descendant
+  # block node children to satisfy the Enumerable contract.
+  #
+  # Returns nothing
+  def each &block
+    # yucky, dlist is a special case
+    if @context == :dlist
+      @blocks.flatten.each &block
+    else
+      #yield self.header if @context == :document && header?
+      @blocks.each &block
+    end
+  end
+
+  #--
+  # TODO is there a way to make this lazy?
+  def each_recursive &block
+    block = lambda {|node| node } unless block_given?
+    results = []
+    self.each do |node|
+      results << block.call(node)
+      results.concat(node.each_recursive(&block)) if ::Enumerable === node
+    end
+    block_given? ? results : results.to_enum
+  end
+=end
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/abstract_node.rb 1.5.7-1/lib/asciidoctor/abstract_node.rb
--- 1.5.6.2-2/lib/asciidoctor/abstract_node.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/abstract_node.rb	2018-05-05 22:54:38.000000000 +0000
@@ -4,26 +4,26 @@ module Asciidoctor
 # node of AsciiDoc content. The state and methods on this class are comment to
 # all content segments in an AsciiDoc document.
 class AbstractNode
-
+  include Logging
   include Substitutors
 
-  # Public: Get the element which is the parent of this node
-  attr_reader :parent
-
-  # Public: Get the Asciidoctor::Document to which this node belongs
-  attr_reader :document
+  # Public: Get the Hash of attributes for this node
+  attr_reader :attributes
 
   # Public: Get the Symbol context for this node
   attr_reader :context
 
-  # Public: Get the String name of this node
-  attr_reader :node_name
+  # Public: Get the Asciidoctor::Document to which this node belongs
+  attr_reader :document
 
   # Public: Get/Set the id of this node
   attr_accessor :id
 
-  # Public: Get the Hash of attributes for this node
-  attr_reader :attributes
+  # Public: Get the String name of this node
+  attr_reader :node_name
+
+  # Public: Get the element which is the parent of this node
+  attr_reader :parent
 
   def initialize parent, context, opts = {}
     if context == :document
@@ -42,22 +42,6 @@ class AbstractNode
     @passthroughs = {}
   end
 
-  # Public: Associate this Block with a new parent Block
-  #
-  # parent - The Block to set as the parent of this Block
-  #
-  # Returns nothing
-  def parent=(parent)
-    @parent, @document = parent, parent.document
-    nil
-  end
-
-  # Public: Get the Asciidoctor::Converter instance being used to convert the
-  # current Asciidoctor::Document.
-  def converter
-    @document.converter
-  end
-
   # Public: Returns whether this {AbstractNode} is an instance of {Block}
   #
   # Returns [Boolean]
@@ -76,6 +60,21 @@ class AbstractNode
     # :nocov:
   end
 
+  # Public: Get the Asciidoctor::Converter instance being used to convert the
+  # current Asciidoctor::Document.
+  def converter
+    @document.converter
+  end
+
+  # Public: Associate this Block with a new parent Block
+  #
+  # parent - The Block to set as the parent of this Block
+  #
+  # Returns the new parent Block associated with this Block
+  def parent= parent
+    @parent, @document = parent, parent.document
+  end
+
   # Public: Get the value of the specified attribute
   #
   # Get the value for the specified attribute. First look in the attributes on
@@ -212,7 +211,7 @@ class AbstractNode
   # in the list of roles on this node
   def has_role?(name)
     # NOTE center + include? is faster than split + include?
-    (val = @attributes['role'] || @document.attributes['role']).nil_or_empty? ? false : %( #{val} ).include?(%( #{name} ))
+    (val = @attributes['role'] || @document.attributes['role']) ? %( #{val} ).include?(%( #{name} )) : false
   end
 
   # Public: A convenience method that adds the given role directly to this node
@@ -279,15 +278,14 @@ class AbstractNode
   # Returns A String reference or data URI for an icon image
   def icon_uri name
     if attr? 'icon'
-      # QUESTION should we add extension if resolved value is an absolute URI?
-      if ::File.extname(uri = (image_uri attr('icon'), 'iconsdir')).empty?
-        %(#{uri}.#{@document.attr 'icontype', 'png'})
-      else
-        uri
+      if ::File.extname(icon = (attr 'icon')).empty?
+        # QUESTION should we be adding the extension if the icon is an absolute URI?
+        icon = %(#{icon}.#{@document.attr 'icontype', 'png'})
       end
     else
-      image_uri %(#{name}.#{@document.attr 'icontype', 'png'}), 'iconsdir'
+      icon = %(#{name}.#{@document.attr 'icontype', 'png'})
     end
+    image_uri icon, 'iconsdir'
   end
 
   # Public: Construct a URI reference or data URI to the target image.
@@ -367,15 +365,15 @@ class AbstractNode
       image_path = normalize_system_path(target_image)
     end
 
-    unless ::File.readable? image_path
-      warn %(asciidoctor: WARNING: image to embed not found or not readable: #{image_path})
-      return %(data:#{mimetype};base64,)
+    if ::File.readable? image_path
+      # NOTE base64 is autoloaded by reference to ::Base64
+      %(data:#{mimetype};base64,#{::Base64.strict_encode64 ::IO.binread image_path})
+    else
+      logger.warn %(image to embed not found or not readable: #{image_path})
+      %(data:#{mimetype};base64,)
       # uncomment to return 1 pixel white dot instead
-      #return 'data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=='
+      #'data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw=='
     end
-
-    # NOTE base64 is autoloaded by reference to ::Base64
-    %(data:#{mimetype};base64,#{::Base64.encode64(::IO.binread image_path).delete LF})
   end
 
   # Public: Read the image data from the specified URI and generate a data URI
@@ -402,14 +400,14 @@ class AbstractNode
 
     begin
       mimetype = nil
-      bindata = open(image_uri, 'rb') {|fd|
+      bindata = open image_uri, 'rb' do |fd|
         mimetype = fd.content_type
         fd.read
-      }
+      end
       # NOTE base64 is autoloaded by reference to ::Base64
-      %(data:#{mimetype};base64,#{::Base64.encode64(bindata).delete LF})
+      %(data:#{mimetype};base64,#{::Base64.strict_encode64 bindata})
     rescue
-      warn %(asciidoctor: WARNING: could not retrieve image data from URI: #{image_uri})
+      logger.warn %(could not retrieve image data from URI: #{image_uri})
       image_uri
       # uncomment to return empty data (however, mimetype needs to be resolved)
       #%(data:#{mimetype}:base64,)
@@ -442,8 +440,8 @@ class AbstractNode
   # start  - the String start (i.e., parent) path
   # jail   - the String jail path to confine the resolved path
   # opts   - an optional Hash of options to control processing (default: {}):
-  #          * :recover is used to control whether the processor should auto-recover
-  #              when an illegal path is encountered
+  #          * :recover is used to control whether the processor should
+  #            automatically recover when an illegal path is encountered
   #          * :target_name is used in messages to refer to the path being resolved
   #
   # raises a SecurityError if a jail is specified and the resolved path is
@@ -453,10 +451,9 @@ class AbstractNode
   # parent references resolved and self references removed. If a jail is provided,
   # this path will be guaranteed to be contained within the jail.
   def normalize_system_path target, start = nil, jail = nil, opts = {}
-    path_resolver = (@path_resolver ||= PathResolver.new)
     if (doc = @document).safe < SafeMode::SAFE
       if start
-        start = ::File.join doc.base_dir, start unless path_resolver.root? start
+        start = ::File.join doc.base_dir, start unless doc.path_resolver.root? start
       else
         start = doc.base_dir
       end
@@ -464,7 +461,7 @@ class AbstractNode
       start = doc.base_dir unless start
       jail = doc.base_dir unless jail
     end
-    path_resolver.system_path target, start, jail, opts
+    doc.path_resolver.system_path target, start, jail, opts
   end
 
   # Public: Normalize the web path using the PathResolver.
@@ -480,7 +477,7 @@ class AbstractNode
     if preserve_uri_target && (Helpers.uriish? target)
       uri_encode_spaces target
     else
-      (@path_resolver ||= PathResolver.new).web_path target, start
+      @document.path_resolver.web_path target, start
     end
   end
 
@@ -508,7 +505,8 @@ class AbstractNode
         ::IO.read path
       end
     elsif opts[:warn_on_failure]
-      warn %(asciidoctor: WARNING: #{(attr 'docfile') || '<stdin>'}: #{opts[:label] || 'file'} does not exist or cannot be read: #{path})
+      logger.warn %(#{(attr 'docfile') || '<stdin>'}: #{opts[:label] || 'file'} does not exist or cannot be read: #{path})
+      nil
     end
   end
 
@@ -531,25 +529,25 @@ class AbstractNode
   def read_contents target, opts = {}
     doc = @document
     if (Helpers.uriish? target) || ((start = opts[:start]) && (Helpers.uriish? start) &&
-        (target = (@path_resolver ||= PathResolver.new).web_path target, start))
+        (target = doc.path_resolver.web_path target, start))
       if doc.attr? 'allow-uri-read'
         Helpers.require_library 'open-uri/cached', 'open-uri-cached' if doc.attr? 'cache-uri'
         begin
           data = ::OpenURI.open_uri(target) {|fd| fd.read }
           data = (Helpers.normalize_lines_from_string data) * LF if opts[:normalize]
+          return data
         rescue
-          warn %(asciidoctor: WARNING: could not retrieve contents of #{opts[:label] || 'asset'} at URI: #{target}) if opts.fetch :warn_on_failure, true
-          data = nil
+          logger.warn %(could not retrieve contents of #{opts[:label] || 'asset'} at URI: #{target}) if opts.fetch :warn_on_failure, true
+          return
         end
       else
-        warn %(asciidoctor: WARNING: cannot retrieve contents of #{opts[:label] || 'asset'} at URI: #{target} (allow-uri-read attribute not enabled)) if opts.fetch :warn_on_failure, true
-        data = nil
+        logger.warn %(cannot retrieve contents of #{opts[:label] || 'asset'} at URI: #{target} (allow-uri-read attribute not enabled)) if opts.fetch :warn_on_failure, true
+        return
       end
     else
       target = normalize_system_path target, opts[:start], nil, :target_name => (opts[:label] || 'asset')
-      data = read_asset target, :normalize => opts[:normalize], :warn_on_failure => (opts.fetch :warn_on_failure, true), :label => opts[:label]
+      return read_asset target, :normalize => opts[:normalize], :warn_on_failure => (opts.fetch :warn_on_failure, true), :label => opts[:label]
     end
-    data
   end
 
   # Internal: URI encode spaces in a String
diff -pruN 1.5.6.2-2/lib/asciidoctor/block.rb 1.5.7-1/lib/asciidoctor/block.rb
--- 1.5.6.2-2/lib/asciidoctor/block.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/block.rb	2018-05-05 22:54:38.000000000 +0000
@@ -124,15 +124,15 @@ class Block < AbstractBlock
         result * LF
       end
     else
-      warn %(Unknown content model '#{@content_model}' for block: #{to_s}) unless @content_model == :empty
+      logger.warn %(Unknown content model '#{@content_model}' for block: #{to_s}) unless @content_model == :empty
       nil
     end
   end
 
   # Public: Returns the preprocessed source of this block
   #
-  # Returns the a String containing the lines joined together or nil if there
-  # are no lines
+  # Returns the a String containing the lines joined together or empty string
+  # if there are no lines
   def source
     @lines * LF
   end
diff -pruN 1.5.6.2-2/lib/asciidoctor/callouts.rb 1.5.7-1/lib/asciidoctor/callouts.rb
--- 1.5.6.2-2/lib/asciidoctor/callouts.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/callouts.rb	2018-05-05 22:54:38.000000000 +0000
@@ -59,7 +59,7 @@ class Callouts
   #
   # Returns A space-separated String of callout ids associated with the specified list item
   def callout_ids li_ordinal
-    current_list.map {|element| element[:ordinal] == li_ordinal ? %(#{element[:id]} ) : nil }.join.chop
+    current_list.map {|it| it[:ordinal] == li_ordinal ? %(#{it[:id]} ) : '' }.join.chop
   end
 
   # Public: The current list for which callouts are being collected
diff -pruN 1.5.6.2-2/lib/asciidoctor/cli/invoker.rb 1.5.7-1/lib/asciidoctor/cli/invoker.rb
--- 1.5.6.2-2/lib/asciidoctor/cli/invoker.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/cli/invoker.rb	2018-05-05 22:54:38.000000000 +0000
@@ -3,6 +3,7 @@ module Asciidoctor
   module Cli
     # Public Invocation class for starting Asciidoctor via CLI
     class Invoker
+
       attr_reader :options
       attr_reader :documents
       attr_reader :code
@@ -29,13 +30,15 @@ module Asciidoctor
       end
 
       def invoke!
-        old_verbose = -1
         return unless @options
 
         old_verbose = $VERBOSE
+        old_logger = old_logger_level = nil
         opts = {}
         infiles = []
         outfile = nil
+        abs_srcdir_posix = nil
+        non_posix_env = ::File::ALT_SEPARATOR == RS
         err = @err || $stderr
         show_timings = false
 
@@ -45,6 +48,11 @@ module Asciidoctor
             infiles = val
           when :output_file
             outfile = val
+          when :source_dir
+            if val
+              abs_srcdir_posix = ::File.expand_path val
+              abs_srcdir_posix = abs_srcdir_posix.tr RS, FS if non_posix_env && (abs_srcdir_posix.include? RS)
+            end
           when :destination_dir
             opts[:to_dir] = val if val
           when :attributes
@@ -58,34 +66,36 @@ module Asciidoctor
             case val
             when 0
               $VERBOSE = nil
+              old_logger = LoggerManager.logger
+              LoggerManager.logger = NullLogger.new
             when 1
               $VERBOSE = false
             when 2
               $VERBOSE = true
+              old_logger_level, LoggerManager.logger.level = LoggerManager.logger.level, ::Logger::Severity::DEBUG
             end
           else
             opts[key] = val unless val.nil?
           end
         end
 
-        stdin = if infiles.size == 1
+        if infiles.size == 1
           if (infile0 = infiles[0]) == '-'
             outfile ||= infile0
-            true
+            stdin = true
           elsif ::File.pipe? infile0
             outfile ||= '-'
-            nil
           end
         end
 
-        tofile = if outfile == '-'
-          @out || $stdout
+        if outfile == '-'
+          tofile = @out || $stdout
         elsif outfile
           opts[:mkdirs] = true
-          outfile
+          tofile = outfile
         else
           opts[:mkdirs] = true
-          nil # automatically calculate outfile based on infile
+          # automatically calculate outfile based on infile
         end
 
         if stdin
@@ -101,6 +111,17 @@ module Asciidoctor
         else
           infiles.each do |infile|
             input_opts = opts.merge :to_file => tofile
+            if abs_srcdir_posix && (input_opts.key? :to_dir)
+              abs_indir = ::File.dirname ::File.expand_path infile
+              if non_posix_env
+                abs_indir_posix = (abs_indir.include? RS) ? (abs_indir.tr RS, FS) : abs_indir
+              else
+                abs_indir_posix = abs_indir
+              end
+              if abs_indir_posix.start_with? %(#{abs_srcdir_posix}/)
+                input_opts[:to_dir] += abs_indir.slice abs_srcdir_posix.length, abs_indir.length
+              end
+            end
             if show_timings
               @documents << (::Asciidoctor.convert_file infile, (input_opts.merge :timings => (timings = Timings.new)))
               timings.print_report err, infile
@@ -109,6 +130,7 @@ module Asciidoctor
             end
           end
         end
+        @code = 1 if ((logger = LoggerManager.logger).respond_to? :max_severity) && logger.max_severity && logger.max_severity >= opts[:failure_level]
       rescue ::Exception => e
         if ::SignalException === e
           @code = e.signo
@@ -129,7 +151,12 @@ module Asciidoctor
         end
         nil
       ensure
-        $VERBOSE = old_verbose unless old_verbose == -1
+        $VERBOSE = old_verbose
+        if old_logger
+          LoggerManager.logger = old_logger
+        elsif old_logger_level
+          LoggerManager.logger.level = old_logger_level
+        end
       end
 
       def document
diff -pruN 1.5.6.2-2/lib/asciidoctor/cli/options.rb 1.5.7-1/lib/asciidoctor/cli/options.rb
--- 1.5.6.2-2/lib/asciidoctor/cli/options.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/cli/options.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,6 +1,8 @@
 # encoding: UTF-8
 module Asciidoctor
   module Cli
+    FS = '/'
+    RS = '\\'
 
     # Public: List of options that can be specified on the command line
     class Options < ::Hash
@@ -24,7 +26,9 @@ module Asciidoctor
         self[:load_paths] = options[:load_paths] || nil
         self[:requires] = options[:requires] || nil
         self[:base_dir] = options[:base_dir]
+        self[:source_dir] = options[:source_dir] || nil
         self[:destination_dir] = options[:destination_dir] || nil
+        self[:failure_level] = ::Logger::Severity::FATAL
         self[:trace] = false
         self[:timings] = false
       end
@@ -75,8 +79,6 @@ Example: asciidoctor -b html5 source.asc
                   'specify eRuby implementation to use when rendering custom ERB templates: [erb, erubis] (default: erb)') do |eruby|
             self[:eruby] = eruby
           end
-          opts.on('-C', '--compact', 'compact the output by removing blank lines. (No longer in use)') do
-          end
           opts.on('-a', '--attribute key[=value]', 'a document attribute to set in the form of key, key! or key=value pair',
                   'unless @ is appended to the value, this attributes takes precedence over attributes',
                   'defined in the source document') do |attr|
@@ -104,6 +106,9 @@ Example: asciidoctor -b html5 source.asc
           opts.on('-B', '--base-dir DIR', 'base directory containing the document and resources (default: directory of source file)') do |base_dir|
             self[:base_dir] = base_dir
           end
+          opts.on('-R', '--source-dir DIR', 'source root directory (used for calculating path in destination directory)') do |src_dir|
+            self[:source_dir] = src_dir
+          end
           opts.on('-D', '--destination-dir DIR', 'destination output directory (default: directory of source file)') do |dest_dir|
             self[:destination_dir] = dest_dir
           end
@@ -115,6 +120,10 @@ Example: asciidoctor -b html5 source.asc
               'may be specified more than once') do |path|
             (self[:requires] ||= []).concat(path.split ',')
           end
+          opts.on('--failure-level LEVEL', %w(warning WARNING error ERROR), 'set minimum logging level that triggers a non-zero exit code: [WARN, ERROR] (default: FATAL)') do |level|
+            level = 'WARN' if (level = level.upcase) == 'WARNING'
+            self[:failure_level] = ::Logger::Severity.const_get level
+          end
           opts.on('-q', '--quiet', 'suppress warnings (default: false)') do |verbose|
             self[:verbose] = 0
           end
@@ -132,11 +141,32 @@ Example: asciidoctor -b html5 source.asc
               'show the command usage if TOPIC is not specified (or not recognized)',
               'dump the Asciidoctor man page (in troff/groff format) if TOPIC is manpage') do |topic|
             if topic == 'manpage'
-              if ::File.exist?(manpage_path = (::File.join ::Asciidoctor::ROOT_PATH, 'man', 'asciidoctor.1'))
-                $stdout.puts(::IO.read manpage_path)
+              if (manpage_path = ENV['ASCIIDOCTOR_MANPAGE_PATH'])
+                if ::File.exist? manpage_path
+                  if manpage_path.end_with? '.gz'
+                    require 'zlib' unless defined? ::Zlib::GzipReader
+                    $stdout.puts ::Zlib::GzipReader.open(manpage_path) {|gz| gz.read }
+                  else
+                    $stdout.puts ::IO.read manpage_path
+                  end
+                else
+                  $stderr.puts %(asciidoctor: FAILED: manual page not found: #{manpage_path})
+                  return 1
+                end
+              elsif ::File.exist?(manpage_path = (::File.join ::Asciidoctor::ROOT_PATH, 'man', 'asciidoctor.1'))
+                $stdout.puts ::IO.read manpage_path
               else
-                $stderr.puts 'asciidoctor: FAILED: man page not found; try `man asciidoctor`'
-                return 1
+                require 'open3' unless defined? ::Open3.popen3
+                manpage_path = ::Open3.popen3('man -w asciidoctor') {|_, out| out.read }.chop rescue ''
+                if manpage_path.empty?
+                  $stderr.puts 'asciidoctor: FAILED: manual page not found; try `man asciidoctor`'
+                  return 1
+                elsif manpage_path.end_with? '.gz'
+                  require 'zlib' unless defined? ::Zlib::GzipReader
+                  $stdout.puts ::Zlib::GzipReader.open(manpage_path) {|gz| gz.read }
+                else
+                  $stdout.puts ::IO.read manpage_path
+                end
               end
             else
               $stdout.puts opts
@@ -171,31 +201,39 @@ Example: asciidoctor -b html5 source.asc
               # warn, but don't panic; we may have enough to proceed, so we won't force a failure
               $stderr.puts %(asciidoctor: WARNING: extra arguments detected (unparsed arguments: '#{args * "', '"}') or incorrect usage of stdin)
             else
-              if ::File.readable? file
-                matches = [file]
+              if ::File.file? file
+                infiles << file
+              # NOTE only attempt to glob if file is not found
               else
                 # Tilt backslashes in Windows paths the Ruby-friendly way
-                if ::File::ALT_SEPARATOR == '\\' && (file.include? '\\')
-                  file = file.tr '\\', '/'
+                if ::File::ALT_SEPARATOR == RS && (file.include? RS)
+                  file = file.tr RS, FS
                 end
                 if (matches = ::Dir.glob file).empty?
-                  $stderr.puts %(asciidoctor: FAILED: input file #{file} missing or cannot be read)
-                  return 1
+                  # NOTE if no matches, assume it's just a missing file and proceed
+                  infiles << file
+                else
+                  infiles.concat matches
                 end
               end
-
-              infiles.concat matches
             end
           end
         end
 
-        infiles.each do |file|
-          unless file == '-' || (::File.file? file) || (::File.pipe? file)
-            if ::File.readable? file
-              $stderr.puts %(asciidoctor: FAILED: input path #{file} is a #{(::File.stat file).ftype}, not a file)
+        infiles.reject {|file| file == '-' }.each do |file|
+          begin
+            fstat = ::File.stat file
+            if fstat.file? || fstat.pipe?
+              unless fstat.readable?
+                $stderr.puts %(asciidoctor: FAILED: input file #{file} is not readable)
+                return 1
+              end
             else
-              $stderr.puts %(asciidoctor: FAILED: input file #{file} missing or cannot be read)
+              $stderr.puts %(asciidoctor: FAILED: input path #{file} is a #{fstat.ftype}, not a file)
+              return 1
             end
+          rescue ::Errno::ENOENT
+            $stderr.puts %(asciidoctor: FAILED: input file #{file} is missing)
             return 1
           end
         end
@@ -206,7 +244,7 @@ Example: asciidoctor -b html5 source.asc
 
         if self[:template_dirs]
           begin
-            require 'tilt' unless defined? ::Tilt
+            require 'tilt' unless defined? ::Tilt::VERSION
           rescue ::LoadError
             raise $! if self[:trace]
             $stderr.puts 'asciidoctor: FAILED: \'tilt\' could not be loaded'
@@ -220,7 +258,7 @@ Example: asciidoctor -b html5 source.asc
 
         if (load_paths = self[:load_paths])
           (self[:load_paths] = load_paths.uniq).reverse_each do |path|
-            $:.unshift File.expand_path(path)
+            $:.unshift ::File.expand_path(path)
           end
         end
 
@@ -251,10 +289,10 @@ Example: asciidoctor -b html5 source.asc
       end
 
       def print_version os = $stdout
-        os.puts %(Asciidoctor #{::Asciidoctor::VERSION} [http://asciidoctor.org])
-        if RUBY_VERSION >= '1.9.3'
-          encoding_info = {'lc' => 'locale', 'fs' => 'filesystem', 'in' => 'internal', 'ex' => 'external'}.map do |k,v|
-            %(#{k}:#{::Encoding.find(v) || '-'})
+        os.puts %(Asciidoctor #{::Asciidoctor::VERSION} [https://asciidoctor.org])
+        if RUBY_MIN_VERSION_1_9
+          encoding_info = { 'lc' => 'locale', 'fs' => 'filesystem', 'in' => 'internal', 'ex' => 'external' }.map do |k, v|
+            %(#{k}:#{v == 'internal' ? (::File.open(__FILE__) {|f| f.getc }).encoding : (::Encoding.find v)})
           end
           os.puts %(Runtime Environment (#{RUBY_DESCRIPTION}) (#{encoding_info * ' '}))
         else
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/base.rb 1.5.7-1/lib/asciidoctor/converter/base.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/base.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/base.rb	2018-05-05 22:54:38.000000000 +0000
@@ -9,11 +9,15 @@ module Asciidoctor
   # Concrete subclasses must implement the {#convert} method and, optionally,
   # the {#convert_with_options} method.
   class Converter::Base
+    include Logging
     include Converter
   end
 
   # An abstract base class for built-in {Converter} classes.
+  # Does not inherit from Converter.
   class Converter::BuiltIn
+    include Logging
+
     def initialize backend, opts = {}
     end
 
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/docbook45.rb 1.5.7-1/lib/asciidoctor/converter/docbook45.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/docbook45.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/docbook45.rb	2018-05-05 22:54:38.000000000 +0000
@@ -18,8 +18,8 @@ module Asciidoctor
 
     def olist node
       result = []
-      num_attribute = node.style ? %( numeration="#{node.style}") : nil
-      start_attribute = (node.attr? 'start') ? %( override="#{node.attr 'start'}") : nil
+      num_attribute = node.style ? %( numeration="#{node.style}") : ''
+      start_attribute = (node.attr? 'start') ? %( override="#{node.attr 'start'}") : ''
       result << %(<orderedlist#{common_attributes node.id, node.role, node.reftext}#{num_attribute}>)
       result << %(<title>#{node.title}</title>) if node.title?
       node.items.each_with_index do |item, idx|
@@ -52,11 +52,18 @@ module Asciidoctor
       end
     end
 
-    def author_element doc, index = nil
-      firstname_key = index ? %(firstname_#{index}) : 'firstname'
-      middlename_key = index ? %(middlename_#{index}) : 'middlename'
-      lastname_key = index ? %(lastname_#{index}) : 'lastname'
-      email_key = index ? %(email_#{index}) : 'email'
+    def author_tag doc, index = nil
+      if index
+        firstname_key = %(firstname_#{index})
+        middlename_key = %(middlename_#{index})
+        lastname_key = %(lastname_#{index})
+        email_key = %(email_#{index})
+      else
+        firstname_key = 'firstname'
+        middlename_key = 'middlename'
+        lastname_key = 'lastname'
+        email_key = 'email'
+      end
 
       result = []
       result << '<author>'
@@ -80,7 +87,7 @@ module Asciidoctor
       %(<!DOCTYPE #{root_tag_name} PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN" "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd">)
     end
 
-    def document_info_element doc, info_tag_prefix
+    def document_info_tag doc, info_tag_prefix
       super doc, info_tag_prefix, true
     end
 
@@ -92,7 +99,7 @@ module Asciidoctor
       if (ns = doc.attr 'xmlns')
         ns.empty? ? ' xmlns="http://docbook.org/ns/docbook"' : %( xmlns="#{ns}")
       else
-        nil
+        ''
       end
     end
   end
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/docbook5.rb 1.5.7-1/lib/asciidoctor/converter/docbook5.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/docbook5.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/docbook5.rb	2018-05-05 22:54:38.000000000 +0000
@@ -4,6 +4,7 @@ module Asciidoctor
   # similar to the docbook45 backend from AsciiDoc Python, but migrated to the
   # DocBook 5 specification.
   class Converter::DocBook5Converter < Converter::BuiltIn
+    CopyrightRx = /^(.+?)(?: ((?:\d{4}\-)?\d{4}))?$/
     ImageMacroRx = /^image::?(.+?)\[(.*?)\]$/
 
     def document node
@@ -29,9 +30,9 @@ module Asciidoctor
           result << '<?asciidoc-numbered?>'
         end
       end
-      lang_attribute = (node.attr? 'nolang') ? nil : %( #{lang_attribute_name}="#{node.attr 'lang', 'en'}")
+      lang_attribute = (node.attr? 'nolang') ? '' : %( #{lang_attribute_name}="#{node.attr 'lang', 'en'}")
       result << %(<#{root_tag_name}#{document_ns_attributes node}#{lang_attribute}>)
-      result << (document_info_element node, root_tag_name) unless node.noheader
+      result << (document_info_tag node, root_tag_name) unless node.noheader
       result << node.content if node.blocks?
       unless (footer_docinfo = node.docinfo :footer).empty?
         result << footer_docinfo
@@ -51,9 +52,9 @@ module Asciidoctor
       else
         tag_name = node.sectname
       end
+      title_el = node.special && (node.option? 'untitled') ? '' : %(<title>#{node.title}</title>\n)
       %(<#{tag_name}#{common_attributes node.id, node.role, node.reftext}>
-<title>#{node.title}</title>
-#{node.content}
+#{title_el}#{node.content}
 </#{tag_name}>)
     end
 
@@ -116,7 +117,7 @@ module Asciidoctor
           end
           result << %(</entry>
 <entry>)
-          unless dd.nil?
+          if dd
             result << %(<simpara>#{dd.text}</simpara>) if dd.text?
             result << dd.content if dd.blocks?
           end
@@ -148,7 +149,7 @@ module Asciidoctor
 
           result << %(</#{label_tag}>) if label_tag
           result << %(<#{item_tag}>)
-          unless dd.nil?
+          if dd
             result << %(<simpara>#{dd.text}</simpara>) if dd.text?
             result << dd.content if dd.blocks?
           end
@@ -184,19 +185,19 @@ module Asciidoctor
       # See http://tdg.docbook.org/tdg/4.5/imagedata-x.html#d0e79635
       if node.attr? 'scaledwidth'
         width_attribute = %( width="#{node.attr 'scaledwidth'}")
-        depth_attribute = nil
-        scale_attribute = nil
+        depth_attribute = ''
+        scale_attribute = ''
       elsif node.attr? 'scale'
         # QUESTION should we set the viewport using width and depth? (the scaled image would be contained within this box)
-        #width_attribute = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : nil
-        #depth_attribute = (node.attr? 'height') ? %( depth="#{node.attr 'height'}") : nil
+        #width_attribute = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : ''
+        #depth_attribute = (node.attr? 'height') ? %( depth="#{node.attr 'height'}") : ''
         scale_attribute = %( scale="#{node.attr 'scale'}")
       else
-        width_attribute = (node.attr? 'width') ? %( contentwidth="#{node.attr 'width'}") : nil
-        depth_attribute = (node.attr? 'height') ? %( contentdepth="#{node.attr 'height'}") : nil
-        scale_attribute = nil
+        width_attribute = (node.attr? 'width') ? %( contentwidth="#{node.attr 'width'}") : ''
+        depth_attribute = (node.attr? 'height') ? %( contentdepth="#{node.attr 'height'}") : ''
+        scale_attribute = ''
       end
-      align_attribute = (node.attr? 'align') ? %( align="#{node.attr 'align'}") : nil
+      align_attribute = (node.attr? 'align') ? %( align="#{node.attr 'align'}") : ''
 
       mediaobject = %(<mediaobject>
 <imageobject>
@@ -222,9 +223,9 @@ module Asciidoctor
       listing_attributes = (common_attributes node.id, node.role, node.reftext)
       if node.style == 'source' && (node.attr? 'language')
         numbering = (node.attr? 'linenums', nil, false) ? 'numbered' : 'unnumbered'
-        listing_content = %(<programlisting#{informal ? listing_attributes : nil} language="#{node.attr 'language', nil, false}" linenumbering="#{numbering}">#{node.content}</programlisting>)
+        listing_content = %(<programlisting#{informal ? listing_attributes : ''} language="#{node.attr 'language', '', false}" linenumbering="#{numbering}">#{node.content}</programlisting>)
       else
-        listing_content = %(<screen#{informal ? listing_attributes : nil}>#{node.content}</screen>)
+        listing_content = %(<screen#{informal ? listing_attributes : ''}>#{node.content}</screen>)
       end
       if informal
         listing_content
@@ -260,8 +261,7 @@ module Asciidoctor
         equation = node.content
       end
       if node.style == 'asciimath'
-        if ((defined? ::AsciiMath) || ((defined? @asciimath_available) ? @asciimath_available :
-            (@asciimath_available = Helpers.require_library 'asciimath', true, :warn)))
+        if (@asciimath ||= ((defined? ::AsciiMath) || (Helpers.require_library 'asciimath', true, :warn)).nil? ? :unavailable : :loaded) == :loaded
           # NOTE fop requires jeuclid to process raw mathml
           equation_data = (::AsciiMath.parse equation).to_mathml 'mml:', 'xmlns:mml' => 'http://www.w3.org/1998/Math/MathML'
         else
@@ -287,8 +287,8 @@ module Asciidoctor
 
     def olist node
       result = []
-      num_attribute = node.style ? %( numeration="#{node.style}") : nil
-      start_attribute = (node.attr? 'start') ? %( startingnumber="#{node.attr 'start'}") : nil
+      num_attribute = node.style ? %( numeration="#{node.style}") : ''
+      start_attribute = (node.attr? 'start') ? %( startingnumber="#{node.attr 'start'}") : ''
       result << %(<orderedlist#{common_attributes node.id, node.role, node.reftext}#{num_attribute}#{start_attribute}>)
       result << %(<title>#{node.title}</title>) if node.title?
       node.items.each do |item|
@@ -305,7 +305,7 @@ module Asciidoctor
       case node.style
       when 'abstract'
         if node.parent == node.document && node.document.doctype == 'book'
-          warn 'asciidoctor: WARNING: abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
+          logger.warn 'abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
           ''
         else
           %(<abstract>
@@ -314,7 +314,7 @@ module Asciidoctor
         end
       when 'partintro'
         unless node.level == 0 && node.parent.context == :section && node.document.doctype == 'book'
-          warn 'asciidoctor: ERROR: partintro block can only be used when doctype is book and it\'s a child of a part section. Excluding block content.'
+          logger.error 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
           ''
         else
           %(<partintro#{common_attributes node.id, node.role, node.reftext}>
@@ -322,7 +322,24 @@ module Asciidoctor
 </partintro>)
         end
       else
-        node.content
+        reftext = node.reftext if (id = node.id)
+        role = node.role
+        if node.title?
+          %(<formalpara#{common_attributes id, role, reftext}>
+<title>#{node.title}</title>
+<para>#{content_spacer = node.content_model == :compound ? LF : ''}#{node.content}#{content_spacer}</para>
+</formalpara>)
+        elsif id || role
+          if node.content_model == :compound
+            %(<para#{common_attributes id, role, reftext}>
+#{node.content}
+</para>)
+          else
+            %(<simpara#{common_attributes id, role, reftext}>#{node.content}</simpara>)
+          end
+        else
+          resolve_content node
+        end
       end
     end
 
@@ -352,22 +369,7 @@ module Asciidoctor
     end
 
     def quote node
-      result = []
-      result << %(<blockquote#{common_attributes node.id, node.role, node.reftext}>)
-      result << %(<title>#{node.title}</title>) if node.title?
-      if (node.attr? 'attribution') || (node.attr? 'citetitle')
-        result << '<attribution>'
-        if node.attr? 'attribution'
-          result << (node.attr 'attribution')
-        end
-        if node.attr? 'citetitle'
-          result << %(<citetitle>#{node.attr 'citetitle'}</citetitle>)
-        end
-        result << '</attribution>'
-      end
-      result << (resolve_content node)
-      result << '</blockquote>'
-      result * LF
+      blockquote_tag(node, (node.has_role? 'epigraph') && 'epigraph') { resolve_content node }
     end
 
     def thematic_break node
@@ -385,8 +387,11 @@ module Asciidoctor
     def table node
       has_body = false
       result = []
-      pgwide_attribute = (node.option? 'pgwide') ? ' pgwide="1"' : nil
-      result << %(<#{tag_name = node.title? ? 'table' : 'informaltable'}#{common_attributes node.id, node.role, node.reftext}#{pgwide_attribute} frame="#{node.attr 'frame', 'all'}" rowsep="#{['none', 'cols'].include?(node.attr 'grid') ? 0 : 1}" colsep="#{['none', 'rows'].include?(node.attr 'grid') ? 0 : 1}"#{(node.attr? 'orientation', 'landscape', nil) ? ' orient="land"' : nil}>)
+      pgwide_attribute = (node.option? 'pgwide') ? ' pgwide="1"' : ''
+      if (frame = node.attr 'frame', 'all') == 'ends'
+        frame = 'topbot'
+      end
+      result << %(<#{tag_name = node.title? ? 'table' : 'informaltable'}#{common_attributes node.id, node.role, node.reftext}#{pgwide_attribute} frame="#{frame}" rowsep="#{['none', 'cols'].include?(node.attr 'grid') ? 0 : 1}" colsep="#{['none', 'rows'].include?(node.attr 'grid') ? 0 : 1}"#{(node.attr? 'orientation', 'landscape', false) ? ' orient="land"' : ''}>)
       if (node.option? 'unbreakable')
         result << '<?dbfo keep-together="always"?>'
       elsif (node.option? 'breakable')
@@ -412,10 +417,10 @@ module Asciidoctor
         rows.each do |row|
           result << '<row>'
           row.each do |cell|
-            halign_attribute = (cell.attr? 'halign') ? %( align="#{cell.attr 'halign'}") : nil
-            valign_attribute = (cell.attr? 'valign') ? %( valign="#{cell.attr 'valign'}") : nil
-            colspan_attribute = cell.colspan ? %( namest="col_#{colnum = cell.column.attr 'colnumber'}" nameend="col_#{colnum + cell.colspan - 1}") : nil
-            rowspan_attribute = cell.rowspan ? %( morerows="#{cell.rowspan - 1}") : nil
+            halign_attribute = (cell.attr? 'halign') ? %( align="#{cell.attr 'halign'}") : ''
+            valign_attribute = (cell.attr? 'valign') ? %( valign="#{cell.attr 'valign'}") : ''
+            colspan_attribute = cell.colspan ? %( namest="col_#{colnum = cell.column.attr 'colnumber'}" nameend="col_#{colnum + cell.colspan - 1}") : ''
+            rowspan_attribute = cell.rowspan ? %( morerows="#{cell.rowspan - 1}") : ''
             # NOTE <entry> may not have whitespace (e.g., line breaks) as a direct descendant according to DocBook rules
             entry_start = %(<entry#{halign_attribute}#{valign_attribute}#{colspan_attribute}#{rowspan_attribute}>)
             if tsec == :head
@@ -444,7 +449,7 @@ module Asciidoctor
       result << '</tgroup>'
       result << %(</#{tag_name}>)
 
-      warn 'asciidoctor: WARNING: tables must have at least one body row' unless has_body
+      logger.warn 'tables must have at least one body row' unless has_body
       result * LF
     end
 
@@ -464,14 +469,14 @@ module Asciidoctor
         result << '</bibliodiv>'
       else
         mark_type = (checklist = node.option? 'checklist') ? 'none' : node.style
-        mark_attribute = mark_type ? %( mark="#{mark_type}") : nil
+        mark_attribute = mark_type ? %( mark="#{mark_type}") : ''
         result << %(<itemizedlist#{common_attributes node.id, node.role, node.reftext}#{mark_attribute}>)
         result << %(<title>#{node.title}</title>) if node.title?
         node.items.each do |item|
           text_marker = if checklist && (item.attr? 'checkbox')
             (item.attr? 'checked') ? '&#10003; ' : '&#10063; '
           else
-            nil
+            ''
           end
           result << '<listitem>'
           result << %(<simpara>#{text_marker}#{item.text}</simpara>)
@@ -485,22 +490,7 @@ module Asciidoctor
     end
 
     def verse node
-      result = []
-      result << %(<blockquote#{common_attributes node.id, node.role, node.reftext}>)
-      result << %(<title>#{node.title}</title>) if node.title?
-      if (node.attr? 'attribution') || (node.attr? 'citetitle')
-        result << '<attribution>'
-        if node.attr? 'attribution'
-          result << (node.attr 'attribution')
-        end
-        if node.attr? 'citetitle'
-          result << %(<citetitle>#{node.attr 'citetitle'}</citetitle>)
-        end
-        result << '</attribution>'
-      end
-      result << %(<literallayout>#{node.content}</literallayout>)
-      result << '</blockquote>'
-      result * LF
+      blockquote_tag(node, (node.has_role? 'epigraph') && 'epigraph') { %(<literallayout>#{node.content}</literallayout>) }
     end
 
     alias video skip
@@ -523,7 +513,8 @@ module Asciidoctor
         # NOTE technically node.text should be node.reftext, but subs have already been applied to text
         %(<anchor#{common_attributes node.id, nil, (text = node.text)}/>#{text})
       else
-        warn %(asciidoctor: WARNING: unknown anchor type: #{node.type.inspect})
+        logger.warn %(unknown anchor type: #{node.type.inspect})
+        nil
       end
     end
 
@@ -548,8 +539,8 @@ module Asciidoctor
     end
 
     def inline_image node
-      width_attribute = (node.attr? 'width') ? %( contentwidth="#{node.attr 'width'}") : nil
-      depth_attribute = (node.attr? 'height') ? %( contentdepth="#{node.attr 'height'}") : nil
+      width_attribute = (node.attr? 'width') ? %( contentwidth="#{node.attr 'width'}") : ''
+      depth_attribute = (node.attr? 'height') ? %( contentdepth="#{node.attr 'height'}") : ''
       %(<inlinemediaobject>
 <imageobject>
 <imagedata fileref="#{node.type == 'icon' ? (node.icon_uri node.target) : (node.image_uri node.target)}"#{width_attribute}#{depth_attribute}/>
@@ -606,8 +597,8 @@ module Asciidoctor
       :monospaced  => ['<literal>',                '</literal>',     false],
       :emphasis    => ['<emphasis>',               '</emphasis>',    true],
       :strong      => ['<emphasis role="strong">', '</emphasis>',    true],
-      :double      => ['&#8220;',                  '&#8221;',        true],
-      :single      => ['&#8216;',                  '&#8217;',        true],
+      :double      => ['<quote>',                  '</quote>',       true],
+      :single      => ['<quote>',                  '</quote>',       true],
       :mark        => ['<emphasis role="marked">', '</emphasis>',    false],
       :superscript => ['<superscript>',            '</superscript>', false],
       :subscript   => ['<subscript>',              '</subscript>',   false]
@@ -615,8 +606,7 @@ module Asciidoctor
 
     def inline_quoted node
       if (type = node.type) == :asciimath
-        if ((defined? ::AsciiMath) || ((defined? @asciimath_available) ? @asciimath_available :
-            (@asciimath_available = Helpers.require_library 'asciimath', true, :warn)))
+        if (@asciimath ||= ((defined? ::AsciiMath) || (Helpers.require_library 'asciimath', true, :warn)).nil? ? :unavailable : :loaded) == :loaded
           # NOTE fop requires jeuclid to process raw mathml
           %(<inlineequation>#{(::AsciiMath.parse node.text).to_mathml 'mml:', 'xmlns:mml' => 'http://www.w3.org/1998/Math/MathML'}</inlineequation>)
         else
@@ -642,7 +632,24 @@ module Asciidoctor
       end
     end
 
-    def author_element doc, index = nil
+    def common_attributes id, role = nil, reftext = nil
+      attrs = id ? %( xml:id="#{id}") : ''
+      attrs = %(#{attrs} role="#{role}") if role
+      if reftext
+        if (reftext.include? '<') && ((reftext = reftext.gsub XmlSanitizeRx, '').include? ' ')
+          reftext = (reftext.squeeze ' ').strip
+        end
+        reftext = (reftext.gsub '"', '&quot;') if reftext.include? '"'
+        attrs = %(#{attrs} xreflabel="#{reftext}")
+      end
+      attrs
+    end
+
+    def doctype_declaration root_tag_name
+      nil
+    end
+
+    def author_tag doc, index = nil
       firstname_key = index ? %(firstname_#{index}) : 'firstname'
       middlename_key = index ? %(middlename_#{index}) : 'middlename'
       lastname_key = index ? %(lastname_#{index}) : 'lastname'
@@ -661,40 +668,30 @@ module Asciidoctor
       result * LF
     end
 
-    def common_attributes id, role = nil, reftext = nil
-      attrs = id ? %( xml:id="#{id}") : ''
-      attrs = %(#{attrs} role="#{role}") if role
-      if reftext
-        if (reftext.include? '<') && ((reftext = reftext.gsub XmlSanitizeRx, '').include? ' ')
-          reftext = (reftext.squeeze ' ').strip
-        end
-        reftext = (reftext.gsub '"', '&quot;') if reftext.include? '"'
-        attrs = %(#{attrs} xreflabel="#{reftext}")
-      end
-      attrs
-    end
-
-    def doctype_declaration root_tag_name
-      nil
-    end
-
-    def document_info_element doc, info_tag_prefix, use_info_tag_prefix = false
-      info_tag_prefix = nil unless use_info_tag_prefix
+    def document_info_tag doc, info_tag_prefix, use_info_tag_prefix = false
+      info_tag_prefix = '' unless use_info_tag_prefix
       result = []
       result << %(<#{info_tag_prefix}info>)
       result << document_title_tags(doc.doctitle :partition => true, :use_fallback => true) unless doc.notitle
       if (date = (doc.attr? 'revdate') ? (doc.attr 'revdate') : ((doc.attr? 'reproducible') ? nil : (doc.attr 'docdate')))
         result << %(<date>#{date}</date>)
       end
+      if doc.attr? 'copyright'
+        CopyrightRx =~ (doc.attr 'copyright')
+        result << '<copyright>'
+        result << %(<holder>#{$1}</holder>)
+        result << %(<year>#{$2}</year>) if $2
+        result << '</copyright>'
+      end
       if doc.has_header?
         if doc.attr? 'author'
           if (authorcount = (doc.attr 'authorcount').to_i) < 2
-            result << (author_element doc)
+            result << (author_tag doc)
             result << %(<authorinitials>#{doc.attr 'authorinitials'}</authorinitials>) if doc.attr? 'authorinitials'
           else
             result << '<authorgroup>'
             authorcount.times do |index|
-              result << (author_element doc, index + 1)
+              result << (author_tag doc, index + 1)
             end
             result << '</authorgroup>'
           end
@@ -730,9 +727,11 @@ module Asciidoctor
         result << '<refmeta>'
         result << %(<refentrytitle>#{doc.attr 'mantitle'}</refentrytitle>) if doc.attr? 'mantitle'
         result << %(<manvolnum>#{doc.attr 'manvolnum'}</manvolnum>) if doc.attr? 'manvolnum'
+        result << %(<refmiscinfo class="source">#{doc.attr 'mansource', '&#160;'}</refmiscinfo>)
+        result << %(<refmiscinfo class="manual">#{doc.attr 'manmanual', '&#160;'}</refmiscinfo>)
         result << '</refmeta>'
         result << '<refnamediv>'
-        result << %(<refname>#{doc.attr 'manname'}</refname>) if doc.attr? 'manname'
+        result += (doc.attr 'mannames').map {|n| %(<refname>#{n}</refname>) } if doc.attr? 'mannames'
         result << %(<refpurpose>#{doc.attr 'manpurpose'}</refpurpose>) if doc.attr? 'manpurpose'
         result << '</refnamediv>'
       end
@@ -763,13 +762,13 @@ module Asciidoctor
     end
 
     def title_tag node, optional = true
-      !optional || node.title? ? %(<title>#{node.title}</title>\n) : nil
+      !optional || node.title? ? %(<title>#{node.title}</title>\n) : ''
     end
 
     def cover_tag doc, face, use_placeholder = false
       if (cover_image = doc.attr %(#{face}-cover-image))
-        width_attr = nil
-        depth_attr = nil
+        width_attr = ''
+        depth_attr = ''
         if (cover_image.include? ':') && ImageMacroRx =~ cover_image
           cover_image = doc.image_uri $1
           unless $2.empty?
@@ -794,5 +793,24 @@ module Asciidoctor
         %(<cover role="#{face}"/>)
       end
     end
+
+    def blockquote_tag node, tag_name = nil
+      if tag_name
+        start_tag, end_tag = %(<#{tag_name}), %(</#{tag_name}>)
+      else
+        start_tag, end_tag = '<blockquote', '</blockquote>'
+      end
+      result = [%(#{start_tag}#{common_attributes node.id, node.role, node.reftext}>)]
+      result << %(<title>#{node.title}</title>) if node.title?
+      if (node.attr? 'attribution') || (node.attr? 'citetitle')
+        result << '<attribution>'
+        result << (node.attr 'attribution') if node.attr? 'attribution'
+        result << %(<citetitle>#{node.attr 'citetitle'}</citetitle>) if node.attr? 'citetitle'
+        result << '</attribution>'
+      end
+      result << yield
+      result << end_tag
+      result * LF
+    end
   end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/factory.rb 1.5.7-1/lib/asciidoctor/converter/factory.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/factory.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/factory.rb	2018-05-05 22:54:38.000000000 +0000
@@ -37,7 +37,7 @@ module Asciidoctor
         # the registry of converters is initialized using a normal Hash.
         #
         # initialize_singleton - A Boolean to indicate whether the singleton should
-        #                        be initialize if it has not already been created.
+        #                        be initialized if it has not already been created.
         #                        If false, and a singleton has not been previously
         #                        initialized, a fresh instance is returned.
         #
@@ -46,10 +46,12 @@ module Asciidoctor
           return @__default__ || new unless initialize_singleton
           # FIXME this assignment is not thread_safe, may need to use a ::Threadsafe helper here
           @__default__ ||= begin
+            # NOTE .to_s hides require from Opal
             require 'thread_safe'.to_s unless defined? ::ThreadSafe
             new ::ThreadSafe::Cache.new
           rescue ::LoadError
-            warn 'asciidoctor: WARNING: gem \'thread_safe\' is not installed. This gem is recommended when registering custom converters.'
+            include Logging unless include? Logging
+            logger.warn 'gem \'thread_safe\' is not installed. This gem is recommended when registering custom converters.'
             new
           end
         end
@@ -183,41 +185,37 @@ module Asciidoctor
       # Returns the [Converter] object
       def create backend, opts = {}
         if (converter = resolve backend)
-          return ::Class === converter ? (converter.new backend, opts) : converter
-        end
-
-        base_converter = case backend
-        when 'html5'
-          unless defined? ::Asciidoctor::Converter::Html5Converter
-            require 'asciidoctor/converter/html5'.to_s
-          end
-          Html5Converter.new backend, opts
-        when 'docbook5'
-          unless defined? ::Asciidoctor::Converter::DocBook5Converter
-            require 'asciidoctor/converter/docbook5'.to_s
-          end
-          DocBook5Converter.new backend, opts
-        when 'docbook45'
-          unless defined? ::Asciidoctor::Converter::DocBook45Converter
-            require 'asciidoctor/converter/docbook45'.to_s
+          base_converter = ::Class === converter ? (converter.new backend, opts) : converter
+          return base_converter unless Converter::BackendInfo === base_converter && base_converter.supports_templates?
+        else
+          case backend
+          when 'html5'
+            # NOTE .to_s hides require from Opal
+            require 'asciidoctor/converter/html5'.to_s unless defined? ::Asciidoctor::Converter::Html5Converter
+            base_converter = Html5Converter.new backend, opts
+          when 'docbook5'
+            # NOTE .to_s hides require from Opal
+            require 'asciidoctor/converter/docbook5'.to_s unless defined? ::Asciidoctor::Converter::DocBook5Converter
+            base_converter = DocBook5Converter.new backend, opts
+          when 'docbook45'
+            # NOTE .to_s hides require from Opal
+            require 'asciidoctor/converter/docbook45'.to_s unless defined? ::Asciidoctor::Converter::DocBook45Converter
+            base_converter = DocBook45Converter.new backend, opts
+          when 'manpage'
+            # NOTE .to_s hides require from Opal
+            require 'asciidoctor/converter/manpage'.to_s unless defined? ::Asciidoctor::Converter::ManPageConverter
+            base_converter = ManPageConverter.new backend, opts
           end
-          DocBook45Converter.new backend, opts
-        when 'manpage'
-          unless defined? ::Asciidoctor::Converter::ManPageConverter
-            require 'asciidoctor/converter/manpage'.to_s
-          end
-          ManPageConverter.new backend, opts
         end
 
         return base_converter unless opts.key? :template_dirs
 
-        unless defined? ::Asciidoctor::Converter::TemplateConverter
-          require 'asciidoctor/converter/template'.to_s
-        end
-        unless defined? ::Asciidoctor::Converter::CompositeConverter
-          require 'asciidoctor/converter/composite'.to_s
-        end
+        # NOTE .to_s hides require from Opal
+        require 'asciidoctor/converter/template'.to_s unless defined? ::Asciidoctor::Converter::TemplateConverter
         template_converter = TemplateConverter.new backend, opts[:template_dirs], opts
+
+        # NOTE .to_s hides require from Opal
+        require 'asciidoctor/converter/composite'.to_s unless defined? ::Asciidoctor::Converter::CompositeConverter
         # QUESTION should we omit the composite converter if built_in_converter is nil?
         CompositeConverter.new backend, template_converter, base_converter
       end
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/html5.rb 1.5.7-1/lib/asciidoctor/converter/html5.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/html5.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/html5.rb	2018-05-05 22:54:38.000000000 +0000
@@ -19,6 +19,8 @@ module Asciidoctor
       #:latexmath   => INLINE_MATH_DELIMITERS[:latexmath] + [false]
     }).default = ['', '', false]
 
+    DropAnchorRx = /<(?:a[^>+]+|\/a)>/
+    StemBreakRx = / *\\\n(?:\\?\n)*|\n\n+/
     SvgPreambleRx = /\A.*?(?=<svg\b)/m
     SvgStartTagRx = /\A<svg[^>]*>/
     DimensionAttributeRx = /\s(?:width|height|style)=(["']).*?\1/
@@ -36,10 +38,10 @@ module Asciidoctor
         asset_uri_scheme = %(#{asset_uri_scheme}:)
       end
       cdn_base = %(#{asset_uri_scheme}//cdnjs.cloudflare.com/ajax/libs)
-      linkcss = node.safe >= SafeMode::SECURE || (node.attr? 'linkcss')
+      linkcss = node.attr? 'linkcss'
       result = ['<!DOCTYPE html>']
-      lang_attribute = (node.attr? 'nolang') ? nil : %( lang="#{node.attr 'lang', 'en'}")
-      result << %(<html#{@xml_mode ? ' xmlns="http://www.w3.org/1999/xhtml"' : nil}#{lang_attribute}>)
+      lang_attribute = (node.attr? 'nolang') ? '' : %( lang="#{node.attr 'lang', 'en'}")
+      result << %(<html#{@xml_mode ? ' xmlns="http://www.w3.org/1999/xhtml"' : ''}#{lang_attribute}>)
       result << %(<head>
 <meta charset="#{node.attr 'encoding', 'UTF-8'}"#{slash}>
 <!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge"#{slash}><![endif]-->
@@ -56,7 +58,7 @@ module Asciidoctor
         else
           icon_type = (icon_ext = ::File.extname icon_href) == '.ico' ? 'image/x-icon' : %(image/#{icon_ext[1..-1]})
         end
-        result << %(<link rel="shortcut icon" type="#{icon_type}" href="#{icon_href}">)
+        result << %(<link rel="icon" type="#{icon_type}" href="#{icon_href}"#{slash}>)
       end
       result << %(<title>#{node.doctitle :sanitize => true, :use_fallback => true}</title>)
 
@@ -81,7 +83,7 @@ module Asciidoctor
 
       if node.attr? 'icons', 'font'
         if node.attr? 'iconfont-remote'
-          result << %(<link rel="stylesheet" href="#{node.attr 'iconfont-cdn', %[#{cdn_base}/font-awesome/4.6.3/css/font-awesome.min.css]}"#{slash}>)
+          result << %(<link rel="stylesheet" href="#{node.attr 'iconfont-cdn', %[#{cdn_base}/font-awesome/#{FONT_AWESOME_VERSION}/css/font-awesome.min.css]}"#{slash}>)
         else
           iconfont_stylesheet = %(#{node.attr 'iconfont-name', 'font-awesome'}.css)
           result << %(<link rel="stylesheet" href="#{node.normalize_web_path iconfont_stylesheet, (node.attr 'stylesdir', ''), false}"#{slash}>)
@@ -113,13 +115,14 @@ module Asciidoctor
       end
 
       result << '</head>'
-      body_attrs = []
-      body_attrs << %(id="#{node.id}") if node.id
+      body_attrs = node.id ? [%(id="#{node.id}")] : []
       if (sectioned = node.sections?) && (node.attr? 'toc-class') && (node.attr? 'toc') && (node.attr? 'toc-placement', 'auto')
-        body_attrs << %(class="#{node.doctype} #{node.attr 'toc-class'} toc-#{node.attr 'toc-position', 'header'}")
+        classes = [node.doctype, (node.attr 'toc-class'), %(toc-#{node.attr 'toc-position', 'header'})]
       else
-        body_attrs << %(class="#{node.doctype}")
+        classes = [node.doctype]
       end
+      classes << (node.attr 'docrole') if node.attr? 'docrole'
+      body_attrs << %(class="#{classes * ' '}")
       body_attrs << %(style="max-width: #{node.attr 'max-width'};") if node.attr? 'max-width'
       result << %(<body #{body_attrs * ' '}>)
 
@@ -133,11 +136,7 @@ module Asciidoctor
 #{outline node}
 </div>)
           end
-          # QUESTION should this h2 have an auto-generated id?
-          result << %(<h2>#{node.attr 'manname-title'}</h2>
-<div class="sectionbody">
-<p>#{node.attr 'manname'} - #{node.attr 'manpurpose'}</p>
-</div>)
+          result << (generate_manname_section node) if node.attr? 'manpurpose'
         else
           if node.has_header?
             result << %(<h1>#{node.header.title}</h1>) unless node.notitle
@@ -190,7 +189,7 @@ module Asciidoctor
         result << %(<div id="footnotes">
 <hr#{slash}>)
         node.footnotes.each do |footnote|
-          result << %(<div class="footnote" id="_footnote_#{footnote.index}">
+          result << %(<div class="footnote" id="_footnotedef_#{footnote.index}">
 <a href="#_footnoteref_#{footnote.index}">#{footnote.index}</a>. #{footnote.text}
 </div>)
         end
@@ -245,7 +244,7 @@ MathJax.Hub.Config({
   TeX: {#{eqnums_opt}}
 });
 </script>
-<script src="#{cdn_base}/mathjax/2.6.0/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script>)
+<script src="#{cdn_base}/mathjax/#{MATHJAX_VERSION}/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script>)
       end
 
       result << '</body>'
@@ -258,17 +257,13 @@ MathJax.Hub.Config({
       if node.doctype == 'manpage'
         # QUESTION should notitle control the manual page title?
         unless node.notitle
-          id_attr = node.id ? %( id="#{node.id}") : nil
+          id_attr = node.id ? %( id="#{node.id}") : ''
           result << %(<h1#{id_attr}>#{node.doctitle} Manual Page</h1>)
         end
-        # QUESTION should this h2 have an auto-generated id?
-        result << %(<h2>#{node.attr 'manname-title'}</h2>
-<div class="sectionbody">
-<p>#{node.attr 'manname'} - #{node.attr 'manpurpose'}</p>
-</div>)
+        result << (generate_manname_section node) if node.attr? 'manpurpose'
       else
         if node.has_header? && !node.notitle
-          id_attr = node.id ? %( id="#{node.id}") : nil
+          id_attr = node.id ? %( id="#{node.id}") : ''
           result << %(<h1#{id_attr}>#{node.header.title}</h1>)
         end
       end
@@ -286,7 +281,7 @@ MathJax.Hub.Config({
         result << %(<div id="footnotes">
 <hr#{@void_element_slash}>)
         node.footnotes.each do |footnote|
-          result << %(<div class="footnote" id="_footnote_#{footnote.index}">
+          result << %(<div class="footnote" id="_footnotedef_#{footnote.index}">
 <a href="#_footnoteref_#{footnote.index}">#{footnote.index}</a>. #{footnote.text}
 </div>)
         end
@@ -312,6 +307,7 @@ MathJax.Hub.Config({
         else
           stitle = section.title
         end
+        stitle = stitle.gsub DropAnchorRx, '' if stitle.include? '<a'
         if slevel < toclevels && (child_toc_level = outline section, :toclevels => toclevels, :secnumlevels => sectnumlevels)
           result << %(<li><a href="##{section.id}">#{stitle}</a>)
           result << child_toc_level
@@ -325,45 +321,46 @@ MathJax.Hub.Config({
     end
 
     def section node
-      slevel = node.level
-      htag = %(h#{slevel + 1})
-      id_attr = anchor = link_start = link_end = nil
+      if (level = node.level) == 0
+        sect0 = true
+        title = node.numbered && level <= (node.document.attr 'sectnumlevels', 3).to_i ? %(#{node.sectnum} #{node.title}) : node.title
+      else
+        title = node.numbered && !node.caption && level <= (node.document.attr 'sectnumlevels', 3).to_i ? %(#{node.sectnum} #{node.title}) : node.captioned_title
+      end
       if node.id
         id_attr = %( id="#{id = node.id}")
-        if (doc = node.document).attr? 'sectanchors'
-          anchor = %(<a class="anchor" href="##{id}"></a>)
-          # possible idea - anchor icons GitHub-style
-          #if doc.attr? 'icons', 'font'
-          #  anchor = %(<a class="anchor" href="##{id}"><i class="fa fa-anchor"></i></a>)
-          #else
-          #  anchor = %(<a class="anchor" href="##{id}"></a>)
-          #end
-        end
-        if doc.attr? 'sectlinks'
-          link_start = %(<a class="link" href="##{id}">)
-          link_end = '</a>'
+        if (doc_attrs = node.document.attributes).key? 'sectlinks'
+          title = %(<a class="link" href="##{id}">#{title}</a>)
         end
+        if doc_attrs.key? 'sectanchors'
+          # QUESTION should we add a font-based icon in anchor if icons=font?
+          if doc_attrs['sectanchors'] == 'after'
+            title = %(#{title}<a class="anchor" href="##{id}"></a>)
+          else
+            title = %(<a class="anchor" href="##{id}"></a>#{title})
+          end
+        end
+      else
+        id_attr = ''
       end
 
-      if slevel == 0
-        %(<h1#{id_attr} class="sect0">#{anchor}#{link_start}#{node.title}#{link_end}</h1>
+      if sect0
+        %(<h1#{id_attr} class="sect0#{(role = node.role) ? " #{role}" : ''}">#{title}</h1>
 #{node.content})
       else
-        class_attr = (role = node.role) ? %( class="sect#{slevel} #{role}") : %( class="sect#{slevel}")
-        sectnum = if node.numbered && !node.caption && slevel <= (node.document.attr 'sectnumlevels', 3).to_i
-          %(#{node.sectnum} )
-        end
-        %(<div#{class_attr}>
-<#{htag}#{id_attr}>#{anchor}#{link_start}#{sectnum}#{node.captioned_title}#{link_end}</#{htag}>
-#{slevel == 1 ? %[<div class="sectionbody">\n#{node.content}\n</div>] : node.content}
+        %(<div class="sect#{level}#{(role = node.role) ? " #{role}" : ''}">
+<h#{level + 1}#{id_attr}>#{title}</h#{level + 1}>
+#{level == 1 ? %[<div class="sectionbody">
+#{node.content}
+</div>] : node.content}
 </div>)
       end
     end
 
     def admonition node
-      id_attr = node.id ? %( id="#{node.id}") : nil
+      id_attr = node.id ? %( id="#{node.id}") : ''
       name = node.attr 'name'
-      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
+      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
       if node.document.attr? 'icons'
         if (node.document.attr? 'icons', 'font') && !(node.attr? 'icon')
           label = %(<i class="fa icon-#{name}" title="#{node.attr 'textlabel'}"></i>)
@@ -373,7 +370,7 @@ MathJax.Hub.Config({
       else
         label = %(<div class="title">#{node.attr 'textlabel'}</div>)
       end
-      %(<div#{id_attr} class="admonitionblock #{name}#{(role = node.role) && " #{role}"}">
+      %(<div#{id_attr} class="admonitionblock #{name}#{(role = node.role) ? " #{role}" : ''}">
 <table>
 <tr>
 <td class="icon">
@@ -389,16 +386,16 @@ MathJax.Hub.Config({
 
     def audio node
       xml = @xml_mode
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['audioblock', node.role].compact
       class_attribute = %( class="#{classes * ' '}")
-      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
+      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
       start_t = node.attr 'start', nil, false
       end_t = node.attr 'end', nil, false
-      time_anchor = (start_t || end_t) ? %(#t=#{start_t}#{end_t ? ',' : nil}#{end_t}) : nil
+      time_anchor = (start_t || end_t) ? %(#t=#{start_t || ''}#{end_t ? ",#{end_t}" : ''}) : ''
       %(<div#{id_attribute}#{class_attribute}>
 #{title_element}<div class="content">
-<audio src="#{node.media_uri(node.attr 'target')}#{time_anchor}"#{(node.option? 'autoplay') ? (append_boolean_attribute 'autoplay', xml) : nil}#{(node.option? 'nocontrols') ? nil : (append_boolean_attribute 'controls', xml)}#{(node.option? 'loop') ? (append_boolean_attribute 'loop', xml) : nil}>
+<audio src="#{node.media_uri(node.attr 'target')}#{time_anchor}"#{(node.option? 'autoplay') ? (append_boolean_attribute 'autoplay', xml) : ''}#{(node.option? 'nocontrols') ? '' : (append_boolean_attribute 'controls', xml)}#{(node.option? 'loop') ? (append_boolean_attribute 'loop', xml) : ''}>
 Your browser does not support the audio tag.
 </audio>
 </div>
@@ -407,7 +404,7 @@ Your browser does not support the audio
 
     def colist node
       result = []
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['colist', node.style, node.role].compact
       class_attribute = %( class="#{classes * ' '}")
 
@@ -446,7 +443,7 @@ Your browser does not support the audio
 
     def dlist node
       result = []
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
 
       classes = case node.style
       when 'qanda'
@@ -481,15 +478,15 @@ Your browser does not support the audio
         result << '<table>'
         if (node.attr? 'labelwidth') || (node.attr? 'itemwidth')
           result << '<colgroup>'
-          col_style_attribute = (node.attr? 'labelwidth') ? %( style="width: #{(node.attr 'labelwidth').chomp '%'}%;") : nil
+          col_style_attribute = (node.attr? 'labelwidth') ? %( style="width: #{(node.attr 'labelwidth').chomp '%'}%;") : ''
           result << %(<col#{col_style_attribute}#{slash}>)
-          col_style_attribute = (node.attr? 'itemwidth') ? %( style="width: #{(node.attr 'itemwidth').chomp '%'}%;") : nil
+          col_style_attribute = (node.attr? 'itemwidth') ? %( style="width: #{(node.attr 'itemwidth').chomp '%'}%;") : ''
           result << %(<col#{col_style_attribute}#{slash}>)
           result << '</colgroup>'
         end
         node.items.each do |terms, dd|
           result << '<tr>'
-          result << %(<td class="hdlist1#{(node.option? 'strong') ? ' strong' : nil}">)
+          result << %(<td class="hdlist1#{(node.option? 'strong') ? ' strong' : ''}">)
           terms_array = [*terms]
           last_term = terms_array[-1]
           terms_array.each do |dt|
@@ -508,7 +505,7 @@ Your browser does not support the audio
         result << '</table>'
       else
         result << '<dl>'
-        dt_style_attribute = node.style ? nil : ' class="hdlist1"'
+        dt_style_attribute = node.style ? '' : ' class="hdlist1"'
         node.items.each do |terms, dd|
           [*terms].each do |dt|
             result << %(<dt#{dt_style_attribute}>#{dt.text}</dt>)
@@ -528,10 +525,10 @@ Your browser does not support the audio
     end
 
     def example node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
-      title_element = node.title? ? %(<div class="title">#{node.captioned_title}</div>\n) : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
+      title_element = node.title? ? %(<div class="title">#{node.captioned_title}</div>\n) : ''
 
-      %(<div#{id_attribute} class="exampleblock#{(role = node.role) && " #{role}"}">
+      %(<div#{id_attribute} class="exampleblock#{(role = node.role) ? " #{role}" : ''}">
 #{title_element}<div class="content">
 #{node.content}
 </div>
@@ -540,15 +537,15 @@ Your browser does not support the audio
 
     def floating_title node
       tag_name = %(h#{node.level + 1})
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = [node.style, node.role].compact
       %(<#{tag_name}#{id_attribute} class="#{classes * ' '}">#{node.title}</#{tag_name}>)
     end
 
     def image node
       target = node.attr 'target'
-      width_attr = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : nil
-      height_attr = (node.attr? 'height') ? %( height="#{node.attr 'height'}") : nil
+      width_attr = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : ''
+      height_attr = (node.attr? 'height') ? %( height="#{node.attr 'height'}") : ''
       if ((node.attr? 'format', 'svg', false) || (target.include? '.svg')) && node.document.safe < SafeMode::SECURE &&
           ((svg = (node.option? 'inline')) || (obj = (node.option? 'interactive')))
         if svg
@@ -559,18 +556,17 @@ Your browser does not support the audio
         end
       end
       img ||= %(<img src="#{node.image_uri target}" alt="#{encode_quotes node.alt}"#{width_attr}#{height_attr}#{@void_element_slash}>)
-      if node.attr? 'link'
-        window_attr = %( target="#{window = node.attr 'window'}"#{window == '_blank' || (node.option? 'noopener') ? ' rel="noopener"' : ''}) if node.attr? 'window'
-        img = %(<a class="image" href="#{node.attr 'link'}"#{window_attr}>#{img}</a>)
+      if node.attr? 'link', nil, false
+        img = %(<a class="image" href="#{node.attr 'link'}"#{(append_link_constraint_attrs node).join}>#{img}</a>)
       end
-      id_attr = node.id ? %( id="#{node.id}") : nil
+      id_attr = node.id ? %( id="#{node.id}") : ''
       classes = ['imageblock', node.role].compact
       class_attr = %( class="#{classes * ' '}")
       styles = []
       styles << %(text-align: #{node.attr 'align'}) if node.attr? 'align'
       styles << %(float: #{node.attr 'float'}) if node.attr? 'float'
-      style_attr = styles.empty? ? nil : %( style="#{styles * ';'}")
-      title_el = node.title? ? %(\n<div class="title">#{node.captioned_title}</div>) : nil
+      style_attr = styles.empty? ? '' : %( style="#{styles * ';'}")
+      title_el = node.title? ? %(\n<div class="title">#{node.captioned_title}</div>) : ''
       %(<div#{id_attr}#{class_attr}#{style_attr}>
 <div class="content">
 #{img}
@@ -584,36 +580,41 @@ Your browser does not support the audio
         if (language = node.attr 'language', nil, false)
           code_attrs = %( data-lang="#{language}")
         else
-          code_attrs = nil
+          code_attrs = ''
         end
         case node.document.attr 'source-highlighter'
         when 'coderay'
-          pre_class = %( class="CodeRay highlight#{nowrap ? ' nowrap' : nil}")
+          pre_class = %( class="CodeRay highlight#{nowrap ? ' nowrap' : ''}")
         when 'pygments'
-          pre_class = %( class="pygments highlight#{nowrap ? ' nowrap' : nil}")
+          if (node.document.attr? 'pygments-css', 'inline')
+            @pygments_bg = @stylesheets.pygments_background(node.document.attr 'pygments-style') unless defined? @pygments_bg
+            pre_class = %( class="pygments highlight#{nowrap ? ' nowrap' : ''}" style="background: #{@pygments_bg}")
+          else
+            pre_class = %( class="pygments highlight#{nowrap ? ' nowrap' : ''}")
+          end
         when 'highlightjs', 'highlight.js'
-          pre_class = %( class="highlightjs highlight#{nowrap ? ' nowrap' : nil}")
+          pre_class = %( class="highlightjs highlight#{nowrap ? ' nowrap' : ''}")
           code_attrs = %( class="language-#{language} hljs"#{code_attrs}) if language
         when 'prettify'
-          pre_class = %( class="prettyprint highlight#{nowrap ? ' nowrap' : nil}#{(node.attr? 'linenums', nil, false) ? ' linenums' : nil}")
+          pre_class = %( class="prettyprint highlight#{nowrap ? ' nowrap' : ''}#{(node.attr? 'linenums', nil, false) ? ' linenums' : ''}")
           code_attrs = %( class="language-#{language}"#{code_attrs}) if language
         when 'html-pipeline'
-          pre_class = language ? %( lang="#{language}") : nil
-          code_attrs = nil
+          pre_class = language ? %( lang="#{language}") : ''
+          code_attrs = ''
         else
-          pre_class = %( class="highlight#{nowrap ? ' nowrap' : nil}")
+          pre_class = %( class="highlight#{nowrap ? ' nowrap' : ''}")
           code_attrs = %( class="language-#{language}"#{code_attrs}) if language
         end
         pre_start = %(<pre#{pre_class}><code#{code_attrs}>)
         pre_end = '</code></pre>'
       else
-        pre_start = %(<pre#{nowrap ? ' class="nowrap"' : nil}>)
+        pre_start = %(<pre#{nowrap ? ' class="nowrap"' : ''}>)
         pre_end = '</pre>'
       end
 
-      id_attribute = node.id ? %( id="#{node.id}") : nil
-      title_element = node.title? ? %(<div class="title">#{node.captioned_title}</div>\n) : nil
-      %(<div#{id_attribute} class="listingblock#{(role = node.role) && " #{role}"}">
+      id_attribute = node.id ? %( id="#{node.id}") : ''
+      title_element = node.title? ? %(<div class="title">#{node.captioned_title}</div>\n) : ''
+      %(<div#{id_attribute} class="listingblock#{(role = node.role) ? " #{role}" : ''}">
 #{title_element}<div class="content">
 #{pre_start}#{node.content}#{pre_end}
 </div>
@@ -621,26 +622,32 @@ Your browser does not support the audio
     end
 
     def literal node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
-      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
+      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
       nowrap = !(node.document.attr? 'prewrap') || (node.option? 'nowrap')
-      %(<div#{id_attribute} class="literalblock#{(role = node.role) && " #{role}"}">
+      %(<div#{id_attribute} class="literalblock#{(role = node.role) ? " #{role}" : ''}">
 #{title_element}<div class="content">
-<pre#{nowrap ? ' class="nowrap"' : nil}>#{node.content}</pre>
+<pre#{nowrap ? ' class="nowrap"' : ''}>#{node.content}</pre>
 </div>
 </div>)
     end
 
     def stem node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
-      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
-      open, close = BLOCK_MATH_DELIMITERS[node.style.to_sym]
+      id_attribute = node.id ? %( id="#{node.id}") : ''
+      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
+      open, close = BLOCK_MATH_DELIMITERS[style = node.style.to_sym]
+      equation = node.content
 
-      unless ((equation = node.content).start_with? open) && (equation.end_with? close)
+      if style == :asciimath && (equation.include? LF)
+        br = %(<br#{@void_element_slash}>#{LF})
+        equation = equation.gsub(StemBreakRx) { %(#{close}#{br * ($&.count LF)}#{open}) }
+      end
+
+      unless (equation.start_with? open) && (equation.end_with? close)
         equation = %(#{open}#{equation}#{close})
       end
 
-      %(<div#{id_attribute} class="stemblock#{(role = node.role) && " #{role}"}">
+      %(<div#{id_attribute} class="stemblock#{(role = node.role) ? " #{role}" : ''}">
 #{title_element}<div class="content">
 #{equation}
 </div>
@@ -649,16 +656,16 @@ Your browser does not support the audio
 
     def olist node
       result = []
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['olist', node.style, node.role].compact
       class_attribute = %( class="#{classes * ' '}")
 
       result << %(<div#{id_attribute}#{class_attribute}>)
       result << %(<div class="title">#{node.title}</div>) if node.title?
 
-      type_attribute = (keyword = node.list_marker_keyword) ? %( type="#{keyword}") : nil
-      start_attribute = (node.attr? 'start') ? %( start="#{node.attr 'start'}") : nil
-      reversed_attribute = (node.option? 'reversed') ? (append_boolean_attribute 'reversed', @xml_mode) : nil
+      type_attribute = (keyword = node.list_marker_keyword) ? %( type="#{keyword}") : ''
+      start_attribute = (node.attr? 'start') ? %( start="#{node.attr 'start'}") : ''
+      reversed_attribute = (node.option? 'reversed') ? (append_boolean_attribute 'reversed', @xml_mode) : ''
       result << %(<ol class="#{node.style}"#{type_attribute}#{start_attribute}#{reversed_attribute}>)
 
       node.items.each do |item|
@@ -676,24 +683,24 @@ Your browser does not support the audio
     def open node
       if (style = node.style) == 'abstract'
         if node.parent == node.document && node.document.doctype == 'book'
-          warn 'asciidoctor: WARNING: abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
+          logger.warn 'abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
           ''
         else
-          id_attr = node.id ? %( id="#{node.id}") : nil
-          title_el = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
-          %(<div#{id_attr} class="quoteblock abstract#{(role = node.role) && " #{role}"}">
+          id_attr = node.id ? %( id="#{node.id}") : ''
+          title_el = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
+          %(<div#{id_attr} class="quoteblock abstract#{(role = node.role) ? " #{role}" : ''}">
 #{title_el}<blockquote>
 #{node.content}
 </blockquote>
 </div>)
         end
       elsif style == 'partintro' && (node.level > 0 || node.parent.context != :section || node.document.doctype != 'book')
-        warn 'asciidoctor: ERROR: partintro block can only be used when doctype is book and it\'s a child of a book part. Excluding block content.'
+        logger.error 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
         ''
       else
-          id_attr = node.id ? %( id="#{node.id}") : nil
-          title_el = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
-        %(<div#{id_attr} class="openblock#{style && style != 'open' ? " #{style}" : ''}#{(role = node.role) && " #{role}"}">
+          id_attr = node.id ? %( id="#{node.id}") : ''
+          title_el = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
+        %(<div#{id_attr} class="openblock#{style && style != 'open' ? " #{style}" : ''}#{(role = node.role) ? " #{role}" : ''}">
 #{title_el}<div class="content">
 #{node.content}
 </div>
@@ -729,7 +736,7 @@ Your browser does not support the audio
 #{outline doc}
 </div>)
       else
-        toc = nil
+        toc = ''
       end
 
       %(<div id="preamble">
@@ -740,18 +747,18 @@ Your browser does not support the audio
     end
 
     def quote node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['quoteblock', node.role].compact
       class_attribute = %( class="#{classes * ' '}")
-      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : nil
+      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : ''
       attribution = (node.attr? 'attribution') ? (node.attr 'attribution') : nil
       citetitle = (node.attr? 'citetitle') ? (node.attr 'citetitle') : nil
       if attribution || citetitle
-        cite_element = citetitle ? %(<cite>#{citetitle}</cite>) : nil
-        attribution_text = attribution ? %(&#8212; #{attribution}#{citetitle ? "<br#{@void_element_slash}>\n" : nil}) : nil
+        cite_element = citetitle ? %(<cite>#{citetitle}</cite>) : ''
+        attribution_text = attribution ? %(&#8212; #{attribution}#{citetitle ? "<br#{@void_element_slash}>\n" : ''}) : ''
         attribution_element = %(\n<div class="attribution">\n#{attribution_text}#{cite_element}\n</div>)
       else
-        attribution_element = nil
+        attribution_element = ''
       end
 
       %(<div#{id_attribute}#{class_attribute}>#{title_element}
@@ -766,9 +773,9 @@ Your browser does not support the audio
     end
 
     def sidebar node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
-      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : nil
-      %(<div#{id_attribute} class="sidebarblock#{(role = node.role) && " #{role}"}">
+      id_attribute = node.id ? %( id="#{node.id}") : ''
+      title_element = node.title? ? %(<div class="title">#{node.title}</div>\n) : ''
+      %(<div#{id_attribute} class="sidebarblock#{(role = node.role) ? " #{role}" : ''}">
 <div class="content">
 #{title_element}#{node.content}
 </div>
@@ -777,36 +784,36 @@ Your browser does not support the audio
 
     def table node
       result = []
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['tableblock', %(frame-#{node.attr 'frame', 'all'}), %(grid-#{node.attr 'grid', 'all'})]
+      if (stripes = node.attr 'stripes')
+        classes << %(stripes-#{stripes})
+      end
       styles = []
-      unless (node.option? 'autowidth') && !(node.attr? 'width', nil, false)
-        if node.attr? 'tablepcwidth', 100
-          classes << 'spread'
-        else
-          styles << %(width: #{node.attr 'tablepcwidth'}%;)
-        end
+      if (autowidth = node.attributes['autowidth-option']) && !(node.attr? 'width', nil, false)
+        classes << 'fit-content'
+      elsif (tablewidth = node.attr 'tablepcwidth') == 100
+        classes << 'stretch'
+      else
+        styles << %(width: #{tablewidth}%;)
       end
       if (role = node.role)
         classes << role
       end
       class_attribute = %( class="#{classes * ' '}")
       styles << %(float: #{node.attr 'float'};) if node.attr? 'float'
-      style_attribute = styles.empty? ? nil : %( style="#{styles * ' '}")
+      style_attribute = styles.empty? ? '' : %( style="#{styles * ' '}")
 
       result << %(<table#{id_attribute}#{class_attribute}#{style_attribute}>)
       result << %(<caption class="title">#{node.captioned_title}</caption>) if node.title?
       if (node.attr 'rowcount') > 0
         slash = @void_element_slash
         result << '<colgroup>'
-        if node.option? 'autowidth'
-          tag = %(<col#{slash}>)
-          node.columns.size.times do
-            result << tag
-          end
+        if autowidth
+          result += (Array.new node.columns.size, %(<col#{slash}>))
         else
           node.columns.each do |col|
-            result << %(<col style="width: #{col.attr 'colpcwidth'}%;"#{slash}>)
+            result << (col.attributes['autowidth-option'] ? %(<col#{slash}>) : %(<col style="width: #{col.attr 'colpcwidth'}%;"#{slash}>))
           end
         end
         result << '</colgroup>'
@@ -821,7 +828,7 @@ Your browser does not support the audio
               else
                 case cell.style
                 when :asciidoc
-                  cell_content = %(<div>#{cell.content}</div>)
+                  cell_content = %(<div class="content">#{cell.content}</div>)
                 when :verse
                   cell_content = %(<div class="verse">#{cell.text}</div>)
                 when :literal
@@ -834,9 +841,9 @@ Your browser does not support the audio
 
               cell_tag_name = (tsec == :head || cell.style == :header ? 'th' : 'td')
               cell_class_attribute = %( class="tableblock halign-#{cell.attr 'halign'} valign-#{cell.attr 'valign'}")
-              cell_colspan_attribute = cell.colspan ? %( colspan="#{cell.colspan}") : nil
-              cell_rowspan_attribute = cell.rowspan ? %( rowspan="#{cell.rowspan}") : nil
-              cell_style_attribute = (node.document.attr? 'cellbgcolor') ? %( style="background-color: #{node.document.attr 'cellbgcolor'};") : nil
+              cell_colspan_attribute = cell.colspan ? %( colspan="#{cell.colspan}") : ''
+              cell_rowspan_attribute = cell.rowspan ? %( rowspan="#{cell.rowspan}") : ''
+              cell_style_attribute = (node.document.attr? 'cellbgcolor') ? %( style="background-color: #{node.document.attr 'cellbgcolor'};") : ''
               result << %(<#{cell_tag_name}#{cell_class_attribute}#{cell_colspan_attribute}#{cell_rowspan_attribute}#{cell_style_attribute}>#{cell_content}</#{cell_tag_name}>)
             end
             result << '</tr>'
@@ -872,10 +879,9 @@ Your browser does not support the audio
 
     def ulist node
       result = []
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       div_classes = ['ulist', node.style, node.role].compact
-      marker_checked = nil
-      marker_unchecked = nil
+      marker_checked = marker_unchecked = ''
       if (checklist = node.option? 'checklist')
         div_classes.unshift div_classes.shift, 'checklist'
         ul_class_attribute = ' class="checklist"'
@@ -897,7 +903,7 @@ Your browser does not support the audio
           end
         end
       else
-        ul_class_attribute = node.style ? %( class="#{node.style}") : nil
+        ul_class_attribute = node.style ? %( class="#{node.style}") : ''
       end
       result << %(<div#{id_attribute} class="#{div_classes * ' '}">)
       result << %(<div class="title">#{node.title}</div>) if node.title?
@@ -920,18 +926,18 @@ Your browser does not support the audio
     end
 
     def verse node
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['verseblock', node.role].compact
       class_attribute = %( class="#{classes * ' '}")
-      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : nil
+      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : ''
       attribution = (node.attr? 'attribution') ? (node.attr 'attribution') : nil
       citetitle = (node.attr? 'citetitle') ? (node.attr 'citetitle') : nil
       if attribution || citetitle
-        cite_element = citetitle ? %(<cite>#{citetitle}</cite>) : nil
-        attribution_text = attribution ? %(&#8212; #{attribution}#{citetitle ? "<br#{@void_element_slash}>\n" : nil}) : nil
+        cite_element = citetitle ? %(<cite>#{citetitle}</cite>) : ''
+        attribution_text = attribution ? %(&#8212; #{attribution}#{citetitle ? "<br#{@void_element_slash}>\n" : ''}) : ''
         attribution_element = %(\n<div class="attribution">\n#{attribution_text}#{cite_element}\n</div>)
       else
-        attribution_element = nil
+        attribution_element = ''
       end
 
       %(<div#{id_attribute}#{class_attribute}>#{title_element}
@@ -941,25 +947,29 @@ Your browser does not support the audio
 
     def video node
       xml = @xml_mode
-      id_attribute = node.id ? %( id="#{node.id}") : nil
+      id_attribute = node.id ? %( id="#{node.id}") : ''
       classes = ['videoblock', node.role].compact
       class_attribute = %( class="#{classes * ' '}")
-      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : nil
-      width_attribute = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : nil
-      height_attribute = (node.attr? 'height') ? %( height="#{node.attr 'height'}") : nil
+      title_element = node.title? ? %(\n<div class="title">#{node.title}</div>) : ''
+      width_attribute = (node.attr? 'width') ? %( width="#{node.attr 'width'}") : ''
+      height_attribute = (node.attr? 'height') ? %( height="#{node.attr 'height'}") : ''
       case node.attr 'poster'
       when 'vimeo'
         unless (asset_uri_scheme = (node.document.attr 'asset-uri-scheme', 'https')).empty?
           asset_uri_scheme = %(#{asset_uri_scheme}:)
         end
-        start_anchor = (node.attr? 'start', nil, false) ? %(#at=#{node.attr 'start'}) : nil
+        start_anchor = (node.attr? 'start', nil, false) ? %(#at=#{node.attr 'start'}) : ''
         delimiter = '?'
-        autoplay_param = (node.option? 'autoplay') ? %(#{delimiter}autoplay=1) : nil
-        delimiter = '&amp;' if autoplay_param
-        loop_param = (node.option? 'loop') ? %(#{delimiter}loop=1) : nil
+        if node.option? 'autoplay'
+          autoplay_param = %(#{delimiter}autoplay=1)
+          delimiter = '&amp;'
+        else
+          autoplay_param = ''
+        end
+        loop_param = (node.option? 'loop') ? %(#{delimiter}loop=1) : ''
         %(<div#{id_attribute}#{class_attribute}>#{title_element}
 <div class="content">
-<iframe#{width_attribute}#{height_attribute} src="#{asset_uri_scheme}//player.vimeo.com/video/#{node.attr 'target'}#{start_anchor}#{autoplay_param}#{loop_param}" frameborder="0"#{(node.option? 'nofullscreen') ? nil : (append_boolean_attribute 'allowfullscreen', xml)}></iframe>
+<iframe#{width_attribute}#{height_attribute} src="#{asset_uri_scheme}//player.vimeo.com/video/#{node.attr 'target'}#{start_anchor}#{autoplay_param}#{loop_param}" frameborder="0"#{(node.option? 'nofullscreen') ? '' : (append_boolean_attribute 'allowfullscreen', xml)}></iframe>
 </div>
 </div>)
       when 'youtube'
@@ -968,22 +978,22 @@ Your browser does not support the audio
         end
         rel_param_val = (node.option? 'related') ? 1 : 0
         # NOTE start and end must be seconds (t parameter allows XmYs where X is minutes and Y is seconds)
-        start_param = (node.attr? 'start', nil, false) ? %(&amp;start=#{node.attr 'start'}) : nil
-        end_param = (node.attr? 'end', nil, false) ? %(&amp;end=#{node.attr 'end'}) : nil
-        autoplay_param = (node.option? 'autoplay') ? '&amp;autoplay=1' : nil
-        loop_param = (node.option? 'loop') ? '&amp;loop=1' : nil
-        controls_param = (node.option? 'nocontrols') ? '&amp;controls=0' : nil
+        start_param = (node.attr? 'start', nil, false) ? %(&amp;start=#{node.attr 'start'}) : ''
+        end_param = (node.attr? 'end', nil, false) ? %(&amp;end=#{node.attr 'end'}) : ''
+        autoplay_param = (node.option? 'autoplay') ? '&amp;autoplay=1' : ''
+        loop_param = (has_loop_param = node.option? 'loop') ? '&amp;loop=1' : ''
+        controls_param = (node.option? 'nocontrols') ? '&amp;controls=0' : ''
         # cover both ways of controlling fullscreen option
         if node.option? 'nofullscreen'
           fs_param = '&amp;fs=0'
-          fs_attribute = nil
+          fs_attribute = ''
         else
-          fs_param = nil
+          fs_param = ''
           fs_attribute = append_boolean_attribute 'allowfullscreen', xml
         end
-        modest_param = (node.option? 'modest') ? '&amp;modestbranding=1' : nil
-        theme_param = (node.attr? 'theme', nil, false) ? %(&amp;theme=#{node.attr 'theme'}) : nil
-        hl_param = (node.attr? 'lang') ? %(&amp;hl=#{node.attr 'lang'}) : nil
+        modest_param = (node.option? 'modest') ? '&amp;modestbranding=1' : ''
+        theme_param = (node.attr? 'theme', nil, false) ? %(&amp;theme=#{node.attr 'theme'}) : ''
+        hl_param = (node.attr? 'lang') ? %(&amp;hl=#{node.attr 'lang'}) : ''
 
         # parse video_id/list_id syntax where list_id (i.e., playlist) is optional
         target, list = (node.attr 'target').split '/', 2
@@ -997,7 +1007,7 @@ Your browser does not support the audio
             list_param = %(&amp;playlist=#{playlist})
           else
             # NOTE for loop to work, playlist must be specified; use VIDEO_ID if there's no explicit playlist
-            list_param = loop_param ? %(&amp;playlist=#{target}) : nil
+            list_param = has_loop_param ? %(&amp;playlist=#{target}) : ''
           end
         end
 
@@ -1007,14 +1017,14 @@ Your browser does not support the audio
 </div>
 </div>)
       else
-        poster_attribute = (val = node.attr 'poster', nil, false).nil_or_empty? ? nil : %( poster="#{node.media_uri val}")
-        preload_attribute = (val = node.attr 'preload', nil, false).nil_or_empty? ? nil : %( preload="#{val}")
+        poster_attribute = (val = node.attr 'poster', nil, false).nil_or_empty? ? '' : %( poster="#{node.media_uri val}")
+        preload_attribute = (val = node.attr 'preload', nil, false).nil_or_empty? ? '' : %( preload="#{val}")
         start_t = node.attr 'start', nil, false
         end_t = node.attr 'end', nil, false
-        time_anchor = (start_t || end_t) ? %(#t=#{start_t}#{end_t ? ',' : nil}#{end_t}) : nil
+        time_anchor = (start_t || end_t) ? %(#t=#{start_t || ''}#{end_t ? ",#{end_t}" : ''}) : ''
         %(<div#{id_attribute}#{class_attribute}>#{title_element}
 <div class="content">
-<video src="#{node.media_uri(node.attr 'target')}#{time_anchor}"#{width_attribute}#{height_attribute}#{poster_attribute}#{(node.option? 'autoplay') ? (append_boolean_attribute 'autoplay', xml) : nil}#{(node.option? 'nocontrols') ? nil : (append_boolean_attribute 'controls', xml)}#{(node.option? 'loop') ? (append_boolean_attribute 'loop', xml) : nil}#{preload_attribute}>
+<video src="#{node.media_uri(node.attr 'target')}#{time_anchor}"#{width_attribute}#{height_attribute}#{poster_attribute}#{(node.option? 'autoplay') ? (append_boolean_attribute 'autoplay', xml) : ''}#{(node.option? 'nocontrols') ? '' : (append_boolean_attribute 'controls', xml)}#{(node.option? 'loop') ? (append_boolean_attribute 'loop', xml) : ''}#{preload_attribute}>
 Your browser does not support the video tag.
 </video>
 </div>
@@ -1025,29 +1035,34 @@ Your browser does not support the video
     def inline_anchor node
       case node.type
       when :xref
-        unless (text = node.text) || (text = node.attributes['path'])
-          if AbstractNode === (ref = node.document.catalog[:refs][refid = node.attributes['refid']])
-            text = ref.xreftext((@xrefstyle ||= node.document.attributes['xrefstyle'])) || %([#{refid}])
-          else
-            text = %([#{refid}])
+        if (path = node.attributes['path'])
+          attrs = (append_link_constraint_attrs node, node.role ? [%( class="#{node.role}")] : []).join
+          text = node.text || path
+        else
+          attrs = node.role ? %( class="#{node.role}") : ''
+          unless (text = node.text)
+            refid = node.attributes['refid']
+            if AbstractNode === (ref = (@refs ||= node.document.catalog[:refs])[refid])
+              text = (ref.xreftext node.attr('xrefstyle')) || %([#{refid}])
+            else
+              text = %([#{refid}])
+            end
           end
         end
-        %(<a href="#{node.target}">#{text}</a>)
+        %(<a href="#{node.target}"#{attrs}>#{text}</a>)
       when :ref
         %(<a id="#{node.id}"></a>)
       when :link
         attrs = node.id ? [%( id="#{node.id}")] : []
-        if (role = node.role)
-          attrs << %( class="#{role}")
-        end
+        attrs << %( class="#{node.role}") if node.role
         attrs << %( title="#{node.attr 'title'}") if node.attr? 'title', nil, false
-        attrs << %( target="#{window = node.attr 'window'}"#{window == '_blank' || (node.option? 'noopener') ? ' rel="noopener"' : ''}) if node.attr? 'window', nil, false
-        %(<a href="#{node.target}"#{attrs.join}>#{node.text}</a>)
+        %(<a href="#{node.target}"#{(append_link_constraint_attrs node, attrs).join}>#{node.text}</a>)
       when :bibref
         # NOTE technically node.text should be node.reftext, but subs have already been applied to text
         %(<a id="#{node.id}"></a>#{node.text})
       else
-        warn %(asciidoctor: WARNING: unknown anchor type: #{node.type.inspect})
+        logger.warn %(unknown anchor type: #{node.type.inspect})
+        nil
       end
     end
 
@@ -1073,10 +1088,10 @@ Your browser does not support the video
     def inline_footnote node
       if (index = node.attr 'index', nil, false)
         if node.type == :xref
-          %(<sup class="footnoteref">[<a class="footnote" href="#_footnote_#{index}" title="View footnote.">#{index}</a>]</sup>)
+          %(<sup class="footnoteref">[<a class="footnote" href="#_footnotedef_#{index}" title="View footnote.">#{index}</a>]</sup>)
         else
-          id_attr = node.id ? %( id="_footnote_#{node.id}") : nil
-          %(<sup class="footnote"#{id_attr}>[<a id="_footnoteref_#{index}" class="footnote" href="#_footnote_#{index}" title="View footnote.">#{index}</a>]</sup>)
+          id_attr = node.id ? %( id="_footnote_#{node.id}") : ''
+          %(<sup class="footnote"#{id_attr}>[<a id="_footnoteref_#{index}" class="footnote" href="#_footnotedef_#{index}" title="View footnote.">#{index}</a>]</sup>)
         end
       elsif node.type == :xref
         %(<sup class="footnoteref red" title="Unresolved footnote reference.">[#{node.text}]</sup>)
@@ -1089,13 +1104,13 @@ Your browser does not support the video
         {'size' => 'fa-', 'rotate' => 'fa-rotate-', 'flip' => 'fa-flip-'}.each do |key, prefix|
           class_attr_val = %(#{class_attr_val} #{prefix}#{node.attr key}) if node.attr? key
         end
-        title_attr = (node.attr? 'title') ? %( title="#{node.attr 'title'}") : nil
+        title_attr = (node.attr? 'title') ? %( title="#{node.attr 'title'}") : ''
         img = %(<i class="#{class_attr_val}"#{title_attr}></i>)
       elsif type == 'icon' && !(node.document.attr? 'icons')
         img = %([#{node.alt}])
       else
         target = node.target
-        attrs = ['width', 'height', 'title'].map {|name| (node.attr? name) ? %( #{name}="#{node.attr name}") : nil }.join
+        attrs = ['width', 'height', 'title'].map {|name| (node.attr? name) ? %( #{name}="#{node.attr name}") : '' }.join
         if type != 'icon' && ((node.attr? 'format', 'svg', false) || (target.include? '.svg')) &&
             node.document.safe < SafeMode::SECURE && ((svg = (node.option? 'inline')) || (obj = (node.option? 'interactive')))
           if svg
@@ -1107,12 +1122,11 @@ Your browser does not support the video
         end
         img ||= %(<img src="#{type == 'icon' ? (node.icon_uri target) : (node.image_uri target)}" alt="#{encode_quotes node.alt}"#{attrs}#{@void_element_slash}>)
       end
-      if node.attr? 'link'
-        window_attr = %( target="#{window = node.attr 'window'}"#{window == '_blank' || (node.option? 'noopener') ? ' rel="noopener"' : ''}) if node.attr? 'window'
-        img = %(<a class="image" href="#{node.attr 'link'}"#{window_attr}>#{img}</a>)
+      if node.attr? 'link', nil, false
+        img = %(<a class="image" href="#{node.attr 'link'}"#{(append_link_constraint_attrs node).join}>#{img}</a>)
       end
       class_attr_val = (role = node.role) ? %(#{type} #{role}) : type
-      style_attr = (node.attr? 'float') ? %( style="float: #{node.attr 'float'}") : nil
+      style_attr = (node.attr? 'float') ? %( style="float: #{node.attr 'float'}") : ''
       %(<span class="#{class_attr_val}"#{style_attr}>#{img}</span>)
     end
 
@@ -1145,17 +1159,17 @@ Your browser does not support the video
 
     def inline_quoted node
       open, close, is_tag = QUOTE_TAGS[node.type]
-      if node.role
+      class_attr = %( class="#{node.role}") if node.role
+      id_attr = %( id="#{node.id}") if node.id
+      if class_attr || id_attr
         if is_tag
-          quoted_text = %(#{open.chop} class="#{node.role}">#{node.text}#{close})
+          %(#{open.chop}#{id_attr || ''}#{class_attr || ''}>#{node.text}#{close})
         else
-          quoted_text = %(<span class="#{node.role}">#{open}#{node.text}#{close}</span>)
+          %(<span#{id_attr || ''}#{class_attr || ''}>#{open}#{node.text}#{close}</span>)
         end
       else
-        quoted_text = %(#{open}#{node.text}#{close})
+        %(#{open}#{node.text}#{close})
       end
-
-      node.id ? %(<a id="#{node.id}"></a>#{quoted_text}) : quoted_text
     end
 
     def append_boolean_attribute name, xml
@@ -1166,6 +1180,29 @@ Your browser does not support the video
       (val.include? '"') ? (val.gsub '"', '&quot;') : val
     end
 
+    def generate_manname_section node
+      manname_title = (node.attr 'manname-title') || 'Name'
+      if (next_section = node.sections[0]) && (next_section_title = next_section.title) == next_section_title.upcase
+        manname_title = manname_title.upcase
+      end
+      manname_id_attr = (manname_id = node.attr 'manname-id') ? %( id="#{manname_id}") : ''
+      %(<h2#{manname_id_attr}>#{manname_title}</h2>
+<div class="sectionbody">
+<p>#{node.attr 'manname'} - #{node.attr 'manpurpose'}</p>
+</div>)
+    end
+
+    def append_link_constraint_attrs node, attrs = []
+      rel = 'nofollow' if node.option? 'nofollow'
+      if (window = node.attributes['window'])
+        attrs << %( target="#{window}")
+        attrs << (rel ? %( rel="#{rel} noopener") : ' rel="noopener"') if window == '_blank' || (node.option? 'noopener')
+      elsif rel
+        attrs << %( rel="#{rel}")
+      end
+      attrs
+    end
+
     def read_svg_contents node, target
       if (svg = node.read_contents target, :start => (node.document.attr 'imagesdir'), :normalize => true, :label => 'SVG')
         svg = svg.sub SvgPreambleRx, '' unless svg.start_with? '<svg'
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/manpage.rb 1.5.7-1/lib/asciidoctor/converter/manpage.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/manpage.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/manpage.rb	2018-05-05 22:54:38.000000000 +0000
@@ -18,7 +18,7 @@ module Asciidoctor
     LeadingPeriodRx = /^\./
     EscapedMacroRx = /^(?:#{ESC}\\c\n)?#{ESC}\.((?:URL|MTO) ".*?" ".*?" )( |[^\s]*)(.*?)(?: *#{ESC}\\c)?$/
     MockBoundaryRx = /<\/?BOUNDARY>/
-    EmDashCharRefRx = /&#8212(?:;&#8203;)?/
+    EmDashCharRefRx = /&#8212;(?:&#8203;)?/
     EllipsisCharRefRx = /&#8230;(?:&#8203;)?/
 
     # Converts HTML entity references back to their original form, escapes
@@ -57,6 +57,7 @@ module Asciidoctor
         gsub('&#8656;', '\(lA').  # leftwards double arrow
         gsub('&#8658;', '\(rA').  # rightwards double arrow
         gsub('&#8203;', '\:').    # zero width space
+        gsub('&amp;','&').        # literal ampersand (NOTE must take place after any other replacement that includes &)
         gsub('\'', '\(aq').       # apostrophe-quote
         gsub(MockBoundaryRx, ''). # mock boundary
         gsub(ESC_BS, '\\').       # unescape troff backslash (NOTE update if more escapes are added)
@@ -66,7 +67,7 @@ module Asciidoctor
     end
 
     def skip_with_warning node, name = nil
-      warn %(asciidoctor: WARNING: converter missing for #{name || node.node_name} node in manpage backend)
+      logger.warn %(converter missing for #{name || node.node_name} node in manpage backend)
       nil
     end
 
@@ -81,7 +82,7 @@ module Asciidoctor
       # NOTE the first line enables the table (tbl) preprocessor, necessary for non-Linux systems
       result = [%('\\" t
 .\\"     Title: #{mantitle}
-.\\"    Author: #{(node.attr? 'authors') ? (node.attr 'authors') : '[see the "AUTHORS" section]'}
+.\\"    Author: #{(node.attr? 'authors') ? (node.attr 'authors') : '[see the "AUTHOR(S)" section]'}
 .\\" Generator: Asciidoctor #{node.attr 'asciidoctor-version'})]
       result << %(.\\"      Date: #{docdate}) if docdate
       result << %(.\\"    Manual: #{(manual = node.attr 'manmanual') || '\ \&'}
@@ -105,22 +106,33 @@ module Asciidoctor
       # define URL macro for portability
       # see http://web.archive.org/web/20060102165607/http://people.debian.org/~branden/talks/wtfm/wtfm.pdf
       #
-      # Use: .URL "http://www.debian.org" "Debian" "."
+      # Usage
+      #
+      # .URL "http://www.debian.org" "Debian" "."
       #
       # * First argument: the URL
       # * Second argument: text to be hyperlinked
-      # * Third (optional) argument: text that needs to immediately trail
-      #   the hyperlink without intervening whitespace
+      # * Third (optional) argument: text that needs to immediately trail the hyperlink without intervening whitespace
       result << '.de URL
-\\\\$2 \(laURL: \\\\$1 \(ra\\\\$3
+\\fI\\\\$2\\fP <\\\\$1>\\\\$3
 ..
-.if \n[.g] .mso www.tmac'
-      result << %(.LINKSTYLE #{node.attr 'man-linkstyle', 'blue R < >'})
+.als MTO URL
+.if \n[.g] \{\
+.  mso www.tmac
+.  am URL
+.    ad l
+.  .
+.  am MTO
+.    ad l
+.  .'
+      result << %(.  LINKSTYLE #{node.attr 'man-linkstyle', 'blue R < >'})
+      result << '.\}'
 
       unless node.noheader
         if node.attr? 'manpurpose'
-          result << %(.SH "#{node.attr 'manname-title'}"
-#{manify mantitle} \\- #{manify node.attr 'manpurpose'})
+          mannames = node.attr 'mannames', [manname]
+          result << %(.SH "#{(node.attr 'manname-title').upcase}"
+#{mannames.map {|n| manify n } * ', '} \\- #{manify node.attr 'manpurpose'})
         end
       end
 
@@ -132,14 +144,19 @@ module Asciidoctor
         result.concat(node.footnotes.map {|fn| %(#{fn.index}. #{fn.text}) })
       end
 
-      # FIXME detect single author and use appropriate heading; itemize the authors if multiple
-      if node.attr? 'authors'
-        result << %(.SH "AUTHOR(S)"
+      # FIXME we really need an API that returns the authors as an array
+      if (num_authors = (node.attr 'authorcount') || 0) > 0
+        if num_authors == 1
+          result << %(.SH "AUTHOR"
 .sp
-\\fB#{node.attr 'authors'}\\fP
-.RS 4
-Author(s).
-.RE)
+#{node.attr 'author'})
+        else
+          result << '.SH "AUTHORS"'
+          (1.upto num_authors).each do |i|
+            result << %(.sp
+#{node.attr "author_#{i}"})
+          end
+        end
       end
 
       result * LF
@@ -176,16 +193,14 @@ Author(s).
 
     def admonition node
       result = []
-      result << %(.if n \\{\\
-.sp
-.\\}
+      result << %(.if n .sp
 .RS 4
 .it 1 an-trap
 .nr an-no-space-flag 1
 .nr an-break-flag 1
 .br
 .ps +1
-.B #{node.attr 'textlabel'}#{node.title? ? "\\fP: #{manify node.title}" : nil}
+.B #{node.attr 'textlabel'}#{node.title? ? "\\fP: #{manify node.title}" : ''}
 .ps -1
 .br
 #{resolve_content node}
@@ -216,10 +231,12 @@ r lw(\n(.lu*75u/100u).'
       result * LF
     end
 
-    # TODO implement title for dlist
     # TODO implement horizontal (if it makes sense)
     def dlist node
       result = []
+      result << %(.sp
+.B #{manify node.title}
+.br) if node.title?
       counter = 0
       node.items.each do |terms, dd|
         counter += 1
@@ -265,15 +282,11 @@ r lw(\n(.lu*75u/100u).'
 .B #{manify node.captioned_title}
 .br) if node.title?
       result << %(.sp
-.if n \\{\\
-.RS 4
-.\\}
+.if n .RS 4
 .nf
 #{manify node.content}
 .fi
-.if n \\{\\
-.RE
-.\\})
+.if n .RE)
       result * LF
     end
 
@@ -283,15 +296,11 @@ r lw(\n(.lu*75u/100u).'
 .B #{manify node.title}
 .br) if node.title?
       result << %(.sp
-.if n \\{\\
-.RS 4
-.\\}
+.if n .RS 4
 .nf
 #{manify node.content}
 .fi
-.if n \\{\\
-.RE
-.\\})
+.if n .RE)
       result * LF
     end
 
@@ -308,8 +317,8 @@ r lw(\n(.lu*75u/100u).'
 \\h'-04' #{idx + 1}.\\h'+01'\\c
 .\\}
 .el \\{\\
-.sp -1
-.IP " #{idx + 1}." 4.2
+.  sp -1
+.  IP " #{idx + 1}." 4.2
 .\\}
 #{manify item.text})
         result << item.content if item.blocks?
@@ -378,7 +387,7 @@ r lw(\n(.lu*75u/100u).'
     def stem node
       title_element = node.title? ? %(.sp
 .B #{manify node.title}
-.br) : nil
+.br) : ''
       open, close = BLOCK_MATH_DELIMITERS[node.style.to_sym]
 
       unless ((equation = node.content).start_with? open) && (equation.end_with? close)
@@ -538,8 +547,8 @@ allbox tab(:);'
 \\h'-04'\\(bu\\h'+03'\\c
 .\\}
 .el \\{\\
-.sp -1
-.IP \\(bu 2.3
+.  sp -1
+.  IP \\(bu 2.3
 .\\}
 #{manify item.text}]
         result << item.content if item.blocks?
@@ -574,8 +583,8 @@ allbox tab(:);'
     end
 
     def video node
-      start_param = (node.attr? 'start', nil, false) ? %(&start=#{node.attr 'start'}) : nil
-      end_param = (node.attr? 'end', nil, false) ? %(&end=#{node.attr 'end'}) : nil
+      start_param = (node.attr? 'start', nil, false) ? %(&start=#{node.attr 'start'}) : ''
+      end_param = (node.attr? 'end', nil, false) ? %(&end=#{node.attr 'end'}) : ''
       result = []
       result << %(.sp
 .B #{manify node.title}
@@ -588,17 +597,18 @@ allbox tab(:);'
       target = node.target
       case node.type
       when :link
-        if (text = node.text) == target
-          text = nil
-        else
-          text = text.gsub '"', %[#{ESC_BS}(dq]
-        end
         if target.start_with? 'mailto:'
           macro = 'MTO'
-          target = target[7..-1].sub '@', %[#{ESC_BS}(at]
+          target = target.slice 7, target.length
         else
           macro = 'URL'
         end
+        if (text = node.text) == target
+          text = ''
+        else
+          text = text.gsub '"', %[#{ESC_BS}(dq]
+        end
+        target = target.sub '@', %[#{ESC_BS}(at] if macro == 'MTO'
         %(#{ESC_BS}c#{LF}#{ESC_FS}#{macro} "#{target}" "#{text}" )
       when :xref
         refid = (node.attr 'refid') || target
@@ -607,7 +617,8 @@ allbox tab(:);'
         # These are anchor points, which shouldn't be visible
         ''
       else
-        warn %(asciidoctor: WARNING: unknown anchor type: #{node.type.inspect})
+        logger.warn %(unknown anchor type: #{node.type.inspect})
+        nil
       end
     end
 
@@ -669,7 +680,7 @@ allbox tab(:);'
       when :strong
         %(#{ESC_BS}fB<BOUNDARY>#{node.text}</BOUNDARY>#{ESC_BS}fP)
       when :monospaced
-        %(#{ESC_BS}f[CR]<BOUNDARY>#{node.text}</BOUNDARY>#{ESC_BS}fP)
+        %[#{ESC_BS}f(CR<BOUNDARY>#{node.text}</BOUNDARY>#{ESC_BS}fP]
       when :single
         %[#{ESC_BS}(oq<BOUNDARY>#{node.text}</BOUNDARY>#{ESC_BS}(cq]
       when :double
@@ -682,5 +693,16 @@ allbox tab(:);'
     def resolve_content node
       node.content_model == :compound ? node.content : %(.sp#{LF}#{manify node.content})
     end
+
+    def write_alternate_pages mannames, manvolnum, target
+      if mannames && mannames.size > 1
+        mannames.shift
+        manvolext = %(.#{manvolnum})
+        dir, basename = ::File.split target
+        mannames.each do |manname|
+          ::IO.write ::File.join(dir, %(#{manname}#{manvolext})), %(.so #{basename})
+        end
+      end
+    end
   end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter/template.rb 1.5.7-1/lib/asciidoctor/converter/template.rb
--- 1.5.6.2-2/lib/asciidoctor/converter/template.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter/template.rb	2018-05-05 22:54:38.000000000 +0000
@@ -39,8 +39,6 @@ module Asciidoctor
       @caches = { :scans => ::ThreadSafe::Cache.new, :templates => ::ThreadSafe::Cache.new }
     rescue ::LoadError
       @caches = { :scans => {}, :templates => {} }
-      # FIXME perhaps only warn if the cache option is enabled (meaning not disabled)?
-      warn 'asciidoctor: WARNING: gem \'thread_safe\' is not installed. This gem is recommended when using custom backend templates.'
     end
 
     def self.caches
@@ -77,6 +75,7 @@ module Asciidoctor
       end
       case opts[:template_cache]
       when true
+        logger.warn 'gem \'thread_safe\' is not installed. This gem is recommended when using the built-in template cache.' unless defined? ::ThreadSafe
         @caches = self.class.caches
       when ::Hash
         @caches = opts[:template_cache]
@@ -105,24 +104,25 @@ module Asciidoctor
       engine = @engine
       @template_dirs.each do |template_dir|
         # FIXME need to think about safe mode restrictions here
-        next unless ::File.directory?(template_dir = (path_resolver.system_path template_dir, nil))
+        next unless ::File.directory?(template_dir = (path_resolver.system_path template_dir))
 
-        # NOTE last matching template wins for template name if no engine is given
-        file_pattern = '*'
         if engine
           file_pattern = %(*.#{engine})
           # example: templates/haml
-          if ::File.directory?(engine_dir = (::File.join template_dir, engine))
+          if ::File.directory?(engine_dir = %(#{template_dir}/#{engine}))
             template_dir = engine_dir
           end
+        else
+          # NOTE last matching template wins for template name if no engine is given
+          file_pattern = '*'
         end
 
-        # example: templates/html5 or templates/haml/html5
-        if ::File.directory?(backend_dir = (::File.join template_dir, backend))
+        # example: templates/html5 (engine not set) or templates/haml/html5 (engine set)
+        if ::File.directory?(backend_dir = %(#{template_dir}/#{backend}))
           template_dir = backend_dir
         end
 
-        pattern = ::File.join template_dir, file_pattern
+        pattern = %(#{template_dir}/#{file_pattern})
 
         if (scan_cache = @caches[:scans])
           template_cache = @caches[:templates]
@@ -161,7 +161,7 @@ module Asciidoctor
         end
       else
         metaclass.send :define_method, name do |node|
-          (template.render node).chomp
+          (template.render node).rstrip
         end
       end
     end
@@ -193,7 +193,7 @@ module Asciidoctor
       if template_name == 'document'
         (template.render node, opts).strip
       else
-        (template.render node, opts).chomp
+        (template.render node, opts).rstrip
       end
     end
 
@@ -280,7 +280,7 @@ module Asciidoctor
         end
         result[name] = template
       end
-      if helpers || ::File.file?(helpers = (::File.join template_dir, 'helpers.rb'))
+      if helpers || ::File.file?(helpers = %(#{template_dir}/helpers.rb))
         require helpers
       end
       result
diff -pruN 1.5.6.2-2/lib/asciidoctor/converter.rb 1.5.7-1/lib/asciidoctor/converter.rb
--- 1.5.6.2-2/lib/asciidoctor/converter.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/converter.rb	2018-05-05 22:54:38.000000000 +0000
@@ -20,7 +20,7 @@ module Asciidoctor
   #       super
   #       outfilesuffix '.txt'
   #     end
-  #     def convert node, transform = nil
+  #     def convert node, transform = nil, opts = {}
   #       case (transform ||= node.node_name)
   #       when 'document'
   #         node.content
@@ -86,44 +86,52 @@ module Asciidoctor
           syntax = 'html'
         end
         {
-          'basebackend' => base,
-          'outfilesuffix' => ext,
-          'filetype' => type,
-          'htmlsyntax' => syntax
+          :basebackend => base,
+          :outfilesuffix => ext,
+          :filetype => type,
+          :htmlsyntax => syntax
         }
       end
 
       def filetype value = nil
         if value
-          backend_info['filetype'] = value
+          backend_info[:filetype] = value
         else
-          backend_info['filetype']
+          backend_info[:filetype]
         end
       end
 
       def basebackend value = nil
         if value
-          backend_info['basebackend'] = value
+          backend_info[:basebackend] = value
         else
-          backend_info['basebackend']
+          backend_info[:basebackend]
         end
       end
 
       def outfilesuffix value = nil
         if value
-          backend_info['outfilesuffix'] = value
+          backend_info[:outfilesuffix] = value
         else
-          backend_info['outfilesuffix']
+          backend_info[:outfilesuffix]
         end
       end
 
       def htmlsyntax value = nil
         if value
-          backend_info['htmlsyntax'] = value
+          backend_info[:htmlsyntax] = value
         else
-          backend_info['htmlsyntax']
+          backend_info[:htmlsyntax]
         end
       end
+
+      def supports_templates
+        backend_info[:supports_templates] = true
+      end
+
+      def supports_templates?
+        backend_info[:supports_templates]
+      end
     end
 
     class << self
@@ -183,6 +191,8 @@ module Asciidoctor
       raise ::NotImplementedError
     end
 
+    alias handles? respond_to?
+
     # Alias for backward compatibility.
     alias convert_with_options convert
   end
diff -pruN 1.5.6.2-2/lib/asciidoctor/core_ext/1.8.7/base64/strict_encode64.rb 1.5.7-1/lib/asciidoctor/core_ext/1.8.7/base64/strict_encode64.rb
--- 1.5.6.2-2/lib/asciidoctor/core_ext/1.8.7/base64/strict_encode64.rb	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/core_ext/1.8.7/base64/strict_encode64.rb	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,6 @@
+# Educate Ruby 1.8.7 about the Base64#strict_encode64 method.
+module Base64
+  def strict_encode64 bin
+    (self.encode64 bin).delete %(\n)
+  end
+end
diff -pruN 1.5.6.2-2/lib/asciidoctor/core_ext.rb 1.5.7-1/lib/asciidoctor/core_ext.rb
--- 1.5.6.2-2/lib/asciidoctor/core_ext.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/core_ext.rb	2018-05-05 22:54:38.000000000 +0000
@@ -2,8 +2,12 @@ require 'asciidoctor/core_ext/nil_or_emp
 require 'asciidoctor/core_ext/regexp/is_match'
 if RUBY_MIN_VERSION_1_9
   require 'asciidoctor/core_ext/string/limit_bytesize'
-  require 'asciidoctor/core_ext/1.8.7/io/write' if RUBY_ENGINE == 'opal'
+  if RUBY_ENGINE == 'opal'
+    require 'asciidoctor/core_ext/1.8.7/io/binread'
+    require 'asciidoctor/core_ext/1.8.7/io/write'
+  end
 elsif RUBY_ENGINE != 'opal'
+  require 'asciidoctor/core_ext/1.8.7/base64/strict_encode64'
   require 'asciidoctor/core_ext/1.8.7/hash/key'
   require 'asciidoctor/core_ext/1.8.7/io/binread'
   require 'asciidoctor/core_ext/1.8.7/io/write'
diff -pruN 1.5.6.2-2/lib/asciidoctor/document.rb 1.5.7-1/lib/asciidoctor/document.rb
--- 1.5.6.2-2/lib/asciidoctor/document.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/document.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,22 +1,85 @@
 # encoding: UTF-8
 module Asciidoctor
-# Public: Methods for parsing and converting AsciiDoc documents.
+# Public: The Document class represents a parsed AsciiDoc document.
 #
-# There are several strategies for getting the title of the document:
+# Document is the root node of a parsed AsciiDoc document. It provides an
+# abstract syntax tree (AST) that represents the structure of the AsciiDoc
+# document from which the Document object was parsed.
 #
-# doctitle - value of title attribute, if assigned and non-empty,
-#            otherwise title of first section in document, if present
-#            otherwise nil
-# name - an alias of doctitle
-# title - value of the title attribute, or nil if not present
-# first_section.title - title of first section in document, if present
-# header.title - title of section level 0
+# Although the constructor can be used to create an empty document object, more
+# commonly, you'll load the document object from AsciiDoc source using the
+# primary API methods, {Asciidoctor.load} or {Asciidoctor.load_file}. When
+# using one of these APIs, you almost always want to set the safe mode to
+# :safe (or :unsafe) to enable all of Asciidoctor's features.
 #
-# Keep in mind that you'll want to honor these document settings:
+#   Asciidoctor.load '= Hello, AsciiDoc!', safe: :safe
+#   # => Asciidoctor::Document { doctype: "article", doctitle: "Hello, Asciidoc!", blocks: 0 }
 #
-# notitle  - The h1 heading should not be shown
-# noheader - The header block (h1 heading, author, revision info) should not be shown
-# nofooter - the footer block should not be shown
+# Instances of this class can be used to extract information from the document
+# or alter its structure. As such, the Document object is most often used in
+# extensions and by integrations.
+#
+# The most basic usage of the Document object is to retrieve the document's
+# title.
+#
+#   source = '= Document Title'
+#   document = Asciidoctor.load source, safe: :safe
+#   document.doctitle
+#   # => 'Document Title'
+#
+# If the document has no title, the {Document#doctitle} method returns the
+# title of the first section. If that check falls through, you can have the
+# method return a fallback value (the value of the untitled-label attribute).
+#
+#   Asciidoctor.load('no doctitle', safe: :safe).doctitle use_fallback: true
+#   # => "Untitled"
+#
+# You can also use the Document object to access document attributes defined in
+# the header, such as the author and doctype.
+#
+#   source = '= Document Title
+#   Author Name
+#   :doctype: book'
+#   document = Asciidoctor.load source, safe: :safe
+#   document.author
+#   # => 'Author Name'
+#   document.doctype
+#   # => 'book'
+#
+# You can retrieve arbitrary document attributes defined in the header using
+# {Document#attr} or check for the existence of one using {Document#attr?}:
+#
+#   source = '= Asciidoctor
+#   :uri-project: https://asciidoctor.org'
+#   document = Asciidoctor.load source, safe: :safe
+#   document.attr 'uri-project'
+#   # => 'https://asciidoctor.org'
+#   document.attr? 'icons'
+#   # => false
+#
+# Starting at the Document object, you can begin walking the document tree using
+# the {Document#blocks} method:
+#
+#   source = 'paragraph contents
+#
+#   [sidebar]
+#   sidebar contents'
+#   doc = Asciidoctor.load source, safe: :safe
+#   doc.blocks.map {|block| block.context }
+#   # => [:paragraph, :sidebar]
+#
+# You can discover block nodes at any depth in the tree using the
+# {AbstractBlock#find_by} method.
+#
+#   source = '****
+#   paragraph in sidebar
+#   ****'
+#   doc = Asciidoctor.load source, safe: :safe
+#   doc.find_by(context: :paragraph).map {|block| block.context }
+#   # => [:paragraph]
+#
+# Loading a document object is the first step in the conversion process. You
+# can take the process to completion by calling the {Document#convert} method.
 class Document < AbstractBlock
 
   Footnote = ::Struct.new :index, :id, :text
@@ -134,9 +197,6 @@ class Document < AbstractBlock
   # Public: Get the Hash of document counters
   attr_reader :counters
 
-  # Public: Get the Hash of callouts
-  attr_reader :callouts
-
   # Public: Get the level-0 Section
   attr_reader :header
 
@@ -158,6 +218,9 @@ class Document < AbstractBlock
   # Public: Get the Reader associated with this document
   attr_reader :reader
 
+  # Public: Get/Set the PathResolver instance used to resolve paths in this Document.
+  attr_reader :path_resolver
+
   # Public: Get the Converter associated with this document
   attr_reader :converter
 
@@ -183,11 +246,11 @@ class Document < AbstractBlock
     if (parent_doc = options.delete :parent)
       @parent_document = parent_doc
       options[:base_dir] ||= parent_doc.base_dir
+      options[:catalog_assets] = true if parent_doc.options[:catalog_assets]
       @catalog = parent_doc.catalog.inject({}) do |accum, (key, table)|
         accum[key] = (key == :footnotes ? [] : table)
         accum
       end
-      @callouts = parent_doc.callouts
       # QUESTION should we support setting attribute in parent document from nested document?
       # NOTE we must dup or else all the assignments to the overrides clobbers the real attributes
       @attribute_overrides = attr_overrides = parent_doc.attributes.dup
@@ -199,6 +262,8 @@ class Document < AbstractBlock
       @safe = parent_doc.safe
       @attributes['compat-mode'] = '' if (@compat_mode = parent_doc.compat_mode)
       @sourcemap = parent_doc.sourcemap
+      @timings = nil
+      @path_resolver = parent_doc.path_resolver
       @converter = parent_doc.converter
       initialize_extensions = false
       @extensions = parent_doc.extensions
@@ -211,25 +276,33 @@ class Document < AbstractBlock
         :links => [],
         :images => [],
         :indexterms => [],
-        :includes => ::Set.new,
+        :callouts => Callouts.new,
+        :includes => {},
       }
-      @callouts = Callouts.new
       # copy attributes map and normalize keys
       # attribute overrides are attributes that can only be set from the commandline
       # a direct assignment effectively makes the attribute a constant
       # a nil value or name with leading or trailing ! will result in the attribute being unassigned
-      attr_overrides = {}
-      (options[:attributes] || {}).each do |key, value|
-        if key.start_with? '!'
-          key = key[1..-1]
-          value = nil
+      @attribute_overrides = attr_overrides = {}
+      (options[:attributes] || {}).each do |key, val|
+        if key.end_with? '@'
+          if key.start_with? '!'
+            key, val = (key.slice 1, key.length), false
+          elsif key.end_with? '!@'
+            key, val = (key.slice 0, key.length - 2), false
+          else
+            key, val = key.chop, %(#{val}@)
+          end
+        elsif key.start_with? '!'
+          key, val = (key.slice 1, key.length), val == '@' ? false : nil
         elsif key.end_with? '!'
-          key = key.chop
-          value = nil
+          key, val = key.chop, val == '@' ? false : nil
         end
-        attr_overrides[key.downcase] = value
+        attr_overrides[key.downcase] = val
+      end
+      if (to_file = options[:to_file])
+        attr_overrides['outfilesuffix'] = ::File.extname to_file
       end
-      @attribute_overrides = attr_overrides
       # safely resolve the safe mode from const, int or string
       if !(safe_mode = options[:safe])
         @safe = SafeMode::SECURE
@@ -246,6 +319,8 @@ class Document < AbstractBlock
       end
       @compat_mode = attr_overrides.key? 'compat-mode'
       @sourcemap = options[:sourcemap]
+      @timings = options.delete :timings
+      @path_resolver = PathResolver.new
       @converter = nil
       initialize_extensions = defined? ::Asciidoctor::Extensions
       @extensions = nil # initialize furthur down
@@ -292,9 +367,8 @@ class Document < AbstractBlock
     attrs['table-caption'] = 'Table'
     attrs['toc-title'] = 'Table of Contents'
     #attrs['preface-title'] = 'Preface'
-    attrs['manname-title'] = 'NAME'
     attrs['section-refsig'] = 'Section'
-    #attrs['part-refsig'] = 'Part'
+    attrs['part-refsig'] = 'Part'
     attrs['chapter-refsig'] = 'Chapter'
     attrs['appendix-caption'] = attrs['appendix-refsig'] = 'Appendix'
     attrs['untitled-label'] = 'Untitled'
@@ -327,7 +401,7 @@ class Document < AbstractBlock
     elsif attr_overrides['docdir']
       @base_dir = attr_overrides['docdir']
     else
-      #warn 'asciidoctor: WARNING: setting base_dir is recommended when working with string documents' unless nested?
+      #logger.warn 'setting base_dir is recommended when working with string documents' unless nested?
       @base_dir = attr_overrides['docdir'] = ::Dir.pwd
     end
 
@@ -354,10 +428,8 @@ class Document < AbstractBlock
       if @safe >= SafeMode::SECURE
         attr_overrides['max-attribute-value-size'] = 4096 unless attr_overrides.key? 'max-attribute-value-size'
         # assign linkcss (preventing css embedding) unless explicitly disabled from the commandline or API
-        # effectively the same has "has key 'linkcss' and value == nil"
-        unless attr_overrides.fetch('linkcss', '').nil?
-          attr_overrides['linkcss'] = ''
-        end
+        #attr_overrides['linkcss'] = (attr_overrides.fetch 'linkcss', '') || nil
+        attr_overrides['linkcss'] = '' unless attr_overrides.key? 'linkcss'
         # restrict document from enabling icons
         attr_overrides['icons'] ||= nil
       end
@@ -367,18 +439,16 @@ class Document < AbstractBlock
     @max_attribute_value_size = (size = (attr_overrides['max-attribute-value-size'] ||= nil)) ? size.to_i.abs : nil
 
     attr_overrides.delete_if do |key, val|
-      verdict = false
-      # a nil value undefines the attribute
-      if val.nil?
-        attrs.delete(key)
-      else
-        # a value ending in @ indicates this attribute does not override
-        # an attribute with the same key in the document souce
+      if val
+        # a value ending in @ allows document to override value
         if ::String === val && (val.end_with? '@')
-          val = val.chop
-          verdict = true
+          val, verdict = val.chop, true
         end
         attrs[key] = val
+      else
+        # a nil or false value both unset the attribute; only a nil value locks it
+        attrs.delete key
+        verdict = val == false
       end
       verdict
     end
@@ -393,6 +463,7 @@ class Document < AbstractBlock
       # don't need to do the extra processing within our own document
       # FIXME line info isn't reported correctly within include files in nested document
       @reader = Reader.new data, options[:cursor]
+      @source_location = @reader.cursor if @sourcemap
 
       # Now parse the lines in the reader into blocks
       # Eagerly parse (for now) since a subdocument is not a publicly accessible object
@@ -441,24 +512,24 @@ class Document < AbstractBlock
 
       # fallback directories
       attrs['stylesdir'] ||= '.'
-      attrs['iconsdir'] ||= ::File.join(attrs.fetch('imagesdir', './images'), 'icons')
+      attrs['iconsdir'] ||= %(#{attrs.fetch 'imagesdir', './images'}/icons)
 
       if initialize_extensions
         if (ext_registry = options[:extension_registry])
-          # QUESTION should we warn the value type of the option is not a registry or boolean?
-          unless Extensions::Registry === ext_registry || (::RUBY_ENGINE_JRUBY &&
+          # QUESTION should we warn if the value type of this option is not a registry
+          if Extensions::Registry === ext_registry || (::RUBY_ENGINE_JRUBY &&
               ::AsciidoctorJ::Extensions::ExtensionRegistry === ext_registry)
-            ext_registry = Extensions::Registry.new
+            @extensions = ext_registry.activate self
           end
         elsif ::Proc === (ext_block = options[:extensions])
-          ext_registry = Extensions.create(&ext_block)
-        else
-          ext_registry = Extensions::Registry.new
+          @extensions = Extensions.create(&ext_block).activate self
+        elsif !Extensions.groups.empty?
+          @extensions = Extensions::Registry.new.activate self
         end
-        @extensions = ext_registry.activate self
       end
 
       @reader = PreprocessorReader.new self, data, (Reader::Cursor.new attrs['docfile'], @base_dir), :normalize => true
+      @source_location = @reader.cursor if @sourcemap
     end
   end
 
@@ -481,6 +552,7 @@ class Document < AbstractBlock
       # create reader if data is provided (used when data is not known at the time the Document object is created)
       if data
         @reader = PreprocessorReader.new doc, data, (Reader::Cursor.new @attributes['docfile'], @base_dir), :normalize => true
+        @source_location = @reader.cursor if @sourcemap
       end
 
       if (exts = @parent_document ? nil : @extensions) && exts.preprocessors?
@@ -583,6 +655,10 @@ class Document < AbstractBlock
     @catalog[:footnotes]
   end
 
+  def callouts
+    @catalog[:callouts]
+  end
+
   def nested?
     @parent_document ? true : false
   end
@@ -609,14 +685,24 @@ class Document < AbstractBlock
     @attributes['basebackend'] == base
   end
 
-  # The title explicitly defined in the document attributes
+  # Public: Return the doctitle as a String
+  #
+  # Returns the resolved doctitle as a [String] or nil if a doctitle cannot be resolved
   def title
-    @attributes['title']
+    doctitle
   end
 
+  # Public: Set the title on the document header
+  #
+  # Set the title of the document header to the specified value. If the header
+  # does not exist, it is first created.
+  #
+  # title - the String title to assign as the title of the document header
+  #
+  # Returns the new [String] title assigned to the document header
   def title= title
     unless (sect = @header)
-      (sect = (@header = Section.new self, 0, false)).sectname = 'header'
+      (sect = (@header = Section.new self, 0)).sectname = 'header'
     end
     sect.title = title
   end
@@ -641,14 +727,12 @@ class Document < AbstractBlock
   # Returns the resolved title as a [Title] if the :partition option is passed or a [String] if not
   # or nil if no value can be resolved.
   def doctitle opts = {}
-    if !(val = @attributes['title'].nil_or_empty?)
-      val = title
-    elsif (sect = first_section)
-      val = sect.title
-    elsif opts[:use_fallback] && (val = @attributes['untitled-label'])
-      # use val set in condition
-    else
-      return
+    unless (val = @attributes['title'])
+      if (sect = first_section)
+        val = sect.title
+      elsif !(opts[:use_fallback] && (val = @attributes['untitled-label']))
+        return
+      end
     end
 
     if (separator = opts[:partition])
@@ -704,7 +788,7 @@ class Document < AbstractBlock
   #
   # Returns The parent Block
   def << block
-    enumerate_section block if block.context == :section
+    assign_numeral block if block.context == :section
     super
   end
 
@@ -800,9 +884,8 @@ class Document < AbstractBlock
 
   # Internal: Restore the attributes to the previously saved state (attributes in header)
   def restore_attributes
-    @callouts.rewind unless @parent_document
-    # QUESTION shouldn't this be a dup in case we convert again?
-    @attributes = @header_attributes
+    @catalog[:callouts].rewind unless @parent_document
+    @attributes.replace @header_attributes
   end
 
   # Internal: Delete any attributes stored for playback
@@ -914,7 +997,7 @@ class Document < AbstractBlock
       current_backend, current_basebackend, current_doctype = @backend, (attrs = @attributes)['basebackend'], @doctype
       if new_backend.start_with? 'xhtml'
         attrs['htmlsyntax'] = 'xml'
-        new_backend = new_backend[1..-1]
+        new_backend = new_backend.slice 1, new_backend.length
       elsif new_backend.start_with? 'html'
         attrs['htmlsyntax'] = 'html' unless attrs['htmlsyntax'] == 'xml'
       end
@@ -941,7 +1024,7 @@ class Document < AbstractBlock
       elsif @converter
         new_basebackend = new_backend.sub TrailingDigitsRx, ''
         if (new_outfilesuffix = DEFAULT_EXTENSIONS[new_basebackend])
-          new_filetype = new_outfilesuffix[1..-1]
+          new_filetype = new_outfilesuffix.slice 1, new_outfilesuffix.length
         else
           new_outfilesuffix, new_basebackend, new_filetype = '.html', 'html', 'html'
         end
@@ -1006,12 +1089,13 @@ class Document < AbstractBlock
   def create_converter
     converter_opts = {}
     converter_opts[:htmlsyntax] = @attributes['htmlsyntax']
-    template_dirs = if (template_dir = @options[:template_dir])
-      converter_opts[:template_dirs] = [template_dir]
+    if (template_dir = @options[:template_dir])
+      template_dirs = [template_dir]
     elsif (template_dirs = @options[:template_dirs])
-      converter_opts[:template_dirs] = template_dirs
+      template_dirs = Array template_dirs
     end
     if template_dirs
+      converter_opts[:template_dirs] = template_dirs
       converter_opts[:template_cache] = @options.fetch :template_cache, true
       converter_opts[:template_engine] = @options[:template_engine]
       converter_opts[:template_engine_options] = @options[:template_engine_options]
@@ -1033,9 +1117,8 @@ class Document < AbstractBlock
   # loaded by the Converter. If a :template_dir is not specified,
   # or a template is missing, the converter will fall back to
   # using the appropriate built-in template.
-  #--
-  # QUESTION should we dup @header_attributes before converting?
   def convert opts = {}
+    @timings.start :convert if @timings
     parse unless @parsed
     unless @safe >= SafeMode::SERVER || opts.empty?
       # QUESTION should we store these on the Document object?
@@ -1046,9 +1129,9 @@ class Document < AbstractBlock
     # QUESTION should we add extensions that execute before conversion begins?
 
     if doctype == 'inline'
-      if (block = @blocks[0])
+      if (block = @blocks[0] || @header)
         if block.content_model == :compound || block.content_model == :empty
-          warn %(asciidoctor: WARNING: no inline candidate; use the inline doctype to convert a single paragragh, verbatim, or raw block)
+          logger.warn 'no inline candidate; use the inline doctype to convert a single paragragh, verbatim, or raw block'
         else
           output = block.content
         end
@@ -1066,6 +1149,7 @@ class Document < AbstractBlock
       end
     end
 
+    @timings.record :convert if @timings
     output
   end
 
@@ -1076,7 +1160,10 @@ class Document < AbstractBlock
   #
   # If the converter responds to :write, delegate the work of writing the file
   # to that method. Otherwise, write the output the specified file.
+  #
+  # Returns nothing
   def write output, target
+    @timings.start :write if @timings
     if Writer === @converter
       @converter.write output, target
     else
@@ -1089,8 +1176,12 @@ class Document < AbstractBlock
       else
         ::IO.write target, output
       end
-      nil
+      if @backend == 'manpage' && ::String === target && (@converter.respond_to? :write_alternate_pages)
+        @converter.write_alternate_pages @attributes['mannames'], @attributes['manvolnum'], target
+      end
     end
+    @timings.record :write if @timings
+    nil
   end
 
 =begin
diff -pruN 1.5.6.2-2/lib/asciidoctor/extensions.rb 1.5.7-1/lib/asciidoctor/extensions.rb
--- 1.5.6.2-2/lib/asciidoctor/extensions.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/extensions.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,3 +1,6 @@
+# NOTE .to_s hides require from Opal
+require 'asciidoctor'.to_s unless defined? Asciidoctor
+
 # encoding: UTF-8
 module Asciidoctor
 # Extensions provide a way to participate in the parsing and converting
@@ -107,37 +110,46 @@ module Extensions
     # opts   - An optional Hash of options (default: {}):
     #          :level    - [Integer] The level to assign to this section; defaults to
     #                      one greater than the parent level (optional).
-    #          :numbered - [Boolean] A flag to force numbering, which falls back to the 
+    #          :numbered - [Boolean] A flag to force numbering, which falls back to the
     #                      state of the sectnums document attribute (optional).
     #
     # Returns a [Section] node with all properties properly initialized.
     def create_section parent, title, attrs, opts = {}
       doc = parent.document
-      doctype, level = doc.doctype, (opts[:level] || parent.level + 1)
+      book = (doctype = doc.doctype) == 'book'
+      level = opts[:level] || parent.level + 1
       if (style = attrs.delete 'style')
-        if style == 'abstract' && doctype == 'book'
+        if book && style == 'abstract'
           sectname, level = 'chapter', 1
         else
           sectname, special = style, true
           level = 1 if level == 0
         end
-      elsif doctype == 'book'
-        sectname = level == 0 ? 'part' : (level == 1 ? 'chapter' : 'section')
+      elsif book
+        sectname = level == 0 ? 'part' : (level > 1 ? 'section' : 'chapter')
       elsif doctype == 'manpage' && (title.casecmp 'synopsis') == 0
         sectname, special = 'synopsis', true
       else
         sectname = 'section'
       end
-      sect = Section.new parent, level, false
+      sect = Section.new parent, level
       sect.title, sect.sectname = title, sectname
       if special
         sect.special = true
-        sect.numbered = true if opts.fetch :numbered, (style == 'appendix')
-      elsif opts.fetch :numbered, (level > 0 && (doc.attributes.key? 'sectnums'))
-        sect.numbered = sect.special ? (parent.context == :section && parent.numbered) : true
+        if opts.fetch :numbered, (style == 'appendix')
+          sect.numbered = true
+        elsif !(opts.key? :numbered) && (doc.attr? 'sectnums', 'all')
+          sect.numbered = book && level == 1 ? :chapter : true
+        end
+      elsif level > 0
+        if opts.fetch :numbered, (doc.attr? 'sectnums')
+          sect.numbered = sect.special ? parent.numbered && true : true
+        end
+      else
+        sect.numbered = true if opts.fetch :numbered, (book && (doc.attr? 'partnums'))
       end
       unless (id = attrs.delete 'id') == false
-        sect.id = attrs['id'] = id || ((doc.attributes.key? 'sectids') ? (Section.generate_id sect.title, doc) : nil)
+        sect.id = attrs['id'] = id || ((doc.attr? 'sectids') ? (Section.generate_id sect.title, doc) : nil)
       end
       sect.update_attributes attrs
       sect
@@ -152,7 +164,7 @@ module Extensions
     # parent - The parent Block (Block, Section, or Document) of this new image block.
     # attrs  - A Hash of attributes to control how the image block is built.
     #          Use the target attribute to set the source of the image.
-    #          Use the alt attribute to specify an alternate text for the image.
+    #          Use the alt attribute to specify an alternative text for the image.
     # opts   - An optional Hash of options (default: {})
     #
     # Returns a [Block] node with all properties properly initialized.
@@ -643,13 +655,12 @@ module Extensions
     # Public: Returns the {Asciidoctor::Document} on which the extensions in this registry are being used.
     attr_reader :document
 
-    # Public: Returns the Array of {Group} classes, instances and/or Procs that have been registered.
+    # Public: Returns the Hash of {Group} classes, instances, and/or Procs that have been registered with this registry.
     attr_reader :groups
 
     def initialize groups = {}
       @groups = groups
-      @preprocessor_extensions = @tree_processor_extensions = @postprocessor_extensions = @include_processor_extensions = @docinfo_processor_extensions = nil
-      @block_extensions = @block_macro_extensions = @inline_macro_extensions = nil
+      @preprocessor_extensions = @tree_processor_extensions = @postprocessor_extensions = @include_processor_extensions = @docinfo_processor_extensions = @block_extensions = @block_macro_extensions = @inline_macro_extensions = nil
       @document = nil
     end
 
@@ -661,19 +672,21 @@ module Extensions
     # Returns the instance of this [Registry].
     def activate document
       @document = document
-      (Extensions.groups.values + @groups.values).each do |group|
-        case group
-        when ::Proc
-          case group.arity
-          when 0, -1
-            instance_exec(&group)
-          when 1
-            group.call self
+      unless (ext_groups = Extensions.groups.values + @groups.values).empty?
+        ext_groups.each do |group|
+          case group
+          when ::Proc
+            case group.arity
+            when 0, -1
+              instance_exec(&group)
+            when 1
+              group.call self
+            end
+          when ::Class
+            group.new.activate self
+          else
+            group.activate self
           end
-        when ::Class
-          group.new.activate self
-        else
-          group.activate self
         end
       end
       self
@@ -705,7 +718,7 @@ module Extensions
     #
     #   # as a method block
     #   preprocessor do
-    #     process |doc, reader|
+    #     process do |doc, reader|
     #       ...
     #     end
     #   end
@@ -757,7 +770,7 @@ module Extensions
     #
     #   # as a method block
     #   tree_processor do
-    #     process |document|
+    #     process do |document|
     #       ...
     #     end
     #   end
@@ -814,7 +827,7 @@ module Extensions
     #
     #   # as a method block
     #   postprocessor do
-    #     process |document, output|
+    #     process do |document, output|
     #       ...
     #     end
     #   end
@@ -866,7 +879,7 @@ module Extensions
     #
     #   # as a method block
     #   include_processor do
-    #     process |document, output|
+    #     process do |document, output|
     #       ...
     #     end
     #   end
@@ -918,7 +931,7 @@ module Extensions
     #
     #   # as a method block
     #   docinfo_processor do
-    #     process |doc|
+    #     process do |doc|
     #       at_location :footer
     #       'footer content'
     #     end
@@ -1007,14 +1020,14 @@ module Extensions
     #   # as a method block
     #   block do
     #     named :shout
-    #     process |parent, reader, attrs|
+    #     process do |parent, reader, attrs|
     #       ...
     #     end
     #   end
     #
     #   # as a method block with an explicit block name
     #   block :shout do
-    #     process |parent, reader, attrs|
+    #     process do |parent, reader, attrs|
     #       ...
     #     end
     #   end
@@ -1096,14 +1109,14 @@ module Extensions
     #   # as a method block
     #   block_macro do
     #     named :gist
-    #     process |parent, target, attrs|
+    #     process do |parent, target, attrs|
     #       ...
     #     end
     #   end
     #
     #   # as a method block with an explicit macro name
     #   block_macro :gist do
-    #     process |parent, target, attrs|
+    #     process do |parent, target, attrs|
     #       ...
     #     end
     #   end
@@ -1168,7 +1181,7 @@ module Extensions
     #   inline_macro ChromeInlineMacro
     #
     #   # as an InlineMacroProcessor subclass with an explicit macro name
-    #   inline_macro ChromeInineMacro, :chrome
+    #   inline_macro ChromeInlineMacro, :chrome
     #
     #   # as an instance of an InlineMacroProcessor subclass
     #   inline_macro ChromeInlineMacro.new
@@ -1180,19 +1193,19 @@ module Extensions
     #   inline_macro 'ChromeInlineMacro'
     #
     #   # as a name of an InlineMacroProcessor subclass with an explicit macro name
-    #   inline_macro 'ChromeInineMacro', :chrome
+    #   inline_macro 'ChromeInlineMacro', :chrome
     #
     #   # as a method block
     #   inline_macro do
     #     named :chrome
-    #     process |parent, target, attrs|
+    #     process do |parent, target, attrs|
     #       ...
     #     end
     #   end
     #
     #   # as a method block with an explicit macro name
     #   inline_macro :chrome do
-    #     process |parent, target, attrs|
+    #     process do |parent, target, attrs|
     #       ...
     #     end
     #   end
@@ -1477,17 +1490,36 @@ module Extensions
     # Public: Resolves the Class object for the qualified name.
     #
     # Returns Class
-    def class_for_name qualified_name
-      resolved = ::Object
-      (qualified_name.split '::').each do |name|
-        unless name.empty? || ((resolved.const_defined? name) && ::Module === (resolved = resolved.const_get name))
-          raise ::NameError, %(Could not resolve class for name: #{qualified_name})
+    if RUBY_MIN_VERSION_2
+      def class_for_name qualified_name
+        resolved = ::Object.const_get qualified_name, false
+        raise unless ::Class === resolved
+        resolved
+      rescue
+        raise ::NameError, %(Could not resolve class for name: #{qualified_name})
+      end
+    elsif RUBY_MIN_VERSION_1_9
+      def class_for_name qualified_name
+        resolved = (qualified_name.split '::').reduce ::Object do |current, name|
+          name.empty? ? current : (current.const_get name, false)
         end
+        raise unless ::Class === resolved
+        resolved
+      rescue
+        raise ::NameError, %(Could not resolve class for name: #{qualified_name})
+      end
+    else
+      def class_for_name qualified_name
+        resolved = (qualified_name.split '::').reduce ::Object do |current, name|
+          # NOTE on Ruby 1.8, const_defined? only checks for constant in current scope
+          name.empty? ? current : ((current.const_defined? name) ? (current.const_get name) : raise)
+        end
+        raise unless ::Class === resolved
+        resolved
+      rescue
+        raise ::NameError, %(Could not resolve class for name: #{qualified_name})
       end
-      raise ::NameError, %(Could not resolve class for name: #{qualified_name}) unless ::Class === resolved
-      resolved
     end
   end
-
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/helpers.rb 1.5.7-1/lib/asciidoctor/helpers.rb
--- 1.5.6.2-2/lib/asciidoctor/helpers.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/helpers.rb	2018-05-05 22:54:38.000000000 +0000
@@ -16,29 +16,31 @@ module Helpers
   #              (default: true)
   # on_failure - a Symbol that indicates how to handle a load failure (:abort, :warn, :ignore) (default: :abort)
   #
-  # returns The return value of Kernel#require if the library is available and can be, or was previously, loaded.
-  # Otherwise, Kernel#raise is called with an appropriate message if on_failure is :abort.
-  # Otherwise, Kernel#warn is called with an appropriate message and nil returned if on_failure is :warn.
+  # Returns The [Boolean] return value of Kernel#require if the library can be loaded.
+  # Otherwise, if on_failure is :abort, Kernel#raise is called with an appropriate message.
+  # Otherwise, if on_failure is :warn, Kernel#warn is called with an appropriate message and nil returned.
   # Otherwise, nil is returned.
   def self.require_library name, gem_name = true, on_failure = :abort
     require name
   rescue ::LoadError => e
+    include Logging unless include? Logging
     if gem_name
       gem_name = name if gem_name == true
       case on_failure
       when :abort
         raise ::LoadError, %(asciidoctor: FAILED: required gem '#{gem_name}' is not installed. Processing aborted.)
       when :warn
-        warn %(asciidoctor: WARNING: optional gem '#{gem_name}' is not installed. Functionality disabled.)
+        logger.warn %(optional gem '#{gem_name}' is not installed. Functionality disabled.)
       end
     else
       case on_failure
       when :abort
         raise ::LoadError, %(asciidoctor: FAILED: #{e.message.chomp '.'}. Processing aborted.)
       when :warn
-        warn %(asciidoctor: WARNING: #{e.message.chomp '.'}. Functionality disabled.)
+        logger.warn %(#{e.message.chomp '.'}. Functionality disabled.)
       end
     end
+    nil
   end
 
   # Public: Normalize the data to prepare for parsing
@@ -48,7 +50,7 @@ module Helpers
   #
   # returns a String Array of normalized lines
   def self.normalize_lines data
-    data.class == ::String ? (normalize_lines_from_string data) : (normalize_lines_array data)
+    ::String === data ? (normalize_lines_from_string data) : (normalize_lines_array data)
   end
 
   # Public: Normalize the array of lines to prepare them for parsing
@@ -195,14 +197,34 @@ module Helpers
     end
   end
 
-  def self.mkdir_p(dir)
+  def self.mkdir_p dir
     unless ::File.directory? dir
-      parent_dir = ::File.dirname(dir)
-      if !::File.directory?(parent_dir = ::File.dirname(dir)) && parent_dir != '.'
-        mkdir_p(parent_dir)
+      unless (parent_dir = ::File.dirname dir) == '.'
+        mkdir_p parent_dir
+      end
+      begin
+        ::Dir.mkdir dir
+      rescue ::SystemCallError
+        raise unless ::File.directory? dir
       end
-      ::Dir.mkdir(dir)
     end
   end
+
+  ROMAN_NUMERALS = {
+    'M' => 1000, 'CM' => 900, 'D' => 500, 'CD' => 400, 'C' => 100, 'XC' => 90,
+    'L' => 50, 'XL' => 40, 'X' => 10, 'IX' => 9, 'V' => 5, 'IV' => 4, 'I' => 1
+  }
+
+  # Converts an integer to a Roman numeral.
+  #
+  # val - the [Integer] value to convert
+  #
+  # Returns the [String] roman numeral for this integer
+  def self.int_to_roman val
+    ROMAN_NUMERALS.map {|l, i|
+      repeat, val = val.divmod i
+      l * repeat
+    }.join
+  end
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/inline.rb 1.5.7-1/lib/asciidoctor/inline.rb
--- 1.5.6.2-2/lib/asciidoctor/inline.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/inline.rb	2018-05-05 22:54:38.000000000 +0000
@@ -21,8 +21,9 @@ class Inline < AbstractNode
     @type = opts[:type]
     @target = opts[:target]
 
-    unless (more_attributes = opts[:attributes]).nil_or_empty?
-      update_attributes more_attributes
+    # value of attributes option for inline nodes may be nil
+    if (attrs = opts[:attributes])
+      @attributes = attrs.dup
     end
   end
 
diff -pruN 1.5.6.2-2/lib/asciidoctor/list.rb 1.5.7-1/lib/asciidoctor/list.rb
--- 1.5.6.2-2/lib/asciidoctor/list.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/list.rb	2018-05-05 22:54:38.000000000 +0000
@@ -73,7 +73,8 @@ class ListItem < AbstractBlock
   #
   # Returns the converted String text for this ListItem
   def text
-    apply_subs @text, @subs
+    # NOTE @text can be nil if dd node only has block content
+    @text && (apply_subs @text, @subs)
   end
 
   # Public: Set the String text.
diff -pruN 1.5.6.2-2/lib/asciidoctor/logging.rb 1.5.7-1/lib/asciidoctor/logging.rb
--- 1.5.6.2-2/lib/asciidoctor/logging.rb	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/logging.rb	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,122 @@
+require 'logger'
+
+module Asciidoctor
+class Logger < ::Logger
+  attr_reader :max_severity
+
+  def initialize *args
+    super
+    self.progname = 'asciidoctor'
+    self.formatter = BasicFormatter.new
+    self.level = WARN
+  end
+
+  def add severity, message = nil, progname = nil
+    if (severity ||= UNKNOWN) > (@max_severity ||= severity)
+      @max_severity = severity
+    end
+    super
+  end
+
+  class BasicFormatter < Formatter
+    SEVERITY_LABELS = { 'WARN' => 'WARNING', 'FATAL' => 'FAILED' }
+
+    def call severity, _, progname, msg
+      %(#{progname}: #{SEVERITY_LABELS[severity] || severity}: #{::String === msg ? msg : msg.inspect}\n)
+    end
+  end
+
+  module AutoFormattingMessage
+    def inspect
+      (sloc = self[:source_location]) ? %(#{sloc}: #{self[:text]}) : self[:text]
+    end
+  end
+end
+
+class MemoryLogger < ::Logger
+  # NOTE Ruby 1.8.7 returns constants as strings instead of symbols
+  SEVERITY_LABELS = ::Hash[Severity.constants.map {|c| [(Severity.const_get c), c.to_sym] }]
+
+  attr_reader :messages
+
+  def initialize
+    self.level = WARN
+    @messages = []
+  end
+
+  def add severity, message = nil, progname = nil
+    message = block_given? ? yield : progname unless message
+    @messages << { :severity => SEVERITY_LABELS[severity || UNKNOWN], :message => message }
+    true
+  end
+
+  def clear
+    @messages.clear
+  end
+
+  def empty?
+    @messages.empty?
+  end
+
+  def max_severity
+    empty? ? nil : @messages.map {|m| Severity.const_get m[:severity] }.max
+  end
+end
+
+class NullLogger < ::Logger
+  attr_reader :max_severity
+
+  def initialize; end
+
+  def add severity, message = nil, progname = nil
+    if (severity ||= UNKNOWN) > (@max_severity ||= severity)
+      @max_severity = severity
+    end
+    true
+  end
+end
+
+module LoggerManager
+  @logger_class = Logger
+  class << self
+    attr_accessor :logger_class
+
+    # NOTE subsequent calls to logger access the logger via the logger property directly
+    def logger pipe = $stderr
+      memoize_logger
+      @logger ||= (@logger_class.new pipe)
+    end
+
+    def logger= logger
+      @logger = logger || (@logger_class.new $stderr)
+    end
+
+    private
+    def memoize_logger
+      class << self
+        alias_method :logger, :logger
+        if RUBY_ENGINE == 'opal'
+          define_method :logger do @logger end
+        else
+          attr_reader :logger
+        end
+      end
+    end
+  end
+end
+
+module Logging
+  def self.included into
+    into.extend Logging
+  end
+
+  private
+  def logger
+    LoggerManager.logger
+  end
+
+  def message_with_context text, context = {}
+    ({ :text => text }.merge context).extend Logger::AutoFormattingMessage
+  end
+end
+end
diff -pruN 1.5.6.2-2/lib/asciidoctor/parser.rb 1.5.7-1/lib/asciidoctor/parser.rb
--- 1.5.6.2-2/lib/asciidoctor/parser.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/parser.rb	2018-05-05 22:54:38.000000000 +0000
@@ -23,6 +23,7 @@ module Asciidoctor
 #   block.class
 #   # => Asciidoctor::Block
 class Parser
+  include Logging
 
   BlockMatchData = Struct.new :context, :masq, :tip, :terminator
 
@@ -93,7 +94,10 @@ class Parser
 
     while reader.has_more_lines?
       new_section, block_attributes = next_section(reader, document, block_attributes)
-      document << new_section if new_section
+      if new_section
+        document.assign_numeral new_section
+        document.blocks << new_section
+      end
     end unless options[:header_only]
 
     document
@@ -113,65 +117,63 @@ class Parser
   # returns the Hash of orphan block attributes captured above the header
   def self.parse_document_header(reader, document)
     # capture lines of block-level metadata and plow away comment lines that precede first block
-    block_attributes = parse_block_metadata_lines reader, document
+    block_attrs = parse_block_metadata_lines reader, document
+    doc_attrs = document.attributes
 
     # special case, block title is not allowed above document title,
     # carry attributes over to the document body
-    if (implicit_doctitle = is_next_line_doctitle? reader, block_attributes, document.attributes['leveloffset']) &&
-        (block_attributes.key? 'title')
-      return document.finalize_header block_attributes, false
+    if (implicit_doctitle = is_next_line_doctitle? reader, block_attrs, doc_attrs['leveloffset']) && block_attrs['title']
+      return document.finalize_header block_attrs, false
     end
 
     # yep, document title logic in AsciiDoc is just insanity
     # definitely an area for spec refinement
     assigned_doctitle = nil
-    unless (val = document.attributes['doctitle']).nil_or_empty?
+    unless (val = doc_attrs['doctitle']).nil_or_empty?
       document.title = assigned_doctitle = val
     end
 
-    section_title = nil
     # if the first line is the document title, add a header to the document and parse the header metadata
     if implicit_doctitle
       source_location = reader.cursor if document.sourcemap
       document.id, _, doctitle, _, atx = parse_section_title reader, document
-      unless assigned_doctitle
-        document.title = assigned_doctitle = doctitle
-      end
+      document.title = assigned_doctitle = doctitle unless assigned_doctitle
+      document.header.source_location = source_location if source_location
       # default to compat-mode if document uses atx-style doctitle
-      document.set_attr 'compat-mode' unless atx || (document.attribute_locked? 'compat-mode')
-      if (separator = block_attributes.delete 'separator')
-        document.set_attr 'title-separator', separator unless document.attribute_locked? 'title-separator'
+      doc_attrs['compat-mode'] = '' unless atx || (document.attribute_locked? 'compat-mode')
+      if (separator = block_attrs['separator'])
+        doc_attrs['title-separator'] = separator unless document.attribute_locked? 'title-separator'
       end
-      document.header.source_location = source_location if source_location
-      document.attributes['doctitle'] = section_title = doctitle
-      # QUESTION: should the id assignment on Document be encapsulated in the Document class?
-      if document.id
-        block_attributes.delete 1
-        block_attributes.delete 'id'
-      else
-        if (style = block_attributes.delete 1)
-          style_attrs = { 1 => style }
-          parse_style_attribute style_attrs, reader
-          block_attributes['id'] = style_attrs['id'] if style_attrs.key? 'id'
-        end
-        document.id = block_attributes.delete 'id'
+      doc_attrs['doctitle'] = section_title = doctitle
+      if (doc_id = block_attrs['id'])
+        document.id = doc_id
+      else
+        doc_id = document.id
+      end
+      if (doc_role = block_attrs['role'])
+        doc_attrs['docrole'] = doc_role
       end
+      if (doc_reftext = block_attrs['reftext'])
+        doc_attrs['reftext'] = doc_reftext
+      end
+      block_attrs = {}
       parse_header_metadata reader, document
+      document.register :refs, [doc_id, document] if doc_id
     end
 
-    unless (val = document.attributes['doctitle']).nil_or_empty? || val == section_title
+    unless (val = doc_attrs['doctitle']).nil_or_empty? || val == section_title
       document.title = assigned_doctitle = val
     end
 
     # restore doctitle attribute to original assignment
-    document.attributes['doctitle'] = assigned_doctitle if assigned_doctitle
+    doc_attrs['doctitle'] = assigned_doctitle if assigned_doctitle
 
     # parse title and consume name section of manpage document
     parse_manpage_header(reader, document) if document.doctype == 'manpage'
 
-    # NOTE block_attributes are the block-level attributes (not document attributes) that
+    # NOTE block_attrs are the block-level attributes (not document attributes) that
     # precede the first line of content (document title, first section or first block)
-    document.finalize_header block_attributes
+    document.finalize_header block_attrs
   end
 
   # Public: Parses the manpage header of the AsciiDoc source read from the Reader
@@ -179,10 +181,10 @@ class Parser
   # returns Nothing
   def self.parse_manpage_header(reader, document)
     if ManpageTitleVolnumRx =~ document.attributes['doctitle']
-      document.attributes['mantitle'] = document.sub_attributes $1.downcase
+      document.attributes['mantitle'] = (($1.include? ATTR_REF_HEAD) ? (document.sub_attributes $1) : $1).downcase
       document.attributes['manvolnum'] = $2
     else
-      warn %(asciidoctor: ERROR: #{reader.prev_line_info}: malformed manpage title)
+      logger.error message_with_context 'malformed manpage title', :source_location => reader.cursor_at_prev_line
       # provide sensible fallbacks
       document.attributes['mantitle'] = document.attributes['doctitle']
       document.attributes['manvolnum'] = '1'
@@ -190,28 +192,36 @@ class Parser
 
     reader.skip_blank_lines
 
-    if is_next_line_section?(reader, {})
-      name_section = initialize_section(reader, document, {})
+    if is_next_line_section? reader, {}
+      name_section = initialize_section reader, document, {}
       if name_section.level == 1
-        name_section_buffer = reader.read_lines_until(:break_on_blank_lines => true) * ' '
-        if (m = ManpageNamePurposeRx.match(name_section_buffer))
-          document.attributes['manname'] = document.sub_attributes m[1]
-          document.attributes['manpurpose'] = m[2]
-          # TODO parse multiple man names
+        name_section_buffer = (reader.read_lines_until :break_on_blank_lines => true, :skip_line_comments => true) * ' '
+        if ManpageNamePurposeRx =~ name_section_buffer
+          document.attributes['manname-title'] ||= name_section.title
+          document.attributes['manname-id'] = name_section.id if name_section.id
+          document.attributes['manpurpose'] = $2
+          if (manname = ($1.include? ATTR_REF_HEAD) ? (document.sub_attributes $1) : $1).include? ','
+            manname = (mannames = (manname.split ',').map {|n| n.lstrip })[0]
+          else
+            mannames = [manname]
+          end
+          document.attributes['manname'] = manname
+          document.attributes['mannames'] = mannames
 
           if document.backend == 'manpage'
-            document.attributes['docname'] = document.attributes['manname']
+            document.attributes['docname'] = manname
             document.attributes['outfilesuffix'] = %(.#{document.attributes['manvolnum']})
           end
         else
-          warn %(asciidoctor: ERROR: #{reader.prev_line_info}: malformed name section body)
+          logger.error message_with_context 'malformed name section body', :source_location => reader.cursor_at_prev_line
         end
       else
-        warn %(asciidoctor: ERROR: #{reader.prev_line_info}: name section title must be at level 1)
+        logger.error message_with_context 'name section title must be at level 1', :source_location => reader.cursor_at_prev_line
       end
     else
-      warn %(asciidoctor: ERROR: #{reader.prev_line_info}: name section expected)
+      logger.error message_with_context 'name section expected', :source_location => reader.cursor_at_prev_line
     end
+    nil
   end
 
   # Public: Return the next section from the Reader.
@@ -254,37 +264,41 @@ class Parser
   def self.next_section reader, parent, attributes = {}
     preamble = intro = part = false
 
-    # FIXME if attributes[1] is a verbatim style, then don't check for section
-
     # check if we are at the start of processing the document
     # NOTE we could drop a hint in the attributes to indicate
     # that we are at a section title (so we don't have to check)
     if parent.context == :document && parent.blocks.empty? && ((has_header = parent.has_header?) ||
         (attributes.delete 'invalid-header') || !(is_next_line_section? reader, attributes))
-      doctype = (document = parent).doctype
-      if has_header || (doctype == 'book' && attributes[1] != 'abstract')
+      book = (document = parent).doctype == 'book'
+      if has_header || (book && attributes[1] != 'abstract')
         preamble = intro = (Block.new parent, :preamble, :content_model => :compound)
-        preamble.title = parent.attr 'preface-title' if doctype == 'book' && (parent.attr? 'preface-title')
-        parent << preamble
+        preamble.title = parent.attr 'preface-title' if book && (parent.attr? 'preface-title')
+        parent.blocks << preamble
       end
       section = parent
-
       current_level = 0
       if parent.attributes.key? 'fragment'
-        expected_next_levels = nil
+        expected_next_level = -1
       # small tweak to allow subsequent level-0 sections for book doctype
-      elsif doctype == 'book'
-        expected_next_levels = [0, 1]
+      elsif book
+        expected_next_level, expected_next_level_alt = 1, 0
       else
-        expected_next_levels = [1]
+        expected_next_level = 1
       end
     else
-      doctype = (document = parent.document).doctype
+      book = (document = parent.document).doctype == 'book'
       section = initialize_section reader, parent, attributes
       # clear attributes except for title attribute, which must be carried over to next content block
       attributes = (title = attributes['title']) ? { 'title' => title } : {}
-      part = section.sectname == 'part'
-      expected_next_levels = [(current_level = section.level) + 1]
+      expected_next_level = (current_level = section.level) + 1
+      if current_level == 0
+        part = book
+      elsif current_level == 1 && section.special
+        # NOTE technically preface and abstract sections are only permitted in the book doctype
+        unless (sectname = section.sectname) == 'appendix' || sectname == 'preface' || sectname == 'abstract'
+          expected_next_level = nil
+        end
+      end
     end
 
     reader.skip_blank_lines
@@ -300,28 +314,32 @@ class Parser
     # otherwise subsequent metadata lines get interpreted as block content
     while reader.has_more_lines?
       parse_block_metadata_lines reader, document, attributes
-
       if (next_level = is_next_line_section?(reader, attributes))
         next_level += document.attr('leveloffset').to_i if document.attr?('leveloffset')
-        if next_level > current_level || (next_level == 0 && section.context == :document)
-          if next_level == 0 && doctype != 'book'
-            warn %(asciidoctor: ERROR: #{reader.line_info}: only book doctypes can contain level 0 sections)
-          elsif expected_next_levels && !expected_next_levels.include?(next_level)
-            warn %(asciidoctor: WARNING: #{reader.line_info}: section title out of sequence: expected #{expected_next_levels.size > 1 ? 'levels' : 'level'} #{expected_next_levels * ' or '}, got level #{next_level})
+        if next_level > current_level
+          if expected_next_level
+            unless next_level == expected_next_level || (expected_next_level_alt && next_level == expected_next_level_alt) || expected_next_level < 0
+              expected_condition = expected_next_level_alt ? %(expected levels #{expected_next_level_alt} or #{expected_next_level}) : %(expected level #{expected_next_level})
+              logger.warn message_with_context %(section title out of sequence: #{expected_condition}, got level #{next_level}), :source_location => reader.cursor
+            end
+          else
+            logger.error message_with_context %(#{sectname} sections do not support nested sections), :source_location => reader.cursor
           end
-          # the attributes returned are those that are orphaned
           new_section, attributes = next_section reader, section, attributes
-          section << new_section
+          section.assign_numeral new_section
+          section.blocks << new_section
+        elsif next_level == 0 && section == document
+          logger.error message_with_context 'level 0 sections can only be used when doctype is book', :source_location => reader.cursor unless book
+          new_section, attributes = next_section reader, section, attributes
+          section.assign_numeral new_section
+          section.blocks << new_section
         else
-          if next_level == 0 && doctype != 'book'
-            warn %(asciidoctor: ERROR: #{reader.line_info}: only book doctypes can contain level 0 sections)
-          end
           # close this section (and break out of the nesting) to begin a new one
           break
         end
       else
         # just take one block or else we run the risk of overrunning section boundaries
-        block_line_info = reader.line_info
+        block_cursor = reader.cursor
         if (new_block = next_block reader, intro || section, attributes, :parse_metadata => false)
           # REVIEW this may be doing too much
           if part
@@ -334,36 +352,32 @@ class Parser
                   new_block.style = 'partintro'
                 # emulate [partintro] open block
                 else
-                  intro = Block.new section, :open, :content_model => :compound
+                  new_block.parent = (intro = Block.new section, :open, :content_model => :compound)
                   intro.style = 'partintro'
-                  new_block.parent = intro
-                  section << intro
+                  section.blocks << intro
                 end
               end
             elsif section.blocks.size == 1
               first_block = section.blocks[0]
               # open the [partintro] open block for appending
               if !intro && first_block.content_model == :compound
-                #new_block.parent = (intro = first_block)
-                warn %(asciidoctor: ERROR: #{block_line_info}: illegal block content outside of partintro block)
+                logger.error message_with_context 'illegal block content outside of partintro block', :source_location => block_cursor
               # rebuild [partintro] paragraph as an open block
               elsif first_block.content_model != :compound
-                intro = Block.new section, :open, :content_model => :compound
+                new_block.parent = (intro = Block.new section, :open, :content_model => :compound)
                 intro.style = 'partintro'
                 section.blocks.shift
                 if first_block.style == 'partintro'
                   first_block.context = :paragraph
                   first_block.style = nil
                 end
-                first_block.parent = intro
                 intro << first_block
-                new_block.parent = intro
-                section << intro
+                section.blocks << intro
               end
             end
           end
 
-          (intro || section) << new_block
+          (intro || section).blocks << new_block
           attributes = {}
         #else
         #  # don't clear attributes if we don't find a block because they may
@@ -376,18 +390,17 @@ class Parser
 
     if part
       unless section.blocks? && section.blocks[-1].context == :section
-        warn %(asciidoctor: ERROR: #{reader.line_info}: invalid part, must have at least one section (e.g., chapter, appendix, etc.))
+        logger.error message_with_context 'invalid part, must have at least one section (e.g., chapter, appendix, etc.)', :source_location => reader.cursor
       end
     # NOTE we could try to avoid creating a preamble in the first place, though
     # that would require reworking assumptions in next_section since the preamble
     # is treated like an untitled section
     elsif preamble # implies parent == document
       if preamble.blocks?
-        # unwrap standalone preamble (i.e., no sections), if permissible
-        if Compliance.unwrap_standalone_preamble && document.blocks.size == 1 && doctype != 'book'
+        # unwrap standalone preamble (i.e., document has no sections) except for books, if permissible
+        unless book || document.blocks[1] || !Compliance.unwrap_standalone_preamble
           document.blocks.shift
           while (child_block = preamble.blocks.shift)
-            child_block.parent = document
             document << child_block
           end
         end
@@ -453,10 +466,9 @@ class Parser
     end
 
     # QUESTION should we introduce a parsing context object?
-    source_location = reader.cursor if document.sourcemap
-    this_path, this_lineno, this_line, in_list = reader.path, reader.lineno, reader.read_line, ListItem === parent
+    reader.mark
+    this_line, doc_attrs, style = reader.read_line, document.attributes, attributes[1]
     block = block_context = cloaked_context = terminator = nil
-    style = attributes[1] ? (parse_style_attribute attributes, reader) : nil
 
     if (delimited_block = is_delimited_block? this_line, true)
       block_context = cloaked_context = delimited_block.context
@@ -471,7 +483,7 @@ class Parser
         elsif block_extensions && extensions.registered_for_block?(style, block_context)
           block_context = style.to_sym
         else
-          warn %(asciidoctor: WARNING: #{this_path}: line #{this_lineno}: invalid style for #{block_context} block: #{style})
+          logger.warn message_with_context %(invalid style for #{block_context} block: #{style}), :source_location => reader.cursor_at_mark
           style = block_context.to_s
         end
       end
@@ -517,24 +529,26 @@ class Parser
             break
           # NOTE very rare that a text-only line will end in ] (e.g., inline macro), so check that first
           elsif (this_line.end_with? ']') && (this_line.include? '::')
-            #if (this_line.start_with? 'image', 'video', 'audio') && (match = BlockMediaMacroRx.match(this_line))
-            if (ch0 == 'i' || (this_line.start_with? 'video:', 'audio:')) && (match = BlockMediaMacroRx.match(this_line))
-              blk_ctx, target = match[1].to_sym, match[2]
-              block = Block.new(parent, blk_ctx, :content_model => :empty)
-              case blk_ctx
-              when :video
-                posattrs = ['poster', 'width', 'height']
-              when :audio
-                posattrs = []
-              else # :image
-                posattrs = ['alt', 'width', 'height']
+            #if (this_line.start_with? 'image', 'video', 'audio') && BlockMediaMacroRx =~ this_line
+            if (ch0 == 'i' || (this_line.start_with? 'video:', 'audio:')) && BlockMediaMacroRx =~ this_line
+              blk_ctx, target, blk_attrs = $1.to_sym, $2, $3
+              block = Block.new parent, blk_ctx, :content_model => :empty
+              if blk_attrs
+                case blk_ctx
+                when :video
+                  posattrs = ['poster', 'width', 'height']
+                when :audio
+                  posattrs = []
+                else # :image
+                  posattrs = ['alt', 'width', 'height']
+                end
+                block.parse_attributes blk_attrs, posattrs, :sub_input => true, :sub_result => false, :into => attributes
               end
-              block.parse_attributes(match[3], posattrs, :sub_input => true, :sub_result => false, :into => attributes)
               # style doesn't have special meaning for media macros
               attributes.delete 'style' if attributes.key? 'style'
               if (target.include? ATTR_REF_HEAD) && (target = block.sub_attributes target, :attribute_missing => 'drop-line').empty?
                 # retain as unparsed if attribute-missing is skip
-                if document.attributes.fetch('attribute-missing', Compliance.attribute_missing) == 'skip'
+                if (doc_attrs['attribute-missing'] || Compliance.attribute_missing) == 'skip'
                   return Block.new(parent, :paragraph, :content_model => :simple, :source => [this_line])
                 # otherwise, drop the line
                 else
@@ -543,7 +557,7 @@ class Parser
                 end
               end
               if blk_ctx == :image
-                block.document.register :images, target
+                document.register :images, target
                 # NOTE style is the value of the first positional attribute in the block attribute line
                 attributes['alt'] ||= style || (attributes['default-alt'] = Helpers.basename(target, true).tr('_-', ' '))
                 unless (scaledwidth = attributes.delete 'scaledwidth').nil_or_empty?
@@ -556,22 +570,20 @@ class Parser
               attributes['target'] = target
               break
 
-            elsif ch0 == 't' && (this_line.start_with? 'toc:') && (match = BlockTocMacroRx.match(this_line))
-              block = Block.new(parent, :toc, :content_model => :empty)
-              block.parse_attributes(match[1], [], :sub_result => false, :into => attributes)
+            elsif ch0 == 't' && (this_line.start_with? 'toc:') && BlockTocMacroRx =~ this_line
+              block = Block.new parent, :toc, :content_model => :empty
+              block.parse_attributes($1, [], :sub_result => false, :into => attributes) if $1
               break
 
-            elsif block_macro_extensions && (match = CustomBlockMacroRx.match(this_line)) &&
-                (extension = extensions.registered_for_block_macro?(match[1]))
-              target = match[2]
-              content = match[3]
+            elsif block_macro_extensions && CustomBlockMacroRx =~ this_line &&
+                (extension = extensions.registered_for_block_macro? $1)
+              target, content = $2, $3
               if extension.config[:content_model] == :attributes
-                unless content.empty?
-                  document.parse_attributes(content, extension.config[:pos_attrs] || [],
-                      :sub_input => true, :sub_result => false, :into => attributes)
+                if content
+                  document.parse_attributes content, extension.config[:pos_attrs] || [], :sub_input => true, :sub_result => false, :into => attributes
                 end
               else
-                attributes['text'] = content
+                attributes['text'] = content || ''
               end
               if (default_attrs = extension.config[:default_attrs])
                 attributes.update(default_attrs) {|_, old_v| old_v }
@@ -594,23 +606,22 @@ class Parser
         block = List.new(parent, :colist)
         attributes['style'] = 'arabic'
         reader.unshift_line this_line
-        expected_index = 1
+        next_index = 1
         # NOTE skip the match on the first time through as we've already done it (emulates begin...while)
-        while match || (reader.has_more_lines? && (match = CalloutListRx.match(reader.peek_line)))
-          list_item_lineno = reader.lineno
+        while match || ((match = CalloutListRx.match reader.peek_line) && reader.mark)
           # might want to move this check to a validate method
-          unless match[1] == expected_index.to_s
-            warn %(asciidoctor: WARNING: #{reader.path}: line #{list_item_lineno}: callout list item index: expected #{expected_index} got #{match[1]})
+          unless match[1] == next_index.to_s
+            logger.warn message_with_context %(callout list item index: expected #{next_index}, got #{match[1]}), :source_location => reader.cursor_at_mark
           end
           if (list_item = next_list_item reader, block, match)
-            block << list_item
+            block.items << list_item
             if (coids = document.callouts.callout_ids block.items.size).empty?
-              warn %(asciidoctor: WARNING: #{reader.path}: line #{list_item_lineno}: no callouts refer to list item #{block.items.size})
+              logger.warn message_with_context %(no callout found for <#{block.items.size}>), :source_location => reader.cursor_at_mark
             else
               list_item.attributes['coids'] = coids
             end
           end
-          expected_index += 1
+          next_index += 1
           match = nil
         end
 
@@ -619,17 +630,16 @@ class Parser
 
       elsif UnorderedListRx.match? this_line
         reader.unshift_line this_line
-        block = next_item_list(reader, :ulist, parent)
-        if (style || (Section === parent && parent.sectname)) == 'bibliography'
-          attributes['style'] = 'bibliography' unless style
-          block.items.each {|item| catalog_inline_biblio_anchor item.instance_variable_get(:@text), item, document }
-        end
+        if Section === parent && parent.sectname == 'bibliography'
+          style = attributes['style'] = 'bibliography'
+        end unless style
+        block = next_list(reader, :ulist, parent, style)
         break
 
       elsif (match = OrderedListRx.match(this_line))
         reader.unshift_line this_line
-        block = next_item_list(reader, :olist, parent)
-        # FIXME move this logic into next_item_list
+        block = next_list(reader, :olist, parent)
+        # FIXME move this logic into next_list
         unless style
           marker = block.items[0].marker
           if marker.start_with? '.'
@@ -651,13 +661,12 @@ class Parser
       elsif (style == 'float' || style == 'discrete') && (Compliance.underline_style_section_titles ?
           (is_section_title? this_line, reader.peek_line) : !indented && (atx_section_title? this_line))
         reader.unshift_line this_line
-        float_id, float_reftext, float_title, float_level, _ = parse_section_title(reader, document)
+        float_id, float_reftext, float_title, float_level = parse_section_title reader, document, attributes['id']
         attributes['reftext'] = float_reftext if float_reftext
         block = Block.new(parent, :floating_title, :content_model => :empty)
         block.title = float_title
         attributes.delete 'title'
-        block.id = float_id || attributes['id'] ||
-            ((document.attributes.key? 'sectids') ? (Section.generate_id block.title, document) : nil)
+        block.id = float_id || ((doc_attrs.key? 'sectids') ? (Section.generate_id block.title, document) : nil)
         block.level = float_level
         break
 
@@ -683,32 +692,26 @@ class Parser
           # advance to block parsing =>
           break
         else
-          warn %(asciidoctor: WARNING: #{this_path}: line #{this_lineno}: invalid style for paragraph: #{style})
+          logger.warn message_with_context %(invalid style for paragraph: #{style}), :source_location => reader.cursor_at_mark
           style = nil
           # continue to process paragraph
         end
       end
 
-      break_at_list = (skipped == 0 && in_list)
       reader.unshift_line this_line
 
       # a literal paragraph: contiguous lines starting with at least one whitespace character
       # NOTE style can only be nil or "normal" at this point
       if indented && !style
-        lines = read_paragraph_lines reader, break_at_list, :skip_line_comments => text_only
-
+        lines = read_paragraph_lines reader, (in_list = ListItem === parent) && skipped == 0, :skip_line_comments => text_only
         adjust_indentation! lines
-
         block = Block.new(parent, :literal, :content_model => :verbatim, :source => lines, :attributes => attributes)
         # a literal gets special meaning inside of a description list
         # TODO this feels hacky, better way to distinguish from explicit literal block?
         block.set_option('listparagraph') if in_list
-
       # a normal paragraph: contiguous non-blank/non-continuation lines (left-indented or normal style)
       else
-        # NOTE we only get here if there's at least one line that's not a line comment
-        lines = read_paragraph_lines reader, break_at_list, :skip_line_comments => true
-
+        lines = read_paragraph_lines reader, skipped == 0 && ListItem === parent, :skip_line_comments => true
         # NOTE don't check indented here since it's extremely rare
         #if text_only || indented
         if text_only
@@ -719,14 +722,12 @@ class Parser
         elsif (ADMONITION_STYLE_HEADS.include? ch0) && (this_line.include? ':') && (AdmonitionParagraphRx =~ this_line)
           lines[0] = $' # string after match
           attributes['name'] = admonition_name = (attributes['style'] = $1).downcase
-          attributes['textlabel'] = (attributes.delete 'caption') || document.attributes[%(#{admonition_name}-caption)]
+          attributes['textlabel'] = (attributes.delete 'caption') || doc_attrs[%(#{admonition_name}-caption)]
           block = Block.new(parent, :admonition, :content_model => :simple, :source => lines, :attributes => attributes)
         elsif md_syntax && ch0 == '>' && this_line.start_with?('> ')
           lines.map! {|line| line == '>' ? line[1..-1] : ((line.start_with? '> ') ? line[2..-1] : line) }
           if lines[-1].start_with? '-- '
-            attribution, citetitle = lines.pop[3..-1].split(', ', 2)
-            attributes['attribution'] = attribution if attribution
-            attributes['citetitle'] = citetitle if citetitle
+            credit_line = (credit_line = lines.pop[3..-1])
             lines.pop while lines[-1].empty?
           end
           attributes['style'] = 'quote'
@@ -734,15 +735,21 @@ class Parser
           # TODO could assume a discrete heading when inside a block context
           # FIXME Reader needs to be created w/ line info
           block = build_block(:quote, :compound, false, parent, Reader.new(lines), attributes)
+          if credit_line
+            attribution, citetitle = (block.apply_subs credit_line).split ', ', 2
+            attributes['attribution'] = attribution if attribution
+            attributes['citetitle'] = citetitle if citetitle
+          end
         elsif ch0 == '"' && lines.size > 1 && (lines[-1].start_with? '-- ') && (lines[-2].end_with? '"')
           lines[0] = this_line[1..-1] # strip leading quote
-          attribution, citetitle = lines.pop[3..-1].split(', ', 2)
-          attributes['attribution'] = attribution if attribution
-          attributes['citetitle'] = citetitle if citetitle
+          credit_line = (credit_line = lines.pop).slice(3, credit_line.length)
           lines.pop while lines[-1].empty?
           lines[-1] = lines[-1].chop # strip trailing quote
           attributes['style'] = 'quote'
           block = Block.new(parent, :quote, :content_model => :simple, :source => lines, :attributes => attributes)
+          attribution, citetitle = (block.apply_subs credit_line).split ', ', 2
+          attributes['attribution'] = attribution if attribution
+          attributes['citetitle'] = citetitle if citetitle
         else
           # if [normal] is used over an indented paragraph, shift content to left margin
           # QUESTION do we even need to shift since whitespace is normalized by XML in this case?
@@ -765,7 +772,7 @@ class Parser
       case block_context
       when :admonition
         attributes['name'] = admonition_name = style.downcase
-        attributes['textlabel'] = (attributes.delete 'caption') || document.attributes[%(#{admonition_name}-caption)]
+        attributes['textlabel'] = (attributes.delete 'caption') || doc_attrs[%(#{admonition_name}-caption)]
         block = build_block(block_context, :compound, terminator, parent, reader, attributes)
 
       when :comment
@@ -781,14 +788,14 @@ class Parser
 
       when :source
         AttributeList.rekey attributes, [nil, 'language', 'linenums']
-        if document.attributes.key? 'source-language'
-          attributes['language'] = document.attributes['source-language'] || 'text'
+        if doc_attrs.key? 'source-language'
+          attributes['language'] = doc_attrs['source-language'] || 'text'
         end unless attributes.key? 'language'
-        if (attributes.key? 'linenums-option') || (document.attributes.key? 'source-linenums-option')
+        if (attributes.key? 'linenums-option') || (doc_attrs.key? 'source-linenums-option')
           attributes['linenums'] = ''
         end unless attributes.key? 'linenums'
-        if document.attributes.key? 'source-indent'
-          attributes['indent'] = document.attributes['source-indent']
+        if doc_attrs.key? 'source-indent'
+          attributes['indent'] = doc_attrs['source-indent']
         end unless attributes.key? 'indent'
         block = build_block(:listing, :verbatim, terminator, parent, reader, attributes)
 
@@ -808,17 +815,17 @@ class Parser
           language = language.lstrip
         end
         if language.nil_or_empty?
-          if document.attributes.key? 'source-language'
-            attributes['language'] = document.attributes['source-language'] || 'text'
+          if doc_attrs.key? 'source-language'
+            attributes['language'] = doc_attrs['source-language'] || 'text'
           end
         else
           attributes['language'] = language
         end
-        if (attributes.key? 'linenums-option') || (document.attributes.key? 'source-linenums-option')
+        if (attributes.key? 'linenums-option') || (doc_attrs.key? 'source-linenums-option')
           attributes['linenums'] = ''
         end unless attributes.key? 'linenums'
-        if document.attributes.key? 'source-indent'
-          attributes['indent'] = document.attributes['source-indent']
+        if doc_attrs.key? 'source-indent'
+          attributes['indent'] = doc_attrs['source-indent']
         end unless attributes.key? 'indent'
         terminator = terminator.slice 0, 3
         block = build_block(:listing, :verbatim, terminator, parent, reader, attributes)
@@ -827,22 +834,15 @@ class Parser
         block = build_block(block_context, :raw, terminator, parent, reader, attributes)
 
       when :stem, :latexmath, :asciimath
-        if block_context == :stem
-          attributes['style'] = if (explicit_stem_syntax = attributes[2])
-            explicit_stem_syntax.include?('tex') ? 'latexmath' : 'asciimath'
-          elsif (default_stem_syntax = document.attributes['stem']).nil_or_empty?
-            'asciimath'
-          else
-            default_stem_syntax
-          end
-        end
+        attributes['style'] = STEM_TYPE_ALIASES[attributes[2] || doc_attrs['stem']] if block_context == :stem
         block = build_block(:stem, :raw, terminator, parent, reader, attributes)
 
       when :open, :sidebar
         block = build_block(block_context, :compound, terminator, parent, reader, attributes)
 
       when :table
-        block_reader = Reader.new reader.read_lines_until(:terminator => terminator, :skip_line_comments => true), reader.cursor
+        block_cursor = reader.cursor
+        block_reader = Reader.new reader.read_lines_until(:terminator => terminator, :skip_line_comments => true, :context => :table, :cursor => :at_mark), block_cursor
         # NOTE it's very rare that format is set when using a format hint char, so short-circuit
         unless terminator.start_with? '|', '!'
           # NOTE infer dsv once all other format hint chars are ruled out
@@ -873,32 +873,29 @@ class Parser
           end
         else
           # this should only happen if there's a misconfiguration
-          raise %(Unsupported block type #{block_context} at #{reader.line_info})
+          raise %(Unsupported block type #{block_context} at #{reader.cursor})
         end
       end
     end
 
     # FIXME we've got to clean this up, it's horrible!
-    block.source_location = source_location if source_location
+    block.source_location = reader.cursor_at_mark if document.sourcemap
     # FIXME title should be assigned when block is constructed
     block.title = attributes.delete 'title' if attributes.key? 'title'
-    #unless attributes.key? 'reftext'
-    #  attributes['reftext'] = document.attributes['reftext'] if document.attributes.key? 'reftext'
-    #end
     # TODO eventually remove the style attribute from the attributes hash
     #block.style = attributes.delete 'style'
     block.style = attributes['style']
     if (block_id = (block.id ||= attributes['id']))
       unless document.register :refs, [block_id, block, attributes['reftext'] || (block.title? ? block.title : nil)]
-        warn %(asciidoctor: WARNING: #{this_path}: line #{this_lineno}: id assigned to block already in use: #{block_id})
+        logger.warn message_with_context %(id assigned to block already in use: #{block_id}), :source_location => reader.cursor_at_mark
       end
     end
     # FIXME remove the need for this update!
     block.attributes.update(attributes) unless attributes.empty?
     block.lock_in_subs
 
-    #if document.attributes.key? :pending_attribute_entries
-    #  document.attributes.delete(:pending_attribute_entries).each do |entry|
+    #if doc_attrs.key? :pending_attribute_entries
+    #  doc_attrs.delete(:pending_attribute_entries).each do |entry|
     #    entry.save_to block.attributes
     #  end
     #end
@@ -1015,7 +1012,7 @@ class Parser
       end
       block_reader = nil
     elsif parse_as_content_model != :compound
-      lines = reader.read_lines_until :terminator => terminator, :skip_processing => skip_processing
+      lines = reader.read_lines_until :terminator => terminator, :skip_processing => skip_processing, :context => block_context, :cursor => :at_mark
       block_reader = nil
     # terminator is false when reader has already been prepared
     elsif terminator == false
@@ -1023,7 +1020,8 @@ class Parser
       block_reader = reader
     else
       lines = nil
-      block_reader = Reader.new reader.read_lines_until(:terminator => terminator, :skip_processing => skip_processing), reader.cursor
+      block_cursor = reader.cursor
+      block_reader = Reader.new reader.read_lines_until(:terminator => terminator, :skip_processing => skip_processing, :context => block_context, :cursor => :at_mark), block_cursor
     end
 
     if content_model == :verbatim
@@ -1081,27 +1079,24 @@ class Parser
   #
   # Returns nothing.
   def self.parse_blocks(reader, parent)
-    while ((block = next_block reader, parent) && parent << block) || reader.has_more_lines?
+    while ((block = next_block reader, parent) && parent.blocks << block) || reader.has_more_lines?
     end
   end
 
-  # Internal: Parse and construct an item list (ordered or unordered) from the current position of the Reader
+  # Internal: Parse and construct an ordered or unordered list at the current position of the Reader
   #
-  # reader    - The Reader from which to retrieve the outline list
+  # reader    - The Reader from which to retrieve the list
   # list_type - A Symbol representing the list type (:olist for ordered, :ulist for unordered)
-  # parent    - The parent Block to which this outline list belongs
+  # parent    - The parent Block to which this list belongs
+  # style     - The block style assigned to this list (optional, default: nil)
   #
-  # Returns the Block encapsulating the parsed outline (unordered or ordered) list
-  def self.next_item_list(reader, list_type, parent)
+  # Returns the Block encapsulating the parsed unordered or ordered list
+  def self.next_list(reader, list_type, parent, style = nil)
     list_block = List.new(parent, list_type)
-    if parent.context == list_type
-      list_block.level = parent.level + 1
-    else
-      list_block.level = 1
-    end
+    list_block.level = parent.context == list_type ? (parent.level + 1) : 1
 
-    while reader.has_more_lines? && (match = ListRxMap[list_type].match(reader.peek_line))
-      marker = resolve_list_marker(list_type, match[1])
+    while reader.has_more_lines? && ListRxMap[list_type] =~ reader.peek_line
+      match, marker = $~, resolve_list_marker(list_type, $1)
 
       # if we are moving to the next item, and the marker is different
       # determine if we are moving up or down in nesting
@@ -1122,7 +1117,7 @@ class Parser
       end
 
       if !list_block.items? || this_item_level == list_block.level
-        list_item = next_list_item(reader, list_block, match)
+        list_item = next_list_item(reader, list_block, match, nil, style)
       elsif this_item_level < list_block.level
         # leave this block
         break
@@ -1132,7 +1127,7 @@ class Parser
         list_block.items[-1] << next_block(reader, list_block)
       end
 
-      list_block << list_item if list_item
+      list_block.items << list_item if list_item
       list_item = nil
 
       reader.skip_blank_lines || break
@@ -1159,6 +1154,25 @@ class Parser
     found
   end
 
+  # Internal: Catalog a matched inline anchor.
+  #
+  # id       - The String id of the anchor
+  # reftext  - The optional String reference text of the anchor
+  # node     - The AbstractNode parent node of the anchor node
+  # location - The source location (file and line) where the anchor was found
+  # doc      - The document to which the node belongs; computed from node if not specified
+  #
+  # Returns nothing
+  def self.catalog_inline_anchor id, reftext, node, location, doc = nil
+    doc ||= node.document
+    reftext = doc.sub_attributes reftext if reftext && (reftext.include? ATTR_REF_HEAD)
+    unless doc.register :refs, [id, (Inline.new node, :anchor, reftext, :type => :ref, :id => id), reftext]
+      location = location.cursor if Reader === location
+      logger.warn message_with_context %(id assigned to anchor already in use: #{id}), :source_location => location
+    end
+    nil
+  end
+
   # Internal: Catalog any inline anchors found in the text (but don't convert)
   #
   # text     - The String text in which to look for inline anchors
@@ -1180,7 +1194,7 @@ class Parser
         end
       end
       unless document.register :refs, [id, (Inline.new block, :anchor, reftext, :type => :ref, :id => id), reftext]
-        warn %(asciidoctor: WARNING: #{document.reader.path}: id assigned to anchor already in use: #{id})
+        logger.warn message_with_context %(id assigned to anchor already in use: #{id}), :source_location => document.reader.cursor_at_prev_line
       end
     end if (text.include? '[[') || (text.include? 'or:')
     nil
@@ -1188,17 +1202,16 @@ class Parser
 
   # Internal: Catalog the bibliography inline anchor found in the start of the list item (but don't convert)
   #
-  # text     - The String text in which to look for an inline bibliography anchor
-  # block    - The ListItem block in which the reference should be searched
-  # document - The current document in which the reference is stored
+  # id      - The String id of the anchor
+  # reftext - The optional String reference text of the anchor
+  # node    - The AbstractNode parent node of the anchor node
+  # reader  - The source Reader for the current Document, positioned at the current list item
   #
   # Returns nothing
-  def self.catalog_inline_biblio_anchor text, block, document
-    if InlineBiblioAnchorRx =~ text
-      # QUESTION should we sub attributes in reftext (like with regular anchors)?
-      unless document.register :refs, [(id = $1), (Inline.new block, :anchor, (reftext = %([#{$2 || id}])), :type => :bibref, :id => id), reftext]
-        warn %(asciidoctor: WARNING: #{document.reader.path}: id assigned to bibliography anchor already in use: #{id})
-      end
+  def self.catalog_inline_biblio_anchor id, reftext, node, reader
+    # QUESTION should we sub attributes in reftext (like with regular anchors)?
+    unless node.document.register :refs, [id, (Inline.new node, :anchor, (styled_reftext = %([#{reftext || id}])), :type => :bibref, :id => id), styled_reftext]
+      logger.warn message_with_context %(id assigned to bibliography anchor already in use: #{id}), :source_location => reader.cursor
     end
     nil
   end
@@ -1220,12 +1233,10 @@ class Parser
     # NOTE skip the match on the first time through as we've already done it (emulates begin...while)
     while match || (reader.has_more_lines? && (match = sibling_pattern.match(reader.peek_line)))
       term, item = next_list_item(reader, list_block, match, sibling_pattern)
-      if previous_pair && !previous_pair[-1]
-        previous_pair.pop
+      if previous_pair && !previous_pair[1]
         previous_pair[0] << term
-        previous_pair << item
+        previous_pair[1] = item
       else
-        # FIXME this misses the automatic parent assignment
         list_block.items << (previous_pair = [[term], item])
       end
       match = nil
@@ -1234,9 +1245,9 @@ class Parser
     list_block
   end
 
-  # Internal: Parse and construct the next ListItem for the current bulleted
-  # (unordered or ordered) list Block, callout lists included, or the next
-  # term ListItem and description ListItem pair for the description list Block.
+  # Internal: Parse and construct the next ListItem for the current list Block
+  # (unordered, ordered, or callout list) or the term ListItem and description
+  # ListItem pair for the description list Block.
   #
   # First collect and process all the lines that constitute the next list
   # item for the parent list (according to its type). Next, parse those lines
@@ -1247,48 +1258,65 @@ class Parser
   # reader        - The Reader from which to retrieve the next list item
   # list_block    - The parent list Block of this ListItem. Also provides access to the list type.
   # match         - The match Array which contains the marker and text (first-line) of the ListItem
-  # sibling_trait - The list marker or the Regexp to match a sibling item
+  # sibling_trait - The list marker or the Regexp to match a sibling item (optional, default: nil)
+  # style         - The block style assigned to this list (optional, default: nil)
   #
   # Returns the next ListItem or ListItem pair (depending on the list type)
   # for the parent list Block.
-  def self.next_list_item(reader, list_block, match, sibling_trait = nil)
+  def self.next_list_item(reader, list_block, match, sibling_trait = nil, style = nil)
     if (list_type = list_block.context) == :dlist
-      list_term = ListItem.new(list_block, match[1])
-      list_item = ListItem.new(list_block, match[3])
-      has_text = !match[3].nil_or_empty?
-    else
-      # Create list item using first line as the text of the list item
-      text = match[2]
-      checkbox = false
-      if list_type == :ulist && text.start_with?('[')
-        if text.start_with?('[ ] ')
-          checkbox = true
-          checked = false
-          text = text[3..-1].lstrip
-        elsif text.start_with?('[x] ', '[*] ')
-          checkbox = true
-          checked = true
-          text = text[3..-1].lstrip
-        end
-      end
-      list_item = ListItem.new(list_block, text)
-
-      if checkbox
-        # FIXME checklist never makes it into the options attribute
-        list_block.attributes['checklist-option'] = ''
-        list_item.attributes['checkbox'] = ''
-        list_item.attributes['checked'] = '' if checked
+      dlist = true
+      list_term = ListItem.new(list_block, (term_text = match[1]))
+      if term_text.start_with?('[[') && LeadingInlineAnchorRx =~ term_text
+        catalog_inline_anchor $1, ($2 || $'.lstrip), list_term, reader
+      end
+      has_text = true if (item_text = match[3])
+      list_item = ListItem.new(list_block, item_text)
+      if list_block.document.sourcemap
+        list_term.source_location = reader.cursor
+        if has_text
+          list_item.source_location = list_term.source_location
+        else
+          sourcemap_assignment_deferred = true
+        end
       end
-
-      sibling_trait ||= resolve_list_marker(list_type, match[1], list_block.items.size, true, reader)
-      list_item.marker = sibling_trait
+    else
       has_text = true
+      list_item = ListItem.new(list_block, (item_text = match[2]))
+      list_item.source_location = reader.cursor if list_block.document.sourcemap
+      if list_type == :ulist
+        list_item.marker = (sibling_trait ||= match[1])
+        if item_text.start_with?('[')
+          if style && style == 'bibliography'
+            if InlineBiblioAnchorRx =~ item_text
+              catalog_inline_biblio_anchor $1, $2, list_item, reader
+            end
+          elsif item_text.start_with?('[[')
+            if LeadingInlineAnchorRx =~ item_text
+              catalog_inline_anchor $1, $2, list_item, reader
+            end
+          elsif item_text.start_with?('[ ] ', '[x] ', '[*] ')
+            # FIXME next_block wipes out update to options attribute
+            #list_block.set_option 'checklist' unless list_block.attributes['checklist-option']
+            list_block.attributes['checklist-option'] = ''
+            list_item.attributes['checkbox'] = ''
+            list_item.attributes['checked'] = '' unless item_text.start_with? '[ '
+            list_item.text = item_text.slice(4, item_text.length)
+          end
+        end
+      elsif list_type == :olist
+        list_item.marker = (sibling_trait ||= resolve_ordered_list_marker(match[1], list_block.items.size, true, reader))
+      else # :colist
+        list_item.marker = (sibling_trait ||= '<1>')
+      end
     end
 
-    # first skip the line with the marker / term
+    # first skip the line with the marker / term (it gets put back onto the reader by next_block)
     reader.shift
-    list_item_reader = Reader.new read_lines_for_list_item(reader, list_type, sibling_trait, has_text), reader.cursor
+    block_cursor = reader.cursor
+    list_item_reader = Reader.new read_lines_for_list_item(reader, list_type, sibling_trait, has_text), block_cursor
     if list_item_reader.has_more_lines?
+      list_item.source_location = block_cursor if sourcemap_assignment_deferred
       # NOTE peek on the other side of any comment lines
       comment_lines = list_item_reader.skip_line_comments
       if (subsequent_line = list_item_reader.peek_line)
@@ -1297,8 +1325,8 @@ class Parser
           content_adjacent = false
         else
           content_adjacent = true
-          # treat lines as paragraph text if continuation does not connect first block (i.e., has_text = false)
-          has_text = false unless list_type == :dlist
+          # treat lines as paragraph text if continuation does not connect first block (i.e., has_text = nil)
+          has_text = nil unless dlist
         end
       else
         # NOTE we have no use for any trailing comment lines we might have found
@@ -1306,24 +1334,22 @@ class Parser
         content_adjacent = false
       end
 
-      # only relevant for :dlist
-      options = {:text => !has_text}
+      # reader is confined to boundaries of list, which means only blocks will be found (no sections)
+      if (block = next_block(list_item_reader, list_item, (attrs = {}), :text => !has_text))
+        list_item.blocks << block
+      end
 
-      # we can look for blocks until lines are exhausted without worrying about
-      # sections since reader is confined to boundaries of list
-      while ((block = next_block list_item_reader, list_item, {}, options) && list_item << block) ||
-          list_item_reader.has_more_lines?
+      while list_item_reader.has_more_lines?
+        if (block = next_block(list_item_reader, list_item, attrs))
+          list_item.blocks << block
+        end
       end
 
       list_item.fold_first(continuation_connects_first_block, content_adjacent)
     end
 
-    if list_type == :dlist
-      if list_item.text? || list_item.blocks?
-        [list_term, list_item]
-      else
-        [list_term, nil]
-      end
+    if dlist
+      list_item.text? || list_item.blocks? ? [list_term, list_item] : [list_term]
     else
       list_item
     end
@@ -1396,7 +1422,7 @@ class Parser
           buffer << this_line
           # grab all the lines in the block, leaving the delimiters in place
           # we're being more strict here about the terminator, but I think that's a good thing
-          buffer.concat reader.read_lines_until(:terminator => match.terminator, :read_last_line => true)
+          buffer.concat reader.read_lines_until(:terminator => match.terminator, :read_last_line => true, :context => nil)
           continuation = :inactive
         else
           break
@@ -1528,58 +1554,57 @@ class Parser
   # reader     - the source reader
   # parent     - the parent Section or Document of this Section
   # attributes - a Hash of attributes to assign to this section (default: {})
+  #
+  # Returns the section [Block]
   def self.initialize_section reader, parent, attributes = {}
     document = parent.document
+    book = (doctype = document.doctype) == 'book'
     source_location = reader.cursor if document.sourcemap
-    sect_id, sect_reftext, sect_title, sect_level, atx = parse_section_title reader, document
+    sect_style = attributes[1]
+    sect_id, sect_reftext, sect_title, sect_level, sect_atx = parse_section_title reader, document, attributes['id']
+
     if sect_reftext
       attributes['reftext'] = sect_reftext
-    elsif attributes.key? 'reftext'
+    else
       sect_reftext = attributes['reftext']
-    #elsif document.attributes.key? 'reftext'
-    #  sect_reftext = attributes['reftext'] = document.attributes['reftext']
     end
 
-    # parse style, id, and role attributes from first positional attribute if present
-    style = attributes[1] ? (parse_style_attribute attributes, reader) : nil
-    if style
-      if style == 'abstract' && document.doctype == 'book'
+    if sect_style
+      if book && sect_style == 'abstract'
         sect_name, sect_level = 'chapter', 1
       else
-        sect_name, sect_special = style, true
+        sect_name, sect_special = sect_style, true
         sect_level = 1 if sect_level == 0
-        sect_numbered_force = style == 'appendix'
+        sect_numbered = sect_style == 'appendix'
       end
+    elsif book
+      sect_name = sect_level == 0 ? 'part' : (sect_level > 1 ? 'section' : 'chapter')
+    elsif doctype == 'manpage' && (sect_title.casecmp 'synopsis') == 0
+      sect_name, sect_special = 'synopsis', true
     else
-      case document.doctype
-      when 'book'
-        sect_name = sect_level == 0 ? 'part' : (sect_level == 1 ? 'chapter' : 'section')
-      when 'manpage'
-        if (sect_title.casecmp 'synopsis') == 0
-          sect_name, sect_special = 'synopsis', true
-        else
-          sect_name = 'section'
-        end
-      else
-        sect_name = 'section'
-      end
+      sect_name = 'section'
     end
 
-    section = Section.new parent, sect_level, false
+    section = Section.new parent, sect_level
     section.id, section.title, section.sectname, section.source_location = sect_id, sect_title, sect_name, source_location
-    # TODO honor special section numbering option (#661)
     if sect_special
       section.special = true
-      section.numbered = true if sect_numbered_force
-    elsif sect_level > 0 && (document.attributes.key? 'sectnums')
-      section.numbered = section.special ? (parent.context == :section && parent.numbered) : true
+      if sect_numbered
+        section.numbered = true
+      elsif document.attributes['sectnums'] == 'all'
+        section.numbered = book && sect_level == 1 ? :chapter : true
+      end
+    elsif document.attributes['sectnums'] && sect_level > 0
+      # NOTE a special section here is guaranteed to be nested in another section
+      section.numbered = section.special ? parent.numbered && true : true
+    elsif book && sect_level == 0 && document.attributes['partnums']
+      section.numbered = true
     end
 
     # generate an ID if one was not embedded or specified as anchor above section title
-    if (id = section.id ||= (attributes['id'] ||
-        ((document.attributes.key? 'sectids') ? (Section.generate_id section.title, document) : nil)))
+    if (id = section.id ||= ((document.attributes.key? 'sectids') ? (Section.generate_id section.title, document) : nil))
       unless document.register :refs, [id, section, sect_reftext || section.title]
-        warn %(asciidoctor: WARNING: #{reader.path}: line #{reader.lineno - (atx ? 1 : 2)}: id assigned to section already in use: #{id})
+        logger.warn message_with_context %(id assigned to section already in use: #{id}), :source_location => (reader.cursor_at_line reader.lineno - (sect_atx ? 1 : 2))
       end
     end
 
@@ -1596,12 +1621,13 @@ class Parser
   #
   # Returns the Integer section level if the Reader is positioned at a section title or nil otherwise
   def self.is_next_line_section?(reader, attributes)
-    if (style = attributes[1]) && (style.start_with? 'discrete', 'float') && (DiscreteHeadingStyleRx.match? style)
+    if (style = attributes[1]) && (style == 'discrete' || style == 'float')
       return
-    elsif reader.has_more_lines?
-      Compliance.underline_style_section_titles ?
-          is_section_title?(*reader.peek_lines(2, style && style == 'comment')) :
-          atx_section_title?(reader.peek_line)
+    elsif Compliance.underline_style_section_titles
+      next_lines = reader.peek_lines 2, style && style == 'comment'
+      is_section_title?(next_lines[0] || '', next_lines[1])
+    else
+      atx_section_title?(reader.peek_line || '')
     end
   end
 
@@ -1701,8 +1727,8 @@ class Parser
   # Returns an 5-element [Array] containing the id (String), reftext (String),
   # title (String), level (Integer), and flag (Boolean) indicating whether an
   # atx section title was matched, or nothing.
-  def self.parse_section_title(reader, document)
-    sect_id = sect_reftext = nil
+  def self.parse_section_title(reader, document, sect_id = nil)
+    sect_reftext = nil
     line1 = reader.read_line
 
     if Compliance.markdown_syntax ? ((line1.start_with? '=', '#') && ExtAtxSectionTitleRx =~ line1) :
@@ -1711,7 +1737,7 @@ class Parser
       sect_level, sect_title, atx = $1.length - 1, $2, true
       if sect_title.end_with?(']]') && InlineSectionAnchorRx =~ sect_title && !$1 # escaped
         sect_title, sect_id, sect_reftext = (sect_title.slice 0, sect_title.length - $&.length), $2, $3
-      end
+      end unless sect_id
     elsif Compliance.underline_style_section_titles && (line2 = reader.peek_line(true)) &&
         (sect_level = SETEXT_SECTION_LEVELS[line2_ch1 = line2.chr]) &&
         line2_ch1 * (line2_len = line2.length) == line2 && (sect_title = SetextSectionTitleRx =~ line1 && $1) &&
@@ -1719,10 +1745,10 @@ class Parser
       atx = false
       if sect_title.end_with?(']]') && InlineSectionAnchorRx =~ sect_title && !$1 # escaped
         sect_title, sect_id, sect_reftext = (sect_title.slice 0, sect_title.length - $&.length), $2, $3
-      end
+      end unless sect_id
       reader.shift
     else
-      raise %(Unrecognized section at #{reader.prev_line_info})
+      raise %(Unrecognized section at #{reader.cursor_at_prev_line})
     end
     sect_level += document.attr('leveloffset').to_i if document.attr?('leveloffset')
     [sect_id, sect_reftext, sect_title, sect_level, atx]
@@ -1758,7 +1784,7 @@ class Parser
   #  # => {'author' => 'Author Name', 'firstname' => 'Author', 'lastname' => 'Name', 'email' => 'author@example.org',
   #  #       'revnumber' => '1.0', 'revdate' => '2012-12-21', 'revremark' => 'Coincide w/ end of world.'}
   def self.parse_header_metadata(reader, document = nil)
-    # NOTE this will discard away any comment lines, but not skip blank lines
+    # NOTE this will discard any comment lines, but not skip blank lines
     process_attribute_entries reader, document
 
     metadata, implicit_author, implicit_authors = {}, nil, nil
@@ -1821,6 +1847,8 @@ class Parser
       process_attribute_entries reader, document
 
       reader.skip_blank_lines
+    else
+      author_metadata = {}
     end
 
     # process author attribute entries that override (or stand in for) the implicit author line
@@ -1863,7 +1891,9 @@ class Parser
         end
       end
 
-      unless author_metadata.empty?
+      if author_metadata.empty?
+        metadata['authorcount'] ||= (document.attributes['authorcount'] = 0)
+      else
         document.attributes.update author_metadata
 
         # special case
@@ -1887,22 +1917,23 @@ class Parser
   # returns a Hash of author metadata
   def self.process_authors author_line, names_only = false, multiple = true
     author_metadata = {}
+    author_idx = 0
     keys = ['author', 'authorinitials', 'firstname', 'middlename', 'lastname', 'email']
     author_entries = multiple ? (author_line.split ';').map {|it| it.strip } : Array(author_line)
-    author_entries.each_with_index do |author_entry, idx|
+    author_entries.each do |author_entry|
       next if author_entry.empty?
+      author_idx += 1
       key_map = {}
-      if idx == 0
+      if author_idx == 1
         keys.each do |key|
           key_map[key.to_sym] = key
         end
       else
         keys.each do |key|
-          key_map[key.to_sym] = %(#{key}_#{idx + 1})
+          key_map[key.to_sym] = %(#{key}_#{author_idx})
         end
       end
 
-      segments = nil
       if names_only # when parsing an attribute value
         # QUESTION should we rstrip author_entry?
         if author_entry.include? '<'
@@ -1939,20 +1970,20 @@ class Parser
         author_metadata[key_map[:authorinitials]] = fname.chr
       end
 
-      author_metadata['authorcount'] = idx + 1
-      # only assign the _1 attributes if there are multiple authors
-      if idx == 1
-        keys.each do |key|
-          author_metadata[%(#{key}_1)] = author_metadata[key] if author_metadata.key? key
-        end
-      end
-      if idx == 0
+      if author_idx == 1
         author_metadata['authors'] = author_metadata[key_map[:author]]
       else
+        # only assign the _1 attributes once we see the second author
+        if author_idx == 2
+          keys.each do |key|
+            author_metadata[%(#{key}_1)] = author_metadata[key] if author_metadata.key? key
+          end
+        end
         author_metadata['authors'] = %(#{author_metadata['authors']}, #{author_metadata[key_map[:author]]})
       end
     end
 
+    author_metadata['authorcount'] = author_idx
     author_metadata
   end
 
@@ -2012,7 +2043,11 @@ class Parser
             return true
           end
         elsif (next_line.end_with? ']') && BlockAttributeListRx =~ next_line
-          document.parse_attributes $1, [], :sub_input => true, :into => attributes
+          current_style = attributes[1]
+          # extract id, role, and options from first positional attribute and remove, if present
+          if (document.parse_attributes $1, [], :sub_input => true, :into => attributes)[1]
+            attributes[1] = (parse_style_attribute attributes, reader) || current_style
+          end
           return true
         end
       elsif normal && (next_line.start_with? '.')
@@ -2027,7 +2062,7 @@ class Parser
           return true
         elsif normal && '/' * (ll = next_line.length) == next_line
           unless ll == 3
-            reader.read_lines_until :skip_first_line => true, :preserve_last_line => true, :terminator => next_line, :skip_processing => true
+            reader.read_lines_until :terminator => next_line, :skip_first_line => true, :preserve_last_line => true, :skip_processing => true, :context => :comment
             return true
           end
         else
@@ -2041,6 +2076,9 @@ class Parser
     end
   end
 
+  # Process consecutive attribute entry lines, ignoring adjacent line comments and comment blocks.
+  #
+  # Returns nothing
   def self.process_attribute_entries reader, document, attributes = nil
     reader.skip_comment_lines
     while process_attribute_entry reader, document, attributes
@@ -2135,12 +2173,12 @@ class Parser
   #
   # Returns the String 0-index marker for this list item
   def self.resolve_list_marker(list_type, marker, ordinal = 0, validate = false, reader = nil)
-    if list_type == :olist
-      (marker.start_with? '.') ? marker : (resolve_ordered_list_marker marker, ordinal, validate, reader)
-    elsif list_type == :colist
-      '<1>'
-    else
+    if list_type == :ulist
       marker
+    elsif list_type == :olist
+      resolve_ordered_list_marker(marker, ordinal, validate, reader)
+    else # :colist
+      '<1>'
     end
   end
 
@@ -2166,6 +2204,7 @@ class Parser
   #
   # Returns the String of the first marker in this number series
   def self.resolve_ordered_list_marker(marker, ordinal = 0, validate = false, reader = nil)
+    return marker if marker.start_with? '.'
     expected = actual = nil
     case ORDERED_LIST_STYLES.find {|s| OrderedListMarkerRxMap[s].match? marker }
     when :arabic
@@ -2188,22 +2227,20 @@ class Parser
       marker = 'A.'
     when :lowerroman
       if validate
-        # TODO report this in roman numerals; see https://github.com/jamesshipton/roman-numeral/blob/master/lib/roman_numeral.rb
-        expected = ordinal + 1
-        actual = roman_numeral_to_int(marker.chop) # remove trailing ) and coerce to int
+        expected = Helpers.int_to_roman(ordinal + 1).downcase
+        actual = marker.chop # remove trailing )
       end
       marker = 'i)'
     when :upperroman
       if validate
-        # TODO report this in roman numerals; see https://github.com/jamesshipton/roman-numeral/blob/master/lib/roman_numeral.rb
-        expected = ordinal + 1
-        actual = roman_numeral_to_int(marker.chop) # remove trailing ) and coerce to int
+        expected = Helpers.int_to_roman(ordinal + 1)
+        actual = marker.chop # remove trailing )
       end
       marker = 'I)'
     end
 
     if validate && expected != actual
-      warn %(asciidoctor: WARNING: #{reader.line_info}: list item index: expected #{expected}, got #{actual})
+      logger.warn message_with_context %(list item index: expected #{expected}, got #{actual}), :source_location => reader.cursor
     end
 
     marker
@@ -2221,18 +2258,13 @@ class Parser
   def self.is_sibling_list_item?(line, list_type, sibling_trait)
     if ::Regexp === sibling_trait
       matcher = sibling_trait
-      expected_marker = false
     else
       matcher = ListRxMap[list_type]
       expected_marker = sibling_trait
     end
 
-    if (m = matcher.match(line))
-      if expected_marker
-        expected_marker == resolve_list_marker(list_type, m[1])
-      else
-        true
-      end
+    if matcher =~ line
+      expected_marker ? expected_marker == resolve_list_marker(list_type, $1) : true
     else
       false
     end
@@ -2263,7 +2295,7 @@ class Parser
     implicit_header = true unless skipped > 0 || (attributes.key? 'header-option') || (attributes.key? 'noheader-option')
 
     while (line = table_reader.read_line)
-      if (loop_idx += 1) > 0 && line.empty?
+      if (beyond_first = (loop_idx += 1) > 0) && line.empty?
         line = nil
         implicit_header_boundary += 1 if implicit_header_boundary
       elsif format == 'psv'
@@ -2285,58 +2317,63 @@ class Parser
         end
       end
 
-      # NOTE implicit header is offset by at least one blank line; implicit_header_boundary tracks size of gap
-      if loop_idx == 0 && implicit_header
-        if table_reader.has_more_lines? && table_reader.peek_line.empty?
-          implicit_header_boundary = 1
-        else
-          implicit_header = false
+      unless beyond_first
+        table_reader.mark
+        # NOTE implicit header is offset by at least one blank line; implicit_header_boundary tracks size of gap
+        if implicit_header
+          if table_reader.has_more_lines? && table_reader.peek_line.empty?
+            implicit_header_boundary = 1
+          else
+            implicit_header = false
+          end
         end
       end
 
       # this loop is used for flow control; internal logic controls how many times it executes
       while true
         if line && (m = parser_ctx.match_delimiter line)
+          pre_match, post_match = m.pre_match, m.post_match
           case format
           when 'csv'
-            if parser_ctx.buffer_has_unclosed_quotes? m.pre_match
-              break if (line = parser_ctx.skip_past_delimiter m).empty?
+            if parser_ctx.buffer_has_unclosed_quotes? pre_match
+              parser_ctx.skip_past_delimiter pre_match
+              break if (line = post_match).empty?
               redo
             end
-            parser_ctx.buffer = %(#{parser_ctx.buffer}#{m.pre_match})
+            parser_ctx.buffer = %(#{parser_ctx.buffer}#{pre_match})
           when 'dsv'
-            if m.pre_match.end_with? '\\'
-              if (line = parser_ctx.skip_past_escaped_delimiter m).empty?
+            if pre_match.end_with? '\\'
+              parser_ctx.skip_past_escaped_delimiter pre_match
+              if (line = post_match).empty?
                 parser_ctx.buffer = %(#{parser_ctx.buffer}#{LF})
                 parser_ctx.keep_cell_open
                 break
               end
               redo
             end
-            parser_ctx.buffer = %(#{parser_ctx.buffer}#{m.pre_match})
+            parser_ctx.buffer = %(#{parser_ctx.buffer}#{pre_match})
           else # psv
-            if m.pre_match.end_with? '\\'
-              if (line = parser_ctx.skip_past_escaped_delimiter m).empty?
+            if pre_match.end_with? '\\'
+              parser_ctx.skip_past_escaped_delimiter pre_match
+              if (line = post_match).empty?
                 parser_ctx.buffer = %(#{parser_ctx.buffer}#{LF})
                 parser_ctx.keep_cell_open
                 break
               end
               redo
             end
-            next_cellspec, cell_text = parse_cellspec m.pre_match
+            next_cellspec, cell_text = parse_cellspec pre_match
             parser_ctx.push_cellspec next_cellspec
             parser_ctx.buffer = %(#{parser_ctx.buffer}#{cell_text})
           end
           # don't break if empty to preserve empty cell found at end of line (see issue #1106)
-          line = nil if (line = m.post_match).empty?
+          line = nil if (line = post_match).empty?
           parser_ctx.close_cell
         else
           # no other delimiters to see here; suck up this line into the buffer and move on
           parser_ctx.buffer = %(#{parser_ctx.buffer}#{line}#{LF})
           case format
           when 'csv'
-            # QUESTION make stripping endlines in csv data an option? (unwrap-option?)
-            parser_ctx.buffer = %(#{parser_ctx.buffer.rstrip} )
             if parser_ctx.buffer_has_unclosed_quotes?
               implicit_header, implicit_header_boundary = false, nil if implicit_header_boundary && loop_idx == 0
               parser_ctx.keep_cell_open
@@ -2412,9 +2449,12 @@ class Parser
           end
         end
 
-        # to_i permits us to support percentage width by stripping the %
-        # NOTE this is slightly out of compliance w/ AsciiDoc, but makes way more sense
-        spec['width'] = (m[3] ? m[3].to_i : 1)
+        if (width = m[3])
+          # to_i will strip the optional %
+          spec['width'] = width == '~' ? -1 : width.to_i
+        else
+          spec['width'] = 1
+        end
 
         # make this an operation
         if m[4] && TableCellStyles.key?(m[4])
@@ -2527,7 +2567,11 @@ class Parser
       save_current = lambda {
         if collector.empty?
           unless type == :style
-            warn %(asciidoctor: WARNING:#{reader ? " #{reader.prev_line_info}:" : nil} invalid empty #{type} detected in style attribute)
+            if reader
+              logger.warn message_with_context %(invalid empty #{type} detected in style attribute), :source_location => reader.cursor_at_prev_line
+            else
+              logger.warn %(invalid empty #{type} detected in style attribute)
+            end
           end
         else
           case type
@@ -2535,7 +2579,11 @@ class Parser
             (parsed[type] ||= []) << collector.join
           when :id
             if parsed.key? :id
-              warn %(asciidoctor: WARNING:#{reader ? " #{reader.prev_line_info}:" : nil} multiple ids detected in style attribute)
+              if reader
+                logger.warn message_with_context 'multiple ids detected in style attribute', :source_location => reader.cursor_at_prev_line
+              else
+                logger.warn 'multiple ids detected in style attribute'
+              end
             end
             parsed[type] = collector.join
           else
@@ -2571,15 +2619,13 @@ class Parser
 
         attributes['id'] = parsed[:id] if parsed.key? :id
 
-        attributes['role'] = parsed[:role] * ' ' if parsed.key? :role
+        if parsed.key? :role
+          attributes['role'] = (existing_role = attributes['role']).nil_or_empty? ? (parsed[:role].join ' ') : %(#{existing_role} #{parsed[:role].join ' '})
+        end
 
         if parsed.key? :option
-          (options = parsed[:option]).each {|option| attributes[%(#{option}-option)] = '' }
-          if (existing_opts = attributes['options'])
-            attributes['options'] = (options + existing_opts.split(',')) * ','
-          else
-            attributes['options'] = options * ','
-          end
+          (opts = parsed[:option]).each {|opt| attributes[%(#{opt}-option)] = '' }
+          attributes['options'] = (existing_opts = attributes['options']).nil_or_empty? ? (opts.join ',') : %(#{existing_opts},#{opts.join ','})
         end
 
         parsed_style
@@ -2710,27 +2756,5 @@ class Parser
   def self.sanitize_attribute_name(name)
     name.gsub(InvalidAttributeNameCharsRx, '').downcase
   end
-
-  # Internal: Converts a Roman numeral to an integer value.
-  #
-  # value - The String Roman numeral to convert
-  #
-  # Returns the Integer for this Roman numeral
-  def self.roman_numeral_to_int(value)
-    value = value.downcase
-    digits = { 'i' => 1, 'v' => 5, 'x' => 10 }
-    result = 0
-
-    (0..value.length - 1).each {|i|
-      digit = digits[value[i..i]]
-      if i + 1 < value.length && digits[value[i+1..i+1]] > digit
-        result -= digit
-      else
-        result += digit
-      end
-    }
-
-    result
-  end
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/path_resolver.rb 1.5.7-1/lib/asciidoctor/path_resolver.rb
--- 1.5.6.2-2/lib/asciidoctor/path_resolver.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/path_resolver.rb	2018-05-05 22:54:38.000000000 +0000
@@ -7,7 +7,7 @@ module Asciidoctor
 # The main emphasis of the class is on creating clean and secure paths. Clean
 # paths are void of duplicate parent and current directory references in the
 # path name. Secure paths are paths which are restricted from accessing
-# directories outside of a jail root, if specified.
+# directories outside of a jail path, if specified.
 #
 # Since joining two paths can result in an insecure path, this class also
 # handles the task of joining a parent (start) and child (target) path.
@@ -94,13 +94,15 @@ module Asciidoctor
 #     => '/path/to/docs/images'
 #
 #     begin
-#       resolver.system_path('images', '/etc', '/path/to/docs')
+#       resolver.system_path('images', '/etc', '/path/to/docs', recover: false)
 #     rescue SecurityError => e
 #       puts e.message
 #     end
-#     => Start path /etc is outside of jail: /path/to/docs'
+#     => start path /etc is outside of jail: /path/to/docs'
 #
 class PathResolver
+  include Logging
+
   DOT = '.'
   DOT_DOT = '..'
   DOT_SLASH = './'
@@ -118,17 +120,14 @@ class PathResolver
   # expanded to an absolute path inside the constructor.
   #
   # file_separator - the String file separator to use for path operations
-  #                  (optional, default: File::SEPARATOR)
+  #                  (optional, default: File::ALT_SEPARATOR or File::SEPARATOR)
   # working_dir    - the String working directory (optional, default: Dir.pwd)
   #
   def initialize file_separator = nil, working_dir = nil
-    @file_separator = file_separator ? file_separator : (::File::ALT_SEPARATOR || ::File::SEPARATOR)
-    if working_dir
-      @working_dir = (root? working_dir) ? working_dir : (::File.expand_path working_dir)
-    else
-      @working_dir = ::File.expand_path ::Dir.pwd
-    end
-    @_partition_path_sys, @_partition_path_web = {}, {}
+    @file_separator = file_separator || ::File::ALT_SEPARATOR || ::File::SEPARATOR
+    @working_dir = working_dir ? ((root? working_dir) ? (posixify working_dir) : (::File.expand_path working_dir)) : ::Dir.pwd
+    @_partition_path_sys = {}
+    @_partition_path_web = {}
   end
 
   # Public: Check whether the specified path is an absolute path.
@@ -196,7 +195,26 @@ class PathResolver
   #
   # returns If path descends from base, return the offset, otherwise false.
   def descends_from? path, base
-    base == path ? 0 : ((path.start_with? base + '/') ? base.length + 1 : false)
+    if base == path
+      0
+    elsif base == SLASH
+      (path.start_with? SLASH) && 1
+    else
+      (path.start_with? base + SLASH) && (base.length + 1)
+    end
+  end
+
+  # Public: Calculate the relative path to this absolute path from the specified base directory
+  #
+  # If neither path or base are absolute paths, or the path is not contained
+  # within the base directory, no work is done.
+  #
+  # path - [String] an absolute filename.
+  # base - [String] an absolute base directory.
+  #
+  # Return the [String] relative path of the specified path calculated from the base directory.
+  def relative_path path, base
+    (root? path) && (offset = descends_from? path, base) ? (path.slice offset, path.length) : path
   end
 
   # Public: Normalize path by converting any backslashes to forward slashes
@@ -205,45 +223,46 @@ class PathResolver
   #
   # returns a String path with any backslashes replaced with forward slashes
   def posixify path
-    if path.nil_or_empty?
-      ''
-    elsif path.include? BACKSLASH
-      path.tr BACKSLASH, SLASH
+    if path
+      @file_separator == BACKSLASH && (path.include? BACKSLASH) ? (path.tr BACKSLASH, SLASH) : path
     else
-      path
+      ''
     end
   end
   alias posixfy posixify
 
-  # Public: Expand the path by resolving any parent references (..)
-  # and cleaning self references (.).
-  #
-  # The result will be relative if the path is relative and
-  # absolute if the path is absolute. The file separator used
-  # in the expanded path is the one specified when the class
-  # was constructed.
+  # Public: Expand the specified path by converting the path to a posix path, resolving parent
+  # references (..), and removing self references (.).
   #
   # path - the String path to expand
   #
-  # returns a String path with any parent or self references resolved.
+  # returns a String path as a posix path with parent references resolved and self references removed.
+  # The result will be relative if the path is relative and absolute if the path is absolute.
   def expand_path path
-    path_segments, path_root, _ = partition_path path
-    join_path path_segments, path_root
+    path_segments, path_root = partition_path path
+    if path.include? DOT_DOT
+      resolved_segments = []
+      path_segments.each do |segment|
+        segment == DOT_DOT ? resolved_segments.pop : resolved_segments << segment
+      end
+      join_path resolved_segments, path_root
+    else
+      join_path path_segments, path_root
+    end
   end
 
-  # Public: Partition the path into path segments and remove any empty segments
-  # or segments that are self references (.). The path is converted to a posix
-  # path before being partitioned.
+  # Public: Partition the path into path segments and remove self references (.) and the trailing
+  # slash, if present. Prior to being partitioned, the path is converted to a posix path.
+  #
+  # Parent references are not resolved by this method since the consumer often needs to handle this
+  # resolution in a certain context (checking for the breach of a jail, for instance).
   #
   # path - the String path to partition
   # web  - a Boolean indicating whether the path should be handled
   #        as a web path (optional, default: false)
   #
-  # Returns a 3-item Array containing the Array of String path segments, the
-  # path root (e.g., '/', './', 'c:/') if the path is absolute and the posix
-  # version of the path.
-  #--
-  # QUESTION is it worth it to normalize slashes? it doubles the time elapsed
+  # Returns a 2-item Array containing the Array of String path segments and the
+  # path root (e.g., '/', './', 'c:/', or '//'), which is nil unless the path is absolute.
   def partition_path path, web = nil
     if (result = (cache = web ? @_partition_path_web : @_partition_path_sys)[path])
       return result
@@ -251,56 +270,36 @@ class PathResolver
 
     posix_path = posixify path
 
-    root = if web
+    if web
       # ex. /sample/path
       if web_root? posix_path
-        SLASH
+        root = SLASH
       # ex. ./sample/path
       elsif posix_path.start_with? DOT_SLASH
-        DOT_SLASH
-      # ex. sample/path
-      else
-        nil
+        root = DOT_SLASH
+      # else ex. sample/path
       end
-    else
-      if root? posix_path
-        # ex. //sample/path
-        if unc? posix_path
-          DOUBLE_SLASH
-        # ex. /sample/path
-        elsif posix_path.start_with? SLASH
-          SLASH
-        # ex. C:/sample/path (or file:///sample/path in browser environment)
-        else
-          posix_path.slice 0, (posix_path.index SLASH) + 1
-        end
-      # ex. ./sample/path
-      elsif posix_path.start_with? DOT_SLASH
-        DOT_SLASH
-      # ex. sample/path
+    elsif root? posix_path
+      # ex. //sample/path
+      if unc? posix_path
+        root = DOUBLE_SLASH
+      # ex. /sample/path
+      elsif posix_path.start_with? SLASH
+        root = SLASH
+      # ex. C:/sample/path (or file:///sample/path in browser environment)
       else
-        nil
+        root = posix_path.slice 0, (posix_path.index SLASH) + 1
       end
+    # ex. ./sample/path
+    elsif posix_path.start_with? DOT_SLASH
+      root = DOT_SLASH
+    # else ex. sample/path
     end
 
-    path_segments = posix_path.split SLASH
-    # shift twice for a UNC path
-    if root == DOUBLE_SLASH
-      path_segments = path_segments[2..-1]
-    # shift twice for a file:/// path and adjust root
-    # NOTE technically file:/// paths work without this adjustment
-    #elsif ::RUBY_ENGINE_OPAL && ::JAVASCRIPT_IO_MODULE == 'xmlhttprequest' && root == 'file:/'
-    #  root = 'file://'
-    #  path_segments = path_segments[2..-1]
-    # shift once for any other root
-    elsif root
-      path_segments.shift
-    end
+    path_segments = (root ? (posix_path.slice root.length, posix_path.length) : posix_path).split SLASH
     # strip out all dot entries
     path_segments.delete DOT
-    # QUESTION should we chop trailing /? (we pay a small fraction)
-    #posix_path = posix_path.chop if posix_path.end_with? SLASH
-    cache[path] = [path_segments, root, posix_path]
+    cache[path] = [path_segments, root]
   end
 
   # Public: Join the segments using the posix file separator (since Ruby knows
@@ -317,110 +316,135 @@ class PathResolver
     root ? %(#{root}#{segments * SLASH}) : segments * SLASH
   end
 
-  # Public: Resolve a system path from the target and start paths. If a jail
-  # path is specified, enforce that the resolved directory is contained within
-  # the jail path. If a jail path is not provided, the resolved path may be
-  # any location on the system. If the resolved path is absolute, use it as is.
-  # If the resolved path is relative, resolve it relative to the working_dir
-  # specified in the constructor.
+  # Public: Securely resolve a system path
+  #
+  # Resolve a system path from the target relative to the start path, jail path, or working
+  # directory (specified in the constructor), in that order. If a jail path is specified, enforce
+  # that the resolved path descends from the jail path. If a jail path is not provided, the resolved
+  # path may be any location on the system. If the resolved path is absolute, use it as is (unless
+  # it breaches the jail path). Expand all parent and self references in the resolved path.
   #
   # target - the String target path
-  # start  - the String start (i.e., parent) path (default: nil)
-  # jail   - the String jail path to confine the resolved path (default: nil)
+  # start  - the String start path from which to resolve a relative target; falls back to jail, if
+  #          specified, or the working directory specified in the constructor (default: nil)
+  # jail   - the String jail path to which to confine the resolved path, if specified; must be an
+  #          absolute path (default: nil)
   # opts   - an optional Hash of options to control processing (default: {}):
-  #          * :recover is used to control whether the processor should auto-recover
-  #              when an illegal path is encountered
+  #          * :recover is used to control whether the processor should
+  #            automatically recover when an illegal path is encountered
   #          * :target_name is used in messages to refer to the path being resolved
   #
-  # returns a String path that joins the target path with the start path with
-  # any parent references resolved and self references removed and enforces
-  # that the resolved path be contained within the jail, if provided
+  # returns a String path relative to the start path, if specified, and confined to the jail path,
+  # if specified. The path is posixified and all parent and self references in the path are expanded.
   def system_path target, start = nil, jail = nil, opts = {}
     if jail
-      unless root? jail
-        raise ::SecurityError, %(Jail is not an absolute path: #{jail})
-      end
+      raise ::SecurityError, %(Jail is not an absolute path: #{jail}) unless root? jail
+      #raise ::SecurityError, %(Jail is not a canonical path: #{jail}) if jail.include? DOT_DOT
       jail = posixify jail
     end
 
-    if target.nil_or_empty?
-      target_segments = []
+    if target
+      if root? target
+        target_path = expand_path target
+        if jail && !(descends_from? target_path, jail)
+          if opts.fetch :recover, true
+            logger.warn %(#{opts[:target_name] || 'path'} is outside of jail; recovering automatically)
+            target_segments, _ = partition_path target_path
+            jail_segments, jail_root = partition_path jail
+            return join_path jail_segments + target_segments, jail_root
+          else
+            raise ::SecurityError, %(#{opts[:target_name] || 'path'} #{target} is outside of jail: #{jail} (disallowed in safe mode))
+          end
+        end
+        return target_path
+      else
+        target_segments, _ = partition_path target
+      end
     else
-      target_segments, target_root, _ = partition_path target
+      target_segments = []
     end
 
     if target_segments.empty?
       if start.nil_or_empty?
-        return jail ? jail : @working_dir
+        return jail || @working_dir
       elsif root? start
-        unless jail
+        if jail
+          start = posixify start
+        else
           return expand_path start
         end
       else
-        return system_path start, jail, jail, opts
+        target_segments, _ = partition_path start
+        start = jail || @working_dir
       end
-    end
-
-    if target_root && target_root != DOT_SLASH
-      resolved_target = join_path target_segments, target_root
-      # if target is absolute and a sub-directory of jail, or
-      # a jail is not in place, let it slide
-      if !jail || (resolved_target.start_with? jail)
-        return resolved_target
-      end
-    end
-
-    if start.nil_or_empty?
-      start = jail ? jail : @working_dir
+    elsif start.nil_or_empty?
+      start = jail || @working_dir
     elsif root? start
-      start = posixify start
+      start = posixify start if jail
     else
-      start = system_path start, jail, jail, opts
+      #start = system_path start, jail, jail, opts
+      start = %(#{(jail || @working_dir).chomp '/'}/#{start})
     end
 
-    # both jail and start have been posixfied at this point
-    if jail == start
-      jail_segments, jail_root, _ = partition_path jail
-      start_segments = jail_segments.dup
-    elsif jail
-      unless start.start_with? jail
-        raise ::SecurityError, %(#{opts[:target_name] || 'Start path'} #{start} is outside of jail: #{jail} (disallowed in safe mode))
+    # both jail and start have been posixified at this point if jail is set
+    if jail && (recheck = !(descends_from? start, jail)) && @file_separator == BACKSLASH
+      start_segments, start_root = partition_path start
+      jail_segments, jail_root = partition_path jail
+      if start_root != jail_root
+        if opts.fetch :recover, true
+          logger.warn %(start path for #{opts[:target_name] || 'path'} is outside of jail root; recovering automatically)
+          start_segments = jail_segments
+          recheck = false
+        else
+          raise ::SecurityError, %(start path for #{opts[:target_name] || 'path'} #{start} refers to location outside jail root: #{jail} (disallowed in safe mode))
+        end
       end
-
-      start_segments, start_root, _ = partition_path start
-      jail_segments, jail_root, _ = partition_path jail
-
-      # Already checked for this condition
-      #if start_root != jail_root
-      #  raise ::SecurityError, %(Jail root #{jail_root} does not match root of #{opts[:target_name] || 'start path'}: #{start_root})
-      #end
     else
-      start_segments, start_root, _ = partition_path start
-      jail_root = start_root
+      start_segments, jail_root = partition_path start
     end
 
-    resolved_segments = start_segments.dup
-    warned = false
-    target_segments.each do |segment|
-      if segment == DOT_DOT
-        if jail
-          if resolved_segments.size > jail_segments.size
-            resolved_segments.pop
-          elsif !(recover ||= (opts.fetch :recover, true))
-            raise ::SecurityError, %(#{opts[:target_name] || 'path'} #{target} refers to location outside jail: #{jail} (disallowed in safe mode))
-          elsif !warned
-            warn %(asciidoctor: WARNING: #{opts[:target_name] || 'path'} has illegal reference to ancestor of jail, auto-recovering)
-            warned = true
+    if (resolved_segments = start_segments + target_segments).include? DOT_DOT
+      unresolved_segments, resolved_segments = resolved_segments, []
+      if jail
+        jail_segments, _ = partition_path jail unless jail_segments
+        warned = false
+        unresolved_segments.each do |segment|
+          if segment == DOT_DOT
+            if resolved_segments.size > jail_segments.size
+              resolved_segments.pop
+            elsif opts.fetch :recover, true
+              unless warned
+                logger.warn %(#{opts[:target_name] || 'path'} has illegal reference to ancestor of jail; recovering automatically)
+                warned = true
+              end
+            else
+              raise ::SecurityError, %(#{opts[:target_name] || 'path'} #{target} refers to location outside jail: #{jail} (disallowed in safe mode))
+            end
+          else
+            resolved_segments << segment
           end
-        else
-          resolved_segments.pop
         end
       else
-        resolved_segments << segment
+        unresolved_segments.each do |segment|
+          segment == DOT_DOT ? resolved_segments.pop : resolved_segments << segment
+        end
       end
     end
 
-    join_path resolved_segments, jail_root
+    if recheck
+      target_path = join_path resolved_segments, jail_root
+      if descends_from? target_path, jail
+        target_path
+      elsif opts.fetch :recover, true
+        logger.warn %(#{opts[:target_name] || 'path'} is outside of jail; recovering automatically)
+        jail_segments, _ = partition_path jail unless jail_segments
+        join_path jail_segments + target_segments, jail_root
+      else
+        raise ::SecurityError, %(#{opts[:target_name] || 'path'} #{target} is outside of jail: #{jail} (disallowed in safe mode))
+      end
+    else
+      join_path resolved_segments, jail_root
+    end
   end
 
   # Public: Resolve a web path from the target and start paths.
@@ -460,7 +484,7 @@ class PathResolver
     #  end
     #end
 
-    target_segments, target_root, _ = partition_path target, true
+    target_segments, target_root = partition_path target, true
     resolved_segments = []
     target_segments.each do |segment|
       if segment == DOT_DOT
@@ -484,22 +508,5 @@ class PathResolver
 
     uri_prefix ? %(#{uri_prefix}#{resolved_path}) : resolved_path
   end
-
-  # Public: Calculate the relative path to this absolute filename from the specified base directory
-  #
-  # If either the filename or the base_directory are not absolute paths, or the
-  # filename is not contained within the base directory, no work is done.
-  #
-  # filename       - [String] an absolute filename.
-  # base_directory - [String] an absolute base directory.
-  #
-  # Return the [String] relative path of the filename calculated from the base directory.
-  def relative_path filename, base_directory
-    if (root? filename) && (filename.start_with? base_directory)
-      filename.slice base_directory.length + 1, filename.length
-    else
-      filename
-    end
-  end
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/reader.rb 1.5.7-1/lib/asciidoctor/reader.rb
--- 1.5.6.2-2/lib/asciidoctor/reader.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/reader.rb	2018-05-05 22:54:38.000000000 +0000
@@ -2,21 +2,21 @@
 module Asciidoctor
 # Public: Methods for retrieving lines from AsciiDoc source files
 class Reader
+  include Logging
+
   class Cursor
-    attr_accessor :file
-    attr_accessor :dir
-    attr_accessor :path
-    attr_accessor :lineno
-
-    def initialize file, dir = nil, path = nil, lineno = nil
-      @file = file
-      @dir = dir
-      @path = path
-      @lineno = lineno
+    attr_reader :file, :dir, :path, :lineno
+
+    def initialize file, dir = nil, path = nil, lineno = 1
+      @file, @dir, @path, @lineno = file, dir, path, lineno
+    end
+
+    def advance num
+      @lineno += num
     end
 
     def line_info
-      %(#{path}: line #{lineno})
+      %(#{@path}: line #{@lineno})
     end
 
     alias to_s line_info
@@ -35,10 +35,14 @@ class Reader
   # Public: Control whether lines are processed using Reader#process_line on first visit (default: true)
   attr_accessor :process_lines
 
+  # Public: Indicates that the end of the reader was reached with a delimited block still open.
+  attr_accessor :unterminated
+
   # Public: Initialize the Reader object
   def initialize data = nil, cursor = nil, opts = {}
     if !cursor
-      @file = @dir = nil
+      @file = nil
+      @dir = '.'
       @path = '<stdin>'
       @lineno = 1 # IMPORTANT lineno assignment must proceed prepare_lines call!
     elsif ::String === cursor
@@ -46,27 +50,22 @@ class Reader
       @dir, @path = ::File.split @file
       @lineno = 1 # IMPORTANT lineno assignment must proceed prepare_lines call!
     else
-      @file = cursor.file
-      @dir = cursor.dir
-      @path = cursor.path || '<stdin>'
-      if @file
-        unless @dir
-          # REVIEW might to look at this assignment closer
-          @dir = ::File.dirname @file
-          @dir = nil if @dir == '.' # right?
-        end
-
-        unless cursor.path
-          @path = ::File.basename @file
-        end
+      if (@file = cursor.file)
+        @dir = cursor.dir || (::File.dirname @file)
+        @path = cursor.path || (::File.basename @file)
+      else
+        @dir = cursor.dir || '.'
+        @path = cursor.path || '<stdin>'
       end
       @lineno = cursor.lineno || 1 # IMPORTANT lineno assignment must proceed prepare_lines call!
     end
     @lines = data ? (prepare_lines data, opts) : []
     @source_lines = @lines.dup
+    @mark = nil
     @look_ahead = 0
     @process_lines = true
     @unescape_next_line = false
+    @unterminated = nil
   end
 
   # Internal: Prepare the lines from the provided data
@@ -188,15 +187,15 @@ class Reader
   # be processed and marked as such so that subsequent reads will not need to process
   # the lines again.
   #
-  # num    - The positive Integer number of lines to peek (must be greater than 0).
-  # direct - A Boolean indicating whether processing should be disabled when reading lines
+  # num    - The positive Integer number of lines to peek or nil to peek all lines (default: nil).
+  # direct - A Boolean indicating whether processing should be disabled when reading lines (default: false).
   #
   # Returns A String Array of the next multiple lines of source data, or an empty Array
   # if there are no more lines in this Reader.
-  def peek_lines num, direct = false
+  def peek_lines num = nil, direct = false
     old_look_ahead = @look_ahead
     result = []
-    num.times do
+    (num || MAX_INT).times do
       if (line = direct ? shift : read_line)
         result << line
       else
@@ -331,44 +330,42 @@ class Reader
     end
   end
 
-  # Public: Skip consecutive lines containing line comments and return them.
+  # Public: Skip consecutive comment lines and block comments.
   #
   # Examples
   #   @lines
   #   => ["// foo", "bar"]
   #
   #   comment_lines = skip_comment_lines
-  #   => ["// foo"]
+  #   => nil
   #
   #   @lines
   #   => ["bar"]
   #
-  # Returns the Array of lines that were skipped
+  # Returns nothing
   def skip_comment_lines
-    return [] if empty?
+    return if empty?
 
-    comment_lines = []
     while (next_line = peek_line) && !next_line.empty?
       if next_line.start_with? '//'
         if next_line.start_with? '///'
           if (ll = next_line.length) > 3 && next_line == '/' * ll
-            comment_lines << shift
-            comment_lines.push(*(read_lines_until(:terminator => next_line, :read_last_line => true, :skip_processing => true)))
+            read_lines_until :terminator => next_line, :skip_first_line => true, :read_last_line => true, :skip_processing => true, :context => :comment
           else
             break
           end
         else
-          comment_lines << shift
+          shift
         end
       else
         break
       end
     end
 
-    comment_lines
+    nil
   end
 
-  # Public: Skip consecutive lines that are line comments and return them.
+  # Public: Skip consecutive comment lines and return them.
   #
   # This method assumes the reader only contains simple lines (no blocks).
   def skip_line_comments
@@ -402,8 +399,12 @@ class Reader
   #   a line for which the given block evals to true.
   #
   # options - an optional Hash of processing options:
+  #           * :terminator may be used to specify the contents of the line
+  #               at which the reader should stop
   #           * :break_on_blank_lines may be used to specify to break on
   #               blank lines
+  #           * :break_on_list_continuation may be used to specify to break
+  #               on a list continuation line
   #           * :skip_first_line may be used to tell the reader to advance
   #               beyond the first line before beginning the scan
   #           * :preserve_last_line may be used to specify that the String
@@ -412,6 +413,10 @@ class Reader
   #           * :read_last_line may be used to specify that the String
   #               causing the method to stop processing lines should be
   #               included in the lines being returned
+  #           * :skip_line_comments may be used to look for and skip
+  #               line comments
+  #           * :skip_processing is used to disable line (pre)processing
+  #               for the duration of this method
   #
   # Returns the Array of lines forming the next segment.
   #
@@ -429,15 +434,12 @@ class Reader
   #   => ["First line", "Second line"]
   def read_lines_until options = {}
     result = []
-    shift if options[:skip_first_line]
     if @process_lines && options[:skip_processing]
       @process_lines = false
       restore_process_lines = true
-    else
-      restore_process_lines = false
     end
-
     if (terminator = options[:terminator])
+      start_cursor = options[:cursor] || cursor
       break_on_blank_lines = false
       break_on_list_continuation = false
     else
@@ -445,10 +447,8 @@ class Reader
       break_on_list_continuation = options[:break_on_list_continuation]
     end
     skip_comments = options[:skip_line_comments]
-    line_read = false
-    line_restored = false
-
-    complete = false
+    complete = line_read = line_restored = nil
+    shift if options[:skip_first_line]
     while !complete && (line = read_line)
       complete = while true
         break true if terminator && line == terminator
@@ -461,7 +461,6 @@ class Reader
         break true if block_given? && (yield line)
         break false
       end
-
       if complete
         if options[:read_last_line]
           result << line
@@ -478,11 +477,15 @@ class Reader
         end
       end
     end
-
     if restore_process_lines
       @process_lines = true
       @look_ahead -= 1 if line_restored && !terminator
     end
+    if terminator && terminator != line && (context = options.fetch :context, terminator)
+      start_cursor = cursor_at_mark if start_cursor == :at_mark
+      logger.warn message_with_context %(unterminated #{context} block), :source_location => start_cursor
+      @unterminated = true
+    end
     result
   end
 
@@ -517,17 +520,37 @@ class Reader
     Cursor.new @file, @dir, @path, @lineno
   end
 
+  def cursor_at_line lineno
+    Cursor.new @file, @dir, @path, lineno
+  end
+
+  def cursor_at_mark
+    @mark ? Cursor.new(*@mark) : cursor
+  end
+
+  def cursor_before_mark
+    if @mark
+      m_file, m_dir, m_path, m_lineno = @mark
+      Cursor.new m_file, m_dir, m_path, m_lineno - 1
+    else
+      Cursor.new @file, @dir, @path, @lineno - 1
+    end
+  end
+
+  def cursor_at_prev_line
+    Cursor.new @file, @dir, @path, @lineno - 1
+  end
+
+  def mark
+    @mark = @file, @dir, @path, @lineno
+  end
+
   # Public: Get information about the last line read, including file name and line number.
   #
   # Returns A String summary of the last line read
   def line_info
     %(#{@path}: line #{@lineno})
   end
-  alias next_line_info line_info
-
-  def prev_line_info
-    %(#{@path}: line #{@lineno - 1})
-  end
 
   # Public: Get a copy of the remaining Array of String lines managed by this Reader
   #
@@ -550,16 +573,13 @@ class Reader
   #
   #
   # Returns A string summary of this reader, which contains the path and line information
-  def to_s
-    line_info
-  end
+  alias to_s line_info
 end
 
 # Public: Methods for retrieving lines from AsciiDoc source files, evaluating preprocessor
 # directives as each line is read off the Array of lines.
 class PreprocessorReader < Reader
   attr_reader :include_stack
-  attr_reader :includes
 
   # Public: Initialize the PreprocessorReader object
   def initialize document, data = nil, cursor = nil, opts = {}
@@ -580,7 +600,7 @@ class PreprocessorReader < Reader
     result = super
 
     # QUESTION should this work for AsciiDoc table cell content? Currently it does not.
-    if @document && (@document.attributes.key? 'skip-front-matter')
+    if @document && @document.attributes['skip-front-matter']
       if (front_matter = skip_front_matter! result)
         @document.attributes['front-matter'] = front_matter * LF
       end
@@ -635,7 +655,7 @@ class PreprocessorReader < Reader
           @look_ahead += 1
           line[1..-1]
         # QUESTION should we strip whitespace from raw attributes in Substitutors#parse_attributes? (check perf)
-        elsif preprocess_include_directive $2, $3.strip
+        elsif preprocess_include_directive $2, $3
           # peek again since the content has changed
           nil
         else
@@ -720,12 +740,12 @@ class PreprocessorReader < Reader
 
     if keyword == 'endif'
       if @conditional_stack.empty?
-        warn %(asciidoctor: ERROR: #{line_info}: unmatched macro: endif::#{target}[])
+        logger.error message_with_context %(unmatched macro: endif::#{target}[]), :source_location => cursor
       elsif no_target || target == (pair = @conditional_stack[-1])[:target]
         @conditional_stack.pop
         @skipping = @conditional_stack.empty? ? false : @conditional_stack[-1][:skipping]
       else
-        warn %(asciidoctor: ERROR: #{line_info}: mismatched macro: endif::#{target}[], expected endif::#{pair[:target]}[])
+        logger.error message_with_context %(mismatched macro: endif::#{target}[], expected endif::#{pair[:target]}[]), :source_location => cursor
       end
       return true
     end
@@ -825,14 +845,14 @@ class PreprocessorReader < Reader
     if ((expanded_target = target).include? ATTR_REF_HEAD) &&
         (expanded_target = @document.sub_attributes target, :attribute_missing => 'drop-line').empty?
       shift
-      if @document.attributes.fetch('attribute-missing', Compliance.attribute_missing) == 'skip'
+      if (@document.attributes['attribute-missing'] || Compliance.attribute_missing) == 'skip'
         unshift %(Unresolved directive in #{@path} - include::#{target}[#{attrlist}])
       end
       true
     elsif include_processors? && (ext = @include_processor_extensions.find {|candidate| candidate.instance.handles? expanded_target })
       shift
       # FIXME parse attributes only if requested by extension
-      ext.process_method[@document, self, expanded_target, AttributeList.new(attrlist).parse]
+      ext.process_method[@document, self, expanded_target, attrlist ? (AttributeList.new attrlist).parse : {}]
       true
     # if running in SafeMode::SECURE or greater, don't process this directive
     # however, be friendly and at least make it a link to the source document
@@ -841,48 +861,39 @@ class PreprocessorReader < Reader
       replace_next_line %(link:#{expanded_target}[])
     elsif (abs_maxdepth = @maxdepth[:abs]) > 0
       if @include_stack.size >= abs_maxdepth
-        warn %(asciidoctor: ERROR: #{line_info}: maximum include depth of #{@maxdepth[:rel]} exceeded)
+        logger.error message_with_context %(maximum include depth of #{@maxdepth[:rel]} exceeded), :source_location => cursor
         return
       end
 
-      parsed_attributes = attrlist.empty? ? {} : (AttributeList.new attrlist).parse
+      parsed_attributes = attrlist ? (AttributeList.new attrlist).parse : {}
       inc_path, target_type, relpath = resolve_include_path expanded_target, attrlist, parsed_attributes
       return inc_path unless target_type
 
       inc_linenos = inc_tags = nil
-      unless parsed_attributes.empty?
+      if attrlist
         if parsed_attributes.key? 'lines'
           inc_linenos = []
           parsed_attributes['lines'].split(DataDelimiterRx).each do |linedef|
             if linedef.include?('..')
               from, to = linedef.split('..', 2).map {|it| it.to_i }
-              if to == -1
-                inc_linenos << from
-                inc_linenos << 1.0/0.0
-              else
-                inc_linenos.concat ::Range.new(from, to).to_a
-              end
+              inc_linenos += to < 0 ? [from, 1.0/0.0] : ::Range.new(from, to).to_a
             else
               inc_linenos << linedef.to_i
             end
           end
           inc_linenos = inc_linenos.empty? ? nil : inc_linenos.sort.uniq
         elsif parsed_attributes.key? 'tag'
-          unless (tag = parsed_attributes['tag']).empty?
-            if tag.start_with? '!'
-              inc_tags = { (tag.slice 1, tag.length) => false } unless tag == '!'
-            else
-              inc_tags = { tag => true }
-            end
+          unless (tag = parsed_attributes['tag']).empty? || tag == '!'
+            inc_tags = (tag.start_with? '!') ? { (tag.slice 1, tag.length) => false } : { tag => true }
           end
         elsif parsed_attributes.key? 'tags'
           inc_tags = {}
           parsed_attributes['tags'].split(DataDelimiterRx).each do |tagdef|
             if tagdef.start_with? '!'
-              inc_tags[tagdef.slice 1, tagdef.length] = false unless tagdef == '!'
+              inc_tags[tagdef.slice 1, tagdef.length] = false
             else
               inc_tags[tagdef] = true
-            end unless tagdef.empty?
+            end unless tagdef.empty? || tagdef == '!'
           end
           inc_tags = nil if inc_tags.empty?
         end
@@ -891,16 +902,16 @@ class PreprocessorReader < Reader
       if inc_linenos
         inc_lines, inc_offset, inc_lineno = [], nil, 0
         begin
-          open(inc_path, 'r') do |f|
+          open(inc_path, 'rb') do |f|
+            select_remaining = nil
             f.each_line do |l|
               inc_lineno += 1
-              select = inc_linenos[0]
-              if ::Float === select && select.infinite?
+              if select_remaining || (::Float === (select = inc_linenos[0]) && (select_remaining = select.infinite?))
                 # NOTE record line where we started selecting
                 inc_offset ||= inc_lineno
                 inc_lines << l
               else
-                if inc_lineno == select
+                if select == inc_lineno
                   # NOTE record line where we started selecting
                   inc_offset ||= inc_lineno
                   inc_lines << l
@@ -911,12 +922,15 @@ class PreprocessorReader < Reader
             end
           end
         rescue
-          warn %(asciidoctor: WARNING: #{line_info}: include #{target_type} not readable: #{inc_path})
+          logger.error message_with_context %(include #{target_type} not readable: #{inc_path}), :source_location => cursor
           return replace_next_line %(Unresolved directive in #{@path} - include::#{expanded_target}[#{attrlist}])
         end
         shift
         # FIXME not accounting for skipped lines in reader line numbering
-        push_include inc_lines, inc_path, relpath, inc_offset, parsed_attributes if inc_offset
+        if inc_offset
+          parsed_attributes['partial-option'] = true
+          push_include inc_lines, inc_path, relpath, inc_offset, parsed_attributes
+        end
       elsif inc_tags
         inc_lines, inc_offset, inc_lineno, tag_stack, tags_used, active_tag = [], nil, 0, [], ::Set.new, nil
         if inc_tags.key? '**'
@@ -930,37 +944,35 @@ class PreprocessorReader < Reader
           select = base_select = !(inc_tags.value? true)
           wildcard = inc_tags.delete '*'
         end
-        if (ext_idx = inc_path.rindex '.') && (circ_cmt = CIRCUMFIX_COMMENTS[inc_path.slice ext_idx, inc_path.length])
-          cmt_suffix_len = (tag_suffix = %([] #{circ_cmt[:suffix]})).length - 2
-        end
         begin
-          open(inc_path, 'r') do |f|
+          open(inc_path, 'rb') do |f|
+            dbl_co, dbl_sb = '::', '[]'
+            encoding = ::Encoding::UTF_8 if COERCE_ENCODING
             f.each_line do |l|
               inc_lineno += 1
               # must force encoding since we're performing String operations on line
-              l.force_encoding ::Encoding::UTF_8 if FORCE_ENCODING
-              if (((tl = l.chomp).end_with? '[]') ||
-                  (tag_suffix && (tl.end_with? tag_suffix) && (tl = tl.slice 0, tl.length - cmt_suffix_len))) &&
-                  TagDirectiveRx =~ tl
+              l.force_encoding encoding if encoding
+              if (l.include? dbl_co) && (l.include? dbl_sb) && TagDirectiveRx =~ l
                 if $1 # end tag
                   if (this_tag = $2) == active_tag
                     tag_stack.pop
                     active_tag, select = tag_stack.empty? ? [nil, base_select] : tag_stack[-1]
                   elsif inc_tags.key? this_tag
+                    include_cursor = create_include_cursor inc_path, expanded_target, inc_lineno
                     if (idx = tag_stack.rindex {|key, _| key == this_tag })
                       idx == 0 ? tag_stack.shift : (tag_stack.delete_at idx)
-                      warn %(asciidoctor: WARNING: #{expanded_target}: line #{inc_lineno}: mismatched end tag in include: expected #{active_tag}, found #{this_tag})
+                      logger.warn message_with_context %(mismatched end tag (expected '#{active_tag}' but found '#{this_tag}') at line #{inc_lineno} of include #{target_type}: #{inc_path}), :source_location => cursor, :include_location => include_cursor
                     else
-                      warn %(asciidoctor: WARNING: #{expanded_target}: line #{inc_lineno}: unexpected end tag in include: #{this_tag})
+                      logger.warn message_with_context %(unexpected end tag '#{this_tag}' at line #{inc_lineno} of include #{target_type}: #{inc_path}), :source_location => cursor, :include_location => include_cursor
                     end
                   end
                 elsif inc_tags.key?(this_tag = $2)
                   tags_used << this_tag
                   # QUESTION should we prevent tag from being selected when enclosing tag is excluded?
-                  tag_stack << [(active_tag = this_tag), (select = inc_tags[this_tag])]
+                  tag_stack << [(active_tag = this_tag), (select = inc_tags[this_tag]), inc_lineno]
                 elsif !wildcard.nil?
                   select = active_tag && !select ? false : wildcard
-                  tag_stack << [(active_tag = this_tag), select]
+                  tag_stack << [(active_tag = this_tag), select, inc_lineno]
                 end
               elsif select
                 # NOTE record the line where we started selecting
@@ -970,29 +982,35 @@ class PreprocessorReader < Reader
             end
           end
         rescue
-          warn %(asciidoctor: WARNING: #{line_info}: include #{target_type} not readable: #{inc_path})
+          logger.error message_with_context %(include #{target_type} not readable: #{inc_path}), :source_location => cursor
           return replace_next_line %(Unresolved directive in #{@path} - include::#{expanded_target}[#{attrlist}])
         end
+        unless tag_stack.empty?
+          tag_stack.each do |tag_name, _, tag_lineno|
+            logger.warn message_with_context %(detected unclosed tag '#{tag_name}' starting at line #{tag_lineno} of include #{target_type}: #{inc_path}), :source_location => cursor, :include_location => (create_include_cursor inc_path, expanded_target, tag_lineno)
+          end
+        end
         unless (missing_tags = inc_tags.keys.to_a - tags_used.to_a).empty?
-          warn %(asciidoctor: WARNING: #{line_info}: tag#{missing_tags.size > 1 ? 's' : nil} '#{missing_tags * ','}' not found in include #{target_type}: #{inc_path})
+          logger.warn message_with_context %(tag#{missing_tags.size > 1 ? 's' : ''} '#{missing_tags.join ', '}' not found in include #{target_type}: #{inc_path}), :source_location => cursor
         end
         shift
-        # FIXME not accounting for skipped lines in reader line numbering
-        push_include inc_lines, inc_path, relpath, inc_offset, parsed_attributes if inc_offset
+        if inc_offset
+          parsed_attributes['partial-option'] = true unless base_select && wildcard && inc_tags.empty?
+          # FIXME not accounting for skipped lines in reader line numbering
+          push_include inc_lines, inc_path, relpath, inc_offset, parsed_attributes
+        end
       else
         begin
           # NOTE read content first so that we only advance cursor if IO operation succeeds
-          inc_content = target_type == :file ? (::IO.read inc_path) : open(inc_path, 'r') {|f| f.read }
+          inc_content = target_type == :file ? (::IO.binread inc_path) : open(inc_path, 'rb') {|f| f.read }
           shift
           push_include inc_content, inc_path, relpath, 1, parsed_attributes
         rescue
-          warn %(asciidoctor: WARNING: #{line_info}: include #{target_type} not readable: #{inc_path})
+          logger.error message_with_context %(include #{target_type} not readable: #{inc_path}), :source_location => cursor
           return replace_next_line %(Unresolved directive in #{@path} - include::#{expanded_target}[#{attrlist}])
         end
       end
       true
-    else
-      false
     end
   end
 
@@ -1015,9 +1033,10 @@ class PreprocessorReader < Reader
   # Returns An Array containing the resolved (absolute) include path, the target type, and the path
   # relative to the outermost document. May also return a boolean to halt processing of the include.
   def resolve_include_path target, attrlist, attributes
-    if Helpers.uriish? target
-      return replace_next_line %(link:#{target}[#{attrlist}]) unless @document.attributes.key? 'allow-uri-read'
-      if @document.attributes.key? 'cache-uri'
+    doc = @document
+    if (Helpers.uriish? target) || (::String === @dir ? nil : (target = %(#{@dir}/#{target})))
+      return replace_next_line %(link:#{target}[#{attrlist}]) unless doc.attr? 'allow-uri-read'
+      if doc.attr? 'cache-uri'
         # caching requires the open-uri-cached gem to be installed
         # processing will be automatically aborted if these libraries can't be opened
         Helpers.require_library 'open-uri/cached', 'open-uri-cached' unless defined? ::OpenURI::Cache
@@ -1025,17 +1044,22 @@ class PreprocessorReader < Reader
         # autoload open-uri
         ::OpenURI
       end
-      [target, :uri, target]
+      [(::URI.parse target), :uri, target]
     else
       # include file is resolved relative to dir of current include, or base_dir if within original docfile
-      inc_path = @document.normalize_system_path target, @dir, nil, :target_name => 'include file'
+      inc_path = doc.normalize_system_path target, @dir, nil, :target_name => 'include file'
       unless ::File.file? inc_path
-        warn %(asciidoctor: WARNING: #{line_info}: include file not found: #{inc_path})
-        return replace_next_line %(Unresolved directive in #{@path} - include::#{target}[#{attrlist}])
+        if attributes.key? 'optional-option'
+          shift
+          return true
+        else
+          logger.error message_with_context %(include file not found: #{inc_path}), :source_location => cursor
+          return replace_next_line %(Unresolved directive in #{@path} - include::#{target}[#{attrlist}])
+        end
       end
       # NOTE relpath is the path relative to the root document (or base_dir, if set)
       # QUESTION should we move relative_path method to Document
-      relpath = (@path_resolver ||= PathResolver.new).relative_path inc_path, @document.base_dir
+      relpath = doc.path_resolver.relative_path inc_path, doc.base_dir
       [inc_path, :file, relpath]
     end
   end
@@ -1056,20 +1080,29 @@ class PreprocessorReader < Reader
   # Returns this Reader object.
   def push_include data, file = nil, path = nil, lineno = 1, attributes = {}
     @include_stack << [@lines, @file, @dir, @path, @lineno, @maxdepth, @process_lines]
-    if file
-      @file = file
-      @dir = File.dirname file
+    if (@file = file)
+      # NOTE if file is not a string, assume it's a URI
+      if ::String === file
+        @dir = ::File.dirname file
+      elsif ::RUBY_ENGINE_OPAL
+        @dir = ::URI.parse ::File.dirname(file = file.to_s)
+      else
+        # NOTE this intentionally throws an error if URI has no path
+        (@dir = file.dup).path = (dir = ::File.dirname file.path) == '/' ? '' : dir
+        file = file.to_s
+      end
+      path ||= ::File.basename file
       # only process lines in AsciiDoc files
       @process_lines = ASCIIDOC_EXTENSIONS[::File.extname file]
     else
-      @file = nil
-      @dir = '.' # right?
+      @dir = '.'
       # we don't know what file type we have, so assume AsciiDoc
       @process_lines = true
     end
 
     if path
-      @includes << Helpers.rootname(@path = path)
+      @path = path
+      @includes[Helpers.rootname path] = attributes['partial-option'] ? nil : true if @process_lines
     else
       @path = '<stdin>'
     end
@@ -1108,6 +1141,18 @@ class PreprocessorReader < Reader
     self
   end
 
+  def create_include_cursor file, path, lineno
+    if ::String === file
+      dir = ::File.dirname file
+    elsif ::RUBY_ENGINE_OPAL
+      dir = ::File.dirname(file = file.to_s)
+    else
+      dir = (dir = ::File.dirname file.path) == '' ? '/' : dir
+      file = file.to_s
+    end
+    Cursor.new file, dir, path, lineno
+  end
+
   def pop_include
     if @include_stack.size > 0
       @lines, @file, @dir, @path, @lineno, @maxdepth, @process_lines = @include_stack.pop
diff -pruN 1.5.6.2-2/lib/asciidoctor/section.rb 1.5.7-1/lib/asciidoctor/section.rb
--- 1.5.6.2-2/lib/asciidoctor/section.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/section.rb	2018-05-05 22:54:38.000000000 +0000
@@ -38,14 +38,19 @@ class Section < AbstractBlock
 
   # Public: Initialize an Asciidoctor::Section object.
   #
-  # parent - The parent Asciidoc Object.
-  def initialize parent = nil, level = nil, numbered = true, opts = {}
+  # parent   - The parent AbstractBlock. If set, must be a Document or Section object (default: nil)
+  # level    - The Integer level of this section (default: 1 more than parent level or 1 if parent not defined)
+  # numbered - A Boolean indicating whether numbering is enabled for this Section (default: false)
+  # opts     - An optional Hash of options (default: {})
+  def initialize parent = nil, level = nil, numbered = false, opts = {}
     super parent, :section, opts
-    @level = level ? level : (parent ? (parent.level + 1) : 1)
-    @numbered = numbered && @level > 0
-    @special = parent && parent.context == :section && parent.special
+    if Section === parent
+      @level, @special = level || (parent.level + 1), parent.special
+    else
+      @level, @special = level || 1, false
+    end
+    @numbered = numbered
     @index = 0
-    @number = 1
   end
 
   # Public: The name of this section, an alias of the section title
@@ -60,10 +65,12 @@ class Section < AbstractBlock
 
   # Public: Get the section number for the current Section
   #
-  # The section number is a unique, dot separated String
-  # where each entry represents one level of nesting and
-  # the value of each entry is the 1-based outline number
-  # of the Section amongst its numbered sibling Sections
+  # The section number is a dot-separated String that uniquely describes the position of this
+  # Section in the document. Each entry represents a level of nesting. The value of each entry is
+  # the 1-based outline number of the Section amongst its numbered sibling Sections.
+  #
+  # This method assumes that both the @level and @parent instance variables have been assigned.
+  # The method also assumes that the value of @parent is either a Document or Section.
   #
   # delimiter - the delimiter to separate the number for each level
   # append    - the String to append at the end of the section number
@@ -103,10 +110,12 @@ class Section < AbstractBlock
   # Returns the section number as a String
   def sectnum(delimiter = '.', append = nil)
     append ||= (append == false ? '' : delimiter)
-    if @level && @level > 1 && @parent && @parent.context == :section
-      %(#{@parent.sectnum(delimiter)}#{@number}#{append})
-    else
+    if @level == 1
       %(#{@number}#{append})
+    elsif @level > 1
+      Section === @parent ? %(#{@parent.sectnum(delimiter)}#{@number}#{append}) : %(#{@number}#{append})
+    else # @level == 0
+      %(#{Helpers.int_to_roman @number}#{append})
     end
   end
 
@@ -153,7 +162,7 @@ class Section < AbstractBlock
   #
   # Returns The parent Block
   def << block
-    enumerate_section block if block.context == :section
+    assign_numeral block if block.context == :section
     super
   end
 
@@ -169,32 +178,40 @@ class Section < AbstractBlock
   # Public: Generate a String ID from the given section title.
   #
   # The generated ID is prefixed with value of the 'idprefix' attribute, which
-  # is an underscore by default. Invalid characters are replaced with the
-  # value of the 'idseparator' attribute, which is an underscore by default.
+  # is an underscore (_) by default. Invalid characters are then removed and
+  # spaces are replaced with the value of the 'idseparator' attribute, which is
+  # an underscore (_) by default.
   #
-  # If the generated ID is already in use in the document, a count is appended
-  # until a unique id is found.
+  # If the generated ID is already in use in the document, a count is appended,
+  # offset by the separator, until a unique ID is found.
   #
-  # Section ID generation can be disabled by undefining the 'sectids' attribute.
+  # Section ID generation can be disabled by unsetting the 'sectids' document attribute.
   #
   # Examples
   #
   #   Section.generate_id 'Foo', document
   #   => "_foo"
   #
+  # Returns the generated [String] ID.
   def self.generate_id title, document
     attrs = document.attributes
-    sep = attrs['idseparator'] || '_'
     pre = attrs['idprefix'] || '_'
-    gen_id = %(#{pre}#{title.downcase.gsub InvalidSectionIdCharsRx, sep})
-    unless sep.empty?
-      # remove repeat and trailing separator characters
-      gen_id = gen_id.tr_s sep, sep
-      gen_id = gen_id.chop if gen_id.end_with? sep
-      # ensure id doesn't begin with idseparator if idprefix is empty and idseparator is not empty
-      if pre.empty?
-        gen_id = gen_id.slice 1, gen_id.length while gen_id.start_with? sep
+    if (sep = attrs['idseparator'])
+      if sep.length == 1 || (!(no_sep = sep.empty?) && (sep = attrs['idseparator'] = sep.chr))
+        sep_sub = sep == '-' || sep == '.' ? ' .-' : %( #{sep}.-)
       end
+    else
+      sep, sep_sub = '_', ' _.-'
+    end
+    gen_id = %(#{pre}#{title.downcase.gsub InvalidSectionIdCharsRx, ''})
+    if no_sep
+      gen_id = gen_id.delete ' '
+    else
+      # replace space with separator and remove repeating and trailing separator characters
+      gen_id = gen_id.tr_s sep_sub, sep
+      gen_id = gen_id.chop if gen_id.end_with? sep
+      # ensure id doesn't begin with idseparator if idprefix is empty (assuming idseparator is not empty)
+      gen_id = gen_id.slice 1, gen_id.length if pre.empty? && (gen_id.start_with? sep)
     end
     if document.catalog[:ids].key? gen_id
       ids, cnt = document.catalog[:ids], Compliance.unique_id_start_index
diff -pruN 1.5.6.2-2/lib/asciidoctor/stylesheets.rb 1.5.7-1/lib/asciidoctor/stylesheets.rb
--- 1.5.6.2-2/lib/asciidoctor/stylesheets.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/stylesheets.rb	2018-05-05 22:54:38.000000000 +0000
@@ -8,6 +8,7 @@ class Stylesheets
   DEFAULT_STYLESHEET_NAME = 'asciidoctor.css'
   DEFAULT_PYGMENTS_STYLE = 'default'
   STYLESHEETS_DATA_PATH = ::File.join DATA_PATH, 'stylesheets'
+  PygmentsBgColorRx = /^\.pygments +\{ *background: *([^;]+);/
 
   @__instance__ = new
 
@@ -23,7 +24,7 @@ class Stylesheets
   #
   # returns the [String] Asciidoctor stylesheet data
   def primary_stylesheet_data
-    @primary_stylesheet_data ||= ::IO.read(::File.join(STYLESHEETS_DATA_PATH, 'asciidoctor-default.css')).chomp
+    @primary_stylesheet_data ||= ::IO.read(::File.join(STYLESHEETS_DATA_PATH, 'asciidoctor-default.css')).rstrip
   end
 
   def embed_primary_stylesheet
@@ -48,7 +49,7 @@ class Stylesheets
     # unless load_coderay.nil?
     #   ::CodeRay::Encoders[:html]::CSS.new(:default).stylesheet
     # end
-    @coderay_stylesheet_data ||= ::IO.read(::File.join(STYLESHEETS_DATA_PATH, 'coderay-asciidoctor.css')).chomp
+    @coderay_stylesheet_data ||= ::IO.read(::File.join(STYLESHEETS_DATA_PATH, 'coderay-asciidoctor.css')).rstrip
   end
 
   def embed_coderay_stylesheet
@@ -65,16 +66,23 @@ class Stylesheets
     %(pygments-#{style || DEFAULT_PYGMENTS_STYLE}.css)
   end
 
+  def pygments_background style = nil
+    if load_pygments && PygmentsBgColorRx =~ (::Pygments.css '.pygments', :style => style || DEFAULT_PYGMENTS_STYLE)
+      $1
+    end
+  end
+
   # Public: Generate the Pygments stylesheet with the specified style.
   #
   # returns the [String] Pygments stylesheet data
   def pygments_stylesheet_data style = nil
     if load_pygments
-      (@pygments_stylesheet_data ||= {})[style || DEFAULT_PYGMENTS_STYLE] ||=
-          (::Pygments.css '.listingblock .pygments', :classprefix => 'tok-', :style => (style || DEFAULT_PYGMENTS_STYLE)).
+      style ||= DEFAULT_PYGMENTS_STYLE
+      (@pygments_stylesheet_data ||= {})[style] ||=
+          ((::Pygments.css '.listingblock .pygments', :classprefix => 'tok-', :style => style) || '/* Failed to load Pygments CSS. */').
           sub('.listingblock .pygments  {', '.listingblock .pygments, .listingblock .pygments code {')
     else
-      '/* Pygments styles disabled. Pygments is not available. */'
+      '/* Pygments CSS disabled. Pygments is not available. */'
     end
   end
 
diff -pruN 1.5.6.2-2/lib/asciidoctor/substitutors.rb 1.5.7-1/lib/asciidoctor/substitutors.rb
--- 1.5.6.2-2/lib/asciidoctor/substitutors.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/substitutors.rb	2018-05-05 22:54:38.000000000 +0000
@@ -43,14 +43,24 @@ module Substitutors
 
   SUB_HIGHLIGHT = ['coderay', 'pygments']
 
-  # Delimiters and matchers for the passthrough placeholder
-  # See http://www.aivosto.com/vbtips/control-characters.html#listabout for characters to use
+  if ::RUBY_MIN_VERSION_1_9
+    CAN = %(\u0018)
+    DEL = %(\u007f)
 
-  # SPA, start of guarded protected area (\u0096)
-  PASS_START = %(\u0096)
+    # Delimiters and matchers for the passthrough placeholder
+    # See http://www.aivosto.com/vbtips/control-characters.html#listabout for characters to use
 
-  # EPA, end of guarded protected area (\u0097)
-  PASS_END = %(\u0097)
+    # SPA, start of guarded protected area (\u0096)
+    PASS_START = %(\u0096)
+
+    # EPA, end of guarded protected area (\u0097)
+    PASS_END = %(\u0097)
+  else
+    CAN = 24.chr
+    DEL = 127.chr
+    PASS_START = 150.chr
+    PASS_END = 151.chr
+  end
 
   # match passthrough slot
   PassSlotRx = /#{PASS_START}(\d+)#{PASS_END}/
@@ -74,39 +84,20 @@ module Substitutors
   # Internal: A String Array of passthough (unprocessed) text captured from this block
   attr_reader :passthroughs
 
-  # Public: Apply the specified substitutions to the source.
+  # Public: Apply the specified substitutions to the text.
   #
-  # source  - The String or String Array of text to process; must not be nil.
-  # subs    - The substitutions to perform; can be a Symbol, Symbol Array or nil (default: NORMAL_SUBS).
-  # expand  - A Boolean (or nil) to control whether substitution aliases are expanded (default: nil).
-  #
-  # Returns a String or String Array with substitutions applied, matching the type of source argument.
-  def apply_subs source, subs = NORMAL_SUBS, expand = nil
-    if source.empty? || !subs
-      return source
-    elsif expand
-      if ::Symbol === subs
-        subs = SUB_GROUPS[subs] || [subs]
-      else
-        effective_subs = []
-        subs.each do |key|
-          if (sub_group = SUB_GROUPS[key])
-            effective_subs += sub_group unless sub_group.empty?
-          else
-            effective_subs << key
-          end
-        end
-
-        if (subs = effective_subs).empty?
-          return source
-        end
-      end
-    elsif subs.empty?
-      return source
+  # text  - The String or String Array of text to process; must not be nil.
+  # subs  - The substitutions to perform; must be a Symbol Array or nil (default: NORMAL_SUBS).
+  #
+  # Returns a String or String Array to match the type of the text argument with substitutions applied.
+  def apply_subs text, subs = NORMAL_SUBS
+    return text if text.empty? || !subs
+
+    if (multiline = ::Array === text)
+      #text = text.size > 1 ? (text.join LF) : text[0]
+      text = text[1] ? (text.join LF) : text[0]
     end
 
-    text = (multiline = ::Array === source) ? source * LF : source
-
     if (has_passthroughs = subs.include? :macros)
       text = extract_passthroughs text
       has_passthroughs = false if @passthroughs.empty?
@@ -119,7 +110,7 @@ module Substitutors
       when :quotes
         text = sub_quotes text
       when :attributes
-        text = sub_attributes(text.split LF, -1) * LF if text.include? ATTR_REF_HEAD
+        text = sub_attributes text if text.include? ATTR_REF_HEAD
       when :replacements
         text = sub_replacements text
       when :macros
@@ -131,7 +122,7 @@ module Substitutors
       when :post_replacements
         text = sub_post_replacements text
       else
-        warn %(asciidoctor: WARNING: unknown substitution type #{type})
+        logger.warn %(unknown substitution type #{type})
       end
     end
     text = restore_passthroughs text if has_passthroughs
@@ -238,13 +229,13 @@ module Substitutors
           next m[0][1..-1]
         end
 
-        @passthroughs[pass_key = @passthroughs.size] = {:text => (unescape_brackets m[8]), :subs => (m[7] ? (resolve_pass_subs m[7]) : [])}
+        @passthroughs[pass_key = @passthroughs.size] = {:text => (unescape_brackets m[8]), :subs => (m[7] ? (resolve_pass_subs m[7]) : nil)}
       end
 
       %(#{preceding}#{PASS_START}#{pass_key}#{PASS_END})
     } if (text.include? '++') || (text.include? '$$') || (text.include? 'ss:')
 
-    pass_inline_char1, pass_inline_char2, pass_inline_rx = PassInlineRx[compat_mode]
+    pass_inline_char1, pass_inline_char2, pass_inline_rx = InlinePassRx[compat_mode]
     text = text.gsub(pass_inline_rx) {
       # alias match for Ruby 1.8.7 compat
       m = $~
@@ -264,7 +255,8 @@ module Substitutors
 
       if attributes
         if format_mark == '`' && !old_behavior
-          next %(#{preceding}[#{attributes}]#{escape_mark}`#{extract_passthroughs content}`)
+          # extract nested single-plus passthrough; otherwise return unprocessed
+          next (extract_inner_passthrough content, %(#{preceding}[#{attributes}]#{escape_mark}), attributes)
         end
 
         if escape_mark
@@ -278,7 +270,8 @@ module Substitutors
           attributes = parse_attributes attributes
         end
       elsif format_mark == '`' && !old_behavior
-        next %(#{preceding}#{escape_mark}`#{extract_passthroughs content}`)
+        # extract nested single-plus passthrough; otherwise return unprocessed
+        next (extract_inner_passthrough content, %(#{preceding}#{escape_mark}))
       elsif escape_mark
         # honor the escape of the formatting mark
         next %(#{preceding}#{m[3][1..-1]})
@@ -311,10 +304,10 @@ module Substitutors
       end
 
       if (type = m[1].to_sym) == :stem
-        type = ((default_stem_type = @document.attributes['stem']).nil_or_empty? ? 'asciimath' : default_stem_type).to_sym
+        type = STEM_TYPE_ALIASES[@document.attributes['stem']].to_sym
       end
       content = unescape_brackets m[3]
-      subs = m[2] ? (resolve_pass_subs m[2]) : ((@document.basebackend? 'html') ? BASIC_SUBS : [])
+      subs = m[2] ? (resolve_pass_subs m[2]) : ((@document.basebackend? 'html') ? BASIC_SUBS : nil)
       @passthroughs[pass_key = @passthroughs.size] = {:text => content, :subs => subs, :type => type}
       %(#{PASS_START}#{pass_key}#{PASS_END})
     } if (text.include? ':') && ((text.include? 'stem:') || (text.include? 'math:'))
@@ -322,6 +315,21 @@ module Substitutors
     text
   end
 
+  def extract_inner_passthrough text, pre, attributes = nil
+    if (text.end_with? '+') && (text.start_with? '+', '\+') && SinglePlusInlinePassRx =~ text
+      if $1
+        %(#{pre}`+#{$2}+`)
+      else
+        @passthroughs[pass_key = @passthroughs.size] = attributes ?
+            { :text => $2, :subs => BASIC_SUBS, :attributes => attributes, :type => :unquoted } :
+            { :text => $2, :subs => BASIC_SUBS }
+        %(#{pre}`#{PASS_START}#{pass_key}#{PASS_END}`)
+      end
+    else
+      %(#{pre}`#{text}`)
+    end
+  end
+
   # Internal: Restore the passthrough text by reinserting into the placeholder positions
   #
   # text  - The String text into which to restore the passthrough text
@@ -366,10 +374,6 @@ module Substitutors
       end
       text
     end
-
-    def sub_specialchars text
-      (text.include? '<') || (text.include? '&') || (text.include? '>') ? (text.gsub SpecialCharsRx, SpecialCharsTr) : text
-    end
   else
     # Public: Substitute quoted text (includes emphasis, strong, monospaced, etc)
     #
@@ -404,23 +408,23 @@ module Substitutors
       end
       text
     end
+  end
 
-    # Public: Substitute special characters (i.e., encode XML)
-    #
-    # The special characters are <, &, and >, which get replaced with &lt;,
-    # &amp;, and &gt;, respectively.
-    #
-    # text - The String text to process
-    #
-    # returns The String text with special characters replaced
-    if ::RUBY_MIN_VERSION_1_9
-      def sub_specialchars text
-        (text.include? '<') || (text.include? '&') || (text.include? '>') ? (text.gsub! SpecialCharsRx, SpecialCharsTr) : text
-      end
-    else
-      def sub_specialchars text
-        (text.include? '<') || (text.include? '&') || (text.include? '>') ? (text.gsub!(SpecialCharsRx) { SpecialCharsTr[$&] }) : text
-      end
+  # Public: Substitute special characters (i.e., encode XML)
+  #
+  # The special characters <, &, and > get replaced with &lt;,
+  # &amp;, and &gt;, respectively.
+  #
+  # text - The String text to process.
+  #
+  # returns The String text with special characters replaced.
+  if ::RUBY_MIN_VERSION_1_9
+    def sub_specialchars text
+      (text.include? '<') || (text.include? '&') || (text.include? '>') ? (text.gsub SpecialCharsRx, SpecialCharsTr) : text
+    end
+  else
+    def sub_specialchars text
+      (text.include? '<') || (text.include? '&') || (text.include? '>') ? (text.gsub(SpecialCharsRx) { SpecialCharsTr[$&] }) : text
     end
   end
   alias sub_specialcharacters sub_specialchars
@@ -444,74 +448,78 @@ module Substitutors
     end
   end
 
-  # Public: Substitute attribute references
+  # Public: Substitutes attribute references in the specified text
   #
   # Attribute references are in the format +{name}+.
   #
-  # If an attribute referenced in the line is missing, the line is dropped.
+  # If an attribute referenced in the line is missing or undefined, the line may be dropped
+  # based on the attribute-missing or attribute-undefined setting, respectively.
   #
-  # text     - The String text to process
+  # text - The String text to process
+  # opts - A Hash of options to control processing: (default: {})
+  #        * :attribute_missing controls how to handle a missing attribute
   #
-  # returns The String text with the attribute references replaced with attribute values
-  #--
-  # NOTE it's necessary to perform this substitution line-by-line
-  # so that a missing key doesn't wipe out the whole block of data
-  # when attribute-undefined and/or attribute-missing is drop-line
-  def sub_attributes data, opts = {}
-    # normalizes data type to an array (string becomes single-element array)
-    data = [data] if (input_is_string = ::String === data)
-    doc_attrs, result = @document.attributes, []
-    data.each do |line|
-      reject = reject_if_empty = false
-      line = line.gsub(AttributeReferenceRx) {
-        # escaped attribute, return unescaped
-        if $1 == RS || $4 == RS
-          %({#{$2}})
-        elsif $3
-          case (args = $2.split ':', 3).shift
-          when 'set'
-            _, value = Parser.store_attribute args[0], args[1] || '', @document
-            # since this is an assignment, only drop-line applies here (skip and drop imply the same result)
-            if (doc_attrs.fetch 'attribute-undefined', Compliance.attribute_undefined) == 'drop-line'
-              reject = true
-              break ''
-            end unless value
-            reject_if_empty = true
-            ''
-          when 'counter2'
-            @document.counter(*args)
-            reject_if_empty = true
-            ''
-          else # 'counter'
-            @document.counter(*args)
-          end
-        elsif doc_attrs.key?(key = $2.downcase)
-          doc_attrs[key]
-        elsif INTRINSIC_ATTRIBUTES.key? key
-          INTRINSIC_ATTRIBUTES[key]
-        else
-          case (attribute_missing ||= opts[:attribute_missing] || (doc_attrs.fetch 'attribute-missing', Compliance.attribute_missing))
-          when 'drop'
-            # QUESTION should we warn in this case?
-            reject_if_empty = true
-            ''
-          when 'drop-line'
-            warn %(asciidoctor: WARNING: dropping line containing reference to missing attribute: #{key})
-            reject = true
-            break ''
-          when 'warn'
-            warn %(asciidoctor: WARNING: skipping reference to missing attribute: #{key})
-            $&
-          else # 'skip'
-            $&
+  # Returns the [String] text with the attribute references replaced with resolved values
+  def sub_attributes text, opts = {}
+    doc_attrs = @document.attributes
+    drop = drop_line = drop_empty_line = attribute_undefined = attribute_missing = nil
+    result = text.gsub AttributeReferenceRx do
+      # escaped attribute, return unescaped
+      if $1 == RS || $4 == RS
+        %({#{$2}})
+      elsif $3
+        case (args = $2.split ':', 3).shift
+        when 'set'
+          _, value = Parser.store_attribute args[0], args[1] || '', @document
+          # NOTE since this is an assignment, only drop-line applies here (skip and drop imply the same result)
+          if value || (attribute_undefined ||= doc_attrs['attribute-undefined'] || Compliance.attribute_undefined) != 'drop-line'
+            drop = drop_empty_line = DEL
+          else
+            drop = drop_line = CAN
           end
+        when 'counter2'
+          @document.counter(*args)
+          drop = drop_empty_line = DEL
+        else # 'counter'
+          @document.counter(*args)
+        end
+      elsif doc_attrs.key?(key = $2.downcase)
+        doc_attrs[key]
+      elsif (value = INTRINSIC_ATTRIBUTES[key])
+        value
+      else
+        case (attribute_missing ||= opts[:attribute_missing] || doc_attrs['attribute-missing'] || Compliance.attribute_missing)
+        when 'drop'
+          drop = drop_empty_line = DEL
+        when 'drop-line'
+          logger.warn %(dropping line containing reference to missing attribute: #{key})
+          drop = drop_line = CAN
+        when 'warn'
+          logger.warn %(skipping reference to missing attribute: #{key})
+          $&
+        else # 'skip'
+          $&
         end
-      } if line.include? ATTR_REF_HEAD
-
-      result << line unless reject || (reject_if_empty && line.empty?)
+      end
     end
 
-    input_is_string ? result * LF : result
+    if drop
+      # drop lines from result
+      if drop_empty_line
+        lines = (result.tr_s DEL, DEL).split LF, -1
+        if drop_line
+          (lines.reject {|line| line == DEL || line == CAN || (line.start_with? CAN) || (line.include? CAN) }.join LF).delete DEL
+        else
+          (lines.reject {|line| line == DEL }.join LF).delete DEL
+        end
+      elsif result.include? LF
+        (result.split LF, -1).reject {|line| line == CAN || (line.start_with? CAN) || (line.include? CAN) }.join LF
+      else
+        ''
+      end
+    else
+      result
+    end
   end
 
   # Public: Substitute inline macros (e.g., links, images, etc)
@@ -529,8 +537,7 @@ module Substitutors
     found_colon = source.include? ':'
     found_macroish = found[:macroish] = found_square_bracket && found_colon
     found_macroish_short = found_macroish && (source.include? ':[')
-    doc_attrs = @document.attributes
-    use_link_attrs = doc_attrs.key? 'linkattrs'
+    doc_attrs = (doc = @document).attributes
     result = source
 
     if doc_attrs.key? 'experimental'
@@ -591,7 +598,7 @@ module Substitutors
       end
 
       if (result.include? '"') && (result.include? '&gt;')
-        result = result.gsub(MenuInlineRx) {
+        result = result.gsub(InlineMenuRx) {
           # alias match for Ruby 1.8.7 compat
           m = $~
           # honor the escape
@@ -610,7 +617,7 @@ module Substitutors
 
     # FIXME this location is somewhat arbitrary, probably need to be able to control ordering
     # TODO this handling needs some cleanup
-    if (extensions = @document.extensions) && extensions.inline_macros? # && found_macroish
+    if (extensions = doc.extensions) && extensions.inline_macros? # && found_macroish
       extensions.inline_macros.each do |extension|
         result = result.gsub(extension.instance.regexp) {
           # alias match for Ruby 1.8.7 compat
@@ -664,63 +671,72 @@ module Substitutors
           # TODO remove this special case once titles use normal substitution order
           target = sub_attributes target
         end
-        @document.register(:images, target) unless type == 'icon'
+        doc.register(:images, target) unless type == 'icon'
         attrs = parse_attributes(m[2], posattrs, :unescape_input => true)
         attrs['alt'] ||= (attrs['default-alt'] = Helpers.basename(target, true).tr('_-', ' '))
         Inline.new(self, :image, nil, :type => type, :target => target, :attributes => attrs).convert
       }
     end
 
-    if ((result.include? '((') && (result.include? '))')) ||
-        (found_macroish_short && (result.include? 'indexterm'))
+    if ((result.include? '((') && (result.include? '))')) || (found_macroish_short && (result.include? 'dexterm'))
       # (((Tigers,Big cats)))
       # indexterm:[Tigers,Big cats]
       # ((Tigers))
       # indexterm2:[Tigers]
       result = result.gsub(InlineIndextermMacroRx) {
-        # alias match for Ruby 1.8.7 compat
-        m = $~
-
-        # honor the escape
-        if m[0].start_with? RS
-          next m[0][1..-1]
-        end
-
-        case m[1]
+        case $1
         when 'indexterm'
+          text = $2
+          # honor the escape
+          if (m0 = $&).start_with? RS
+            next m0.slice 1, m0.length
+          end
           # indexterm:[Tigers,Big cats]
-          terms = split_simple_csv(normalize_string m[2], true)
-          @document.register :indexterms, terms
+          terms = split_simple_csv normalize_string text, true
+          doc.register :indexterms, terms
           (Inline.new self, :indexterm, nil, :attributes => { 'terms' => terms }).convert
         when 'indexterm2'
+          text = $2
+          # honor the escape
+          if (m0 = $&).start_with? RS
+            next m0.slice 1, m0.length
+          end
           # indexterm2:[Tigers]
-          term = normalize_string m[2], true
-          @document.register :indexterms, [term]
+          term = normalize_string text, true
+          doc.register :indexterms, [term]
           (Inline.new self, :indexterm, term, :type => :visible).convert
         else
-          text, visible, before, after = m[3], true, nil, nil
-          if text.start_with? '('
-            if text.end_with? ')'
-              text, visible = (text.slice 1, text.length - 2), false
+          text = $3
+          # honor the escape
+          if (m0 = $&).start_with? RS
+            # escape concealed index term, but process nested flow index term
+            if (text.start_with? '(') && (text.end_with? ')')
+              text = text.slice 1, text.length - 2
+              visible, before, after = true, '(', ')'
             else
-              text, before, after = (text.slice 1, text.length - 1), '(', ''
+              next m0.slice 1, m0.length
             end
-          elsif text.end_with? ')'
+          else
+            visible = true
             if text.start_with? '('
-              text, visible = (text.slice 1, text.length - 2), false
-            else
+              if text.end_with? ')'
+                text, visible = (text.slice 1, text.length - 2), false
+              else
+                text, before, after = (text.slice 1, text.length), '(', ''
+              end
+            elsif text.end_with? ')'
               text, before, after = (text.slice 0, text.length - 1), '', ')'
             end
           end
           if visible
             # ((Tigers))
             term = normalize_string text
-            @document.register :indexterms, [term]
+            doc.register :indexterms, [term]
             result = (Inline.new self, :indexterm, term, :type => :visible).convert
           else
             # (((Tigers,Big cats)))
             terms = split_simple_csv(normalize_string text)
-            @document.register :indexterms, terms
+            doc.register :indexterms, terms
             result = (Inline.new self, :indexterm, nil, :attributes => { 'terms' => terms }).convert
           end
           before ? %(#{before}#{result}#{after}) : result
@@ -730,7 +746,7 @@ module Substitutors
 
     if found_colon && (result.include? '://')
       # inline urls, target[text] (optionally prefixed with link: and optionally surrounded by <>)
-      result = result.gsub(LinkInlineRx) {
+      result = result.gsub(InlineLinkRx) {
         # alias match for Ruby 1.8.7 compat
         m = $~
         # honor the escape
@@ -759,15 +775,13 @@ module Substitutors
             if prefix.start_with?('&lt;') && target.end_with?('&gt;')
               prefix = prefix[4..-1]
               target = target[0...-4]
+            # strip trailing ;
+            # check for trailing );
+            elsif (target = target.chop).end_with?(')')
+              target = target.chop
+              suffix = ');'
             else
-              # strip trailing ;
-              # check for trailing );
-              if (target = target.chop).end_with?(')')
-                target = target.chop
-                suffix = ');'
-              else
-                suffix = ';'
-              end
+              suffix = ';'
             end
           when ':'
             # strip trailing :
@@ -779,15 +793,16 @@ module Substitutors
               suffix = ':'
             end
           end
+          # NOTE handle case when remaining target is a URI scheme (e.g., http://)
+          return m[0] if target.end_with? '://'
         end
 
         attrs, link_opts = nil, { :type => :link }
         unless text.empty?
           text = text.gsub ESC_R_SB, R_SB if text.include? R_SB
-          if use_link_attrs && ((text.start_with? '"') || ((text.include? ',') && (text.include? '=')))
-            attrs = parse_attributes text, []
+          if !doc.compat_mode && (text.include? '=')
+            text = (attrs = (AttributeList.new text, self).parse)[1] || ''
             link_opts[:id] = attrs.delete 'id' if attrs.key? 'id'
-            text = attrs[1] || ''
           end
 
           # TODO enable in Asciidoctor 1.6.x
@@ -818,7 +833,7 @@ module Substitutors
           end
         end
 
-        @document.register :links, (link_opts[:target] = target)
+        doc.register :links, (link_opts[:target] = target)
         link_opts[:attributes] = attrs if attrs
         %(#{prefix}#{Inline.new(self, :anchor, text, link_opts).convert}#{suffix})
       }
@@ -837,10 +852,10 @@ module Substitutors
         attrs, link_opts = nil, { :type => :link }
         unless (text = m[3]).empty?
           text = text.gsub ESC_R_SB, R_SB if text.include? R_SB
-          if use_link_attrs && ((text.start_with? '"') || ((text.include? ',') && (mailto || (text.include? '='))))
-            attrs = parse_attributes text, []
-            link_opts[:id] = attrs.delete 'id' if attrs.key? 'id'
-            if mailto
+          if mailto
+            if !doc.compat_mode && (text.include? ',')
+              text = (attrs = (AttributeList.new text, self).parse)[1] || ''
+              link_opts[:id] = attrs.delete 'id' if attrs.key? 'id'
               if attrs.key? 2
                 if attrs.key? 3
                   target = %(#{target}?subject=#{Helpers.uri_encode attrs[2]}&amp;body=#{Helpers.uri_encode attrs[3]})
@@ -849,7 +864,9 @@ module Substitutors
                 end
               end
             end
-            text = attrs[1] || ''
+          elsif !doc.compat_mode && (text.include? '=')
+            text = (attrs = (AttributeList.new text, self).parse)[1] || ''
+            link_opts[:id] = attrs.delete 'id' if attrs.key? 'id'
           end
 
           # TODO enable in Asciidoctor 1.6.x
@@ -886,14 +903,14 @@ module Substitutors
         end
 
         # QUESTION should a mailto be registered as an e-mail address?
-        @document.register :links, (link_opts[:target] = target)
+        doc.register :links, (link_opts[:target] = target)
         link_opts[:attributes] = attrs if attrs
         Inline.new(self, :anchor, text, link_opts).convert
       }
     end
 
     if result.include? '@'
-      result = result.gsub(EmailInlineRx) {
+      result = result.gsub(InlineEmailRx) {
         address, tip = $&, $1
         if tip
           next (tip == RS ? address[1..-1] : address)
@@ -901,13 +918,13 @@ module Substitutors
 
         target = %(mailto:#{address})
         # QUESTION should this be registered as an e-mail address?
-        @document.register(:links, target)
+        doc.register(:links, target)
 
         Inline.new(self, :anchor, address, :type => :link, :target => target).convert
       }
     end
 
-    if found_macroish_short && (result.include? 'footnote')
+    if found_macroish && (result.include? 'tnote')
       result = result.gsub(InlineFootnoteMacroRx) {
         # alias match for Ruby 1.8.7 compat
         m = $~
@@ -915,36 +932,35 @@ module Substitutors
         if m[0].start_with? RS
           next m[0][1..-1]
         end
-        if m[1] == 'footnote'
-          id = nil
-          # REVIEW it's a dirty job, but somebody's gotta do it
-          text = restore_passthroughs(sub_inline_xrefs(sub_inline_anchors(normalize_string m[2], true)), false)
-          index = @document.counter('footnote-number')
-          @document.register(:footnotes, Document::Footnote.new(index, id, text))
-          type = nil
-          target = nil
+        if m[1] # footnoteref (legacy)
+          id, text = (m[3] || '').split(',', 2)
         else
-          id, text = m[2].split(',', 2)
-          id = id.strip
+          id, text = m[2], m[3]
+        end
+        if id
           if text
             # REVIEW it's a dirty job, but somebody's gotta do it
             text = restore_passthroughs(sub_inline_xrefs(sub_inline_anchors(normalize_string text, true)), false)
-            index = @document.counter('footnote-number')
-            @document.register(:footnotes, Document::Footnote.new(index, id, text))
-            type = :ref
-            target = nil
+            index = doc.counter('footnote-number')
+            doc.register(:footnotes, Document::Footnote.new(index, id, text))
+            type, target = :ref, nil
           else
-            if (footnote = @document.footnotes.find {|fn| fn.id == id })
-              index = footnote.index
-              text = footnote.text
+            if (footnote = doc.footnotes.find {|candidate| candidate.id == id })
+              index, text = footnote.index, footnote.text
             else
-              index = nil
-              text = id
+              logger.warn %(invalid footnote reference: #{id})
+              index, text = nil, id
             end
-            target = id
-            id = nil
-            type = :xref
+            type, target, id = :xref, id, nil
           end
+        elsif text
+          # REVIEW it's a dirty job, but somebody's gotta do it
+          text = restore_passthroughs(sub_inline_xrefs(sub_inline_anchors(normalize_string text, true)), false)
+          index = doc.counter('footnote-number')
+          doc.register(:footnotes, Document::Footnote.new(index, id, text))
+          type = target = nil
+        else
+          next m[0]
         end
         Inline.new(self, :footnote, text, :attributes => {'index' => index}, :id => id, :target => target, :type => type).convert
       }
@@ -985,74 +1001,95 @@ module Substitutors
   end
 
   # Internal: Substitute cross reference links
-  def sub_inline_xrefs(text, found = nil)
-    if ((found ? found[:macroish] : (text.include? '[')) && (text.include? 'xref:')) ||
-        ((text.include? '&') && (text.include? '&lt;&lt;'))
-      text = text.gsub(InlineXrefMacroRx) {
+  def sub_inline_xrefs(content, found = nil)
+    if ((found ? found[:macroish] : (content.include? '[')) && (content.include? 'xref:')) || ((content.include? '&') && (content.include? 'lt;&'))
+      content = content.gsub(InlineXrefMacroRx) {
         # alias match for Ruby 1.8.7 compat
         m = $~
         # honor the escape
         if m[0].start_with? RS
           next m[0][1..-1]
         end
-        if (id = m[1])
-          id, reftext = id.split ',', 2
-          reftext = reftext.lstrip if reftext
+        attrs, doc = {}, @document
+        if (refid = m[1])
+          refid, text = refid.split ',', 2
+          text = text.lstrip if text
         else
-          id = m[2]
-          if (reftext = m[3]) && (reftext.include? R_SB)
-            reftext = reftext.gsub ESC_R_SB, R_SB
+          macro = true
+          refid = m[2]
+          if (text = m[3])
+            text = text.gsub ESC_R_SB, R_SB if text.include? R_SB
+            # NOTE if an equal sign (=) is present, parse text as attributes
+            text = ((AttributeList.new text, self).parse_into attrs)[1] if !doc.compat_mode && (text.include? '=')
           end
         end
 
-        if (hash_idx = id.index '#')
+        if doc.compat_mode
+          fragment = refid
+        elsif (hash_idx = refid.index '#')
           if hash_idx > 0
-            if (fragment_len = id.length - hash_idx - 1) > 0
-              path, fragment = (id.slice 0, hash_idx), (id.slice hash_idx + 1, fragment_len)
+            if (fragment_len = refid.length - hash_idx - 1) > 0
+              path, fragment = (refid.slice 0, hash_idx), (refid.slice hash_idx + 1, fragment_len)
             else
-              path, fragment = (id.slice 0, hash_idx), nil
+              path = refid.slice 0, hash_idx
+            end
+            if (ext = ::File.extname path).empty?
+              src2src = path
+            elsif ASCIIDOC_EXTENSIONS[ext]
+              src2src = (path = path.slice 0, path.length - ext.length)
             end
           else
-            target, path, fragment = id, nil, (id.slice 1, id.length)
+            target, fragment = refid, (refid.slice 1, refid.length)
           end
+        elsif macro && (refid.end_with? '.adoc')
+          src2src = (path = refid.slice 0, refid.length - 5)
         else
-          path, fragment = nil, id
+          fragment = refid
         end
 
         # handles: #id
         if target
           refid = fragment
-        # handles: path#, path.adoc#, path#id, or path.adoc#id
+          logger.warn %(invalid reference: #{refid}) if $VERBOSE && !(doc.catalog[:ids].key? refid)
         elsif path
-          if (ext_idx = path.rindex '.') && ASCIIDOC_EXTENSIONS[path.slice ext_idx, path.length]
-            path = path.slice 0, ext_idx
-          end
-          # the referenced path is this document, or its contents has been included in this document
-          if @document.attributes['docname'] == path || @document.catalog[:includes].include?(path)
-            refid, path, target = fragment, nil, %(##{fragment})
+          # handles: path#, path#id, path.adoc#, path.adoc#id, or path.adoc (xref macro only)
+          # the referenced path is the current document, or its contents have been included in the current document
+          if src2src && (doc.attributes['docname'] == path || doc.catalog[:includes][path])
+            if fragment
+              refid, path, target = fragment, nil, %(##{fragment})
+              logger.warn %(invalid reference: #{refid}) if $VERBOSE && !(doc.catalog[:ids].key? refid)
+            else
+              refid, path, target = nil, nil, '#'
+            end
           else
-            refid = fragment ? %(#{path}##{fragment}) : path
-            path = %(#{@document.attributes['relfileprefix']}#{path}#{@document.attributes.fetch 'outfilesuffix', '.html'})
-            target = fragment ? %(#{path}##{fragment}) : path
-          end
-        # handles: id or Section Title
-        else
-          # resolve fragment as reftext if it's not a known ID and resembles reftext (includes space or has uppercase char)
-          unless @document.catalog[:ids].key? fragment
-            if ((fragment.include? ' ') || fragment.downcase != fragment) &&
-                (resolved_id = @document.catalog[:ids].key fragment)
-              fragment = resolved_id
-            elsif $VERBOSE
-              warn %(asciidoctor: WARNING: invalid reference: #{fragment})
+            refid, path = path, %(#{doc.attributes['relfileprefix']}#{path}#{src2src ? (doc.attributes.fetch 'relfilesuffix', doc.outfilesuffix) : ''})
+            if fragment
+              refid, target = %(#{refid}##{fragment}), %(#{path}##{fragment})
+            else
+              target = path
             end
           end
+        # handles: id (in compat mode or when natural xrefs are disabled)
+        elsif doc.compat_mode || !Compliance.natural_xrefs
+          refid, target = fragment, %(##{fragment})
+          logger.warn %(invalid reference: #{refid}) if $VERBOSE && !(doc.catalog[:ids].key? refid)
+        # handles: id
+        elsif doc.catalog[:ids].key? fragment
           refid, target = fragment, %(##{fragment})
+        # handles: Node Title or Reference Text
+        # do reverse lookup on fragment if not a known ID and resembles reftext (contains a space or uppercase char)
+        elsif (refid = doc.catalog[:ids].key fragment) && ((fragment.include? ' ') || fragment.downcase != fragment)
+          fragment, target = refid, %(##{refid})
+        else
+          refid, target = fragment, %(##{fragment})
+          logger.warn %(invalid reference: #{refid}) if $VERBOSE
         end
-        Inline.new(self, :anchor, reftext, :type => :xref, :target => target, :attributes => {'path' => path, 'fragment' => fragment, 'refid' => refid}).convert
+        attrs['path'], attrs['fragment'], attrs['refid'] = path, fragment, refid
+        Inline.new(self, :anchor, text, :type => :xref, :target => target, :attributes => attrs).convert
       }
     end
 
-    text
+    content
   end
 
   # Public: Substitute callout source references
@@ -1135,7 +1172,7 @@ module Substitutors
   # Returns a Hash of attributes (role and id only)
   def parse_quoted_text_attributes str
     # NOTE attributes are typically resolved after quoted text, so substitute eagerly
-    str = sub_attributes str if str.include? ATTR_REF_HEAD
+    str = sub_attributes str, :multiline => true if str.include? ATTR_REF_HEAD
     # for compliance, only consider first positional attribute
     str = str.slice 0, (str.index ',') if str.include? ','
 
@@ -1178,8 +1215,8 @@ module Substitutors
   def parse_attributes(attrline, posattrs = ['role'], opts = {})
     return unless attrline
     return {} if attrline.empty?
-    attrline = @document.sub_attributes(attrline) if opts[:sub_input] && (attrline.include? ATTR_REF_HEAD)
-    attrline = unescape_bracketed_text(attrline) if opts[:unescape_input]
+    attrline = @document.sub_attributes attrline if opts[:sub_input] && (attrline.include? ATTR_REF_HEAD)
+    attrline = unescape_bracketed_text attrline if opts[:unescape_input]
     # substitutions are only performed on attribute values if block is not nil
     block = opts.fetch(:sub_result, true) ? self : nil
     if (into = opts[:into])
@@ -1189,7 +1226,33 @@ module Substitutors
     end
   end
 
-  # Internal: Strip bounding whitespace, fold endlines and unescaped closing
+  # Expand all groups in the subs list and return. If no subs are resolve, return nil.
+  #
+  # subs - The substitutions to expand; can be a Symbol, Symbol Array or nil
+  #
+  # Returns a Symbol Array of substitutions to pass to apply_subs or nil if no substitutions were resolved.
+  def expand_subs subs
+    if ::Symbol === subs
+      unless subs == :none
+        SUB_GROUPS[subs] || [subs]
+      end
+    else
+      expanded_subs = []
+      subs.each do |key|
+        unless key == :none
+          if (sub_group = SUB_GROUPS[key])
+            expanded_subs += sub_group
+          else
+            expanded_subs << key
+          end
+        end
+      end
+
+      expanded_subs.empty? ? nil : expanded_subs
+    end
+  end
+
+  # Internal: Strip bounding whitespace, fold endlines and unescape closing
   # square brackets from text extracted from brackets
   def unescape_bracketed_text text
     if (text = text.strip.tr LF, ' ').include? R_SB
@@ -1253,9 +1316,9 @@ module Substitutors
   #
   # subs - A comma-delimited String of substitution aliases
   #
-  # returns An Array of Symbols representing the substitution operation
+  # returns An Array of Symbols representing the substitution operation or nothing if no subs are found.
   def resolve_subs subs, type = :block, defaults = nil, subject = nil
-    return [] if subs.nil_or_empty?
+    return if subs.nil_or_empty?
     # QUESTION should we store candidates as a Set instead of an Array?
     candidates = nil
     subs = subs.delete ' ' if subs.include? ' '
@@ -1306,12 +1369,12 @@ module Substitutors
         candidates += resolved_keys
       end
     end
-    return [] unless candidates
+    return unless candidates
     # weed out invalid options and remove duplicates (order is preserved; first occurence wins)
     resolved = candidates & SUB_OPTIONS[type]
     unless (candidates - resolved).empty?
       invalid = candidates - resolved
-      warn %(asciidoctor: WARNING: invalid substitution type#{invalid.size > 1 ? 's' : ''}#{subject ? ' for ' : nil}#{subject}: #{invalid * ', '})
+      logger.warn %(invalid substitution type#{invalid.size > 1 ? 's' : ''}#{subject ? ' for ' : ''}#{subject}: #{invalid * ', '})
     end
     resolved
   end
@@ -1339,19 +1402,21 @@ module Substitutors
   def highlight_source source, process_callouts, highlighter = nil
     case (highlighter ||= @document.attributes['source-highlighter'])
     when 'coderay'
-      unless (highlighter_loaded = defined? ::CodeRay) || @document.attributes['coderay-unavailable']
+      unless (highlighter_loaded = defined? ::CodeRay) ||
+          (defined? @@coderay_unavailable) || @document.attributes['coderay-unavailable']
         if (Helpers.require_library 'coderay', true, :warn).nil?
-          # prevent further attempts to load CodeRay
-          @document.set_attr 'coderay-unavailable'
+          # prevent further attempts to load CodeRay in this process
+          @@coderay_unavailable = true
         else
           highlighter_loaded = true
         end
       end
     when 'pygments'
-      unless (highlighter_loaded = defined? ::Pygments) || @document.attributes['pygments-unavailable']
+      unless (highlighter_loaded = defined? ::Pygments) ||
+          (defined? @@pygments_unavailable) || @document.attributes['pygments-unavailable']
         if (Helpers.require_library 'pygments', 'pygments.rb', :warn).nil?
-          # prevent further attempts to load Pygments
-          @document.set_attr 'pygments-unavailable'
+          # prevent further attempts to load Pygments in this process
+          @@pygments_unavailable = true
         else
           highlighter_loaded = true
         end
@@ -1422,21 +1487,26 @@ module Substitutors
           opts[:hl_lines] = highlight_lines * ' '
         end
       end
+      # NOTE highlight can return nil if something goes wrong; fallback to source if this happens
       # TODO we could add the line numbers in ourselves instead of having to strip out the junk
       if (attr? 'linenums', nil, false) && (opts[:linenos] = @document.attributes['pygments-linenums-mode'] || 'table') == 'table'
         linenums_mode = :table
-        result = lexer.highlight(source, :options => opts).sub(PygmentsWrapperDivRx, '\1').gsub(PygmentsWrapperPreRx, '\1')
-      else
-        if PygmentsWrapperPreRx =~ (result = lexer.highlight(source, :options => opts))
+        if (result = lexer.highlight source, :options => opts)
+          result = (result.sub PygmentsWrapperDivRx, '\1').gsub PygmentsWrapperPreRx, '\1'
+        else
+          result = sub_specialchars source
+        end
+      elsif (result = lexer.highlight source, :options => opts)
+        if PygmentsWrapperPreRx =~ result
           result = $1
         end
+      else
+        result = sub_specialchars source
       end
     end
 
     # fix passthrough placeholders that got caught up in syntax highlighting
-    unless @passthroughs.empty?
-      result = result.gsub HighlightedPassSlotRx, %(#{PASS_START}\\1#{PASS_END})
-    end
+    result = result.gsub HighlightedPassSlotRx, %(#{PASS_START}\\1#{PASS_END}) unless @passthroughs.empty?
 
     if process_callouts && callout_marks
       lineno = 0
@@ -1539,7 +1609,11 @@ module Substitutors
       end
     end
 
-    @subs = (custom_subs = @attributes['subs']) ? (resolve_block_subs custom_subs, default_subs, @context) : default_subs.dup
+    if (custom_subs = @attributes['subs'])
+      @subs = (resolve_block_subs custom_subs, default_subs, @context) || []
+    else
+      @subs = default_subs.dup
+    end
 
     # QUESION delegate this logic to a method?
     if @context == :listing && @style == 'source' && (@attributes.key? 'language') && (@document.basebackend? 'html') &&
diff -pruN 1.5.6.2-2/lib/asciidoctor/table.rb 1.5.7-1/lib/asciidoctor/table.rb
--- 1.5.6.2-2/lib/asciidoctor/table.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/table.rb	2018-05-05 22:54:38.000000000 +0000
@@ -3,6 +3,8 @@ module Asciidoctor
 # Public: Methods and constants for managing AsciiDoc table content in a document.
 # It supports all three of AsciiDoc's table formats: psv, dsv and csv.
 class Table < AbstractBlock
+  # multipler / divisor for tuning precision of calculated result
+  DEFAULT_PRECISION_FACTOR = 10000.0
 
   # Public: A data object that encapsulates the collection of rows (head, foot, body) for a table
   class Rows
@@ -24,7 +26,7 @@ class Table < AbstractBlock
     #
     # Returns a 2-dimentional Array of rows grouped by section.
     def by_section
-      [[:head, @head], [:foot, @foot], [:body, @body]]
+      [[:head, @head], [:body, @body], [:foot, @foot]]
     end
   end
 
@@ -48,7 +50,7 @@ class Table < AbstractBlock
 
     @has_header_option = attributes.key? 'header-option'
 
-    # smell like we need a utility method here
+    # smells like we need a utility method here
     # to resolve an integer width from potential bogus input
     if (pcwidth = attributes['width'])
       if (pcwidth_intval = pcwidth.to_i) > 100 || pcwidth_intval < 1
@@ -79,14 +81,21 @@ class Table < AbstractBlock
   # returns nothing
   def create_columns colspecs
     cols = []
+    autowidth_cols = nil
     width_base = 0
     colspecs.each do |colspec|
-      width_base += colspec['width']
+      colwidth = colspec['width']
       cols << (Column.new self, cols.size, colspec)
+      if colwidth < 0
+        (autowidth_cols ||= []) << cols[-1]
+      else
+        width_base += colwidth
+      end
     end
-    unless (@columns = cols).empty?
-      @attributes['colcount'] = cols.size
-      assign_column_widths(width_base == 0 ? nil : width_base)
+    if (num_cols = (@columns = cols).size) > 0
+      @attributes['colcount'] = num_cols
+      width_base = nil unless width_base > 0 || autowidth_cols
+      assign_column_widths width_base, autowidth_cols
     end
     nil
   end
@@ -101,11 +110,23 @@ class Table < AbstractBlock
   # width_base - the total of the relative column values used for calculating percentage widths (default: nil)
   #
   # returns nothing
-  def assign_column_widths width_base = nil
-    pf = 10.0 ** 4 # precision factor (multipler / divisor) for managing precision of calculated result
+  def assign_column_widths width_base = nil, autowidth_cols = nil
+    pf = DEFAULT_PRECISION_FACTOR
     total_width = col_pcwidth = 0
 
     if width_base
+      if autowidth_cols
+        if width_base > 100
+          autowidth = 0
+          logger.warn %(total column width must not exceed 100% when using autowidth columns; got #{width_base}%)
+        else
+          autowidth = ((100.0 - width_base) / autowidth_cols.size * pf).to_i / pf
+          autowidth = autowidth.to_i if autowidth.to_i == autowidth
+          width_base = 100
+        end
+        autowidth_attrs = { 'width' => autowidth, 'autowidth-option' => '' }
+        autowidth_cols.each {|col| col.update_attributes autowidth_attrs }
+      end
       @columns.each {|col| total_width += (col_pcwidth = col.assign_width nil, width_base, pf) }
     else
       col_pcwidth = ((100 * pf / @columns.size).to_i) / pf
@@ -198,9 +219,15 @@ end
 
 # Public: Methods for managing the a cell in an AsciiDoc table.
 class Table::Cell < AbstractNode
+  # Public: Gets/Sets the location in the AsciiDoc source where this cell begins
+  attr_reader :source_location
+
   # Public: Get/Set the Symbol style for this cell (default: nil)
   attr_accessor :style
 
+  # Public: Substitutions to be applied to content in this cell
+  attr_accessor :subs
+
   # Public: An Integer of the number of columns this cell will span (default: nil)
   attr_accessor :colspan
 
@@ -215,34 +242,47 @@ class Table::Cell < AbstractNode
 
   def initialize column, cell_text, attributes = {}, opts = {}
     super column, :cell
+    @source_location = opts[:cursor].dup if @document.sourcemap
     if column
-      cell_style = (in_header_row = column.table.header_row?) ? nil : column.attributes['style']
+      cell_style = column.attributes['style'] unless (in_header_row = column.table.header_row?)
       # REVIEW feels hacky to inherit all attributes from column
       update_attributes column.attributes
-    else
-      in_header_row = cell_style = nil
     end
+    # NOTE if attributes is defined, we know this is a psv cell; implies text should be stripped
     if attributes
-      @colspan = attributes.delete 'colspan'
-      @rowspan = attributes.delete 'rowspan'
-      # TODO eventually remove the style attribute from the attributes hash
-      #cell_style = attributes.delete 'style' unless in_header_row || !(attributes.key? 'style')
-      cell_style = attributes['style'] unless in_header_row || !(attributes.key? 'style')
-      if opts[:strip_text]
-        if cell_style == :literal || cell_style == :verse
-          cell_text = cell_text.rstrip
-          cell_text = cell_text.slice 1, cell_text.length - 1 while cell_text.start_with? LF
+      if attributes.empty?
+        @colspan = @rowspan = nil
+      else
+        @colspan, @rowspan = (attributes.delete 'colspan'), (attributes.delete 'rowspan')
+        # TODO delete style attribute from @attributes if set
+        cell_style = attributes['style'] || cell_style unless in_header_row
+        update_attributes attributes
+      end
+      if cell_style == :asciidoc
+        asciidoc = true
+        inner_document_cursor = opts[:cursor]
+        if (cell_text = cell_text.rstrip).start_with? LF
+          lines_advanced = 1
+          lines_advanced += 1 while (cell_text = cell_text.slice 1, cell_text.length).start_with? LF
+          # NOTE this only works if we remain in the same file
+          inner_document_cursor.advance lines_advanced
         else
-          cell_text = cell_text.strip
+          cell_text = cell_text.lstrip
         end
+      elsif (literal = cell_style == :literal) || cell_style == :verse
+        cell_text = cell_text.rstrip
+        # QUESTION should we use same logic as :asciidoc cell? strip leading space if text doesn't start with newline?
+        cell_text = cell_text.slice 1, cell_text.length while cell_text.start_with? LF
+      else
+        normal_psv = true
+        # NOTE AsciidoctorJ uses nil cell_text to create an empty cell
+        cell_text = cell_text ? cell_text.strip : ''
       end
-      update_attributes attributes
     else
-      @colspan = nil
-      @rowspan = nil
+      @colspan = @rowspan = nil
     end
     # NOTE only true for non-header rows
-    if cell_style == :asciidoc
+    if asciidoc
       # FIXME hide doctitle from nested document; temporary workaround to fix
       # nested document seeing doctitle and assuming it has its own document title
       parent_doctitle = @document.attributes.delete('doctitle')
@@ -259,8 +299,16 @@ class Table::Cell < AbstractNode
           inner_document_lines.unshift(*preprocessed_lines) unless preprocessed_lines.empty?
         end
       end unless inner_document_lines.empty?
-      @inner_document = Document.new(inner_document_lines, :header_footer => false, :parent => @document, :cursor => opts[:cursor])
+      @inner_document = Document.new(inner_document_lines, :header_footer => false, :parent => @document, :cursor => inner_document_cursor)
       @document.attributes['doctitle'] = parent_doctitle unless parent_doctitle.nil?
+      @subs = nil
+    elsif literal
+      @subs = BASIC_SUBS
+    else
+      if normal_psv && (cell_text.start_with? '[[') && LeadingInlineAnchorRx =~ cell_text
+        Parser.catalog_inline_anchor $1, $2, self, opts[:cursor], @document
+      end
+      @subs = NORMAL_SUBS
     end
     @text = cell_text
     @style = cell_style
@@ -275,7 +323,7 @@ class Table::Cell < AbstractNode
   #
   # Returns the converted String text for this Cell
   def text
-    apply_subs @text, (@style == :literal ? BASIC_SUBS : NORMAL_SUBS)
+    apply_subs @text, @subs
   end
 
   # Public: Set the String text.
@@ -302,6 +350,16 @@ class Table::Cell < AbstractNode
     end
   end
 
+  # Public: Get the source file where this block started
+  def file
+    @source_location && @source_location.file
+  end
+
+  # Public: Get the source line number where this block started
+  def lineno
+    @source_location && @source_location.lineno
+  end
+
   def to_s
     "#{super.to_s} - [text: #@text, colspan: #{@colspan || 1}, rowspan: #{@rowspan || 1}, attributes: #@attributes]"
   end
@@ -314,6 +372,8 @@ end
 # instantiated, the row is closed if the cell satisifies the column count and,
 # finally, a new buffer is allocated to track the next cell.
 class Table::ParserContext
+  include Logging
+
   # Public: An Array of String keys that represent the table formats in AsciiDoc
   #--
   # QUESTION should we recognize !sv as a valid format value?
@@ -351,10 +411,8 @@ class Table::ParserContext
   attr_reader :delimiter_re
 
   def initialize reader, table, attributes = {}
-    @reader = reader
+    @start_cursor_data = (@reader = reader).mark
     @table = table
-    # IMPORTANT if reader.cursor becomes a reference, this assignment would require .dup
-    @last_cursor = reader.cursor
 
     if attributes.key? 'format'
       if FORMATS.include?(xsv = attributes['format'])
@@ -365,7 +423,7 @@ class Table::ParserContext
           xsv = '!sv'
         end
       else
-        warn %(asciidoctor: ERROR: #{reader.prev_line_info}: illegal table format: #{xsv})
+        logger.error message_with_context %(illegal table format: #{xsv}), :source_location => reader.cursor_at_prev_line
         @format, xsv = 'psv', (table.document.nested? ? '!sv' : 'psv')
       end
     else
@@ -413,18 +471,18 @@ class Table::ParserContext
 
   # Public: Skip past the matched delimiter because it's inside quoted text.
   #
-  # returns the String after the match
-  def skip_past_delimiter(match)
-    @buffer = %(#{@buffer}#{match.pre_match}#{@delimiter})
-    match.post_match
+  # Returns nothing
+  def skip_past_delimiter(pre)
+    @buffer = %(#{@buffer}#{pre}#{@delimiter})
+    nil
   end
 
   # Public: Skip past the matched delimiter because it's escaped.
   #
-  # returns the String after the match
-  def skip_past_escaped_delimiter(match)
-    @buffer = %(#{@buffer}#{match.pre_match.chop}#{@delimiter})
-    match.post_match
+  # Returns nothing
+  def skip_past_escaped_delimiter(pre)
+    @buffer = %(#{@buffer}#{pre.chop}#{@delimiter})
+    nil
   end
 
   # Public: Determines whether the buffer has unclosed quotes. Used for CSV data.
@@ -432,7 +490,9 @@ class Table::ParserContext
   # returns true if the buffer has unclosed quotes, false if it doesn't or it
   # isn't quoted data
   def buffer_has_unclosed_quotes? append = nil
-    if (record = append ? (buffer + append).strip : buffer.strip).start_with? '"'
+    if (record = append ? (@buffer + append).strip : @buffer.strip) == '"'
+      true
+    elsif record.start_with? '"'
       if ((trailing_quote = record.end_with? '"') && (record.end_with? '""')) || (record.start_with? '""')
         ((record = record.gsub '""', '').start_with? '"') && !(record.end_with? '"')
       else
@@ -513,18 +573,16 @@ class Table::ParserContext
   # returns nothing
   def close_cell(eol = false)
     if @format == 'psv'
-      strip_text = true
       cell_text = @buffer
       @buffer = ''
       if (cellspec = take_cellspec)
         repeat = cellspec.delete('repeatcol') || 1
       else
-        warn %(asciidoctor: ERROR: #{@last_cursor.line_info}: table missing leading separator, recovering automatically)
+        logger.error message_with_context 'table missing leading separator; recovering automatically', :source_location => Reader::Cursor.new(*@start_cursor_data)
         cellspec = {}
         repeat = 1
       end
     else
-      strip_text = false
       cell_text = @buffer.strip
       @buffer = ''
       cellspec = nil
@@ -534,7 +592,7 @@ class Table::ParserContext
           # this may not be perfect logic, but it hits the 99%
           if cell_text.start_with?('"') && cell_text.end_with?('"')
             # unquote
-            cell_text = cell_text[1...-1].strip
+            cell_text = cell_text.slice(1, cell_text.length - 2).strip
           end
 
           # collapse escaped quotes
@@ -556,13 +614,13 @@ class Table::ParserContext
       else
         # QUESTION is this right for cells that span columns?
         unless (column = @table.columns[@current_row.size])
-          warn %(asciidoctor: ERROR: #{@last_cursor.line_info}: dropping cell because it exceeds specified number of columns)
+          logger.error message_with_context 'dropping cell because it exceeds specified number of columns', :source_location => @reader.cursor_before_mark
           return
         end
       end
 
-      cell = Table::Cell.new(column, cell_text, cellspec, :cursor => @last_cursor, :strip_text => strip_text)
-      @last_cursor = @reader.cursor
+      cell = Table::Cell.new(column, cell_text, cellspec, :cursor => @reader.cursor_before_mark)
+      @reader.mark
       unless !cell.rowspan || cell.rowspan == 1
         activate_rowspan(cell.rowspan, (cell.colspan || 1))
       end
@@ -620,6 +678,5 @@ class Table::ParserContext
   def advance
     @linenum += 1
   end
-
 end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/timings.rb 1.5.7-1/lib/asciidoctor/timings.rb
--- 1.5.6.2-2/lib/asciidoctor/timings.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/timings.rb	2018-05-05 22:54:38.000000000 +0000
@@ -7,27 +7,44 @@ module Asciidoctor
     end
 
     def start key
-      @timers[key] = ::Time.now
+      @timers[key] = now
     end
 
     def record key
-      @log[key] = (::Time.now - (@timers.delete key))
+      @log[key] = (now - (@timers.delete key))
+    end
+
+    def time *keys
+      time = keys.reduce(0) {|sum, key| sum + (@log[key] || 0) }
+      time > 0 ? time : nil
+    end
+
+    def read
+      time :read
+    end
+
+    def parse
+      time :parse
     end
 
     def read_parse
-      (time = (@log[:read] || 0) + (@log[:parse] || 0)) > 0 ? time : nil
+      time :read, :parse
     end
 
     def convert
-      @log[:convert] || 0
+      time :convert
     end
 
     def read_parse_convert
-      (time = (@log[:read] || 0) + (@log[:parse] || 0) + (@log[:convert] || 0)) > 0 ? time : nil
+      time :read, :parse, :convert
+    end
+
+    def write
+      time :write
     end
 
     def total
-      (time = (@log[:read] || 0) + (@log[:parse] || 0) + (@log[:convert] || 0) + (@log[:write] || 0)) > 0 ? time : nil
+      time :read, :parse, :convert, :write
     end
 
     def print_report to = $stdout, subject = nil
@@ -36,5 +53,16 @@ module Asciidoctor
       to.puts %(  Time to convert document: #{'%05.5f' % convert.to_f})
       to.puts %(  Total time (read, parse and convert): #{'%05.5f' % read_parse_convert.to_f})
     end
+
+    if (::Process.const_defined? :CLOCK_MONOTONIC) && (::Process.respond_to? :clock_gettime)
+      CLOCK_ID = ::Process::CLOCK_MONOTONIC
+      def now
+        ::Process.clock_gettime CLOCK_ID
+      end
+    else
+      def now
+        ::Time.now
+      end
+    end
   end
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor/version.rb 1.5.7-1/lib/asciidoctor/version.rb
--- 1.5.6.2-2/lib/asciidoctor/version.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor/version.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,3 +1,3 @@
 module Asciidoctor
-  VERSION = '1.5.6.2'
+  VERSION = '1.5.7'
 end
diff -pruN 1.5.6.2-2/lib/asciidoctor.rb 1.5.7-1/lib/asciidoctor.rb
--- 1.5.6.2-2/lib/asciidoctor.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/lib/asciidoctor.rb	2018-05-05 22:54:38.000000000 +0000
@@ -13,6 +13,7 @@ if RUBY_ENGINE == 'opal'
   require 'asciidoctor/js'
 else
   autoload :Base64, 'base64'
+  autoload :URI, 'uri'
   autoload :OpenURI, 'open-uri'
   autoload :StringScanner, 'strscan'
 end
@@ -20,6 +21,8 @@ end
 # ideally we should use require_relative instead of modifying the LOAD_PATH
 $:.unshift File.dirname __FILE__
 
+require 'asciidoctor/logging'
+
 # Public: Methods for parsing AsciiDoc input files and converting documents
 # using eRuby templates.
 #
@@ -170,6 +173,11 @@ module Asciidoctor
     # Compliance value: false
     define :shorthand_property_syntax, true
 
+    # Asciidoctor will attempt to resolve the target of a cross reference by
+    # matching its reference text (reftext or title) (e.g., <<Section Title>>)
+    # Compliance value: false
+    define :natural_xrefs, true
+
     # Asciidoctor will start counting at the following number
     # when creating a unique id when there is a conflict
     # Compliance value: 2
@@ -225,6 +233,9 @@ module Asciidoctor
   # String for matching tab character
   TAB = "\t"
 
+  # Maximum integer value for "boundless" operations; equal to MAX_SAFE_INTEGER in JavaScript
+  MAX_INT = 9007199254740991
+
   # The default document type
   # Can influence markup generated by the converters
   DEFAULT_DOCTYPE = 'article'
@@ -259,10 +270,10 @@ module Asciidoctor
 
   # Set of file extensions recognized as AsciiDoc documents (stored as a truth hash)
   ASCIIDOC_EXTENSIONS = {
-    '.asciidoc' => true,
     '.adoc' => true,
-    '.ad' => true,
+    '.asciidoc' => true,
     '.asc' => true,
+    '.ad' => true,
     # TODO .txt should be deprecated
     '.txt' => true
   }
@@ -281,7 +292,7 @@ module Asciidoctor
 
   CALLOUT_LIST_HEADS = ['<', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0'].to_set
 
-  PARAGRAPH_STYLES = ['comment', 'example', 'literal', 'listing', 'normal', 'pass', 'quote', 'sidebar', 'source', 'verse', 'abstract', 'partintro'].to_set
+  PARAGRAPH_STYLES = ['comment', 'example', 'literal', 'listing', 'normal', 'open', 'pass', 'quote', 'sidebar', 'source', 'verse', 'abstract', 'partintro'].to_set
 
   VERBATIM_STYLES = ['literal', 'listing', 'source', 'verse'].to_set
 
@@ -345,6 +356,8 @@ module Asciidoctor
 
   LINE_CONTINUATION_LEGACY = ' +'
 
+  MATHJAX_VERSION = '2.7.4'
+
   BLOCK_MATH_DELIMITERS = {
     :asciimath => ['\$', '\$'],
     :latexmath => ['\[', '\]'],
@@ -355,21 +368,18 @@ module Asciidoctor
     :latexmath => ['\(', '\)'],
   }
 
+  (STEM_TYPE_ALIASES = {
+    'latexmath' => 'latexmath',
+    'latex' => 'latexmath',
+    'tex' => 'latexmath'
+  }).default = 'asciimath'
+
+  FONT_AWESOME_VERSION = '4.7.0'
+
   # attributes which be changed within the content of the document (but not
   # header) because it has semantic meaning; ex. sectnums
   FLEXIBLE_ATTRIBUTES = ['sectnums']
 
-  # map of file extension to comment affixes for languages that only support circumfix comments
-  CIRCUMFIX_COMMENTS = {
-    ['/*', '*/'] => ['.css'],
-    ['(*', '*)'] => ['.ml', '.mli', '.nb'],
-    ['<!--', '-->'] => ['.html', '.xhtml', '.xml', '.xsl'],
-    ['<%--', '--%>'] => ['.asp', '.jsp']
-  }.inject({}) {|accum, (affixes, exts)|
-    exts.each {|ext| accum[ext] = { :prefix => affixes[0], :suffix => affixes[-1] } }
-    accum
-  }
-
   # A collection of regular expressions used by the parser.
   #
   # NOTE: The following pattern, which appears frequently, captures the
@@ -485,7 +495,7 @@ module Asciidoctor
     #   include::chapter1.ad[]
     #   include::example.txt[lines=1;2;5..10]
     #
-    IncludeDirectiveRx = /^(\\)?include::([^\[][^\[]*)\[(.*)\]$/
+    IncludeDirectiveRx = /^(\\)?include::([^\[][^\[]*)\[(.+)?\]$/
 
     # Matches a trailing tag directive in an include file.
     #
@@ -498,7 +508,7 @@ module Asciidoctor
     #     log(e);
     #   }
     #   // end::try-catch[]
-    TagDirectiveRx = /\b(?:tag|(end))::(\S+)\[\]$/
+    TagDirectiveRx = /\b(?:tag|(e)nd)::(\S+?)\[\][\n \r]/
 
     ## Attribute entries and references
 
@@ -515,10 +525,10 @@ module Asciidoctor
     #                collapsing the line breaks and indentation to \
     #                a single space.
     #
-    AttributeEntryRx = /^:(!?\w.*?):(?:[ \t]+(.*))?$/
+    AttributeEntryRx = /^:(!?#{CG_WORD}[^:]*):(?:[ \t]+(.*))?$/
 
     # Matches invalid characters in an attribute name.
-    InvalidAttributeNameCharsRx = /[^\w\-]/
+    InvalidAttributeNameCharsRx = /[^#{CC_WORD}-]/
 
     # Matches a pass inline macro that surrounds the value of an attribute
     # entry once it has been parsed.
@@ -544,7 +554,7 @@ module Asciidoctor
     #   {set:foo:bar}
     #   {set:name!}
     #
-    AttributeReferenceRx = /(\\)?\{(\w+[-\w]*|(set|counter2?):.+?)(\\)?\}/
+    AttributeReferenceRx = /(\\)?\{(#{CG_WORD}+[-#{CC_WORD}]*|(set|counter2?):.+?)(\\)?\}/
 
     ## Paragraphs and delimited blocks
 
@@ -583,7 +593,7 @@ module Asciidoctor
     #
     #   .Title goes here
     #
-    BlockTitleRx = /^\.([^ \t.].*)$/
+    BlockTitleRx = /^\.(\.?[^ \t.].*)$/
 
     # Matches an admonition label at the start of a paragraph.
     #
@@ -650,26 +660,17 @@ module Asciidoctor
     #
     InlineSectionAnchorRx = / (\\)?\[\[([#{CC_ALPHA}_:][#{CC_WORD}:.-]*)(?:, *(.+))?\]\]$/
 
-    # Matches invalid characters in a section id.
+    # Matches invalid ID characters in a section title.
     #
-    # NOTE uppercase chars are not included since the expression is used on a lowercased string
-    InvalidSectionIdCharsRx = /&(?:[a-z][a-z]+\d{0,2}|#\d\d\d{0,4}|#x[\da-f][\da-f][\da-f]{0,3});|[^#{CC_WORD}]+?/
-
-    # Matches the block style used to designate a discrete (aka free-floating) heading.
-    #
-    # Examples
-    #
-    #   [discrete]
-    #   = Discrete Heading
-    #
-    DiscreteHeadingStyleRx = /^(?:discrete|float)\b/
+    # NOTE uppercase chars not included since expression is only run on a lowercase string
+    InvalidSectionIdCharsRx = /<[^>]+>|&(?:[a-z][a-z]+\d{0,2}|#\d\d\d{0,4}|#x[\da-f][\da-f][\da-f]{0,3});|[^ #{CC_WORD}\-.]+?/
 
     ## Lists
 
     # Detects the start of any list item.
     #
     # NOTE we only have to check as far as the blank character because we know it means non-whitespace follows.
-    AnyListRx = /^(?:[ \t]*(?:-|\*\*{0,4}|\.\.{0,4}|\u2022\u2022{0,4}|\d+\.|[a-zA-Z]\.|[IVXivx]+\))[ \t]|[ \t]*.*?(?::{2,4}|;;)(?:$|[ \t])|<?\d+>[ \t])/
+    AnyListRx = /^(?:[ \t]*(?:-|\*\*{0,4}|\.\.{0,4}|\u2022\u2022{0,4}|\d+\.|[a-zA-Z]\.|[IVXivx]+\))[ \t]|[ \t]*.*?(?::::{0,2}|;;)(?:$|[ \t])|<?\d+>[ \t])/
 
     # Matches an unordered list item (one level for hyphens, up to 5 levels for asterisks).
     #
@@ -712,35 +713,34 @@ module Asciidoctor
     # Examples
     #
     #   foo::
-    #   foo:::
-    #   foo::::
-    #   foo;;
+    #   bar:::
+    #   baz::::
+    #   blah;;
     #
-    #   # the term can be followed by a description on the same line...
+    #   # the term may be followed by a description on the same line...
     #
-    #   foo:: That which precedes 'bar' (see also, <<bar>>)
+    #   foo:: The metasyntactic variable that commonly accompanies 'bar' (see also, <<bar>>).
     #
-    #   # ...or on a separate line (optionally indented)
+    #   # ...or on a separate line, which may optionally be indented
     #
     #   foo::
-    #     That which precedes 'bar' (see also, <<bar>>)
+    #     The metasyntactic variable that commonly accompanies 'bar' (see also, <<bar>>).
     #
-    #   # the term or description may be an attribute reference
+    #   # attribute references may be used in both the term and the description
     #
-    #   {foo_term}:: {foo_def}
+    #   {foo-term}:: {foo-desc}
     #
+    # NOTE we know trailing (.*) will match at least one character because we strip trailing spaces
     # NOTE negative match for comment line is intentional since that isn't handled when looking for next list item
     # TODO check for line comment when scanning lines instead of in regex
-    #
-    DescriptionListRx = %r(^(?!//)[ \t]*(.*?)(:{2,4}|;;)(?:[ \t]+(.*))?$)
+    DescriptionListRx = %r(^(?!//)[ \t]*(.*?)(:::{0,2}|;;)(?:$|[ \t]+(.*)$))
 
     # Matches a sibling description list item (which does not include the type in the key).
     DescriptionListSiblingRx = {
-      # (?:.*?[^:])? - a non-capturing group which grabs longest sequence of characters that doesn't end w/ colon
-      '::' => %r(^(?!//)[ \t]*((?:.*[^:])?)(::)(?:[ \t]+(.*))?$),
-      ':::' => %r(^(?!//)[ \t]*((?:.*[^:])?)(:::)(?:[ \t]+(.*))?$),
-      '::::' => %r(^(?!//)[ \t]*((?:.*[^:])?)(::::)(?:[ \t]+(.*))?$),
-      ';;' => %r(^(?!//)[ \t]*(.*)(;;)(?:[ \t]+(.*))?$)
+      '::' => %r(^(?!//)[ \t]*(.*[^:]|)(::)(?:$|[ \t]+(.*)$)),
+      ':::' => %r(^(?!//)[ \t]*(.*[^:]|)(:::)(?:$|[ \t]+(.*)$)),
+      '::::' => %r(^(?!//)[ \t]*(.*[^:]|)(::::)(?:$|[ \t]+(.*)$)),
+      ';;' => %r(^(?!//)[ \t]*(.*?)(;;)(?:$|[ \t]+(.*)$))
     }
 
     # Matches a callout list item.
@@ -787,7 +787,7 @@ module Asciidoctor
     #
     #   1*h,2*,^3e
     #
-    ColumnSpecRx = /^(?:(\d+)\*)?([<^>](?:\.[<^>]?)?|(?:[<^>]?\.)?[<^>])?(\d+%?)?([a-z])?$/
+    ColumnSpecRx = /^(?:(\d+)\*)?([<^>](?:\.[<^>]?)?|(?:[<^>]?\.)?[<^>])?(\d+%?|~)?([a-z])?$/
 
     # Parses the start and end of a cell spec (i.e., cellspec) for a table.
     #
@@ -809,7 +809,7 @@ module Asciidoctor
     #
     #--
     # NOTE we've relaxed the match for target to accomodate the short format (e.g., name::[attrlist])
-    CustomBlockMacroRx = /^(#{CG_WORD}+)::(|\S|\S.*?\S)\[(.*)\]$/
+    CustomBlockMacroRx = /^(#{CG_WORD}+)::(|\S|\S.*?\S)\[(.+)?\]$/
 
     # Matches an image, video or audio block macro.
     #
@@ -818,7 +818,7 @@ module Asciidoctor
     #   image::filename.png[Caption]
     #   video::http://youtube.com/12345[Cats vs Dogs]
     #
-    BlockMediaMacroRx = /^(image|video|audio)::(\S|\S.*?\S)\[(.*)\]$/
+    BlockMediaMacroRx = /^(image|video|audio)::(\S|\S.*?\S)\[(.+)?\]$/
 
     # Matches the TOC block macro.
     #
@@ -827,7 +827,7 @@ module Asciidoctor
     #   toc::[]
     #   toc::[levels=2]
     #
-    BlockTocMacroRx = /^toc::\[(.*)\]$/
+    BlockTocMacroRx = /^toc::\[(.+)?\]$/
 
     ## Inline macros
 
@@ -845,6 +845,9 @@ module Asciidoctor
     # Scans for a non-escaped anchor (i.e., id + optional reference text) in the flow of text.
     InlineAnchorScanRx = /(?:^|[^\\\[])\[\[([#{CC_ALPHA}_:][#{CC_WORD}:.-]*)(?:, *(.+?))?\]\]|(?:^|[^\\])anchor:([#{CC_ALPHA}_:][#{CC_WORD}:.-]*)\[(?:\]|(.*?[^\\])\])/
 
+    # Scans for a leading, non-escaped anchor (i.e., id + optional reference text).
+    LeadingInlineAnchorRx = /^\[\[([#{CC_ALPHA}_:][#{CC_WORD}:.-]*)(?:, *(.+?))?\]\]/
+
     # Matches a bibliography anchor at the start of the list item text (in a bibliography list).
     #
     # Examples
@@ -857,16 +860,18 @@ module Asciidoctor
     #
     #   doc.writer@example.com
     #
-    EmailInlineRx = %r(([\\>:/])?#{CG_WORD}[#{CC_WORD}.%+-]*@#{CG_ALNUM}[#{CC_ALNUM}.-]*\.#{CG_ALPHA}{2,4}\b)
+    InlineEmailRx = %r(([\\>:/])?#{CG_WORD}[#{CC_WORD}.%+-]*@#{CG_ALNUM}[#{CC_ALNUM}.-]*\.#{CG_ALPHA}{2,4}\b)
 
     # Matches an inline footnote macro, which is allowed to span multiple lines.
     #
     # Examples
-    #   footnote:[text]
-    #   footnoteref:[id,text]
-    #   footnoteref:[id]
+    #   footnote:[text] (not referenceable)
+    #   footnote:id[text] (referenceable)
+    #   footnote:id[] (reference)
+    #   footnoteref:[id,text] (legacy)
+    #   footnoteref:[id] (legacy)
     #
-    InlineFootnoteMacroRx = /\\?(footnote(?:ref)?):\[(#{CC_ALL}*?[^\\])\]/m
+    InlineFootnoteMacroRx = /\\?footnote(?:(ref):|:([\w-]+)?)\[(?:|(#{CC_ALL}*?[^\\]))\]/m
 
     # Matches an image or icon inline macro.
     #
@@ -913,7 +918,7 @@ module Asciidoctor
     #   link:https://github.com[]
     #
     # FIXME revisit! the main issue is we need different rules for implicit vs explicit
-    LinkInlineRx = %r((^|link:|#{CG_BLANK}|&lt;|[>\(\)\[\];])(\\?(?:https?|file|ftp|irc)://[^\s\[\]<]*[^\s.,\[\]<])(?:\[(|#{CC_ALL}*?[^\\])\])?)m
+    InlineLinkRx = %r((^|link:|#{CG_BLANK}|&lt;|[>\(\)\[\];])(\\?(?:https?|file|ftp|irc)://[^\s\[\]<]*[^\s.,\[\]<])(?:\[(|#{CC_ALL}*?[^\\])\])?)m
 
     # Match a link or e-mail inline macro.
     #
@@ -955,9 +960,9 @@ module Asciidoctor
     #
     #   "File > New..."
     #
-    MenuInlineRx = /\\?"([#{CC_WORD}&][^"]*?[ \n]+&gt;[ \n]+[^"]*)"/
+    InlineMenuRx = /\\?"([#{CC_WORD}&][^"]*?[ \n]+&gt;[ \n]+[^"]*)"/
 
-    # Matches an inline passthrough value, which may span multiple lines.
+    # Matches an inline passthrough, which may span multiple lines.
     #
     # Examples
     #
@@ -965,11 +970,20 @@ module Asciidoctor
     #   `text` (compat)
     #
     # NOTE we always capture the attributes so we know when to use compatible (i.e., legacy) behavior
-    PassInlineRx = {
+    InlinePassRx = {
       false => ['+', '`', /(^|[^#{CC_WORD};:])(?:\[([^\]]+)\])?(\\?(\+|`)(\S|\S#{CC_ALL}*?\S)\4)(?!#{CG_WORD})/m],
       true  => ['`', nil, /(^|[^`#{CC_WORD}])(?:\[([^\]]+)\])?(\\?(`)([^`\s]|[^`\s]#{CC_ALL}*?\S)\4)(?![`#{CC_WORD}])/m]
     }
 
+    # Matches an inline plus passthrough spanning multiple lines, but only when it occurs directly
+    # inside constrained monospaced formatting in non-compat mode.
+    #
+    # Examples
+    #
+    #   +text+
+    #
+    SinglePlusInlinePassRx = /^(\\)?\+(\S|\S#{CC_ALL}*?\S)\+$/m
+
     # Matches several variants of the passthrough inline macro, which may span multiple lines.
     #
     # Examples
@@ -1257,8 +1271,9 @@ module Asciidoctor
   # Public: Parse the AsciiDoc source input into a {Document}
   #
   # Accepts input as an IO (or StringIO), String or String Array object. If the
-  # input is a File, information about the file is stored in attributes on the
-  # Document object.
+  # input is a File, the object is expected to be opened for reading and is not
+  # closed afterwards by this method. Information about the file (filename,
+  # directory name, etc) gets assigned to attributes on the Document object.
   #
   # input   - the AsciiDoc source as a IO, String or Array.
   # options - a String, Array or Hash of options to control processing (default: {})
@@ -1268,10 +1283,15 @@ module Asciidoctor
   # Returns the Document
   def load input, options = {}
     options = options.dup
+
     if (timings = options[:timings])
       timings.start :read
     end
 
+    if (logger = options[:logger]) && logger != LoggerManager.logger
+      LoggerManager.logger = logger
+    end
+
     if !(attrs = options[:attributes])
       attrs = {}
     elsif ::Hash === attrs || (::RUBY_ENGINE_JRUBY && ::Java::JavaUtil::Map === attrs)
@@ -1363,10 +1383,6 @@ module Asciidoctor
 
   # Public: Parse the contents of the AsciiDoc source file into an Asciidoctor::Document
   #
-  # Accepts input as an IO, String or String Array object. If the
-  # input is a File, information about the file is stored in
-  # attributes on the Document.
-  #
   # input   - the String AsciiDoc source filename
   # options - a String, Array or Hash of options to control processing (default: {})
   #           String and Array values are converted into a Hash.
@@ -1374,17 +1390,18 @@ module Asciidoctor
   #
   # Returns the Asciidoctor::Document
   def load_file filename, options = {}
-    ::File.open(filename) {|file| self.load file, options }
+    ::File.open(filename, 'rb') {|file| self.load file, options }
   end
 
   # Public: Parse the AsciiDoc source input into an Asciidoctor::Document and
   # convert it to the specified backend format.
   #
-  # Accepts input as an IO, String or String Array object. If the
-  # input is a File, information about the file is stored in
-  # attributes on the Document.
+  # Accepts input as an IO (or StringIO), String or String Array object. If the
+  # input is a File, the object is expected to be opened for reading and is not
+  # closed afterwards by this method. Information about the file (filename,
+  # directory name, etc) gets assigned to attributes on the Document object.
   #
-  # If the :in_place option is true, and the input is a File, the output is
+  # If the :to_file option is true, and the input is a File, the output is
   # written to a file adjacent to the input file, having an extension that
   # corresponds to the backend format. Otherwise, if the :to_file option is
   # specified, the file is written to that file. If :to_file is not an absolute
@@ -1412,7 +1429,6 @@ module Asciidoctor
     to_file = options.delete(:to_file)
     to_dir = options.delete(:to_dir)
     mkdirs = options.delete(:mkdirs) || false
-    timings = options[:timings]
 
     case to_file
     when true, nil
@@ -1429,7 +1445,7 @@ module Asciidoctor
       return self.load input, options
     else
       write_to_same_dir = false
-      write_to_target = (stream_output = to_file.respond_to? :write) ? false : to_file
+      write_to_target = (stream_output = to_file.respond_to? :write) ? false : (options[:to_file] = to_file)
     end
 
     unless options.key? :header_footer
@@ -1443,17 +1459,17 @@ module Asciidoctor
     elsif write_to_target
       if to_dir
         if to_file
-          options[:to_dir] = ::File.expand_path ::File.join to_dir, to_file, '..'
+          options[:to_dir] = ::File.dirname ::File.expand_path ::File.join to_dir, to_file
         else
           options[:to_dir] = ::File.expand_path to_dir
         end
       elsif to_file
-        options[:to_dir] = ::File.expand_path to_file, '..'
+        options[:to_dir] = ::File.dirname ::File.expand_path to_file
       end
-    else
-      options[:to_dir] = nil
     end
 
+    # NOTE :to_dir is always set when outputting to a file
+    # NOTE :to_file option only passed if assigned an explicit path
     doc = self.load input, options
 
     if write_to_same_dir # write to file in same directory
@@ -1462,7 +1478,7 @@ module Asciidoctor
         raise ::IOError, %(input file and output file cannot be the same: #{outfile})
       end
     elsif write_to_target # write to explicit file or directory
-      working_dir = (options.key? :base_dir) ? (::File.expand_path options[:base_dir]) : (::File.expand_path ::Dir.pwd)
+      working_dir = (options.key? :base_dir) ? (::File.expand_path options[:base_dir]) : ::Dir.pwd
       # QUESTION should the jail be the working_dir or doc.base_dir???
       jail = doc.safe >= SafeMode::SAFE ? working_dir : nil
       if to_dir
@@ -1484,28 +1500,22 @@ module Asciidoctor
         raise ::IOError, %(input file and output file cannot be the same: #{outfile})
       end
 
-      unless ::File.directory? outdir
-        if mkdirs
-          Helpers.mkdir_p outdir
-        else
-          # NOTE we intentionally refer to the directory as it was passed to the API
-          raise ::IOError, %(target directory does not exist: #{to_dir})
-        end
+      if mkdirs
+        Helpers.mkdir_p outdir
+      else
+        # NOTE we intentionally refer to the directory as it was passed to the API
+        raise ::IOError, %(target directory does not exist: #{to_dir} (hint: set mkdirs option)) unless ::File.directory? outdir
       end
     else # write to stream
       outfile = to_file
       outdir = nil
     end
 
-    timings.start :convert if timings
     opts = outfile && !stream_output ? { 'outfile' => outfile, 'outdir' => outdir } : {}
     output = doc.convert opts
-    timings.record :convert if timings
 
     if outfile
-      timings.start :write if timings
       doc.write output, outfile
-      timings.record :write if timings
 
       # NOTE document cannot control this behavior if safe >= SafeMode::SERVER
       # NOTE skip if stylesdir is a URI
@@ -1525,7 +1535,11 @@ module Asciidoctor
         copy_pygments_stylesheet = (doc.attr? 'source-highlighter', 'pygments') && (doc.attr 'pygments-css', 'class') == 'class'
         if copy_asciidoctor_stylesheet || copy_user_stylesheet || copy_coderay_stylesheet || copy_pygments_stylesheet
           stylesoutdir = doc.normalize_system_path(stylesdir, outdir, doc.safe >= SafeMode::SAFE ? outdir : nil)
-          Helpers.mkdir_p stylesoutdir if mkdirs
+          if mkdirs
+            Helpers.mkdir_p stylesoutdir
+          else
+            raise ::IOError, %(target stylesheet directory does not exist: #{stylesoutdir} (hint: set mkdirs option)) unless ::File.directory? stylesoutdir
+          end
 
           if copy_asciidoctor_stylesheet
             Stylesheets.instance.write_primary_stylesheet stylesoutdir
@@ -1572,7 +1586,7 @@ module Asciidoctor
   # Returns the Document object if the converted String is written to a
   # file, otherwise the converted String
   def convert_file filename, options = {}
-    ::File.open(filename) {|file| self.convert file, options }
+    ::File.open(filename, 'rb') {|file| self.convert file, options }
   end
 
   # Alias render_file to convert_file to maintain backwards compatibility
diff -pruN 1.5.6.2-2/man/asciidoctor.1 1.5.7-1/man/asciidoctor.1
--- 1.5.6.2-2/man/asciidoctor.1	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/man/asciidoctor.1	2018-05-05 22:54:38.000000000 +0000
@@ -1,23 +1,32 @@
 '\" t
 .\"     Title: asciidoctor
 .\"    Author: Dan Allen, Sarah White, Ryan Waldron
-.\" Generator: Asciidoctor 1.5.6.2
-.\"      Date: 2018-03-20
+.\" Generator: Asciidoctor 1.5.7
+.\"      Date: 2018-05-02
 .\"    Manual: Asciidoctor Manual
-.\"    Source: Asciidoctor 1.5.6.2
+.\"    Source: Asciidoctor 1.5.7
 .\"  Language: English
 .\"
-.TH "ASCIIDOCTOR" "1" "2018-03-20" "Asciidoctor 1.5.6.2" "Asciidoctor Manual"
+.TH "ASCIIDOCTOR" "1" "2018-05-02" "Asciidoctor 1.5.7" "Asciidoctor Manual"
 .ie \n(.g .ds Aq \(aq
 .el       .ds Aq '
 .ss \n[.ss] 0
 .nh
 .ad l
 .de URL
-\\$2 \(laURL: \\$1 \(ra\\$3
+\fI\\$2\fP <\\$1>\\$3
 ..
-.if \n[.g] .mso www.tmac
-.LINKSTYLE blue R < >
+.als MTO URL
+.if \n[.g] \{\
+.  mso www.tmac
+.  am URL
+.    ad l
+.  .
+.  am MTO
+.    ad l
+.  .
+.  LINKSTYLE blue R < >
+.\}
 .SH "NAME"
 asciidoctor \- converts AsciiDoc source files to HTML, DocBook and other formats
 .SH "SYNOPSIS"
@@ -41,7 +50,7 @@ When combined with the safe mode setting
 \fB\-S, \-\-safe\-mode\fP=\fISAFE_MODE\fP
 .RS 4
 Set safe mode level: \fIunsafe\fP, \fIsafe\fP, \fIserver\fP or \fIsecure\fP.
-Disables potentially dangerous macros in source files, such as \f[CR]include::[]\fP.
+Disables potentially dangerous macros in source files, such as \f(CRinclude::[]\fP.
 If not set, the safe mode level defaults to \fIunsafe\fP when Asciidoctor is invoked using this script.
 .RE
 .sp
@@ -83,13 +92,7 @@ The \fImanpage\fP document type enables
 The \fIinline\fP document type allows the content of a single paragraph to be formatted and returned without wrapping it in a containing element.
 Defaults to \fIarticle\fP.
 .RE
-.SS "Rendering Control"
-.sp
-\fB\-C, \-\-compact\fP
-.RS 4
-Compact the output by removing blank lines.
-(No longer in use).
-.RE
+.SS "Document Conversion"
 .sp
 \fB\-D, \-\-destination\-dir\fP=\fIDIR\fP
 .RS 4
@@ -122,7 +125,7 @@ This option may be specified more than o
 \fB\-n, \-\-section\-numbers\fP
 .RS 4
 Auto\-number section titles.
-Synonym for \fB\-\-attribute numbered\fP.
+Synonym for \fB\-\-attribute sectnums\fP.
 .RE
 .sp
 \fB\-o, \-\-out\-file\fP=\fIOUT_FILE\fP
@@ -134,6 +137,14 @@ If the input is read from standard input
 If \fIOUT_FILE\fP is \fI\-\fP, then the output file is written to standard output.
 .RE
 .sp
+\fB\-R, \-\-source\-dir\fP=\fIDIR\fP
+.RS 4
+Source directory.
+Currently only used if the destination directory is also specified.
+Used to preserve the directory structure of files converted within this directory in the destination directory.
+If specified, the directory is resolved relative to the working directory.
+.RE
+.sp
 \fB\-r, \-\-require\fP=\fILIBRARY\fP
 .RS 4
 Require the specified library before executing the processor, using the standard Ruby require.
@@ -158,6 +169,12 @@ Matching templates found in subsequent d
 .RE
 .SS "Processing Information"
 .sp
+\fB\-\-failure\-level\fP=\fILEVEL\fP
+.RS 4
+The minimum logging level that triggers a non\-zero exit code (failure).
+If this option is not set (default: FATAL), the program exits with a status code zero even if warnings or errors have been logged.
+.RE
+.sp
 \fB\-q, \-\-quiet\fP
 .RS 4
 Silence warnings.
@@ -191,7 +208,7 @@ Dump the Asciidoctor man page (in troff/
 .RS 4
 Print program version number.
 .sp
-\f[CR]\-v\fP can also be used if no other flags or arguments are present.
+\f(CR\-v\fP can also be used if no other flags or arguments are present.
 .RE
 .SH "ENVIRONMENT"
 .sp
@@ -223,7 +240,7 @@ Refer to the \fBAsciidoctor\fP issue tra
 .SH "RESOURCES"
 .sp
 \fBProject web site:\fP \c
-.URL "http://asciidoctor.org" "" ""
+.URL "https://asciidoctor.org" "" ""
 .sp
 \fBGit source repository on GitHub:\fP \c
 .URL "https://github.com/asciidoctor/asciidoctor" "" ""
@@ -237,9 +254,10 @@ Refer to the \fBAsciidoctor\fP issue tra
 .sp
 Copyright (C) 2012\-2018 Dan Allen, Ryan Waldron and the Asciidoctor Project.
 Free use of this software is granted under the terms of the MIT License.
-.SH "AUTHOR(S)"
+.SH "AUTHORS"
 .sp
-\fBDan Allen, Sarah White, Ryan Waldron\fP
-.RS 4
-Author(s).
-.RE
\ No newline at end of file
+Dan Allen
+.sp
+Sarah White
+.sp
+Ryan Waldron
\ No newline at end of file
diff -pruN 1.5.6.2-2/man/asciidoctor.adoc 1.5.7-1/man/asciidoctor.adoc
--- 1.5.6.2-2/man/asciidoctor.adoc	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/man/asciidoctor.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -2,7 +2,7 @@
 Dan Allen; Sarah White; Ryan Waldron
 :doctype: manpage
 :man manual: Asciidoctor Manual
-:man source: Asciidoctor 1.5.6.2
+:man source: Asciidoctor 1.5.7
 :page-layout: base
 
 == NAME
@@ -65,11 +65,7 @@ This option may be specified more than o
   The _inline_ document type allows the content of a single paragraph to be formatted and returned without wrapping it in a containing element.
   Defaults to _article_.
 
-=== Rendering Control
-
-*-C, --compact*::
-  Compact the output by removing blank lines.
-  (No longer in use).
+=== Document Conversion
 
 *-D, --destination-dir*=_DIR_::
   Destination output directory.
@@ -93,7 +89,7 @@ This option may be specified more than o
 
 *-n, --section-numbers*::
   Auto-number section titles.
-  Synonym for *--attribute numbered*.
+  Synonym for *--attribute sectnums*.
 
 *-o, --out-file*=_OUT_FILE_::
   Write output to file _OUT_FILE_.
@@ -102,6 +98,12 @@ This option may be specified more than o
   If the input is read from standard input or a named pipe (fifo), then the output file defaults to stdout.
   If _OUT_FILE_ is _-_, then the output file is written to standard output.
 
+*-R, --source-dir*=_DIR_::
+  Source directory.
+  Currently only used if the destination directory is also specified.
+  Used to preserve the directory structure of files converted within this directory in the destination directory.
+  If specified, the directory is resolved relative to the working directory.
+
 *-r, --require*=_LIBRARY_::
   Require the specified library before executing the processor, using the standard Ruby require.
   This option may be specified more than once.
@@ -121,6 +123,10 @@ Matching templates found in subsequent d
 
 === Processing Information
 
+*--failure-level*=_LEVEL_::
+  The minimum logging level that triggers a non-zero exit code (failure).
+  If this option is not set (default: FATAL), the program exits with a status code zero even if warnings or errors have been logged.
+
 *-q, --quiet*::
   Silence warnings.
 
@@ -172,7 +178,7 @@ Refer to the *Asciidoctor* issue tracker
 
 == RESOURCES
 
-*Project web site:* http://asciidoctor.org
+*Project web site:* https://asciidoctor.org
 
 *Git source repository on GitHub:* https://github.com/asciidoctor/asciidoctor
 
diff -pruN 1.5.6.2-2/Rakefile 1.5.7-1/Rakefile
--- 1.5.6.2-2/Rakefile	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/Rakefile	2018-05-05 22:54:38.000000000 +0000
@@ -82,3 +82,60 @@ desc 'Open an irb session preloaded with
 task :console do
   sh 'bundle console', :verbose => false
 end
+
+namespace :build do
+desc 'Trigger builds for all dependent projects on Travis CI'
+  task :dependents do
+    if ENV['TRAVIS'].to_s == 'true'
+      next unless ENV['TRAVIS_PULL_REQUEST'].to_s == 'false' &&
+          ENV['TRAVIS_TAG'].to_s.empty? &&
+          (ENV['TRAVIS_JOB_NUMBER'].to_s.end_with? '.1')
+    end
+    # NOTE The TRAVIS_TOKEN env var must be defined in Travis interface.
+    # Retrieve this token using the `travis token` command.
+    # The GitHub user corresponding to the Travis user must have write access to the repository.
+    # After granting permission, sign into Travis and resync the repositories.
+    next unless (token = ENV['TRAVIS_TOKEN'])
+    require 'json'
+    require 'net/http'
+    require 'open-uri'
+    require 'yaml'
+    %w(
+      asciidoctor/asciidoctor.js
+      asciidoctor/asciidoctorj
+      asciidoctor/asciidoctorj/asciidoctorj-1.6.0
+      asciidoctor/asciidoctor-diagram
+      asciidoctor/asciidoctor-reveal.js
+    ).each do |project|
+      org, name, branch = project.split '/', 3
+      branch ||= 'master'
+      project = [org, name, branch] * '/'
+      header = {
+        'Content-Type' => 'application/json',
+        'Accept' => 'application/json',
+        'Travis-API-Version' => '3',
+        'Authorization' => %(token #{token})
+      }
+      if (commit_hash = ENV['TRAVIS_COMMIT'])
+        commit_memo = %( (#{commit_hash.slice 0, 8})\n\nhttps://github.com/#{ENV['TRAVIS_REPO_SLUG'] || 'asciidoctor/asciidoctor'}/commit/#{commit_hash})
+      end
+      config = YAML.load open(%(https://raw.githubusercontent.com/#{project}/.travis-upstream-only.yml)) {|fd| fd.read } rescue {}
+      payload = {
+        'request' => {
+          'branch' => branch,
+          'message' => %(Build triggered by Asciidoctor#{commit_memo}),
+          'config' => config
+        }
+      }.to_json
+      (http = Net::HTTP.new 'api.travis-ci.org', 443).use_ssl = true
+      request = Net::HTTP::Post.new %(/repo/#{org}%2F#{name}/requests), header
+      request.body = payload
+      response = http.request request
+      if response.code == '202'
+        puts %(Successfully triggered build on #{project} repository)
+      else
+        warn %(Unable to trigger build on #{project} repository: #{response.code} - #{response.message})
+      end
+    end
+  end
+end
diff -pruN 1.5.6.2-2/README.adoc 1.5.7-1/README.adoc
--- 1.5.6.2-2/README.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/README.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,454 @@
+= Asciidoctor
+Dan Allen <https://github.com/mojavelinux[@mojavelinux]>; Sarah White <https://github.com/graphitefriction[@graphitefriction]>; Ryan Waldron <https://github.com/erebor[@erebor]>
+v1.5.7, 2018-05-02
+// settings:
+:idprefix:
+:idseparator: -
+:source-language: ruby
+:language: {source-language}
+ifndef::env-github[:icons: font]
+ifdef::env-github[]
+:status:
+:outfilesuffix: .adoc
+:caution-caption: :fire:
+:important-caption: :exclamation:
+:note-caption: :paperclip:
+:tip-caption: :bulb:
+:warning-caption: :warning:
+endif::[]
+// Variables:
+:release-version: 1.5.7
+// URIs:
+:uri-org: https://github.com/asciidoctor
+:uri-repo: {uri-org}/asciidoctor
+:uri-asciidoctorj: {uri-org}/asciidoctorj
+:uri-asciidoctorjs: {uri-org}/asciidoctor.js
+:uri-project: https://asciidoctor.org
+ifdef::env-site[:uri-project: link:]
+:uri-docs: {uri-project}/docs
+:uri-news: {uri-project}/news
+:uri-manpage: {uri-project}/man/asciidoctor
+:uri-issues: {uri-repo}/issues
+:uri-contributors: {uri-repo}/graphs/contributors
+:uri-rel-file-base: link:
+:uri-rel-tree-base: link:
+ifdef::env-site[]
+:uri-rel-file-base: {uri-repo}/blob/master/
+:uri-rel-tree-base: {uri-repo}/tree/master/
+endif::[]
+:uri-changelog: {uri-rel-file-base}CHANGELOG.adoc
+:uri-contribute: {uri-rel-file-base}CONTRIBUTING.adoc
+:uri-license: {uri-rel-file-base}LICENSE
+:uri-tests: {uri-rel-tree-base}test
+:uri-discuss: http://discuss.asciidoctor.org
+:uri-irc: irc://irc.freenode.org/#asciidoctor
+:uri-rubygem: https://rubygems.org/gems/asciidoctor
+:uri-what-is-asciidoc: {uri-docs}/what-is-asciidoc
+:uri-user-manual: {uri-docs}/user-manual
+:uri-install-docker: https://github.com/asciidoctor/docker-asciidoctor
+//:uri-install-doc: {uri-docs}/install-toolchain
+:uri-install-macos-doc: {uri-docs}/install-asciidoctor-macos
+:uri-render-doc: {uri-docs}/render-documents
+:uri-themes-doc: {uri-docs}/produce-custom-themes-using-asciidoctor-stylesheet-factory
+:uri-gitscm-repo: https://github.com/git/git-scm.com
+:uri-prototype: {uri-gitscm-repo}/commits/master/lib/asciidoc.rb
+:uri-freesoftware: https://www.gnu.org/philosophy/free-sw.html
+:uri-foundation: https://foundation.zurb.com
+:uri-tilt: https://github.com/rtomayko/tilt
+:uri-ruby: https://www.ruby-lang.org
+// images:
+:image-uri-screenshot: https://raw.githubusercontent.com/asciidoctor/asciidoctor/master/screenshot.png
+
+{uri-project}[Asciidoctor] is a _fast_ text processor and publishing toolchain for converting {uri-what-is-asciidoc}[AsciiDoc] content to HTML5, DocBook, PDF, and other formats.
+Asciidoctor is written in Ruby, packaged and distributed as a gem to {uri-rubygem}[RubyGems.org], and packaged for popular Linux distributions, including Fedora, Debian, Ubuntu, and Alpine.
+Asciidoctor can be run on the JVM using AsciidoctorJ and in all JavaScript environments using Asciidoctor.js.
+Asciidoctor is {uri-license}[open source software] and {uri-repo}[hosted on GitHub].
+
+ifndef::env-site[]
+This document is also available in the following languages: +
+{uri-rel-file-base}README-zh_CN.adoc[汉语]
+|
+{uri-rel-file-base}README-fr.adoc[Français]
+|
+{uri-rel-file-base}README-jp.adoc[日本語]
+endif::[]
+
+.Key documentation
+[.compact]
+* {uri-docs}/what-is-asciidoc[What is AsciiDoc?]
+* {uri-docs}/asciidoc-writers-guide[AsciiDoc Writer's Guide]
+* {uri-docs}/user-manual[Asciidoctor User Manual]
+* {uri-docs}/asciidoc-syntax-quick-reference[AsciiDoc Syntax Reference]
+
+ifdef::status[]
+.*Project health*
+image:https://img.shields.io/travis/asciidoctor/asciidoctor/master.svg[Build Status (Travis CI), link=https://travis-ci.org/asciidoctor/asciidoctor]
+image:https://ci.appveyor.com/api/projects/status/ifplu67oxvgn6ceq/branch/master?svg=true&amp;passingText=green%20bar&amp;failingText=%23fail&amp;pendingText=building%2E%2E%2E[Build Status (AppVeyor), link=https://ci.appveyor.com/project/asciidoctor/asciidoctor]
+//image:https://img.shields.io/coveralls/asciidoctor/asciidoctor/master.svg[Coverage Status, link=https://coveralls.io/r/asciidoctor/asciidoctor]
+//image:https://codeclimate.com/github/asciidoctor/asciidoctor/badges/gpa.svg[Code Climate, link="https://codeclimate.com/github/asciidoctor/asciidoctor"]
+image:https://inch-ci.org/github/asciidoctor/asciidoctor.svg?branch=master[Inline docs, link="https://inch-ci.org/github/asciidoctor/asciidoctor"]
+endif::[]
+
+== Sponsors
+
+We want to recognize our generous sponsors, without whose support Asciidoctor would not be possible.
+Thank you sponsors for your dedication to improving the state of technical documentation!
+
+image:https://www.okta.com/sites/all/themes/Okta/images/blog/Logos/Okta_Logo_BrightBlue_Medium.png[Okta,280,link=https://developer.okta.com/signup?utm_source=asciidoctor&utm_medium=logo&utm_campaign=sponsor,title="Add User Auth to Your Apps in Minutes with Okta"]
+&nbsp; &nbsp; &nbsp;
+image:https://secure.gravatar.com/avatar/823717a797dbd78ceff7b26aa397f383.png?size=200[OpenDevise,100,link=https://opendevise.com,title="Let the Creators of Asciidoctor and Antora Help You to Accelerate Your Docs"]
+
+Major funding for Asciidoctor is provided by our *Change Makers*, https://developer.okta.com/signup?utm_source=asciidoctor&utm_medium=text-link&utm_campaign=sponsor[Okta] and https://opendevise.com[OpenDevise], and our *Strategy Sponsors*, Khronos Group and Linda Roberts.
+Additional funding is provided by our https://asciidoctor.org/supporters[Community Backers].
+
+You can support this project by becoming a sponsor on https://opencollective.com/asciidoctor[OpenCollective].
+
+== The Big Picture
+
+Asciidoctor reads content written in plain text, as shown in the panel on the left in the image below, and converts it to HTML5, as shown rendered in the right panel.
+Asciidoctor applies a default stylesheet to the HTML5 document to provide a pleasant out-of-the-box experience.
+
+image::{image-uri-screenshot}[Preview of AsciiDoc source and corresponding rendered HTML]
+
+== AsciiDoc Processing
+
+Asciidoctor reads and parses text written in the AsciiDoc syntax, then feeds the parse tree to a set of built-in converters to produce HTML5, DocBook 5 (or 4.5) or man(ual) page output.
+You have the option of using your own converter or loading {uri-tilt}[Tilt]-supported templates to customize the generated output or produce additional formats.
+
+NOTE: Asciidoctor is a drop-in replacement for the original AsciiDoc Python processor (`asciidoc.py`).
+The Asciidoctor test suite has {uri-tests}[> 2,000 tests] to ensure compatibility with the AsciiDoc syntax.
+
+In addition to the classic AsciiDoc syntax, Asciidoctor recognizes additional markup and formatting options, such as font-based icons (e.g., `+icon:fire[]+`) and UI elements (e.g., `+button:[Save]+`).
+Asciidoctor also offers a modern, responsive theme based on {uri-foundation}[Foundation] to style the HTML5 output.
+
+== Where Ruby goes, Asciidoctor follows
+
+You can run Asciidoctor on the JVM using JRuby.
+To invoke the Asciidoctor API directly from Java and other JVM languages, use {uri-asciidoctorj}[AsciidoctorJ].
+There are plugins available, based on AsciidoctorJ, that integrate the Asciidoctor processor into Apache Maven, Gradle or Javadoc builds.
+
+Asciidoctor also runs in JavaScript.
+We use https://opalrb.com[Opal] to transcompile the Ruby source to JavaScript to produce {uri-asciidoctorjs}[Asciidoctor.js], a fully-functional version of Asciidoctor that works in any JavaScript environment, such as a web browser or Node.js.
+Asciidoctor.js is used to power the AsciiDoc preview extensions for Chrome, Atom, Brackets and other web-based tooling.
+
+== Requirements
+
+Asciidoctor works on Linux, macOS and Windows and requires one of the following implementations of {uri-ruby}[Ruby]:
+
+* Ruby (MRI/CRuby 1.8.7 - 2.5)
+* JRuby (1.7 in Ruby 1.8 and 1.9 modes, 9000)
+* Rubinius 2.2.x
+* Opal (JavaScript)
+
+We welcome your help testing Asciidoctor on these and other platforms.
+Refer to the <<Contributing>> section to learn how to get involved.
+
+[CAUTION]
+====
+If you're using a non-English Windows environment, you may bump into an `Encoding::UndefinedConversionError` when invoking Asciidoctor.
+To solve this issue, we recommend changing the active code page in your console to UTF-8:
+
+ chcp 65001
+
+Once you make this change, all your Unicode headaches will be behind you.
+If you're using an IDE like Eclipse, make sure you set the encoding to UTF-8 there as well.
+Asciidoctor works best when you use UTF-8 everywhere.
+====
+
+== Installation
+
+Asciidoctor can be installed using (a) the `gem install` command, (b) Bundler, (c) package managers for popular Linux distributions, or (d) Homebrew for macOS.
+
+TIP: The benefit of using a Linux package manager to install the gem is that it handles installing Ruby and the RubyGems library if those packages are not already installed on your machine.
+The drawback is that the package may not be available immediately after the release of the gem.
+If you need the latest version, you can always fallback to using the `gem` command.
+
+=== (a) gem install
+
+Open a terminal and type (excluding the leading `$`):
+
+ $ gem install asciidoctor
+
+If you want to install a pre-release version (e.g., a release candidate), use:
+
+ $ gem install asciidoctor --pre
+
+.Upgrading your installation
+[TIP]
+====
+If you have an earlier version of Asciidoctor installed, you can update it using:
+
+ $ gem update asciidoctor
+
+If you install a new version of the gem using `gem install` instead of gem update, you'll have multiple versions installed.
+If that's the case, use the following gem command to remove the old versions:
+
+ $ gem cleanup asciidoctor
+====
+
+=== (b) Bundler
+
+. Create a Gemfile in the root folder of your project (or the current directory)
+. Add the `asciidoctor` gem to your Gemfile as follows:
++
+[source,subs=attributes+]
+----
+source 'https://rubygems.org'
+gem 'asciidoctor'
+# or specify the version explicitly
+# gem 'asciidoctor', '{release-version}'
+----
+
+. Save the Gemfile
+. Open a terminal and install the gem using:
+
+ $ bundle
+
+To upgrade the gem, specify the new version in the Gemfile and run `bundle` again.
+Using `bundle update` is *not* recommended as it will also update other gems, which may not be the desired result.
+
+=== (c) Linux package managers
+
+==== DNF (Fedora 21 or greater)
+
+To install the gem on Fedora 21 or greater using dnf, open a terminal and type:
+
+ $ sudo dnf install -y asciidoctor
+
+To upgrade the gem, use:
+
+ $ sudo dnf update -y asciidoctor
+
+TIP: Your system may be configured to automatically update rpm packages, in which case no action is required by you to update the gem.
+
+==== apt-get (Debian, Ubuntu, or Mint)
+
+To install the gem on Debian, Ubuntu or Mint, open a terminal and type:
+
+ $ sudo apt-get install -y asciidoctor
+
+To upgrade the gem, use:
+
+ $ sudo apt-get upgrade -y asciidoctor
+
+TIP: Your system may be configured to automatically update deb packages, in which case no action is required by you to update the gem.
+
+The version of Asciidoctor installed by the package manager (apt-get) may not match the latest release of Asciidoctor.
+Consult the package repository for your distribution to find out which version is packaged per distribution release.
+
+* https://packages.debian.org/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Debian release]
+* https://packages.ubuntu.com/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Ubuntu release]
+* https://community.linuxmint.com/software/view/asciidoctor[asciidoctor package by Mint release]
+
+[CAUTION]
+====
+You're advised against using the `gem update` command to update a gem managed by the package manager.
+Doing so puts the system into an inconsistent state as the package manager can no longer track the files (which get installed under /usr/local).
+Simply put, system gems should only be managed by the package manager.
+
+If you want to use a version of Asciidoctor that is newer than what is installed by the package manager, you should use https://rvm.io[RVM] to install Ruby in your home directory (i.e., user space).
+Then, you can safely use the `gem` command to install or update the Asciidoctor gem.
+When using RVM, gems are installed in a location isolated from the system.
+====
+
+==== apk (Alpine Linux)
+
+To install the gem on Alpine Linux, open a terminal and type:
+
+ $ sudo apk add asciidoctor
+
+To upgrade the gem, use:
+
+ $ sudo apk add -u asciidoctor
+
+TIP: Your system may be configured to automatically update apk packages, in which case no action is required by you to update the gem.
+
+=== (d) Homebrew (macOS)
+
+You can use Homebrew to install Asciidoctor on macOS.
+If you haven't yet installed Homebrew, follow the instructions at https://brew.sh/[brew.sh].
+
+Once Homebrew is installed, you can install the `asciidoctor` gem using the http://brewformulas.org/Asciidoctor[asciidoctor] package.
+To do so, open a terminal and type:
+
+ $ brew install asciidoctor
+
+To upgrade the gem, use:
+
+ $ brew update
+ $ brew upgrade asciidoctor
+
+TIP: Homebrew installs the `asciidoctor` gem into an exclusive prefix that's independent of system gems.
+
+=== Other installation options
+
+* {uri-install-docker}[Installing Asciidoctor using Docker]
+* {uri-install-macos-doc}[Installing Asciidoctor on macOS]
+// at the moment, the following entry is just a reiteration of the information in this README
+//* {uri-install-doc}[Installing the Asciidoctor toolchain]
+
+== Usage
+
+If the Asciidoctor gem installed successfully, the `asciidoctor` command line interface (CLI) will be available on your PATH.
+To verify it's available, run the following in your terminal:
+
+ $ asciidoctor --version
+
+You should see information about the Asciidoctor version and your Ruby environment printed in the terminal.
+
+[.output,subs=attributes+]
+....
+Asciidoctor {release-version} [https://asciidoctor.org]
+Runtime Environment (ruby 2.4.1p111 [x86_64-linux]) (lc:UTF-8 fs:UTF-8 in:- ex:UTF-8)
+....
+
+Asciidoctor also provides an API.
+The API is intended for integration with other Ruby software, such as Rails, Sinatra and GitHub, and other languages, such as Java (via {uri-asciidoctorj}[AsciidoctorJ]) and JavaScript (via {uri-asciidoctorjs}[Asciidoctor.js]).
+
+=== Command line interface (CLI)
+
+The `asciidoctor` command allows you to invoke Asciidoctor from the command line (i.e., a terminal).
+
+The following command converts the file README.adoc to HTML and saves the result to the file README.html in the same directory.
+The name of the generated HTML file is derived from the source file by changing its file extension to `.html`.
+
+ $ asciidoctor README.adoc
+
+You can control the Asciidoctor processor by adding various flags and switches, which you can learn about using:
+
+ $ asciidoctor --help
+
+For instance, to write the file to a different directory, use:
+
+ $ asciidoctor -D output README.adoc
+
+The `asciidoctor` {uri-manpage}[man page] provides a complete reference of the command line interface.
+
+Refer to the following resources to learn more about how to use the `asciidoctor` command.
+
+* {uri-render-doc}[How do I convert a document?]
+* {uri-themes-doc}[How do I use the Asciidoctor stylesheet factory to produce custom themes?]
+
+=== Ruby API
+
+To use Asciidoctor in your application, you first need to require the gem:
+
+[source]
+require 'asciidoctor'
+
+You can then convert an AsciiDoc source file to an HTML file using:
+
+[source]
+Asciidoctor.convert_file 'README.adoc', to_file: true, safe: :safe
+
+WARNING: When using Asciidoctor via the API, the default safe mode is `:secure`.
+In secure mode, several core features are disabled, including the `include` directive.
+If you want to enable these features, you'll need to explicitly set the safe mode to `:server` (recommended) or `:safe`.
+
+You can also convert an AsciiDoc string to embeddable HTML (for inserting in an HTML page) using:
+
+[source]
+----
+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
+Asciidoctor.convert content, safe: :safe
+----
+
+If you want the full HTML document, enable the `header_footer` option as follows:
+
+[source]
+----
+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
+html = Asciidoctor.convert content, header_footer: true, safe: :safe
+----
+
+If you need access to the parsed document, you can split the conversion into discrete steps:
+
+[source]
+----
+content = '_Zen_ in the art of writing https://asciidoctor.org[AsciiDoc].'
+document = Asciidoctor.load content, header_footer: true, safe: :safe
+puts document.doctitle
+html = document.convert
+----
+
+Keep in mind that if you don't like the output Asciidoctor produces, _you can change it!_
+Asciidoctor supports custom converters that can handle converting from the parsed document to the generated output.
+
+One easy way to customize the output piecemeal is by using the template converter.
+The template converter allows you to supply a {uri-tilt}[Tilt]-supported template file to handle converting any node in the document.
+
+However you go about it, you _can_ have 100% control over the output.
+For more information about how to use the API or to customize the output, refer to the {uri-user-manual}[user manual].
+
+== Contributing
+
+In the spirit of {uri-freesoftware}[free software], _everyone_ is encouraged to help improve this project.
+If you discover errors or omissions in the source code, documentation, or website content, please don't hesitate to submit an issue or open a pull request with a fix.
+New contributors are always welcome!
+
+Here are some ways *you* can contribute:
+
+* by using prerelease (alpha, beta or preview) versions
+* by reporting bugs
+* by suggesting new features
+* by writing or editing documentation
+* by writing specifications
+* by writing code -- _No patch is too small._
+** fix typos
+** add comments
+** clean up inconsistent whitespace
+** write tests!
+* by refactoring code
+* by fixing {uri-issues}[issues]
+* by reviewing patches
+
+The {uri-contribute}[Contributing] guide provides information on how to create, style, and submit issues, feature requests, code, and documentation to the Asciidoctor Project.
+
+== Getting Help
+
+The Asciidoctor project is developed to help you easily write and publish your content.
+But we can't do it without your feedback!
+We encourage you to ask questions and discuss any aspects of the project on the discussion list, on Twitter or in the chat room.
+
+Discussion list (Nabble):: {uri-discuss}
+Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] hashtag or https://twitter.com/asciidoctor[@asciidoctor] mention
+Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+////
+Chat (IRC):: {uri-irc}[#asciidoctor] on FreeNode IRC
+////
+
+ifdef::env-github[]
+Further information and documentation about Asciidoctor can be found on the project's website.
+
+{uri-project}[Home] | {uri-news}[News] | {uri-docs}[Docs]
+endif::[]
+
+The Asciidoctor organization on GitHub hosts the project's source code, issue tracker, and sub-projects.
+
+Source repository (git):: {uri-repo}
+Issue tracker:: {uri-issues}
+Asciidoctor organization on GitHub:: {uri-org}
+
+== Copyright and Licensing
+
+Copyright (C) 2012-2018 Dan Allen, Ryan Waldron and the Asciidoctor Project.
+Free use of this software is granted under the terms of the MIT License.
+
+See the {uri-license}[LICENSE] file for details.
+
+== Authors
+
+*Asciidoctor* is led by https://github.com/mojavelinux[Dan Allen] and https://github.com/graphitefriction[Sarah White] and has received contributions from {uri-contributors}[many other individuals] in Asciidoctor's awesome community.
+The project was initiated in 2012 by https://github.com/erebor[Ryan Waldron] and based on {uri-prototype}[a prototype] written by https://github.com/nickh[Nick Hengeveld].
+
+*AsciiDoc* was started by Stuart Rackham and has received contributions from many other individuals in the AsciiDoc community.
+
+ifndef::env-site[]
+== Changelog
+
+ifeval::[{safe-mode-level} < 20]
+include::CHANGELOG.adoc[tag=compact,leveloffset=+1]
+endif::[]
+
+Refer to the {uri-changelog}[CHANGELOG] for a complete list of changes in older releases.
+endif::[]
diff -pruN 1.5.6.2-2/README-fr.adoc 1.5.7-1/README-fr.adoc
--- 1.5.6.2-2/README-fr.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/README-fr.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,441 @@
+= Asciidoctor
+Dan Allen <https://github.com/mojavelinux[@mojavelinux]>; Sarah White <https://github.com/graphitefriction[@graphitefriction]>; Ryan Waldron <https://github.com/erebor[@erebor]>
+v1.5.7, 2018-05-02
+// settings:
+:idprefix:
+:idseparator: -
+:source-language: ruby
+:language: {source-language}
+ifndef::env-github[:icons: font]
+ifdef::env-github[]
+:status:
+:outfilesuffix: .adoc
+:caution-caption: :fire:
+:important-caption: :exclamation:
+:note-caption: :paperclip:
+:tip-caption: :bulb:
+:warning-caption: :warning:
+endif::[]
+// Variables:
+:release-version: 1.5.7
+// URIs:
+:uri-org: https://github.com/asciidoctor
+:uri-repo: {uri-org}/asciidoctor
+:uri-asciidoctorj: {uri-org}/asciidoctorj
+:uri-asciidoctorjs: {uri-org}/asciidoctor.js
+:uri-project: http://asciidoctor.org
+ifdef::env-site[:uri-project: link:]
+:uri-docs: {uri-project}/docs
+:uri-news: {uri-project}/news
+:uri-manpage: {uri-project}/man/asciidoctor
+:uri-issues: {uri-repo}/issues
+:uri-contributors: {uri-repo}/graphs/contributors
+:uri-rel-file-base: link:
+:uri-rel-tree-base: link:
+ifdef::env-site[]
+:uri-rel-file-base: {uri-repo}/blob/master/
+:uri-rel-tree-base: {uri-repo}/tree/master/
+endif::[]
+:uri-changelog: {uri-rel-file-base}CHANGELOG.adoc
+:uri-contribute: {uri-rel-file-base}CONTRIBUTING.adoc
+:uri-license: {uri-rel-file-base}LICENSE
+:uri-tests: {uri-rel-tree-base}test
+:uri-discuss: http://discuss.asciidoctor.org
+:uri-irc: irc://irc.freenode.org/#asciidoctor
+:uri-rubygem: https://rubygems.org/gems/asciidoctor
+:uri-what-is-asciidoc: {uri-docs}/what-is-asciidoc
+:uri-user-manual: {uri-docs}/user-manual
+:uri-install-docker: https://github.com/asciidoctor/docker-asciidoctor
+//:uri-install-doc: {uri-docs}/install-toolchain
+:uri-install-macos-doc: {uri-docs}/install-asciidoctor-macos
+:uri-render-doc: {uri-docs}/render-documents
+:uri-themes-doc: {uri-docs}/produce-custom-themes-using-asciidoctor-stylesheet-factory
+:uri-gitscm-repo: https://github.com/git/git-scm.com
+:uri-prototype: {uri-gitscm-repo}/commits/master/lib/asciidoc.rb
+:uri-freesoftware: https://www.gnu.org/philosophy/free-sw.html
+:uri-foundation: http://foundation.zurb.com
+:uri-tilt: https://github.com/rtomayko/tilt
+:uri-ruby: https://ruby-lang.org
+// images:
+:image-uri-screenshot: https://raw.githubusercontent.com/asciidoctor/asciidoctor/master/screenshot.png
+
+{uri-project}/[Asciidoctor] est un processeur de texte _rapide_ et une chaîne de publication pour convertir du contenu {uri-what-is-asciidoc}[AsciiDoc] en HTML5, DocBook 5 (ou 4.5) et d'autres formats.
+Asciidoctor est écrit en Ruby, packagé sous forme de RubyGem et publié sur {uri-rubygem}[RubyGems.org].
+La gemme est aussi incluse dans plusieurs distributions Linux, dont Fedora, Debian, Ubuntu et Alpine.
+Asciidoctor est open source, {uri-repo}[hébergé sur GitHub] et distribué sous {uri-license}[licence MIT].
+
+ifndef::env-site[]
+Ce document est traduit dans les langues suivantes :
+
+* {uri-rel-file-base}README.adoc[Anglais]
+* {uri-rel-file-base}README-zh_CN.adoc[Chinois]
+* {uri-rel-file-base}README-jp.adoc[Japonais]
+endif::[]
+
+.Documentation clé
+[.compact]
+* {uri-docs}/what-is-asciidoc[Qu'est ce qu'AsciiDoc ?]
+* {uri-docs}/asciidoc-writers-guide[Guide pour Rédacteur AsciiDoc]
+* {uri-docs}/asciidoc-syntax-quick-reference[Syntaxe de Référence AsciiDoc]
+* {uri-docs}/user-manual[Manuel Utilisateur Asciidoctor]
+
+.Asciidoctor est disponible partout où Ruby est disponible
+****
+Vous pouvez exécuter Asciidoctor dans la JVM en utilisant JRuby.
+Pour invoquer l'API Asciidoctor directement depuis Java ou d'autres langages de la JVM, utilisez {uri-asciidoctorj}[AsciidoctorJ].
+Des plugins basés sur AsciidoctorJ permettent d'intégrer le processeur Asciidoctor avec Apache Maven, Gradle ou Javadoc.
+
+Asciidoctor s'exécute également au sein de JavaScript.
+Nous utilisons http://opalrb.org[Opal] pour transcrire le code source Ruby en JavaScript afin de produire {uri-asciidoctorjs}[Asciidoctor.js], une version pleinement fonctionnelle d'Asciidoctor qui s'intègre dans tout environnement JavaScript, comme un navigateur web ou Node.js.
+Asciidoctor.js est utilisé pour faire fonctionner les extensions AsciiDoc Preview pour Chrome, Atom, Brackets et autres outils web.
+****
+
+ifdef::status[]
+.*Santé du projet*
+image:https://img.shields.io/travis/asciidoctor/asciidoctor/master.svg[Build Status (Travis CI), link=https://travis-ci.org/asciidoctor/asciidoctor]
+image:https://ci.appveyor.com/api/projects/status/ifplu67oxvgn6ceq/branch/master?svg=true&amp;passingText=green%20bar&amp;failingText=%23fail&amp;pendingText=building%2E%2E%2E[Build Status (AppVeyor), link=https://ci.appveyor.com/project/asciidoctor/asciidoctor]
+//image:https://img.shields.io/coveralls/asciidoctor/asciidoctor/master.svg[Coverage Status, link=https://coveralls.io/r/asciidoctor/asciidoctor]
+//image:https://codeclimate.com/github/asciidoctor/asciidoctor/badges/gpa.svg[Code Climate, link="https://codeclimate.com/github/asciidoctor/asciidoctor"]
+image:https://inch-ci.org/github/asciidoctor/asciidoctor.svg?branch=master[Inline docs, link="https://inch-ci.org/github/asciidoctor/asciidoctor"]
+endif::[]
+
+== En un mot
+
+Asciidoctor lit du contenu écrit en texte brut, comme présenté dans la partie gauche de l'image ci-dessous, et le convertit en HTML5, comme présenté dans la partie droite.
+Asciidoctor applique une feuille de style par défaut au document HTML5 afin de fournir une expérience de lecture agréable, clé en main.
+
+image::{image-uri-screenshot}[Prévisualisation d'une source AsciiDoc et le rendu HTML correspondant]
+
+== Le traitement d'AsciiDoc
+
+Asciidoctor lit et analyse la syntaxe du texte écrit en AsciiDoc afin de créer une représentation, sous forme d'arbre, à partir de laquelle des templates sont appliqués pour produire de l'HTML5, du DocBook 5 (ou 4.5).
+
+Vous avez la possibilité d'écrire votre propre convertisseur ou de fournir des templates supportant {uri-tilt}[Tilt] pour personnaliser le résultat généré ou pour produire des formats alternatifs.
+
+NOTE: Asciidoctor est un remplaçant du processeur AsciiDoc original écrit en Python (`asciidoc.py`).
+La suite de tests Asciidoctor possède {uri-tests}[> 1,900 tests] pour garantir la compatibilité avec la syntaxe AsciiDoc.
+
+En plus de la syntaxe AsciiDoc standard, Asciidoctor reconnaît des balises additionnelles ainsi que des options de formatage, comme les polices d'icônes (par exemple `+icon:fire[]+`) et des éléments d'interface (par exemple `+button:[Enregistrer]+`).
+Asciidoctor offre aussi un thème moderne et « responsive » basé sur {uri-foundation}[Foundation] pour styliser le document HTML5 généré.
+
+== Prérequis
+
+Asciidoctor fonctionne sur Linux, macOS et Windows et requiert une des implémentations suivantes de {uri-ruby}[Ruby] :
+
+* Ruby (MRI/CRuby 1.8.7 - 2.5)
+* JRuby (1.7 dans les modes Ruby 1.8 et 1.9, 9000)
+* Rubinius 2.2.x
+* Opal (JavaScript)
+
+Votre aide est appréciée pour tester Asciidoctor sur l'une de ces plateformes.
+Référez-vous au paragraphe <<Contributions>> si vous souhaitez vous impliquer dans ce projet.
+
+[CAUTION]
+====
+Si vous utilisez un environnement Windows dans une autre langue que l'anglais, vous pourriez tomber sur l'erreur `Encoding::UndefinedConversionError` lors du lancement d'Asciidoctor.
+Pour corriger ce problème, nous recommandons de changer la page de code en UTF-8 dans votre console :
+
+ chcp 65001
+
+Après ce changement, tous les maux de tête liés à l'Unicode seront derrière vous.
+Si vous utilisez un environnement de développement comme Eclipse, assurez-vous de définir l'encodage en UTF-8.
+Asciidoctor fonctionne mieux lorsque vous utilisez UTF-8 partout.
+====
+
+== Installation
+
+Asciidoctor peut être installé en utilisant la commande (a) `gem install`, (b) Bundler, (c) les gestionnaires de paquets pour les distributions Linux populaires, ou (d) Homebrew pour macOS.
+
+TIP: L'avantage d'utiliser le gestionnaire de paquets pour installer la gemme est que l'installation englobe celle des librairies Ruby et RubyGems si elles ne sont pas déjà installés.
+L'inconvénient est que le paquet n'est pas forcément mis à jour immédiatement après la mise à disposition de la gemme.
+Si vous avez besoin de la dernière version, vous devez passer par la commande `gem`.
+
+=== (a) Installation de la gemme
+
+Ouvrir un terminal et taper (en excluant le `$`) :
+
+ $ gem install asciidoctor
+
+Si vous souhaitez installer une version pre-release (c'est-à-dire, une « release candidate »), utilisez :
+
+ $ gem install asciidoctor --pre
+
+.Mettre à jour votre installation
+[TIP]
+====
+Si vous avez une précédente version d'Asciidoctor installée, vous pouvez la mettre à jour en utilisant :
+
+ $ gem update asciidoctor
+
+Si vous installez une nouvelle version de la gemme en utilisant `gem install` au lieu de `gem update`, vous aurez plusieurs versions d'installées.
+Si c'est le cas, utilisez la commande gem suivante pour supprimer la vieille version :
+
+ $ gem cleanup asciidoctor
+====
+
+=== (b) Bundler
+
+. Créez un fichier Gemfile à la racine de votre projet (ou du répertoire courant)
+. Ajoutez la gemme `asciidoctor` dans votre fichier Gemfile comme ci-dessous :
++
+[source,subs=attributes+]
+----
+source 'https://rubygems.org'
+gem 'asciidoctor'
+# ou spécifier la version explicitement
+# gem 'asciidoctor', '{release-version}'
+----
+
+. Sauvegardez le fichier Gemfile
+. Ouvrez un terminal et installez la gemme en utilisant :
+
+ $ bundle
+
+Pour mettre à jour la gemme, spécifiez la nouvelle version dans le fichier Gemfile et exécutez `bundle` à nouveau.
+Utiliser `bundle update` *n*'est *pas* recommandé car les autres gemmes seront également mises à jour, ce qui n'est pas forcément le résultat voulu.
+
+=== (c) Gestionnaires de paquets Linux
+
+==== DNF (Fedora 21 ou supérieure)
+
+Pour installer la gemme sur Fedora 21 ou supérieure en utilisant dnf, ouvrez un terminal et tapez :
+
+ $ sudo dnf install -y asciidoctor
+
+Pour mettre à jour la gemme, utilisez :
+
+ $ sudo dnf update -y asciidoctor
+
+TIP: Votre système peut être configuré pour mettre à jour automatiquement les paquets rpm, auquel cas aucune action de votre part ne sera nécessaire pour mettre à jour la gemme.
+
+==== apt-get (Debian, Ubuntu, ou Mint)
+
+Pour installer la gemme sur Debian, Ubuntu ou Mint, ouvrez un terminal et tapez :
+
+ $ sudo apt-get install -y asciidoctor
+
+Pour mettre à jour la gemme, utilisez :
+
+ $ sudo apt-get upgrade -y asciidoctor
+
+TIP: Votre système peut être configuré pour mettre à jour automatiquement les paquets deb, auquel cas aucune action de votre part ne sera nécessaire pour mettre à jour la gemme.
+
+La version d'Asciidoctor installé par le gestionnaire de paquets (apt-get) peut ne pas correspondre à la dernière version d'Asciidoctor.
+Consultez le dépôt de paquets de votre distribution pour trouver quelle version est disponible par version de distribution.
+
+* https://packages.debian.org/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[Paquet asciidoctor par version de Debian]
+* http://packages.ubuntu.com/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[Paquet asciidoctor par version d'Ubuntu]
+* https://community.linuxmint.com/software/view/asciidoctor[Paquet asciidoctor par version de Mint]
+
+[CAUTION]
+====
+Il est déconseillé d'utiliser la commande `gem update` pour mettre à jour la gemme gérée par le gestionnaire de paquets.
+Le faire mettrait la système dans un état incohérent car le gestionnaire de paquets ne pourrait plus gérer les fichiers (qui sont installés dans /usr/local).
+En résumé, les gemmes du système doivent être gérées seulement par le gestionnaire de paquets.
+
+Si vous souhaitez utiliser une version d'Asciidoctor qui est plus récente que celle installée par votre gestionnaire de paquets, vous devriez utiliser http://rvm.io[RVM] pour installer Ruby dans votre répertoire personnel (dans votre espace utilisateur).
+Vous pouvez alors utiliser la commande `gem` pour installer ou mettre à jour la gemme Asciidoctor.
+En utilisant RVM, les gemmes sont installées dans un emplacement isolé du système.
+====
+
+==== apk (Alpine Linux)
+
+Pour installer la gemme sur Alpine Linux, ouvrez un terminal et tapez :
+
+ $ sudo apk add asciidoctor
+
+Pour mettre à jour la gemme, utilisez :
+
+ $ sudo apk add -u asciidoctor
+
+TIP: Votre système peut être configuré pour mettre à jour automatiquement les paquets apk, auquel cas aucune action de votre part ne sera nécessaire pour mettre à jour la gemme.
+
+=== (d) Homebrew (macOS)
+
+Vous pouvez utiliser Homebrew pour installer Asciidoctor sur macOS.
+Si vous n'avez pas encore installé Homebrew, suivez les instructions sur https://brew.sh/[brew.sh].
+
+Une fois Homebrew installé, vous pouvez installer la gemme `asciidoctor` avec le paquet http://brewformulas.org/Asciidoctor[asciidoctor].
+Ouvrez un terminal et tapez :
+
+ $ brew install asciidoctor
+
+Pour mettre à jour la gemme, utilisez :
+
+ $ brew update
+ $ brew upgrade asciidoctor
+
+TIP: Homebrew installe la gemme `asciidoctor` dans un répertoire spécifique qui est indépendant des gemmes système.
+
+=== Autres options d'installation
+
+* {uri-install-docker}[Installation d'Asciidoctor avec Docker]
+* {uri-install-macos-doc}[Installation d'Asciidoctor sur macOS]
+// pour l'instant, l'entrée suivante est juste une répétition de l'information dans ce README
+//* {uri-install-doc}[Installation de l'outillage Asciidoctor]
+
+== Utilisation
+
+Si la gemme Asciidoctor s'est installée correctement, la ligne de commande (CLI) `asciidoctor` sera disponible dans votre PATH.
+Pour vérifier sa disponibilité, exécutez la commande suivante dans votre terminal :
+
+ $ asciidoctor --version
+
+Vous devriez voir les informations concernant la version d'Asciidoctor et celle de votre environnement Ruby s'afficher dans le terminal.
+
+[.output,subs=attributes+]
+....
+Asciidoctor {release-version} [http://asciidoctor.org]
+Runtime Environment (ruby 2.4.1p111 [x86_64-linux]) (lc:UTF-8 fs:UTF-8 in:- ex:UTF-8)
+....
+
+Asciidoctor fournit aussi une API.
+Cette API permet une intégration avec d'autres logiciels Ruby, comme Rails, Sinatra et GitHub, ainsi que d'autres langages comme Java (via {uri-asciidoctorj}[AsciidoctorJ]) ou JavaScript (via {uri-asciidoctorjs}[Asciidoctor.js]).
+
+=== Interface de Ligne de Commande (CLI)
+
+La commande `asciidoctor` vous permet d'invoquer Asciidoctor à partir de la ligne de commande (c'est-à-dire, un terminal).
+
+La commande suivante convertit le fichier README.adoc en HTML et sauvegarde le résultat dans le fichier README.html dans le même répertoire.
+Le nom du fichier HTML généré est tiré de celui du fichier source, l'extension a été changée pour `.html`.
+
+ $ asciidoctor README.adoc
+
+Vous pouvez contrôler le processeur Asciidoctor en ajoutant plusieurs paramètres, vous pouvez en apprendre plus sur ces derniers en utilisant la commande :
+
+ $ asciidoctor --help
+
+Par exemple, pour écrire le fichier dans un répertoire différent, utilisez :
+
+ $ asciidoctor -D output README.adoc
+
+La {uri-manpage}[page man] `asciidoctor` fournit une référence complète sur l'interface de ligne de commande.
+
+Référez-vous aux ressources suivantes pour en apprendre davantage sur la façon d'utiliser la commande `asciidoctor`.
+
+* {uri-render-doc}[Comment convertir un document ?]
+* {uri-themes-doc}[Comment utiliser la fabrique de feuilles de style Asciidoctor pour produire des thèmes personnalisés ?]
+
+=== API Ruby
+
+Pour utiliser Asciidoctor dans votre application, vous avez tout d'abord besoin de faire un « require » sur la gemme :
+
+[source]
+require 'asciidoctor'
+
+Vous pouvez ensuite convertir un fichier AsciiDoc en fichier HTML en utilisant :
+
+[source]
+Asciidoctor.convert_file 'README.adoc', to_file: true, safe: :safe
+
+WARNING: Quand vous utilisez Asciidoctor via l'API, le mode de sûreté par défaut est `:secure`.
+Dans le mode « secure », plusieurs fonctionnalités centrales sont désactivées, comme la directive `include`.
+Si vous souhaitez activer ces fonctionnalités, vous aurez besoin de définir explicitement le mode de sûreté avec une la valeur `:server` (recommandée) ou `:safe`.
+
+Vous pouvez aussi convertir une chaîne de texte en fragment HTML (pour une insertion dans une page HTML) en utilisant :
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+Asciidoctor.convert content, safe: :safe
+----
+
+Si vous voulez le document HTML complet, activez l'option `header_footer` comme ci-dessous :
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+html = Asciidoctor.convert content, header_footer: true, safe: :safe
+----
+
+Si vous avez besoin d'accéder au document analysé, vous pouvez séparer la conversion en deux étapes distinctes :
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+document = Asciidoctor.load content, header_footer: true, safe: :safe
+puts document.doctitle
+html = document.convert
+----
+
+Gardez en tête que si vous n'aimez pas le contenu généré par Asciidoctor, _vous pouvez le changer !_
+Asciidoctor supporte des convertisseurs personnalisés qui peuvent prendre en charge la conversion depuis le document analysé jusqu'au contenu généré.
+
+Une façon simple de personnaliser les morceaux de contenu générés est d'utiliser le convertisseur de template.
+Le convertisseur de template vous permet, en utilisant un template supporté par {uri-tilt}[Tilt], de prendre en charge la conversion de n'importe quel élément dans le document.
+
+Vous l'aurez compris, vous _pouvez_ complètement prendre le contrôle sur le contenu généré.
+Pour plus d'informations sur comment utiliser l'API ou personnaliser le contenu généré, référez-vous au {uri-user-manual}[manuel utilisateur].
+
+== Contributions
+
+Dans l'esprit du {uri-freesoftware}[logiciel libre], _tout le monde_ est encouragé à aider en vue d'améliorer le projet.
+Si vous découvrez des erreurs ou des oublis dans le code source, la documentation, ou le contenu du site web, s'il vous plaît n'hésitez pas à ouvrir un ticket ou une « pull request » avec un correctif.
+Les contributeurs et contributrices sont toujours les bienvenus !
+
+Voici quelques façons de contribuer :
+
+* en utilisant les versions prerelease (alpha, beta ou preview),
+* en rapportant des anomalies,
+* en suggérant de nouvelles fonctionnalités,
+* en écrivant ou éditant la documentation,
+* en écrivant des spécifications,
+* en écrivant du code -- _Aucun patch n'est trop petit_
+** corriger une coquille,
+** ajouter des commentaires,
+** nettoyer des espaces inutiles,
+** écrire des tests !
+* en refactorant le code,
+* en corrigeant des {uri-issues}[anomalies],
+* en effectuant des relectures des patches.
+
+Le guide du {uri-contribute}[parfait Contributeur] fournit des informations sur comment créer, styliser et soumettre des tickets, des demandes de fonctionnalités, du code et de la documentation pour le projet Asciidoctor.
+
+== Être aidé
+
+Le projet Asciidoctor est développé pour vous aider à écrire et publier du contenu.
+Mais nous ne pouvons pas le faire sans avoir vos avis !
+Nous vous encourageons à poser vos questions et discuter de n'importe quels aspects du projet sur la liste de discussion, Twitter ou dans le salon de discussion.
+
+Mailing list:: {uri-discuss}
+Twitter:: hashtag https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] ou la mention https://twitter.com/asciidoctor[@asciidoctor]
+Gitter (Chat):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+////
+IRC (Chat):: {uri-irc}[#asciidoctor] sur FreeNode IRC
+////
+
+ifdef::env-github[]
+De plus amples informations et documentations sur Asciidoctor peuvent être trouvées sur le site web du projet.
+
+{uri-project}/[Home] | {uri-news}[News] | {uri-docs}[Docs]
+endif::[]
+
+L'organisation Asciidoctor sur GitHub héberge le code source du projet, le gestionnaire de tickets ainsi que des sous-projets.
+
+Dépôt des sources (git):: {uri-repo}
+Gestionnaire de tickets:: {uri-issues}
+L'organisation Asciidoctor sur GitHub:: {uri-org}
+
+== Copyright et licence
+
+Copyright (C) 2012-2018 Dan Allen, Ryan Waldron et le projet Asciidoctor.
+Une utilisation libre de ce logiciel est autorisée sous les termes de la licence MIT.
+
+Consultez le fichier {uri-license}[LICENSE] pour plus de détails.
+
+== Auteurs
+
+*Asciidoctor* est mené par https://github.com/mojavelinux[Dan Allen] et https://github.com/graphitefriction[Sarah White] et reçoit de nombreuses contributions de la part de la {uri-contributors}[géniale communauté] Asciidoctor.
+Le projet a été initié en 2012 par https://github.com/erebor[Ryan Waldron] et est basé sur {uri-prototype}[un prototype] écrit par https://github.com/nickh[Nick Hengeveld].
+
+*AsciiDoc* a été démarré par Stuart Rackham et a reçu de nombreuses contributions de la part de la communauté AsciiDoc.
+
+ifndef::env-site[]
+== Changelog
+
+ifeval::[{safe-mode-level} < 20]
+include::CHANGELOG.adoc[tag=compact,leveloffset=+1]
+endif::[]
+
+Référez-vous au fichier {uri-changelog}[CHANGELOG] pour une liste complète des changements des versions précédentes.
+endif::[]
diff -pruN 1.5.6.2-2/README-jp.adoc 1.5.7-1/README-jp.adoc
--- 1.5.6.2-2/README-jp.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/README-jp.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,418 @@
+= Asciidoctor
+Dan Allen <https://github.com/mojavelinux[@mojavelinux]>; Sarah White <https://github.com/graphitefriction[@graphitefriction]>; Ryan Waldron <https://github.com/erebor[@erebor]>
+v1.5.7, 2018-05-02
+// settings:
+:page-layout: base
+:idprefix:
+:idseparator: -
+:source-language: ruby
+:language: {source-language}
+ifndef::env-github[:icons: font]
+ifdef::env-github[]
+:status:
+:outfilesuffix: .adoc
+:caution-caption: :fire:
+:important-caption: :exclamation:
+:note-caption: :paperclip:
+:tip-caption: :bulb:
+:warning-caption: :warning:
+endif::[]
+// Variables:
+:release-version: 1.5.7
+// URIs:
+:uri-org: https://github.com/asciidoctor
+:uri-repo: {uri-org}/asciidoctor
+:uri-asciidoctorj: {uri-org}/asciidoctorj
+:uri-asciidoctorjs: {uri-org}/asciidoctor.js
+:uri-project: http://asciidoctor.org
+ifdef::env-site[:uri-project: link:]
+:uri-docs: {uri-project}/docs
+:uri-news: {uri-project}/news
+:uri-manpage: {uri-project}/man/asciidoctor
+:uri-issues: {uri-repo}/issues
+:uri-contributors: {uri-repo}/graphs/contributors
+:uri-rel-file-base: link:
+:uri-rel-tree-base: link:
+ifdef::env-site[]
+:uri-rel-file-base: {uri-repo}/blob/master/
+:uri-rel-tree-base: {uri-repo}/tree/master/
+endif::[]
+:uri-changelog: {uri-rel-file-base}CHANGELOG.adoc
+:uri-contribute: {uri-rel-file-base}CONTRIBUTING.adoc
+:uri-license: {uri-rel-file-base}LICENSE
+:uri-tests: {uri-rel-tree-base}test
+:uri-discuss: http://discuss.asciidoctor.org
+:uri-irc: irc://irc.freenode.org/#asciidoctor
+:uri-rubygem: https://rubygems.org/gems/asciidoctor
+:uri-what-is-asciidoc: {uri-docs}/what-is-asciidoc
+:uri-user-manual: {uri-docs}/user-manual
+:uri-install-docker: https://github.com/asciidoctor/docker-asciidoctor
+//:uri-install-doc: {uri-docs}/install-toolchain
+:uri-install-osx-doc: {uri-docs}/install-asciidoctor-macosx
+:uri-render-doc: {uri-docs}/render-documents
+:uri-themes-doc: {uri-docs}/produce-custom-themes-using-asciidoctor-stylesheet-factory
+:uri-gitscm-repo: https://github.com/git/git-scm.com
+:uri-prototype: {uri-gitscm-repo}/commits/master/lib/asciidoc.rb
+:uri-freesoftware: https://www.gnu.org/philosophy/free-sw.html
+:uri-foundation: http://foundation.zurb.com
+:uri-tilt: https://github.com/rtomayko/tilt
+:uri-ruby: https://ruby-lang.org
+// images:
+:image-uri-screenshot: https://raw.githubusercontent.com/asciidoctor/asciidoctor/master/screenshot.png
+
+{uri-project}/[Asciidoctor]は _高速な_ テキストプロセッサで {uri-what-is-asciidoc}[AsciiDoc] をHTML5, DocBook 5(4.5)や他のフォーマットに変換するツールチェインを配布しています.
+AsciidoctorはRubyで書かれており, RubyGemとしてパッケージされ,  {uri-rubygem}[RubyGems.org] で配布されています.
+gemはいくつかのLinuxディストリビューション, Fedora, Debian, Ubuntuにも含まれています.
+Asciidoctorはオープンソース {uri-repo}[hosted on Github] で {uri-license}[the MIT licence]のもとに配布されます.
+
+ifndef::env-site[]
+Translations of this document are available in the following languages:
+
+* {uri-rel-file-base}README-zh_CN.adoc[汉语]
+* {uri-rel-file-base}README.adoc[English]
+* {uri-rel-file-base}README-fr.adoc[Français]
+endif::[]
+
+.Key documentation
+[.compact]
+* {uri-docs}/what-is-asciidoc[What is AsciiDoc?]
+* {uri-docs}/asciidoc-writers-guide[AsciiDoc Writer's Guide]
+* {uri-docs}/asciidoc-syntax-quick-reference[AsciiDoc Syntax Reference]
+* {uri-docs}/user-manual[Asciidoctor User Manual]
+
+.Rubyの行く先, Asciidoctorの追うところ
+****
+AsciidoctorはJRubyを用いてJVM上でも実行できます.
+Javaや他のJVM言語からAsciidoctor APIを直接呼び出すには,  {uri-asciidoctorj}[AsciidoctorJ] を使ってください.
+AsciidoctorJに基づいた, AsciidoctorプロセッサをApache Maven, GradleやJavadocに統合するプラグインがあります.
+
+AsciidoctorはJavaScriptでも実行可能です.
+{uri-asciidoctorjs}[Asciidoctor.js], WebブラウザやNode.jsのようなJavaScript環境で動くAsciidoctorの完全機能版, を生成するために, RubyのソースをJavaScriptにトランスパイルするのに http://opalrb.org[Opal]を使います.
+Asciidoctor.jsはChrome, Atom, Brackets や他のウェブベースのツールの拡張機能としてAsciiDocのプレビューのために使われます.
+****
+
+ifdef::status[]
+.*Project health*
+image:https://img.shields.io/travis/asciidoctor/asciidoctor/master.svg[Build Status (Travis CI), link=https://travis-ci.org/asciidoctor/asciidoctor]
+image:https://ci.appveyor.com/api/projects/status/ifplu67oxvgn6ceq/branch/master?svg=true&amp;passingText=green%20bar&amp;failingText=%23fail&amp;pendingText=building%2E%2E%2E[Build Status (AppVeyor), link=https://ci.appveyor.com/project/asciidoctor/asciidoctor]
+//image:https://img.shields.io/coveralls/asciidoctor/asciidoctor/master.svg[Coverage Status, link=https://coveralls.io/r/asciidoctor/asciidoctor]
+image:https://codeclimate.com/github/asciidoctor/asciidoctor/badges/gpa.svg[Code Climate, link="https://codeclimate.com/github/asciidoctor/asciidoctor"]
+image:https://inch-ci.org/github/asciidoctor/asciidoctor.svg?branch=master[Inline docs, link="https://inch-ci.org/github/asciidoctor/asciidoctor"]
+endif::[]
+
+== The Big Picture
+
+Asciidoctorは下図の左側のパネルに示されるように, 平文で書かれた内容を読み, 右のパネルに描かれるようにHTML5に変換します.
+Asciidoctorは枠にとらわれない快適なエクスペリエンスのためにデフォルトスタイルシートをHTML5ドキュメントに適用します.
+
+image::{image-uri-screenshot}[Preview of AsciiDoc source and corresponding rendered HTML]
+
+== AsciiDoc Processing
+AsciidoctorはAsciiDoc文法で書かれたテキストを読み込み解釈し, それからHTML5, DocBook5(4.5)やman(ual)を出力するために内蔵コンバータセットにパースツリーを渡します.
+生成された出力をカスタマイズ, あるいは追加のフォーマットをつくるためにあなた自身のコンバータを使うことや {uri-tilt}[Tilt]-supported テンプレートを読み込むオプションがあります.
+
+NOTE: AsciidoctorはオリジナルのAsciiDoc Pythonプロセッサ(`asciidoc.py`)の完全互換です.
+Asciidoctorテストスイートは {uri-tests}[> 1,600 tests] をAsciiDoc文法との互換性を保証するために有しています.
+
+クラシックなAsciiDoc文法に加えて, Asciidoctorは追加のマークアップとフォントベースのicons(例えば, `+icon:fire[]+`)などのフォーマッティングオプションとUIエレメント(`+button:[Save]+`)を  受け付けます.
+AsciidoctorはHTML5出力をスタイルするため, モダンで,  {uri-foundation}[Foundation] に基づいたレスポンシブテーマをも提供します.
+
+== Requirements
+
+AsciidoctorはLinux, OS X (Mac)とWindowsで動き, 下記の {uri-ruby}[Ruby]実装の一つを必要とします.
+
+* MRI (Ruby 1.8.7, 1.9.3, 2.0, 2.1, 2.2 & 2.3)
+* JRuby (1.7 in Ruby 1.8 and 1.9 modes, 9000)
+* Rubinius 2.2.x
+* Opal (JavaScript)
+
+[CAUTION]
+====
+もし非英語環境のWindowsを使っているなら, Asciidoctorを起動した時に `Encoding::UndefinedConversionError` に遭遇するでしょう.
+これを解決するには使っているコンソールの有効なコードページをUTF-8:
+
+ chcp 65001
+
+に変更することを推奨します.
+一度この変更をすると, Unicode関連の頭痛の種は消えるでしょう.
+もしEclipseのようなIDEを使っているなら, 同様にエンコーディングをUTF-8にするのを忘れないでください.
+AsciidoctorはUTF-8が使われているところで最高の働きを見せます.
+====
+
+== Installation
+
+Asciidoctorは (a) `gem install` コマンド,  (b) Bundler あるいは (c) 有名Linuxディストリビューションのパッケージマネージャ を用いてインストールされます.
+
+TIP: Linuxパッケージマネージャを用いてインストールすることの利点は, もしRubyやRubyGemsライブラリがまだインストールされていなかったら, それらを処理してくれることです.
+欠点はgemのリリース直後にはすぐには有効にならないことです.
+もし最新バージョンを使いたければ, 必ず `gem` コマンドを使いましょう.
+
+=== (a) gem install
+
+ターミナルを開き, 入力しましょう (先頭の`$`は除く):
+
+ $ gem install asciidoctor
+
+もし, 先行リリースバージョン(例えばリリース候補版)をインストールしたければ
+
+ $ gem install asciidoctor --pre
+
+.アップグレード
+[TIP]
+====
+もしAsciidoctorの以前のバージョンがインストール済みであれば, 以下によってアップデートできます:
+
+ $ gem update asciidoctor
+
+もし gem update の代わりに `gem install` を使ってgemを新バージョンにした場合, 複数バージョンがインストールされるでしょう.
+そのときは, 以下のgemコマンドで古いバージョンを削除しましょう:
+
+ $ gem cleanup asciidoctor
+====
+
+=== (b) Bundler
+
+. プロジェクトフォルダーのルート(かカレントディレクトリ)にGemfileを作成
+. `asciidoctor` gemをGemfileに以下のように追加:
++
+[source,subs=attributes+]
+----
+source 'https://rubygems.org'
+gem 'asciidoctor'
+# or specify the version explicitly
+# gem 'asciidoctor', '{release-version}'
+----
+
+. Gemfileを保存
+. ターミナルを開き, gemをインストール:
+
+ $ bundle
+
+gemをアップグレードするには, Gemfileで新バージョンを指定し, `bundle` を再び実行してください.
+`bundle update` は他のgemもアップデートするため推奨されて *いない* ので, 思わぬ結果になるかも知れません.
+
+=== (c) Linux package managers
+
+==== DNF (Fedora 21 or greater)
+
+dnfを使いFedora21かそれ以上にインストールするには, ターミナルを開き, 以下を入力してください:
+
+ $ sudo dnf install -y asciidoctor
+
+gemをアップグレードするには:
+
+ $ sudo dnf update -y asciidoctor
+
+TIP: お使いのシステムは自動的にrpmパッケージをアップデートするよう設定されているかも知れません.その場合, gemのアップデートのためにあなたがすべきことはありません.
+
+==== apt-get (Debian, Ubuntu, Mint)
+
+Debian, UbuntuまたはMintにインストールするには, ターミナルを開き, 以下を入力してください:
+
+ $ sudo apt-get install -y asciidoctor
+
+gemをアップグレードするには:
+
+ $ sudo apt-get upgrade -y asciidoctor
+
+TIP: お使いのシステムは自動的にdebパッケージをアップデートするよう設定されているかも知れません.その場合, gemのアップデートのためにあなたがすべきことはありません.
+
+パッケージマネージャ(apt-get)によってインストールされたバージョンのAsciidoctorは最新リリースのAsciidoctorではないかもしれません.
+ディストリビューションのリリース毎に, どのバージョンがパッケージされているかはパッケージリポジトリを調べてください.
+
+* https://packages.debian.org/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Debian release]
+* http://packages.ubuntu.com/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[asciidoctor package by Ubuntu release]
+* https://community.linuxmint.com/software/view/asciidoctor[asciidoctor package by Mint release]
+
+[CAUTION]
+====
+パッケージマネージャによって管理されているgemをアップデートするのに `gem udpate` コマンドを使うなといわれるでしょう.
+そのようなことをするのは, パッケージマネージャがファイル(/usr/local下にインストールされた)を追跡できなくなるためにシステムが不安定な状態にするためです.
+単純に, システムgemはパッケージマネージャによってのみ管理されるべきです.
+
+もし, パッケージマネージャによってインストールされたのより新しいバージョンのAsciidoctorを使いたければ,  http://rvm.io[RVM] や https://github.com/rbenv/rbenv[rbenv]を使ってRubyをホームディレクトリ(すなわち, ユーザースペース)にインストールするべきです.
+それから, 安心して `gem` コマンドをAsciidoctorのアップデート, インストールのために使うことができます.
+RVMやrbenvを使っているなら, gemはシステムからは孤立した場所にインストールされます.
+====
+
+==== apk (Alpine Linux)
+
+Alpine Linuxにgemをインストールするには, ターミナルを開き, 以下を入力してください:
+
+ $ sudo apk add asciidoctor
+
+gemをアップグレードするには:
+
+ $ sudo apk add -u asciidoctor
+
+TIP: お使いのシステムは自動的にapkパッケージをアップデートするよう設定されているかも知れません.その場合, gemのアップデートのためにあなたがすべきことはありません.
+
+=== Other installation options
+
+* {uri-install-docker}[Installing Asciidoctor using Docker]
+* {uri-install-osx-doc}[Installing Asciidoctor on Mac OS X]
+// at the moment, the following entry is just a reiteration of the information in this README
+//* {uri-install-doc}[Installing the Asciidoctor toolchain]
+
+== Usage
+
+Asciidoctorのインストールに成功すれば,  `asciidoctor` コマンドラインインターフェース(CLI)がPATH中で有効になります.
+確認のために, 以下をターミナルで実行しましょう:
+
+ $ asciidoctor --version
+
+AsciidoctorのバージョンとRuby環境についての情報がターミナルに出力されたのを見ることができるはずです.
+
+[.output,subs=attributes+]
+....
+Asciidoctor {release-version} [http://asciidoctor.org]
+Runtime Environment (ruby 2.4.1p111 [x86_64-linux]) (lc:UTF-8 fs:UTF-8 in:- ex:UTF-8)
+....
+
+AsciidoctorはAPIを提供します.
+APIは他のRubyソフトウェア, Rails, SinatraとGitHub, そして他の言語, Java (via {uri-asciidoctorj}[AsciidoctorJ] )とJavaScript (via {uri-asciidoctorjs}[Asciidoctor.js])との統合を意図しています.
+
+=== Command line interface (CLI)
+
+`asciidoctor` コマンドはAsciidoctorをコマンドライン(つまりターミナル)から起動することを可能にします.
+
+次のコマンドはファイルREADME.adocをHTMLに変換し, 結果を同じディレクトリのREADME.htmlに保存します.
+生成されたHTMLファイルの名前はソースファイル依存し, その拡張子を `.html` に変えます.
+
+ $ asciidoctor README.adoc
+
+Asciidoctorプロセッサに様々なフラグやスイッチを与えることで制御できます.それは以下を用いて調べることができます:
+
+ $ asciidoctor --help
+
+例えば, ファイルを異なるディレクトリに書き出すには:
+
+ $ asciidoctor -D output README.adoc
+
+`asciidoctor` {uri-manpage}[man page] はコマンドライン・インタフェースの完全なリファレンスを提供します.
+
+`asciidoctor` コマンドの使い方についてもっと学ぶには以下を参照してください.
+
+* {uri-render-doc}[How do I convert a document?]
+* {uri-themes-doc}[How do I use the Asciidoctor stylesheet factory to produce custom themes?]
+
+=== Ruby API
+
+Asciidoctorをアプリケーションの中で使うには, まずgemをrequireする必要があります:
+
+[source]
+require 'asciidoctor'
+
+それから, AsciiDocソースファイルをHTMLファイルに変換できます:
+
+[source]
+Asciidoctor.convert_file 'README.adoc', to_file: true, safe: :safe
+
+WARNING: AsciidoctorをAPI経由で使っている時, デフォルトのセーフモードは `:secure` です.
+セキュアモードでは,  `include` ディレクティブを含むいくつかのコア機能は無効化されています.
+もしこれらの機能を有効化したい場合, 明示的にセーフモードを `:server` (推奨)か `:safe` にする必要があります.
+
+AsciiDoc文字列を埋め込みHTML(HTMLページヘの挿入)へ変換することもできます:
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+Asciidoctor.convert content, safe: :safe
+----
+
+もし完全なHTMLドキュメントを求めるのであれば,  `header_footer` オプションを以下の通り有効にしてください:
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+html = Asciidoctor.convert content, header_footer: true, safe: :safe
+----
+
+パースされたドキュメントにアクセスしたいのなら, 変換を個々のステップに分割することが出来ます:
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+document = Asciidoctor.load content, header_footer: true, safe: :safe
+puts document.doctitle
+html = document.convert
+----
+
+Asciidoctorの生成する出力が気に入らないのであれば,  _あなたはそれを変更できる_ ことを忘れないでください!
+Asciidoctorはパースされたドキュメントを生成された出力に変換する処理を扱うカスタムコンバーターをサポートしています.
+
+断片的な出力をカスタマイズする簡単な方法の一つはテンプレートコンバーターを使うことです.
+テンプレートコンバーターによって, ドキュメント中のあらゆるノードの変換を扱うために {uri-tilt}[Tilt]-supportedテンプレートファイルを使うことができます.
+
+そのようにすれば, 出力を100%制御することが _できます_ .
+APIの使い方や出力のカスタマイズ方法についてのより詳しい情報は {uri-user-manual}[user manual] を参照してください.
+
+== Contributing
+
+{uri-freesoftware}[free software] の精神においては,  _everyone_ がこのプロジェクトを改良するのをたすけることが勧められています.
+もしエラーや手抜かりをソースコード, ドキュメント, あるいはウェブサイトに見つけたのなら, 恥じることなく修正と共にpull requestの開設やissueの送信をしてください.
+New contributors are always welcome!
+
+*あなた*  にもできることがあります:
+
+* 先行バージョン(alpha, beta or preview)の使用
+* バグレポート
+* 新機能提案
+* ドキュメントの執筆
+* 仕様の執筆
+* コーディング -- _パッチでも, 足りなすぎるなんてことはありません_
+** typoの修正
+** コメントの追加
+** 一貫性のないホワイトスペースの除去
+** テストの記述!
+* リファクタリング
+*  {uri-issues}[issues] の修正
+* パッチの批評
+
+{uri-contribute}[Contributing] ガイドはどうやってスタイルをつくるか, issueを送るか, 機能リクエスト, コーディング, ドキュメンテーションをAsciidoctor Projectにするかについての情報を提供しています.
+
+== Getting Help
+
+Asciidoctorプロジェクトはあなたが簡単に著作を書いて, 配布するのをたすけるため開発されています.
+しかしあなたのフィードバックなしにはできません!
+ディスカッションリストで, Twitterで, チャットルームで, 質問し, プロジェクトのあらゆる側面について話し合うようお勧めします.
+
+Discussion list (Nabble):: {uri-discuss}
+Twitter:: #asciidoctor hashtag or @asciidoctor mention
+Chat (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+
+ifdef::env-github[]
+以下のプロジェクトサイトに、Asciidoctorに関するさらに詳しい情報やドキュメントがあります。
+
+{uri-project}/[Home] | {uri-news}[News] | {uri-docs}[Docs]
+endif::[]
+
+GitHub上のAsciidoctorはプロジェクトのソースコード, イシュートラッカー, サブプロジェクトを管理しています.
+
+Source repository (git):: {uri-repo}
+Issue tracker:: {uri-issues}
+Asciidoctor organization on GitHub:: {uri-org}
+
+== Copyright and Licensing
+
+Copyright (C) 2012-2018 Dan Allen, Ryan Waldron and the Asciidoctor Project.
+本ソフトウェアはMITライセンスのもとで自由に使用できます.
+
+詳細は {uri-license}[LICENSE] ファイルを参照してください.
+
+== Authors
+
+*Asciidoctor* は https://github.com/mojavelinux[Dan Allen] と https://github.com/graphitefriction[Sarah White] が先導し, Asciidoctorの素晴らしきコミュニティの数多くのメンバからコントリビューションを受けてきました．
+このプロジェクトは2012年から https://github.com/nickh[Nick Hengeveld] の {uri-prototype}[プロトタイプ] をベースに https://github.com/erebor[Ryan Waldron] により創始されました.
+
+*AsciiDoc* は Stuart Rackham により創始され, AsciiDocコミュニティの数多くのメンバからコントリビューションを受けてきました.
+
+ifndef::env-site[]
+== Changelog
+
+ifeval::[{safe-mode-level} < 20]
+include::CHANGELOG.adoc[tag=compact,leveloffset=+1]
+endif::[]
+
+リリースごとの変更一覧は {uri-changelog}[CHANGELOG] を参照してください.
+endif::[]
diff -pruN 1.5.6.2-2/README-zh_CN.adoc 1.5.7-1/README-zh_CN.adoc
--- 1.5.6.2-2/README-zh_CN.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/README-zh_CN.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,430 @@
+= Asciidoctor
+Dan Allen <https://github.com/mojavelinux[@mojavelinux]>; Sarah White <https://github.com/graphitefriction[@graphitefriction]>; Ryan Waldron <https://github.com/erebor[@erebor]>
+v1.5.7, 2018-05-02
+// settings:
+:page-layout: base
+:idprefix:
+:idseparator: -
+:source-language: ruby
+:language: {source-language}
+ifndef::env-github[:icons: font]
+ifdef::env-github[]
+:status:
+:outfilesuffix: .adoc
+:caution-caption: :fire:
+:important-caption: :exclamation:
+:note-caption: :paperclip:
+:tip-caption: :bulb:
+:warning-caption: :warning:
+endif::[]
+// Variables:
+:release-version: 1.5.7
+// URIs:
+:uri-org: https://github.com/asciidoctor
+:uri-repo: {uri-org}/asciidoctor
+:uri-asciidoctorj: {uri-org}/asciidoctorj
+:uri-asciidoctorjs: {uri-org}/asciidoctor.js
+:uri-project: http://asciidoctor.org
+ifdef::env-site[:uri-project: link:]
+:uri-docs: {uri-project}/docs
+:uri-news: {uri-project}/news
+:uri-manpage: {uri-project}/man/asciidoctor
+:uri-issues: {uri-repo}/issues
+:uri-contributors: {uri-repo}/graphs/contributors
+:uri-rel-file-base: link:
+:uri-rel-tree-base: link:
+ifdef::env-site[]
+:uri-rel-file-base: {uri-repo}/blob/master/
+:uri-rel-tree-base: {uri-repo}/tree/master/
+endif::[]
+:uri-changelog: {uri-rel-file-base}CHANGELOG.adoc
+:uri-contribute: {uri-rel-file-base}CONTRIBUTING.adoc
+:uri-license: {uri-rel-file-base}LICENSE
+:uri-tests: {uri-rel-tree-base}test
+:uri-discuss: http://discuss.asciidoctor.org
+:uri-irc: irc://irc.freenode.org/#asciidoctor
+:uri-rubygem: https://rubygems.org/gems/asciidoctor
+:uri-what-is-asciidoc: {uri-docs}/what-is-asciidoc
+:uri-user-manual: {uri-docs}/user-manual
+:uri-install-docker: https://github.com/asciidoctor/docker-asciidoctor
+//:uri-install-doc: {uri-docs}/install-toolchain
+:uri-install-osx-doc: {uri-docs}/install-asciidoctor-macosx
+:uri-render-doc: {uri-docs}/render-documents
+:uri-themes-doc: {uri-docs}/produce-custom-themes-using-asciidoctor-stylesheet-factory
+:uri-gitscm-repo: https://github.com/git/git-scm.com
+:uri-prototype: {uri-gitscm-repo}/commits/master/lib/asciidoc.rb
+:uri-freesoftware: https://www.gnu.org/philosophy/free-sw.html
+:uri-foundation: http://foundation.zurb.com
+:uri-tilt: https://github.com/rtomayko/tilt
+:uri-ruby: https://ruby-lang.org
+// images:
+:image-uri-screenshot: https://raw.githubusercontent.com/asciidoctor/asciidoctor/master/screenshot.png
+
+{uri-project}/[Asciidoctor] 是一个 _快速_ 文本处理器和发布工具链，它可以将 {uri-what-is-asciidoc}[AsciiDoc] 文档转化成 HTML5、 DocBook 5 (或 4.5) 以及其他格式。
+Asciidoctor 由 Ruby 编写，打包成 RubyGem，然后发布到 {uri-rubygem}[RubyGems.org] 上。
+这个 gem 还被包含道几个 Linux 发行版中，其中包括 Fedora、Debian 和 Ubuntu。
+Asciidoctor 是开源的，{uri-repo}[代码]托管在 GitHub，遵从 {uri-license}[MIT] 协议。
+
+该文档有如下语言的翻译版：
+
+* {uri-rel-file-base}README.adoc[English]
+* {uri-rel-file-base}README-fr.adoc[Français]
+* {uri-rel-file-base}README-jp.adoc[日本語]
+
+.关键文档
+[.compact]
+* {uri-docs}/what-is-asciidoc[Asciidoctor 是什么？]
+* {uri-docs}/asciidoc-writers-guide[AsciiDoc 写作指南]
+* {uri-docs}/asciidoc-syntax-quick-reference[AsciiDoc 语法快速参考]
+* {uri-docs}/user-manual[Asciidoctor 用户手册]
+
+.Ruby 所至， Asciidoctor 相随
+****
+使用 JRuby 让 Asciidoctor 运行在 Java 虚拟机上。
+使用 {uri-asciidoctorj}[AsciidoctorJ] 直接调用 Asciidoctor 的 API 运行在 Java 或者其他 Java 虚拟机中。
+基于 AsciidoctorJ 有好多插件可用，这些插件可以将 Asciidoctor 整合到 Apache Maven，Gradle 或 Javadoc 构建中。
+
+Asciidoctor 也可以运行在 JavaScript 上。
+我们可以使用 http://opalrb.org[Opal] 将 Ruby 源码编译成 JavaScript 生成 {uri-asciidoctorjs}[Asciidoctor.js] 文件，这是一个全功能版的 Asciidoctor，可以运行在任意的 JavaScript 环境中，比如 Web 浏览器 或 Node.js。
+Asciidoctor.js 被用于预览 AsciiDoc，支持 Chrome 扩展，Atom，Brackets 或其他基于 Web 的工具。
+****
+
+ifdef::status[]
+.*Project health*
+image:https://img.shields.io/travis/asciidoctor/asciidoctor/master.svg[Build Status (Travis CI), link=https://travis-ci.org/asciidoctor/asciidoctor]
+image:https://ci.appveyor.com/api/projects/status/ifplu67oxvgn6ceq/branch/master?svg=true&amp;passingText=green%20bar&amp;failingText=%23fail&amp;pendingText=building%2E%2E%2E[Build Status (AppVeyor), link=https://ci.appveyor.com/project/asciidoctor/asciidoctor]
+//image:https://img.shields.io/coveralls/asciidoctor/asciidoctor/master.svg[Coverage Status, link=https://coveralls.io/r/asciidoctor/asciidoctor]
+//image:https://codeclimate.com/github/asciidoctor/asciidoctor/badges/gpa.svg[Code Climate, link="https://codeclimate.com/github/asciidoctor/asciidoctor"]
+image:https://inch-ci.org/github/asciidoctor/asciidoctor.svg?branch=master[Inline docs, link="https://inch-ci.org/github/asciidoctor/asciidoctor"]
+endif::[]
+
+[#the-big-picture]
+== 整体概况
+
+Asciidoctor 以纯文本格式读取内容，见下图左边的面板，并将它转换成 HTML5 呈现在右侧面板中。
+Asciidoctor 将默认的样式表应用到 HTML5 文档上，提供一个愉快的开箱即用的体验。
+
+image::{image-uri-screenshot}[AsciiDoc 源文预览和相应的 HTML 渲染]
+
+[#asciidoc-processing]
+== AsciiDoc Processing
+
+Asciidoctor 会读取并处理用 AsciiDoc 语法写的文件，然后将解析出来的解析树参数交给内置的转化器去生成 HTML5，DocBook 5 (或 4.5) 或帮助手册页面输出。
+你可以选择使用你自己的转化器或者加载 {uri-tilt}[Tilt] - 支持通过模板来自定义输出或产生附加的格式。
+
+NOTE: Asciidoctor是为了直接替换原 AsciiDoc Python 处理器（`asciidoc.py`）。
+Asciidoctor 测试套件含有 {uri-tests}[> 1,600 测试示例] 来确保和 AsciiDoc 语法的兼容性。
+
+除了传统的 AsciiDoc 语法，Asciidoctor 还添加额外的标记和格式设置选项，例如 font-based 图标（例如： `+icon:fire[]+`）和 UI 元素（例如： `+button:[Save]+`）。
+Asciidoctor 还提供了一个基于 {uri-foundation}[Foundation] 的现代化的、响应式主题来美化 HTML5 输出。
+
+[#requirements]
+== 要求
+
+Asciidoctor 可以运行在 Linux，OSX (Mac) 和 Windows 系统，但需要安装下面任意一个 {uri-ruby}[Ruby] 环境去实现：
+
+* MRI (Ruby 1.8.7, 1.9.3, 2.0, 2.1, 2.2 & 2.3)
+* JRuby (1.7 in Ruby 1.8 and 1.9 modes, 9000)
+* Rubinius 2.2.x
+* Opal (JavaScript)
+
+我们欢迎你来帮助在这些以及其他平台测试 Asciidoctor。
+
+请参考 <<{idprefix}contributing,Contributing>> 来了解如何参与。
+
+[CAUTION]
+====
+如果在非英语的 Windows 环境，当你去调用 Asciidoctor 时，可能会碰到 `Encoding::UndefinedConversionError` 的错误提示。
+为了解决这个问题，我们建议将控制台的编码更改为 UTF-8：
+
+ chcp 65001
+
+一旦你做了这个改变，所有的编码问题，都将迎刃而解。
+如果你使用的是像 Eclipse 这样的 IDE 集成开发工具，你也需要确保他被你设置为 UTF-8 编码。
+使用 UTF-8 能使 Asciidoctor 在任何地方都能正常工作。
+====
+
+[#installation]
+== 安装
+
+Asciidoctor 可以通过三种方式安装（a）`gem install` 命令；（b）Bundler打包编译；（c）流行的 Linux 发行版的包管理器
+
+TIP: 使用 Linux 包管理器安装的好处是如果你机器在之前没有安装 Ruby 和 RubyGems 库，当你选择这种方式安装时它们会一并安装上去。
+不利的是在 gem 发布之后，这类安装包并不是立即可用。
+如果你需要安装最新版，你应该总是优先使用 `gem` 命令安装。
+
+[#a-gem-install]
+=== (a) gem 安装
+
+打开一个终端输入如下命令（不含开头的 `$`）：
+
+ $ gem install asciidoctor
+
+如果想安装一个预览版（比如：候选发布版），请使用：
+
+ $ gem install asciidoctor --pre
+
+.升级
+[TIP]
+====
+如果你安装有的是旧版本 Asciidoctor，你可以使用下面的命令来升级：
+
+ $ gem update asciidoctor
+
+如果使用 `gem install` 命令来安装一个新版本的 gem 来代替升级，会安装多个版本。
+这种情况，你可以使用下面的 gem 命令来移除旧版本：
+
+ $ gem cleanup asciidoctor
+====
+
+[#b-bundler]
+=== (b) Bundler
+
+. 在项目的根目录（或者当前路径），创建一个 `Gemfile` 文件；
+. 在这个文件中添加 `asciidoctor` gem 如下：
++
+[source,subs=attributes+]
+----
+source 'https://rubygems.org'
+gem 'asciidoctor'
+# 或者明确指明版本
+# gem 'asciidoctor', '{release-version}'
+----
+
+. 保存 `Gemfile` 文件
+. 打开终端，使用如下命令安装 gem：
+
+ $ bundle
+
+要升级 gem 的话，在 `Gemfile` 文件中，指明新版本，然后再次运行 `bundle` 即可。
+*不推荐* 直接使用 `bundle update` 命令，因为它还会升级其他 gem，也许会造成不可预料的结果。
+
+[#c-linux-package-managers]
+=== (c) Linux 包管理
+
+[#dnf-fedora-21-or-greater]
+==== DNF (Fedora 21 或更高版本)
+
+在 Fedora 21 或更高版本中安装这个 gem，可以使用 dnf。打开终端并输入如下命令：
+
+ $ sudo dnf install -y asciidoctor
+
+升级则使用：
+
+ $ sudo dnf update -y asciidoctor
+
+TIP: 如果你的 Fedora 系统配置的是自动升级包，在这种情况下，不需要你亲自动手升级。
+
+[#apt-get-debian-ubuntu-mint]
+==== apt-get (Debian, Ubuntu, Mint)
+
+在 Debian，Ubuntu 或 Mint 中安装这个 gem，请打开终端并输入如下命令：
+
+ $ sudo apt-get install -y asciidoctor
+
+升级则使用：
+
+ $ sudo apt-get upgrade -y asciidoctor
+
+TIP: 如果你的 Debian 或 Ubuntu 系统配置的是自动升级包，在这种情况下，不需要你亲自动手升级。
+
+使用包管理器（ apt-get ）安装的 Asciidoctor 的版本也许不是最新发布版。
+请查看发行版的包库，来确定每个发行版是打包的哪个版本。
+
+* https://packages.debian.org/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[Debian 发行版中的 asciidoctor]
+* http://packages.ubuntu.com/search?keywords=asciidoctor&searchon=names&exact=1&suite=all&section=all[Ubuntu 发行版中的 asciidoctor]
+* https://community.linuxmint.com/software/view/asciidoctor[Mint 发行版中的 asciidoctor]
+
+[CAUTION]
+====
+我们建议不要使用 `gem update` 来升级包管理的 gem。
+这样做会使系统进入不一致的状态，包管理工具将不再跟踪相关文件（通常安装在 /usr/local 下。）
+简单地说，系统的 gem 只能由包管理器进行管理。
+
+如果你想使用一个比包管理器安装的更新版本的 Asciidoctor，你应该使用 http://rvm.io[RVM] 在你的用户家目录（比如：用户空间）下安装 Ruby。
+然后，你就可以放心地使用 `gem` 命令来安装或者更新 Asciidoctor gem。
+当使用 RVM 时，gem 将被安装到与系统隔离的位置。
+====
+
+[#apk-alpine-linux]
+==== apk (Alpine Linux)
+
+在 Alpine Linux 中安装这个 gem，请打开终端并输入如下命令：
+
+ $ sudo apk add asciidoctor
+
+升级则使用：
+
+ $ sudo apk add -u asciidoctor
+
+TIP: 如果你的 Alpine Linux 系统配置的是自动升级包，在这种情况下，不需要你亲自动手升级。
+
+[#other-installation-options]
+=== 其他安装选项
+
+* {uri-install-docker}[使用 Docker 安装 Asciidoctor ]
+* {uri-install-osx-doc}[在 Mac OS X 安装 Asciidoctor ]
+
+[#usage]
+== 使用
+
+如果成功安装 Asciidoctor，则在可执行程序路径中，`asciidoctor` 就可用了。
+为了验证它的可用性，你可以在终端中执行如下命令：
+
+ $ asciidoctor --version
+
+你应该看到关于 Asciidoctor 和 Ruby 环境信息将打印到你的终端上。
+
+[.output,subs=attributes+]
+....
+Asciidoctor {release-version} [http://asciidoctor.org]
+Runtime Environment (ruby 2.4.1p111 [x86_64-linux]) (lc:UTF-8 fs:UTF-8 in:- ex:UTF-8)
+....
+
+Asciidoctor 还提供了一套 API。
+这套 API 是为了整合其他的 Ruby 软件，例如 Rails、Sinatra、Github，甚至其他语言，比如 Java （通过 {uri-asciidoctorj}[AsciidoctorJ]） 和 JavaScript （通过 {uri-asciidoctorjs}[Asciidoctor.js]）。
+
+[#command-line-interface-cli]
+=== 命令行（CLI）
+
+`asciidoctor` 命令可以让你通过命令行（比如：终端）来调用 Asciidoctor。
+
+下面的命令将 README.adoc 文件转化为 HTML，并且保存到同一目录下的 README.html 文件中。
+生成的 HTML 文件名源自源文件名，只是将其扩展名改为了 `.html`。
+
+ $ asciidoctor README.adoc
+
+您可以通过添加各种标志和开关控制 Asciidoctor 处理器，通过下面的命令你可以学习它的更多用法：
+
+ $ asciidoctor --help
+
+比如，将文件写入到不同路径里，使用如下命令：
+
+ $ asciidoctor -D output README.adoc
+
+`asciidoctor` {uri-manpage}[帮助页面] 提供了这个命令的完整参考。
+
+点击下面的资源，学习更多关于 `asciidoctor` 命令的用法。
+
+* {uri-render-doc}[如何转化文档？]
+* {uri-themes-doc}[如何使用 Asciidoctor 样式工厂来创建自定义主题？]
+
+[#ruby-api]
+=== Ruby API
+
+为了在你应用中使用 Asciidoctor，首先需要引入这个 gem：
+
+[source]
+require 'asciidoctor'
+
+然后，你可以通过下面的代码将 AsciiDoc 源文件转化成一个 HTML 文件：
+
+[source]
+Asciidoctor.convert_file 'README.adoc', to_file: true, safe: :safe
+
+WARNING: 当你通过 API 使用 Asciidoctor 时，默认的安全模式是 `:secure`。
+在 secure 模式下，很多核心特性将不可用，包括 `include` 特性。
+如果你想启用这些特性，你需要明确设置安全模式为 `:server` （推荐）或 `:safe`。
+
+你也可以将 AsciiDoc 字符串转化我内嵌的 HTML （为了插入到一个 HTML 页面），用法如下：
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+Asciidoctor.convert content, safe: :safe
+----
+
+如果你想得到完整的 HTML 文档，只需要启用 `header_footer` 选项即可。如下：
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+html = Asciidoctor.convert content, header_footer: true, safe: :safe
+----
+
+如果你想访问已经处理过的文档，可以将转化过程拆分成离散的几步：
+
+[source]
+----
+content = '_Zen_ in the art of writing http://asciidoctor.org[AsciiDoc].'
+document = Asciidoctor.load content, header_footer: true, safe: :safe
+puts document.doctitle
+html = document.convert
+----
+
+请注意：如果你不喜欢 Asciidoctor 输出结果，_你完全可以改变它。_
+Asciidoctor 支持自定义转化器，它可以操作从待处理文件到生成文档整个环节。
+
+一个简单的、细微地自定义输出的方式是使用模板转化器。
+模板转化器运行你提供一个 {uri-tilt}[Tilt] 模板，这样通过模板文件来操作转化出的文档的每个节点。
+
+这样，你就 _可以_ 百分之百地控制你的输出。
+关于更多关于 API 或自定义输出信息，请参考 {uri-user-manual}[用户帮助手册]。
+
+[#contributing]
+== 贡献
+
+自由软件的精神鼓励 _每个人_ 来帮助改善这个项目。
+如果你在源码、文档或网站内容中发现错误或漏洞，请不要犹豫，提交一个议题或者推送一个修复请求。
+随时欢迎新的贡献者！
+
+这里有几种 *你* 可以做出贡献的方式：
+
+* 使用预发布版本（alpha, beta 或 preview）
+* 报告 Bug
+* 提议新功能
+* 编写文档
+* 编写规范
+* 编写 -- _任何补丁都不小。_
+** 修正错别字
+** 添加评论
+** 清理多余空白
+** 编写测试！
+* 重构代码
+* 修复 {uri-issues}[issues]
+* 审查补丁
+
+{uri-contribute}[贡献指南]提供了如何提供贡献，包括如何创建、修饰和提交问题、特性、需求、代码和文档给 Asciidoctor 项目。
+
+[#getting-help]
+== 获得帮助
+
+开发 Asciidoctor 项目是未来了帮助你更容易地书写和发布你的内容。
+但是，如果没有反馈，我们将寸步难行。
+我们鼓励你在讨论组、Twitter或聊天室里，提问为题，讨论项目的方方面面，
+
+讨论组 (Nabble):: {uri-discuss}
+Twitter:: https://twitter.com/search?f=tweets&q=%23asciidoctor[#asciidoctor] 来加入话题 或 https://twitter.com/asciidoctor[@asciidoctor] at并提醒我们
+聊天 (Gitter):: image:https://badges.gitter.im/Join%20In.svg[Gitter, link=https://gitter.im/asciidoctor/asciidoctor]
+
+ifdef::env-github[]
+Further information and documentation about Asciidoctor can be found on the project's website.
+
+{uri-project}/[Home] | {uri-news}[News] | {uri-docs}[Docs]
+endif::[]
+
+Asciidoctor 组织在 Github 托管代码、议案跟踪和相关子项目。
+
+代码库 (git):: {uri-repo}
+议案跟踪:: {uri-issues}
+在 GitHub 的 Asciidoctor 组织:: {uri-org}
+
+[#copyright-and-licensing]
+== 版权和协议
+
+Copyright (C) 2012-2018 Dan Allen, Ryan Waldron and the Asciidoctor Project.
+这个软件的免费使用是在MIT许可条款授予的。
+
+请看 {uri-license}[版权声明] 文件来获取更多详细信息。
+
+[#authors]
+== 作者
+
+*Asciidoctor* 由 https://github.com/mojavelinux[Dan Allen] 和 https://github.com/graphitefriction[Sarah White] 领导，并从 Asciidoctor 社区的 {uri-contributors}[很多其他独立开发者] 上收到了很多贡献。
+项目最初由 https://github.com/erebor[Ryan Waldron] 于 2012年基于 https://github.com/nickh[Nick Hengeveld] 的 {uri-prototype}[原型] 创建。
+
+*AsciiDoc* 由 Stuart Rackham 启动，并从 AsciiDoc 社区的其他独立开发者上收到很多贡献。
+
+== Changelog
+
+请看 {uri-changelog}[CHANGELOG]。
diff -pruN 1.5.6.2-2/test/api_test.rb 1.5.7-1/test/api_test.rb
--- 1.5.6.2-2/test/api_test.rb	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/api_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,1004 @@
+# encoding: UTF-8
+unless defined? ASCIIDOCTOR_PROJECT_DIR
+  $: << File.dirname(__FILE__); $:.uniq!
+  require 'test_helper'
+end
+
+context 'API' do
+  context 'Load' do
+    test 'should load input file' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      doc = File.open(sample_input_path) {|file| Asciidoctor.load file, :safe => Asciidoctor::SafeMode::SAFE }
+      assert_equal 'Document Title', doc.doctitle
+      assert_equal File.expand_path(sample_input_path), doc.attr('docfile')
+      assert_equal File.expand_path(File.dirname(sample_input_path)), doc.attr('docdir')
+      assert_equal '.asciidoc', doc.attr('docfilesuffix')
+    end
+
+    test 'should load input file from filename' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      doc = Asciidoctor.load_file(sample_input_path, :safe => Asciidoctor::SafeMode::SAFE)
+      assert_equal 'Document Title', doc.doctitle
+      assert_equal File.expand_path(sample_input_path), doc.attr('docfile')
+      assert_equal File.expand_path(File.dirname(sample_input_path)), doc.attr('docdir')
+      assert_equal '.asciidoc', doc.attr('docfilesuffix')
+    end
+
+    test 'should not load invalid file' do
+      sample_input_path = fixture_path('hello-asciidoctor.pdf')
+      exception = assert_raises ArgumentError do
+        Asciidoctor.load_file(sample_input_path, :safe => Asciidoctor::SafeMode::SAFE)
+      end
+      assert_match(/Failed to load AsciiDoc document/, exception.message)
+      # verify we have the correct backtrace (should be in at least first 5 lines)
+      assert_match((RUBY_ENGINE == 'rbx' ? /parser\.rb/ : /helpers\.rb/), exception.backtrace[0..4].join("\n"))
+    end if RUBY_MIN_VERSION_1_9
+
+    test 'should load input IO' do
+      input = StringIO.new(<<-EOS)
+Document Title
+==============
+
+preamble
+      EOS
+      doc = Asciidoctor.load(input, :safe => Asciidoctor::SafeMode::SAFE)
+      assert_equal 'Document Title', doc.doctitle
+      refute doc.attr?('docfile')
+      assert_equal doc.base_dir, doc.attr('docdir')
+    end
+
+    test 'should load input string' do
+      input = <<-EOS
+Document Title
+==============
+
+preamble
+      EOS
+      doc = Asciidoctor.load(input, :safe => Asciidoctor::SafeMode::SAFE)
+      assert_equal 'Document Title', doc.doctitle
+      refute doc.attr?('docfile')
+      assert_equal doc.base_dir, doc.attr('docdir')
+    end
+
+    test 'should load input string array' do
+      input = <<-EOS
+Document Title
+==============
+
+preamble
+      EOS
+      doc = Asciidoctor.load(input.lines.entries, :safe => Asciidoctor::SafeMode::SAFE)
+      assert_equal 'Document Title', doc.doctitle
+      refute doc.attr?('docfile')
+      assert_equal doc.base_dir, doc.attr('docdir')
+    end
+
+    test 'should accept attributes as array' do
+	  # NOTE there's a tab character before idseparator
+      doc = Asciidoctor.load('text', :attributes => %w(toc sectnums   source-highlighter=coderay idprefix	idseparator=-))
+      assert_kind_of Hash, doc.attributes
+      assert doc.attr?('toc')
+      assert_equal '', doc.attr('toc')
+      assert doc.attr?('sectnums')
+      assert_equal '', doc.attr('sectnums')
+      assert doc.attr?('source-highlighter')
+      assert_equal 'coderay', doc.attr('source-highlighter')
+      assert doc.attr?('idprefix')
+      assert_equal '', doc.attr('idprefix')
+      assert doc.attr?('idseparator')
+      assert_equal '-', doc.attr('idseparator')
+    end
+
+    test 'should accept attributes as empty array' do
+      doc = Asciidoctor.load('text', :attributes => [])
+      assert_kind_of Hash, doc.attributes
+    end
+
+    test 'should accept attributes as string' do
+      doc = Asciidoctor.load('text', :attributes => 'toc sectnums
+source-highlighter=coderay
+idprefix
+idseparator=-')
+      assert_kind_of Hash, doc.attributes
+      assert doc.attr?('toc')
+      assert_equal '', doc.attr('toc')
+      assert doc.attr?('sectnums')
+      assert_equal '', doc.attr('sectnums')
+      assert doc.attr?('source-highlighter')
+      assert_equal 'coderay', doc.attr('source-highlighter')
+      assert doc.attr?('idprefix')
+      assert_equal '', doc.attr('idprefix')
+      assert doc.attr?('idseparator')
+      assert_equal '-', doc.attr('idseparator')
+    end
+
+    test 'should accept values containing spaces in attributes string' do
+      doc = Asciidoctor.load('text', :attributes => %(idprefix idseparator=-   note-caption=Note\\ to\\\tself toc))
+      assert_kind_of Hash, doc.attributes
+      assert doc.attr?('idprefix')
+      assert_equal '', doc.attr('idprefix')
+      assert doc.attr?('idseparator')
+      assert_equal '-', doc.attr('idseparator')
+      assert doc.attr?('note-caption')
+      assert_equal "Note to\tself", doc.attr('note-caption')
+    end
+
+    test 'should accept attributes as empty string' do
+      doc = Asciidoctor.load('text', :attributes => '')
+      assert_kind_of Hash, doc.attributes
+    end
+
+    test 'should accept attributes as nil' do
+      doc = Asciidoctor.load('text', :attributes => nil)
+      assert_kind_of Hash, doc.attributes
+    end
+
+    test 'should accept attributes if hash like' do
+      class Hashish
+        def initialize
+          @table = {'toc' => ''}
+        end
+
+        def keys
+          @table.keys
+        end
+
+        def [](key)
+          @table[key]
+        end
+      end
+
+      doc = Asciidoctor.load('text', :attributes => Hashish.new)
+      assert_kind_of Hash, doc.attributes
+      assert doc.attributes.has_key?('toc')
+    end
+
+    test 'should not expand value of docdir attribute if specified via API' do
+      docdir = 'virtual/directory'
+      doc = document_from_string '', :safe => :safe, :attributes => { 'docdir' => docdir }
+      assert_equal docdir, (doc.attr 'docdir')
+      assert_equal docdir, doc.base_dir
+    end
+
+    test 'converts block to output format when convert is called' do
+      doc = Asciidoctor.load 'paragraph text'
+      expected = <<-EOS
+<div class="paragraph">
+<p>paragraph text</p>
+</div>
+      EOS
+      assert_equal 1, doc.blocks.length
+      assert_equal :paragraph, doc.blocks[0].context
+      assert_equal expected.chomp, doc.blocks[0].convert
+    end
+
+    test 'render method on node is aliased to convert method' do
+      input = <<-EOS
+paragraph text
+
+* list item
+      EOS
+      doc = Asciidoctor.load input
+      assert_equal 2, doc.blocks.length
+      ([doc] + doc.blocks).each do |block|
+        assert_equal block.method(:convert), block.method(:render)
+      end
+      inline = Asciidoctor::Inline.new doc.blocks[0], :image, nil, :type => 'image', :target => 'tiger.png'
+      assert_equal inline.method(:convert), inline.method(:render)
+    end
+
+    test 'should output timestamps by default' do
+      doc = document_from_string 'text', :backend => :html5, :attributes => nil
+      result = doc.convert
+      assert doc.attr?('docdate')
+      refute doc.attr? 'reproducible'
+      assert_xpath '//div[@id="footer-text" and contains(string(.//text()), "Last updated")]', result, 1
+    end
+
+    test 'should not output timestamps if reproducible attribute is set in HTML 5' do
+      doc = document_from_string 'text', :backend => :html5, :attributes => { 'reproducible' => '' }
+      result = doc.convert
+      assert doc.attr?('docdate')
+      assert doc.attr?('reproducible')
+      assert_xpath '//div[@id="footer-text" and contains(string(.//text()), "Last updated")]', result, 0
+    end
+
+    test 'should not output timestamps if reproducible attribute is set in DocBook' do
+      doc = document_from_string 'text', :backend => :docbook, :attributes => { 'reproducible' => '' }
+      result = doc.convert
+      assert doc.attr?('docdate')
+      assert doc.attr?('reproducible')
+      assert_xpath '/article/info/date', result, 0
+    end
+
+    test 'should not modify options argument' do
+      options = {
+        :safe => Asciidoctor::SafeMode::SAFE
+      }
+      options.freeze
+      sample_input_path = fixture_path('sample.asciidoc')
+      begin
+        Asciidoctor.load_file sample_input_path, options
+      rescue
+        flunk %(options argument should not be modified)
+      end
+    end
+
+    test 'should not modify attributes Hash argument' do
+      attributes = {}
+      attributes.freeze
+      options = {
+        :safe => Asciidoctor::SafeMode::SAFE,
+        :attributes => attributes
+      }
+      sample_input_path = fixture_path('sample.asciidoc')
+      begin
+        Asciidoctor.load_file sample_input_path, options
+      rescue
+        flunk %(attributes argument should not be modified)
+      end
+    end
+
+    test 'should be able to restore header attributes after call to convert' do
+      input = <<-EOS
+= Document Title
+:foo: bar
+
+content
+
+:foo: baz
+
+content
+      EOS
+      doc = Asciidoctor.load input
+      assert_equal 'bar', (doc.attr 'foo')
+      doc.convert
+      assert_equal 'baz', (doc.attr 'foo')
+      doc.restore_attributes
+      assert_equal 'bar', (doc.attr 'foo')
+    end
+
+    test 'should track file and line information with blocks if sourcemap option is set' do
+      doc = Asciidoctor.load_file fixture_path('sample.asciidoc'), :sourcemap => true
+
+      refute_nil doc.source_location
+      assert_equal 'sample.asciidoc', doc.file
+      assert_equal 1, doc.lineno
+
+      section_1 = doc.sections[0]
+      assert_equal 'Section A', section_1.title
+      refute_nil section_1.source_location
+      assert_equal 'sample.asciidoc', section_1.file
+      assert_equal 10, section_1.lineno
+
+      section_2 = doc.sections[1]
+      assert_equal 'Section B', section_2.title
+      refute_nil section_2.source_location
+      assert_equal 'sample.asciidoc', section_2.file
+      assert_equal 18, section_2.lineno
+
+      table_block = section_2.blocks[1]
+      assert_equal :table, table_block.context
+      refute_nil table_block.source_location
+      assert_equal 'sample.asciidoc', table_block.file
+      assert_equal 22, table_block.lineno
+      first_cell = table_block.rows.body[0][0]
+      refute_nil first_cell.source_location
+      assert_equal 'sample.asciidoc', first_cell.file
+      assert_equal 23, first_cell.lineno
+      second_cell = table_block.rows.body[0][1]
+      refute_nil second_cell.source_location
+      assert_equal 'sample.asciidoc', second_cell.file
+      assert_equal 23, second_cell.lineno
+      last_cell = table_block.rows.body[-1][-1]
+      refute_nil last_cell.source_location
+      assert_equal 'sample.asciidoc', last_cell.file
+      assert_equal 24, last_cell.lineno
+
+      last_block = section_2.blocks[-1]
+      assert_equal :ulist, last_block.context
+      refute_nil last_block.source_location
+      assert_equal 'sample.asciidoc', last_block.file
+      assert_equal 28, last_block.lineno
+
+      list_items = last_block.blocks
+      refute_nil list_items[0].source_location
+      assert_equal 'sample.asciidoc', list_items[0].file
+      assert_equal 28, list_items[0].lineno
+
+      refute_nil list_items[1].source_location
+      assert_equal 'sample.asciidoc', list_items[1].file
+      assert_equal 29, list_items[1].lineno
+
+      refute_nil list_items[2].source_location
+      assert_equal 'sample.asciidoc', list_items[2].file
+      assert_equal 30, list_items[2].lineno
+
+      doc = Asciidoctor.load_file fixture_path('master.adoc'), :sourcemap => true, :safe => :safe
+
+      section_1 = doc.sections[0]
+      assert_equal 'Chapter A', section_1.title
+      refute_nil section_1.source_location
+      assert_equal fixture_path('chapter-a.adoc'), section_1.file
+      assert_equal 1, section_1.lineno
+    end
+
+    test 'should track file and line information on list items if sourcemap option is set' do
+      doc = Asciidoctor.load_file fixture_path('lists.adoc'), :sourcemap => true
+
+      first_section = doc.blocks[1]
+
+      unordered_basic_list = first_section.blocks[0]
+      assert_equal 11, unordered_basic_list.lineno
+
+      unordered_basic_list_items = unordered_basic_list.find_by :context => :list_item
+      assert_equal 11, unordered_basic_list_items[0].lineno
+      assert_equal 12, unordered_basic_list_items[1].lineno
+      assert_equal 13, unordered_basic_list_items[2].lineno
+
+      unordered_max_nesting = first_section.blocks[1]
+      assert_equal 16, unordered_max_nesting.lineno
+      unordered_max_nesting_items = unordered_max_nesting.find_by :context => :list_item
+      assert_equal 16, unordered_max_nesting_items[0].lineno
+      assert_equal 17, unordered_max_nesting_items[1].lineno
+      assert_equal 18, unordered_max_nesting_items[2].lineno
+      assert_equal 19, unordered_max_nesting_items[3].lineno
+      assert_equal 20, unordered_max_nesting_items[4].lineno
+      assert_equal 21, unordered_max_nesting_items[5].lineno
+
+      checklist = first_section.blocks[2]
+      assert_equal 24, checklist.lineno
+      checklist_list_items = checklist.find_by :context => :list_item
+      assert_equal 24, checklist_list_items[0].lineno
+      assert_equal 25, checklist_list_items[1].lineno
+      assert_equal 26, checklist_list_items[2].lineno
+      assert_equal 27, checklist_list_items[3].lineno
+
+      ordered_basic = first_section.blocks[3]
+      assert_equal 30, ordered_basic.lineno
+      ordered_basic_list_items = ordered_basic.find_by :context => :list_item
+      assert_equal 30, ordered_basic_list_items[0].lineno
+      assert_equal 31, ordered_basic_list_items[1].lineno
+      assert_equal 32, ordered_basic_list_items[2].lineno
+
+      ordered_nested = first_section.blocks[4]
+      assert_equal 35, ordered_nested.lineno
+      ordered_nested_list_items = ordered_nested.find_by :context => :list_item
+      assert_equal 35, ordered_nested_list_items[0].lineno
+      assert_equal 36, ordered_nested_list_items[1].lineno
+      assert_equal 37, ordered_nested_list_items[2].lineno
+      assert_equal 38, ordered_nested_list_items[3].lineno
+      assert_equal 39, ordered_nested_list_items[4].lineno
+
+      ordered_max_nesting = first_section.blocks[5]
+      assert_equal 42, ordered_max_nesting.lineno
+      ordered_max_nesting_items = ordered_max_nesting.find_by :context => :list_item
+      assert_equal 42, ordered_max_nesting_items[0].lineno
+      assert_equal 43, ordered_max_nesting_items[1].lineno
+      assert_equal 44, ordered_max_nesting_items[2].lineno
+      assert_equal 45, ordered_max_nesting_items[3].lineno
+      assert_equal 46, ordered_max_nesting_items[4].lineno
+      assert_equal 47, ordered_max_nesting_items[5].lineno
+
+      labeled_singleline = first_section.blocks[6]
+      assert_equal 50, labeled_singleline.lineno
+      labeled_singleline_items = labeled_singleline.find_by :context => :list_item
+      assert_equal 50, labeled_singleline_items[0].lineno
+      assert_equal 50, labeled_singleline_items[1].lineno
+      assert_equal 51, labeled_singleline_items[2].lineno
+      assert_equal 51, labeled_singleline_items[3].lineno
+
+      labeled_multiline = first_section.blocks[7]
+      assert_equal 54, labeled_multiline.lineno
+      labeled_multiline_items = labeled_multiline.find_by :context => :list_item
+      assert_equal 54, labeled_multiline_items[0].lineno
+      assert_equal 55, labeled_multiline_items[1].lineno
+      assert_equal 56, labeled_multiline_items[2].lineno
+      assert_equal 57, labeled_multiline_items[3].lineno
+
+      qanda = first_section.blocks[8]
+      assert_equal 61, qanda.lineno
+      qanda_items = qanda.find_by :context => :list_item
+      assert_equal 61, qanda_items[0].lineno
+      assert_equal 62, qanda_items[1].lineno
+      assert_equal 63, qanda_items[2].lineno
+      assert_equal 63, qanda_items[3].lineno
+
+      mixed = first_section.blocks[9]
+      assert_equal 66, mixed.lineno
+      mixed_items = mixed.find_by(:context => :list_item) {|block| block.text? }
+      assert_equal 66, mixed_items[0].lineno
+      assert_equal 67, mixed_items[1].lineno
+      assert_equal 68, mixed_items[2].lineno
+      assert_equal 69, mixed_items[3].lineno
+      assert_equal 70, mixed_items[4].lineno
+      assert_equal 71, mixed_items[5].lineno
+      assert_equal 72, mixed_items[6].lineno
+      assert_equal 73, mixed_items[7].lineno
+      assert_equal 74, mixed_items[8].lineno
+      assert_equal 75, mixed_items[9].lineno
+      assert_equal 77, mixed_items[10].lineno
+      assert_equal 78, mixed_items[11].lineno
+      assert_equal 79, mixed_items[12].lineno
+      assert_equal 80, mixed_items[13].lineno
+      assert_equal 81, mixed_items[14].lineno
+      assert_equal 82, mixed_items[15].lineno
+      assert_equal 83, mixed_items[16].lineno
+
+      unordered_complex_list = first_section.blocks[10]
+      assert_equal 86, unordered_complex_list.lineno
+      unordered_complex_items = unordered_complex_list.find_by :context => :list_item
+      assert_equal 86, unordered_complex_items[0].lineno
+      assert_equal 87, unordered_complex_items[1].lineno
+      assert_equal 88, unordered_complex_items[2].lineno
+      assert_equal 92, unordered_complex_items[3].lineno
+      assert_equal 96, unordered_complex_items[4].lineno
+    end
+
+    test 'should assign correct source location if section occurs on last line of input' do
+      input = <<-EOS
+= Document Title
+
+== Section A
+
+content
+
+== Section B
+      EOS
+
+      doc = document_from_string input, :sourcemap => true
+      assert_equal [1, 3, 7], (doc.find_by :context => :section).map(&:lineno)
+    end
+
+    test 'should allow sourcemap option on document to be modified' do
+      doc = Asciidoctor.load_file fixture_path('sample.asciidoc'), :parse => false
+      doc.sourcemap = true
+      doc = doc.parse
+
+      section_1 = doc.sections[0]
+      assert_equal 'Section A', section_1.title
+      refute_nil section_1.source_location
+      assert_equal 'sample.asciidoc', section_1.file
+      assert_equal 10, section_1.lineno
+    end
+
+    test 'find_by should return Array of blocks anywhere in document tree that match criteria' do
+      input = <<-EOS
+= Document Title
+
+preamble
+
+== Section A
+
+paragraph
+
+--
+Exhibit A::
++
+[#tiger.animal]
+image::tiger.png[Tiger]
+--
+
+image::shoe.png[Shoe]
+
+== Section B
+
+paragraph
+      EOS
+
+      doc = Asciidoctor.load input
+      result = doc.find_by :context => :image
+      assert_equal 2, result.size
+      assert_equal :image, result[0].context
+      assert_equal 'tiger.png', result[0].attr('target')
+      assert_equal :image, result[1].context
+      assert_equal 'shoe.png', result[1].attr('target')
+    end
+
+    test 'find_by should return an empty Array if no matches are found' do
+      input = <<-EOS
+paragraph
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by :context => :section
+      refute_nil result
+      assert_equal 0, result.size
+    end
+
+    test 'find_by should return Array of blocks that match style criteria' do
+      input = <<-EOS
+[square]
+* one
+* two
+* three
+
+---
+
+* apples
+* bananas
+* pears
+      EOS
+
+      doc = Asciidoctor.load input
+      result = doc.find_by :context => :ulist, :style => 'square'
+      assert_equal 1, result.size
+      assert_equal :ulist, result[0].context
+    end
+
+    test 'find_by should return Array of blocks that match role criteria' do
+      input = <<-EOS
+[#tiger.animal]
+image::tiger.png[Tiger]
+
+image::shoe.png[Shoe]
+      EOS
+
+      doc = Asciidoctor.load input
+      result = doc.find_by :context => :image, :role => 'animal'
+      assert_equal 1, result.size
+      assert_equal :image, result[0].context
+      assert_equal 'tiger.png', result[0].attr('target')
+    end
+
+    test 'find_by should return the document title section if context selector is :section' do
+      input = <<-EOS
+= Document Title
+
+preamble
+
+== Section One
+
+content
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by :context => :section
+      refute_nil result
+      assert_equal 2, result.size
+      assert_equal :section, result[0].context
+      assert_equal 'Document Title', result[0].title
+    end
+
+    test 'find_by should only return results for which the block argument yields true' do
+      input = <<-EOS
+== Section
+
+content
+
+=== Subsection
+
+content
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by(:context => :section) {|sect| sect.level == 1 }
+      refute_nil result
+      assert_equal 1, result.size
+      assert_equal :section, result[0].context
+      assert_equal 'Section', result[0].title
+    end
+
+    test 'find_by should only return one result when matching by id' do
+      input = <<-EOS
+== Section
+
+content
+
+[#subsection]
+=== Subsection
+
+content
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by(:context => :section, :id => 'subsection')
+      refute_nil result
+      assert_equal 1, result.size
+      assert_equal :section, result[0].context
+      assert_equal 'Subsection', result[0].title
+    end
+
+    test 'find_by should return an empty Array if the id criteria matches but the block argument yields false' do
+      input = <<-EOS
+== Section
+
+content
+
+[#subsection]
+=== Subsection
+
+content
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by(:context => :section, :id => 'subsection') {|sect| false }
+      refute_nil result
+      assert_equal 0, result.size
+    end
+
+    test 'find_by should not crash if dlist entry does not have description' do
+      input = <<-EOS
+term without description::
+      EOS
+      doc = Asciidoctor.load input
+      result = doc.find_by
+      refute_nil result
+      assert_equal 3, result.size
+      assert_kind_of Asciidoctor::Document, result[0]
+      assert_kind_of Asciidoctor::List, result[1]
+      assert_kind_of Asciidoctor::ListItem, result[2]
+    end
+
+    test 'timings are recorded for each step when load and convert are called separately' do
+      sample_input_path = fixture_path 'asciidoc_index.txt'
+      (Asciidoctor.load_file sample_input_path, :timings => (timings = Asciidoctor::Timings.new)).convert
+      refute_equal '0.00000', '%05.5f' % timings.read_parse.to_f
+      refute_equal '0.00000', '%05.5f' % timings.convert.to_f
+      refute_equal timings.read_parse, timings.total
+    end
+  end
+
+  context 'Convert' do
+    test 'render_file is aliased to convert_file' do
+      assert_equal Asciidoctor.method(:convert_file), Asciidoctor.method(:render_file)
+    end
+
+    test 'render is aliased to convert' do
+      assert_equal Asciidoctor.method(:convert), Asciidoctor.method(:render)
+    end
+
+    test 'should convert source document to string when to_file is false' do
+      sample_input_path = fixture_path('sample.asciidoc')
+
+      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
+      refute_empty output
+      assert_xpath '/html', output, 1
+      assert_xpath '/html/head', output, 1
+      assert_xpath '/html/body', output, 1
+      assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
+      assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
+    end
+
+    test 'lines in output should be separated by line feed' do
+      sample_input_path = fixture_path('sample.asciidoc')
+
+      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
+      refute_empty output
+      lines = output.split("\n")
+      assert_equal lines.size, output.split(/\r\n|\r|\n/).size
+      raw_lengths = lines.map(&:length)
+      trimmed_lengths = lines.map {|line| line.rstrip.length }
+      assert_equal raw_lengths, trimmed_lengths
+    end
+
+    test 'should accept attributes as array' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      output = Asciidoctor.convert_file sample_input_path, :attributes => %w(sectnums idprefix idseparator=-), :to_file => false
+      assert_css '#section-a', output, 1
+    end
+
+    test 'should accept attributes as string' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      output = Asciidoctor.convert_file sample_input_path, :attributes => 'sectnums idprefix idseparator=-', :to_file => false
+      assert_css '#section-a', output, 1
+    end
+
+    test 'should link to default stylesheet by default when safe mode is SECURE or greater' do
+      sample_input_path = fixture_path('basic.asciidoc')
+      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
+      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
+      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 1
+    end
+
+    test 'should embed default stylesheet by default if SafeMode is less than SECURE' do
+      input = <<-EOS
+= Document Title
+
+text
+      EOS
+
+      output = Asciidoctor.convert input, :safe => Asciidoctor::SafeMode::SERVER, :header_footer => true
+      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
+      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 0
+      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
+      styles = stylenode.content
+      refute_nil styles
+      refute_empty styles.strip
+    end
+
+    test 'should not allow linkcss be unset from document if SafeMode is SECURE or greater' do
+      input = <<-EOS
+= Document Title
+:linkcss!:
+
+text
+      EOS
+
+      output = Asciidoctor.convert input, :header_footer => true
+      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
+      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 1
+    end
+
+    test 'should embed default stylesheet if linkcss is unset from API and SafeMode is SECURE or greater' do
+      input = <<-EOS
+= Document Title
+
+text
+      EOS
+
+      #[{ 'linkcss!' => '' }, { 'linkcss' => nil }, { 'linkcss' => false }].each do |attrs|
+      [{ 'linkcss!' => '' }, { 'linkcss' => nil }].each do |attrs|
+        output = Asciidoctor.convert input, :header_footer => true, :attributes => attrs
+        assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
+        assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 0
+        stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
+        styles = stylenode.content
+        refute_nil styles
+        refute_empty styles.strip
+      end
+    end
+
+    test 'should embed default stylesheet if safe mode is less than SECURE and linkcss is unset from API' do
+      sample_input_path = fixture_path('basic.asciidoc')
+      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false,
+          :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'linkcss!' => ''}
+      assert_css 'html:root > head > style', output, 1
+      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
+      styles = stylenode.content
+      refute_nil styles
+      refute_empty styles.strip
+    end
+
+    test 'should not link to stylesheet if stylesheet is unset' do
+      input = <<-EOS
+= Document Title
+
+text
+      EOS
+
+      output = Asciidoctor.convert input, :header_footer => true, :attributes => {'stylesheet!' => ''}
+      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 0
+      assert_css 'html:root > head > link[rel="stylesheet"]', output, 0
+    end
+
+    test 'should link to custom stylesheet if specified in stylesheet attribute' do
+      input = <<-EOS
+= Document Title
+
+text
+      EOS
+
+      output = Asciidoctor.convert input, :header_footer => true, :attributes => {'stylesheet' => './custom.css'}
+      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 0
+      assert_css 'html:root > head > link[rel="stylesheet"][href="./custom.css"]', output, 1
+
+      output = Asciidoctor.convert input, :header_footer => true, :attributes => {'stylesheet' => 'file:///home/username/custom.css'}
+      assert_css 'html:root > head > link[rel="stylesheet"][href="file:///home/username/custom.css"]', output, 1
+    end
+
+    test 'should resolve custom stylesheet relative to stylesdir' do
+      input = <<-EOS
+= Document Title
+
+text
+      EOS
+
+      output = Asciidoctor.convert input, :header_footer => true, :attributes => {'stylesheet' => 'custom.css', 'stylesdir' => './stylesheets'}
+      assert_css 'html:root > head > link[rel="stylesheet"][href="./stylesheets/custom.css"]', output, 1
+    end
+
+    test 'should resolve custom stylesheet to embed relative to stylesdir' do
+      sample_input_path = fixture_path('basic.asciidoc')
+      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :safe => Asciidoctor::SafeMode::SAFE, :to_file => false,
+          :attributes => {'stylesheet' => 'custom.css', 'stylesdir' => './stylesheets', 'linkcss!' => ''}
+      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
+      styles = stylenode.content
+      refute_nil styles
+      refute_empty styles.strip
+    end
+
+    test 'should convert source file and write result to adjacent file by default' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      sample_output_path = fixture_path('sample.html')
+      begin
+        Asciidoctor.convert_file sample_input_path
+        assert File.exist?(sample_output_path)
+        output = IO.read(sample_output_path)
+        refute_empty output
+        assert_xpath '/html', output, 1
+        assert_xpath '/html/head', output, 1
+        assert_xpath '/html/body', output, 1
+        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
+        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
+      ensure
+        FileUtils.rm(sample_output_path)
+      end
+    end
+
+    test 'should convert source file and write to specified file' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      sample_output_path = fixture_path('result.html')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_file => sample_output_path
+        assert File.exist?(sample_output_path)
+        output = IO.read(sample_output_path)
+        refute_empty output
+        assert_xpath '/html', output, 1
+        assert_xpath '/html/head', output, 1
+        assert_xpath '/html/body', output, 1
+        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
+        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
+      ensure
+        FileUtils.rm(sample_output_path)
+      end
+    end
+
+    test 'should convert source file and write to specified file in base_dir' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      sample_output_path = fixture_path('result.html')
+      fixture_dir = fixture_path('')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_file => 'result.html', :base_dir => fixture_dir
+        assert File.exist?(sample_output_path)
+        output = IO.read(sample_output_path)
+        refute_empty output
+        assert_xpath '/html', output, 1
+        assert_xpath '/html/head', output, 1
+        assert_xpath '/html/body', output, 1
+        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
+        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
+      rescue => e
+        flunk e.message
+      ensure
+        FileUtils.rm(sample_output_path, :force => true)
+      end
+    end
+
+    test 'in_place option is ignored when to_file is specified' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      sample_output_path = fixture_path('result.html')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_file => sample_output_path, :in_place => true
+        assert File.exist?(sample_output_path)
+      ensure
+        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
+      end
+    end
+
+    test 'in_place option is ignored when to_dir is specified' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      sample_output_path = fixture_path('sample.html')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_dir => File.dirname(sample_output_path), :in_place => true
+        assert File.exist?(sample_output_path)
+      ensure
+        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
+      end
+    end
+
+    test 'should set outfilesuffix to match file extension of target file' do
+      sample_input = '{outfilesuffix}'
+      sample_output_path = fixture_path('result.htm')
+      begin
+        Asciidoctor.convert sample_input, :to_file => sample_output_path, :header_footer => false
+        assert File.exist?(sample_output_path)
+        output = IO.read(sample_output_path)
+        refute_empty output
+        assert_includes output, '<p>.htm</p>'
+      ensure
+        FileUtils.rm(sample_output_path)
+      end
+    end
+
+    test 'output should be relative to to_dir option' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      output_dir = File.join(File.dirname(sample_input_path), 'test_output')
+      Dir.mkdir output_dir if !File.exist? output_dir
+      sample_output_path = File.join(output_dir, 'sample.html')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_dir => output_dir
+        assert File.exist? sample_output_path
+      ensure
+        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
+        FileUtils.rmdir output_dir
+      end
+    end
+
+    test 'missing directories should be created if mkdirs is enabled' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      output_dir = File.join(File.join(File.dirname(sample_input_path), 'test_output'), 'subdir')
+      sample_output_path = File.join(output_dir, 'sample.html')
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_dir => output_dir, :mkdirs => true
+        assert File.exist? sample_output_path
+      ensure
+        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
+        FileUtils.rmdir output_dir
+        FileUtils.rmdir File.dirname(output_dir)
+      end
+    end
+
+    # TODO need similar test for when to_dir is specified
+    test 'should raise exception if an attempt is made to overwrite input file' do
+      sample_input_path = fixture_path('sample.asciidoc')
+
+      assert_raises IOError do
+        Asciidoctor.convert_file sample_input_path, :attributes => { 'outfilesuffix' => '.asciidoc' }
+      end
+    end
+
+    test 'to_file should be relative to to_dir when both given' do
+      sample_input_path = fixture_path('sample.asciidoc')
+      base_dir = File.dirname(sample_input_path)
+      sample_rel_output_path = File.join('test_output', 'result.html')
+      output_dir = File.dirname(File.join(base_dir, sample_rel_output_path))
+      Dir.mkdir output_dir if !File.exist? output_dir
+      sample_output_path = File.join(base_dir, sample_rel_output_path)
+      begin
+        Asciidoctor.convert_file sample_input_path, :to_dir => base_dir, :to_file => sample_rel_output_path
+        assert File.exist? sample_output_path
+      ensure
+        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
+        FileUtils.rmdir output_dir
+      end
+    end
+
+    test 'should not modify options argument' do
+      options = {
+        :safe => Asciidoctor::SafeMode::SAFE,
+        :to_file => false
+      }
+      options.freeze
+      sample_input_path = fixture_path('sample.asciidoc')
+      begin
+        Asciidoctor.convert_file sample_input_path, options
+      rescue
+        flunk %(options argument should not be modified)
+      end
+    end
+
+    test 'should set to_dir option to parent directory of specified output file' do
+      sample_input_path = fixture_path 'basic.asciidoc'
+      sample_output_path = fixture_path 'basic.html'
+      begin
+        doc = Asciidoctor.convert_file sample_input_path, :to_file => sample_output_path
+        assert_equal File.dirname(sample_output_path), doc.options[:to_dir]
+      ensure
+        FileUtils.rm(sample_output_path)
+      end
+    end
+
+    test 'should set to_dir option to parent directory of specified output directory and file' do
+      sample_input_path = fixture_path 'basic.asciidoc'
+      sample_output_path = fixture_path 'basic.html'
+      fixture_base_path = File.dirname sample_output_path
+      fixture_parent_path = File.dirname fixture_base_path
+      sample_output_relpath = File.join 'fixtures', 'basic.html'
+      begin
+        doc = Asciidoctor.convert_file sample_input_path, :to_dir => fixture_parent_path, :to_file => sample_output_relpath
+        assert_equal fixture_base_path, doc.options[:to_dir]
+      ensure
+        FileUtils.rm(sample_output_path)
+      end
+    end
+
+    test 'timings are recorded for each step' do
+      sample_input_path = fixture_path 'asciidoc_index.txt'
+      Asciidoctor.convert_file sample_input_path, :timings => (timings = Asciidoctor::Timings.new), :to_file => false
+      refute_equal '0.00000', '%05.5f' % timings.read_parse.to_f
+      refute_equal '0.00000', '%05.5f' % timings.convert.to_f
+      refute_equal timings.read_parse, timings.total
+    end
+  end
+
+  context 'AST' do
+    test 'should not crash if nil cell text is passed to Cell constructor' do
+      input = <<-EOS
+|===
+|a
+|===
+      EOS
+      table = (document_from_string input).blocks[0]
+      cell = Asciidoctor::Table::Cell.new table.rows.body[0][0].column, nil, {}
+      refute cell.style
+      assert_same Asciidoctor::AbstractNode::NORMAL_SUBS, cell.subs
+      assert_equal '', cell.text
+    end
+  end
+end
diff -pruN 1.5.6.2-2/test/attributes_test.rb 1.5.7-1/test/attributes_test.rb
--- 1.5.6.2-2/test/attributes_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/attributes_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -5,6 +5,16 @@ unless defined? ASCIIDOCTOR_PROJECT_DIR
 end
 
 context 'Attributes' do
+  default_logger = Asciidoctor::LoggerManager.logger
+
+  setup do
+    Asciidoctor::LoggerManager.logger = (@logger = Asciidoctor::MemoryLogger.new)
+  end
+
+  teardown do
+    Asciidoctor::LoggerManager.logger = default_logger
+  end
+
   context 'Assignment' do
     test 'creates an attribute' do
       doc = document_from_string(':frog: Tanglefoot')
@@ -13,9 +23,45 @@ context 'Attributes' do
 
     test 'requires a space after colon following attribute name' do
       doc = document_from_string 'foo:bar'
-      assert_equal nil, doc.attributes['foo']
+      assert_nil doc.attributes['foo']
     end
 
+    # NOTE AsciiDoc Python recognizes this entry
+    test 'does not recognize attribute entry if name contains colon' do
+      input = <<-EOS.chomp
+:foo:bar: baz
+      EOS
+      doc = document_from_string input
+      refute doc.attr?('foo:bar')
+      assert_equal 1, doc.blocks.size
+      assert_equal :paragraph, doc.blocks[0].context
+    end
+
+    # NOTE AsciiDoc Python recognizes this entry
+    test 'does not recognize attribute entry if name ends with colon' do
+      input = <<-EOS.chomp
+:foo:: bar
+      EOS
+      doc = document_from_string input
+      refute doc.attr?('foo:')
+      assert_equal 1, doc.blocks.size
+      assert_equal :dlist, doc.blocks[0].context
+    end
+
+    # NOTE AsciiDoc Python does not recognize this entry
+    test 'allows any word character defined by Unicode in an attribute name' do
+      [['café', 'a coffee shop'], ['سمن', %(سازمان مردمنهاد)]].each do |(name, value)|
+        str = <<-EOS
+:#{name}: #{value}
+
+{#{name}}
+        EOS
+        result = render_embedded_string str
+        assert_includes result, %(<p>#{value}</p>)
+      end
+
+    end if ::RUBY_MIN_VERSION_1_9
+
     test 'creates an attribute by fusing a legacy multi-line value' do
       str = <<-EOS
 :description: This is the first      +
@@ -58,32 +104,32 @@ linus.torvalds@example.com
 
     test 'should delete an attribute that ends with !' do
       doc = document_from_string(":frog: Tanglefoot\n:frog!:")
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test 'should delete an attribute that ends with ! set via API' do
       doc = document_from_string(":frog: Tanglefoot", :attributes => {'frog!' => ''})
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test 'should delete an attribute that begins with !' do
       doc = document_from_string(":frog: Tanglefoot\n:!frog:")
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test 'should delete an attribute that begins with ! set via API' do
       doc = document_from_string(":frog: Tanglefoot", :attributes => {'!frog' => ''})
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test 'should delete an attribute set via API to nil value' do
       doc = document_from_string(":frog: Tanglefoot", :attributes => {'frog' => nil})
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test "doesn't choke when deleting a non-existing attribute" do
       doc = document_from_string(':frog!:')
-      assert_equal nil, doc.attributes['frog']
+      assert_nil doc.attributes['frog']
     end
 
     test "replaces special characters in attribute value" do
@@ -98,11 +144,8 @@ linus.torvalds@example.com
 
     test 'assigns attribute to empty string if substitution fails to resolve attribute' do
       input = ':release: Asciidoctor {version}'
-      doc, warnings = redirect_streams do |_, err|
-        [(document_from_string input, :attributes => { 'attribute-missing' => 'drop-line' }), err.string]
-      end
-      assert_equal '', doc.attributes['release']
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      document_from_string input, :attributes => { 'attribute-missing' => 'drop-line' }
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: version'
     end
 
     test 'assigns multi-line attribute to empty string if substitution fails to resolve attribute' do
@@ -110,11 +153,9 @@ linus.torvalds@example.com
 :release: Asciidoctor +
           {version}
       EOS
-      doc, warnings = redirect_streams do |_, err|
-        [(document_from_string input, :attributes => { 'attribute-missing' => 'drop-line' }), err.string]
-      end
+      doc = document_from_string input, :attributes => { 'attribute-missing' => 'drop-line' }
       assert_equal '', doc.attributes['release']
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: version'
     end
 
     test 'resolves attributes inside attribute value within header' do
@@ -127,7 +168,7 @@ linus.torvalds@example.com
       EOS
 
       result = render_embedded_string input
-      assert result.include? 'bigfoot'
+      assert_includes result, 'bigfoot'
     end
 
     test 'resolves attributes and pass macro inside attribute value outside header' do
@@ -142,7 +183,7 @@ content
       EOS
 
       result = render_embedded_string input
-      assert result.include? '<em>big</em>foot'
+      assert_includes result, '<em>big</em>foot'
     end
 
     test 'should limit maximum size of attribute value if safe mode is SECURE' do
@@ -259,22 +300,60 @@ endif::holygrail[]
       assert_xpath '(//p)[2][text() = "Buggers! What happened to the grail?"]', output, 1
     end
 
-    # Validates requirement: "Header attributes are overridden by command-line attributes."
-    test 'attribute defined in document options overrides attribute in document' do
+    test 'attribute set via API overrides attribute set in document' do
       doc = document_from_string(':cash: money', :attributes => {'cash' => 'heroes'})
       assert_equal 'heroes', doc.attributes['cash']
     end
 
-    test 'attribute defined in document options cannot be unassigned in document' do
+    test 'attribute set via API cannot be unset by document' do
       doc = document_from_string(':cash!:', :attributes => {'cash' => 'heroes'})
       assert_equal 'heroes', doc.attributes['cash']
     end
 
-    test 'attribute undefined in document options cannot be assigned in document' do
-      doc = document_from_string(':cash: money', :attributes => {'cash!' => '' })
-      assert_equal nil, doc.attributes['cash']
-      doc = document_from_string(':cash: money', :attributes => {'cash' => nil })
-      assert_equal nil, doc.attributes['cash']
+    test 'attribute soft set via API using modifier on name can be overridden by document' do
+      doc = document_from_string(':cash: money', :attributes => {'cash@' => 'heroes'})
+      assert_equal 'money', doc.attributes['cash']
+    end
+
+    test 'attribute soft set via API using modifier on value can be overridden by document' do
+      doc = document_from_string(':cash: money', :attributes => {'cash' => 'heroes@'})
+      assert_equal 'money', doc.attributes['cash']
+    end
+
+    test 'attribute soft set via API using modifier on name can be unset by document' do
+      doc = document_from_string(':cash!:', :attributes => {'cash@' => 'heroes'})
+      assert_nil doc.attributes['cash']
+      doc = document_from_string(':cash!:', :attributes => {'cash@' => true})
+      assert_nil doc.attributes['cash']
+    end
+
+    test 'attribute soft set via API using modifier on value can be unset by document' do
+      doc = document_from_string(':cash!:', :attributes => {'cash' => 'heroes@'})
+      assert_nil doc.attributes['cash']
+    end
+
+    test 'attribute unset via API cannot be set by document' do
+      [
+        { 'cash!' => '' },
+        { '!cash' => '' },
+        { 'cash' => nil },
+      ].each do |attributes|
+        doc = document_from_string(':cash: money', :attributes => attributes)
+        assert_nil doc.attributes['cash']
+      end
+    end
+
+    test 'attribute soft unset via API can be set by document' do
+      [
+        { 'cash!@' => '' },
+        { '!cash@' => '' },
+        { 'cash!' => '@' },
+        { '!cash' => '@' },
+        { 'cash' => false },
+      ].each do |attributes|
+        doc = document_from_string(':cash: money', :attributes => attributes)
+        assert_equal 'money', doc.attributes['cash']
+      end
     end
 
     test 'backend and doctype attributes are set by default in default configuration' do
@@ -378,6 +457,13 @@ content
       assert doc.attributes.has_key? 'basebackend-html'
     end
 
+    test 'can only access a positional attribute from the attributes hash' do
+      node = Asciidoctor::Block.new nil, :paragraph, :attributes => { 1 => 'position 1' }
+      assert_nil node.attr(1)
+      refute node.attr?(1)
+      assert_equal 'position 1', node.attributes[1]
+    end
+
     test 'set_attr should set value to empty string if no value is specified' do
       node = Asciidoctor::Block.new nil, :paragraph, :attributes => {}
       node.set_attr 'foo'
@@ -522,16 +608,16 @@ This is
 blah blah {foobarbaz}
 all there is.
       EOS
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       para = xmlnodes_at_css 'p', output, 1
       refute_includes 'blah blah', para.content
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: foobarbaz'
     end
 
     test "attribute value gets interpretted when rendering" do
       doc = document_from_string(":google: http://google.com[Google]\n\n{google}")
       assert_equal 'http://google.com[Google]', doc.attributes['google']
-      output = doc.render
+      output = doc.convert
       assert_xpath '//a[@href="http://google.com"][text() = "Google"]', output, 1
     end
 
@@ -543,10 +629,10 @@ Line 1: This line should appear in the o
 Line 2: Oh no, a {bogus-attribute}! This line should not appear in the output.
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       assert_match(/Line 1/, output)
       refute_match(/Line 2/, output)
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: bogus-attribute'
     end
 
     test 'should not drop line with reference to missing attribute by default' do
@@ -589,6 +675,28 @@ Line 2: {set:a!}This line should appear
       refute_match(/\{set:a!\}/, output)
     end
 
+    test 'should drop line that only contains attribute assignment' do
+      input = <<-EOS
+Line 1
+{set:a}
+Line 2
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath %(//p[text()="Line 1\nLine 2"]), output, 1
+    end
+
+    test 'should drop line that only contains unresolved attribute when attribute-missing is drop' do
+      input = <<-EOS
+Line 1
+{unresolved}
+Line 2
+      EOS
+
+      output = render_embedded_string input, :attributes => { 'attribute-missing' => 'drop' }
+      assert_xpath %(//p[text()="Line 1\nLine 2"]), output, 1
+    end
+
     test "substitutes inside unordered list items" do
       html = render_string(":foo: bar\n* snort at the {foo}\n* yawn")
       result = Nokogiri::HTML(html)
@@ -660,9 +768,23 @@ v1.0, 2010-01-01: First release!
       assert_equal 'value', doc.attr('a')
       assert_equal 'value', doc.attr('a2')
 
-      output = doc.render
-      assert output.include?('value == value')
-      assert output.include?('2010-01-01 == 2010-01-01')
+      output = doc.convert
+      assert_includes output, 'value == value'
+      assert_includes output, '2010-01-01 == 2010-01-01'
+    end
+
+    test 'should warn if unterminated block comment is detected in document header' do
+      input = <<-EOS
+= Document Title
+:foo: bar
+////
+:hey: there
+
+content
+      EOS
+      doc = document_from_string input
+      assert_nil doc.attr('hey')
+      assert_message @logger, :WARN, '<stdin>: line 3: unterminated comment block', Hash
     end
 
     test 'substitutes inside block title' do
@@ -749,14 +871,14 @@ puts 'The forecast for today is {forecas
     end
 
     test 'does not substitute attributes inside literal blocks' do
-       input = <<-EOS
+      input = <<-EOS
 :foo: bar
 
 ....
 You insert the text {foo} to expand the value
 of the attribute named foo in your document.
 ....
-       EOS
+      EOS
       output = render_string(input)
       assert_match(/\{foo\}/, output)
     end
@@ -816,7 +938,7 @@ of the attribute named foo in your docum
 {set:foo!}
 {foo}yes
       EOS
-      output = redirect_streams { render_embedded_string input }
+      output = render_embedded_string input
       assert_xpath '//p', output, 1
       assert_xpath '//p/child::text()', output, 0
     end
@@ -848,7 +970,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      output = doc.render
+      output = doc.convert
       assert_equal 1, doc.attributes['mycounter']
       assert_xpath '//p[text()="1"]', output, 1
     end
@@ -859,7 +981,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      output = doc.render
+      output = doc.convert
       assert_equal 1, doc.attributes['mycounter']
       assert_xpath '//p[text()="1"]', output, 0
     end
@@ -870,7 +992,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      doc.render
+      doc.convert
       assert_equal 10, doc.attributes['mycounter']
     end
 
@@ -880,7 +1002,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      doc.render
+      doc.convert
       assert_equal 'A', doc.attributes['mycounter']
     end
 
@@ -894,7 +1016,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      output = doc.render
+      output = doc.convert
       assert_equal 2, doc.attributes['mycounter']
       assert_xpath '//p[text()="2"]', output, 2
     end
@@ -909,7 +1031,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      output = doc.render
+      output = doc.convert
       assert_equal 'A', doc.attributes['mycounter']
       assert_xpath '//p[text()="A"]', output, 2
     end
@@ -924,7 +1046,7 @@ of the attribute named foo in your docum
       EOS
 
       doc = document_from_string input
-      output = doc.render :header_footer => false
+      output = doc.convert :header_footer => false
       assert_equal 1, doc.attributes['mycounter']
       assert_xpath '//p[text()="1"]', output, 2
     end
@@ -941,7 +1063,7 @@ after: {counter:mycounter}
       EOS
 
       doc = document_from_string input
-      output = doc.render :header_footer => false
+      output = doc.convert :header_footer => false
       assert_equal 1, doc.attributes['mycounter']
       assert_xpath '//p[text()="before: 1 2 3"]', output, 1
       assert_xpath '//p[text()="after: 1"]', output, 1
@@ -1190,11 +1312,29 @@ A paragraph
 
     test 'id, role and options attributes can be specified on block style using shorthand syntax' do
       input = <<-EOS
-[normal#first.lead%step]
-A normal paragraph.
+[literal#first.lead%step]
+A literal paragraph.
+      EOS
+      doc = document_from_string(input)
+      para = doc.blocks.first
+      assert_equal :literal, para.context
+      assert_equal 'first', para.attributes['id']
+      assert_equal 'lead', para.attributes['role']
+      assert_equal 'step', para.attributes['options']
+      assert para.attributes.has_key?('step-option')
+    end
+
+    test 'id, role and options attributes can be specified using shorthand syntax on block style using multiple block attribute lines' do
+      input = <<-EOS
+[literal]
+[#first]
+[.lead]
+[%step]
+A literal paragraph.
       EOS
       doc = document_from_string(input)
       para = doc.blocks.first
+      assert_equal :literal, para.context
       assert_equal 'first', para.attributes['id']
       assert_equal 'lead', para.attributes['role']
       assert_equal 'step', para.attributes['options']
@@ -1215,6 +1355,58 @@ Text
       assert para.attributes.has_key?('option2-option')
     end
 
+    test 'options specified using shorthand syntax on block style across multiple lines should be additive' do
+      input = <<-EOS
+[%option1]
+[%option2]
+Text
+      EOS
+
+      doc = document_from_string input
+      para = doc.blocks.first
+      assert_equal 'option1,option2', para.attributes['options']
+      assert para.attributes.has_key?('option1-option')
+      assert para.attributes.has_key?('option2-option')
+    end
+
+    test 'roles specified using shorthand syntax on block style across multiple lines should be additive' do
+      input = <<-EOS
+[.role1]
+[.role2.role3]
+Text
+      EOS
+
+      doc = document_from_string input
+      para = doc.blocks.first
+      assert_equal 'role1 role2 role3', para.attributes['role']
+    end
+
+    test 'setting a role using the role attribute replaces any existing roles' do
+      input = <<-EOS
+[.role1]
+[role=role2]
+[.role3]
+Text
+      EOS
+
+      doc = document_from_string input
+      para = doc.blocks.first
+      assert_equal 'role2 role3', para.attributes['role']
+    end
+
+    test 'setting a role using the shorthand syntax on block style should not clear the ID' do
+      input = <<-EOS
+[#id]
+[.role]
+Text
+      EOS
+
+      doc = document_from_string input
+      para = doc.blocks.first
+      assert_equal 'id', para.id
+      assert_equal 'role', para.role
+    end
+
     test 'a role can be added using add_role when the node has no roles' do
         input = <<-EOS
 A normal paragraph
@@ -1278,7 +1470,7 @@ A normal paragraph
       res = para.remove_role 'role1'
       assert res
       refute para.role?
-      assert_equal nil, para.attributes['role']
+      assert_nil para.attributes['role']
       refute para.has_role? 'role1'
     end
 
@@ -1304,7 +1496,7 @@ A normal paragraph
       para = doc.blocks.first
       res = para.remove_role 'role1'
       refute res
-      assert_equal nil, para.attributes['role']
+      assert_nil para.attributes['role']
       refute para.has_role?('role1')
     end
 
@@ -1318,7 +1510,6 @@ A normal paragraph
       list = doc.blocks.first
       assert_equal 'interactive', list.attributes['options']
       assert list.attributes.has_key?('interactive-option')
-      assert list.attributes[1] == '%interactive'
     end
 
     test 'id and role attributes can be specified on section style using shorthand syntax' do
diff -pruN 1.5.6.2-2/test/blocks_test.rb 1.5.7-1/test/blocks_test.rb
--- 1.5.6.2-2/test/blocks_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/blocks_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -4,7 +4,17 @@ unless defined? ASCIIDOCTOR_PROJECT_DIR
   require 'test_helper'
 end
 
-context "Blocks" do
+context 'Blocks' do
+  default_logger = Asciidoctor::LoggerManager.logger
+
+  setup do
+    Asciidoctor::LoggerManager.logger = (@logger = Asciidoctor::MemoryLogger.new)
+  end
+
+  teardown do
+    Asciidoctor::LoggerManager.logger = default_logger
+  end
+
   context 'Layout Breaks' do
     test 'horizontal rule' do
       %w(''' '''' '''''').each do |line|
@@ -141,7 +151,7 @@ block comment
       EOS
       d = document_from_string input
       assert_equal 1, d.blocks.size
-      assert_xpath '//p', d.render, 1
+      assert_xpath '//p', d.convert, 1
     end
 
     test 'line starting with three slashes should not be line comment' do
@@ -181,6 +191,36 @@ line should be rendered
       assert_xpath '//p[text() = "line should be rendered"]', output, 1
     end
 
+    test 'should warn if unterminated comment block is detected in body' do
+      input = <<-EOS
+before comment block
+
+////
+content that has been disabled
+
+supposed to be after comment block, except it got swallowed by block comment
+      EOS
+
+      render_embedded_string input
+      assert_message @logger, :WARN, '<stdin>: line 3: unterminated comment block', Hash
+    end
+
+    test 'should warn if unterminated comment block is detected inside another block' do
+      input = <<-EOS
+before sidebar block
+
+****
+////
+content that has been disabled
+****
+
+supposed to be after sidebar block, except it got swallowed by block comment
+      EOS
+
+      render_embedded_string input
+      assert_message @logger, :WARN, '<stdin>: line 4: unterminated comment block', Hash
+    end
+
     # WARNING if first line of content is a directive, it will get interpretted before we know it's a comment block
     # it happens because we always look a line ahead...not sure what we can do about it
     test 'preprocessor directives should not be processed within comment open block' do
@@ -311,15 +351,30 @@ ____
 
     test 'quote block with attribute and id and role shorthand' do
       input = <<-EOS
-[quote#think.big, Donald Trump]
+[quote#justice-to-all.solidarity, Martin Luther King, Jr.]
 ____
-As long as your going to be thinking anyway, think big.
+Injustice anywhere is a threat to justice everywhere.
 ____
       EOS
 
       output = render_embedded_string input
       assert_css '.quoteblock', output, 1
-      assert_css '#think.quoteblock.big', output, 1
+      assert_css '#justice-to-all.quoteblock.solidarity', output, 1
+      assert_css '.quoteblock > .attribution', output, 1
+    end
+
+    test 'setting ID using style shorthand should not reset block style' do
+      input = <<-EOS
+[quote]
+[#justice-to-all.solidarity, Martin Luther King, Jr.]
+____
+Injustice anywhere is a threat to justice everywhere.
+____
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.quoteblock', output, 1
+      assert_css '#justice-to-all.quoteblock.solidarity', output, 1
       assert_css '.quoteblock > .attribution', output, 1
     end
 
@@ -338,6 +393,42 @@ ____
       assert_css '.quoteblock > blockquote > .paragraph + .admonitionblock', output, 1
     end
 
+    test 'quote block with attribution converted to DocBook' do
+      input = <<-EOS
+[quote, Famous Person, Famous Book (1999)]
+____
+A famous quote.
+____
+      EOS
+      output = render_string input, :backend => :docbook
+      assert_css 'blockquote', output, 1
+      assert_css 'blockquote > simpara', output, 1
+      assert_css 'blockquote > attribution', output, 1
+      assert_css 'blockquote > attribution > citetitle', output, 1
+      assert_xpath '//blockquote/attribution/citetitle[text() = "Famous Book (1999)"]', output, 1
+      attribution = xmlnodes_at_xpath '//blockquote/attribution', output, 1
+      author = attribution.children.first
+      assert_equal 'Famous Person', author.text.strip
+    end
+ 
+    test 'epigraph quote block with attribution converted to DocBook' do
+      input = <<-EOS
+[.epigraph, Famous Person, Famous Book (1999)]
+____
+A famous quote.
+____
+      EOS
+      output = render_string input, :backend => :docbook
+      assert_css 'epigraph', output, 1
+      assert_css 'epigraph > simpara', output, 1
+      assert_css 'epigraph > attribution', output, 1
+      assert_css 'epigraph > attribution > citetitle', output, 1
+      assert_xpath '//epigraph/attribution/citetitle[text() = "Famous Book (1999)"]', output, 1
+      attribution = xmlnodes_at_xpath '//epigraph/attribution', output, 1
+      author = attribution.children.first
+      assert_equal 'Famous Person', author.text.strip
+    end
+
     test 'quote block using air quotes with no attribution' do
       input = <<-EOS
 ""
@@ -429,6 +520,18 @@ Some more inspiring words.
       assert_equal "#{decode_char 8212} Famous Person", author.text.strip
     end
 
+    test 'should parse credit line in markdown-style quote block like positional block attributes' do
+      input = <<-EOS
+> I hold it that a little rebellion now and then is a good thing,
+> and as necessary in the political world as storms in the physical.
+-- Thomas Jefferson, https://jeffersonpapers.princeton.edu/selected-documents/james-madison-1[The Papers of Thomas Jefferson, Volume 11]
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.quoteblock', output, 1
+      assert_css '.quoteblock cite a[href="https://jeffersonpapers.princeton.edu/selected-documents/james-madison-1"]', output, 1
+    end
+
     test 'quoted paragraph-style quote block with attribution' do
       input = <<-EOS
 "A famous quote.
@@ -448,6 +551,18 @@ Some more inspiring words."
       assert_equal "#{decode_char 8212} Famous Person", author.text.strip
     end
 
+    test 'should parse credit line in quoted paragraph-style quote block like positional block attributes' do
+      input = <<-EOS
+"I hold it that a little rebellion now and then is a good thing,
+and as necessary in the political world as storms in the physical."
+-- Thomas Jefferson, https://jeffersonpapers.princeton.edu/selected-documents/james-madison-1[The Papers of Thomas Jefferson, Volume 11]
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.quoteblock', output, 1
+      assert_css '.quoteblock cite a[href="https://jeffersonpapers.princeton.edu/selected-documents/james-madison-1"]', output, 1
+    end
+
     test 'single-line verse block without attribution' do
       input = <<-EOS
 [verse]
@@ -483,6 +598,44 @@ ____
       assert_equal "#{decode_char 8212} Famous Poet", author.text.strip
     end
 
+    test 'single-line verse block with attribution converted to DocBook' do
+      input = <<-EOS
+[verse, Famous Poet, Famous Poem]
+____
+A famous verse.
+____
+      EOS
+      output = render_string input, :backend => :docbook
+      assert_css 'blockquote', output, 1
+      assert_css 'blockquote simpara', output, 0
+      assert_css 'blockquote > literallayout', output, 1
+      assert_css 'blockquote > attribution', output, 1
+      assert_css 'blockquote > attribution > citetitle', output, 1
+      assert_xpath '//blockquote/attribution/citetitle[text() = "Famous Poem"]', output, 1
+      attribution = xmlnodes_at_xpath '//blockquote/attribution', output, 1
+      author = attribution.children.first
+      assert_equal 'Famous Poet', author.text.strip
+    end
+ 
+    test 'single-line epigraph verse block with attribution converted to DocBook' do
+      input = <<-EOS
+[verse.epigraph, Famous Poet, Famous Poem]
+____
+A famous verse.
+____
+      EOS
+      output = render_string input, :backend => :docbook
+      assert_css 'epigraph', output, 1
+      assert_css 'epigraph simpara', output, 0
+      assert_css 'epigraph > literallayout', output, 1
+      assert_css 'epigraph > attribution', output, 1
+      assert_css 'epigraph > attribution > citetitle', output, 1
+      assert_xpath '//epigraph/attribution/citetitle[text() = "Famous Poem"]', output, 1
+      attribution = xmlnodes_at_xpath '//epigraph/attribution', output, 1
+      author = attribution.children.first
+      assert_equal 'Famous Poet', author.text.strip
+    end
+
     test 'multi-stanza verse block' do
       input = <<-EOS
 [verse]
@@ -539,9 +692,9 @@ ____
 <1> Not pointing to a callout
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       assert_xpath '//pre[text()="La la la <1>"]', output, 1
-      assert_includes warnings, 'line 5: no callouts refer to list item 1'
+      assert_message @logger, :WARN, '<stdin>: line 5: no callout found for <1>', Hash
     end
 
     test 'should perform normal subs on a verse block' do
@@ -553,7 +706,7 @@ ____
       EOS
 
       output = render_embedded_string input
-      assert output.include?('<pre class="content"><em>GET /groups/<a href="#group-id">{group-id}</a></em></pre>')
+      assert_includes output, '<pre class="content"><em>GET /groups/<a href="#group-id">{group-id}</a></em></pre>'
     end
   end
 
@@ -591,7 +744,7 @@ You futz with XML.
       doc = document_from_string input
       assert_equal 1, doc.blocks[0].number
       assert_equal 2, doc.blocks[1].number
-      output = doc.render
+      output = doc.convert
       assert_xpath '(//*[@class="exampleblock"])[1]/*[@class="title"][text()="Example 1. Writing Docs with AsciiDoc"]', output, 1
       assert_xpath '(//*[@class="exampleblock"])[2]/*[@class="title"][text()="Example 2. Writing Docs with DocBook"]', output, 1
       assert_equal 2, doc.attributes['example-number']
@@ -619,7 +772,7 @@ You futz with XML.
       doc = document_from_string input
       assert_equal 'A', doc.blocks[0].number
       assert_equal 'B', doc.blocks[1].number
-      output = doc.render
+      output = doc.convert
       assert_xpath '(//*[@class="exampleblock"])[1]/*[@class="title"][text()="Example A. Writing Docs with AsciiDoc"]', output, 1
       assert_xpath '(//*[@class="exampleblock"])[2]/*[@class="title"][text()="Example B. Writing Docs with DocBook"]', output, 1
       assert_equal 'B', doc.attributes['example-number']
@@ -638,7 +791,7 @@ You just write.
 
       doc = document_from_string input
       assert_nil doc.blocks[0].number
-      output = doc.render
+      output = doc.convert
       assert_xpath '(//*[@class="exampleblock"])[1]/*[@class="title"][text()="Look! Writing Docs with AsciiDoc"]', output, 1
       refute doc.attributes.has_key?('example-number')
     end
@@ -672,41 +825,58 @@ yet another example
       assert_xpath '(/*[@class="exampleblock"])[2]/*[@class="title"][text()="second example"]', output, 1
       assert_xpath '(/*[@class="exampleblock"])[3]/*[@class="title"][starts-with(text(), "Exhibit ")]', output, 1
     end
+
+    test 'should warn if example block is not terminated' do
+      input = <<-EOS
+outside
+
+====
+inside
+
+still inside
+
+eof
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '/*[@class="exampleblock"]', output, 1
+      assert_message @logger, :WARN, '<stdin>: line 3: unterminated example block', Hash
+    end
   end
 
   context 'Admonition Blocks' do
     test 'caption block-level attribute should be used as caption' do
-       input = <<-EOS
+      input = <<-EOS
 :tip-caption: Pro Tip
 
 [caption="Pro Tip"]
 TIP: Override the caption of an admonition block using an attribute entry
-       EOS
+      EOS
 
-       output = render_embedded_string input
-       assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Pro Tip"]', output, 1
+      output = render_embedded_string input
+      assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Pro Tip"]', output, 1
     end
 
     test 'can override caption of admonition block using document attribute' do
-       input = <<-EOS
+      input = <<-EOS
 :tip-caption: Pro Tip
 
 TIP: Override the caption of an admonition block using an attribute entry
-       EOS
+      EOS
 
-       output = render_embedded_string input
-       assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Pro Tip"]', output, 1
+      output = render_embedded_string input
+      assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Pro Tip"]', output, 1
     end
 
     test 'blank caption document attribute should not blank admonition block caption' do
-       input = <<-EOS
+      input = <<-EOS
 :caption:
 
 TIP: Override the caption of an admonition block using an attribute entry
-       EOS
+      EOS
 
-       output = render_embedded_string input
-       assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Tip"]', output, 1
+      output = render_embedded_string input
+      assert_xpath '/*[@class="admonitionblock tip"]//*[@class="icon"]/*[@class="title"][text()="Tip"]', output, 1
     end
   end
 
@@ -820,7 +990,7 @@ last line
       doc = document_from_string input, :header_footer => false
       block = doc.blocks.first
       assert_equal ['', '', '  first line', '', 'last line', '', '{empty}', ''], block.lines
-      result = doc.render
+      result = doc.convert
       assert_xpath %(//pre[text()="  first line\n\nlast line"]), result, 1
     end
 
@@ -1014,8 +1184,8 @@ Map<String, String> *attributes*; //<1>
 
       block = block_from_string input
       assert_equal [:specialcharacters,:callouts,:quotes], block.subs
-      output = block.render
-      assert output.include?('Map&lt;String, String&gt; <strong>attributes</strong>;')
+      output = block.convert
+      assert_includes output, 'Map&lt;String, String&gt; <strong>attributes</strong>;'
       assert_xpath '//pre/b[text()="(1)"]', output, 1
     end
 
@@ -1028,7 +1198,7 @@ No callout here <1>
       EOS
       block = block_from_string input
       assert_equal [:specialcharacters], block.subs
-      output = block.render
+      output = block.convert
       assert_xpath '//pre/b[text()="(1)"]', output, 0
     end
 
@@ -1067,6 +1237,20 @@ AssertionError
       assert_equal output.rstrip, output2.rstrip
     end
 
+    test 'first character of block title may be a period if not followed by space' do
+      input = <<-EOS
+..gitignore
+----
+/.bundle/
+/build/
+/Gemfile.lock
+----
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '//*[@class="title"][text()=".gitignore"]', output
+    end
+
     test 'listing block without title should generate screen element in docbook' do
       input = <<-EOS
 ----
@@ -1151,6 +1335,111 @@ ____
       assert_xpath '//*[@class="openblock"]//p', output, 3
       assert_xpath '//*[@class="openblock"]//*[@class="quoteblock"]', output, 1
     end
+
+    test 'should transfer id and reftext on open block to DocBook output' do
+      input = <<-EOS
+Check out that <<open>>!
+
+[[open,Open Block]]
+--
+This is an open block.
+
+TIP: An open block can have other blocks inside of it.
+--
+
+Back to our regularly scheduled programming.
+      EOS
+
+      output = render_string input, :backend => :docbook, :keep_namespaces => true
+      assert_css 'article > simpara', output, 2
+      assert_css 'article > para', output, 1
+      assert_css 'article > para > simpara', output, 1
+      assert_css 'article > para > tip', output, 1
+      open = xmlnodes_at_xpath '/xmlns:article/xmlns:para', output, 1
+      # nokogiri can't make up its mind
+      id = open.attribute('id') || open.attribute('xml:id')
+      refute_nil id
+      assert_equal 'open', id.value
+      xreflabel = open.attribute('xreflabel')
+      refute_nil xreflabel
+      assert_equal 'Open Block', xreflabel.value
+    end
+
+    test 'should transfer id and reftext on open paragraph to DocBook output' do
+      input = <<-EOS
+[open#openpara,reftext="Open Paragraph"]
+This is an open paragraph.
+      EOS
+
+      output = render_string input, :backend => :docbook, :keep_namespaces => true
+      assert_css 'article > simpara', output, 1
+      open = xmlnodes_at_xpath '/xmlns:article/xmlns:simpara', output, 1
+      open = xmlnodes_at_xpath '/xmlns:article/xmlns:simpara[text()="This is an open paragraph."]', output, 1
+      # nokogiri can't make up its mind
+      id = open.attribute('id') || open.attribute('xml:id')
+      refute_nil id
+      assert_equal 'openpara', id.value
+      xreflabel = open.attribute('xreflabel')
+      refute_nil xreflabel
+      assert_equal 'Open Paragraph', xreflabel.value
+    end
+
+    test 'should transfer title on open block to DocBook output' do
+      input = <<-EOS
+.Behold the open
+--
+This is an open block with a title.
+--
+      EOS
+
+      output = render_string input, :backend => :docbook
+      assert_css 'article > formalpara', output, 1
+      assert_css 'article > formalpara > *', output, 2
+      assert_css 'article > formalpara > title', output, 1
+      assert_xpath '/article/formalpara/title[text()="Behold the open"]', output, 1
+      assert_css 'article > formalpara > para', output, 1
+      assert_css 'article > formalpara > para > simpara', output, 1
+    end
+
+    test 'should transfer title on open paragraph to DocBook output' do
+      input = <<-EOS
+.Behold the open
+This is an open paragraph with a title.
+      EOS
+
+      output = render_string input, :backend => :docbook
+      assert_css 'article > formalpara', output, 1
+      assert_css 'article > formalpara > *', output, 2
+      assert_css 'article > formalpara > title', output, 1
+      assert_xpath '/article/formalpara/title[text()="Behold the open"]', output, 1
+      assert_css 'article > formalpara > para', output, 1
+      assert_css 'article > formalpara > para[text()="This is an open paragraph with a title."]', output, 1
+    end
+
+    test 'should transfer role on open block to DocBook output' do
+      input = <<-EOS
+[.container]
+--
+This is an open block.
+It holds stuff.
+--
+      EOS
+
+      output = render_string input, :backend => :docbook
+      assert_css 'article > para[role=container]', output, 1
+      assert_css 'article > para[role=container] > simpara', output, 1
+    end
+
+    test 'should transfer role on open paragraph to DocBook output' do
+      input = <<-EOS
+[.container]
+This is an open block.
+It holds stuff.
+      EOS
+
+      output = render_string input, :backend => :docbook
+      assert_css 'article > simpara[role=container]', output, 1
+    end
   end
 
   context 'Passthrough Blocks' do
@@ -1240,7 +1529,7 @@ line below
       doc = document_from_string input, :header_footer => false
       block = doc.blocks[1]
       assert_equal ['', '', '  first line', '', 'last line', '', ''], block.lines
-      result = doc.render
+      result = doc.convert
       assert_equal "line above\n  first line\n\nlast line\nline below", result, 1
     end
   end
@@ -1293,6 +1582,88 @@ line below
       assert_equal expect.strip, output.strip
     end
 
+    test 'should not split equation in AsciiMath block at single newline' do
+      input = <<-'EOS'
+[asciimath]
+++++
+f: bbb"N" -> bbb"N"
+f: x |-> x + 1
+++++
+      EOS
+      expected = <<-'EOS'.chomp
+\$f: bbb"N" -&gt; bbb"N"
+f: x |-&gt; x + 1\$
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.stemblock', output, 1
+      nodes = xmlnodes_at_xpath '//*[@class="content"]', output
+      assert_equal expected, nodes.first.inner_html.strip
+    end
+
+    test 'should split equation in AsciiMath block at escaped newline' do
+      input = <<-'EOS'
+[asciimath]
+++++
+f: bbb"N" -> bbb"N" \
+f: x |-> x + 1
+++++
+      EOS
+      expected = <<-'EOS'.chomp
+\$f: bbb"N" -&gt; bbb"N"\$<br>
+\$f: x |-&gt; x + 1\$
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.stemblock', output, 1
+      nodes = xmlnodes_at_xpath '//*[@class="content"]', output
+      assert_equal expected, nodes.first.inner_html.strip
+    end
+
+    test 'should split equation in AsciiMath block at sequence of escaped newlines' do
+      input = <<-'EOS'
+[asciimath]
+++++
+f: bbb"N" -> bbb"N" \
+\
+f: x |-> x + 1
+++++
+      EOS
+      expected = <<-'EOS'.chomp
+\$f: bbb"N" -&gt; bbb"N"\$<br>
+<br>
+\$f: x |-&gt; x + 1\$
+      EOS
+
+      output = render_embedded_string input
+      assert_css '.stemblock', output, 1
+      nodes = xmlnodes_at_xpath '//*[@class="content"]', output
+      assert_equal expected, nodes.first.inner_html.strip
+    end
+
+    test 'should split equation in AsciiMath block at newline sequence and preserve breaks' do
+      input = <<-'EOS'
+[asciimath]
+++++
+f: bbb"N" -> bbb"N"
+
+
+f: x |-> x + 1
+++++
+      EOS
+      expected = <<-'EOS'.chomp
+\$f: bbb"N" -&gt; bbb"N"\$<br>
+<br>
+<br>
+\$f: x |-&gt; x + 1\$
+EOS
+
+      output = render_embedded_string input
+      assert_css '.stemblock', output, 1
+      nodes = xmlnodes_at_xpath '//*[@class="content"]', output
+      assert_equal expected, nodes.first.inner_html.strip
+    end
+
     test 'should add AsciiMath delimiters around asciimath block content' do
       input = <<-'EOS'
 [asciimath]
@@ -1321,7 +1692,8 @@ sqrt(3x-1)+(1+x)^2 < y
       assert_equal '\$sqrt(3x-1)+(1+x)^2 &lt; y\$', nodes.first.to_s.strip
     end
 
-    test 'should render asciimath block in textobject of equation in DocBook backend' do
+    test 'should convert contents of asciimath block to MathML in DocBook output if asciimath gem is available' do
+      asciimath_available = !(Asciidoctor::Helpers.require_library 'asciimath', true, :ignore).nil?
       input = <<-'EOS'
 [asciimath]
 ++++
@@ -1333,8 +1705,17 @@ x+b/(2a)<+-sqrt((b^2)/(4a^2)-c/a)
 <mml:math xmlns:mml="http://www.w3.org/1998/Math/MathML"><mml:mi>x</mml:mi><mml:mo>+</mml:mo><mml:mfrac><mml:mi>b</mml:mi><mml:mrow><mml:mn>2</mml:mn><mml:mi>a</mml:mi></mml:mrow></mml:mfrac><mml:mo>&#x003C;</mml:mo><mml:mo>&#x00B1;</mml:mo><mml:msqrt><mml:mrow><mml:mfrac><mml:msup><mml:mi>b</mml:mi><mml:mn>2</mml:mn></mml:msup><mml:mrow><mml:mn>4</mml:mn><mml:msup><mml:mi>a</mml:mi><mml:mn>2</mml:mn></mml:msup></mml:mrow></mml:mfrac><mml:mo>&#x2212;</mml:mo><mml:mfrac><mml:mi>c</mml:mi><mml:mi>a</mml:mi></mml:mfrac></mml:mrow></mml:msqrt></mml:math>
 </informalequation>)
 
-      output = render_embedded_string input, :backend => :docbook
-      assert_equal expect.strip, output.strip
+      using_memory_logger do |logger|
+        doc = document_from_string input, :backend => :docbook, :header_footer => false
+        actual = doc.convert
+        if asciimath_available
+          assert_equal expect.strip, actual.strip
+          assert_equal :loaded, doc.converter.instance_variable_get(:@asciimath)
+        else
+          assert_message logger, :WARN, 'optional gem \'asciimath\' is not installed. Functionality disabled.'
+          assert_equal :unavailable, doc.converter.instance_variable_get(:@asciimath)
+        end
+      end
     end
 
     test 'should output title for latexmath block if defined' do
@@ -1371,7 +1752,7 @@ a//b
       assert_xpath '//*[@class="title"][text()="Simple fraction"]', output, 1
     end
 
-    test 'should add AsciiMath delimiters around stem block content if stem attribute != latexmath' do
+    test 'should add AsciiMath delimiters around stem block content if stem attribute is asciimath, empty, or not set' do
       input = <<-'EOS'
 [stem]
 ++++
@@ -1382,7 +1763,8 @@ sqrt(3x-1)+(1+x)^2 < y
       [
         {},
         {'stem' => ''},
-        {'stem' => 'asciimath'}
+        {'stem' => 'asciimath'},
+        {'stem' => 'bogus'}
       ].each do |attributes|
         output = render_embedded_string input, :attributes => attributes
         assert_css '.stemblock', output, 1
@@ -1391,7 +1773,7 @@ sqrt(3x-1)+(1+x)^2 < y
       end
     end
 
-    test 'should add LaTeX math delimiters around stem block content if stem attribute is latexmath' do
+    test 'should add LaTeX math delimiters around stem block content if stem attribute is latexmath, latex, or tex' do
       input = <<-'EOS'
 [stem]
 ++++
@@ -1399,10 +1781,36 @@ sqrt(3x-1)+(1+x)^2 < y
 ++++
       EOS
 
-      output = render_embedded_string input, :attributes => {'stem' => 'latexmath'}
+      [
+        {'stem' => 'latexmath'},
+        {'stem' => 'latex'},
+        {'stem' => 'tex'}
+      ].each do |attributes|
+        output = render_embedded_string input, :attributes => attributes
+        assert_css '.stemblock', output, 1
+        nodes = xmlnodes_at_xpath '//*[@class="content"]/child::text()', output
+        assert_equal '\[\sqrt{3x-1}+(1+x)^2 &lt; y\]', nodes.first.to_s.strip
+      end
+    end
+
+    test 'should allow stem style to be set using second positional argument of block attributes' do
+      input = <<-EOS
+:stem: latexmath
+
+[stem,asciimath]
+++++
+sqrt(3x-1)+(1+x)^2 < y
+++++
+      EOS
+
+      doc = document_from_string input
+      stemblock = doc.blocks[0]
+      assert_equal :stem, stemblock.context
+      assert_equal 'asciimath', stemblock.attributes['style']
+      output = doc.convert :header_footer => false
       assert_css '.stemblock', output, 1
       nodes = xmlnodes_at_xpath '//*[@class="content"]/child::text()', output
-      assert_equal '\[\sqrt{3x-1}+(1+x)^2 &lt; y\]', nodes.first.to_s.strip
+      assert_equal '\$sqrt(3x-1)+(1+x)^2 &lt; y\$', nodes.first.to_s.strip
     end
   end
 
@@ -1427,18 +1835,13 @@ paragraph
 
 section paragraph
       EOS
-      output, errors = nil
-      redirect_streams do |stdout, stderr|
-        output = render_string input
-        errors = stderr.string
-      end
+      output = render_string input
       assert_xpath '//*[@id="header"]/*', output, 0
       assert_xpath '//*[@id="preamble"]/*', output, 0
       assert_xpath '//*[@id="content"]/h1[text()="Section Title"]', output, 1
       assert_xpath '//*[@class="paragraph"]', output, 1
       assert_xpath '//*[@class="paragraph"]/*[@class="title"][text()="Block title"]', output, 1
-      refute_empty errors
-      assert_match(/only book doctypes can contain level 0 sections/, errors)
+      assert_message @logger, :ERROR, '<stdin>: line 2: level 0 sections can only be used when doctype is book', Hash
     end
 
     test 'block title above document title gets carried over to first block in first section if no preamble' do
@@ -1467,8 +1870,8 @@ Block content
       EOS
 
       output = render_embedded_string input
-      assert output.include?('Block content')
-      refute output.include?('[]')
+      assert_includes output, 'Block content'
+      refute_includes output, '[]'
     end
 
     test 'empty block anchor should not appear in output' do
@@ -1480,8 +1883,8 @@ Block content
       EOS
 
       output = render_embedded_string input
-      assert output.include?('Block content')
-      refute output.include?('[[]]')
+      assert_includes output, 'Block content'
+      refute_includes output, '[[]]'
     end
   end
 
@@ -1570,7 +1973,7 @@ image::http://example.org/tiger-svg[Tige
 image::circle.svg[Tiger,100]
       EOS
 
-      output = render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'docdir' => ::File.dirname(__FILE__) }
+      output = render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'docdir' => testdir }
       assert_match(/<svg\s[^>]*width="100px"[^>]*>/, output, 1)
       refute_match(/<svg\s[^>]*width="500px"[^>]*>/, output)
       refute_match(/<svg\s[^>]*height="500px"[^>]*>/, output)
@@ -1586,7 +1989,7 @@ image::circle.svg[Tiger,100]
 image::circle.svg[Tiger,100]
       EOS
 
-      output = render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'docdir' => ::File.dirname(__FILE__) }
+      output = render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'docdir' => testdir }
       assert_match(/<svg\s[^>]*width="100px">/, output, 1)
     end
 
@@ -1596,9 +1999,9 @@ image::circle.svg[Tiger,100]
 image::no-such-image.svg[Alt Text]
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER), err.string] }
+      output = render_embedded_string input, :safe => Asciidoctor::SafeMode::SERVER
       assert_xpath '//span[@class="alt"][text()="Alt Text"]', output, 1
-      assert_includes warnings, 'SVG does not exist or cannot be read'
+      assert_message @logger, :WARN, '~SVG does not exist or cannot be read'
     end
 
     test 'can render block image with alt text defined in macro containing square bracket' do
@@ -1735,6 +2138,15 @@ image::images/tiger.png[Tiger,link=http:
       assert_xpath '/*[@class="imageblock"]//a[@class="image"][@href="http://en.wikipedia.org/wiki/Tiger"][@target="name"][@rel="noopener"]/img[@src="images/tiger.png"][@alt="Tiger"]', output, 1
     end
 
+    test 'adds rel=nofollow attribute to block image with a link when the nofollow option is set' do
+      input = <<-EOS
+image::images/tiger.png[Tiger,link=http://en.wikipedia.org/wiki/Tiger,opts=nofollow]
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '/*[@class="imageblock"]//a[@class="image"][@href="http://en.wikipedia.org/wiki/Tiger"][@rel="nofollow"]/img[@src="images/tiger.png"][@alt="Tiger"]', output, 1
+    end
+
     test 'can render block image with caption' do
       input = <<-EOS
 .The AsciiDoc Tiger
@@ -1743,7 +2155,7 @@ image::images/tiger.png[Tiger]
 
       doc = document_from_string input
       assert_equal 1, doc.blocks[0].number
-      output = doc.render
+      output = doc.convert
       assert_xpath '//*[@class="imageblock"]//img[@src="images/tiger.png"][@alt="Tiger"]', output, 1
       assert_xpath '//*[@class="imageblock"]/*[@class="title"][text() = "Figure 1. The AsciiDoc Tiger"]', output, 1
       assert_equal 1, doc.attributes['figure-number']
@@ -1758,7 +2170,7 @@ image::images/tiger.png[Tiger]
 
       doc = document_from_string input
       assert_nil doc.blocks[0].number
-      output = doc.render
+      output = doc.convert
       assert_xpath '//*[@class="imageblock"]//img[@src="images/tiger.png"][@alt="Tiger"]', output, 1
       assert_xpath '//*[@class="imageblock"]/*[@class="title"][text() = "Voila! The AsciiDoc Tiger"]', output, 1
       refute doc.attributes.has_key?('figure-number')
@@ -1831,9 +2243,9 @@ image::images/sunset.jpg[Sunset,scaledwi
 image::{bogus}[]
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-      assert output.include?('image::{bogus}[]')
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      output = render_embedded_string input
+      assert_includes output, 'image::{bogus}[]'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: bogus'
     end
 
     test 'drops line if image target is missing attribute reference and attribute-missing is drop' do
@@ -1843,9 +2255,9 @@ image::{bogus}[]
 image::{bogus}[]
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       assert_empty output.strip
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: bogus'
     end
 
     test 'drops line if image target is missing attribute reference and attribute-missing is drop-line' do
@@ -1855,9 +2267,9 @@ image::{bogus}[]
 image::{bogus}[]
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       assert_empty output.strip
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: bogus'
     end
 
     test 'dropped image does not break processing of following section and attribute-missing is drop-line' do
@@ -1869,11 +2281,11 @@ image::{bogus}[]
 == Section Title
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
+      output = render_embedded_string input
       assert_css 'img', output, 0
       assert_css 'h2', output, 1
-      refute output.include?('== Section Title')
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
+      refute_includes output, '== Section Title'
+      assert_message @logger, :WARN, 'dropping line containing reference to missing attribute: bogus'
     end
 
     test 'should pass through image that references uri' do
@@ -1915,9 +2327,9 @@ image::tiger.png[Tiger]
 image::dot.gif[Dot]
       EOS
 
-      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}
+      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => testdir }
       assert_equal 'fixtures', doc.attributes['imagesdir']
-      output = doc.render
+      output = doc.convert
       assert_xpath '//img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Dot"]', output, 1
     end
 
@@ -1929,11 +2341,11 @@ image::dot.gif[Dot]
 image::unreadable.gif[Dot]
       EOS
 
-      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}
+      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => testdir }
       assert_equal 'fixtures', doc.attributes['imagesdir']
-      output, warnings = redirect_streams {|_, err| [doc.render, err.string] }
+      output = doc.convert
       assert_xpath '//img[@src="data:image/gif;base64,"]', output, 1
-      assert_includes warnings, 'image to embed not found or not readable'
+      assert_message @logger, :WARN, '~image to embed not found or not readable'
     end
 
     test 'embeds base64-encoded data uri for remote image when data-uri attribute is set' do
@@ -1973,16 +2385,12 @@ image::dot.gif[Dot]
 image::#{image_uri}[Missing image]
       EOS
 
-      output = warnings = nil
-      redirect_streams do |_, err|
-        output = using_test_webserver do
-          render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
-        end
-        warnings = err.string
+      output = using_test_webserver do
+        render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
       end
 
       assert_xpath %(/*[@class="imageblock"]//img[@src="#{image_uri}"][@alt="Missing image"]), output, 1
-      assert_includes warnings, 'could not retrieve image data from URI'
+      assert_message @logger, :WARN, '~could not retrieve image data from URI'
     end
 
     test 'uses remote image uri when data-uri attribute is set and allow-uri-read is not set' do
@@ -2028,13 +2436,13 @@ image::data:image/gif;base64,R0lGODlhAQA
 image::dot.gif[Dot]
       EOS
 
-      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}
+      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => testdir }
       assert_equal '../..//fixtures/./../../fixtures', doc.attributes['imagesdir']
-      output, warnings = redirect_streams {|_, err| [doc.render, err.string] }
+      output = doc.convert
       # image target resolves to fixtures/dot.gif relative to docdir (which is explicitly set to the directory of this file)
       # the reference cannot fall outside of the document directory in safe mode
       assert_xpath '//img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Dot"]', output, 1
-      assert_includes warnings, 'image has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'image has illegal reference to ancestor of jail; recovering automatically'
     end
 
     test 'cleans reference to ancestor directories in target before reading image if safe mode level is at least SAFE' do
@@ -2045,13 +2453,13 @@ image::dot.gif[Dot]
 image::../..//fixtures/./../../fixtures/dot.gif[Dot]
       EOS
 
-      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}
+      doc = document_from_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => { 'docdir' => testdir }
       assert_equal './', doc.attributes['imagesdir']
-      output, warnings = redirect_streams {|_, err| [doc.render, err.string] }
+      output = doc.convert
       # image target resolves to fixtures/dot.gif relative to docdir (which is explicitly set to the directory of this file)
       # the reference cannot fall outside of the document directory in safe mode
       assert_xpath '//img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Dot"]', output, 1
-      assert_includes warnings, 'image has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'image has illegal reference to ancestor of jail; recovering automatically'
     end
   end
 
@@ -2293,7 +2701,22 @@ Override the icon of an admonition block
 You can use icons for admonitions by setting the 'icons' attribute.
       EOS
 
-      output = render_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}
+      output = render_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => { 'docdir' => testdir }
+      assert_xpath '//*[@class="admonitionblock tip"]//*[@class="icon"]/img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Tip"]', output, 1
+    end
+
+    test 'should embed base64-encoded data uri of custom icon when data-uri attribute is set' do
+      input = <<-EOS
+:icons:
+:iconsdir: fixtures
+:icontype: gif
+:data-uri:
+
+[TIP,icon=tip]
+You can set a custom icon using the icon attribute on the block.
+      EOS
+
+      output = render_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => { 'docdir' => testdir }
       assert_xpath '//*[@class="admonitionblock tip"]//*[@class="icon"]/img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Tip"]', output, 1
     end
 
@@ -2323,11 +2746,9 @@ You can use icons for admonitions by set
 You can use icons for admonitions by setting the 'icons' attribute.
       EOS
 
-      output, warnings = redirect_streams do |_, err|
-        [(render_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'docdir' => File.dirname(__FILE__)}), err.string]
-      end
+      output = render_string input, :safe => Asciidoctor::SafeMode::SAFE, :attributes => { 'docdir' => testdir }
       assert_xpath '//*[@class="admonitionblock tip"]//*[@class="icon"]/img[@src="data:image/gif;base64,R0lGODlhAQABAIAAAAUEBAAAACwAAAAAAQABAAACAkQBADs="][@alt="Tip"]', output, 1
-      assert_includes warnings, 'image has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'image has illegal reference to ancestor of jail; recovering automatically'
     end
 
     test 'should import Font Awesome and use font-based icons when value of icons attribute is font' do
@@ -2339,7 +2760,7 @@ You can use icons for admonitions by set
       EOS
 
       output = render_string input, :safe => Asciidoctor::SafeMode::SERVER
-      assert_css 'html > head > link[rel="stylesheet"][href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css"]', output, 1
+      assert_css %(html > head > link[rel="stylesheet"][href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/#{Asciidoctor::FONT_AWESOME_VERSION}/css/font-awesome.min.css"]), output, 1
       assert_xpath '//*[@class="admonitionblock tip"]//*[@class="icon"]/i[@class="fa icon-tip"]', output, 1
     end
 
@@ -2370,7 +2791,7 @@ puts "AsciiDoc, FTW!"
       EOS
 
       output = render_string input, :safe => Asciidoctor::SafeMode::SAFE
-      assert_css 'html > head > link[rel="stylesheet"][href="http://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css"]', output, 1
+      assert_css %(html > head > link[rel="stylesheet"][href="http://cdnjs.cloudflare.com/ajax/libs/font-awesome/#{Asciidoctor::FONT_AWESOME_VERSION}/css/font-awesome.min.css"]), output, 1
       assert_css 'html > body > script[src="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"]', output, 1
     end
 
@@ -2387,32 +2808,31 @@ puts "AsciiDoc, FTW!"
       EOS
 
       output = render_string input, :safe => Asciidoctor::SafeMode::SAFE
-      assert_css 'html > head > link[rel="stylesheet"][href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css"]', output, 1
+      assert_css %(html > head > link[rel="stylesheet"][href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/#{Asciidoctor::FONT_AWESOME_VERSION}/css/font-awesome.min.css"]), output, 1
       assert_css 'html > body > script[src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"]', output, 1
     end
   end
 
   context 'Image paths' do
-
     test 'restricts access to ancestor directories when safe mode level is at least SAFE' do
       input = <<-EOS
 image::asciidoctor.png[Asciidoctor]
       EOS
-      basedir = File.expand_path File.dirname(__FILE__)
+      basedir = testdir
       block = block_from_string input, :attributes => {'docdir' => basedir}
       doc = block.document
       assert doc.safe >= Asciidoctor::SafeMode::SAFE
 
       assert_equal File.join(basedir, 'images'), block.normalize_asset_path('images')
-      assert_equal File.join(basedir, 'etc/images'), redirect_streams { block.normalize_asset_path("#{disk_root}etc/images") }
-      assert_equal File.join(basedir, 'images'), redirect_streams { block.normalize_asset_path('../../images') }
+      assert_equal File.join(basedir, 'etc/images'), block.normalize_asset_path("#{disk_root}etc/images")
+      assert_equal File.join(basedir, 'images'), block.normalize_asset_path('../../images')
     end
 
     test 'does not restrict access to ancestor directories when safe mode is disabled' do
       input = <<-EOS
 image::asciidoctor.png[Asciidoctor]
       EOS
-      basedir = File.expand_path File.dirname(__FILE__)
+      basedir = testdir
       block = block_from_string input, :safe => Asciidoctor::SafeMode::UNSAFE, :attributes => {'docdir' => basedir}
       doc = block.document
       assert doc.safe == Asciidoctor::SafeMode::UNSAFE
@@ -2686,7 +3106,7 @@ public class Printer {
       assert_match(/\.<em>out<\/em>\./, output, 1)
       assert_match(/\*asterisks\*/, output, 1)
       assert_match(/<strong>bold<\/strong>/, output, 1)
-      refute output.include?(Asciidoctor::Substitutors::PASS_START)
+      refute_includes output, Asciidoctor::Substitutors::PASS_START
     end
 
     test 'should link to CodeRay stylesheet if source-highlighter is coderay and linkcss is set' do
@@ -2780,6 +3200,23 @@ puts HTML::Pipeline.new(filters, {}).cal
       doc = document_from_string input, :safe => Asciidoctor::SafeMode::SERVER
       assert_nil doc.attributes['source-highlighter']
     end
+
+    test 'should warn if listing block is not terminated' do
+      input = <<-EOS
+outside
+
+----
+inside
+
+still inside
+
+eof
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '/*[@class="listingblock"]', output, 1
+      assert_message @logger, :WARN, '<stdin>: line 3: unterminated listing block', Hash
+    end
   end
 
   context 'Abstract and Part Intro' do
@@ -2852,15 +3289,9 @@ Abstract for book with title is valid
 Abstract for book without title is invalid.
       EOS
 
-      warnings = nil
-      output = nil
-      redirect_streams do |stdout, stderr|
-        output = render_string input
-        warnings = stderr.string
-      end
+      output = render_string input
       assert_css '.abstract', output, 0
-      refute_nil warnings
-      assert_match(/WARNING:.*abstract block/, warnings)
+      assert_message @logger, :WARN, 'abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
     end
 
     test 'should make abstract on open block without title rendered to DocBook' do
@@ -2918,15 +3349,9 @@ Abstract for book with title is valid
 Abstract for book is invalid.
       EOS
 
-      output = nil
-      warnings = nil
-      redirect_streams do |stdout, stderr|
-        output = render_string input, :backend => 'docbook'
-        warnings = stderr.string
-      end
+      output = render_string input, :backend => 'docbook'
       assert_css 'abstract', output, 0
-      refute_nil warnings
-      assert_match(/WARNING:.*abstract block/, warnings)
+      assert_message @logger, :WARN, 'abstract block cannot be used in a document without a title when doctype is book. Excluding block content.'
     end
 
     # TODO partintro shouldn't be recognized if doctype is not book, should be in proper place
@@ -2995,9 +3420,9 @@ content
 part intro paragraph
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_string input), err.string] }
+      output = render_string input
       assert_css '.partintro', output, 0
-      assert_includes warnings, 'partintro block can only be used when doctype is book and it\'s a child of a book part'
+      assert_message @logger, :ERROR, 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
     end
 
     test 'should not allow partintro unless doctype is book' do
@@ -3006,9 +3431,9 @@ part intro paragraph
 part intro paragraph
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_string input), err.string] }
+      output = render_string input
       assert_css '.partintro', output, 0
-      assert_includes warnings, 'partintro block can only be used when doctype is book and it\'s a child of a book part'
+      assert_message @logger, :ERROR, 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
     end
 
     test 'should accept partintro on open block without title rendered to DocBook' do
@@ -3070,9 +3495,9 @@ content
 part intro paragraph
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_string input, :backend => 'docbook'), err.string] }
+      output = render_string input, :backend => 'docbook'
       assert_css 'partintro', output, 0
-      assert_includes warnings, 'partintro block can only be used when doctype is book and it\'s a child of a part section'
+      assert_message @logger, :ERROR, 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
     end
 
     test 'should not allow partintro unless doctype is book rendered to DocBook' do
@@ -3081,9 +3506,9 @@ part intro paragraph
 part intro paragraph
       EOS
 
-      output, warnings = redirect_streams {|_, err| [(render_string input, :backend => 'docbook'), err.string] }
+      output = render_string input, :backend => 'docbook'
       assert_css 'partintro', output, 0
-      assert_includes warnings, 'partintro block can only be used when doctype is book and it\'s a child of a part section'
+      assert_message @logger, :ERROR, 'partintro block can only be used when doctype is book and must be a child of a book part. Excluding block content.'
     end
   end
 
@@ -3148,15 +3573,15 @@ content
 
 [subs="attributes+,-verbatim,+specialcharacters,+macros"]
 ....
-http://{application}.org[{gt}{gt}] <1>
+https://{application}.org[{gt}{gt}] <1>
 ....
       EOS
 
       doc = document_from_string input, :header_footer => false
       block = doc.blocks.first
       assert_equal [:attributes, :specialcharacters, :macros], block.subs
-      result = doc.render
-      assert result.include?('<pre><a href="http://asciidoctor.org">&gt;&gt;</a> &lt;1&gt;</pre>')
+      result = doc.convert
+      assert_includes result, '<pre><a href="https://asciidoctor.org">&gt;&gt;</a> &lt;1&gt;</pre>'
     end
 
     test 'should be able to set subs then modify them' do
@@ -3168,8 +3593,8 @@ _hey now_ <1>
       doc = document_from_string input, :header_footer => false
       block = doc.blocks.first
       assert_equal [:specialcharacters], block.subs
-      result = doc.render
-      assert result.include?('_hey now_ &lt;1&gt;')
+      result = doc.convert
+      assert_includes result, '_hey now_ &lt;1&gt;'
     end
   end
 
diff -pruN 1.5.6.2-2/test/converter_test.rb 1.5.7-1/test/converter_test.rb
--- 1.5.6.2-2/test/converter_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/converter_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -9,59 +9,65 @@ context 'Converter' do
 
   context 'View options' do
     test 'should set Haml format to html5 for html5 backend' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Tilt::HamlTemplate
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Tilt::HamlTemplate, selected.templates['paragraph']
       assert_equal :html5, selected.templates['paragraph'].options[:format]
     end
 
     test 'should set Haml format to xhtml for docbook backend' do
-      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Tilt::HamlTemplate
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Tilt::HamlTemplate, selected.templates['paragraph']
       assert_equal :xhtml, selected.templates['paragraph'].options[:format]
     end
 
     test 'should configure Slim to resolve includes in specified template dirs' do
-      template_dirs = [
-        File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'),
-        File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim-overrides'),
-      ]
+      template_dirs = [(fixture_path 'custom-backends/slim'), (fixture_path 'custom-backends/slim-overrides')]
       doc = Asciidoctor::Document.new [], :template_dirs => template_dirs, :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Slim::Template
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Slim::Template, selected.templates['paragraph']
       assert_equal template_dirs.reverse.map {|dir| File.expand_path dir }, selected.templates['paragraph'].options[:include_dirs]
     end
 
+    test 'should coerce template_dirs option to an Array' do
+      template_dirs = fixture_path 'custom-backends/slim'
+      doc = Asciidoctor::Document.new [], :template_dirs => template_dirs, :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
+      selected = doc.converter.find_converter('paragraph')
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Array, (selected.instance_variable_get :@template_dirs)
+    end
+
     test 'should set Slim format to html for html5 backend' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Slim::Template
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Slim::Template, selected.templates['paragraph']
       assert_equal :html, selected.templates['paragraph'].options[:format]
     end
 
     test 'should set Slim format to nil for docbook backend' do
-      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Slim::Template
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Slim::Template, selected.templates['paragraph']
       assert_nil selected.templates['paragraph'].options[:format]
     end
 
     test 'should set safe mode of Slim AsciiDoc engine to match document safe mode when Slim >= 3' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false, :safe => :unsafe
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false, :safe => :unsafe
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
       slim_asciidoc_opts = selected.instance_variable_get(:@engine_options)[:slim][:asciidoc]
       if ::Slim::VERSION >= '3.0'
         assert_equal({ :safe => Asciidoctor::SafeMode::UNSAFE }, slim_asciidoc_opts)
@@ -71,20 +77,20 @@ context 'Converter' do
     end
 
     test 'should support custom template engine options for known engine' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false, :template_engine_options => { :slim => { :pretty => true } }
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false, :template_engine_options => { :slim => { :pretty => true } }
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Slim::Template
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Slim::Template, selected.templates['paragraph']
       assert_equal true, selected.templates['paragraph'].options[:pretty]
     end
 
     test 'should support custom template engine options' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false, :template_engine_options => { :slim => { :pretty => true } }
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false, :template_engine_options => { :slim => { :pretty => true } }
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       selected = doc.converter.find_converter('paragraph')
-      assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-      assert selected.templates['paragraph'].is_a? Slim::Template
+      assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+      assert_kind_of Slim::Template, selected.templates['paragraph']
       assert_equal false, selected.templates['paragraph'].options[:sort_attrs]
       assert_equal true, selected.templates['paragraph'].options[:pretty]
     end
@@ -92,43 +98,43 @@ context 'Converter' do
 
   context 'Custom backends' do
     test 'should load Haml templates for default backend' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph', 'sidebar'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-        assert selected.templates[node_name].is_a? Tilt::HamlTemplate
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+        assert_kind_of Tilt::HamlTemplate, selected.templates[node_name]
         assert_equal %(block_#{node_name}.html.haml), File.basename(selected.templates[node_name].file)
       end
     end
 
     test 'should set outfilesuffix according to backend info' do
       doc = Asciidoctor.load 'content'
-      doc.render
+      doc.convert
       assert_equal '.html', doc.attributes['outfilesuffix']
 
-      doc = Asciidoctor.load 'content', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
-      doc.render
+      doc = Asciidoctor.load 'content', :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
+      doc.convert
       assert_equal '.html', doc.attributes['outfilesuffix']
     end
 
     test 'should not override outfilesuffix attribute if locked' do
       doc = Asciidoctor.load 'content', :attributes => {'outfilesuffix' => '.foo'}
-      doc.render
+      doc.convert
       assert_equal '.foo', doc.attributes['outfilesuffix']
 
-      doc = Asciidoctor.load 'content', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false, :attributes => {'outfilesuffix' => '.foo'}
-      doc.render
+      doc = Asciidoctor.load 'content', :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false, :attributes => {'outfilesuffix' => '.foo'}
+      doc.convert
       assert_equal '.foo', doc.attributes['outfilesuffix']
     end
 
     test 'should load Haml templates for docbook45 backend' do
-      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-        assert selected.templates[node_name].is_a? Tilt::HamlTemplate
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+        assert_kind_of Tilt::HamlTemplate, selected.templates[node_name]
         assert_equal %(block_#{node_name}.xml.haml), File.basename(selected.templates[node_name].file)
       end
     end
@@ -148,7 +154,7 @@ Sidebar content
 ****
       EOS
 
-      output = render_embedded_string input, :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'), :template_cache => false
+      output = render_embedded_string input, :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
       assert_xpath '/*[@class="sect1"]/*[@class="sectionbody"]/p', output, 1
       assert_xpath '//aside', output, 1
       assert_xpath '/*[@class="sect1"]/*[@class="sectionbody"]/p/following-sibling::aside', output, 1
@@ -161,12 +167,12 @@ Sidebar content
         # clear out any cache, just to be sure
         Asciidoctor::Converter::TemplateConverter.clear_caches if defined? Asciidoctor::Converter::TemplateConverter
 
-        template_dir = File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml')
+        template_dir = fixture_path 'custom-backends/haml'
         doc = Asciidoctor::Document.new [], :template_dir => template_dir
         doc.converter
         caches = Asciidoctor::Converter::TemplateConverter.caches
         if defined? ::ThreadSafe::Cache
-          assert caches[:templates].is_a?(::ThreadSafe::Cache)
+          assert_kind_of ::ThreadSafe::Cache, caches[:templates]
           refute_empty caches[:templates]
           paragraph_template_before = caches[:templates].values.find {|t| File.basename(t.file) == 'block_paragraph.html.haml' }
           refute_nil paragraph_template_before
@@ -194,7 +200,7 @@ Sidebar content
     end
 
     test 'should use custom cache to cache templates' do
-      template_dir = File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml')
+      template_dir = fixture_path 'custom-backends/haml'
       Asciidoctor::PathResolver.new.system_path(File.join(template_dir, 'html5', 'block_paragraph.html.haml'), nil)
       caches = { :scans => {}, :templates => {} }
       doc = Asciidoctor::Document.new [], :template_dir => template_dir, :template_cache => caches
@@ -203,7 +209,7 @@ Sidebar content
       refute_empty caches[:templates]
       paragraph_template = caches[:templates].values.find {|t| File.basename(t.file) == 'block_paragraph.html.haml' }
       refute_nil paragraph_template
-      assert paragraph_template.is_a? ::Tilt::HamlTemplate
+      assert_kind_of ::Tilt::HamlTemplate, paragraph_template
     end
 
     test 'should be able to disable template cache' do
@@ -211,8 +217,7 @@ Sidebar content
         # clear out any cache, just to be sure
         Asciidoctor::Converter::TemplateConverter.clear_caches if defined? Asciidoctor::Converter::TemplateConverter
 
-        doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'haml'),
-            :template_cache => false
+        doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/haml'), :template_cache => false
         doc.converter
         caches = Asciidoctor::Converter::TemplateConverter.caches
         assert caches.empty? || caches[:scans].empty?
@@ -224,51 +229,51 @@ Sidebar content
     end
 
     test 'should load ERB templates using ERBTemplate if eruby is not set' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'erb'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/erb'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
         template = selected.templates[node_name]
-        assert template.is_a? Tilt::ERBTemplate
-        refute template.is_a? Tilt::ErubisTemplate
-        assert template.instance_variable_get('@engine').is_a? ::ERB
+        assert_kind_of Tilt::ERBTemplate, template
+        refute_kind_of Tilt::ErubisTemplate, template
+        assert_kind_of ::ERB, template.instance_variable_get('@engine')
         assert_equal %(block_#{node_name}.html.erb), File.basename(selected.templates[node_name].file)
       end
     end
 
     test 'should load ERB templates using ErubisTemplate if eruby is set to erubis' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'erb'), :template_cache => false, :eruby => 'erubis'
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/erb'), :template_cache => false, :eruby => 'erubis'
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
         template = selected.templates[node_name]
-        assert template.is_a? Tilt::ERBTemplate
-        assert template.is_a? Tilt::ErubisTemplate
-        assert template.instance_variable_get('@engine').is_a? ::Erubis::FastEruby
+        assert_kind_of Tilt::ERBTemplate, template
+        assert_kind_of Tilt::ErubisTemplate, template
+        assert_kind_of ::Erubis::FastEruby, template.instance_variable_get('@engine')
         assert_equal %(block_#{node_name}.html.erb), File.basename(selected.templates[node_name].file)
       end
     end
 
     test 'should load Slim templates for default backend' do
-      doc = Asciidoctor::Document.new [], :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph', 'sidebar'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-        assert selected.templates[node_name].is_a? Slim::Template
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+        assert_kind_of Slim::Template, selected.templates[node_name]
         assert_equal %(block_#{node_name}.html.slim), File.basename(selected.templates[node_name].file)
       end
     end
 
     test 'should load Slim templates for docbook45 backend' do
-      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false
-      assert doc.converter.is_a?(Asciidoctor::Converter::CompositeConverter)
+      doc = Asciidoctor::Document.new [], :backend => 'docbook45', :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false
+      assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
       ['paragraph'].each do |node_name|
         selected = doc.converter.find_converter node_name
-        assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-        assert selected.templates[node_name].is_a? Slim::Template
+        assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+        assert_kind_of Slim::Template, selected.templates[node_name]
         assert_equal %(block_#{node_name}.xml.slim), File.basename(selected.templates[node_name].file)
       end
     end
@@ -288,7 +293,7 @@ Sidebar content
 ****
       EOS
 
-      output = render_embedded_string input, :template_dir => File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends', 'slim'), :template_cache => false
+      output = render_embedded_string input, :template_dir => (fixture_path 'custom-backends/slim'), :template_cache => false
       assert_xpath '/*[@class="sect1"]/*[@class="sectionbody"]/p', output, 1
       assert_xpath '//aside', output, 1
       assert_xpath '/*[@class="sect1"]/*[@class="sectionbody"]/p/following-sibling::aside', output, 1
@@ -350,6 +355,93 @@ content
       end
     end
 
+    test 'should map handles? method on converter to respond_to? by default' do
+      class CustomConverterC
+        include Asciidoctor::Converter
+        def paragraph node
+          'paragraph'
+        end
+      end
+
+      converter = CustomConverterC.new 'myhtml'
+      assert_respond_to converter, :handles?
+      assert converter.handles?(:paragraph)
+    end
+
+    test 'should not configure converter to support templates by default' do
+      input = <<-EOS
+paragraph
+      EOS
+
+      begin
+        Asciidoctor::Converter::Factory.unregister_all
+        class CustomConverterD
+          include Asciidoctor::Converter
+          register_for 'myhtml'
+          def convert node, transform = nil, opts = {}
+            transform ||= node.node_name
+            send transform, node
+          end
+
+          def document node
+            ['<!DOCTYPE html>', '<html>', '<body>', node.content, '</body>', '</html>'] * %(\n)
+          end
+
+          def paragraph node
+            ['<div class="paragraph">', %(<p>#{node.content}</p>), '</div>'] * %(\n)
+          end
+        end
+
+        doc = document_from_string input, :backend => 'myhtml', :template_dir => (fixture_path 'custom-backends/slim/html5'), :template_cache => false
+        assert_kind_of CustomConverterD, doc.converter
+        refute doc.converter.supports_templates?
+        output = doc.convert
+        assert_xpath '//*[@class="paragraph"]/p[text()="paragraph"]', output, 1
+      ensure
+        Asciidoctor::Converter::Factory.unregister_all
+      end
+    end
+
+    test 'should wrap converter in composite converter with template converter if it declares that it supports templates' do
+      input = <<-EOS
+paragraph
+      EOS
+
+      begin
+        Asciidoctor::Converter::Factory.unregister_all
+        class CustomConverterE
+          include Asciidoctor::Converter
+          register_for 'myhtml'
+
+          def initialize *args
+            super
+            supports_templates
+          end
+
+          def convert node, transform = nil, opts = {}
+            transform ||= node.node_name
+            send transform, node
+          end
+
+          def document node
+            ['<!DOCTYPE html>', '<html>', '<body>', node.content, '</body>', '</html>'] * %(\n)
+          end
+
+          def paragraph node
+            ['<div class="paragraph">', %(<p>#{node.content}</p>), '</div>'] * %(\n)
+          end
+        end
+
+        doc = document_from_string input, :backend => 'myhtml', :template_dir => (fixture_path 'custom-backends/slim/html5'), :template_cache => false
+        assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
+        output = doc.convert
+        assert_xpath '//*[@class="paragraph"]/p[text()="paragraph"]', output, 0
+        assert_xpath '//body/p[text()="paragraph"]', output, 1
+      ensure
+        Asciidoctor::Converter::Factory.unregister_all
+      end
+    end
+
     test 'should fall back to catch all converter' do
       input = <<-EOS
 content
@@ -358,7 +450,7 @@ content
       begin
         Asciidoctor::Converter::Factory.unregister_all
 
-        class CustomConverterC
+        class CustomConverterF
           include Asciidoctor::Converter
           register_for '*'
           def convert node, name = nil
@@ -367,7 +459,7 @@ content
         end
 
         converters = Asciidoctor::Converter::Factory.converters
-        assert converters['*'] == CustomConverterC
+        assert converters['*'] == CustomConverterF
         output = render_string input, :backend => 'foobaz'
         assert 'foobaz content', output
       ensure
diff -pruN 1.5.6.2-2/test/document_test.rb 1.5.7-1/test/document_test.rb
--- 1.5.6.2-2/test/document_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/document_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -131,718 +131,6 @@ content
     end
   end
 
-  context 'Load APIs' do
-    test 'should load input file' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      doc = File.open(sample_input_path) {|file| Asciidoctor.load file, :safe => Asciidoctor::SafeMode::SAFE }
-      assert_equal 'Document Title', doc.doctitle
-      assert_equal File.expand_path(sample_input_path), doc.attr('docfile')
-      assert_equal File.expand_path(File.dirname(sample_input_path)), doc.attr('docdir')
-      assert_equal '.asciidoc', doc.attr('docfilesuffix')
-    end
-
-    test 'should load input file from filename' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      doc = Asciidoctor.load_file(sample_input_path, :safe => Asciidoctor::SafeMode::SAFE)
-      assert_equal 'Document Title', doc.doctitle
-      assert_equal File.expand_path(sample_input_path), doc.attr('docfile')
-      assert_equal File.expand_path(File.dirname(sample_input_path)), doc.attr('docdir')
-      assert_equal '.asciidoc', doc.attr('docfilesuffix')
-    end
-
-    test 'should not load invalid file' do
-      sample_input_path = fixture_path('hello-asciidoctor.pdf')
-      exception = assert_raises ArgumentError do
-        Asciidoctor.load_file(sample_input_path, :safe => Asciidoctor::SafeMode::SAFE)
-      end
-      assert_match(/Failed to load AsciiDoc document/, exception.message)
-      # verify we have the correct backtrace (should be in at least first 5 lines)
-      assert_match((RUBY_ENGINE == 'rbx' ? /parser\.rb/ : /helpers\.rb/), exception.backtrace[0..4].join("\n"))
-    end if RUBY_MIN_VERSION_1_9
-
-    test 'should load input IO' do
-      input = StringIO.new(<<-EOS)
-Document Title
-==============
-
-preamble
-      EOS
-      doc = Asciidoctor.load(input, :safe => Asciidoctor::SafeMode::SAFE)
-      assert_equal 'Document Title', doc.doctitle
-      refute doc.attr?('docfile')
-      assert_equal doc.base_dir, doc.attr('docdir')
-    end
-
-    test 'should load input string' do
-      input = <<-EOS
-Document Title
-==============
-
-preamble
-      EOS
-      doc = Asciidoctor.load(input, :safe => Asciidoctor::SafeMode::SAFE)
-      assert_equal 'Document Title', doc.doctitle
-      refute doc.attr?('docfile')
-      assert_equal doc.base_dir, doc.attr('docdir')
-    end
-
-    test 'should load input string array' do
-      input = <<-EOS
-Document Title
-==============
-
-preamble
-      EOS
-      doc = Asciidoctor.load(input.lines.entries, :safe => Asciidoctor::SafeMode::SAFE)
-      assert_equal 'Document Title', doc.doctitle
-      refute doc.attr?('docfile')
-      assert_equal doc.base_dir, doc.attr('docdir')
-    end
-
-    test 'should accept attributes as array' do
-	  # NOTE there's a tab character before idseparator
-      doc = Asciidoctor.load('text', :attributes => %w(toc sectnums   source-highlighter=coderay idprefix	idseparator=-))
-      assert_kind_of Hash, doc.attributes
-      assert doc.attr?('toc')
-      assert_equal '', doc.attr('toc')
-      assert doc.attr?('sectnums')
-      assert_equal '', doc.attr('sectnums')
-      assert doc.attr?('source-highlighter')
-      assert_equal 'coderay', doc.attr('source-highlighter')
-      assert doc.attr?('idprefix')
-      assert_equal '', doc.attr('idprefix')
-      assert doc.attr?('idseparator')
-      assert_equal '-', doc.attr('idseparator')
-    end
-
-    test 'should accept attributes as empty array' do
-      doc = Asciidoctor.load('text', :attributes => [])
-      assert_kind_of Hash, doc.attributes
-    end
-
-    test 'should accept attributes as string' do
-      doc = Asciidoctor.load('text', :attributes => 'toc sectnums
-source-highlighter=coderay
-idprefix
-idseparator=-')
-      assert_kind_of Hash, doc.attributes
-      assert doc.attr?('toc')
-      assert_equal '', doc.attr('toc')
-      assert doc.attr?('sectnums')
-      assert_equal '', doc.attr('sectnums')
-      assert doc.attr?('source-highlighter')
-      assert_equal 'coderay', doc.attr('source-highlighter')
-      assert doc.attr?('idprefix')
-      assert_equal '', doc.attr('idprefix')
-      assert doc.attr?('idseparator')
-      assert_equal '-', doc.attr('idseparator')
-    end
-
-    test 'should accept values containing spaces in attributes string' do
-      doc = Asciidoctor.load('text', :attributes => %(idprefix idseparator=-   note-caption=Note\\ to\\\tself toc))
-      assert_kind_of Hash, doc.attributes
-      assert doc.attr?('idprefix')
-      assert_equal '', doc.attr('idprefix')
-      assert doc.attr?('idseparator')
-      assert_equal '-', doc.attr('idseparator')
-      assert doc.attr?('note-caption')
-      assert_equal "Note to\tself", doc.attr('note-caption')
-    end
-
-    test 'should accept attributes as empty string' do
-      doc = Asciidoctor.load('text', :attributes => '')
-      assert_kind_of Hash, doc.attributes
-    end
-
-    test 'should accept attributes as nil' do
-      doc = Asciidoctor.load('text', :attributes => nil)
-      assert_kind_of Hash, doc.attributes
-    end
-
-    test 'should accept attributes if hash like' do
-      class Hashish
-        def initialize
-          @table = {'toc' => ''}
-        end
-
-        def keys
-          @table.keys
-        end
-
-        def [](key)
-          @table[key]
-        end
-      end
-
-      doc = Asciidoctor.load('text', :attributes => Hashish.new)
-      assert_kind_of Hash, doc.attributes
-      assert doc.attributes.has_key?('toc')
-    end
-
-    test 'should output timestamps by default' do
-      doc = document_from_string 'text', :backend => :html5, :attributes => nil
-      result = doc.convert
-      assert doc.attr?('docdate')
-      refute doc.attr? 'reproducible'
-      assert_xpath '//div[@id="footer-text" and contains(string(.//text()), "Last updated")]', result, 1
-    end
-
-    test 'should not output timestamps if reproducible attribute is set in HTML 5' do
-      doc = document_from_string 'text', :backend => :html5, :attributes => { 'reproducible' => '' }
-      result = doc.convert
-      assert doc.attr?('docdate')
-      assert doc.attr?('reproducible')
-      assert_xpath '//div[@id="footer-text" and contains(string(.//text()), "Last updated")]', result, 0
-    end
-
-    test 'should not output timestamps if reproducible attribute is set in DocBook' do
-      doc = document_from_string 'text', :backend => :docbook, :attributes => { 'reproducible' => '' }
-      result = doc.convert
-      assert doc.attr?('docdate')
-      assert doc.attr?('reproducible')
-      assert_xpath '/article/info/date', result, 0
-    end
-
-    test 'should not modify options argument' do
-      options = {
-        :safe => Asciidoctor::SafeMode::SAFE
-      }
-      options.freeze
-      sample_input_path = fixture_path('sample.asciidoc')
-      begin
-        Asciidoctor.load_file sample_input_path, options
-      rescue
-        flunk %(options argument should not be modified)
-      end
-    end
-
-    test 'should not modify attributes Hash argument' do
-      attributes = {}
-      attributes.freeze
-      options = {
-        :safe => Asciidoctor::SafeMode::SAFE,
-        :attributes => attributes
-      }
-      sample_input_path = fixture_path('sample.asciidoc')
-      begin
-        Asciidoctor.load_file sample_input_path, options
-      rescue
-        flunk %(attributes argument should not be modified)
-      end
-    end
-
-    test 'should track file and line information with blocks if sourcemap option is set' do
-      doc = Asciidoctor.load_file fixture_path('sample.asciidoc'), :sourcemap => true
-
-      section_1 = doc.sections[0]
-      assert_equal 'Section A', section_1.title
-      refute_nil section_1.source_location
-      assert_equal 'sample.asciidoc', section_1.file
-      assert_equal 10, section_1.lineno
-
-      section_2 = doc.sections[1]
-      assert_equal 'Section B', section_2.title
-      refute_nil section_2.source_location
-      assert_equal 'sample.asciidoc', section_2.file
-      assert_equal 18, section_2.lineno
-
-      last_block = section_2.blocks[-1]
-      assert_equal :ulist, last_block.context
-      refute_nil last_block.source_location
-      assert_equal 'sample.asciidoc', last_block.file
-      assert_equal 23, last_block.lineno
-
-      doc = Asciidoctor.load_file fixture_path('master.adoc'), :sourcemap => true, :safe => :safe
-
-      section_1 = doc.sections[0]
-      assert_equal 'Chapter A', section_1.title
-      refute_nil section_1.source_location
-      assert_equal fixture_path('chapter-a.adoc'), section_1.file
-      assert_equal 1, section_1.lineno
-    end
-
-    test 'should assign correct source location if section occurs on last line of input' do
-      input = <<-EOS
-= Document Title
-
-== Section A
-
-content
-
-== Section B
-      EOS
-
-      doc = document_from_string input, :sourcemap => true
-      assert_equal [1, 3, 7], (doc.find_by :context => :section).map(&:lineno)
-    end
-
-    test 'should allow sourcemap option on document to be modified' do
-      doc = Asciidoctor.load_file fixture_path('sample.asciidoc'), :parse => false
-      doc.sourcemap = true
-      doc = doc.parse
-
-      section_1 = doc.sections[0]
-      assert_equal 'Section A', section_1.title
-      refute_nil section_1.source_location
-      assert_equal 'sample.asciidoc', section_1.file
-      assert_equal 10, section_1.lineno
-    end
-
-    test 'find_by should return Array of blocks anywhere in document tree that match criteria' do
-      input = <<-EOS
-= Document Title
-
-preamble
-
-== Section A
-
-paragraph
-
---
-Exhibit A::
-+
-[#tiger.animal]
-image::tiger.png[Tiger]
---
-
-image::shoe.png[Shoe]
-
-== Section B
-
-paragraph
-      EOS
-
-      doc = Asciidoctor.load input
-      result = doc.find_by :context => :image
-      assert_equal 2, result.size
-      assert_equal :image, result[0].context
-      assert_equal 'tiger.png', result[0].attr('target')
-      assert_equal :image, result[1].context
-      assert_equal 'shoe.png', result[1].attr('target')
-    end
-
-    test 'find_by should return an empty Array if no matches are found' do
-      input = <<-EOS
-paragraph
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by :context => :section
-      refute_nil result
-      assert_equal 0, result.size
-    end
-
-    test 'find_by should return Array of blocks that match style criteria' do
-      input = <<-EOS
-[square]
-* one
-* two
-* three
-
----
-
-* apples
-* bananas
-* pears
-      EOS
-
-      doc = Asciidoctor.load input
-      result = doc.find_by :context => :ulist, :style => 'square'
-      assert_equal 1, result.size
-      assert_equal :ulist, result[0].context
-    end
-
-    test 'find_by should return Array of blocks that match role criteria' do
-      input = <<-EOS
-[#tiger.animal]
-image::tiger.png[Tiger]
-
-image::shoe.png[Shoe]
-      EOS
-
-      doc = Asciidoctor.load input
-      result = doc.find_by :context => :image, :role => 'animal'
-      assert_equal 1, result.size
-      assert_equal :image, result[0].context
-      assert_equal 'tiger.png', result[0].attr('target')
-    end
-
-    test 'find_by should return the document title section if context selector is :section' do
-      input = <<-EOS
-= Document Title
-
-preamble
-
-== Section One
-
-content
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by :context => :section
-      refute_nil result
-      assert_equal 2, result.size
-      assert_equal :section, result[0].context
-      assert_equal 'Document Title', result[0].title
-    end
-
-    test 'find_by should only return results for which the block argument yields true' do
-      input = <<-EOS
-== Section
-
-content
-
-=== Subsection
-
-content
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by(:context => :section) {|sect| sect.level == 1 }
-      refute_nil result
-      assert_equal 1, result.size
-      assert_equal :section, result[0].context
-      assert_equal 'Section', result[0].title
-    end
-
-    test 'find_by should only return one result when matching by id' do
-      input = <<-EOS
-== Section
-
-content
-
-[#subsection]
-=== Subsection
-
-content
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by(:context => :section, :id => 'subsection')
-      refute_nil result
-      assert_equal 1, result.size
-      assert_equal :section, result[0].context
-      assert_equal 'Subsection', result[0].title
-    end
-
-    test 'find_by should return an empty Array if the id criteria matches but the block argument yields false' do
-      input = <<-EOS
-== Section
-
-content
-
-[#subsection]
-=== Subsection
-
-content
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by(:context => :section, :id => 'subsection') {|sect| false }
-      refute_nil result
-      assert_equal 0, result.size
-    end
-
-    test 'find_by should not crash if dlist entry does not have description' do
-      input = <<-EOS
-term without description::
-      EOS
-      doc = Asciidoctor.load input
-      result = doc.find_by
-      refute_nil result
-      assert_equal 3, result.size
-      assert_kind_of Asciidoctor::Document, result[0]
-      assert_kind_of Asciidoctor::List, result[1]
-      assert_kind_of Asciidoctor::ListItem, result[2]
-    end
-  end
-
-  context 'Convert APIs' do
-    test 'should convert source document to string when to_file is false' do
-      sample_input_path = fixture_path('sample.asciidoc')
-
-      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
-      refute_empty output
-      assert_xpath '/html', output, 1
-      assert_xpath '/html/head', output, 1
-      assert_xpath '/html/body', output, 1
-      assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
-      assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
-    end
-
-    test 'lines in output should be separated by line feed' do
-      sample_input_path = fixture_path('sample.asciidoc')
-
-      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
-      refute_empty output
-      lines = output.split("\n")
-      assert_equal lines.size, output.split(/\r\n|\r|\n/).size
-      raw_lengths = lines.map(&:length)
-      trimmed_lengths = lines.map {|line| line.rstrip.length }
-      assert_equal raw_lengths, trimmed_lengths
-    end
-
-    test 'should accept attributes as array' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      output = Asciidoctor.convert_file sample_input_path, :attributes => %w(sectnums idprefix idseparator=-), :to_file => false
-      assert_css '#section-a', output, 1
-    end
-
-    test 'should accept attributes as string' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      output = Asciidoctor.convert_file sample_input_path, :attributes => 'sectnums idprefix idseparator=-', :to_file => false
-      assert_css '#section-a', output, 1
-    end
-
-    test 'should link to default stylesheet by default when safe mode is SECURE or greater' do
-      sample_input_path = fixture_path('basic.asciidoc')
-      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 1
-    end
-
-    test 'should embed default stylesheet by default if SafeMode is less than SECURE' do
-      input = <<-EOS
-= Document Title
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :safe => Asciidoctor::SafeMode::SERVER, :header_footer => true)
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 0
-      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
-      styles = stylenode.content
-      refute_nil styles
-      refute_empty styles.strip
-    end
-
-    test 'should link to default stylesheet by default even if linkcss is unset in document' do
-      input = <<-EOS
-= Document Title
-:linkcss!:
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :header_footer => true)
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 1
-    end
-
-    test 'should link to default stylesheet by default if linkcss is unset' do
-      input = <<-EOS
-= Document Title
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :header_footer => true, :attributes => {'linkcss!' => ''})
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 1
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./asciidoctor.css"]', output, 1
-    end
-
-    test 'should embed default stylesheet if safe mode is less than secure and linkcss is unset' do
-      sample_input_path = fixture_path('basic.asciidoc')
-      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :to_file => false,
-          :safe => Asciidoctor::SafeMode::SAFE, :attributes => {'linkcss!' => ''}
-      assert_css 'html:root > head > style', output, 1
-      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
-      styles = stylenode.content
-      refute_nil styles
-      refute_empty styles.strip
-    end
-
-    test 'should not link to stylesheet if stylesheet is unset' do
-      input = <<-EOS
-= Document Title
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :header_footer => true, :attributes => {'stylesheet!' => ''})
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 0
-      assert_css 'html:root > head > link[rel="stylesheet"]', output, 0
-    end
-
-    test 'should link to custom stylesheet if specified in stylesheet attribute' do
-      input = <<-EOS
-= Document Title
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :header_footer => true, :attributes => {'stylesheet' => './custom.css'})
-      assert_css 'html:root > head > link[rel="stylesheet"][href^="https://fonts.googleapis.com"]', output, 0
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./custom.css"]', output, 1
-
-      output = Asciidoctor.render(input, :header_footer => true, :attributes => {'stylesheet' => 'file:///home/username/custom.css'})
-      assert_css 'html:root > head > link[rel="stylesheet"][href="file:///home/username/custom.css"]', output, 1
-    end
-
-    test 'should resolve custom stylesheet relative to stylesdir' do
-      input = <<-EOS
-= Document Title
-
-text
-      EOS
-
-      output = Asciidoctor.render(input, :header_footer => true, :attributes => {'stylesheet' => 'custom.css', 'stylesdir' => './stylesheets'})
-      assert_css 'html:root > head > link[rel="stylesheet"][href="./stylesheets/custom.css"]', output, 1
-    end
-
-    test 'should resolve custom stylesheet to embed relative to stylesdir' do
-      sample_input_path = fixture_path('basic.asciidoc')
-      output = Asciidoctor.convert_file sample_input_path, :header_footer => true, :safe => Asciidoctor::SafeMode::SAFE, :to_file => false,
-          :attributes => {'stylesheet' => 'custom.css', 'stylesdir' => './stylesheets', 'linkcss!' => ''}
-      stylenode = xmlnodes_at_css 'html:root > head > style', output, 1
-      styles = stylenode.content
-      refute_nil styles
-      refute_empty styles.strip
-    end
-
-    test 'should convert source file and write result to adjacent file by default' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      sample_output_path = fixture_path('sample.html')
-      begin
-        Asciidoctor.convert_file sample_input_path
-        assert File.exist?(sample_output_path)
-        output = IO.read(sample_output_path)
-        refute_empty output
-        assert_xpath '/html', output, 1
-        assert_xpath '/html/head', output, 1
-        assert_xpath '/html/body', output, 1
-        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
-        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
-      ensure
-        FileUtils.rm(sample_output_path)
-      end
-    end
-
-    test 'should convert source file and write to specified file' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      sample_output_path = fixture_path('result.html')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_file => sample_output_path
-        assert File.exist?(sample_output_path)
-        output = IO.read(sample_output_path)
-        refute_empty output
-        assert_xpath '/html', output, 1
-        assert_xpath '/html/head', output, 1
-        assert_xpath '/html/body', output, 1
-        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
-        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
-      ensure
-        FileUtils.rm(sample_output_path)
-      end
-    end
-
-    test 'should convert source file and write to specified file in base_dir' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      sample_output_path = fixture_path('result.html')
-      fixture_dir = fixture_path('')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_file => 'result.html', :base_dir => fixture_dir
-        assert File.exist?(sample_output_path)
-        output = IO.read(sample_output_path)
-        refute_empty output
-        assert_xpath '/html', output, 1
-        assert_xpath '/html/head', output, 1
-        assert_xpath '/html/body', output, 1
-        assert_xpath '/html/head/title[text() = "Document Title"]', output, 1
-        assert_xpath '/html/body/*[@id="header"]/h1[text() = "Document Title"]', output, 1
-      rescue => e
-        flunk e.message
-      ensure
-        FileUtils.rm(sample_output_path, :force => true)
-      end
-    end
-
-    test 'in_place option is ignored when to_file is specified' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      sample_output_path = fixture_path('result.html')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_file => sample_output_path, :in_place => true
-        assert File.exist?(sample_output_path)
-      ensure
-        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
-      end
-    end
-
-    test 'in_place option is ignored when to_dir is specified' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      sample_output_path = fixture_path('sample.html')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_dir => File.dirname(sample_output_path), :in_place => true
-        assert File.exist?(sample_output_path)
-      ensure
-        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
-      end
-    end
-
-    test 'output should be relative to to_dir option' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      output_dir = File.join(File.dirname(sample_input_path), 'test_output')
-      Dir.mkdir output_dir if !File.exist? output_dir
-      sample_output_path = File.join(output_dir, 'sample.html')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_dir => output_dir
-        assert File.exist? sample_output_path
-      ensure
-        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
-        FileUtils.rmdir output_dir
-      end
-    end
-
-    test 'missing directories should be created if mkdirs is enabled' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      output_dir = File.join(File.join(File.dirname(sample_input_path), 'test_output'), 'subdir')
-      sample_output_path = File.join(output_dir, 'sample.html')
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_dir => output_dir, :mkdirs => true
-        assert File.exist? sample_output_path
-      ensure
-        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
-        FileUtils.rmdir output_dir
-        FileUtils.rmdir File.dirname(output_dir)
-      end
-    end
-
-    # TODO need similar test for when to_dir is specified
-    test 'should raise exception if an attempt is made to overwrite input file' do
-      sample_input_path = fixture_path('sample.asciidoc')
-
-      assert_raises IOError do
-        Asciidoctor.convert_file sample_input_path, :attributes => { 'outfilesuffix' => '.asciidoc' }
-      end
-    end
-
-    test 'to_file should be relative to to_dir when both given' do
-      sample_input_path = fixture_path('sample.asciidoc')
-      base_dir = File.dirname(sample_input_path)
-      sample_rel_output_path = File.join('test_output', 'result.html')
-      output_dir = File.dirname(File.join(base_dir, sample_rel_output_path))
-      Dir.mkdir output_dir if !File.exist? output_dir
-      sample_output_path = File.join(base_dir, sample_rel_output_path)
-      begin
-        Asciidoctor.convert_file sample_input_path, :to_dir => base_dir, :to_file => sample_rel_output_path
-        assert File.exist? sample_output_path
-      ensure
-        FileUtils.rm(sample_output_path) if File.exist? sample_output_path
-        FileUtils.rmdir output_dir
-      end
-    end
-
-    test 'should not modify options argument' do
-      options = {
-        :safe => Asciidoctor::SafeMode::SAFE,
-        :to_file => false
-      }
-      options.freeze
-      sample_input_path = fixture_path('sample.asciidoc')
-      begin
-        Asciidoctor.convert_file sample_input_path, options
-      rescue
-        flunk %(options argument should not be modified)
-      end
-    end
-  end
-
   context 'Docinfo files' do
     test 'should include docinfo files for html backend' do
       sample_input_path = fixture_path('basic.asciidoc')
@@ -1048,18 +336,17 @@ text
 
     test 'should substitute attributes in docinfo files by default' do
       sample_input_path = fixture_path 'subs.adoc'
-      output, warnings = redirect_streams do |_, err|
+      using_memory_logger do |logger|
         output = Asciidoctor.convert_file sample_input_path,
             :to_file => false,
             :header_footer => true,
             :safe => :server,
             :attributes => { 'docinfo' => '', 'bootstrap-version' => nil, 'linkcss' => '', 'attribute-missing' => 'drop-line' }
-        [output, err.string]
+        refute_empty output
+        assert_css 'script', output, 0
+        assert_xpath %(//meta[@name="copyright"][@content="(C) OpenDevise"]), output, 1
+        assert_message logger, :WARN, 'dropping line containing reference to missing attribute: bootstrap-version'
       end
-      refute_empty output
-      assert_css 'script', output, 0
-      assert_xpath %(//meta[@name="copyright"][@content="(C) OpenDevise"]), output, 1
-      assert_includes warnings, 'dropping line containing reference to missing attribute'
     end
 
     test 'should apply explicit substitutions to docinfo files' do
@@ -1134,9 +421,9 @@ text
         '/img/favicon.png' => %w(/img/favicon.png image/png)
       }.each {|val, (href, type)|
         result = render_string %(= Untitled), :attributes => { 'favicon' => val }
-        assert_css 'link[rel="shortcut icon"]', result, 1
-        assert_css %(link[rel="shortcut icon"][href="#{href}"]), result, 1
-        assert_css %(link[rel="shortcut icon"][type="#{type}"]), result, 1
+        assert_css 'link[rel="icon"]', result, 1
+        assert_css %(link[rel="icon"][href="#{href}"]), result, 1
+        assert_css %(link[rel="icon"][type="#{type}"]), result, 1
       }
     end
   end
@@ -1302,7 +589,25 @@ Block content
      assert doc.has_header?
      assert_equal 'Document Title', doc.header.title
      assert_equal 'Document Title', doc.first_section.title
-     assert_xpath '//*[@id="preamble"]//p[text()="Document Title"]', doc.render, 1
+     assert_xpath '//*[@id="preamble"]//p[text()="Document Title"]', doc.convert, 1
+    end
+
+    test 'document with blank title attribute entry overrides doctitle' do
+     input = <<-EOS
+= Document Title
+:title:
+
+{doctitle}
+
+== First Section
+     EOS
+     doc = document_from_string input
+     assert_equal '', doc.doctitle
+     assert_equal '', doc.title
+     assert doc.has_header?
+     assert_equal 'Document Title', doc.header.title
+     assert_equal 'Document Title', doc.first_section.title
+     assert_xpath '//*[@id="preamble"]//p[text()="Document Title"]', doc.convert, 1
     end
 
     test 'document with title attribute entry overrides doctitle attribute entry' do
@@ -1322,7 +627,7 @@ Block content
      assert doc.has_header?
      assert_equal 'doctitle', doc.header.title
      assert_equal 'doctitle', doc.first_section.title
-     assert_xpath '//*[@id="preamble"]//p[text()="Document Title, doctitle"]', doc.render, 1
+     assert_xpath '//*[@id="preamble"]//p[text()="Document Title, doctitle"]', doc.convert, 1
     end
 
     test 'document with doctitle attribute entry overrides header title and doctitle' do
@@ -1337,11 +642,11 @@ Block content
      EOS
      doc = document_from_string input
      assert_equal 'Override', doc.doctitle
-     assert_nil doc.title
+     assert_nil doc.attributes['title']
      assert doc.has_header?
      assert_equal 'Override', doc.header.title
      assert_equal 'Override', doc.first_section.title
-     assert_xpath '//*[@id="preamble"]//p[text()="Document Title, Override"]', doc.render, 1
+     assert_xpath '//*[@id="preamble"]//p[text()="Document Title, Override"]', doc.convert, 1
     end
 
     test 'doctitle attribute entry above header overrides header title and doctitle' do
@@ -1355,11 +660,11 @@ Block content
      EOS
      doc = document_from_string input
      assert_equal 'Override', doc.doctitle
-     assert_nil doc.title
+     assert_nil doc.attributes['title']
      assert doc.has_header?
      assert_equal 'Override', doc.header.title
      assert_equal 'Override', doc.first_section.title
-     assert_xpath '//*[@id="preamble"]//p[text()="Override"]', doc.render, 1
+     assert_xpath '//*[@id="preamble"]//p[text()="Override"]', doc.convert, 1
     end
 
     test 'should recognize document title when preceded by blank lines' do
@@ -1568,6 +873,18 @@ content
       assert_xpath '//meta[@name="author"][@content="Ze Product team"]', output, 1
     end
 
+    test 'should not double escape ampersand in author attribute' do
+      input = <<-EOS
+= Document Title
+R&D Lab
+
+{author}
+      EOS
+
+      output = render_string input
+      assert_includes output, 'R&amp;D Lab', 2
+    end
+
     test 'should include multiple authors in HTML output' do
       input = <<-EOS
 = Document Title
@@ -1605,6 +922,19 @@ content
       assert_xpath '//articleinfo/authorgroup/author[2]/firstname[text() = "Junior"]', output, 1
     end
 
+    test 'with author defined by indexed attribute name' do
+      input = <<-EOS
+= Document Title
+:author_1: Doc Writer
+
+{author}
+      EOS
+
+      doc = document_from_string input
+      assert_equal 'Doc Writer', (doc.attr 'author')
+      assert_equal 'Doc Writer', (doc.attr 'author_1')
+    end
+
     test 'with authors defined using attribute entry to DocBook' do
       input = <<-EOS
 = Document Title
@@ -1625,10 +955,50 @@ content
       assert_xpath '(//articleinfo/authorgroup/author)[2]/email[text() = "junior@asciidoc.org"]', output, 1
     end
 
+    test 'should populate copyright element in DocBook output if copyright attribute is defined' do
+      input = <<-EOS
+= Jet Bike
+:copyright: ACME, Inc.
+
+Essential for catching road runners.
+      EOS
+      output = render_string input, :backend => 'docbook5'
+      assert_xpath '/article/info/copyright', output, 1
+      assert_xpath '/article/info/copyright/holder[text()="ACME, Inc."]', output, 1
+    end
+
+    test 'should populate copyright element in DocBook output if copyright attribute is defined with year' do
+      input = <<-EOS
+= Jet Bike
+:copyright: ACME, Inc. 1956
+
+Essential for catching road runners.
+      EOS
+      output = render_string input, :backend => 'docbook5'
+      assert_xpath '/article/info/copyright', output, 1
+      assert_xpath '/article/info/copyright/holder[text()="ACME, Inc."]', output, 1
+      assert_xpath '/article/info/copyright/year', output, 1
+      assert_xpath '/article/info/copyright/year[text()="1956"]', output, 1
+    end
+
+    test 'should populate copyright element in DocBook output if copyright attribute is defined with year range' do
+      input = <<-EOS
+= Jet Bike
+:copyright: ACME, Inc. 1956-2018
+
+Essential for catching road runners.
+      EOS
+      output = render_string input, :backend => 'docbook5'
+      assert_xpath '/article/info/copyright', output, 1
+      assert_xpath '/article/info/copyright/holder[text()="ACME, Inc."]', output, 1
+      assert_xpath '/article/info/copyright/year', output, 1
+      assert_xpath '/article/info/copyright/year[text()="1956-2018"]', output, 1
+    end
+
     test 'with header footer' do
       doc = document_from_string "= Title\n\nparagraph"
       refute doc.attr?('embedded')
-      result = doc.render
+      result = doc.convert
       assert_xpath '/html', result, 1
       assert_xpath '//*[@id="header"]', result, 1
       assert_xpath '//*[@id="header"]/h1', result, 1
@@ -1649,7 +1019,7 @@ content
 
     test 'can disable last updated in footer' do
       doc = document_from_string "= Document Title\n\npreamble", :attributes => {'last-update-label!' => ''}
-      result = doc.render
+      result = doc.convert
       assert_xpath '//*[@id="footer-text"]', result, 1
       assert_xpath '//*[@id="footer-text"][normalize-space(text())=""]', result, 1
     end
@@ -1657,7 +1027,7 @@ content
     test 'no header footer' do
       doc = document_from_string "= Document Title\n\ncontent", :header_footer => false
       assert doc.attr?('embedded')
-      result = doc.render
+      result = doc.convert
       assert_xpath '/html', result, 0
       assert_xpath '/h1', result, 0
       assert_xpath '/*[@id="header"]', result, 0
@@ -1726,13 +1096,13 @@ finally a reference to the second footno
       output = render_string input
       assert_css '#footnotes', output, 1
       assert_css '#footnotes .footnote', output, 2
-      assert_css '#footnotes .footnote#_footnote_1', output, 1
-      assert_xpath '//div[@id="footnotes"]/div[@id="_footnote_1"]/a[@href="#_footnoteref_1"][text()="1"]', output, 1
-      text = xmlnodes_at_xpath '//div[@id="footnotes"]/div[@id="_footnote_1"]/text()', output
+      assert_css '#footnotes .footnote#_footnotedef_1', output, 1
+      assert_xpath '//div[@id="footnotes"]/div[@id="_footnotedef_1"]/a[@href="#_footnoteref_1"][text()="1"]', output, 1
+      text = xmlnodes_at_xpath '//div[@id="footnotes"]/div[@id="_footnotedef_1"]/text()', output
       assert_equal '. An example footnote.', text.text.strip
-      assert_css '#footnotes .footnote#_footnote_2', output, 1
-      assert_xpath '//div[@id="footnotes"]/div[@id="_footnote_2"]/a[@href="#_footnoteref_2"][text()="2"]', output, 1
-      text = xmlnodes_at_xpath '//div[@id="footnotes"]/div[@id="_footnote_2"]/text()', output
+      assert_css '#footnotes .footnote#_footnotedef_2', output, 1
+      assert_xpath '//div[@id="footnotes"]/div[@id="_footnotedef_2"]/a[@href="#_footnoteref_2"][text()="2"]', output, 1
+      text = xmlnodes_at_xpath '//div[@id="footnotes"]/div[@id="_footnotedef_2"]/text()', output
       assert_equal '. Second footnote.', text.text.strip
     end
 
@@ -1744,9 +1114,9 @@ Text that has supporting information{emp
       output = render_embedded_string input
       assert_css '#footnotes', output, 1
       assert_css '#footnotes .footnote', output, 1
-      assert_css '#footnotes .footnote#_footnote_1', output, 1
-      assert_xpath '/div[@id="footnotes"]/div[@id="_footnote_1"]/a[@href="#_footnoteref_1"][text()="1"]', output, 1
-      text = xmlnodes_at_xpath '/div[@id="footnotes"]/div[@id="_footnote_1"]/text()', output
+      assert_css '#footnotes .footnote#_footnotedef_1', output, 1
+      assert_xpath '/div[@id="footnotes"]/div[@id="_footnotedef_1"]/a[@href="#_footnoteref_1"][text()="1"]', output, 1
+      text = xmlnodes_at_xpath '/div[@id="footnotes"]/div[@id="_footnotedef_1"]/text()', output
       assert_equal '. An example footnote.', text.text.strip
     end
 
@@ -1776,12 +1146,29 @@ content{blank}footnote:[commentary]
 
       doc = document_from_string input
       refute_nil doc.catalog
-      assert_equal [:footnotes, :ids, :images, :includes, :indexterms, :links, :refs].to_set, doc.catalog.keys.to_set
+      assert_equal [:footnotes, :ids, :images, :includes, :indexterms, :links, :refs, :callouts].to_set, doc.catalog.keys.to_set
       assert_same doc.catalog, doc.references
       assert_same doc.catalog[:footnotes], doc.references[:footnotes]
       assert_same doc.catalog[:ids], doc.references[:ids]
       assert_equal 'Section A', doc.references[:ids]['_section_a']
     end
+
+    test 'should catalog assets inside nested document' do
+      input = <<-EOS
+image::outer.png[]
+
+|===
+a|
+image::inner.png[]
+|===
+      EOS
+
+      doc = document_from_string input, :catalog_assets => true
+      images = doc.catalog[:images]
+      refute_empty images
+      assert_equal 2, images.size
+      assert_equal images, ['outer.png', 'inner.png']
+    end
   end
 
   context 'Backends and Doctypes' do
@@ -1861,6 +1248,7 @@ content
 Author Name
 v1.0, 2001-01-01
 :icons:
+:favicon:
 
 image:tiger.png[]
 
@@ -2057,6 +1445,8 @@ section body
     test 'docbook5 backend doctype manpage' do
       input = <<-EOS
 = asciidoctor(1)
+:mansource: Asciidoctor
+:manmanual: Asciidoctor Manual
 
 == NAME
 
@@ -2079,6 +1469,8 @@ section body
       assert_xpath '/xmlns:refentry/xmlns:info/xmlns:title[text() = "asciidoctor(1)"]', result, 1
       assert_xpath '/xmlns:refentry/xmlns:refmeta/xmlns:refentrytitle[text() = "asciidoctor"]', result, 1
       assert_xpath '/xmlns:refentry/xmlns:refmeta/xmlns:manvolnum[text() = "1"]', result, 1
+      assert_xpath '/xmlns:refentry/xmlns:refmeta/xmlns:refmiscinfo[@class="source"][text() = "Asciidoctor"]', result, 1
+      assert_xpath '/xmlns:refentry/xmlns:refmeta/xmlns:refmiscinfo[@class="manual"][text() = "Asciidoctor Manual"]', result, 1
       assert_xpath '/xmlns:refentry/xmlns:refnamediv/xmlns:refname[text() = "asciidoctor"]', result, 1
       assert_xpath '/xmlns:refentry/xmlns:refnamediv/xmlns:refpurpose[text() = "Process text"]', result, 1
       assert_xpath '/xmlns:refentry/xmlns:refsynopsisdiv', result, 1
@@ -2093,6 +1485,23 @@ section body
       assert_equal '_first_section', id_attr.value
     end
 
+    test 'should output non-breaking space for source and manual in docbook5 manpage output if absent from source' do
+      input = <<-EOS
+= asciidoctor(1)
+
+== NAME
+
+asciidoctor - Process text
+
+== SYNOPSIS
+
+some text
+      EOS
+      result = render_string(input, :keep_namespaces => true, :attributes => {'backend' => 'docbook5', 'doctype' => 'manpage'})
+      assert_xpath %(/xmlns:refentry/xmlns:refmeta/xmlns:refmiscinfo[@class="source"][text() = "#{decode_char 160}"]), result, 1
+      assert_xpath %(/xmlns:refentry/xmlns:refmeta/xmlns:refmiscinfo[@class="manual"][text() = "#{decode_char 160}"]), result, 1
+    end
+
     test 'docbook5 backend doctype book' do
       input = <<-EOS
 = Title
@@ -2122,6 +1531,30 @@ chapter body
       assert_equal '_first_chapter', id_attr.value
     end
 
+    test 'adds refname to DocBook output for each name defined in NAME section of manpage' do
+      input = <<-EOS
+= eve(1)
+Andrew Stanton
+v1.0.0
+:doctype: manpage
+:manmanual: EVE
+:mansource: EVE
+
+== NAME
+
+eve, islifeform - analyzes an image to determine if it's a picture of a life form
+
+== SYNOPSIS
+
+*eve* ['OPTION']... 'FILE'...
+      EOS
+
+      result = render_string input, :backend => 'docbook5'
+      assert_xpath '/refentry/refnamediv/refname', result, 2
+      assert_xpath '(/refentry/refnamediv/refname)[1][text()="eve"]', result, 1
+      assert_xpath '(/refentry/refnamediv/refname)[2][text()="islifeform"]', result, 1
+    end
+
     test 'adds a front and back cover image to DocBook 5 when doctype is book' do
       input = <<-EOS
 = Title
@@ -2214,24 +1647,24 @@ preamble
 asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats
       EOS
 
-       doc = document_from_string input
-       assert_equal 'asciidoctor', doc.attr('mantitle')
-       assert_equal '1', doc.attr('manvolnum')
+      doc = document_from_string input
+      assert_equal 'asciidoctor', doc.attr('mantitle')
+      assert_equal '1', doc.attr('manvolnum')
     end
 
     test 'should perform attribute substitution on mantitle in manpage doctype' do
       input = <<-EOS
 = {app}(1)
 :doctype: manpage
-:app: asciidoctor
+:app: Asciidoctor
 
 == NAME
 
 asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats
       EOS
 
-       doc = document_from_string input
-       assert_equal 'asciidoctor', doc.attr('mantitle')
+      doc = document_from_string input
+      assert_equal 'asciidoctor', doc.attr('mantitle')
     end
 
     test 'should consume name section as manname and manpurpose for manpage doctype' do
@@ -2244,10 +1677,11 @@ asciidoctor - converts AsciiDoc source f
 asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats
       EOS
 
-       doc = document_from_string input
-       assert_equal 'asciidoctor', doc.attr('manname')
-       assert_equal 'converts AsciiDoc source files to HTML, DocBook and other formats', doc.attr('manpurpose')
-       assert_equal 0, doc.blocks.size
+      doc = document_from_string input
+      assert_equal 'asciidoctor', doc.attr('manname')
+      assert_equal 'converts AsciiDoc source files to HTML, DocBook and other formats', doc.attr('manpurpose')
+      assert_equal '_name', doc.attr('manname-id')
+      assert_equal 0, doc.blocks.size
     end
 
     test 'should set docname and outfilesuffix from manname and manvolnum for manpage backend and doctype' do
@@ -2260,9 +1694,9 @@ asciidoctor - converts AsciiDoc source f
 asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats
       EOS
 
-       doc = document_from_string input, :backend => 'manpage'
-       assert_equal 'asciidoctor', doc.attributes['docname']
-       assert_equal '.1', doc.attributes['outfilesuffix']
+      doc = document_from_string input, :backend => 'manpage'
+      assert_equal 'asciidoctor', doc.attributes['docname']
+      assert_equal '.1', doc.attributes['outfilesuffix']
     end
 
     test 'should mark synopsis as special section in manpage doctype' do
@@ -2279,12 +1713,12 @@ asciidoctor - converts AsciiDoc source f
 *asciidoctor* ['OPTION']... 'FILE'..
       EOS
 
-       doc = document_from_string input
-       synopsis_section = doc.blocks.first
-       refute_nil synopsis_section
-       assert_equal :section, synopsis_section.context
-       assert synopsis_section.special
-       assert_equal 'synopsis', synopsis_section.sectname
+      doc = document_from_string input
+      synopsis_section = doc.blocks.first
+      refute_nil synopsis_section
+      assert_equal :section, synopsis_section.context
+      assert synopsis_section.special
+      assert_equal 'synopsis', synopsis_section.sectname
     end
 
     test 'should output special header block in HTML for manpage doctype' do
@@ -2305,6 +1739,7 @@ asciidoctor - converts AsciiDoc source f
       assert_css 'body.manpage', output, 1
       assert_xpath '//body/*[@id="header"]/h1[text()="asciidoctor(1) Manual Page"]', output, 1
       assert_xpath '//body/*[@id="header"]/h1/following-sibling::h2[text()="NAME"]', output, 1
+      assert_xpath '//h2[@id="_name"][text()="NAME"]', output, 1
       assert_xpath '//h2[text()="NAME"]/following-sibling::*[@class="sectionbody"]', output, 1
       assert_xpath '//h2[text()="NAME"]/following-sibling::*[@class="sectionbody"]/p[text()="asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats"]', output, 1
       assert_xpath '//*[@id="content"]/*[@class="sect1"]/h2[text()="SYNOPSIS"]', output, 1
@@ -2328,6 +1763,7 @@ asciidoctor - converts AsciiDoc source f
       output = render_embedded_string input
       assert_xpath '/h1[text()="asciidoctor(1) Manual Page"]', output, 1
       assert_xpath '/h1/following-sibling::h2[text()="NAME"]', output, 1
+      assert_xpath '/h2[@id="_name"][text()="NAME"]', output, 1
       assert_xpath '/h2[text()="NAME"]/following-sibling::*[@class="sectionbody"]', output, 1
       assert_xpath '/h2[text()="NAME"]/following-sibling::*[@class="sectionbody"]/p[text()="asciidoctor - converts AsciiDoc source files to HTML, DocBook and other formats"]', output, 1
     end
@@ -2342,18 +1778,23 @@ asciidoctor - converts AsciiDoc source f
 
     test 'keeps naughty absolute paths from getting outside' do
       naughty_path = "#{disk_root}etc/passwd"
-      doc = empty_document
-      secure_path = doc.normalize_asset_path(naughty_path)
-      refute_equal naughty_path, secure_path
-      assert_match(/^#{doc.base_dir}/, secure_path)
+      using_memory_logger do |logger|
+        doc = empty_document
+        secure_path = doc.normalize_asset_path naughty_path
+        refute_equal naughty_path, secure_path
+        assert_equal (::File.join doc.base_dir, 'etc/passwd'), secure_path
+        assert_message logger, :WARN, 'path is outside of jail; recovering automatically'
+      end
     end
 
     test 'keeps naughty relative paths from getting outside' do
       naughty_path = 'safe/ok/../../../../../etc/passwd'
-      doc = empty_document
-      secure_path = redirect_streams { doc.normalize_asset_path(naughty_path) }
-      refute_equal naughty_path, secure_path
-      assert_match(/^#{doc.base_dir}/, secure_path)
+      using_memory_logger do
+        doc = empty_document
+        secure_path = doc.normalize_asset_path naughty_path
+        refute_equal naughty_path, secure_path
+        assert_match(/^#{doc.base_dir}/, secure_path)
+      end
     end
 
     test 'should raise an exception when a converter cannot be resolved before conversion' do
diff -pruN 1.5.6.2-2/test/extensions_test.rb 1.5.7-1/test/extensions_test.rb
--- 1.5.6.2-2/test/extensions_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/extensions_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -10,14 +10,17 @@ class ExtensionsInitTest < Minitest::Tes
     refute doc.extensions?, 'Extensions should not be enabled by default'
 
     begin
-      # NOTE trigger extensions to autoload
-      Asciidoctor::Extensions.groups
+      # NOTE trigger extensions to autoload by registering empty group
+      Asciidoctor::Extensions.register do
+      end
     rescue; end
 
     doc = empty_document
     assert doc.extensions?, 'Extensions should be enabled after being autoloaded'
 
     self.class.remove_tests self.class
+  ensure
+    Asciidoctor::Extensions.unregister_all
   end
   self
 end.new(nil).test_autoload
@@ -200,6 +203,12 @@ end
 
 context 'Extensions' do
   context 'Register' do
+    test 'should not activate registry if no extension groups are registered' do
+      assert defined? Asciidoctor::Extensions
+      doc = empty_document
+      refute doc.extensions?, 'Extensions should not be enabled if not groups are registered'
+    end
+
     test 'should register extension group class' do
       begin
         Asciidoctor::Extensions.register :sample, SampleExtensionGroup
@@ -238,7 +247,7 @@ context 'Extensions' do
         Asciidoctor::Extensions.register :sample, SampleExtensionGroup.new
         refute_nil Asciidoctor::Extensions.groups
         assert_equal 1, Asciidoctor::Extensions.groups.size
-        assert Asciidoctor::Extensions.groups[:sample].is_a? SampleExtensionGroup
+        assert_kind_of SampleExtensionGroup, Asciidoctor::Extensions.groups[:sample]
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -250,7 +259,7 @@ context 'Extensions' do
         end
         refute_nil Asciidoctor::Extensions.groups
         assert_equal 1, Asciidoctor::Extensions.groups.size
-        assert Asciidoctor::Extensions.groups[:sample].is_a? Proc
+        assert_kind_of Proc, Asciidoctor::Extensions.groups[:sample]
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -331,6 +340,24 @@ context 'Extensions' do
       end
     end
 
+    test 'should raise exception if constant name is invalid' do
+      begin
+        Asciidoctor::Extensions.class_for_name 'foobar'
+        flunk 'Expecting RuntimeError to be raised'
+      rescue NameError => e
+        assert_equal 'Could not resolve class for name: foobar', e.message
+      end
+    end
+
+    test 'should raise exception if class not found in scope' do
+      begin
+        Asciidoctor::Extensions.class_for_name 'Asciidoctor::Extensions::String'
+        flunk 'Expecting RuntimeError to be raised'
+      rescue NameError => e
+        assert_equal 'Could not resolve class for name: Asciidoctor::Extensions::String', e.message
+      end
+    end
+
     test 'should raise exception if name resolves to module' do
       begin
         Asciidoctor::Extensions.class_for_name 'Asciidoctor::Extensions'
@@ -352,6 +379,29 @@ context 'Extensions' do
       assert_equal Asciidoctor::Document, clazz
     end
 
+    test 'should not resolve class if not in scope' do
+      begin
+        Asciidoctor::Extensions.resolve_class 'Asciidoctor::Extensions::String'
+        flunk 'Expecting RuntimeError to be raised'
+      rescue NameError => e
+        assert_equal 'Could not resolve class for name: Asciidoctor::Extensions::String', e.message
+      end
+    end
+
+    test 'should raise NameError if extension class cannot be resolved from string' do
+      begin
+        Asciidoctor::Extensions.register do
+          block 'foobar'
+        end
+        empty_document
+        flunk 'Expecting RuntimeError to be raised'
+      rescue NameError => e
+        assert_equal 'Could not resolve class for name: foobar', e.message
+      ensure
+        Asciidoctor::Extensions.unregister_all
+      end
+    end
+
     test 'should allow standalone registry to be created but not registered' do
       registry = Asciidoctor::Extensions.create 'sample' do
         block do
@@ -407,7 +457,7 @@ context 'Extensions' do
         SampleExtensionGroup.register
         doc = Asciidoctor::Document.new
         assert doc.extensions?
-        assert doc.extensions.is_a? Asciidoctor::Extensions::Registry
+        assert_kind_of Asciidoctor::Extensions::Registry, doc.extensions
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -423,9 +473,9 @@ context 'Extensions' do
       assert registry.preprocessors?
       extensions = registry.preprocessors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extensions.first.instance.is_a? SamplePreprocessor
-      assert extensions.first.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
+      assert_kind_of SamplePreprocessor, extensions.first.instance
+      assert_kind_of Method, extensions.first.process_method
     end
 
     test 'should instantiate include processors' do
@@ -435,9 +485,9 @@ context 'Extensions' do
       assert registry.include_processors?
       extensions = registry.include_processors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extensions.first.instance.is_a? SampleIncludeProcessor
-      assert extensions.first.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
+      assert_kind_of SampleIncludeProcessor, extensions.first.instance
+      assert_kind_of Method, extensions.first.process_method
     end
 
     test 'should instantiate docinfo processors' do
@@ -448,9 +498,9 @@ context 'Extensions' do
       assert registry.docinfo_processors?(:head)
       extensions = registry.docinfo_processors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extensions.first.instance.is_a? SampleDocinfoProcessor
-      assert extensions.first.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
+      assert_kind_of SampleDocinfoProcessor, extensions.first.instance
+      assert_kind_of Method, extensions.first.process_method
     end
 
     # NOTE intentionally using the legacy names
@@ -461,9 +511,9 @@ context 'Extensions' do
       assert registry.treeprocessors?
       extensions = registry.treeprocessors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extensions.first.instance.is_a? SampleTreeprocessor
-      assert extensions.first.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
+      assert_kind_of SampleTreeprocessor, extensions.first.instance
+      assert_kind_of Method, extensions.first.process_method
     end
 
     test 'should instantiate postprocessors' do
@@ -473,9 +523,9 @@ context 'Extensions' do
       assert registry.postprocessors?
       extensions = registry.postprocessors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extensions.first.instance.is_a? SamplePostprocessor
-      assert extensions.first.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
+      assert_kind_of SamplePostprocessor, extensions.first.instance
+      assert_kind_of Method, extensions.first.process_method
     end
 
     test 'should instantiate block processor' do
@@ -485,9 +535,9 @@ context 'Extensions' do
       assert registry.blocks?
       assert registry.registered_for_block? :sample, :paragraph
       extension = registry.find_block_extension :sample
-      assert extension.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extension.instance.is_a? SampleBlock
-      assert extension.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extension
+      assert_kind_of SampleBlock, extension.instance
+      assert_kind_of Method, extension.process_method
     end
 
     test 'should not match block processor for unsupported context' do
@@ -504,9 +554,9 @@ context 'Extensions' do
       assert registry.block_macros?
       assert registry.registered_for_block_macro? 'sample'
       extension = registry.find_block_macro_extension 'sample'
-      assert extension.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extension.instance.is_a? SampleBlockMacro
-      assert extension.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extension
+      assert_kind_of SampleBlockMacro, extension.instance
+      assert_kind_of Method, extension.process_method
     end
 
     test 'should instantiate inline macro processor' do
@@ -516,9 +566,9 @@ context 'Extensions' do
       assert registry.inline_macros?
       assert registry.registered_for_inline_macro? 'sample'
       extension = registry.find_inline_macro_extension 'sample'
-      assert extension.is_a? Asciidoctor::Extensions::ProcessorExtension
-      assert extension.instance.is_a? SampleInlineMacro
-      assert extension.process_method.is_a? ::Method
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extension
+      assert_kind_of SampleInlineMacro, extension.instance
+      assert_kind_of Method, extension.process_method
     end
 
     test 'should allow processors to be registered by a string name' do
@@ -528,12 +578,12 @@ context 'Extensions' do
       assert registry.preprocessors?
       extensions = registry.preprocessors
       assert_equal 1, extensions.size
-      assert extensions.first.is_a? Asciidoctor::Extensions::ProcessorExtension
+      assert_kind_of Asciidoctor::Extensions::ProcessorExtension, extensions.first
     end
   end
 
   context 'Integration' do
-    test 'can provide extension registry as option' do
+    test 'can provide extension registry as an option' do
       registry = Asciidoctor::Extensions.create do
         tree_processor SampleTreeProcessor
       end
@@ -546,6 +596,19 @@ context 'Extensions' do
       assert_equal 0, Asciidoctor::Extensions.groups.size
     end
 
+    # NOTE I'm not convinced we want to continue to support this use case
+    test 'can provide extension registry created without any groups as option' do
+      registry = Asciidoctor::Extensions.create
+      registry.tree_processor SampleTreeProcessor
+
+      doc = document_from_string %(= Document Title\n\ncontent), :extension_registry => registry
+      refute_nil doc.extensions
+      assert_equal 0, doc.extensions.groups.size
+      assert doc.extensions.tree_processors?
+      assert_equal 1, doc.extensions.tree_processors.size
+      assert_equal 0, Asciidoctor::Extensions.groups.size
+    end
+
     test 'can provide extensions proc as option' do
       doc = document_from_string %(= Document Title\n\ncontent), :extensions => proc {
         tree_processor SampleTreeProcessor
@@ -597,9 +660,9 @@ after
 
         result = render_string input, :safe => :server
         assert_css '.paragraph > p', result, 3
-        assert result.include?('before')
-        assert result.include?('Lorem ipsum')
-        assert result.include?('after')
+        assert_includes result, 'before'
+        assert_includes result, 'Lorem ipsum'
+        assert_includes result, 'after'
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -614,19 +677,21 @@ include::include-file.asciidoc[]
 last line
       EOS
 
-      # Safe Mode is not required here
-      document = empty_document :base_dir => File.expand_path(File.dirname(__FILE__))
-      document.extensions.include_processor do
-        handles? do |target|
-          target == 'include-file.asciidoc'
-        end
+      registry = Asciidoctor::Extensions.create do
+        include_processor do
+          handles? do |target|
+            target == 'include-file.asciidoc'
+          end
 
-        process do |doc, reader, target, attributes|
-          # demonstrate that push_include normalizes endlines
-          content = ["include target:: #{target}\n", "\n", "middle line\n"]
-          reader.push_include content, target, target, 1, attributes
+          process do |doc, reader, target, attributes|
+            # demonstrate that push_include normalizes endlines
+            content = ["include target:: #{target}\n", "\n", "middle line\n"]
+            reader.push_include content, target, target, 1, attributes
+          end
         end
       end
+      # Safe Mode is not required here
+      document = empty_document :base_dir => testdir, :extension_registry => registry
       reader = Asciidoctor::PreprocessorReader.new document, input, nil, :normalize => true
       lines = []
       lines << reader.read_line
@@ -662,6 +727,25 @@ content
       end
     end
 
+    test 'should set source_location on document before invoking tree processors' do
+      begin
+        Asciidoctor::Extensions.register do
+          tree_processor do
+            process do |doc|
+              para = create_paragraph doc.blocks.last.parent, %(file: #{doc.file}, lineno: #{doc.lineno}), {}
+              doc << para
+            end
+          end
+        end
+
+        sample_doc = fixture_path 'sample.asciidoc'
+        doc = Asciidoctor.load_file sample_doc, :sourcemap => true
+        assert_includes doc.convert, 'file: sample.asciidoc, lineno: 1'
+      ensure
+        Asciidoctor::Extensions.unregister_all
+      end
+    end
+
     test 'should allow tree processor to replace tree' do
       input = <<-EOS
 = Original Document
@@ -751,6 +835,28 @@ Hi there!
       end
     end
 
+    test 'should invoke processor for custom block in an AsciiDoc table cell' do
+      input = <<-EOS
+|===
+a|
+[yell]
+Hi there!
+|===
+      EOS
+
+      begin
+        Asciidoctor::Extensions.register do
+          block UppercaseBlock
+        end
+
+        output = render_embedded_string input
+        assert_xpath '/table//p', output, 1
+        assert_xpath '/table//p[text()="HI THERE!"]', output, 1
+      ensure
+        Asciidoctor::Extensions.unregister_all
+      end
+    end
+
     test 'should pass cloaked context in attributes passed to process method of custom block' do
       input = <<-EOS
 [custom]
@@ -789,7 +895,30 @@ snippet::12345[mode=edit]
         end
 
         output = render_embedded_string input
-        assert output.include?('<script src="http://example.com/12345.js?_mode=edit"></script>')
+        assert_includes output, '<script src="http://example.com/12345.js?_mode=edit"></script>'
+      ensure
+        Asciidoctor::Extensions.unregister_all
+      end
+    end
+
+    test 'should invoke processor for custom block macro in an AsciiDoc table cell' do
+      input = <<-EOS
+|===
+a|message::hi[]
+|===
+      EOS
+
+      begin
+        Asciidoctor::Extensions.register do
+          block_macro :message do
+            process do |parent, target, attrs|
+              create_paragraph parent, target.upcase, {}
+            end
+          end
+        end
+
+        output = render_embedded_string input
+        assert_xpath '/table//p[text()="HI"]', output, 1
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -828,10 +957,10 @@ custom_toc::[]
         end
 
         output = render_embedded_string 'Room temperature is deg:25[C,precision=0].', :attributes => { 'temperature-unit' => 'F' }
-        assert output.include?('Room temperature is 25 &#176;C.')
+        assert_includes output, 'Room temperature is 25 &#176;C.'
 
         output = render_embedded_string 'Normal body temperature is deg:37[].', :attributes => { 'temperature-unit' => 'F' }
-        assert output.include?('Normal body temperature is 98.6 &#176;F.')
+        assert_includes output, 'Normal body temperature is 98.6 &#176;F.'
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -851,7 +980,7 @@ custom_toc::[]
         end
 
         output = render_embedded_string 'label:[Checkbox]'
-        assert output.include?('<label>Checkbox</label>')
+        assert_includes output, '<label>Checkbox</label>'
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -952,7 +1081,7 @@ target="target", attributes=[]
         end
 
         output = render_embedded_string 'mention:mojavelinux[Dan]'
-        assert output.include?('<a href="https://github.com/mojavelinux">Dan</a>')
+        assert_includes output, '<a href="https://github.com/mojavelinux">Dan</a>'
       ensure
         Asciidoctor::Extensions.unregister_all
       end
@@ -1094,6 +1223,7 @@ content
             process do |parent, target, attrs|
               opts = (level = attrs.delete 'level') ? { :level => level.to_i } : {}
               attrs['id'] = false if attrs['id'] == 'false'
+              parent = parent.parent if parent.context == :preamble
               sect = create_section parent, 'Section Title', attrs, opts
               nil
             end
@@ -1111,20 +1241,26 @@ sect::[%s]
         {
           ''                       => ['chapter',  1, false, true, '_section_title'],
           'level=0'                => ['part',     0, false, false, '_section_title'],
+          'level=0,alt'            => ['part',     0, false, true, '_section_title', { 'partnums' => '' }],
           'level=0,style=appendix' => ['appendix', 1, true,  true, '_section_title'],
           'style=appendix'         => ['appendix', 1, true,  true, '_section_title'],
           'style=glossary'         => ['glossary', 1, true,  false, '_section_title'],
+          'style=glossary,alt'     => ['glossary', 1, true,  :chapter, '_section_title', { 'sectnums' => 'all' }],
           'style=abstract'         => ['chapter',  1, false, true, '_section_title'],
           'id=section-title'       => ['chapter',  1, false, true, 'section-title'],
           'id=false'               => ['chapter',  1, false, true, nil]
-        }.each do |attrlist, (expect_sectname, expect_level, expect_special, expect_numbered, expect_id)|
+        }.each do |attrlist, (expect_sectname, expect_level, expect_special, expect_numbered, expect_id, extra_attrs)|
           input = input_tpl % attrlist
-          document_from_string input, :safe => :server
+          document_from_string input, :safe => :server, :attributes => extra_attrs
           assert_equal expect_sectname, sect.sectname
           assert_equal expect_level, sect.level
           assert_equal expect_special, sect.special
           assert_equal expect_numbered, sect.numbered
-          assert_equal expect_id, sect.id
+          if expect_id
+            assert_equal expect_id, sect.id
+          else
+            assert_nil sect.id
+          end
         end
       ensure
         Asciidoctor::Extensions.unregister_all
@@ -1150,7 +1286,6 @@ sample content
       end
     end
 
-
     test 'should add multiple docinfo to document' do
       input = <<-EOS
 = Document Title
diff -pruN 1.5.6.2-2/test/fixtures/custom-backends/slim/html5/block_paragraph.html.slim 1.5.7-1/test/fixtures/custom-backends/slim/html5/block_paragraph.html.slim
--- 1.5.6.2-2/test/fixtures/custom-backends/slim/html5/block_paragraph.html.slim	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/fixtures/custom-backends/slim/html5/block_paragraph.html.slim	2018-05-05 22:54:38.000000000 +0000
@@ -1,3 +1,3 @@
 - if title?
   .title=title
-p id=@id class=(attr 'role') =content
+p id=id class="#{role}" =content
diff -pruN 1.5.6.2-2/test/fixtures/custom-backends/slim/html5/block_sidebar.html.slim 1.5.7-1/test/fixtures/custom-backends/slim/html5/block_sidebar.html.slim
--- 1.5.6.2-2/test/fixtures/custom-backends/slim/html5/block_sidebar.html.slim	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/fixtures/custom-backends/slim/html5/block_sidebar.html.slim	2018-05-05 22:54:38.000000000 +0000
@@ -1,4 +1,4 @@
-aside id=@id class=(attr 'role')
+aside id=id class="#{role}"
   - if title?
     header
       h1=title
diff -pruN 1.5.6.2-2/test/fixtures/file-with-missing-include.adoc 1.5.7-1/test/fixtures/file-with-missing-include.adoc
--- 1.5.6.2-2/test/fixtures/file-with-missing-include.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/file-with-missing-include.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1 @@
+include::no-such-file.adoc[]
diff -pruN 1.5.6.2-2/test/fixtures/include-file.jsx 1.5.7-1/test/fixtures/include-file.jsx
--- 1.5.6.2-2/test/fixtures/include-file.jsx	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/include-file.jsx	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,8 @@
+const element = (
+  <div>
+    <h1>Hello, Programmer!</h1>
+    <!-- tag::snippet[] -->
+    <p>Welcome to the club.</p>
+    <!-- end::snippet[] -->
+  </div>
+)
diff -pruN 1.5.6.2-2/test/fixtures/lists.adoc 1.5.7-1/test/fixtures/lists.adoc
--- 1.5.6.2-2/test/fixtures/lists.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/lists.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,96 @@
+= Document Title
+Doc Writer <thedoc@asciidoctor.org>
+
+Preamble paragraph.
+
+NOTE: This is test, only a test.
+
+== Lists
+
+.Unordered, basic
+* Edgar Allen Poe
+* Sheri S. Tepper
+* Bill Bryson
+
+.Unordered, max nesting
+* level 1
+** level 2
+*** level 3
+**** level 4
+***** level 5
+* level 1
+
+.Checklist
+- [*] checked
+- [x] also checked
+- [ ] not checked
+-     normal list item
+
+.Ordered, basic
+. Step 1
+. Step 2
+. Step 3
+
+.Ordered, nested
+. Step 1
+. Step 2
+.. Step 2a
+.. Step 2b
+. Step 3
+
+.Ordered, max nesting
+. level 1
+.. level 2
+... level 3
+.... level 4
+..... level 5
+. level 1
+
+.Labeled, single-line
+first term:: definition of first term
+section term:: definition of second term
+
+.Labeled, multi-line
+first term::
+definition of first term
+second term::
+definition of second term
+
+.Q&A
+[qanda]
+What is Asciidoctor?::
+  An implementation of the AsciiDoc processor in Ruby.
+What is the answer to the Ultimate Question?:: 42
+
+.Mixed
+Operating Systems::
+  Linux:::
+    . Fedora
+      * Desktop
+    . Ubuntu
+      * Desktop
+      * Server
+  BSD:::
+    . FreeBSD
+    . NetBSD
+
+Cloud Providers::
+  PaaS:::
+    . OpenShift
+    . CloudBees
+  IaaS:::
+    . Amazon EC2
+    . Rackspace
+
+.Unordered, complex
+* level 1
+** level 2
+*** level 3
+This is a new line inside an unordered list using {plus} symbol.
+We can even force content to start on a separate line... +
+Amazing, isn't it?
+**** level 4
++
+The {plus} symbol is on a new line.
+
+***** level 5
diff -pruN 1.5.6.2-2/test/fixtures/other-chapters.adoc 1.5.7-1/test/fixtures/other-chapters.adoc
--- 1.5.6.2-2/test/fixtures/other-chapters.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/other-chapters.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,11 @@
+// tag::ch2[]
+[#ch2]
+== Chapter 2
+
+The plot thickens.
+// end::ch2[]
+
+[#ch3]
+== Chapter 3
+
+The plot runs its course, predictably.
diff -pruN 1.5.6.2-2/test/fixtures/outer-include.adoc 1.5.7-1/test/fixtures/outer-include.adoc
--- 1.5.6.2-2/test/fixtures/outer-include.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/outer-include.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,5 @@
+first line of outer
+
+include::subdir/middle-include.adoc[]
+
+last line of outer
diff -pruN 1.5.6.2-2/test/fixtures/sample.asciidoc 1.5.7-1/test/fixtures/sample.asciidoc
--- 1.5.6.2-2/test/fixtures/sample.asciidoc	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/fixtures/sample.asciidoc	2018-05-05 22:54:38.000000000 +0000
@@ -19,8 +19,12 @@ NOTE: This is test, only a test.
 
 *Section B* paragraph.
 
+|===
+|a |b |c
+|1 |2 |3
+|===
+
 .Section B list
 * Item 1
 * Item 2
 * Item 3
-
diff -pruN 1.5.6.2-2/test/fixtures/subdir/index.adoc 1.5.7-1/test/fixtures/subdir/index.adoc
--- 1.5.6.2-2/test/fixtures/subdir/index.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/subdir/index.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,3 @@
+= Sample Document
+
+content
diff -pruN 1.5.6.2-2/test/fixtures/subdir/inner-include.adoc 1.5.7-1/test/fixtures/subdir/inner-include.adoc
--- 1.5.6.2-2/test/fixtures/subdir/inner-include.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/subdir/inner-include.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,3 @@
+first line of inner
+
+last line of inner
diff -pruN 1.5.6.2-2/test/fixtures/subdir/middle-include.adoc 1.5.7-1/test/fixtures/subdir/middle-include.adoc
--- 1.5.6.2-2/test/fixtures/subdir/middle-include.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/subdir/middle-include.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,5 @@
+first line of middle
+
+include::inner-include.adoc[]
+
+last line of middle
diff -pruN 1.5.6.2-2/test/fixtures/tagged-class-enclosed.rb 1.5.7-1/test/fixtures/tagged-class-enclosed.rb
--- 1.5.6.2-2/test/fixtures/tagged-class-enclosed.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/fixtures/tagged-class-enclosed.rb	2018-05-05 22:54:38.000000000 +0000
@@ -17,7 +17,6 @@ class Dog
       'woof woof'
     #end::bark-other[]
     #tag::bark-all[]
-    #tag::bark-all[]
     end
     #end::bark-all[]
   end
diff -pruN 1.5.6.2-2/test/fixtures/unclosed-tag.adoc 1.5.7-1/test/fixtures/unclosed-tag.adoc
--- 1.5.6.2-2/test/fixtures/unclosed-tag.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/unclosed-tag.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,3 @@
+x
+// tag::a[]
+a
diff -pruN 1.5.6.2-2/test/fixtures/unexpected-end-tag.adoc 1.5.7-1/test/fixtures/unexpected-end-tag.adoc
--- 1.5.6.2-2/test/fixtures/unexpected-end-tag.adoc	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/fixtures/unexpected-end-tag.adoc	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,4 @@
+// tag::a[]
+a
+// end::a[]
+// end::a[]
diff -pruN 1.5.6.2-2/test/invoker_test.rb 1.5.7-1/test/invoker_test.rb
--- 1.5.6.2-2/test/invoker_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/invoker_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -33,8 +33,8 @@ context 'Invoker' do
   end
 
   test 'should set implicit doc info attributes' do
-    sample_filepath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.asciidoc'))
-    sample_filedir = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures'))
+    sample_filepath = fixture_path 'sample.asciidoc'
+    sample_filedir = fixturedir
     invoker = invoke_cli_to_buffer %w(-o /dev/null), sample_filepath
     doc = invoker.document
     assert_equal 'sample', doc.attr('docname')
@@ -48,7 +48,7 @@ context 'Invoker' do
   end
 
   test 'should allow docdate and doctime to be overridden' do
-    sample_filepath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.asciidoc'))
+    sample_filepath = fixture_path 'sample.asciidoc'
     invoker = invoke_cli_to_buffer %w(-o /dev/null -a docdate=2015-01-01 -a doctime=10:00:00-07:00), sample_filepath
     doc = invoker.document
     assert doc.attr?('docdate', '2015-01-01')
@@ -86,7 +86,7 @@ context 'Invoker' do
   end
 
   test 'should accept document from stdin and write to output file' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample-output.html'))
+    sample_outpath = fixture_path 'sample-output.html'
     begin
       invoker = invoke_cli(%W(-s -o #{sample_outpath}), '-') { 'content' }
       doc = invoker.document
@@ -111,13 +111,13 @@ context 'Invoker' do
   end
 
   test 'should fail if input file matches specified output file' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.asciidoc'))
+    sample_outpath = fixture_path 'sample.asciidoc'
     invoker = invoke_cli_to_buffer %W(-o #{sample_outpath}), 'sample.asciidoc'
     assert_match(/input file and output file cannot be the same/, invoker.read_error)
   end
 
   test 'should accept input from named pipe and output to stdout' do
-    sample_inpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample-pipe.adoc'))
+    sample_inpath = fixture_path 'sample-pipe.adoc'
     begin
       %x(mkfifo #{sample_inpath})
       write_thread = Thread.new do
@@ -133,7 +133,7 @@ context 'Invoker' do
   end if RUBY_MIN_VERSION_1_9 && !windows?
 
   test 'should allow docdir to be specified when input is a string' do
-    expected_docdir = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures'))
+    expected_docdir = fixturedir
     invoker = invoke_cli_to_buffer(%w(-s --base-dir test/fixtures -o /dev/null), '-') { 'content' }
     doc = invoker.document
     assert_equal expected_docdir, doc.attr('docdir')
@@ -141,7 +141,7 @@ context 'Invoker' do
   end
 
   test 'should display version and exit' do
-    expected = %(Asciidoctor #{Asciidoctor::VERSION} [http://asciidoctor.org]\nRuntime Environment (#{RUBY_DESCRIPTION}))
+    expected = %(Asciidoctor #{Asciidoctor::VERSION} [https://asciidoctor.org]\nRuntime Environment (#{RUBY_DESCRIPTION}))
     ['--version', '-V'].each do |switch|
       actual = nil
       redirect_streams do |out, err|
@@ -179,6 +179,18 @@ context 'Invoker' do
     assert_equal '', warnings
   end
 
+  test 'should return non-zero exit code if failure level is reached' do
+    input = <<-EOS
+2. second
+3. third
+    EOS
+    exit_code, messages = redirect_streams do |_, err|
+      [invoke_cli(%w(-q --failure-level=WARN -o /dev/null), '-') { input }.code, err.string]
+    end
+    assert_equal 1, exit_code
+    assert messages.empty?
+  end
+
   test 'should report usage if no input file given' do
     redirect_streams do |out, err|
       invoke_cli [], nil
@@ -189,7 +201,7 @@ context 'Invoker' do
   test 'should report error if input file does not exist' do
     redirect_streams do |out, err|
       invoker = invoke_cli [], 'missing_file.asciidoc'
-      assert_match(/input file .* missing or cannot be read/, err.string)
+      assert_match(/input file .* is missing/, err.string)
       assert_equal 1, invoker.code
     end
   end
@@ -197,13 +209,13 @@ context 'Invoker' do
   test 'should treat extra arguments as files' do
     redirect_streams do |out, err|
       invoker = invoke_cli %w(-o /dev/null extra arguments sample.asciidoc), nil
-      assert_match(/input file .* missing or cannot be read/, err.string)
+      assert_match(/input file .* is missing/, err.string)
       assert_equal 1, invoker.code
     end
   end
 
   test 'should output to file name based on input file name' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.html'))
+    sample_outpath = fixture_path 'sample.html'
     begin
       invoker = invoke_cli
       doc = invoker.document
@@ -222,8 +234,8 @@ context 'Invoker' do
   end
 
   test 'should output to file in destination directory if set' do
-    destination_path = File.expand_path(File.join(File.dirname(__FILE__), 'test_output'))
-    sample_outpath = File.join(destination_path, 'sample.html')
+    destination_path = File.join testdir, 'test_output'
+    sample_outpath = File.join destination_path, 'sample.html'
     begin
       FileUtils.mkdir_p(destination_path)
       # QUESTION should -D be relative to working directory or source directory?
@@ -238,8 +250,25 @@ context 'Invoker' do
     end
   end
 
+  test 'should preserve directory structure in destination directory if source directory is set' do
+    sample_inpath = 'subdir/index.adoc'
+    destination_path = 'test_output'
+    destination_subdir_path = File.join destination_path, 'subdir'
+    sample_outpath = File.join destination_subdir_path, 'index.html'
+    begin
+      FileUtils.mkdir_p(destination_path)
+      invoke_cli %W(-D #{destination_path} -R test/fixtures), sample_inpath
+      assert File.directory?(destination_subdir_path)
+      assert File.exist?(sample_outpath)
+    ensure
+      FileUtils.rm_f(sample_outpath)
+      FileUtils.rmdir(destination_subdir_path)
+      FileUtils.rmdir(destination_path)
+    end
+  end
+
   test 'should output to file specified' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample-output.html'))
+    sample_outpath = fixture_path 'sample-output.html'
     begin
       invoker = invoke_cli %W(-o #{sample_outpath})
       doc = invoker.document
@@ -251,9 +280,9 @@ context 'Invoker' do
   end
 
   test 'should copy default stylesheet to target directory if linkcss is specified' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample-output.html'))
-    asciidoctor_stylesheet = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'asciidoctor.css'))
-    coderay_stylesheet = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'coderay-asciidoctor.css'))
+    sample_outpath = fixture_path 'sample-output.html'
+    asciidoctor_stylesheet = fixture_path 'asciidoctor.css'
+    coderay_stylesheet = fixture_path 'coderay-asciidoctor.css'
     begin
       invoker = invoke_cli %W(-o #{sample_outpath} -a linkcss -a source-highlighter=coderay)
       invoker.document
@@ -268,8 +297,8 @@ context 'Invoker' do
   end
 
   test 'should not copy default stylesheet to target directory if linkcss is set and copycss is unset' do
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample-output.html'))
-    default_stylesheet = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'asciidoctor.css'))
+    sample_outpath = fixture_path 'sample-output.html'
+    default_stylesheet = fixture_path 'asciidoctor.css'
     begin
       invoker = invoke_cli %W(-o #{sample_outpath} -a linkcss -a copycss!)
       invoker.document
@@ -282,7 +311,7 @@ context 'Invoker' do
   end
 
   test 'should copy custom stylesheet to target directory if stylesheet and linkcss is specified' do
-    destdir = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'output'))
+    destdir = fixture_path 'output'
     sample_outpath = File.join destdir, 'sample-output.html'
     stylesdir = File.join destdir, 'styles'
     custom_stylesheet = File.join stylesdir, 'custom.css'
@@ -300,7 +329,7 @@ context 'Invoker' do
   end
 
   test 'should not copy custom stylesheet to target directory if stylesheet and linkcss are set and copycss is unset' do
-    destdir = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'output'))
+    destdir = fixture_path 'output'
     sample_outpath = File.join destdir, 'sample-output.html'
     stylesdir = File.join destdir, 'styles'
     custom_stylesheet = File.join stylesdir, 'custom.css'
@@ -318,7 +347,7 @@ context 'Invoker' do
   end
 
   test 'should not copy custom stylesheet to target directory if stylesdir is a URI' do
-    destdir = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'output'))
+    destdir = fixture_path 'output'
     sample_outpath = File.join destdir, 'sample-output.html'
     stylesdir = File.join destdir, 'http:'
     begin
@@ -334,8 +363,8 @@ context 'Invoker' do
   end
 
   test 'should render all passed files' do
-    basic_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'basic.html'))
-    sample_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.html'))
+    basic_outpath = fixture_path 'basic.html'
+    sample_outpath = fixture_path 'sample.html'
     begin
       invoke_cli_with_filenames [], %w(basic.asciidoc sample.asciidoc)
       assert File.exist?(basic_outpath)
@@ -347,9 +376,9 @@ context 'Invoker' do
   end
 
   test 'options should not be modified when processing multiple files' do
-    destination_path = File.expand_path(File.join(File.dirname(__FILE__), 'test_output'))
-    basic_outpath = File.join(destination_path, 'basic.htm')
-    sample_outpath = File.join(destination_path, 'sample.htm')
+    destination_path = File.join testdir, 'test_output'
+    basic_outpath = File.join destination_path, 'basic.htm'
+    sample_outpath = File.join destination_path, 'sample.htm'
     begin
       invoke_cli_with_filenames %w(-D test/test_output -a outfilesuffix=.htm), %w(basic.asciidoc sample.asciidoc)
       assert File.exist?(basic_outpath)
@@ -362,7 +391,7 @@ context 'Invoker' do
   end
 
   test 'should render all files that matches a glob expression' do
-    basic_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'basic.html'))
+    basic_outpath = fixture_path 'basic.html'
     begin
       invoke_cli_to_buffer [], "ba*.asciidoc"
       assert File.exist?(basic_outpath)
@@ -372,8 +401,8 @@ context 'Invoker' do
   end
 
   test 'should render all files that matches an absolute path glob expression' do
-    basic_outpath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'basic.html'))
-    glob = File.join(File.expand_path(File.dirname(__FILE__)), 'fixtures', 'ba*.asciidoc')
+    basic_outpath = fixture_path 'basic.html'
+    glob = fixture_path 'ba*.asciidoc'
     # test Windows using backslash-style pathname
     if File::ALT_SEPARATOR == '\\'
       glob = glob.tr '/', '\\'
@@ -394,6 +423,38 @@ context 'Invoker' do
     assert_xpath '/*[@id="preamble"]', output, 1
   end
 
+  test 'should write page for each alternate manname' do
+    outdir = fixturedir
+    outfile_1 = File.join outdir, 'eve.1'
+    outfile_2 = File.join outdir, 'islifeform.1'
+    input = <<-EOS
+= eve(1)
+Andrew Stanton
+v1.0.0
+:doctype: manpage
+:manmanual: EVE
+:mansource: EVE
+
+== NAME
+
+eve, islifeform - analyzes an image to determine if it's a picture of a life form
+
+== SYNOPSIS
+
+*eve* ['OPTION']... 'FILE'...
+    EOS
+
+    begin
+      invoke_cli(%W(-b manpage -o #{outfile_1}), '-') { input }
+      assert File.exist?(outfile_1)
+      assert File.exist?(outfile_2)
+      assert_equal '.so eve.1', (IO.read outfile_2).chomp
+    ensure
+      FileUtils.rm_f outfile_1
+      FileUtils.rm_f outfile_2
+    end
+  end
+
   test 'should output a trailing endline to stdout' do
     invoker = nil
     output = nil
@@ -467,18 +528,18 @@ context 'Invoker' do
   end
 
   test 'should locate custom templates based on template dir, template engine and backend' do
-    custom_backend_root = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends'))
+    custom_backend_root = fixture_path 'custom-backends'
     invoker = invoke_cli_to_buffer %W(-E haml -T #{custom_backend_root} -o -)
     doc = invoker.document
-    assert doc.converter.is_a? Asciidoctor::Converter::CompositeConverter
+    assert_kind_of Asciidoctor::Converter::CompositeConverter, doc.converter
     selected = doc.converter.find_converter 'paragraph'
-    assert selected.is_a? Asciidoctor::Converter::TemplateConverter
-    assert selected.templates['paragraph'].is_a? Tilt::HamlTemplate
+    assert_kind_of Asciidoctor::Converter::TemplateConverter, selected
+    assert_kind_of Tilt::HamlTemplate, selected.templates['paragraph']
   end
 
   test 'should load custom templates from multiple template directories' do
-    custom_backend_1 = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends/haml/html5'))
-    custom_backend_2 = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'custom-backends/haml/html5-tweaks'))
+    custom_backend_1 = fixture_path 'custom-backends/haml/html5'
+    custom_backend_2 = fixture_path 'custom-backends/haml/html5-tweaks'
     invoker = invoke_cli_to_buffer %W(-T #{custom_backend_1} -T #{custom_backend_2} -o - -s)
     output = invoker.read_output
     assert_css '.paragraph', output, 0
@@ -568,7 +629,7 @@ context 'Invoker' do
   end
 
   test 'should force default external encoding to UTF-8' do
-    executable = File.expand_path(File.join(File.dirname(__FILE__), '..', 'bin', 'asciidoctor'))
+    executable = File.join ASCIIDOCTOR_PROJECT_DIR, 'bin', 'asciidoctor'
     input_path = fixture_path 'encoding.asciidoc'
     old_lang = ENV['LANG']
     ENV['LANG'] = 'US-ASCII'
@@ -586,7 +647,7 @@ context 'Invoker' do
       refute_empty stdout_lines
       stdout_lines.each {|l| l.force_encoding Encoding::UTF_8 } if Asciidoctor::FORCE_ENCODING
       stdout_str = stdout_lines.join
-      assert stdout_str.include?('Codierungen sind verrückt auf älteren Versionen von Ruby')
+      assert_includes stdout_str, 'Codierungen sind verrückt auf älteren Versionen von Ruby'
     ensure
       ENV['LANG'] = old_lang
     end
@@ -611,7 +672,7 @@ context 'Invoker' do
     old_source_date_epoch = ENV.delete 'SOURCE_DATE_EPOCH'
     begin
       ENV['SOURCE_DATE_EPOCH'] = '1234123412'
-      sample_filepath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.asciidoc'))
+      sample_filepath = fixture_path 'sample.asciidoc'
       invoker = invoke_cli_to_buffer %w(-o /dev/null), sample_filepath
       doc = invoker.document
       assert_equal '2009-02-08', (doc.attr 'docdate')
@@ -633,7 +694,7 @@ context 'Invoker' do
     old_source_date_epoch = ENV.delete 'SOURCE_DATE_EPOCH'
     begin
       ENV['SOURCE_DATE_EPOCH'] = 'aaaaaaaa'
-      sample_filepath = File.expand_path(File.join(File.dirname(__FILE__), 'fixtures', 'sample.asciidoc'))
+      sample_filepath = fixture_path 'sample.asciidoc'
       assert_equal 1, (invoke_cli_to_buffer %w(-o /dev/null), sample_filepath).code
     ensure
       if old_source_date_epoch
diff -pruN 1.5.6.2-2/test/links_test.rb 1.5.7-1/test/links_test.rb
--- 1.5.6.2-2/test/links_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/links_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -11,7 +11,7 @@ context 'Links' do
   end
 
   test 'qualified url with role inline with text' do
-    assert_xpath "//a[@href='http://asciidoc.org'][@class='bare project'][text() = 'http://asciidoc.org']", render_string("The AsciiDoc project is located at http://asciidoc.org[,role=project].", :attributes => {'linkattrs' => ''})
+    assert_xpath "//a[@href='http://asciidoc.org'][@class='bare project'][text() = 'http://asciidoc.org']", render_string("The AsciiDoc project is located at http://asciidoc.org[role=project].")
   end
 
   test 'qualified http url inline with hide-uri-scheme set' do
@@ -43,7 +43,7 @@ context 'Links' do
   end
 
   test 'qualified url with role using link macro' do
-    assert_xpath "//a[@href='http://asciidoc.org'][@class='bare project'][text() = 'http://asciidoc.org']", render_string("We're parsing link:http://asciidoc.org[,role=project] markup", :attributes => {'linkattrs' => ''})
+    assert_xpath "//a[@href='http://asciidoc.org'][@class='bare project'][text() = 'http://asciidoc.org']", render_string("We're parsing link:http://asciidoc.org[role=project] markup")
   end
 
   test 'qualified url using macro syntax with multi-line label inline with text' do
@@ -82,37 +82,57 @@ context 'Links' do
   end
 
   test 'qualified url with trailing round bracket' do
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', render_string('Asciidoctor is a Ruby-based AsciiDoc processor (see http://asciidoctor.org)'), 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', render_string('Asciidoctor is a Ruby-based AsciiDoc processor (see https://asciidoctor.org)'), 1
   end
 
   test 'qualified url with trailing semi-colon' do
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', render_string('http://asciidoctor.org; where text gets parsed'), 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', render_string('https://asciidoctor.org; where text gets parsed'), 1
   end
 
   test 'qualified url with trailing colon' do
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', render_string('http://asciidoctor.org: where text gets parsed'), 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', render_string('https://asciidoctor.org: where text gets parsed'), 1
   end
 
   test 'qualified url in round brackets with trailing colon' do
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', render_string('(http://asciidoctor.org): where text gets parsed'), 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', render_string('(https://asciidoctor.org): where text gets parsed'), 1
   end
 
   test 'qualified url with trailing round bracket followed by colon' do
-    result = render_embedded_string '(from http://asciidoctor.org): where text gets parsed'
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', result, 1
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]/preceding-sibling::text()[.="(from "]', result, 1
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]/following-sibling::text()[.="): where text gets parsed"]', result, 1
+    result = render_embedded_string '(from https://asciidoctor.org): where text gets parsed'
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', result, 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]/preceding-sibling::text()[.="(from "]', result, 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]/following-sibling::text()[.="): where text gets parsed"]', result, 1
   end
 
   test 'qualified url in round brackets with trailing semi-colon' do
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', render_string('(http://asciidoctor.org); where text gets parsed'), 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', render_string('(https://asciidoctor.org); where text gets parsed'), 1
   end
 
   test 'qualified url with trailing round bracket followed by semi-colon' do
-    result = render_embedded_string '(from http://asciidoctor.org); where text gets parsed'
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]', result, 1
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]/preceding-sibling::text()[.="(from "]', result, 1
-    assert_xpath '//a[@href="http://asciidoctor.org"][text()="http://asciidoctor.org"]/following-sibling::text()[.="); where text gets parsed"]', result, 1
+    result = render_embedded_string '(from https://asciidoctor.org); where text gets parsed'
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]', result, 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]/preceding-sibling::text()[.="(from "]', result, 1
+    assert_xpath '//a[@href="https://asciidoctor.org"][text()="https://asciidoctor.org"]/following-sibling::text()[.="); where text gets parsed"]', result, 1
+  end
+
+  test 'URI scheme with trailing characters should not be converted to a link' do
+    input_sources = %w(
+      (https://)
+      http://;
+      file://:
+      <ftp://>
+    )
+    expected_outputs = %w(
+      (https://)
+      http://;
+      file://:
+      &lt;ftp://&gt;
+    )
+    input_sources.each_with_index do |input_source, i|
+      expected_output = expected_outputs[i]
+      actual = block_from_string input_source
+      assert_equal expected_output, actual.content
+    end
   end
 
   test 'qualified url containing round brackets' do
@@ -176,26 +196,35 @@ context 'Links' do
     assert_xpath '//a[@href="https://github.com/asciidoctor"]', render_string('Asciidoctor GitHub organization: <**https://github.com/asciidoctor**>'), 1
   end
 
-  test 'link with quoted text should not be separated into attributes when linkattrs is set' do
-    assert_xpath '//a[@href="http://search.example.com"][text()="Google, Yahoo, Bing = Search Engines"]', render_embedded_string('http://search.example.com["Google, Yahoo, Bing = Search Engines"]', :attributes => {'linkattrs' => ''}), 1
+  test 'link with quoted text should not be separated into attributes when text contains an equal sign' do
+    assert_xpath '//a[@href="http://search.example.com"][text()="Google, Yahoo, Bing = Search Engines"]', render_embedded_string('http://search.example.com["Google, Yahoo, Bing = Search Engines"]'), 1
+  end
+
+  test 'link with quoted text but no equal sign should carry quotes over to output' do
+    assert_xpath %(//a[@href="http://search.example.com"][text()='"Google, Yahoo, Bing"']), render_embedded_string('http://search.example.com["Google, Yahoo, Bing"]'), 1
   end
 
-  test 'link with comma in text but no equal sign should not be separated into attributes when linkattrs is set' do
-    assert_xpath '//a[@href="http://search.example.com"][text()="Google, Yahoo, Bing"]', render_embedded_string('http://search.example.com[Google, Yahoo, Bing]', :attributes => {'linkattrs' => ''}), 1
+  test 'link with comma in text but no equal sign should not be separated into attributes' do
+    assert_xpath '//a[@href="http://search.example.com"][text()="Google, Yahoo, Bing"]', render_embedded_string('http://search.example.com[Google, Yahoo, Bing]'), 1
   end
 
-  test 'role and window attributes on link are processed when linkattrs is set' do
-    assert_xpath '//a[@href="http://google.com"][@class="external"][@target="_blank"]', render_embedded_string('http://google.com[Google, role="external", window="_blank"]', :attributes => {'linkattrs' => ''}), 1
+  test 'role and window attributes on link are processed' do
+    assert_xpath '//a[@href="http://google.com"][@class="external"][@target="_blank"]', render_embedded_string('http://google.com[Google, role=external, window="_blank"]'), 1
+  end
+
+  test 'link macro with attributes but no text should use URL as text' do
+    url = 'https://fonts.googleapis.com/css?family=Roboto:400,400italic,'
+    assert_xpath %(//a[@href="#{url}"][text()="#{url}"]), render_embedded_string(%(link:#{url}[family=Roboto,weight=400])), 1
   end
 
-  test 'link macro with attributes but no text should use URL as text when linkattrs is set' do
+  test 'link macro with attributes but blank text should use URL as text' do
     url = 'https://fonts.googleapis.com/css?family=Roboto:400,400italic,'
-    assert_xpath %(//a[@href="#{url}"][text()="#{url}"]), render_embedded_string(%(link:#{url}[family=Roboto,weight=400]), :attributes => {'linkattrs' => ''}), 1
+    assert_xpath %(//a[@href="#{url}"][text()="#{url}"]), render_embedded_string(%(link:#{url}[,family=Roboto,weight=400])), 1
   end
 
-  test 'link macro with comma but no explicit attributes in text should not parse text when linkattrs is set' do
+  test 'link macro with comma but no explicit attributes in text should not parse text' do
     url = 'https://fonts.googleapis.com/css?family=Roboto:400,400italic,'
-    assert_xpath %(//a[@href="#{url}"][text()="Roboto,400"]), render_embedded_string(%(link:#{url}[Roboto,400]), :attributes => {'linkattrs' => ''}), 1
+    assert_xpath %(//a[@href="#{url}"][text()="Roboto,400"]), render_embedded_string(%(link:#{url}[Roboto,400])), 1
   end
 
   test 'link text that ends in ^ should set link window to _blank' do
@@ -207,21 +236,25 @@ context 'Links' do
   end
 
   test 'rel=noopener should be added to a link that targets a named window when the noopener option is set' do
-    assert_xpath '//a[@href="http://google.com"][@target="name"][@rel="noopener"]', render_embedded_string('http://google.com[Google,window=name,opts=noopener]', :attributes => {'linkattrs' => ''}), 1
+    assert_xpath '//a[@href="http://google.com"][@target="name"][@rel="noopener"]', render_embedded_string('http://google.com[Google,window=name,opts=noopener]'), 1
   end
 
   test 'rel=noopener should not be added to a link if it does not target a window' do
-    result = render_embedded_string 'http://google.com[Google,opts=noopener]', :attributes => {'linkattrs' => ''}
+    result = render_embedded_string 'http://google.com[Google,opts=noopener]'
     assert_xpath '//a[@href="http://google.com"]', result, 1
     assert_xpath '//a[@href="http://google.com"][@rel="noopener"]', result, 0
   end
 
-  test 'id attribute on link are processed when linkattrs is set' do
-    assert_xpath '//a[@href="http://google.com"][@id="link-1"]', render_embedded_string('http://google.com[Google, id="link-1"]', :attributes => {'linkattrs' => ''}), 1
+  test 'rel=nofollow should be added to a link when the nofollow option is set' do
+    assert_xpath '//a[@href="http://google.com"][@target="name"][@rel="nofollow noopener"]', render_embedded_string('http://google.com[Google,window=name,opts="nofollow,noopener"]'), 1
   end
 
-  test 'title attribute on link are processed when linkattrs is set' do
-    assert_xpath '//a[@href="http://google.com"][@title="title-1"]', render_embedded_string('http://google.com[Google, title="title-1"]', :attributes => {'linkattrs' => ''}), 1
+  test 'id attribute on link is processed' do
+    assert_xpath '//a[@href="http://google.com"][@id="link-1"]', render_embedded_string('http://google.com[Google, id="link-1"]'), 1
+  end
+
+  test 'title attribute on link is processed' do
+    assert_xpath '//a[@href="http://google.com"][@title="title-1"]', render_embedded_string('http://google.com[Google, title="title-1"]'), 1
   end
 
   test 'inline irc link' do
@@ -236,9 +269,9 @@ context 'Links' do
     variations = %w([[tigers]] anchor:tigers[])
     variations.each do |anchor|
       doc = document_from_string %(Here you can read about tigers.#{anchor})
-      output = doc.render
+      output = doc.convert
       assert_equal '[tigers]', doc.catalog[:ids]['tigers']
-      assert doc.catalog[:refs]['tigers'].is_a? Asciidoctor::Inline
+      assert_kind_of Asciidoctor::Inline, doc.catalog[:refs]['tigers']
       assert_nil doc.catalog[:refs]['tigers'].text
       assert_xpath '//a[@id = "tigers"]', output, 1
       assert_xpath '//a[@id = "tigers"]/child::text()', output, 0
@@ -249,7 +282,7 @@ context 'Links' do
     variations = %w([[tigers]] anchor:tigers[])
     variations.each do |anchor|
       doc = document_from_string %(Here you can read about tigers.\\#{anchor})
-      output = doc.render
+      output = doc.convert
       refute doc.catalog[:ids].key?('tigers')
       refute doc.catalog[:refs].key?('tigers')
       assert_xpath '//a[@id = "tigers"]', output, 0
@@ -272,9 +305,9 @@ context 'Links' do
   test 'inline ref with reftext' do
     %w([[tigers,Tigers]] anchor:tigers[Tigers]).each do |anchor|
       doc = document_from_string %(Here you can read about tigers.#{anchor})
-      output = doc.render
+      output = doc.convert
       assert_equal 'Tigers', doc.catalog[:ids]['tigers']
-      assert doc.catalog[:refs]['tigers'].is_a? Asciidoctor::Inline
+      assert_kind_of Asciidoctor::Inline, doc.catalog[:refs]['tigers']
       assert_equal 'Tigers', doc.catalog[:refs]['tigers'].text
       assert_xpath '//a[@id = "tigers"]', output, 1
       assert_xpath '//a[@id = "tigers"]/child::text()', output, 0
@@ -290,8 +323,8 @@ context 'Links' do
   test 'should substitute attribute references in reftext when registering inline ref' do
     %w([[tigers,{label-tigers}]] anchor:tigers[{label-tigers}]).each do |anchor|
       doc = document_from_string %(Here you can read about tigers.#{anchor}), :attributes => { 'label-tigers' => 'Tigers' }
-      doc.render
-      assert doc.catalog[:refs]['tigers'].is_a? Asciidoctor::Inline
+      doc.convert
+      assert_kind_of Asciidoctor::Inline, doc.catalog[:refs]['tigers']
       assert_equal 'Tigers', doc.catalog[:refs]['tigers'].text
       assert_equal 'Tigers', doc.catalog[:ids]['tigers']
     end
@@ -301,7 +334,7 @@ context 'Links' do
     %w([[tigers,<Tigers>]] anchor:tigers[<Tigers>]).each do |anchor|
       doc = document_from_string %(Here you can read about tigers.#{anchor}), :backend => :docbook45
       output = doc.convert :header_footer => false
-      assert doc.catalog[:refs]['tigers'].is_a? Asciidoctor::Inline
+      assert_kind_of Asciidoctor::Inline, doc.catalog[:refs]['tigers']
       assert_equal '<Tigers>', doc.catalog[:refs]['tigers'].text
       assert_equal '<Tigers>', doc.references[:ids]['tigers']
       assert_includes output, '<anchor id="tigers" xreflabel="&lt;Tigers&gt;"/>'
@@ -349,13 +382,13 @@ anchor:foo[b[a\]r]text'
   test 'xref using angled bracket syntax' do
     doc = document_from_string '<<tigers>>'
     doc.register :refs, ['tigers', (Asciidoctor::Inline.new doc, :anchor, '[tigers]', :type => :ref, :target => 'tigers'), '[tigers]']
-    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', doc.render, 1
+    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with explicit hash' do
     doc = document_from_string '<<#tigers>>'
     doc.register :refs, ['tigers', (Asciidoctor::Inline.new doc, :anchor, 'Tigers', :type => :ref, :target => 'tigers'), 'Tigers']
-    assert_xpath '//a[@href="#tigers"][text() = "Tigers"]', doc.render, 1
+    assert_xpath '//a[@href="#tigers"][text() = "Tigers"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with label' do
@@ -378,14 +411,26 @@ anchor:foo[b[a\]r]text'
     assert_xpath %q(//a[@href="#tigers"][text() = '"About Tigers"']), render_string(input), 1
   end
 
+  test 'should not interpret path sans extension in xref with angled bracket syntax in compat mode' do
+    using_memory_logger do |logger|
+      doc = document_from_string '<<tigers#>>', :header_footer => false, :attributes => { 'compat-mode' => '' }
+      assert_xpath '//a[@href="#tigers#"][text() = "[tigers#]"]', doc.convert, 1
+    end
+  end
+
   test 'xref using angled bracket syntax with path sans extension' do
     doc = document_from_string '<<tigers#>>', :header_footer => false
-    assert_xpath '//a[@href="tigers.html"][text() = "tigers.html"]', doc.render, 1
+    assert_xpath '//a[@href="tigers.html"][text() = "tigers.html"]', doc.convert, 1
   end
 
-  test 'inter-document xref should not truncate after period if path has no extension' do
-    result = render_embedded_string '<<using-.net-web-services#,Using .NET web services>>'
-    assert_xpath '//a[@href="using-.net-web-services.html"][text() = "Using .NET web services"]', result, 1
+  test 'inter-document xref should not add suffix to path with a non-AsciiDoc extension' do
+    {
+      'using-.net-web-services' => 'Using .NET web services',
+      '../file.pdf' => 'Download the .pdf file'
+    }.each do |path, text|
+      result = render_embedded_string %(<<#{path}#,#{text}>>)
+      assert_xpath %(//a[@href="#{path}"][text() = "#{text}"]), result, 1
+    end
   end
 
   test 'inter-document xref should only remove the file extension part if the path contains a period elsewhere' do
@@ -395,52 +440,94 @@ anchor:foo[b[a\]r]text'
 
   test 'xref using angled bracket syntax with path sans extension using docbook backend' do
     doc = document_from_string '<<tigers#>>', :header_footer => false, :backend => 'docbook'
-    assert_match '<link xl:href="tigers.xml">tigers.xml</link>', doc.render, 1
+    assert_match '<link xl:href="tigers.xml">tigers.xml</link>', doc.convert, 1
     doc = document_from_string '<<tigers#>>', :header_footer => false, :backend => 'docbook45'
-    assert_match '<ulink url="tigers.xml">tigers.xml</ulink>', doc.render, 1
+    assert_match '<ulink url="tigers.xml">tigers.xml</ulink>', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with ancestor path sans extension' do
     doc = document_from_string '<<../tigers#,tigers>>', :header_footer => false
-    assert_xpath '//a[@href="../tigers.html"][text() = "tigers"]', doc.render, 1
+    assert_xpath '//a[@href="../tigers.html"][text() = "tigers"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with absolute path sans extension' do
     doc = document_from_string '<</path/to/tigers#,tigers>>', :header_footer => false
-    assert_xpath '//a[@href="/path/to/tigers.html"][text() = "tigers"]', doc.render, 1
+    assert_xpath '//a[@href="/path/to/tigers.html"][text() = "tigers"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with path and extension' do
+    using_memory_logger do |logger|
+      doc = document_from_string '<<tigers.adoc>>', :header_footer => false
+      assert_xpath '//a[@href="#tigers.adoc"][text() = "[tigers.adoc]"]', doc.convert, 1
+    end
+  end
+
+  test 'xref using angled bracket syntax with path and extension with hash' do
     doc = document_from_string '<<tigers.adoc#>>', :header_footer => false
-    assert_xpath '//a[@href="tigers.html"][text() = "tigers.html"]', doc.render, 1
+    assert_xpath '//a[@href="tigers.html"][text() = "tigers.html"]', doc.convert, 1
+  end
+
+  test 'xref using angled bracket syntax with path and extension with fragment' do
+    doc = document_from_string '<<tigers.adoc#id>>', :header_footer => false
+    assert_xpath '//a[@href="tigers.html#id"][text() = "tigers.html"]', doc.convert, 1
+  end
+
+  test 'xref using macro syntax with path and extension in compat mode' do
+    using_memory_logger do |logger|
+      doc = document_from_string 'xref:tigers.adoc[]', :header_footer => false, :attributes => { 'compat-mode' => '' }
+      assert_xpath '//a[@href="#tigers.adoc"][text() = "[tigers.adoc]"]', doc.convert, 1
+    end
+  end
+
+  test 'xref using macro syntax with path and extension' do
+    doc = document_from_string 'xref:tigers.adoc[]', :header_footer => false
+    assert_xpath '//a[@href="tigers.html"][text() = "tigers.html"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with path and fragment' do
     doc = document_from_string '<<tigers#about>>', :header_footer => false
-    assert_xpath '//a[@href="tigers.html#about"][text() = "tigers.html"]', doc.render, 1
+    assert_xpath '//a[@href="tigers.html#about"][text() = "tigers.html"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with path, fragment and text' do
     doc = document_from_string '<<tigers#about,About Tigers>>', :header_footer => false
-    assert_xpath '//a[@href="tigers.html#about"][text() = "About Tigers"]', doc.render, 1
+    assert_xpath '//a[@href="tigers.html#about"][text() = "About Tigers"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with path and custom relfilesuffix and outfilesuffix' do
     attributes = {'relfileprefix' => '../', 'outfilesuffix' => '/'}
     doc = document_from_string '<<tigers#about,About Tigers>>', :header_footer => false, :attributes => attributes
-    assert_xpath '//a[@href="../tigers/#about"][text() = "About Tigers"]', doc.render, 1
+    assert_xpath '//a[@href="../tigers/#about"][text() = "About Tigers"]', doc.convert, 1
+  end
+
+  test 'xref using angled bracket syntax with path and custom relfilesuffix' do
+    attributes = { 'relfilesuffix' => '/' }
+    doc = document_from_string '<<tigers#about,About Tigers>>', :header_footer => false, :attributes => attributes
+    assert_xpath '//a[@href="tigers/#about"][text() = "About Tigers"]', doc.convert, 1
   end
 
   test 'xref using angled bracket syntax with path which has been included in this document' do
-    doc = document_from_string '<<tigers#about,About Tigers>>', :header_footer => false
-    doc.catalog[:includes] << 'tigers'
-    assert_xpath '//a[@href="#about"][text() = "About Tigers"]', doc.render, 1
+    using_memory_logger do |logger|
+      in_verbose_mode do
+        doc = document_from_string '<<tigers#about,About Tigers>>', :header_footer => false
+        doc.catalog[:includes]['tigers'] = true
+        output = doc.convert
+        assert_xpath '//a[@href="#about"][text() = "About Tigers"]', output, 1
+        assert_message logger, :WARN, 'invalid reference: about'
+      end
+    end
   end
 
   test 'xref using angled bracket syntax with nested path which has been included in this document' do
-    doc = document_from_string '<<part1/tigers#about,About Tigers>>', :header_footer => false
-    doc.catalog[:includes] << 'part1/tigers'
-    assert_xpath '//a[@href="#about"][text() = "About Tigers"]', doc.render, 1
+    using_memory_logger do |logger|
+      in_verbose_mode do
+        doc = document_from_string '<<part1/tigers#about,About Tigers>>', :header_footer => false
+        doc.catalog[:includes]['part1/tigers'] = true
+        output = doc.convert
+        assert_xpath '//a[@href="#about"][text() = "About Tigers"]', output, 1
+        assert_message logger, :WARN, 'invalid reference: about'
+      end
+    end
   end
 
   test 'xref using angled bracket syntax inline with text' do
@@ -496,7 +583,7 @@ A summary of the first lesson.
   test 'xref using macro syntax' do
     doc = document_from_string 'xref:tigers[]'
     doc.register :refs, ['tigers', (Asciidoctor::Inline.new doc, :anchor, '[tigers]', :type => :ref, :target => 'tigers'), '[tigers]']
-    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', doc.render, 1
+    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', doc.convert, 1
   end
 
   test 'multiple xref macros with implicit text in single line' do
@@ -517,7 +604,7 @@ This document has two sections, xref:sec
   test 'xref using macro syntax with explicit hash' do
     doc = document_from_string 'xref:#tigers[]'
     doc.register :refs, ['tigers', (Asciidoctor::Inline.new doc, :anchor, 'Tigers', :type => :ref, :target => 'tigers'), 'Tigers']
-    assert_xpath '//a[@href="#tigers"][text() = "Tigers"]', doc.render, 1
+    assert_xpath '//a[@href="#tigers"][text() = "Tigers"]', doc.convert, 1
   end
 
   test 'xref using macro syntax with label' do
@@ -552,14 +639,24 @@ tigers]?
     assert_xpath %{//a[@href="#tigers"][normalize-space(text()) = "about tigers"]}, render_string(input), 1
   end
 
-  test 'xref using macro syntax with text that contains an escaped closing bracket' do
+  test 'xref using macro syntax with text that ends with an escaped closing bracket' do
     input = <<-EOS
 xref:tigers[[tigers\\]]
 
 [#tigers]
 == Tigers
     EOS
-    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', render_string(input), 1
+    assert_xpath '//a[@href="#tigers"][text() = "[tigers]"]', render_embedded_string(input), 1
+  end
+
+  test 'xref using macro syntax with text that contains an escaped closing bracket' do
+    input = <<-EOS
+xref:tigers[[tigers\\] are cats]
+
+[#tigers]
+== Tigers
+    EOS
+    assert_xpath '//a[@href="#tigers"][text() = "[tigers] are cats"]', render_embedded_string(input), 1
   end
 
   test 'unescapes square bracket in reftext used by xref' do
@@ -574,7 +671,7 @@ see <<foo>>'
   test 'xref using invalid macro syntax does not create link' do
     doc = document_from_string 'xref:tigers'
     doc.register :refs, ['tigers', (Asciidoctor::Inline.new doc, :anchor, 'Tigers', :type => :ref, :target => 'tigers'), 'Tigers']
-    assert_xpath '//a', doc.render, 0
+    assert_xpath '//a', doc.convert, 0
   end
 
   test 'should warn and create link if verbose flag is set and reference is not found' do
@@ -586,14 +683,111 @@ see <<foo>>'
 
 See <<foobaz>>.
     EOS
-    begin
-      old_verbose, $VERBOSE = $VERBOSE, true
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-      assert_xpath '//a[@href="#foobaz"][text() = "[foobaz]"]', output, 1
-      refute_empty warnings
-      assert_includes warnings, 'asciidoctor: WARNING: invalid reference: foobaz'
-    ensure
-      $VERBOSE = old_verbose
+    using_memory_logger do |logger|
+      in_verbose_mode do
+        output = render_embedded_string input
+        assert_xpath '//a[@href="#foobaz"][text() = "[foobaz]"]', output, 1
+        assert_message logger, :WARN, 'invalid reference: foobaz'
+      end
+    end
+  end
+
+  test 'should warn and create link if verbose flag is set and reference using # notation is not found' do
+    input = <<-EOS
+[#foobar]
+== Foobar
+
+== Section B
+
+See <<#foobaz>>.
+    EOS
+    using_memory_logger do |logger|
+      in_verbose_mode do
+        output = render_embedded_string input
+        assert_xpath '//a[@href="#foobaz"][text() = "[foobaz]"]', output, 1
+        assert_message logger, :WARN, 'invalid reference: foobaz'
+      end
+    end
+  end
+
+  test 'should produce an internal anchor from an inter-document xref to file included into current file' do
+    input = <<-'EOS'
+= Book Title
+:doctype: book
+
+[#ch1]
+== Chapter 1
+
+So it begins.
+
+Read <<other-chapters.adoc#ch2>> to find out what happens next!
+
+include::other-chapters.adoc[]
+    EOS
+
+    doc = document_from_string input, :safe => :safe, :base_dir => fixturedir
+    assert doc.catalog[:includes].key?('other-chapters')
+    assert doc.catalog[:includes]['other-chapters']
+    output = doc.convert
+    assert_xpath '//a[@href="#ch2"][text()="Chapter 2"]', output, 1
+  end
+
+  test 'should produce an internal anchor from an inter-document xref to file included entirely into current file using tags' do
+    input = <<-'EOS'
+= Book Title
+:doctype: book
+
+[#ch1]
+== Chapter 1
+
+So it begins.
+
+Read <<other-chapters.adoc#ch2>> to find out what happens next!
+
+include::other-chapters.adoc[tags=**]
+    EOS
+
+    output = render_embedded_string input, :safe => :safe, :base_dir => fixturedir
+    assert_xpath '//a[@href="#ch2"][text()="Chapter 2"]', output, 1
+  end
+
+  test 'should not produce an internal anchor for inter-document xref to file partially included into current file' do
+    input = <<-'EOS'
+= Book Title
+:doctype: book
+
+[#ch1]
+== Chapter 1
+
+So it begins.
+
+Read <<other-chapters.adoc#ch2,the next chapter>> to find out what happens next!
+
+include::other-chapters.adoc[tags=ch2]
+    EOS
+
+    doc = document_from_string input, :safe => :safe, :base_dir => fixturedir
+    assert doc.catalog[:includes].key?('other-chapters')
+    refute doc.catalog[:includes]['other-chapters']
+    output = doc.convert
+    assert_xpath '//a[@href="other-chapters.html#ch2"][text()="the next chapter"]', output, 1
+  end
+
+  test 'should warn and create link if debug mode is enabled, inter-document xref points to current doc, and reference not found' do
+    input = <<-EOS
+[#foobar]
+== Foobar
+
+== Section B
+
+See <<test.adoc#foobaz>>.
+    EOS
+    using_memory_logger do |logger|
+      in_verbose_mode do
+        output = render_embedded_string input, :attributes => { 'docname' => 'test' }
+        assert_xpath '//a[@href="#foobaz"][text() = "[foobaz]"]', output, 1
+        assert_message logger, :WARN, 'invalid reference: foobaz'
+      end
     end
   end
 
diff -pruN 1.5.6.2-2/test/lists_test.rb 1.5.7-1/test/lists_test.rb
--- 1.5.6.2-2/test/lists_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/lists_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -185,7 +185,7 @@ Bar
 
       output = render_embedded_string input
       assert_css 'ul ul', output, 1
-      refute output.include?('* Foo')
+      refute_includes output, '* Foo'
     end
 
     test 'a list item for a different list terminates non-indented paragraph for text of list item' do
@@ -205,9 +205,9 @@ term:: def
 
       output = render_embedded_string input
       assert_css 'ul ol', output, 1
-      refute output.include?('* Foo')
+      refute_includes output, '* Foo'
       assert_css 'ul dl', output, 1
-      refute output.include?('term:: def')
+      refute_includes output, 'term:: def'
     end
 
     test 'an indented wrapped line is unindented and folded into text of list item' do
@@ -255,7 +255,7 @@ second wrapped line
 
       output = render_embedded_string input
       assert_css 'ul ul', output, 1
-      refute output.include?('* Foo')
+      refute_includes output, '* Foo'
     end
 
     test 'a list item that starts with a sequence of list markers characters should not match a nested list' do
@@ -287,9 +287,9 @@ term:: def
 
       output = render_embedded_string input
       assert_css 'ul ol', output, 1
-      refute output.include?('* Foo')
+      refute_includes output, '* Foo'
       assert_css 'ul dl', output, 1
-      refute output.include?('term:: def')
+      refute_includes output, 'term:: def'
     end
 
     test "a literal paragraph offset by blank lines in list content is appended as a literal block" do
@@ -355,6 +355,48 @@ NOTE: This is a note.
       assert_xpath '//ul/li/*[@class="admonitionblock note"]//td[@class="content"][normalize-space(text())="This is a note."]', output, 1
     end
 
+    test 'paragraph-like blocks attached to an ancestory list item by a list continuation should produce blocks' do
+      input = <<-EOS
+* parent
+ ** child
+
++
+NOTE: This is a note.
+
+* another parent
+ ** another child
+
++
+'''
+      EOS
+
+      output = render_embedded_string input
+      assert_css 'ul ul .admonitionblock.note', output, 0
+      assert_xpath '(//ul)[1]/li/*[@class="admonitionblock note"]', output, 1
+      assert_css 'ul ul hr', output, 0
+      assert_xpath '(//ul)[1]/li/hr', output, 1
+    end
+
+    test 'should continue to parse blocks attached by a list continuation after block is dropped' do
+      input = <<-EOS
+* item
++
+paragraph
++
+[comment]
+comment
++
+====
+example
+====
+'''
+      EOS
+
+      output = render_embedded_string input
+      assert_css 'ul > li > .paragraph', output, 1
+      assert_css 'ul > li > .exampleblock', output, 1
+    end
+
     test 'appends line as paragraph if attached by continuation following line comment' do
       input = <<-EOS
 - list item 1
@@ -637,7 +679,7 @@ item
       assert_css 'ul', output, 1
       assert_css 'ul > li', output, 2
       assert_css 'h2', output, 0
-      assert output.include?('== Not a section')
+      assert_includes output, '== Not a section'
       assert_xpath %((//li)[2]/p[text() = "second\n== Not a section"]), output, 1
     end
   end
@@ -700,6 +742,26 @@ B. And it ends here.
       assert_xpath '//ol', output, 1
       assert_xpath '//ol/li', output, 2
     end
+
+    test 'should discover anchor at start of list item text and register it as a reference' do
+      input = <<-EOS
+The highest peak in the Front Range is <<grays-peak>>, which tops <<mount-evans>> by just a few feet.
+
+* [[mount-evans,Mount Evans]]At 14,271 feet, Mount Evans is the highest summit of the Chicago Peaks in the Front Range of the Rocky Mountains.
+* [[grays-peak,Grays Peak]]
+Grays Peak rises to 14,278 feet, making it the highest summit in the Front Range of the Rocky Mountains.
+* Longs Peak is a 14,259-foot high, prominent mountain summit in the northern Front Range of the Rocky Mountains.
+* Pikes Peak is the highest summit of the southern Front Range of the Rocky Mountains at 14,115 feet.
+      EOS
+
+      doc = document_from_string input
+      refs = doc.catalog[:refs]
+      assert refs.key?('mount-evans')
+      assert refs.key?('grays-peak')
+      output = doc.convert :header_footer => false
+      assert_xpath '(//p)[1]/a[@href="#grays-peak"][text()="Grays Peak"]', output, 1
+      assert_xpath '(//p)[1]/a[@href="#mount-evans"][text()="Mount Evans"]', output, 1
+    end
   end
 
   context "Nested lists" do
@@ -1540,6 +1602,23 @@ Item one, paragraph two
     end
 =end
 
+    test 'should warn if unterminated block is detected in list item' do
+      input = <<-EOS
+* item
++
+====
+example
+* swallowed item
+      EOS
+
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_xpath '//ul/li', output, 1
+        assert_xpath '//ul/li/*[@class="exampleblock"]', output, 1
+        assert_xpath %(//p[text()="example\n* swallowed item"]), output, 1
+        assert_message logger, :WARN, '<stdin>: line 3: unterminated example block', Hash
+      end
+    end
   end
 end
 
@@ -1764,6 +1843,30 @@ List
       assert_xpath '(//orderedlist)[@startingnumber = "7"]', output, 1
     end
   end
+
+  test 'should warn if explicit uppercase roman numerals in list are out of sequence' do
+    input = <<-EOS
+I) one
+III) three
+    EOS
+    using_memory_logger do |logger|
+      output = render_embedded_string input
+      assert_xpath '//ol/li', output, 2
+      assert_message logger, :WARN, '<stdin>: line 2: list item index: expected II, got III', Hash
+    end
+  end
+
+  test 'should warn if explicit lowercase roman numerals in list are out of sequence' do
+    input = <<-EOS
+i) one
+iii) three
+    EOS
+    using_memory_logger do |logger|
+      output = render_embedded_string input
+      assert_xpath '//ol/li', output, 2
+      assert_message logger, :WARN, '<stdin>: line 2: list item index: expected ii, got iii', Hash
+    end
+  end
 end
 
 context "Description lists (:dlist)" do
@@ -1783,6 +1886,21 @@ term2:: def2
       assert_xpath '(//dl/dt)[2]/following-sibling::dd/p[text() = "def2"]', output, 1
     end
 
+    test 'should parse sibling items using same rules' do
+      input = <<-EOS
+term1;; ;; def1
+term2;; ;; def2
+      EOS
+      output = render_string input
+      assert_xpath '//dl', output, 1
+      assert_xpath '//dl/dt', output, 2
+      assert_xpath '//dl/dt/following-sibling::dd', output, 2
+      assert_xpath '(//dl/dt)[1][normalize-space(text()) = "term1"]', output, 1
+      assert_xpath '(//dl/dt)[1]/following-sibling::dd/p[text() = ";; def1"]', output, 1
+      assert_xpath '(//dl/dt)[2][normalize-space(text()) = "term2"]', output, 1
+      assert_xpath '(//dl/dt)[2]/following-sibling::dd/p[text() = ";; def2"]', output, 1
+    end
+
     test "single-line indented adjacent elements" do
       input = <<-EOS
 term1:: def1
@@ -2046,16 +2164,24 @@ def2
       assert_xpath '(//dl/dt)[2]/following-sibling::dd/p[text() = "def2"]', output, 1
     end
 
-    test "element with anchor" do
+    test 'should discover anchor at start of description term text and register it as a reference' do
       input = <<-EOS
-[[term1]]term1:: def1
-[[term2]]term2:: def2
+The highest peak in the Front Range is <<grays-peak>>, which tops <<mount-evans>> by just a few feet.
+
+[[mount-evans,Mount Evans]]Mount Evans:: 14,271 feet
+[[grays-peak]]Grays Peak:: 14,278 feet
       EOS
-      output = render_string input
+      doc = document_from_string input
+      refs = doc.catalog[:refs]
+      assert refs.key?('mount-evans')
+      assert refs.key?('grays-peak')
+      output = doc.convert :header_footer => false
+      assert_xpath '(//p)[1]/a[@href="#grays-peak"][text()="Grays Peak"]', output, 1
+      assert_xpath '(//p)[1]/a[@href="#mount-evans"][text()="Mount Evans"]', output, 1
       assert_xpath '//dl', output, 1
       assert_xpath '//dl/dt', output, 2
-      assert_xpath '(//dl/dt)[1]/a[@id = "term1"]', output, 1
-      assert_xpath '(//dl/dt)[2]/a[@id = "term2"]', output, 1
+      assert_xpath '(//dl/dt)[1]/a[@id="mount-evans"]', output, 1
+      assert_xpath '(//dl/dt)[2]/a[@id="grays-peak"]', output, 1
     end
 
     test "missing space before term does not produce description list" do
@@ -2327,6 +2453,18 @@ A term::::: a description
       assert_xpath '//dt[text()="A term:"]', output, 1
       assert_xpath '//dd/p[text()="a description"]', output, 1
     end
+
+    test 'text method of dd node should return nil if dd node only contains blocks' do
+      input = <<-EOS
+term::
++
+paragraph
+      EOS
+
+      doc = document_from_string input
+      dd = doc.blocks[0].items[0][1]
+      assert_nil dd.text
+    end
   end
 
   context "Nested lists" do
@@ -2774,6 +2912,23 @@ last question::
       assert_css 'bibliodiv > bibliomixed:nth-child(2) > bibliomisc > anchor[xreflabel="[walsh-muellner]"]', output, 1
     end
 
+    test 'should warn if a bibliography ID is already in use' do
+      input = <<-EOS
+[bibliography]
+* [[[Fowler]]] Fowler M. _Analysis Patterns: Reusable Object Models_.
+Addison-Wesley. 1997.
+* [[[Fowler]]] Fowler M. _Analysis Patterns: Reusable Object Models_.
+Addison-Wesley. 1997.
+      EOS
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_css '.ulist.bibliography', output, 1
+        assert_css '.ulist.bibliography ul li:nth-child(1) p a#Fowler', output, 1
+        assert_css '.ulist.bibliography ul li:nth-child(2) p a#Fowler', output, 1
+        assert_message logger, :WARN, '<stdin>: line 4: id assigned to bibliography anchor already in use: Fowler', Hash
+      end
+    end
+
     test 'should automatically add bibliography style to top-level lists in bibliography section' do
       input = <<-EOS
 [bibliography]
@@ -3448,7 +3603,7 @@ not a term::: def
       assert_css '.dlist > dl > dt', output, 1
       assert_css '.dlist > dl > dd', output, 1
       assert_css '.dlist > dl > dd > .paragraph', output, 1
-      assert output.include?('not a term::: def')
+      assert_includes output, 'not a term::: def'
     end
 
     # FIXME pending
@@ -3465,7 +3620,7 @@ not a term:: def
       assert_css '.dlist > dl > dt', output, 1
       assert_css '.dlist > dl > dd', output, 1
       assert_css '.dlist > dl > dd > .paragraph', output, 1
-      assert output.include?('not a term:: def')
+      assert_includes output, 'not a term:: def'
     end
 =end
 
@@ -3482,7 +3637,7 @@ not a term::: def
       assert_css '.dlist > dl > dt', output, 1
       assert_css '.dlist > dl > dd', output, 1
       assert_css '.dlist > dl > dd > .quoteblock', output, 1
-      assert output.include?('not a term::: def')
+      assert_includes output, 'not a term::: def'
     end
 
     test 'appends line as paragraph if attached by continuation following blank line and line comment when term has no inline description' do
@@ -3906,7 +4061,7 @@ context 'Callout lists' do
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 <1> Describe the first line
 <2> Describe the second line
@@ -3930,7 +4085,7 @@ puts doc.render # <3>
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 
 Paragraph.
@@ -3958,7 +4113,7 @@ Paragraph.
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <2>
+puts doc.convert # <2>
 ----
 <1> Import the library
 <2> Where the magic happens
@@ -3980,7 +4135,7 @@ puts doc.render # <2>
 ----
 require 'asciidoctor' # <2>
 doc = Asciidoctor::Document.new('Hello, World!') # <3>
-puts doc.render # <1>
+puts doc.convert # <1>
 ----
 <1> Describe the first line
 <2> Describe the second line
@@ -4010,7 +4165,7 @@ require 'asciidoctor' # <1>
 [source, ruby]
 ----
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 
 <1> Describe the first line
@@ -4042,7 +4197,7 @@ require 'asciidoctor' # <1>
 [source, ruby]
 ----
 doc = Asciidoctor::Document.new('Hello, World!') # <1>
-puts doc.render # <2>
+puts doc.convert # <2>
 ----
 <1> Describe the second line
 <2> Describe the third line
@@ -4068,7 +4223,7 @@ puts doc.render # <2>
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 <1> Imports the library
 as a RubyGem
@@ -4093,7 +4248,7 @@ You can write this to file rather than p
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 <1> Imports the library
 as a RubyGem
@@ -4142,7 +4297,7 @@ puts "The syntax <1> at the end of the l
 ----
 require 'asciidoctor' <1>
 doc = Asciidoctor.load('Hello, World!') # <2> <3> <4>
-puts doc.render <5><6>
+puts doc.convert <5><6>
 exit 0
 ----
 <1> Require library
@@ -4195,11 +4350,13 @@ foo::
 
 <1> Not pointing to a callout
     EOS
-    output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-    assert_xpath '//dl//b', output, 0
-    assert_xpath '//dl/dd/p[text()="bar <1>"]', output, 1
-    assert_xpath '//ol/li/p[text()="Not pointing to a callout"]', output, 1
-    assert_includes warnings, 'line 4: no callouts refer to list item 1'
+    using_memory_logger do |logger|
+      output = render_embedded_string input
+      assert_xpath '//dl//b', output, 0
+      assert_xpath '//dl/dd/p[text()="bar <1>"]', output, 1
+      assert_xpath '//ol/li/p[text()="Not pointing to a callout"]', output, 1
+      assert_message logger, :WARN, '<stdin>: line 4: no callout found for <1>', Hash
+    end
   end
 
   test 'should not recognize callouts in an indented outline list paragraph' do
@@ -4209,11 +4366,13 @@ foo::
 
 <1> Not pointing to a callout
     EOS
-    output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-    assert_xpath '//ul//b', output, 0
-    assert_xpath %(//ul/li/p[text()="foo\nbar <1>"]), output, 1
-    assert_xpath '//ol/li/p[text()="Not pointing to a callout"]', output, 1
-    assert_includes warnings, 'line 4: no callouts refer to list item 1'
+    using_memory_logger do |logger|
+      output = render_embedded_string input
+      assert_xpath '//ul//b', output, 0
+      assert_xpath %(//ul/li/p[text()="foo\nbar <1>"]), output, 1
+      assert_xpath '//ol/li/p[text()="Not pointing to a callout"]', output, 1
+      assert_message logger, :WARN, '<stdin>: line 4: no callout found for <1>', Hash
+    end
   end
 
   test 'should warn if numbers in callout list are out of sequence' do
@@ -4227,10 +4386,14 @@ foo::
 Beans are fun.
 <3> An actual bean.
     EOS
-    output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-    assert_xpath '//ol/li', output, 2
-    assert_includes warnings, 'line 8: callout list item index: expected 2 got 3'
-    assert_includes warnings, 'line 8: no callouts refer to list item 2'
+    using_memory_logger do |logger|
+      output = render_embedded_string input
+      assert_xpath '//ol/li', output, 2
+      assert_messages logger, [
+        [:WARN, '<stdin>: line 8: callout list item index: expected 2, got 3', Hash],
+        [:WARN, '<stdin>: line 8: no callout found for <2>', Hash]
+      ]
+    end
   end
 
   test 'should remove line comment chars that precedes callout number' do
@@ -4312,7 +4475,7 @@ Violets are blue <2>
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') # <2>
-puts doc.render # <3>
+puts doc.convert # <3>
 ----
 <1> Describe the first line
 <2> Describe the second line
@@ -4335,7 +4498,7 @@ puts doc.render # <3>
 ----
 require 'asciidoctor' # <1>
 doc = Asciidoctor::Document.new('Hello, World!') #<2>
-puts doc.render #<3>
+puts doc.convert #<3>
 ----
 <1> Describe the first line
 <2> Describe the second line
@@ -4367,7 +4530,17 @@ context 'Checklists' do
 - plain
     EOS
 
-    output = render_embedded_string input
+    doc = document_from_string input
+    checklist = doc.blocks[0]
+    assert checklist.option?('checklist')
+    #assert_equal 'checklist', checklist.attributes['options']
+    assert checklist.items[0].attr?('checkbox')
+    refute checklist.items[0].attr?('checked')
+    assert checklist.items[1].attr?('checkbox')
+    assert checklist.items[1].attr?('checked')
+    refute checklist.items[4].attr?('checkbox')
+
+    output = doc.convert :header_footer => false
     assert_css '.ulist.checklist', output, 1
     assert_xpath %((/*[@class="ulist checklist"]/ul/li)[1]/p[text()="#{decode_char 10063} todo"]), output, 1
     assert_xpath %((/*[@class="ulist checklist"]/ul/li)[2]/p[text()="#{decode_char 10003} done"]), output, 1
@@ -4394,12 +4567,17 @@ context 'Checklists' do
     input = <<-EOS
 :icons: font
 
-[options="interactive"]
+[%interactive]
 - [ ] todo
 - [x] done
     EOS
 
-    output = render_embedded_string input
+    doc = document_from_string input
+    checklist = doc.blocks[0]
+    assert checklist.option?('checklist')
+    assert checklist.option?('interactive')
+
+    output = doc.convert :header_footer => false
     assert_css '.ulist.checklist', output, 1
     assert_css '.ulist.checklist li input[type="checkbox"]', output, 2
     assert_css '.ulist.checklist li input[type="checkbox"][disabled]', output, 0
@@ -4417,7 +4595,7 @@ context 'Lists model' do
 
     doc = document_from_string input
     list = doc.blocks.first
-    assert list.is_a? Asciidoctor::List
+    assert_kind_of Asciidoctor::List, list
     items = list.items
     assert_equal 3, items.size
     assert_equal list.items, list.content
@@ -4556,4 +4734,24 @@ listing block in list item 1
     assert_equal '`three`', list.items[2].text
     assert_equal '<mark>four</mark>', list.items[3].text
   end
+
+  test 'should set lineno to line number in source where list starts' do
+    input = <<-EOS
+* bullet 1
+** bullet 1.1
+*** bullet 1.1.1
+* bullet 2
+    EOS
+    doc = document_from_string input, :sourcemap => true
+    lists = doc.find_by :context => :ulist
+    assert_equal 1, lists[0].lineno
+    assert_equal 2, lists[1].lineno
+    assert_equal 3, lists[2].lineno
+
+    list_items = doc.find_by :context => :list_item
+    assert_equal 1, list_items[0].lineno
+    assert_equal 2, list_items[1].lineno
+    assert_equal 3, list_items[2].lineno
+    assert_equal 4, list_items[3].lineno
+  end
 end
diff -pruN 1.5.6.2-2/test/logger_test.rb 1.5.7-1/test/logger_test.rb
--- 1.5.6.2-2/test/logger_test.rb	1970-01-01 00:00:00.000000000 +0000
+++ 1.5.7-1/test/logger_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -0,0 +1,211 @@
+# encoding: UTF-8
+unless defined? ASCIIDOCTOR_PROJECT_DIR
+  $: << File.dirname(__FILE__); $:.uniq!
+  require 'test_helper'
+end
+
+context 'Logger' do
+  MyLogger = Class.new Logger
+
+  context 'LoggerManager' do
+    test 'provides access to logger via static logger method' do
+      logger = Asciidoctor::LoggerManager.logger
+      refute_nil logger
+      assert_kind_of Logger, logger
+    end
+
+    test 'allows logger instance to be changed' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      new_logger = MyLogger.new $stdout
+      begin
+        Asciidoctor::LoggerManager.logger = new_logger
+        assert_same new_logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+
+    test 'setting logger instance to falsy value resets instance to default logger' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      begin
+        Asciidoctor::LoggerManager.logger = MyLogger.new $stdout
+        Asciidoctor::LoggerManager.logger = nil
+        refute_nil Asciidoctor::LoggerManager.logger
+        assert_kind_of Logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+
+    test 'creates logger instance from static logger_class property' do
+      old_logger_class = Asciidoctor::LoggerManager.logger_class
+      old_logger = Asciidoctor::LoggerManager.logger
+      begin
+        Asciidoctor::LoggerManager.logger_class = MyLogger
+        Asciidoctor::LoggerManager.logger = nil
+        refute_nil Asciidoctor::LoggerManager.logger
+        assert_kind_of MyLogger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger_class = old_logger_class
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+  end
+
+  context 'Logger' do
+    test 'configures default logger with progname set to asciidoctor' do
+      assert_equal 'asciidoctor', Asciidoctor::LoggerManager.logger.progname
+    end
+
+    test 'configures default logger with level set to WARN' do
+      assert_equal Logger::Severity::WARN, Asciidoctor::LoggerManager.logger.level
+    end
+
+    test 'configures default logger to write messages to $stderr' do
+      out_string, err_string = redirect_streams do |out, err|
+        Asciidoctor::LoggerManager.logger.warn 'this is a call'
+        [out.string, err.string]
+      end
+      assert_empty out_string
+      refute_empty err_string
+      assert_includes err_string, 'this is a call'
+    end
+
+    test 'configures default logger to use a formatter that matches traditional format' do
+      err_string = redirect_streams do |_, err|
+        Asciidoctor::LoggerManager.logger.warn 'this is a call'
+        Asciidoctor::LoggerManager.logger.fatal 'it cannot be done'
+        err.string
+      end
+      assert_includes err_string, %(asciidoctor: WARNING: this is a call)
+      assert_includes err_string, %(asciidoctor: FAILED: it cannot be done)
+    end
+  end
+
+  context ':logger API option' do
+    test 'should be able to set logger when invoking load API' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      new_logger = MyLogger.new $stdout
+      begin
+        Asciidoctor.load 'contents', :logger => new_logger
+        assert_same new_logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+
+    test 'should be able to set logger when invoking load_file API' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      new_logger = MyLogger.new $stdout
+      begin
+        Asciidoctor.load_file fixture_path('basic.asciidoc'), :logger => new_logger
+        assert_same new_logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+
+    test 'should be able to set logger when invoking convert API' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      new_logger = MyLogger.new $stdout
+      begin
+        Asciidoctor.convert 'contents', :logger => new_logger
+        assert_same new_logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+
+    test 'should be able to set logger when invoking convert_file API' do
+      old_logger = Asciidoctor::LoggerManager.logger
+      new_logger = MyLogger.new $stdout
+      begin
+        Asciidoctor.convert_file fixture_path('basic.asciidoc'), :to_file => false, :logger => new_logger
+        assert_same new_logger, Asciidoctor::LoggerManager.logger
+      ensure
+        Asciidoctor::LoggerManager.logger = old_logger
+      end
+    end
+  end
+
+  context 'Logging' do
+    test 'including Logging gives instance methods on module access to logging infrastructure' do
+      module SampleModuleA
+        include Asciidoctor::Logging
+        def get_logger
+          logger
+        end
+      end
+
+      class SampleClassA
+        include SampleModuleA
+      end
+      assert_same Asciidoctor::LoggerManager.logger, SampleClassA.new.get_logger
+      assert SampleClassA.private_method_defined? :logger
+    end
+
+    test 'including Logging gives static methods on module access to logging infrastructure' do
+      module SampleModuleB
+        include Asciidoctor::Logging
+        def self.get_logger
+          logger
+        end
+      end
+
+      assert_same Asciidoctor::LoggerManager.logger, SampleModuleB.get_logger
+    end
+
+    test 'including Logging gives instance methods on class access to logging infrastructure' do
+      class SampleClassC
+        include Asciidoctor::Logging
+        def get_logger
+          logger
+        end
+      end
+
+      assert_same Asciidoctor::LoggerManager.logger, SampleClassC.new.get_logger
+      assert SampleClassC.private_method_defined? :logger
+    end
+
+    test 'including Logging gives static methods on class access to logging infrastructure' do
+      class SampleClassD
+        include Asciidoctor::Logging
+        def self.get_logger
+          logger
+        end
+      end
+
+      assert_same Asciidoctor::LoggerManager.logger, SampleClassD.get_logger
+    end
+
+    test 'can create an auto-formatting message with context' do
+      class SampleClassE
+        include Asciidoctor::Logging
+        def create_message cursor
+          message_with_context 'Asciidoctor was here', :source_location => cursor
+        end
+      end
+
+      cursor = Asciidoctor::Reader::Cursor.new 'file.adoc', fixturedir, 'file.adoc', 5
+      message = SampleClassE.new.create_message cursor
+      assert_equal 'Asciidoctor was here', message[:text]
+      assert_same cursor, message[:source_location]
+      assert_equal 'file.adoc: line 5: Asciidoctor was here', message.inspect
+    end
+
+    test 'writes message prefixed with program name and source location to stderr' do
+      input = <<-EOS
+[#first]
+first paragraph
+
+[#first]
+another first paragraph
+      EOS
+      messages = redirect_streams do |_, err|
+        render_embedded_string input
+        err.string
+      end
+      assert_equal 'asciidoctor: WARNING: <stdin>: line 5: id assigned to block already in use: first', messages.chomp
+    end
+  end
+end
diff -pruN 1.5.6.2-2/test/manpage_test.rb 1.5.7-1/test/manpage_test.rb
--- 1.5.6.2-2/test/manpage_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/manpage_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -37,33 +37,85 @@ context 'Manpage' do
       assert_equal 'command', doc.attributes['docname']
     end
 
+    test 'should output multiple mannames in NAME section' do
+      input = SAMPLE_MANPAGE_HEADER.sub(/^command - /, 'command, alt_command - ')
+      output = Asciidoctor.convert input, :backend => :manpage, :header_footer => true
+      assert_includes output.lines, %(command, alt_command \\- does stuff\n)
+    end
+
+    test 'should skip line comments in NAME section' do
+      input = <<-EOS
+= foobar (1)
+Author Name
+:doctype: manpage
+:man manual: Foo Bar Manual
+:man source: Foo Bar 1.0
+
+== NAME
+
+// follows the form `name - description`
+foobar - puts some foo on the bar
+// a little bit of this, a little bit of that
+
+== SYNOPSIS
+
+*foobar* [_OPTIONS_]...
+
+== DESCRIPTION
+
+When you need to put some foo on the bar.
+      EOS
+
+      doc = Asciidoctor.load input, :backend => :manpage, :header_footer => true
+      assert_equal 'puts some foo on the bar', (doc.attr 'manpurpose')
+    end
+
     test 'should define default linkstyle' do
       input = SAMPLE_MANPAGE_HEADER
       output = Asciidoctor.convert input, :backend => :manpage, :header_footer => true
-      assert_includes output.lines, %(.LINKSTYLE blue R < >\n)
+      assert_includes output.lines, %(.  LINKSTYLE blue R < >\n)
     end
 
     test 'should use linkstyle defined by man-linkstyle attribute' do
       input = SAMPLE_MANPAGE_HEADER
       output = Asciidoctor.convert input, :backend => :manpage, :header_footer => true,
           :attributes => { 'man-linkstyle' => 'cyan B \[fo] \[fc]' }
-      assert_includes output.lines, %(.LINKSTYLE cyan B \\[fo] \\[fc]\n)
+      assert_includes output.lines, %(.  LINKSTYLE cyan B \\[fo] \\[fc]\n)
     end
 
     test 'should require specialchars in value of man-linkstyle attribute defined in document to be escaped' do
       input = %(:man-linkstyle: cyan R < >
 #{SAMPLE_MANPAGE_HEADER})
       output = Asciidoctor.convert input, :backend => :manpage, :header_footer => true
-      assert_includes output.lines, %(.LINKSTYLE cyan R &lt; &gt;\n)
+      assert_includes output.lines, %(.  LINKSTYLE cyan R &lt; &gt;\n)
 
       input = %(:man-linkstyle: pass:[cyan R < >]
 #{SAMPLE_MANPAGE_HEADER})
       output = Asciidoctor.convert input, :backend => :manpage, :header_footer => true
-      assert_includes output.lines, %(.LINKSTYLE cyan R < >\n)
+      assert_includes output.lines, %(.  LINKSTYLE cyan R < >\n)
     end
   end
 
   context 'Manify' do
+    test 'should unescape literal ampersand' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+
+(C) & (R) are translated to character references, but not the &.)
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert_equal '\\(co & \\(rg are translated to character references, but not the &.', output.lines.entries.last.chomp
+    end
+
+    test 'should replace em dashes' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+
+go -- to
+
+go--to)
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert_includes output, 'go \\(em to'
+      assert_includes output, 'go\\(emto'
+    end
+
     test 'should escape lone period' do
       input = %(#{SAMPLE_MANPAGE_HEADER}
 
@@ -98,7 +150,7 @@ BBB this line and the one above it shoul
 
 "`hello`" '`goodbye`' *strong* _weak_ `even`)
       output = Asciidoctor.convert input, :backend => :manpage
-      assert_equal '\(lqhello\(rq \(oqgoodbye\(cq \fBstrong\fP \fIweak\fP \f[CR]even\fP', output.lines.entries.last.chomp
+      assert_equal '\(lqhello\(rq \(oqgoodbye\(cq \fBstrong\fP \fIweak\fP \f(CReven\fP', output.lines.entries.last.chomp
     end
 
     test 'should escape backslashes in content' do
@@ -216,15 +268,81 @@ Please search |\c
 .URL "http://discuss.asciidoctor.org" "the forums" "|"
 before asking.', output.lines.entries[-4..-1].join
     end
+
+    test 'should be able to use monospaced text inside a link' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+
+Enter the link:cat[`cat`] command.)
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert_equal '.sp
+Enter the \c
+.URL "cat" "\f(CRcat\fP" " "
+command.', output.lines.entries[-4..-1].join
+    end
+  end
+
+  context 'MTO macro' do
+    test 'should convert inline email macro into MTO macro' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+First paragraph.
+
+mailto:doc@example.org[Contact the doc])
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert_equal '.sp
+First paragraph.
+.sp
+.MTO "doc\\(atexample.org" "Contact the doc" ""', output.lines.entries[-4..-1].join
+    end
+
+    test 'should set text of MTO macro to blank for implicit email' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+Bugs fixed daily by doc@example.org.)
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert output.end_with? 'Bugs fixed daily by \\c
+.MTO "doc\\(atexample.org" "" "."'
+    end
   end
 
   context 'Table' do
+    test 'should create header, body, and footer rows in correct order' do
+      input = %(#{SAMPLE_MANPAGE_HEADER}
+
+[%header%footer]
+|===
+|Header
+|Body 1
+|Body 2
+|Footer
+|===)
+      output = Asciidoctor.convert input, :backend => :manpage
+      assert output.end_with? 'allbox tab(:);
+lt.
+T{
+.sp
+Header
+T}
+T{
+.sp
+Body 1
+T}
+T{
+.sp
+Body 2
+T}
+T{
+.sp
+Footer
+T}
+.TE
+.sp'
+    end
+
     test 'should manify normal table cell content' do
       input = %(#{SAMPLE_MANPAGE_HEADER}
 
-[%header%footer,cols=2*]
 |===
 |*Col A* |_Col B_
+
 |*bold* |`mono`
 |_italic_ | #mark#
 |===)
diff -pruN 1.5.6.2-2/test/options_test.rb 1.5.7-1/test/options_test.rb
--- 1.5.6.2-2/test/options_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/options_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -31,6 +31,24 @@ context 'Options' do
     assert_includes output, '.TH "ASCIIDOCTOR"'
   end
 
+  test 'should print message and return error code 1 when manpage is not found' do
+    old_manpage_path = ENV['ASCIIDOCTOR_MANPAGE_PATH']
+    begin
+      ENV['ASCIIDOCTOR_MANPAGE_PATH'] = (manpage_path = fixture_path 'no-such-file.1')
+      redirect_streams do |out, stderr|
+        exitval = Asciidoctor::Cli::Options.parse!(%w(-h manpage))
+        assert_equal 1, exitval
+        assert_equal %(asciidoctor: FAILED: manual page not found: #{manpage_path}), stderr.string.chomp
+      end
+    ensure
+      if old_manpage_path
+        ENV['ASCIIDOCTOR_MANPAGE_PATH'] = old_manpage_path
+      else
+        ENV.delete 'ASCIIDOCTOR_MANPAGE_PATH'
+      end
+    end
+  end
+
   test 'should return error code 1 when invalid option present' do
     redirect_streams do |stdout, stderr|
       exitval = Asciidoctor::Cli::Options.parse!(%w(--foobar))
@@ -58,7 +76,7 @@ context 'Options' do
   test 'should emit warning when unparsed options remain' do
     redirect_streams do |stdout, stderr|
       options = Asciidoctor::Cli::Options.parse!(%w(-b docbook - -))
-      assert options.is_a? Hash
+      assert_kind_of Hash, options
       assert_match(/asciidoctor: WARNING: extra arguments .*/, stderr.string.chomp)
     end
   end
@@ -184,6 +202,33 @@ context 'Options' do
     end
   end
 
+  test 'should set failure level to FATAL by default' do
+    options = Asciidoctor::Cli::Options.parse! %W(test/fixtures/sample.asciidoc)
+    assert_equal ::Logger::Severity::FATAL, options[:failure_level]
+  end
+
+  test 'should allow failure level to be set to WARN' do
+    %w(w warn WARN warning WARNING).each do |val|
+      options = Asciidoctor::Cli::Options.parse!(%W(--failure-level=#{val} test/fixtures/sample.asciidoc))
+      assert_equal ::Logger::Severity::WARN, options[:failure_level]
+    end
+  end
+
+  test 'should allow failure level to be set to ERROR' do
+    %w(e err ERR error ERROR).each do |val|
+      options = Asciidoctor::Cli::Options.parse!(%W(--failure-level=#{val} test/fixtures/sample.asciidoc))
+      assert_equal ::Logger::Severity::ERROR, options[:failure_level]
+    end
+  end
+
+  test 'should not allow failure level to be set to unknown value' do
+    exit_code, messages = redirect_streams do |_, err|
+      [(Asciidoctor::Cli::Options.parse! %W(--failure-level=foobar test/fixtures/sample.asciidoc)), err.string]
+    end
+    assert_equal 1, exit_code
+    assert_includes messages, 'invalid argument: --failure-level=foobar'
+  end
+
   test 'should set verbose to 2 when -v flag is specified' do
     options = Asciidoctor::Cli::Options.parse!(%w(-v test/fixtures/sample.asciidoc))
     assert_equal 2, options[:verbose]
diff -pruN 1.5.6.2-2/test/paragraphs_test.rb 1.5.7-1/test/paragraphs_test.rb
--- 1.5.6.2-2/test/paragraphs_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/paragraphs_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -194,7 +194,7 @@ Note that multi-entry terms generate sep
       EOS
 
       output = render_embedded_string input
-      assert output.include?('*&lt;Hey Jude&gt;*')
+      assert_includes output, '*&lt;Hey Jude&gt;*'
     end
 
     test 'normal paragraph should honor specialchars shorthand' do
@@ -204,7 +204,7 @@ Note that multi-entry terms generate sep
       EOS
 
       output = render_embedded_string input
-      assert output.include?('*&lt;Hey Jude&gt;*')
+      assert_includes output, '*&lt;Hey Jude&gt;*'
     end
 
     test 'should add a hardbreak at end of each line when hardbreaks option is set' do
@@ -218,7 +218,7 @@ lips
       output = render_embedded_string input
       assert_css 'br', output, 2
       assert_xpath '//p', output, 1
-      assert output.include?("<p>read<br>\nmy<br>\nlips</p>")
+      assert_includes output, "<p>read<br>\nmy<br>\nlips</p>"
     end
   end
 
@@ -371,7 +371,7 @@ _GET /groups/link:#group-id[\{group-id\}
       EOS
 
       output = render_embedded_string input
-      assert output.include?('<pre class="content"><em>GET /groups/<a href="#group-id">{group-id}</a></em></pre>')
+      assert_includes output, '<pre class="content"><em>GET /groups/<a href="#group-id">{group-id}</a></em></pre>'
     end
 
     test 'quote paragraph should honor explicit subs list' do
@@ -382,7 +382,7 @@ _GET /groups/link:#group-id[\{group-id\}
       EOS
 
       output = render_embedded_string input
-      assert output.include?('*Hey Jude*')
+      assert_includes output, '*Hey Jude*'
     end
   end
 
@@ -465,6 +465,9 @@ As you can see here.
 
 [quote]
 Wise words from a wise person.
+
+[open]
+Make it what you want.
         EOS
 
         output = render_string input, :backend => 'docbook'
@@ -473,6 +476,18 @@ Wise words from a wise person.
         assert_css 'sidebar > simpara', output, 1
         assert_css 'informalexample > simpara', output, 1
         assert_css 'blockquote > simpara', output, 1
+        assert_css 'chapter > simpara', output, 1
+      end
+
+      test 'should convert open paragraph to open block' do
+        input = <<-EOS
+[open]
+Make it what you want.
+        EOS
+
+        output = render_embedded_string input
+        assert_css '.openblock', output, 1
+        assert_css '.openblock p', output, 0
       end
 
       test 'should wrap text in simpara for styled paragraphs with title when rendered to DocBook' do
@@ -536,13 +551,11 @@ Wise words from a wise person.
 
       test 'should output nil and warn if first block is not a paragraph' do
         input = '* bullet'
-        output = nil
-        warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           output =  render_string input, :doctype => 'inline'
-          err.string
+          assert_nil output
+          assert_message logger, :WARN, '~no inline candidate'
         end
-        assert_nil output
-        assert_includes warnings, 'no inline candidate'
       end
     end
   end
diff -pruN 1.5.6.2-2/test/parser_test.rb 1.5.7-1/test/parser_test.rb
--- 1.5.6.2-2/test/parser_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/parser_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -351,7 +351,7 @@ context "Parser" do
     attributes = {1 => '%header', 'options' => 'footer', 'footer-option' => ''}
     style = Asciidoctor::Parser.parse_style_attribute(attributes)
     assert_nil style
-    assert_equal 'header,footer', attributes['options']
+    assert_equal 'footer,header', attributes['options']
     assert_equal '', attributes['header-option']
     assert_equal '', attributes['footer-option']
   end
@@ -526,6 +526,13 @@ context "Parser" do
     assert_equal 'John Smith', metadata['author_2']
   end
 
+  test 'skips blank author entries in implicit author line' do
+    metadata, _ = parse_header_metadata 'Doc Writer; ; John Smith <john.smith@asciidoc.org>;'
+    assert_equal 2, metadata['authorcount']
+    assert_equal 'Doc Writer', metadata['author_1']
+    assert_equal 'John Smith', metadata['author_2']
+  end
+
   test 'parse name with more than 3 parts in author attribute' do
     doc = empty_document
     parse_header_metadata ':author: Leroy  Harold  Scherer,  Jr.', doc
@@ -535,6 +542,14 @@ context "Parser" do
     assert_equal 'Scherer, Jr.', doc.attributes['lastname']
   end
 
+  test 'sets authorcount to 0 if document has no authors' do
+    input = ''
+    doc = empty_document
+    metadata, _ = parse_header_metadata input, doc
+    assert_equal 0, doc.attributes['authorcount']
+    assert_equal 0, metadata['authorcount']
+  end
+
   test 'does not drop name joiner when using multiple authors' do
     input = <<-EOS
 Kismet Chameleon; Lazarus het_Draeke
@@ -712,6 +727,20 @@ v0.0.7, 2013-12-18
     assert_equal '2013-12-18', metadata['revdate']
   end
 
+  test 'break header at line with three forward slashes' do
+    input = <<-EOS
+Joe Cool
+v1.0
+///
+stuff
+    EOS
+    metadata, _ = parse_header_metadata input
+    assert_equal 7, metadata.size
+    assert_equal 1, metadata['authorcount']
+    assert_equal 'Joe Cool', metadata['author']
+    assert_equal '1.0', metadata['revnumber']
+  end
+
   test 'attribute entry overrides generated author initials' do
     doc = empty_document
     metadata, _ = parse_header_metadata %(Stuart Rackham <founder@asciidoc.org>\n:Author Initials: SJR), doc
diff -pruN 1.5.6.2-2/test/paths_test.rb 1.5.7-1/test/paths_test.rb
--- 1.5.6.2-2/test/paths_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/paths_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -89,6 +89,7 @@ context 'Path Resolver' do
     end
 
     test 'posixifies windows paths' do
+      @resolver.file_separator = '\\'
       assert_equal '/images', @resolver.web_path('\\images')
       assert_equal '../images', @resolver.web_path('..\\images')
       assert_equal '/images', @resolver.web_path('\\..\\images')
@@ -103,29 +104,47 @@ context 'Path Resolver' do
 
   context 'System Paths' do
     JAIL = '/home/doctor/docs'
+    default_logger = Asciidoctor::LoggerManager.logger
 
     def setup
       @resolver = Asciidoctor::PathResolver.new
+      @logger = (Asciidoctor::LoggerManager.logger = Asciidoctor::MemoryLogger.new)
     end
 
-    test 'prevents access to paths outside of jail' do
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '../../../../../css', %(#{JAIL}/assets/stylesheets), JAIL), err.string]
+    teardown do
+      Asciidoctor::LoggerManager.logger = default_logger
+    end
+
+    test 'raises security error if jail is not an absolute path' do
+      begin
+        @resolver.system_path('images/tiger.png', '/etc', 'foo')
+        flunk 'Expecting SecurityError to be raised'
+      rescue SecurityError
       end
+    end
+
+    #test 'raises security error if jail is not a canoncial path' do
+    #  begin
+    #    @resolver.system_path('images/tiger.png', '/etc', %(#{JAIL}/../foo))
+    #    flunk 'Expecting SecurityError to be raised'
+    #  rescue SecurityError
+    #  end
+    #end
+
+    test 'prevents access to paths outside of jail' do
+      result = @resolver.system_path '../../../../../css', %(#{JAIL}/assets/stylesheets), JAIL
       assert_equal %(#{JAIL}/css), result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'path has illegal reference to ancestor of jail; recovering automatically'
 
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '/../../../../../css', %(#{JAIL}/assets/stylesheets), JAIL), err.string]
-      end
+      @logger.clear
+      result = @resolver.system_path '/../../../../../css', %(#{JAIL}/assets/stylesheets), JAIL
       assert_equal %(#{JAIL}/css), result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
 
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '../../../css', '../../..', JAIL), err.string]
-      end
+      @logger.clear
+      result = @resolver.system_path '../../../css', '../../..', JAIL
       assert_equal %(#{JAIL}/css), result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'path has illegal reference to ancestor of jail; recovering automatically'
     end
 
     test 'throws exception for illegal path access if recover is false' do
@@ -141,15 +160,39 @@ context 'Path Resolver' do
       assert_equal "#{JAIL}/assets/stylesheets", @resolver.system_path(nil, "#{JAIL}/assets/stylesheets", JAIL)
     end
 
+    test 'expands parent references in start path if target is empty' do
+      assert_equal "#{JAIL}/stylesheets", @resolver.system_path('', "#{JAIL}/assets/../stylesheets", JAIL)
+    end
+
+    test 'expands parent references in start path if target is not empty' do
+      assert_equal "#{JAIL}/stylesheets/site.css", @resolver.system_path('site.css', "#{JAIL}/assets/../stylesheets", JAIL)
+    end
+
     test 'resolves start path if target is dot' do
       assert_equal "#{JAIL}/assets/stylesheets", @resolver.system_path('.', "#{JAIL}/assets/stylesheets", JAIL)
       assert_equal "#{JAIL}/assets/stylesheets", @resolver.system_path('./', "#{JAIL}/assets/stylesheets", JAIL)
     end
 
-    test 'treats absolute target as relative when jail is specified' do
-      assert_equal "#{JAIL}/assets/stylesheets", @resolver.system_path('/', "#{JAIL}/assets/stylesheets", JAIL)
-      assert_equal "#{JAIL}/assets/stylesheets/foo", @resolver.system_path('/foo', "#{JAIL}/assets/stylesheets", JAIL)
-      assert_equal "#{JAIL}/assets/foo", @resolver.system_path('/../foo', "#{JAIL}/assets/stylesheets", JAIL)
+    test 'treats absolute target outside of jail as relative when jail is specified' do
+      result = @resolver.system_path '/', "#{JAIL}/assets/stylesheets", JAIL
+      assert_equal JAIL, result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      result = @resolver.system_path '/foo', "#{JAIL}/assets/stylesheets", JAIL
+      assert_equal "#{JAIL}/foo", result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      result = @resolver.system_path '/../foo', "#{JAIL}/assets/stylesheets", JAIL
+      assert_equal "#{JAIL}/foo", result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      @resolver.file_separator = '\\'
+      result = @resolver.system_path 'baz.adoc', 'C:/foo', 'C:/bar'
+      assert_equal 'C:/bar/baz.adoc', result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
     end
 
     test 'allows use of absolute target or start if resolved path is sub-path of jail' do
@@ -158,6 +201,9 @@ context 'Path Resolver' do
       assert_equal "#{JAIL}/my/path", @resolver.system_path('', "#{JAIL}/my/path", JAIL)
       assert_equal "#{JAIL}/my/path", @resolver.system_path(nil, "#{JAIL}/my/path", JAIL)
       assert_equal "#{JAIL}/my/path", @resolver.system_path('path', "#{JAIL}/my", JAIL)
+      assert_equal '/foo/bar/baz.adoc', @resolver.system_path('/foo/bar/baz.adoc', nil, '/')
+      assert_equal '/foo/bar/baz.adoc', @resolver.system_path('baz.adoc', '/foo/bar', '/')
+      assert_equal '/foo/bar/baz.adoc', @resolver.system_path('baz.adoc', 'foo/bar', '/')
     end
 
     test 'uses jail path if start path is empty' do
@@ -165,20 +211,59 @@ context 'Path Resolver' do
       assert_equal "#{JAIL}/images/tiger.png", @resolver.system_path('images/tiger.png', nil, JAIL)
     end
 
-    test 'raises security error if start is not contained within jail' do
+    test 'warns if start is not contained within jail' do
+      result = @resolver.system_path 'images/tiger.png', '/etc', JAIL
+      assert_equal %(#{JAIL}/images/tiger.png), result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      result = @resolver.system_path '.', '/etc', JAIL
+      assert_equal JAIL, result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      @resolver.file_separator = '\\'
+      result = @resolver.system_path '.', 'C:/foo', 'C:/bar'
+      assert_equal 'C:/bar', result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+    end
+
+    test 'allows start path to be parent of jail if resolved target is inside jail' do
+      assert_equal "#{JAIL}/foo/path", @resolver.system_path('foo/path', JAIL, "#{JAIL}/foo")
+      @resolver.file_separator = '\\'
+      assert_equal "C:/dev/project/README.adoc", @resolver.system_path('project/README.adoc', 'C:/dev', 'C:/dev/project')
+    end
+
+    test 'relocates target to jail if resolved value fails outside of jail' do
+      result = @resolver.system_path 'bar/baz.adoc', JAIL, "#{JAIL}/foo"
+      assert_equal %(#{JAIL}/foo/bar/baz.adoc), result
+      assert_message @logger, :WARN, 'path is outside of jail; recovering automatically'
+
+      @logger.clear
+      @resolver.file_separator = '\\'
+      result = @resolver.system_path 'bar/baz.adoc', 'D:/', 'C:/foo'
+      assert_equal 'C:/foo/bar/baz.adoc', result
+      assert_message @logger, :WARN, '~outside of jail root'
+    end
+
+    test 'raises security error if start is not contained within jail and recover is disabled' do
       begin
-        @resolver.system_path('images/tiger.png', '/etc', JAIL)
+        @resolver.system_path('images/tiger.png', '/etc', JAIL, :recover => false)
         flunk 'Expecting SecurityError to be raised'
       rescue SecurityError
       end
 
       begin
-        @resolver.system_path('.', '/etc', JAIL)
+        @resolver.system_path('.', '/etc', JAIL, :recover => false)
         flunk 'Expecting SecurityError to be raised'
       rescue SecurityError
       end
     end
 
+    test 'expands parent references in absolute path if jail is not specified' do
+      assert_equal '/etc/stylesheet.css', @resolver.system_path('/usr/share/../../etc/stylesheet.css')
+    end
+
     test 'resolves absolute directory if jail is not specified' do
       assert_equal '/usr/share/stylesheet.css', @resolver.system_path('/usr/share/stylesheet.css', '/home/dallen/docs/assets/stylesheets')
     end
@@ -208,19 +293,19 @@ context 'Path Resolver' do
       assert_equal "#{pwd}/.images/tiger.png", @resolver.system_path('.images/tiger.png', nil)
     end
 
-    test 'resolves and normalizes start with target is empty' do
+    test 'resolves and normalizes start when target is empty' do
       pwd = File.expand_path Dir.pwd
       assert_equal '/home/doctor/docs', (@resolver.system_path '', '/home/doctor/docs')
+      assert_equal '/home/doctor/docs', (@resolver.system_path '', '/home/doctor/./docs')
       assert_equal '/home/doctor/docs', (@resolver.system_path nil, '/home/doctor/docs')
+      assert_equal '/home/doctor/docs', (@resolver.system_path nil, '/home/doctor/./docs')
       assert_equal %(#{pwd}/assets/images), (@resolver.system_path nil, 'assets/images')
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '', '../assets/images', JAIL), err.string]
-      end
-      assert_equal %(#{JAIL}/assets/images), result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      @resolver.system_path '', '../assets/images', JAIL
+      assert_message @logger, :WARN, 'path has illegal reference to ancestor of jail; recovering automatically'
     end
 
     test 'posixifies windows paths' do
+      @resolver.file_separator = '\\'
       assert_equal "#{JAIL}/assets/css", @resolver.system_path('..\\css', 'assets\\stylesheets', JAIL)
     end
 
@@ -229,17 +314,14 @@ context 'Path Resolver' do
 
       assert_equal 'C:/data/docs', (@resolver.system_path '..', 'C:\\data\\docs\\assets', 'C:\\data\\docs')
 
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '..\\..', 'C:\\data\\docs\\assets', 'C:\\data\\docs'), err.string]
-      end
+      result = @resolver.system_path '..\\..', 'C:\\data\\docs\\assets', 'C:\\data\\docs'
       assert_equal 'C:/data/docs', result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'path has illegal reference to ancestor of jail; recovering automatically'
 
-      result, warnings = redirect_streams do |_, err|
-        [(@resolver.system_path '..\\..\\css', 'C:\\data\\docs\\assets', 'C:\\data\\docs'), err.string]
-      end
+      @logger.clear
+      result = @resolver.system_path '..\\..\\css', 'C:\\data\\docs\\assets', 'C:\\data\\docs'
       assert_equal 'C:/data/docs/css', result
-      assert_includes warnings, 'path has illegal reference to ancestor of jail'
+      assert_message @logger, :WARN, 'path has illegal reference to ancestor of jail; recovering automatically'
     end
 
     test 'should calculate relative path' do
diff -pruN 1.5.6.2-2/test/preamble_test.rb 1.5.7-1/test/preamble_test.rb
--- 1.5.6.2-2/test/preamble_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/preamble_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -145,7 +145,7 @@ The axe came swinging.
 
       d = document_from_string(input)
       assert_equal 'book', d.doctype
-      output = d.render
+      output = d.convert
       assert_xpath '//h1', output, 3
       assert_xpath %{//*[@id="preamble"]//p[text() = "Back then#{decode_char 8230}#{decode_char 8203}"]}, output, 1
   end
diff -pruN 1.5.6.2-2/test/reader_test.rb 1.5.7-1/test/reader_test.rb
--- 1.5.6.2-2/test/reader_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/reader_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -5,7 +5,7 @@ unless defined? ASCIIDOCTOR_PROJECT_DIR
 end
 
 class ReaderTest < Minitest::Test
-  DIRNAME = File.expand_path(File.dirname(__FILE__))
+  DIRNAME = File.expand_path File.dirname __FILE__
 
   SAMPLE_DATA = <<-EOS.chomp.split(::Asciidoctor::LF)
 first line
@@ -156,6 +156,12 @@ third line
         assert_equal 1, reader.lineno
       end
 
+      test 'peek_lines should peek all lines if no arguments are given' do
+        reader = Asciidoctor::Reader.new SAMPLE_DATA
+        assert_equal SAMPLE_DATA, reader.peek_lines
+        assert_equal 1, reader.lineno
+      end
+
       test 'peek_lines should not invert order of lines' do
         reader = Asciidoctor::Reader.new SAMPLE_DATA
         assert_equal SAMPLE_DATA, reader.lines
@@ -251,13 +257,13 @@ third line
         reader = Asciidoctor::Reader.new SAMPLE_DATA, 'sample.adoc'
         reader.read_line
         assert_equal 'sample.adoc: line 2', reader.line_info
-        assert_equal 'sample.adoc: line 2', reader.next_line_info
+        assert_equal 'sample.adoc: line 2', reader.cursor.to_s
       end
 
-      test 'prev_line_info should return file name and line number of previous line read' do
+      test 'cursor_at_prev_line should return file name and line number of previous line read' do
         reader = Asciidoctor::Reader.new SAMPLE_DATA, 'sample.adoc'
         reader.read_line
-        assert_equal 'sample.adoc: line 1', reader.prev_line_info
+        assert_equal 'sample.adoc: line 1', reader.cursor_at_prev_line.to_s
       end
     end
 
@@ -361,6 +367,50 @@ This is a paragraph outside the block.
         assert_equal lines[1, 4], result
         assert_equal '--', reader.peek_line
       end
+
+      test 'read lines until terminator' do
+        lines = <<-EOS.each_line.to_a
+****
+captured
+
+also captured
+****
+
+not captured
+        EOS
+
+        expected = ['captured', '', 'also captured']
+
+        doc = empty_safe_document :base_dir => DIRNAME
+        reader = Asciidoctor::PreprocessorReader.new doc, lines, nil, :normalize => true
+        terminator = reader.read_line
+        result = reader.read_lines_until :terminator => terminator, :skip_processing => true
+        assert_equal expected, result
+        refute reader.unterminated
+      end
+
+      test 'should flag reader as unterminated if reader reaches end of source without finding terminator' do
+        lines = <<-EOS.each_line.to_a
+****
+captured
+
+also captured
+
+captured yet again
+        EOS
+
+        expected = lines[1..-1].map {|l| l.chomp }
+
+        using_memory_logger do |logger|
+          doc = empty_safe_document :base_dir => DIRNAME
+          reader = Asciidoctor::PreprocessorReader.new doc, lines, nil, :normalize => true
+          terminator = reader.peek_line
+          result = reader.read_lines_until :terminator => terminator, :skip_first_line => true, :skip_processing => true
+          assert_equal expected, result
+          assert reader.unterminated
+          assert_message logger, :WARN, '<stdin>: line 1: unterminated **** block', Hash
+        end
+      end
     end
   end
 
@@ -368,7 +418,7 @@ This is a paragraph outside the block.
     context 'Type hierarchy' do
       test 'PreprocessorReader should extend from Reader' do
         reader = empty_document.reader
-        assert reader.is_a?(Asciidoctor::Reader)
+        assert_kind_of Asciidoctor::PreprocessorReader, reader
       end
 
       test 'PreprocessorReader should invoke or emulate Reader initializer' do
@@ -489,6 +539,36 @@ preamble
         assert_nil reader.file
         assert_equal '<stdin>', reader.path
       end
+
+      test 'PreprocessorReader#push_include method should set path from file automatically if not specified' do
+        lines = %w(a b c)
+        doc = Asciidoctor::Document.new lines
+        reader = doc.reader
+        append_lines = %w(one two three)
+        reader.push_include append_lines, '/tmp/lines.adoc'
+        assert_equal '/tmp/lines.adoc', reader.file
+        assert_equal 'lines.adoc', reader.path
+      end
+
+      test 'PreprocessorReader#push_include method should accept file as a URI and compute dir and path' do
+        file_uri = ::URI.parse 'http://example.com/docs/file.adoc'
+        dir_uri = ::URI.parse 'http://example.com/docs'
+        reader = empty_document.reader
+        reader.push_include %w(one two three), file_uri
+        assert_same file_uri, reader.file
+        assert_equal dir_uri, reader.dir
+        assert_equal 'file.adoc', reader.path
+      end
+
+      test 'PreprocessorReader#push_include method should accept file as a top-level URI and compute dir and path' do
+        file_uri = ::URI.parse 'http://example.com/index.adoc'
+        dir_uri = ::URI.parse 'http://example.com'
+        reader = empty_document.reader
+        reader.push_include %w(one two three), file_uri
+        assert_same file_uri, reader.file
+        assert_equal dir_uri, reader.dir
+        assert_equal 'index.adoc', reader.path
+      end
     end
 
     context 'Include Directive' do
@@ -507,8 +587,20 @@ include::fixtures/include-file.asciidoc[
         EOS
 
         doc = document_from_string input, :safe => :safe, :header_footer => false, :base_dir => DIRNAME
-        output = doc.render
+        output = doc.convert
         assert_match(/included content/, output)
+        assert doc.catalog[:includes]['fixtures/include-file']
+      end
+
+      test 'should not track include in catalog for non-AsciiDoc include files' do
+        input = <<-EOS
+----
+include::fixtures/circle.svg[]
+----
+        EOS
+
+        doc = document_from_string input, :safe => :safe, :header_footer => false, :base_dir => DIRNAME
+        assert doc.catalog[:includes].empty?
       end
 
       test 'include directive should resolve file with spaces in name' do
@@ -521,7 +613,7 @@ include::fixtures/include file.asciidoc[
         begin
           FileUtils.cp include_file, include_file_with_sp
           doc = document_from_string input, :safe => :safe, :header_footer => false, :base_dir => DIRNAME
-          output = doc.render
+          output = doc.convert
           assert_match(/included content/, output)
         ensure
           FileUtils.rm include_file_with_sp
@@ -538,7 +630,7 @@ include::fixtures/include{sp}file.asciid
         begin
           FileUtils.cp include_file, include_file_with_sp
           doc = document_from_string input, :safe => :safe, :header_footer => false, :base_dir => DIRNAME
-          output = doc.render
+          output = doc.convert
           assert_match(/included content/, output)
         ensure
           FileUtils.rm include_file_with_sp
@@ -565,7 +657,7 @@ include::fixtures/parent-include.adoc[]
 
         assert_equal 'first line of parent', reader.read_line
 
-        assert_equal 'fixtures/parent-include.adoc: line 1', reader.prev_line_info
+        assert_equal 'fixtures/parent-include.adoc: line 1', reader.cursor_at_prev_line.to_s
         assert_equal parent_include_docfile, reader.file
         assert_equal fixtures_dir, reader.dir
         assert_equal 'fixtures/parent-include.adoc', reader.path
@@ -574,7 +666,7 @@ include::fixtures/parent-include.adoc[]
 
         assert_equal 'first line of child', reader.read_line
 
-        assert_equal 'fixtures/child-include.adoc: line 1', reader.prev_line_info
+        assert_equal 'fixtures/child-include.adoc: line 1', reader.cursor_at_prev_line.to_s
         assert_equal child_include_docfile, reader.file
         assert_equal fixtures_dir, reader.dir
         assert_equal 'fixtures/child-include.adoc', reader.path
@@ -583,7 +675,7 @@ include::fixtures/parent-include.adoc[]
 
         assert_equal 'first line of grandchild', reader.read_line
 
-        assert_equal 'fixtures/grandchild-include.adoc: line 1', reader.prev_line_info
+        assert_equal 'fixtures/grandchild-include.adoc: line 1', reader.cursor_at_prev_line.to_s
         assert_equal grandchild_include_docfile, reader.file
         assert_equal fixtures_dir, reader.dir
         assert_equal 'fixtures/grandchild-include.adoc', reader.path
@@ -600,12 +692,31 @@ include::fixtures/parent-include.adoc[]
 
         assert_equal 'last line of parent', reader.read_line
 
-        assert_equal 'fixtures/parent-include.adoc: line 5', reader.prev_line_info
+        assert_equal 'fixtures/parent-include.adoc: line 5', reader.cursor_at_prev_line.to_s
         assert_equal parent_include_docfile, reader.file
         assert_equal fixtures_dir, reader.dir
         assert_equal 'fixtures/parent-include.adoc', reader.path
       end
 
+      test 'missing file referenced by include directive is skipped when optional option is set' do
+        input = <<-EOS
+include::fixtures/no-such-file.adoc[opts=optional]
+
+trailing content
+        EOS
+
+        begin
+          using_memory_logger do |logger|
+            doc = document_from_string input, :safe => :safe, :base_dir => DIRNAME
+            assert_equal 1, doc.blocks.size
+            assert_equal ['trailing content'], doc.blocks[0].lines
+            assert logger.empty?
+          end
+        rescue
+          flunk 'include directive should not raise exception on missing file'
+        end
+      end
+
       test 'missing file referenced by include directive is replaced by warning' do
         input = <<-EOS
 include::fixtures/no-such-file.adoc[]
@@ -614,13 +725,13 @@ trailing content
         EOS
 
         begin
-          doc, warnings = redirect_streams do |_, err|
-            [(document_from_string input, :safe => :safe, :base_dir => DIRNAME), err.string]
+          using_memory_logger do |logger|
+            doc = document_from_string input, :safe => :safe, :base_dir => DIRNAME
+            assert_equal 2, doc.blocks.size
+            assert_equal ['Unresolved directive in <stdin> - include::fixtures/no-such-file.adoc[]'], doc.blocks[0].lines
+            assert_equal ['trailing content'], doc.blocks[1].lines
+            assert_message logger, :ERROR, '~<stdin>: line 1: include file not found', Hash
           end
-          assert_equal 2, doc.blocks.size
-          assert_equal ['Unresolved directive in <stdin> - include::fixtures/no-such-file.adoc[]'], doc.blocks[0].lines
-          assert_equal ['trailing content'], doc.blocks[1].lines
-          assert_includes warnings, 'include file not found'
         rescue
           flunk 'include directive should not raise exception on missing file'
         end
@@ -636,13 +747,13 @@ trailing content
         EOS
 
         begin
-          doc, warnings = redirect_streams do |_, err|
-            [(document_from_string input, :safe => :safe, :base_dir => DIRNAME), err.string]
+          using_memory_logger do |logger|
+            doc = document_from_string input, :safe => :safe, :base_dir => DIRNAME
+            assert_equal 2, doc.blocks.size
+            assert_equal ['Unresolved directive in <stdin> - include::fixtures/chapter-a.adoc[]'], doc.blocks[0].lines
+            assert_equal ['trailing content'], doc.blocks[1].lines
+            assert_message logger, :ERROR, '~<stdin>: line 1: include file not readable', Hash
           end
-          assert_equal 2, doc.blocks.size
-          assert_equal ['Unresolved directive in <stdin> - include::fixtures/chapter-a.adoc[]'], doc.blocks[0].lines
-          assert_equal ['trailing content'], doc.blocks[1].lines
-          assert_includes warnings, 'include file not readable'
         rescue
           flunk 'include directive should not raise exception on missing file'
         ensure
@@ -664,7 +775,6 @@ include::#{include_path}[]
       end
 
       test 'include directive can retrieve data from uri' do
-        #url = 'http://echo.jsontest.com/name/asciidoctor'
         url = %(http://#{resolve_localhost}:9876/name/asciidoctor)
         input = <<-EOS
 ....
@@ -680,6 +790,92 @@ include::#{url}[]
         assert_match(expect, output)
       end
 
+      test 'nested include directives are resolved relative to current file' do
+        input = <<-EOS
+....
+include::fixtures/outer-include.adoc[]
+....
+        EOS
+
+        output = render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
+        expected = 'first line of outer
+
+first line of middle
+
+first line of inner
+
+last line of inner
+
+last line of middle
+
+last line of outer'
+        assert_includes output, expected
+      end
+
+      test 'nested remote include directive is resolved relative to uri of current file' do
+        url = %(http://#{resolve_localhost}:9876/fixtures/outer-include.adoc)
+        input = <<-EOS
+....
+include::#{url}[]
+....
+        EOS
+        output = using_test_webserver do
+          render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
+        end
+
+        expected = 'first line of outer
+
+first line of middle
+
+first line of inner
+
+last line of inner
+
+last line of middle
+
+last line of outer'
+        assert_includes output, expected
+      end
+
+      test 'nested remote include directive that cannot be resolved does not crash processor' do
+        include_url = %(http://#{resolve_localhost}:9876/fixtures/file-with-missing-include.adoc)
+        nested_include_url = 'no-such-file.adoc'
+        input = <<-EOS
+....
+include::#{include_url}[]
+....
+        EOS
+        begin
+          using_memory_logger do |logger|
+            result = using_test_webserver do
+              render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
+            end
+            assert_includes result, %(Unresolved directive in #{include_url} - include::#{nested_include_url}[])
+            assert_message logger, :ERROR, %(#{include_url}: line 1: include uri not readable: http://#{resolve_localhost}:9876/fixtures/#{nested_include_url}), Hash
+          end
+        rescue
+          flunk 'include directive should not raise exception on missing file'
+        end
+      end
+
+      test 'tag filtering is supported for remote includes' do
+        url = %(http://#{resolve_localhost}:9876/fixtures/tagged-class.rb)
+        input = <<-EOS
+[source,ruby]
+----
+include::#{url}[tag=init,indent=0]
+----
+        EOS
+        output = using_test_webserver do
+          render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
+        end
+
+        expected = '<code class="language-ruby" data-lang="ruby">def initialize breed
+  @breed = breed
+end</code>'
+        assert_includes output, expected
+      end
+
       test 'inaccessible uri referenced by include directive does not crash processor' do
         url = %(http://#{resolve_localhost}:9876/no_such_file)
         input = <<-EOS
@@ -689,22 +885,20 @@ include::#{url}[]
         EOS
 
         begin
-          output = warnings = nil
-          redirect_streams do |_, err|
+          using_memory_logger do |logger|
             output = using_test_webserver do
               render_embedded_string input, :safe => :safe, :attributes => {'allow-uri-read' => ''}
             end
-            warnings = err.string
+            refute_nil output
+            assert_match(/Unresolved directive/, output)
+            assert_message logger, :ERROR, %(<stdin>: line 2: include uri not readable: #{url}), Hash
           end
-          refute_nil output
-          assert_match(/Unresolved directive/, output)
-          assert_includes warnings, 'include uri not readable'
         rescue
           flunk 'include directive should not raise exception on inaccessible uri'
         end
       end
 
-      test 'include directive supports line selection' do
+      test 'include directive supports selecting lines by line number' do
         input = <<-EOS
 include::fixtures/include-file.asciidoc[lines=1;3..4;6..-1]
         EOS
@@ -721,7 +915,7 @@ include::fixtures/include-file.asciidoc[
         assert_match(/last line of included content/, output)
       end
 
-      test 'include directive supports line selection using quoted attribute value' do
+      test 'include directive supports line ranges specified in quoted attribute value' do
         input = <<-EOS
 include::fixtures/include-file.asciidoc[lines="1, 3..4 , 6 .. -1"]
         EOS
@@ -750,7 +944,7 @@ include::fixtures/include-file.asciidoc[
         assert_includes output, 'last line of included content'
       end
 
-      test 'include directive supports tagged selection' do
+      test 'include directive supports selecting lines by tag' do
         input = <<-EOS
 include::fixtures/include-file.asciidoc[tag=snippetA]
         EOS
@@ -762,7 +956,7 @@ include::fixtures/include-file.asciidoc[
         refute_match(/included content/, output)
       end
 
-      test 'include directive supports multiple tagged selection' do
+      test 'include directive supports selecting lines by tags' do
         input = <<-EOS
 include::fixtures/include-file.asciidoc[tags=snippetA;snippetB]
         EOS
@@ -774,15 +968,16 @@ include::fixtures/include-file.asciidoc[
         refute_match(/included content/, output)
       end
 
-      test 'include directive supports tagged selection in language that uses circumfix comments' do
+      test 'include directive supports selecting lines by tag in language that uses circumfix comments' do
         {
           'include-file.xml' => '<snippet>content</snippet>',
-          'include-file.ml' => 'let s = SS.empty;;'
+          'include-file.ml' => 'let s = SS.empty;;',
+          'include-file.jsx' => '<p>Welcome to the club.</p>'
         }.each do |filename, expect|
           input = <<-EOS
-[source,xml,indent=0]
+[source,xml]
 ----
-include::fixtures/#{filename}[tag=snippet]
+include::fixtures/#{filename}[tag=snippet,indent=0]
 ----
           EOS
 
@@ -791,7 +986,24 @@ include::fixtures/#{filename}[tag=snippe
         end
       end
 
-      test 'include directive does not select lines with tag directives inside tagged selection' do
+      test 'include directive supports selecting tagged lines in file that has CRLF endlines' do
+        begin
+          tmp_include = Tempfile.new %w(include- .adoc)
+          tmp_include_dir, tmp_include_path = File.split tmp_include.path
+          tmp_include.write %(do not include\r\ntag::include-me[]\r\nincluded line\r\nend::include-me[]\r\ndo not include\r\n)
+          tmp_include.close
+          input = <<-EOS
+include::#{tmp_include_path}[tag=include-me]
+          EOS
+          output = render_embedded_string input, :safe => :safe, :base_dir => tmp_include_dir
+          assert_includes output, 'included line'
+          refute_includes output, 'do not include'
+        ensure
+          tmp_include.close!
+        end 
+      end
+
+      test 'include directive does not select lines with tag directives within selected tag region' do
         input = <<-EOS
 ++++
 include::fixtures/include-file.asciidoc[tags=snippet]
@@ -938,20 +1150,44 @@ end)
         assert_includes output, expected
       end
 
-      test 'should warn if tag is not found in include file' do
+      test 'should warn if specified tag is not found in include file' do
         input = <<-EOS
-include::fixtures/include-file.asciidoc[tag=snippetZ]
+include::fixtures/include-file.asciidoc[tag=no-such-tag]
         EOS
 
-        old_stderr = $stderr
-        $stderr = StringIO.new
-        begin
+        using_memory_logger do |logger|
           render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
-          warning = $stderr.tap(&:rewind).read
-          refute_nil warning
-          assert_match(/WARNING.*snippetZ/, warning)
-        ensure
-          $stderr = old_stderr
+          assert_message logger, :WARN, %(~<stdin>: line 1: tag 'no-such-tag' not found in include file), Hash
+        end
+      end
+
+      test 'should warn if specified tags are not found in include file' do
+        input = <<-EOS
+++++
+include::fixtures/include-file.asciidoc[tags=no-such-tag-b;no-such-tag-a]
+++++
+        EOS
+
+        using_memory_logger do |logger|
+          render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
+          # NOTE Ruby 1.8 swaps the order of the list for some silly reason
+          expected_tags = ::RUBY_MIN_VERSION_1_9 ? 'no-such-tag-b, no-such-tag-a' : 'no-such-tag-a, no-such-tag-b'
+          assert_message logger, :WARN, %(~<stdin>: line 2: tags '#{expected_tags}' not found in include file), Hash
+        end
+      end
+
+      test 'should warn if specified tag in include file is not closed' do
+        input = <<-EOS
+++++
+include::fixtures/unclosed-tag.adoc[tag=a]
+++++
+        EOS
+
+        using_memory_logger do |logger|
+          result = render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
+          assert_equal 'a', result
+          assert_message logger, :WARN, %(~<stdin>: line 2: detected unclosed tag 'a' starting at line 2 of include file), Hash
+          refute_nil logger.messages[0][:message][:include_location]
         end
       end
 
@@ -962,12 +1198,29 @@ include::fixtures/mismatched-end-tag.ado
 ++++
         EOS
 
-        result, warnings = redirect_streams do |out, err|
-          [(render_embedded_string input, :safe => :safe, :base_dir => DIRNAME), err.string]
+        inc_path = File.join DIRNAME, 'fixtures/mismatched-end-tag.adoc'
+        using_memory_logger do |logger|
+          result = render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
+          assert_equal %(a\nb), result
+          assert_message logger, :WARN, %(<stdin>: line 2: mismatched end tag (expected 'b' but found 'a') at line 5 of include file: #{inc_path}), Hash
+          refute_nil logger.messages[0][:message][:include_location]
+        end
+      end
+
+      test 'should warn if unexpected end tag is found in included file' do
+        input = <<-EOS
+++++
+include::fixtures/unexpected-end-tag.adoc[tags=a]
+++++
+        EOS
+
+        inc_path = File.join DIRNAME, 'fixtures/unexpected-end-tag.adoc'
+        using_memory_logger do |logger|
+          result = render_embedded_string input, :safe => :safe, :base_dir => DIRNAME
+          assert_equal 'a', result
+          assert_message logger, :WARN, %(<stdin>: line 2: unexpected end tag 'a' at line 4 of include file: #{inc_path}), Hash
+          refute_nil logger.messages[0][:message][:include_location]
         end
-        assert_equal %(a\nb), result
-        refute_nil warnings
-        assert_match(/WARNING: .*end tag/, warnings)
       end
 
       test 'include directive ignores tags attribute when empty' do
@@ -1065,7 +1318,7 @@ include::{fixturesdir}/include-file.{ext
         EOS
 
         doc = document_from_string input, :safe => :safe, :base_dir => DIRNAME
-        output = doc.render
+        output = doc.convert
         assert_match(/included content/, output)
       end
 
@@ -1074,13 +1327,13 @@ include::{fixturesdir}/include-file.{ext
 include::{foodir}/include-file.asciidoc[]
         EOS
 
-        line, warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           doc = empty_safe_document :base_dir => DIRNAME
           reader = Asciidoctor::PreprocessorReader.new doc, input, nil, :normalize => true
-          [reader.read_line, err.string]
+          line = reader.read_line
+          assert_equal 'Unresolved directive in <stdin> - include::{foodir}/include-file.asciidoc[]', line
+          assert_message logger, :WARN, 'dropping line containing reference to missing attribute: foodir'
         end
-        assert_equal 'Unresolved directive in <stdin> - include::{foodir}/include-file.asciidoc[]', line
-        assert_includes warnings, 'dropping line containing reference to missing attribute'
       end
 
       test 'line is dropped if target of include directive resolves to empty and attribute-missing attribute is not skip' do
@@ -1088,13 +1341,13 @@ include::{foodir}/include-file.asciidoc[
 include::{foodir}/include-file.asciidoc[]
         EOS
 
-        line, warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           doc = empty_safe_document :base_dir => DIRNAME, :attributes => {'attribute-missing' => 'drop'}
           reader = Asciidoctor::PreprocessorReader.new doc, input, nil, :normalize => true
-          [reader.read_line, err.string]
+          line = reader.read_line
+          assert_nil line
+          assert_message logger, :WARN, 'dropping line containing reference to missing attribute: foodir'
         end
-        assert_nil line
-        assert_includes warnings, 'dropping line containing reference to missing attribute'
       end
 
       test 'line following dropped include is not dropped' do
@@ -1103,13 +1356,13 @@ include::{foodir}/include-file.asciidoc[
 yo
         EOS
 
-        line, warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           doc = empty_safe_document :base_dir => DIRNAME, :attributes => {'attribute-missing' => 'drop'}
           reader = Asciidoctor::PreprocessorReader.new doc, input, nil, :normalize => true
-          [reader.read_line, err.string]
+          line = reader.read_line
+          assert_equal 'yo', line
+          assert_message logger, :WARN, 'dropping line containing reference to missing attribute: foodir'
         end
-        assert_equal 'yo', line
-        assert_includes warnings, 'dropping line containing reference to missing attribute'
       end
 
       test 'escaped include directive is left unprocessed' do
@@ -1163,14 +1416,14 @@ include::include-file.asciidoc[]
 include::fixtures/parent-include.adoc[depth=1]
         EOS
 
-        lines, warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           pseudo_docfile = File.join DIRNAME, 'include-master.adoc'
           doc = empty_safe_document :base_dir => DIRNAME
           reader = Asciidoctor::PreprocessorReader.new doc, input, Asciidoctor::Reader::Cursor.new(pseudo_docfile), :normalize => true
-          [reader.readlines, err.string]
+          lines = reader.readlines
+          assert_includes lines, 'include::child-include.adoc[]'
+          assert_message logger, :ERROR, 'fixtures/parent-include.adoc: line 3: maximum include depth of 1 exceeded', Hash
         end
-        assert lines.include?('include::child-include.adoc[]')
-        assert_match(/maximum include depth .* exceeded/, warnings)
       end
 
       test 'include directive should be disabled if max include depth set in nested context has been exceeded' do
@@ -1178,15 +1431,15 @@ include::fixtures/parent-include.adoc[de
 include::fixtures/parent-include-restricted.adoc[depth=3]
         EOS
 
-        lines, warnings = redirect_streams do |_, err|
+        using_memory_logger do |logger|
           pseudo_docfile = File.join DIRNAME, 'include-master.adoc'
           doc = empty_safe_document :base_dir => DIRNAME
           reader = Asciidoctor::PreprocessorReader.new doc, input, Asciidoctor::Reader::Cursor.new(pseudo_docfile), :normalize => true
-          [reader.readlines, err.string]
+          lines = reader.readlines
+          assert_includes lines, 'first line of child'
+          assert_includes lines, 'include::grandchild-include.adoc[]'
+          assert_message logger, :ERROR, 'fixtures/child-include.adoc: line 3: maximum include depth of 1 exceeded', Hash
         end
-        assert lines.include?('first line of child')
-        assert lines.include?('include::grandchild-include.adoc[]')
-        assert_match(/maximum include depth .* exceeded/, warnings)
       end
 
       test 'read_lines_until should not process lines if process option is false' do
@@ -1210,10 +1463,13 @@ include::fixtures/no-such-file.adoc[]
 ////
         EOS
 
-        doc = empty_safe_document :base_dir => DIRNAME
-        reader = Asciidoctor::PreprocessorReader.new doc, lines, nil, :normalize => true
-        result = reader.skip_comment_lines
-        assert_equal lines.map {|l| l.chomp}, result
+        using_memory_logger do |logger|
+          doc = empty_safe_document :base_dir => DIRNAME
+          reader = Asciidoctor::PreprocessorReader.new doc, lines, nil, :normalize => true
+          reader.skip_comment_lines
+          assert reader.empty?
+          assert logger.empty?
+        end
       end
     end
 
diff -pruN 1.5.6.2-2/test/sections_test.rb 1.5.7-1/test/sections_test.rb
--- 1.5.6.2-2/test/sections_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/sections_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -11,12 +11,12 @@ context 'Sections' do
       assert_equal '_section_one', sec.id
     end
 
-    test 'synthetic id replaces non-word characters with underscores' do
-      sec = block_from_string("== We're back!")
-      assert_equal '_we_re_back', sec.id
+    test 'synthetic id removes non-word characters' do
+      sec = block_from_string("== We’re back!")
+      assert_equal '_were_back', sec.id
     end
 
-    test 'synthetic id removes repeating underscores' do
+    test 'synthetic id removes repeating separators' do
       sec = block_from_string('== Section $ One')
       assert_equal '_section_one', sec.id
     end
@@ -31,6 +31,26 @@ context 'Sections' do
       assert_equal '_a_b', sec.id
     end
 
+    test 'synthetic id removes XML tags' do
+      sec = block_from_string('== Use the `run` command to make it icon:gear[]')
+      assert_equal '_use_the_run_command_to_make_it_gear', sec.id
+    end
+
+    test 'synthetic id collapses repeating spaces' do
+      sec = block_from_string('== Go    Far')
+      assert_equal '_go_far', sec.id
+    end
+
+    test 'synthetic id replaces hyphens with separator' do
+      sec = block_from_string('== State-of-the-art design')
+      assert_equal '_state_of_the_art_design', sec.id
+    end
+
+    test 'synthetic id replaces dots with separator' do
+      sec = block_from_string("== Section 1.1.1")
+      assert_equal '_section_1_1_1', sec.id
+    end
+
     test 'synthetic id prefix can be customized' do
       sec = block_from_string(":idprefix: id_\n\n== Section One")
       assert_equal 'id_section_one', sec.id
@@ -42,7 +62,7 @@ context 'Sections' do
     end
 
     test 'synthetic id prefix is stripped from beginning of id if set to blank' do
-      sec = block_from_string(":idprefix:\n\n== & More")
+      sec = block_from_string(":idprefix:\n\n== & ! More")
       assert_equal 'more', sec.id
     end
 
@@ -51,6 +71,26 @@ context 'Sections' do
       assert_equal '_section-one', sec.id
     end
 
+    test 'synthetic id separator can be hyphen and hyphens are preserved' do
+      sec = block_from_string(":idseparator: -\n\n== State-of-the-art design")
+      assert_equal '_state-of-the-art-design', sec.id
+    end
+
+    test 'synthetic id separator can be dot and dots are preserved' do
+      sec = block_from_string(":idseparator: .\n\n== Version 5.0.1")
+      assert_equal '_version.5.0.1', sec.id
+    end
+
+    test 'synthetic id separator can only be one character' do
+      input = <<-EOS
+:idseparator: -=-
+
+== This Section Is All You Need
+      EOS
+      sec = block_from_string input
+      assert_equal '_this-section-is-all-you-need', sec.id
+    end
+
     test 'synthetic id separator can be set to blank' do
       sec = block_from_string(":idseparator:\n\n== Section One")
       assert_equal '_sectionone', sec.id
@@ -76,6 +116,26 @@ context 'Sections' do
       assert_equal 'one', sec.id
     end
 
+    test 'explicit id in block attributes above section title overrides synthetic id' do
+      sec = block_from_string("[id=one]\n== Section One")
+      assert_equal 'one', sec.id
+    end
+
+    test 'explicit id set using shorthand in style above section title overrides synthetic id' do
+      sec = block_from_string("[#one]\n== Section One")
+      assert_equal 'one', sec.id
+    end
+
+    test 'should use explicit id from last block attribute line above section title that defines an explicit id' do
+      input = <<-EOS
+[#un]
+[#one]
+== Section One
+      EOS
+      sec = block_from_string input
+      assert_equal 'one', sec.id
+    end
+
     test 'explicit id can be defined using an embedded anchor' do
       sec = block_from_string("== Section One [[one]] ==")
       assert_equal 'one', sec.id
@@ -120,6 +180,12 @@ Section Title [[refid,reftext]]
       assert_equal 'Section One [[one]]', sec.title
     end
 
+    test 'should not process inline anchor in section title if section has explicit ID' do
+      sec = block_from_string(%([#sect-one]\n== Section One [[one]]))
+      assert_equal 'sect-one', sec.id
+      assert_equal 'Section One <a id="one"></a>', sec.title
+    end
+
     test 'title substitutions are applied before generating id' do
       sec = block_from_string("== Section{sp}One\n")
       assert_equal '_section_one', sec.id
@@ -219,11 +285,13 @@ content
 content
       EOS
 
-      doc, warnings = redirect_streams {|_, err| [(document_from_string input), err.string]}
-      reftext = doc.catalog[:ids]['install']
-      refute_nil reftext
-      assert_equal 'First Install', reftext
-      assert_includes warnings, 'line 7: id assigned to section already in use: install'
+      using_memory_logger do |logger|
+        doc = document_from_string input
+        reftext = doc.catalog[:ids]['install']
+        refute_nil reftext
+        assert_equal 'First Install', reftext
+        assert_message logger, :WARN, '<stdin>: line 7: id assigned to section already in use: install', Hash
+      end
     end
 
     test 'duplicate block id should not overwrite existing section id entry in references table' do
@@ -237,11 +305,13 @@ content
 content
       EOS
 
-      doc, warnings = redirect_streams {|_, err| [(document_from_string input), err.string] }
-      reftext = doc.catalog[:ids]['install']
-      refute_nil reftext
-      assert_equal 'First Install', reftext
-      assert_includes warnings, 'line 7: id assigned to block already in use: install'
+      using_memory_logger do |logger|
+        doc = document_from_string input
+        reftext = doc.catalog[:ids]['install']
+        refute_nil reftext
+        assert_equal 'First Install', reftext
+        assert_message logger, :WARN, '<stdin>: line 7: id assigned to block already in use: install', Hash
+      end
     end
   end
 
@@ -284,21 +354,39 @@ preamble
     test "not enough chars for a multiline document title" do
       title = "My Title"
       chars = "=" * (title.length - 2)
-      assert_xpath '//h1', render_string(title + "\n" + chars), 0
-      assert_xpath '//h1', render_string(title + "\n" + chars + "\n"), 0
+      using_memory_logger do |logger|
+        output = render_string(title + "\n" + chars)
+        assert_xpath '//h1', output, 0
+        refute logger.empty?
+        logger.clear
+        output = render_string(title + "\n" + chars + "\n")
+        assert_xpath '//h1', output, 0
+        refute logger.empty?
+      end
     end
 
     test "too many chars for a multiline document title" do
       title = "My Title"
       chars = "=" * (title.length + 2)
-      assert_xpath '//h1', render_string(title + "\n" + chars), 0
-      assert_xpath '//h1', render_string(title + "\n" + chars + "\n"), 0
+      using_memory_logger do |logger|
+        output = render_string(title + "\n" + chars)
+        assert_xpath '//h1', output, 0
+        refute logger.empty?
+        logger.clear
+        output = render_string(title + "\n" + chars + "\n")
+        assert_xpath '//h1', output, 0
+        refute logger.empty?
+      end
     end
 
     test "document title with multiline syntax cannot begin with a dot" do
       title = ".My Title"
       chars = "=" * title.length
-      assert_xpath '//h1', render_string(title + "\n" + chars), 0
+      using_memory_logger do |logger|
+        output = render_string(title + "\n" + chars)
+        assert_xpath '//h1', output, 0
+        refute logger.empty?
+      end
     end
 
     test "document title with atx syntax" do
@@ -339,7 +427,7 @@ content
       assert_css 'body#idname', output, 1
     end
 
-    test 'should use inline id instead of id defined in block attributes' do
+    test 'should use ID defined in block attributes instead of ID defined inline' do
       input = <<-EOS
 [#idname-block]
 = Document Title [[idname-inline]]
@@ -347,7 +435,7 @@ content
 content
       EOS
       output = render_string input
-      assert_css 'body#idname-inline', output, 1
+      assert_css 'body#idname-block', output, 1
     end
 
     test 'block id above document title sets id on document' do
@@ -361,10 +449,23 @@ preamble
       doc = document_from_string input
       assert_equal 'reference', doc.id
       assert_equal 'refguide', doc.attr('css-signature')
-      output = doc.render
+      output = doc.convert
       assert_css 'body#reference', output, 1
     end
 
+    test 'should register document in catalog if id is set' do
+      input = <<-EOS
+[[manual,Manual]]
+= Reference Manual
+
+preamble
+      EOS
+      doc = document_from_string input
+      assert_equal 'manual', doc.id
+      assert_equal 'Manual', doc.attributes['reftext']
+      assert_equal doc, doc.catalog[:refs]['manual']
+    end
+
     test 'should discard style, role and options shorthand attributes defined on document title' do
       input = <<-EOS
 [style#idname.rolename%optionname]
@@ -375,8 +476,10 @@ content
       doc = document_from_string input
       assert_empty doc.blocks[0].attributes
       output = doc.convert
+      assert_css '#idname', output, 1
       assert_css 'body#idname', output, 1
-      assert_css '.rolename', output, 0
+      assert_css '.rolename', output, 1
+      assert_css 'body.rolename', output, 1
     end
   end
 
@@ -410,7 +513,11 @@ endif::[]
     test "heading title with multiline syntax cannot begin with a dot" do
       title = ".My Title"
       chars = "-" * title.length
-      assert_xpath '//h2', render_string(title + "\n" + chars), 0
+      using_memory_logger do |logger|
+        output = render_string(title + "\n" + chars)
+        assert_xpath '//h2', output, 0
+        refute logger.empty?
+      end
     end
 
     test "with atx syntax" do
@@ -426,11 +533,11 @@ endif::[]
     end
 
     test "with XML entity" do
-      assert_xpath "//h2[@id='_where_s_the_love'][text() = \"Where#{decode_char 8217}s the love?\"]", render_string("== Where's the love?")
+      assert_xpath "//h2[@id='_whats_new'][text() = \"What#{decode_char 8217}s new?\"]", render_string("== What's new?")
     end
 
     test "with non-word character" do
-      assert_xpath "//h2[@id='_where_s_the_love'][text() = \"Where’s the love?\"]", render_string("== Where’s the love?")
+      assert_xpath "//h2[@id='_whats_new'][text() = \"What’s new?\"]", render_string("== What’s new?")
     end
 
     test "with sequential non-word characters" do
@@ -523,6 +630,191 @@ content
     end
   end
 
+  context 'Nesting' do
+    test 'should warn if section title is out of sequence' do
+      input = <<-EOS
+= Document Title
+
+== Section A
+
+==== Nested Section
+
+content
+
+== Section B
+
+content
+      EOS
+
+      using_memory_logger do |logger|
+        result = render_embedded_string input
+        assert_xpath '//h4[text()="Nested Section"]', result, 1
+        assert_message logger, :WARN, '<stdin>: line 5: section title out of sequence: expected level 2, got level 3', Hash
+      end
+    end
+
+    test 'should warn if chapter title is out of sequence' do
+      input = <<-EOS
+= Document Title
+:doctype: book
+
+=== Not a Chapter
+
+content
+      EOS
+
+      using_memory_logger do |logger|
+        result = render_embedded_string input
+        assert_xpath '//h3[text()="Not a Chapter"]', result, 1
+        assert_message logger, :WARN, '<stdin>: line 4: section title out of sequence: expected levels 0 or 1, got level 2', Hash
+      end
+    end
+
+    test 'should not warn if top-level section title is out of sequence when fragment attribute is set on document' do
+      input = <<-EOS
+= Document Title
+
+=== First Section
+
+content
+      EOS
+
+      using_memory_logger do |logger|
+        render_embedded_string input, :attributes => { 'fragment' => '' }
+        assert logger.empty?
+      end
+    end
+
+    test 'should warn if nested section title is out of sequence when fragment attribute is set on document' do
+      input = <<-EOS
+= Document Title
+
+=== First Section
+
+===== Nested Section
+      EOS
+
+      using_memory_logger do |logger|
+        render_embedded_string input, :attributes => { 'fragment' => '' }
+        assert_message logger, :WARN, '<stdin>: line 5: section title out of sequence: expected level 3, got level 4', Hash
+      end
+    end
+    test 'should log error if subsections are found in special sections in article that do not support subsections' do
+      input = <<-EOS
+= Document Title
+
+== Section
+
+=== Subsection of Section
+
+allowed
+
+[appendix]
+== Appendix
+
+=== Subsection of Appendix
+
+allowed
+
+[glossary]
+== Glossary
+
+=== Subsection of Glossary
+
+not allowed
+
+[bibliography]
+== Bibliography
+
+=== Subsection of Bibliography
+
+not allowed
+      EOS
+
+      using_memory_logger do |logger|
+        render_embedded_string input
+        assert_messages logger, [
+          [:ERROR, '<stdin>: line 19: glossary sections do not support nested sections', Hash],
+          [:ERROR, '<stdin>: line 26: bibliography sections do not support nested sections', Hash],
+        ]
+      end
+    end
+
+    test 'should log error if subsections are found in special sections in book that do not support subsections' do
+      input = <<-EOS
+= Document Title
+:doctype: book
+
+[preface]
+= Preface
+
+=== Subsection of Preface
+
+allowed
+
+[colophon]
+= Colophon
+
+=== Subsection of Colophon
+
+not allowed
+
+[dedication]
+= Dedication
+
+=== Subsection of Dedication
+
+not allowed
+
+= Part 1
+
+[abstract]
+== Abstract
+
+=== Subsection of Abstract
+
+allowed
+
+== Chapter 1
+
+=== Subsection of Chapter
+
+allowed
+
+[appendix]
+= Appendix
+
+=== Subsection of Appendix
+
+allowed
+
+[glossary]
+= Glossary
+
+=== Subsection of Glossary
+
+not allowed
+
+[bibliography]
+= Bibliography
+
+=== Subsection of Bibliography
+
+not allowed
+      EOS
+
+      using_memory_logger do |logger|
+        render_embedded_string input
+        assert_messages logger, [
+          [:ERROR, '<stdin>: line 14: colophon sections do not support nested sections', Hash],
+          [:ERROR, '<stdin>: line 21: dedication sections do not support nested sections', Hash],
+          [:ERROR, '<stdin>: line 50: glossary sections do not support nested sections', Hash],
+          [:ERROR, '<stdin>: line 57: bibliography sections do not support nested sections', Hash]
+        ]
+      end
+    end
+  end
+
   context 'Markdown-style headings' do
     test 'atx document title with leading marker' do
       input = <<-EOS
@@ -664,7 +956,7 @@ not in section
 
       doc = document_from_string input
       heading = doc.blocks.first
-      assert heading.is_a?(Asciidoctor::Block)
+      assert_kind_of Asciidoctor::Block, heading
       assert_equal :floating_title, heading.context
       assert_equal '_independent_heading', heading.id
       assert doc.catalog[:ids].has_key?('_independent_heading')
@@ -801,6 +1093,19 @@ content
       refute_nil reftext
       assert_equal 'Install Procedure', reftext
     end
+
+    test 'should not process inline anchor in discrete heading if explicit ID is assigned' do
+      input = <<-EOS
+[discrete#install]
+== Install [[installation]]
+
+content
+      EOS
+
+      block = block_from_string input
+      assert_equal block.id, 'install'
+      assert_equal 'Install <a id="installation"></a>', block.title
+    end
   end
 
   context 'Level offset' do
@@ -820,14 +1125,10 @@ text in standalone
 // end simulated include::[]
       EOS
 
-      warnings = nil
-      redirect_streams do |out, err|
+      using_memory_logger do |logger|
         render_string input
-        warnings = err.string
+        assert_message logger, :ERROR, '<stdin>: line 7: level 0 sections can only be used when doctype is book', Hash
       end
-
-      refute_empty warnings
-      assert_match(/only book doctypes can contain level 0 sections/, warnings)
     end
 
     test 'should add level offset to section level' do
@@ -857,13 +1158,12 @@ Standalone section text.
 Master section text.
       EOS
 
-      output = warnings = nil
-      redirect_streams do |out, err|
+      output = nil
+      using_memory_logger do |logger|
         output = render_string input
-        warnings = err.string
+        assert logger.empty?
       end
 
-      assert_empty warnings
       assert_match(/Master document written by Doc Writer/, output)
       assert_match(/Standalone document written by Junior Writer/, output)
       assert_xpath '//*[@class="sect1"]/h2[text() = "Standalone Document"]', output, 1
@@ -937,40 +1237,50 @@ content
 
   context 'Section Numbering' do
     test 'should create section number with one entry for level 1' do
-      sect1 = Asciidoctor::Section.new
+      doc = empty_document
+      sect1 = Asciidoctor::Section.new nil, nil, true
+      doc << sect1
       assert_equal '1.', sect1.sectnum
     end
 
     test 'should create section number with two entries for level 2' do
-      sect1 = Asciidoctor::Section.new
-      sect1_1 = Asciidoctor::Section.new(sect1)
+      doc = empty_document
+      sect1 = Asciidoctor::Section.new nil, nil, true
+      doc << sect1
+      sect1_1 = Asciidoctor::Section.new sect1, nil, true
       sect1 << sect1_1
       assert_equal '1.1.', sect1_1.sectnum
     end
 
     test 'should create section number with three entries for level 3' do
-      sect1 = Asciidoctor::Section.new
-      sect1_1 = Asciidoctor::Section.new(sect1)
+      doc = empty_document
+      sect1 = Asciidoctor::Section.new nil, nil, true
+      doc << sect1
+      sect1_1 = Asciidoctor::Section.new sect1, nil, true
       sect1 << sect1_1
-      sect1_1_1 = Asciidoctor::Section.new(sect1_1)
+      sect1_1_1 = Asciidoctor::Section.new sect1_1, nil, true
       sect1_1 << sect1_1_1
       assert_equal '1.1.1.', sect1_1_1.sectnum
     end
 
     test 'should create section number for second section in level' do
-      sect1 = Asciidoctor::Section.new
-      sect1_1 = Asciidoctor::Section.new(sect1)
+      doc = empty_document
+      sect1 = Asciidoctor::Section.new nil, nil, true
+      doc << sect1
+      sect1_1 = Asciidoctor::Section.new sect1, nil, true
       sect1 << sect1_1
-      sect1_2 = Asciidoctor::Section.new(sect1)
+      sect1_2 = Asciidoctor::Section.new sect1, nil, true
       sect1 << sect1_2
       assert_equal '1.2.', sect1_2.sectnum
     end
 
     test 'sectnum should use specified delimiter and append string' do
-      sect1 = Asciidoctor::Section.new
-      sect1_1 = Asciidoctor::Section.new(sect1)
+      doc = empty_document
+      sect1 = Asciidoctor::Section.new nil, nil, true
+      doc << sect1
+      sect1_1 = Asciidoctor::Section.new sect1, nil, true
       sect1 << sect1_1
-      sect1_1_1 = Asciidoctor::Section.new(sect1_1)
+      sect1_1_1 = Asciidoctor::Section.new sect1_1, nil, true
       sect1_1 << sect1_1_1
       assert_equal '1,1,1,', sect1_1_1.sectnum(',')
       assert_equal '1:1:1', sect1_1_1.sectnum(':', false)
@@ -1054,6 +1364,31 @@ text
       assert_xpath '//h3[@id="_section_2_2"][starts-with(text(), "2.2. ")]', output, 1
     end
 
+    test 'should number parts when doctype is book and partnums attributes is set' do
+      input = <<-EOS
+= Book Title
+:doctype: book
+:sectnums:
+:partnums:
+
+= Language
+
+== Syntax
+
+content
+
+= Processor
+
+== CLI
+
+content
+      EOS
+
+      output = render_string input
+      assert_xpath '//h1[@id="_language"][text() = "I. Language"]', output, 1
+      assert_xpath '//h1[@id="_processor"][text() = "II. Processor"]', output, 1
+    end
+
     test 'blocks should have level' do
       input = <<-EOS
 = Title
@@ -1313,7 +1648,7 @@ content
       EOS
 
       doc = document_from_string input
-      second_section = Asciidoctor::Section.new doc
+      second_section = Asciidoctor::Section.new doc, nil, true
       doc.blocks.insert 1, second_section
       doc.reindex_sections
       sections = doc.sections
@@ -1345,6 +1680,26 @@ Linux installation instructions.
       assert_xpath '//*[@class="sect2"]/h3[@id="_linux"]/a/following-sibling::text()="Linux"', output, true
     end
 
+    test 'should position after title text if sectanchors is set to after' do
+      input = <<-EOS
+== Installation
+
+Installation section.
+
+=== Linux
+
+Linux installation instructions.
+      EOS
+
+      output = render_embedded_string input, :attributes => {'sectanchors' => 'after'}
+      assert_xpath '/*[@class="sect1"]/h2[@id="_installation"]/a', output, 1
+      assert_xpath '/*[@class="sect1"]/h2[@id="_installation"]/a[@class="anchor"][@href="#_installation"]', output, 1
+      assert_xpath '/*[@class="sect1"]/h2[@id="_installation"]/a/preceding-sibling::text()="Installation"', output, true
+      assert_xpath '//*[@class="sect2"]/h3[@id="_linux"]/a', output, 1
+      assert_xpath '//*[@class="sect2"]/h3[@id="_linux"]/a[@class="anchor"][@href="#_linux"]', output, 1
+      assert_xpath '//*[@class="sect2"]/h3[@id="_linux"]/a/preceding-sibling::text()="Linux"', output, true
+    end
+
     test 'should link section if sectlinks document attribute is set' do
       input = <<-EOS
 == Installation
@@ -1394,6 +1749,32 @@ Details
       assert_xpath '//h2[text()="Appendix A: Attribute Options"]', output, 1
     end
 
+    test 'should use style from last block attribute line above section that defines a style' do
+      input = <<-EOS
+[glossary]
+[appendix]
+== Attribute Options
+
+Details
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '//h2[text()="Appendix A: Attribute Options"]', output, 1
+    end
+
+    test 'setting ID using style shorthand should not clear section style' do
+      input = <<-EOS
+[appendix]
+[#attribute-options]
+== Attribute Options
+
+Details
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '//h2[@id="attribute-options"][text()="Appendix A: Attribute Options"]', output, 1
+    end
+
     test 'should use custom appendix caption if specified' do
       input = <<-EOS
 :appendix-caption: App
@@ -1624,17 +2005,20 @@ Terms
 
     test 'should not number special sections or their subsections by default except for appendices' do
       input = <<-EOS
+:doctype: book
 :sectnums:
 
-[dedication]
-== Dedication
+[preface]
+== Preface
 
-=== Dedication Subsection
+=== Preface Subsection
 
 content
 
 == Section One
 
+content
+
 [appendix]
 == Attribute Options
 
@@ -1656,8 +2040,8 @@ Terms
       EOS
 
       output = render_embedded_string input
-      assert_xpath '(//h2)[1][text()="Dedication"]', output, 1
-      assert_xpath '(//h3)[1][text()="Dedication Subsection"]', output, 1
+      assert_xpath '(//h2)[1][text()="Preface"]', output, 1
+      assert_xpath '(//h3)[1][text()="Preface Subsection"]', output, 1
       assert_xpath '(//h2)[2][text()="1. Section One"]', output, 1
       assert_xpath '(//h2)[3][text()="Appendix A: Attribute Options"]', output, 1
       assert_xpath '(//h2)[4][text()="Appendix B: Migration"]', output, 1
@@ -1667,18 +2051,21 @@ Terms
 
     test 'should not number special sections or their subsections in toc by default except for appendices' do
       input = <<-EOS
+:doctype: book
 :sectnums:
 :toc:
 
-[dedication]
-== Dedication
+[preface]
+== Preface
 
-=== Dedication Subsection
+=== Preface Subsection
 
 content
 
 == Section One
 
+content
+
 [appendix]
 == Attribute Options
 
@@ -1700,8 +2087,8 @@ Terms
       EOS
 
       output = render_string input
-      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Dedication"]', output, 1
-      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Dedication Subsection"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Preface"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Preface Subsection"]', output, 1
       assert_xpath '//*[@id="toc"]/ul//li/a[text()="1. Section One"]', output, 1
       assert_xpath '//*[@id="toc"]/ul//li/a[text()="Appendix A: Attribute Options"]', output, 1
       assert_xpath '//*[@id="toc"]/ul//li/a[text()="Appendix B: Migration"]', output, 1
@@ -1709,6 +2096,99 @@ Terms
       assert_xpath '//*[@id="toc"]/ul//li/a[text()="Glossary"]', output, 1
     end
 
+    test 'should number special sections and their subsections when sectnums is all' do
+      input = <<-EOS
+:doctype: book
+:sectnums: all
+
+[preface]
+== Preface
+
+=== Preface Subsection
+
+content
+
+== Section One
+
+content
+
+[appendix]
+== Attribute Options
+
+Details
+
+[appendix]
+== Migration
+
+Details
+
+=== Gotchas
+
+Details
+
+[glossary]
+== Glossary
+
+Terms
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '(//h2)[1][text()="1. Preface"]', output, 1
+      assert_xpath '(//h3)[1][text()="1.1. Preface Subsection"]', output, 1
+      assert_xpath '(//h2)[2][text()="2. Section One"]', output, 1
+      assert_xpath '(//h2)[3][text()="Appendix A: Attribute Options"]', output, 1
+      assert_xpath '(//h2)[4][text()="Appendix B: Migration"]', output, 1
+      assert_xpath '(//h3)[2][text()="B.1. Gotchas"]', output, 1
+      assert_xpath '(//h2)[5][text()="3. Glossary"]', output, 1
+    end
+
+    test 'should number special sections and their subsections in toc when sectnums is all' do
+      input = <<-EOS
+:doctype: book
+:sectnums: all
+:toc:
+
+[preface]
+== Preface
+
+=== Preface Subsection
+
+content
+
+== Section One
+
+content
+
+[appendix]
+== Attribute Options
+
+Details
+
+[appendix]
+== Migration
+
+Details
+
+=== Gotchas
+
+Details
+
+[glossary]
+== Glossary
+
+Terms
+      EOS
+
+      output = render_string input
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="1. Preface"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="1.1. Preface Subsection"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="2. Section One"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Appendix A: Attribute Options"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="Appendix B: Migration"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="B.1. Gotchas"]', output, 1
+      assert_xpath '//*[@id="toc"]/ul//li/a[text()="3. Glossary"]', output, 1
+    end
+
     test 'level 0 special sections in multipart book should be rendered as level 1' do
       input = <<-EOS
 = Multipart Book
@@ -1883,6 +2363,19 @@ The corresponding definition.
       assert_xpath '//glossary/title[text()="Glossary A"]', output, 1
       assert_xpath '//glossary/glossentry', output, 2
     end
+
+    test 'should drop title on special section in DocBook output if untitled option is set' do
+      input = <<-EOS
+[dedication%untitled]
+== Dedication
+
+content
+      EOS
+
+      output = render_embedded_string input, :backend => :docbook
+      assert_xpath '/dedication', output, 1
+      assert_xpath '/dedication/title', output, 0
+    end
   end
 
   context "heading patterns in blocks" do
@@ -2567,6 +3060,61 @@ It only has content.
         assert_css '#toctitle', output, 0
       end
     end
+
+    test 'should drop anchors from contents of entries in table of contents' do
+      input = <<-EOS
+= Document Title
+:toc:
+
+== [[un]]Section One
+
+content
+
+== [[two]][[deux]]Section Two
+
+content
+
+== Plant Trees by https://ecosia.org[Searching]
+
+content
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '/*[@id="toc"]', output, 1
+      toc_links = xmlnodes_at_xpath '/*[@id="toc"]//li', output
+      assert_equal 3, toc_links.size
+      assert_equal '<a href="#_section_one">Section One</a>', toc_links[0].inner_html
+      assert_equal '<a href="#_section_two">Section Two</a>', toc_links[1].inner_html
+      assert_equal '<a href="#_plant_trees_by_searching">Plant Trees by Searching</a>', toc_links[2].inner_html
+    end
+
+    test 'should not remove non-anchor tags from contents of entries in table of contents' do
+      input = <<-EOS
+= Document Title
+:toc:
+:icons: font
+
+== `run` command
+
+content
+
+== icon:bug[] Issues
+
+content
+
+== https://ecosia.org[_Sustainable_ Searches]
+
+content
+      EOS
+
+      output = render_embedded_string input, :safe => :safe
+      assert_xpath '/*[@id="toc"]', output, 1
+      toc_links = xmlnodes_at_xpath '/*[@id="toc"]//li', output
+      assert_equal 3, toc_links.size
+      assert_equal '<a href="#_run_command"><code>run</code> command</a>', toc_links[0].inner_html
+      assert_equal '<a href="#_issues"><span class="icon"><i class="fa fa-bug"></i></span> Issues</a>', toc_links[1].inner_html
+      assert_equal '<a href="#_sustainable_searches"><em>Sustainable</em> Searches</a>', toc_links[2].inner_html
+    end
   end
 
   context 'article doctype' do
@@ -2657,6 +3205,48 @@ That's all she wrote!
       assert_xpath '//h1[@id="_chapter_three"][text() = "Chapter Three"]', output, 1
     end
 
+    test 'should print error if level 0 section comes after nested section and doctype is not book' do
+      input = <<-EOS
+= Document Title
+
+== Level 1 Section
+
+=== Level 2 Section
+
+= Level 0 Section
+      EOS
+
+      using_memory_logger do |logger|
+        render_string input
+        assert_message logger, :ERROR, '<stdin>: line 7: level 0 sections can only be used when doctype is book', Hash
+      end
+    end
+
+    test 'should add class matching role to part' do
+      input = <<-EOS
+= Book Title
+:doctype: book
+
+[.newbie]
+= Part 1
+
+== Chapter A
+
+content
+
+= Part 2
+
+== Chapter B
+
+content
+      EOS
+
+      result = render_embedded_string input
+      assert_css 'h1.sect0', result, 2
+      assert_css 'h1.sect0.newbie', result, 1
+      assert_css 'h1.sect0.newbie#_part_1', result, 1
+    end
+
     test 'should assign appropriate sectname for section type' do
       input = <<-EOS
 = Book Title
@@ -2761,15 +3351,10 @@ more part intro
 intro
       EOS
 
-      warnings = nil
-      redirect_streams do |out, err|
+      using_memory_logger do |logger|
         document_from_string input
-        warnings = err.string
+        assert_message logger, :ERROR, '<stdin>: line 8: invalid part, must have at least one section (e.g., chapter, appendix, etc.)', Hash
       end
-
-      refute_nil warnings
-      refute_empty warnings
-      assert_match(/ERROR:.*section/, warnings)
     end
 
     test 'should create parts and chapters in docbook backend' do
@@ -2850,12 +3435,11 @@ Appendix content
 Appendix subsection content
       EOS
 
-      output = warnings = nil
-      redirect_streams do |out, err|
+      output = nil
+      using_memory_logger do |logger|
         output = render_string input, :backend => 'docbook'
-        warnings = err.string
+        assert logger.empty?
       end
-      assert_empty warnings
       assert_xpath '/book/preface', output, 1
       assert_xpath '/book/preface/section', output, 1
       assert_xpath '/book/part', output, 1
diff -pruN 1.5.6.2-2/test/substitutions_test.rb 1.5.7-1/test/substitutions_test.rb
--- 1.5.6.2-2/test/substitutions_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/substitutions_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -17,6 +17,15 @@ context 'Substitutions' do
       assert_equal %{<em class="blue"><a href="http://asciidoc.org">AsciiDoc</a></em> &amp; <strong class="red">Ruby</strong>\n&#167; Making <u>documentation</u> together<br>\nsince &#169; 2012.}, result
     end
 
+    test 'apply_subs should not modify string directly' do
+      input = '<html> -- the root of all web'
+      para = block_from_string input
+      para_source = para.source
+      result = para.apply_subs para_source
+      assert_equal '&lt;html&gt;&#8201;&#8212;&#8201;the root of all web', result
+      assert_equal input, para_source
+    end
+
     test 'should not drop trailing blank lines when performing substitutions' do
       para = block_from_string %([%hardbreaks]\nthis\nis\n-> {program})
       para.lines << ''
@@ -28,15 +37,12 @@ context 'Substitutions' do
       assert_equal %(this<br>\nis<br>\n&#8594; Asciidoctor<br>\n<br>\n), result
     end
 
-    test 'should expand subs passed to apply_subs when expand argument is set' do
+    test 'should expand subs passe to expand_subs' do
       para = block_from_string %({program}\n*bold*\n2 > 1)
       para.document.attributes['program'] = 'Asciidoctor'
-      result = para.apply_subs para.lines, [:specialchars], true
-      assert_equal ['{program}', '*bold*', '2 &gt; 1'], result
-      result = para.apply_subs para.lines, [:none], true
-      assert_equal ['{program}', '*bold*', '2 > 1'], result
-      result = para.apply_subs para.lines, [:normal], true
-      assert_equal ['Asciidoctor', '<strong>bold</strong>', '2 &gt; 1'], result
+      assert_equal [:specialcharacters], (para.expand_subs [:specialchars])
+      refute para.expand_subs([:none])
+      assert_equal [:specialcharacters, :quotes, :attributes, :replacements, :macros, :post_replacements], (para.expand_subs [:normal])
     end
 
     test 'apply_subs should allow the subs argument to be nil' do
@@ -53,6 +59,9 @@ context 'Substitutions' do
 
       para = block_from_string(%q{"`a few quoted words`"})
       assert_equal '&#8220;a few quoted words&#8221;', para.sub_quotes(para.source)
+
+      para = block_from_string(%q{"`a few quoted words`"}, :backend => 'docbook')
+      assert_equal '<quote>a few quoted words</quote>', para.sub_quotes(para.source)
     end
 
     test 'escaped single-line double-quoted string' do
@@ -107,6 +116,9 @@ context 'Substitutions' do
 
       para = block_from_string(%q{'`a few quoted words`'})
       assert_equal '&#8216;a few quoted words&#8217;', para.sub_quotes(para.source)
+
+      para = block_from_string(%q{'`a few quoted words`'}, :backend => 'docbook')
+      assert_equal '<quote>a few quoted words</quote>', para.sub_quotes(para.source)
     end
 
     test 'escaped single-line single-quoted string' do
@@ -538,12 +550,12 @@ context 'Substitutions' do
 
     test 'quoted text with id shorthand' do
       para = block_from_string(%q{[#bond]#007#})
-      assert_equal '<a id="bond"></a>007', para.sub_quotes(para.source)
+      assert_equal '<span id="bond">007</span>', para.sub_quotes(para.source)
     end
 
     test 'quoted text with id and role shorthand' do
       para = block_from_string(%q{[#bond.white.red-background]#007#})
-      assert_equal '<a id="bond"></a><span class="white red-background">007</span>', para.sub_quotes(para.source)
+      assert_equal '<span id="bond" class="white red-background">007</span>', para.sub_quotes(para.source)
     end
 
     test 'quoted text with id and role shorthand using docbook backend' do
@@ -593,12 +605,12 @@ context 'Substitutions' do
     end
 
     test 'a mailto macro with text and subject should be interpreted as a mailto link' do
-      para = block_from_string('mailto:doc.writer@asciidoc.org[Doc Writer, Pull request]', :attributes => {'linkattrs' => ''})
+      para = block_from_string('mailto:doc.writer@asciidoc.org[Doc Writer, Pull request]')
       assert_equal %q{<a href="mailto:doc.writer@asciidoc.org?subject=Pull%20request">Doc Writer</a>}, para.sub_macros(para.source)
     end
 
     test 'a mailto macro with text, subject and body should be interpreted as a mailto link' do
-      para = block_from_string('mailto:doc.writer@asciidoc.org[Doc Writer, Pull request, Please accept my pull request]', :attributes => {'linkattrs' => ''})
+      para = block_from_string('mailto:doc.writer@asciidoc.org[Doc Writer, Pull request, Please accept my pull request]')
       assert_equal %q{<a href="mailto:doc.writer@asciidoc.org?subject=Pull%20request&amp;body=Please%20accept%20my%20pull%20request">Doc Writer</a>}, para.sub_macros(para.source)
     end
 
@@ -698,7 +710,7 @@ context 'Substitutions' do
     end
 
     test 'an image macro with an inline SVG image should be converted to an svg element' do
-      para = block_from_string('image:circle.svg[Tiger,100,opts=inline]', :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'imagesdir' => 'fixtures', 'docdir' => ::File.dirname(__FILE__) })
+      para = block_from_string('image:circle.svg[Tiger,100,opts=inline]', :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'imagesdir' => 'fixtures', 'docdir' => testdir })
       result = para.sub_macros(para.source).gsub(/>\s+</, '><')
       assert_match(/<svg\s[^>]*width="100px"[^>]*>/, result)
       refute_match(/<svg\s[^>]*width="500px"[^>]*>/, result)
@@ -707,7 +719,7 @@ context 'Substitutions' do
     end
 
     test 'an image macro with an inline SVG image should be converted to an svg element even when data-uri is set' do
-      para = block_from_string('image:circle.svg[Tiger,100,opts=inline]', :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'data-uri' => '', 'imagesdir' => 'fixtures', 'docdir' => ::File.dirname(__FILE__) })
+      para = block_from_string('image:circle.svg[Tiger,100,opts=inline]', :safe => Asciidoctor::SafeMode::SERVER, :attributes => { 'data-uri' => '', 'imagesdir' => 'fixtures', 'docdir' => testdir })
       assert_match(/<svg\s[^>]*width="100px">/, para.sub_macros(para.source).gsub(/>\s+</, '><'))
     end
 
@@ -751,6 +763,12 @@ context 'Substitutions' do
           para.sub_macros(para.source).gsub(/>\s+</, '><')
     end
 
+    test 'rel=nofollow should be added to an image with a link when the nofollow option is set' do
+      para = block_from_string 'image:tiger.png[Tiger,link=http://en.wikipedia.org/wiki/Tiger,opts=nofollow]'
+      assert_equal %{<span class="image"><a class="image" href="http://en.wikipedia.org/wiki/Tiger" rel="nofollow"><img src="tiger.png" alt="Tiger"></a></span>},
+          para.sub_macros(para.source).gsub(/>\s+</, '><')
+    end
+
     test 'a multi-line image macro with text and dimensions should be interpreted as an image with alt text and dimensions' do
       para = block_from_string(%(image:tiger.png[Another\nAwesome\nTiger, 200,\n100]))
       assert_equal %{<span class="image"><img src="tiger.png" alt="Another Awesome Tiger" width="200" height="100"></span>},
@@ -796,7 +814,7 @@ context 'Substitutions' do
     test 'should not match an inline image macro if target contains an endline character' do
       para = block_from_string(%(Fear not. There are no image:big\ncats.png[] around here.))
       result = para.sub_macros(para.source)
-      refute result.include?('<img ')
+      refute_includes result, '<img '
       assert_includes result, %(image:big\ncats.png[])
     end
 
@@ -804,7 +822,7 @@ context 'Substitutions' do
       ['image: big cats.png[]', 'image:big cats.png []'].each do |input|
         para = block_from_string %(Fear not. There are no #{input} around here.)
         result = para.sub_macros(para.source)
-        refute result.include?('<img ')
+        refute_includes result, '<img '
         assert_includes result, input
       end
     end
@@ -812,8 +830,8 @@ context 'Substitutions' do
     test 'should not detect a block image macro found inline' do
       para = block_from_string(%(Not an inline image macro image::tiger.png[].))
       result = para.sub_macros(para.source)
-      refute result.include?('<img ')
-      assert result.include?('image::tiger.png[]')
+      refute_includes result, '<img '
+      assert_includes result, 'image::tiger.png[]'
     end
 
     # NOTE this test verifies attributes get substituted eagerly in target of image in title
@@ -822,12 +840,11 @@ context 'Substitutions' do
 == image:{iconsdir}/dot.gif[dot] Title
       EOS
 
-      sect, warnings = redirect_streams do |_, err|
-        [(block_from_string input, :attributes => { 'data-uri' => '', 'iconsdir' => 'fixtures', 'docdir' => ::File.dirname(__FILE__) }, :safe => :server, :catalog_assets => true), err.string]
+      using_memory_logger do |logger|
+        sect = block_from_string input, :attributes => { 'data-uri' => '', 'iconsdir' => 'fixtures', 'docdir' => testdir }, :safe => :server, :catalog_assets => true
+        assert_includes sect.document.catalog[:images], 'fixtures/dot.gif'
+        assert logger.empty?
       end
-      assert sect.document.catalog[:images].include? 'fixtures/dot.gif'
-      refute_nil warnings
-      assert_empty warnings
     end
 
     test 'an icon macro should be interpreted as an icon if icons are enabled' do
@@ -862,7 +879,7 @@ context 'Substitutions' do
 
     test 'a single-line footnote macro should be registered and rendered as a footnote' do
       para = block_from_string('Sentence text footnote:[An example footnote.].')
-      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal 1, footnote.index
@@ -872,7 +889,7 @@ context 'Substitutions' do
 
     test 'a multi-line footnote macro should be registered and rendered as a footnote without endline' do
       para = block_from_string("Sentence text footnote:[An example footnote\nwith wrapped text.].")
-      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal 1, footnote.index
@@ -882,7 +899,7 @@ context 'Substitutions' do
 
     test 'an escaped closing square bracket in a footnote should be unescaped when rendered' do
       para = block_from_string(%(footnote:[a #{BACKSLASH}] b].))
-      assert_equal %(<sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(<sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal "a ] b", footnote.text
@@ -890,7 +907,7 @@ context 'Substitutions' do
 
     test 'a footnote macro can be directly adjacent to preceding word' do
       para = block_from_string('Sentence textfootnote:[An example footnote.].')
-      assert_equal %(Sentence text<sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text<sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
     end
 
     test 'a footnote macro may contain an escaped backslash' do
@@ -907,7 +924,7 @@ context 'Substitutions' do
 
     test 'a footnote macro may contain a link macro' do
       para = block_from_string('Share your code. footnote:[https://github.com[GitHub]]')
-      assert_equal %(Share your code. <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
+      assert_equal %(Share your code. <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote1 = para.document.catalog[:footnotes][0]
       assert_equal '<a href="https://github.com">GitHub</a>', footnote1.text
@@ -916,7 +933,7 @@ context 'Substitutions' do
     test 'a footnote macro may contain a plain URL' do
       para = block_from_string %(the JLine footnote:[https://github.com/jline/jline2]\nlibrary.)
       result = para.sub_macros para.source
-      assert_equal %(the JLine <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>\nlibrary.), result
+      assert_equal %(the JLine <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>\nlibrary.), result
       assert_equal 1, para.document.catalog[:footnotes].size
       fn1 = para.document.catalog[:footnotes].first
       assert_equal '<a href="https://github.com/jline/jline2" class="bare">https://github.com/jline/jline2</a>', fn1.text
@@ -925,7 +942,7 @@ context 'Substitutions' do
     test 'a footnote macro followed by a semi-colon may contain a plain URL' do
       para = block_from_string %(the JLine footnote:[https://github.com/jline/jline2];\nlibrary.)
       result = para.sub_macros para.source
-      assert_equal %(the JLine <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>;\nlibrary.), result
+      assert_equal %(the JLine <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>;\nlibrary.), result
       assert_equal 1, para.document.catalog[:footnotes].size
       fn1 = para.document.catalog[:footnotes].first
       assert_equal '<a href="https://github.com/jline/jline2" class="bare">https://github.com/jline/jline2</a>', fn1.text
@@ -937,7 +954,7 @@ context 'Substitutions' do
       doc = para.document
       doc.register :refs, ['_install', (Asciidoctor::Inline.new doc, :anchor, 'Install', :type => :ref, :target => '_install'), 'Install']
       catalog = doc.catalog
-      assert_equal %(text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
+      assert_equal %(text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
       assert_equal 1, catalog[:footnotes].size
       footnote1 = catalog[:footnotes][0]
       assert_equal '<a href="#_install">install</a>', footnote1.text
@@ -945,7 +962,7 @@ context 'Substitutions' do
 
     test 'a footnote macro may contain an anchor macro' do
       para = block_from_string('text footnote:[a [[b\]\] \[[c\]\] d]')
-      assert_equal %(text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
+      assert_equal %(text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote1 = para.document.catalog[:footnotes][0]
       assert_equal 'a <a id="b"></a> [[c]] d', footnote1.text
@@ -962,7 +979,7 @@ foofootnote:[+http://example.com+]barfoo
 
     test 'should increment index of subsequent footnote macros' do
       para = block_from_string("Sentence text footnote:[An example footnote.]. Sentence text footnote:[Another footnote.].")
-      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>. Sentence text <sup class="footnote">[<a id="_footnoteref_2" class="footnote" href="#_footnote_2" title="View footnote.">2</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>. Sentence text <sup class="footnote">[<a id="_footnoteref_2" class="footnote" href="#_footnotedef_2" title="View footnote.">2</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 2, para.document.catalog[:footnotes].size
       footnote1 = para.document.catalog[:footnotes][0]
       assert_equal 1, footnote1.index
@@ -976,7 +993,7 @@ foofootnote:[+http://example.com+]barfoo
 
     test 'a footnoteref macro with id and single-line text should be registered and rendered as a footnote' do
       para = block_from_string('Sentence text footnoteref:[ex1, An example footnote.].')
-      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal 1, footnote.index
@@ -986,7 +1003,7 @@ foofootnote:[+http://example.com+]barfoo
 
     test 'a footnoteref macro with id and multi-line text should be registered and rendered as a footnote without endlines' do
       para = block_from_string("Sentence text footnoteref:[ex1, An example footnote\nwith wrapped text.].")
-      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal 1, footnote.index
@@ -996,7 +1013,7 @@ foofootnote:[+http://example.com+]barfoo
 
     test 'a footnoteref macro with id should refer to footnoteref with same id' do
       para = block_from_string('Sentence text footnoteref:[ex1, An example footnote.]. Sentence text footnoteref:[ex1].')
-      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>. Sentence text <sup class="footnoteref">[<a class="footnote" href="#_footnote_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
+      assert_equal %(Sentence text <sup class="footnote" id="_footnote_ex1">[<a id="_footnoteref_1" class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>. Sentence text <sup class="footnoteref">[<a class="footnote" href="#_footnotedef_1" title="View footnote.">1</a>]</sup>.), para.sub_macros(para.source)
       assert_equal 1, para.document.catalog[:footnotes].size
       footnote = para.document.catalog[:footnotes].first
       assert_equal 1, footnote.index
@@ -1004,9 +1021,66 @@ foofootnote:[+http://example.com+]barfoo
       assert_equal 'An example footnote.', footnote.text
     end
 
-    test 'an unresolved footnoteref should not crash the processor' do
-      para = block_from_string('Sentence text footnoteref:[ex1].')
-      para.sub_macros para.source
+    test 'an unresolved footnote reference should produce a warning message' do
+      input = 'Sentence text.footnote:ex1[]'
+      using_memory_logger do |logger|
+        para = block_from_string input
+        para.sub_macros para.source
+        assert_message logger, :WARN, 'invalid footnote reference: ex1'
+      end
+    end
+
+    test 'inline footnote macro can be used to define and reference a footnote reference' do
+      input = <<-EOS
+You can download the software from the product page.footnote:sub[Option only available if you have an active subscription.]
+
+You can also file a support request.footnote:sub[]
+
+If all else fails, you can give us a call.footnoteref:[sub]
+      EOS
+
+      output = render_embedded_string input
+      assert_css '#_footnotedef_1', output, 1
+      assert_css 'p a[href="#_footnotedef_1"]', output, 3
+      assert_css '#footnotes .footnote', output, 1
+    end
+
+    test 'should parse multiple footnote references in a single line' do
+      input = <<-'EOS'
+notable text.footnote:id[about this [text\]], footnote:id[], footnote:id[]
+      EOS
+
+      output = render_embedded_string input
+      assert_xpath '(//p)[1]/sup[starts-with(@class,"footnote")]', output, 3
+      assert_xpath '(//p)[1]/sup[@class="footnote"]', output, 1
+      assert_xpath '(//p)[1]/sup[@class="footnoteref"]', output, 2
+      assert_xpath '(//p)[1]/sup[starts-with(@class,"footnote")]/a[@class="footnote"][text()="1"]', output, 3
+      assert_css '#footnotes .footnote', output, 1
+    end
+
+    test 'should not resolve an inline footnote macro missing both id and text' do
+      input = <<-EOS
+The footnote:[] macro can be used for defining and referencing footnotes.
+
+The footnoteref:[] macro is now deprecated.
+      EOS
+
+      output = render_embedded_string input
+      assert_includes output, 'The footnote:[] macro'
+      assert_includes output, 'The footnoteref:[] macro'
+    end
+
+    test 'inline footnote macro can define a numeric id without conflicting with auto-generated ID' do
+      input = <<-EOS
+You can download the software from the product page.footnote:1[Option only available if you have an active subscription.]
+      EOS
+
+      output = render_embedded_string input
+      assert_css '#_footnote_1', output, 1
+      assert_css 'p sup#_footnote_1', output, 1
+      assert_css 'p a#_footnoteref_1', output, 1
+      assert_css 'p a[href="#_footnotedef_1"]', output, 1
+      assert_css '#footnotes #_footnotedef_1', output, 1
     end
 
     test 'a single-line index term macro with a primary term should be registered as an index reference' do
@@ -1057,6 +1131,16 @@ foofootnote:[+http://example.com+]barfoo
       end
     end
 
+    test 'should only escape enclosing brackets if concealed index term is preceded by a backslash' do
+      input = %[National Institute of Science and Technology #{BACKSLASH}(((NIST)))]
+      doc = document_from_string input, :header_footer => false
+      output = doc.convert
+      assert_xpath '//p[text()="National Institute of Science and Technology (NIST)"]', output, 1
+      term = doc.catalog[:indexterms].first
+      assert_equal 1, term.size
+      assert_equal 'NIST', term.first
+    end
+
     test 'should not split index terms on commas inside of quoted terms' do
       inputs = []
       inputs.push <<-EOS
@@ -1585,18 +1669,34 @@ EOS
         assert_equal '\$a &lt; b\$', para.content
       end
 
-      # NOTE this test doesn't work once AsciiMath has been loaded
-      #test 'should not perform specialcharacters subs on asciimath macro content in docbook backend by default' do
-      #  input = 'asciimath:[a < b]'
-      #  para = block_from_string input, :backend => :docbook
-      #  para.document.converter.instance_variable_set :@asciimath_available, false
-      #  assert_equal '<inlineequation><mathphrase><![CDATA[a < b]]></mathphrase></inlineequation>', para.content
-      #end
+      test 'should convert contents of asciimath macro to MathML in DocBook output if asciimath gem is available' do
+        asciimath_available = !(Asciidoctor::Helpers.require_library 'asciimath', true, :ignore).nil?
+        input = 'asciimath:[a < b]'
+        expected = '<inlineequation><mml:math xmlns:mml="http://www.w3.org/1998/Math/MathML"><mml:mi>a</mml:mi><mml:mo>&#x003C;</mml:mo><mml:mi>b</mml:mi></mml:math></inlineequation>'
+        using_memory_logger do |logger|
+          para = block_from_string input, :backend => :docbook
+          actual = para.content
+          if asciimath_available
+            assert_equal expected, actual
+            assert_equal :loaded, para.document.converter.instance_variable_get(:@asciimath)
+          else
+            assert_message logger, :WARN, 'optional gem \'asciimath\' is not installed. Functionality disabled.'
+            assert_equal :unavailable, para.document.converter.instance_variable_get(:@asciimath)
+          end
+        end
+      end
 
-      test 'should convert asciimath macro content to MathML when asciimath gem is available' do
+      test 'should not perform specialcharacters subs on asciimath macro content in Docbook output if asciimath gem not available' do
+        asciimath_available = !(Asciidoctor::Helpers.require_library 'asciimath', true, :ignore).nil?
         input = 'asciimath:[a < b]'
         para = block_from_string input, :backend => :docbook
-        assert_equal '<inlineequation><mml:math xmlns:mml="http://www.w3.org/1998/Math/MathML"><mml:mi>a</mml:mi><mml:mo>&#x003C;</mml:mo><mml:mi>b</mml:mi></mml:math></inlineequation>', para.content
+        para.document.converter.instance_variable_set :@asciimath, :unavailable
+        if asciimath_available
+          old_asciimath = ::AsciiMath
+          Object.send :remove_const, 'AsciiMath'
+        end
+        assert_equal '<inlineequation><mathphrase><![CDATA[a < b]]></mathphrase></inlineequation>', para.content
+        ::AsciiMath = old_asciimath if asciimath_available
       end
 
       test 'should honor explicit subslist on asciimath macro' do
@@ -1649,17 +1749,36 @@ EOS
         assert_equal 'the text <code>asciimath:[x = y]</code> should be passed through as <code>literal</code> text', para.content
       end
 
+      test 'should not process an escaped passthrough macro inside a monospaced phrase' do
+        input = 'use the `\pass:c[]` macro'
+        para = block_from_string input
+        assert_equal 'use the <code>pass:c[]</code> macro', para.content
+      end
+
+      test 'should not process an escaped passthrough macro inside a monospaced phrase with attributes' do
+        input = 'use the [syntax]`\pass:c[]` macro'
+        para = block_from_string input
+        assert_equal 'use the <code class="syntax">pass:c[]</code> macro', para.content
+      end
+
+      test 'should honor an escaped single plus passthrough inside a monospaced phrase' do
+        input = 'use `\+{author}+` to show an attribute reference'
+        para = block_from_string input
+        assert_equal 'use <code>+{author}+</code> to show an attribute reference', para.content
+      end
+
       test 'should not recognize stem macro with no content' do
         input = 'stem:[]'
         para = block_from_string input
         assert_equal input, para.content
       end
 
-      test 'should passthrough text in stem macro and surround with AsciiMath delimiters if stem attribute != latexmath' do
+      test 'should passthrough text in stem macro and surround with AsciiMath delimiters if stem attribute is asciimath, empty, or not set' do
         [
           {},
           {'stem' => ''},
-          {'stem' => 'asciimath'}
+          {'stem' => 'asciimath'},
+          {'stem' => 'bogus'}
         ].each do |attributes|
           input = 'stem:[x/x={(1,if x!=0),(text{undefined},if x=0):}]'
           para = block_from_string input, :attributes => attributes
@@ -1667,10 +1786,16 @@ EOS
         end
       end
 
-      test 'should passthrough text in stem macro and surround with LaTeX math delimiters if stem attribute = latexmath' do
-        input = 'stem:[C = \alpha + \beta Y^{\gamma} + \epsilon]'
-        para = block_from_string input, :attributes => {'stem' => 'latexmath'}
-        assert_equal '\(C = \alpha + \beta Y^{\gamma} + \epsilon\)', para.content
+      test 'should passthrough text in stem macro and surround with LaTeX math delimiters if stem attribute is latexmath, latex, or tex' do
+        [
+          {'stem' => 'latexmath'},
+          {'stem' => 'latex'},
+          {'stem' => 'tex'}
+        ].each do |attributes|
+          input = 'stem:[C = \alpha + \beta Y^{\gamma} + \epsilon]'
+          para = block_from_string input, :attributes => attributes
+          assert_equal '\(C = \alpha + \beta Y^{\gamma} + \epsilon\)', para.content
+        end
       end
 
       test 'should apply substitutions specified on stem macro' do
@@ -1779,25 +1904,25 @@ foo&#8201;&#8212;&#8201;'
   context 'Post replacements' do
     test 'line break inserted after line with line break character' do
       para = block_from_string("First line +\nSecond line")
-      result = para.apply_subs(para.lines, :post_replacements, true)
+      result = para.apply_subs para.lines, (para.expand_subs :post_replacements)
       assert_equal 'First line<br>', result.first
     end
 
     test 'line break inserted after line wrap with hardbreaks enabled' do
       para = block_from_string("First line\nSecond line", :attributes => {'hardbreaks' => ''})
-      result = para.apply_subs(para.lines, :post_replacements, true)
+      result = para.apply_subs para.lines, (para.expand_subs :post_replacements)
       assert_equal 'First line<br>', result.first
     end
 
     test 'line break character stripped from end of line with hardbreaks enabled' do
       para = block_from_string("First line +\nSecond line", :attributes => {'hardbreaks' => ''})
-      result = para.apply_subs(para.lines, :post_replacements, true)
+      result = para.apply_subs para.lines, (para.expand_subs :post_replacements)
       assert_equal 'First line<br>', result.first
     end
 
     test 'line break not inserted for single line with hardbreaks enabled' do
       para = block_from_string('First line', :attributes => {'hardbreaks' => ''})
-      result = para.apply_subs(para.lines, :post_replacements, true)
+      result = para.apply_subs para.lines, (para.expand_subs :post_replacements)
       assert_equal 'First line', result.first
     end
   end
diff -pruN 1.5.6.2-2/test/tables_test.rb 1.5.7-1/test/tables_test.rb
--- 1.5.6.2-2/test/tables_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/tables_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -21,7 +21,7 @@ context 'Tables' do
       assert 100, table.columns.map {|col| col.attributes['colpcwidth'] }.reduce(:+)
       output = doc.convert
       assert_css 'table', output, 1
-      assert_css 'table.tableblock.frame-all.grid-all.spread', output, 1
+      assert_css 'table.tableblock.frame-all.grid-all.stretch', output, 1
       assert_css 'table > colgroup > col[style*="width: 33.3333%"]', output, 2
       assert_css 'table > colgroup > col:last-of-type[style*="width: 33.3334%"]', output, 1
       assert_css 'table tr', output, 3
@@ -37,6 +37,20 @@ context 'Tables' do
       }
     end
 
+    test 'should set stripes class if stripes option is set' do
+      input = <<-EOS
+[stripes=odd]
+|=======
+|A |B |C
+|a |b |c
+|1 |2 |3
+|=======
+      EOS
+
+      output = render_embedded_string input
+      assert_css 'table.stripes-odd', output, 1
+    end
+
     test 'renders caption on simple psv table' do
       input = <<-EOS
 .Simple psv table
@@ -109,11 +123,11 @@ context 'Tables' do
     test 'preserves escaped delimiters at the end of the line' do
       input = <<-EOS
 [%header,cols="1,1"]
-|====
+|===
 |A |B\\|
 |A1 |B1\\|
 |A2 |B2\\|
-|====
+|===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -130,11 +144,11 @@ context 'Tables' do
 
     test 'should treat trailing pipe as an empty cell' do
       input = <<-EOS
-|====
+|===
 |A1 |
 |B1 |B2
 |C1 |C2
-|====
+|===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -150,18 +164,23 @@ context 'Tables' do
       input = <<-EOS
 |===
 A | here| a | there
-|===
-      EOS
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-      assert_css 'table', output, 1
-      assert_css 'table > colgroup > col', output, 4
-      assert_css 'table > tbody > tr', output, 1
-      assert_css 'table > tbody > tr > td', output, 4
-      assert_xpath '/table/tbody/tr/td[1]/p[text()="A"]', output, 1
-      assert_xpath '/table/tbody/tr/td[2]/p[text()="here"]', output, 1
-      assert_xpath '/table/tbody/tr/td[3]/p[text()="a"]', output, 1
-      assert_xpath '/table/tbody/tr/td[4]/p[text()="there"]', output, 1
-      assert_includes warnings, 'table missing leading separator'
+| x
+| y
+| z
+| end
+|===
+      EOS
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_css 'table', output, 1
+        assert_css 'table > tbody > tr', output, 2
+        assert_css 'table > tbody > tr > td', output, 8
+        assert_xpath '/table/tbody/tr[1]/td[1]/p[text()="A"]', output, 1
+        assert_xpath '/table/tbody/tr[1]/td[2]/p[text()="here"]', output, 1
+        assert_xpath '/table/tbody/tr[1]/td[3]/p[text()="a"]', output, 1
+        assert_xpath '/table/tbody/tr[1]/td[4]/p[text()="there"]', output, 1
+        assert_message logger, :ERROR, '<stdin>: line 2: table missing leading separator; recovering automatically', Hash
+      end
     end
 
     test 'performs normal substitutions on cell content' do
@@ -224,7 +243,7 @@ three
       assert_equal %(<div class="verse">  one\n  two\nthree</div>), result.to_s
     end
 
-    test 'table and col width not assigned when autowidth option is specified' do
+    test 'table and column width not assigned when autowidth option is specified' do
       input = <<-EOS
 [options="autowidth"]
 |=======
@@ -235,9 +254,78 @@ three
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
+      assert_css 'table.fit-content', output, 1
       assert_css 'table[style*="width"]', output, 0
       assert_css 'table colgroup col', output, 3
-      assert_css 'table colgroup col[width]', output, 0
+      assert_css 'table colgroup col[style*="width"]', output, 0
+    end
+
+    test 'does not assign column width for autowidth columns in HTML output' do
+      input = <<-EOS
+[cols="15%,3*~"]
+|=======
+|A |B |C |D
+|a |b |c |d
+|1 |2 |3 |4
+|=======
+      EOS
+      doc = document_from_string input
+      table_row0 = doc.blocks[0].rows.body[0]
+      assert_equal 15, table_row0[0].attributes['width']
+      assert_equal 15, table_row0[0].attributes['colpcwidth']
+      refute_equal '', table_row0[0].attributes['autowidth-option']
+      expected_pcwidths = { 1 => 28.3333, 2 => 28.3333, 3 => 28.3334 }
+      (1..3).each do |i|
+        assert_equal 28.3333, table_row0[i].attributes['width']
+        assert_equal expected_pcwidths[i], table_row0[i].attributes['colpcwidth']
+        assert_equal '', table_row0[i].attributes['autowidth-option']
+      end
+      output = doc.convert :header_footer => false
+      assert_css 'table', output, 1
+      assert_css 'table colgroup col', output, 4
+      assert_css 'table colgroup col[style]', output, 1
+      assert_css 'table colgroup col[style*="width: 15%"]', output, 1
+    end
+
+    test 'can assign autowidth to all columns even when table has a width' do
+      input = <<-EOS
+[cols="4*~",width=50%]
+|=======
+|A |B |C |D
+|a |b |c |d
+|1 |2 |3 |4
+|=======
+      EOS
+      doc = document_from_string input
+      table_row0 = doc.blocks[0].rows.body[0]
+      (0..3).each do |i|
+        assert_equal 25, table_row0[i].attributes['width']
+        assert_equal 25, table_row0[i].attributes['colpcwidth']
+        assert_equal '', table_row0[i].attributes['autowidth-option']
+      end
+      output = doc.convert :header_footer => false
+      assert_css 'table', output, 1
+      assert_css 'table[style*="width: 50%;"]', output, 1
+      assert_css 'table colgroup col', output, 4
+      assert_css 'table colgroup col[style]', output, 0
+    end
+
+    test 'equally distributes remaining column width to autowidth columns in DocBook output' do
+      input = <<-EOS
+[cols="15%,3*~"]
+|=======
+|A |B |C |D
+|a |b |c |d
+|1 |2 |3 |4
+|=======
+      EOS
+      output = render_embedded_string input, :backend => 'docbook5'
+      assert_css 'tgroup[cols="4"]', output, 1
+      assert_css 'tgroup colspec', output, 4
+      assert_css 'tgroup colspec[colwidth]', output, 4
+      assert_css 'tgroup colspec[colwidth="15*"]', output, 1
+      assert_css 'tgroup colspec[colwidth="28.3333*"]', output, 2
+      assert_css 'tgroup colspec[colwidth="28.3334*"]', output, 1
     end
 
     test 'explicit table width is used even when autowidth option is specified' do
@@ -253,16 +341,16 @@ three
       assert_css 'table', output, 1
       assert_css 'table[style*="width"]', output, 1
       assert_css 'table colgroup col', output, 3
-      assert_css 'table colgroup col[width]', output, 0
+      assert_css 'table colgroup col[style*="width"]', output, 0
     end
 
     test 'first row sets number of columns when not specified' do
       input = <<-EOS
-|====
+|===
 |first |second |third |fourth
 |1 |2 |3
 |4
-|====
+|===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -392,6 +480,8 @@ three
       assert_css 'table > tfoot > tr > td', output, 2
       assert_css 'table > tbody', output, 1
       assert_css 'table > tbody > tr', output, 3
+      table_section_names = (xmlnodes_at_css 'table > *', output).map(&:node_name).select {|n| n.start_with? 't' }
+      assert_equal %w(thead tbody tfoot), table_section_names
     end
 
     test 'table with header and footer docbook' do
@@ -425,6 +515,19 @@ three
       assert_css 'table > tgroup > tbody', output, 1
       assert_css 'table > tgroup > tbody > row', output, 3
       assert_css 'table > tgroup > tbody > row', output, 3
+      table_section_names = (xmlnodes_at_css 'table > tgroup > *', output).map(&:node_name).select {|n| n.start_with? 't' }
+      assert_equal %w(thead tbody tfoot), table_section_names
+    end
+
+    test 'should recognize ends as an alias to topbot for frame when converting to DocBook' do
+      input = <<-EOS
+[frame=ends]
+|===
+|A |B |C
+|===
+      EOS
+      output = render_embedded_string input, :backend => 'docbook'
+      assert_css 'informaltable[frame="topbot"]', output, 1
     end
 
     test 'table with landscape orientation in DocBook' do
@@ -613,11 +716,11 @@ just text
     test 'styles not applied to header cells' do
       input = <<-EOS
 [cols="1h,1s,1e",options="header,footer"]
-|====
+|===
 |Name |Occupation| Website
 |Octocat |Social coding| https://github.com
 |Name |Occupation| Website
-|====
+|===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -639,7 +742,7 @@ just text
     test 'vertical table headers use th element instead of header class' do
       input = <<-EOS
 [cols="1h,1s,1e"]
-|====
+|===
 
 |Name |Occupation| Website
 
@@ -647,7 +750,7 @@ just text
 
 |Name |Occupation| Website
 
-|====
+|===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -837,12 +940,12 @@ d|9 2+>|10
 
     test 'assigns unique column names for table with implicit column count and colspans in first row' do
       input = <<-EOS
-|====
+|===
 |                 2+| Node 0          2+| Node 1
 
 | Host processes    | Core 0 | Core 1   | Core 4 | Core 5
 | Guest processes   | Core 2 | Core 3   | Core 6 | Core 7
-|====
+|===
       EOS
 
       output = render_embedded_string input, :backend => 'docbook'
@@ -859,7 +962,7 @@ d|9 2+>|10
 
     test 'ignores cell with colspan that exceeds colspec' do
       input = <<-EOS
-[cols="1,1"]
+[cols=2*]
 |===
 3+|A
 |B
@@ -868,10 +971,12 @@ a|C
 more C
 |===
       EOS
-      output, warnings = redirect_streams {|_, err| [(render_embedded_string input), err.string] }
-      assert_css 'table', output, 1
-      assert_css 'table *', output, 0
-      assert_includes warnings, 'exceeds specified number of columns'
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_css 'table', output, 1
+        assert_css 'table *', output, 0
+        assert_message logger, :ERROR, '<stdin>: line 5: dropping cell because it exceeds specified number of columns', Hash
+      end
     end
 
     test 'paragraph, verse and literal content' do
@@ -943,7 +1048,7 @@ third paragraph
       assert_xpath %((//p[@class="tableblock"])[3][text()="third paragraph"]), result, 1
     end
 
-    test 'basic asciidoc cell' do
+    test 'basic AsciiDoc cell' do
       input = <<-EOS
 |===
 a|--
@@ -962,7 +1067,19 @@ content
       assert_css 'table.tableblock td.tableblock .openblock .paragraph', result, 1
     end
 
-    test 'doctype can be set in asciidoc table cell' do
+    test 'AsciiDoc table cell should be wrapped in div with class "content"' do
+      input = <<-EOS
+|===
+a|AsciiDoc table cell
+|===
+      EOS
+
+      result = render_embedded_string input
+      assert_css 'table.tableblock td.tableblock > div.content', result, 1
+      assert_css 'table.tableblock td.tableblock > div.content > div.paragraph', result, 1
+    end
+
+    test 'doctype can be set in AsciiDoc table cell' do
       input = <<-EOS
 |===
 a|
@@ -1024,7 +1141,7 @@ doctype={doctype}
       assert_includes result, '{backend-html5-doctype-article}'
     end
 
-    test 'asciidoc content' do
+    test 'AsciiDoc content' do
       input = <<-EOS
 [cols="1e,1,5a",frame="topbot",options="header"]
 |===
@@ -1033,9 +1150,11 @@ doctype={doctype}
 |badges |xhtml11, html5 |
 Link badges ('XHTML 1.1' and 'CSS') in document footers.
 
-NOTE: The path names of images, icons and scripts are relative path
+[NOTE]
+====
+The path names of images, icons and scripts are relative path
 names to the output document not the source document.
-
+====
 |[[X97]] docinfo, docinfo1, docinfo2 |All backends |
 These three attributes control which document information
 files will be included in the the header of the output file:
@@ -1050,23 +1169,52 @@ DocBook outputs. If the input file is th
 output file name is used.
 |===
       EOS
-      doc = document_from_string input
+      doc = document_from_string input, :sourcemap => true
       table = doc.blocks.first
       refute_nil table
       tbody = table.rows.body
       assert_equal 2, tbody.size
+      body_cell_1_2 = tbody[0][1]
+      assert_equal 5, body_cell_1_2.lineno
       body_cell_1_3 = tbody[0][2]
       refute_nil body_cell_1_3.inner_document
       assert body_cell_1_3.inner_document.nested?
       assert_equal doc, body_cell_1_3.inner_document.parent_document
       assert_equal doc.converter, body_cell_1_3.inner_document.converter
-      output = doc.render
+      assert_equal 5, body_cell_1_3.lineno
+      assert_equal 6, body_cell_1_3.inner_document.lineno
+      note = (body_cell_1_3.inner_document.find_by :context => :admonition)[0]
+      assert_equal 9, note.lineno
+      output = doc.convert :header_footer => false
 
       assert_css 'table > tbody > tr', output, 2
       assert_css 'table > tbody > tr:nth-child(1) > td:nth-child(3) div.admonitionblock', output, 1
       assert_css 'table > tbody > tr:nth-child(2) > td:nth-child(3) div.dlist', output, 1
     end
 
+    test 'should preserve leading indentation in contents of AsciiDoc table cell if contents starts with newline' do
+      input = <<-EOS
+|===
+a|
+ $ command
+a| paragraph
+|===
+      EOS
+      doc = document_from_string input, :sourcemap => true
+      table = doc.blocks[0]
+      tbody = table.rows.body
+      assert_equal 1, table.lineno
+      assert_equal 2, tbody[0][0].lineno
+      assert_equal 3, tbody[0][0].inner_document.lineno
+      assert_equal 4, tbody[1][0].lineno
+      output = doc.convert :header_footer => false
+      assert_css 'td', output, 2
+      assert_xpath '(//td)[1]//*[@class="literalblock"]', output, 1
+      assert_xpath '(//td)[2]//*[@class="paragraph"]', output, 1
+      assert_xpath '(//pre)[1][text()="$ command"]', output, 1
+      assert_xpath '(//p)[1][text()="paragraph"]', output, 1
+    end
+
     test 'preprocessor directive on first line of an AsciiDoc table cell should be processed' do
       input = <<-EOS
 |===
@@ -1074,7 +1222,7 @@ a|include::fixtures/include-file.asciido
 |===
       EOS
 
-      output = render_embedded_string input, :safe => :safe, :base_dir => File.dirname(__FILE__)
+      output = render_embedded_string input, :safe => :safe, :base_dir => testdir
       assert_match(/included content/, output)
     end
 
@@ -1096,6 +1244,31 @@ content
       assert_xpath '//a[@href="#_more"][text()="More"]', result, 1
     end
 
+    test 'should discover anchor at start of cell and register it as a reference' do
+      input = <<-EOS
+The highest peak in the Front Range is <<grays-peak>>, which tops <<mount-evans>> by just a few feet.
+
+[cols="1s,1"]
+|===
+|[[mount-evans,Mount Evans]]Mount Evans
+|14,271 feet
+
+h|[[grays-peak,Grays Peak]]
+Grays Peak
+|14,278 feet
+|===
+      EOS
+      doc = document_from_string input
+      refs = doc.catalog[:refs]
+      assert refs.key?('mount-evans')
+      assert refs.key?('grays-peak')
+      output = doc.convert :header_footer => false
+      assert_xpath '(//p)[1]/a[@href="#grays-peak"][text()="Grays Peak"]', output, 1
+      assert_xpath '(//p)[1]/a[@href="#mount-evans"][text()="Mount Evans"]', output, 1
+      assert_xpath '(//table/tbody/tr)[1]//td//a[@id="mount-evans"]', output, 1
+      assert_xpath '(//table/tbody/tr)[2]//th//a[@id="grays-peak"]', output, 1
+    end
+
     test 'footnotes should not be shared between an AsciiDoc table cell and the main document' do
       input = <<-EOS
 |===
@@ -1104,7 +1277,7 @@ a|AsciiDoc footnote:[A lightweight marku
       EOS
 
       result = render_string input
-      assert_css '#_footnote_1', result, 1
+      assert_css '#_footnotedef_1', result, 1
     end
 
     test 'callout numbers should be globally unique, including AsciiDoc table cells' do
@@ -1113,25 +1286,25 @@ a|AsciiDoc footnote:[A lightweight marku
 
 == Section 1
 
-|====
+|===
 a|
 [source, yaml]
 ----
 key: value <1>
 ----
 <1> First callout
-|====
+|===
 
 == Section 2
 
-|====
+|===
 a|
 [source, yaml]
 ----
 key: value <1>
 ----
 <1> Second callout
-|====
+|===
 
 == Section 3
 
@@ -1359,6 +1532,50 @@ plain
       assert_xpath '(/table/tbody/tr/td)[1][@style="background-color: red;"]', output, 1
       assert_xpath '(/table/tbody/tr/td)[2][@style="background-color: green;"]', output, 0
     end
+
+    test 'should warn if table block is not terminated' do
+      input = <<-EOS
+outside
+
+|===
+|
+inside
+
+still inside
+
+eof
+      EOS
+
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_xpath '/table', output, 1
+        assert_message logger, :WARN, '<stdin>: line 3: unterminated table block', Hash
+      end
+    end
+
+    test 'should show correct line number in warning about unterminated block inside AsciiDoc table cell' do
+      input = <<-EOS
+outside
+
+* list item
++
+|===
+|cell
+a|inside
+
+====
+unterminated example block
+|===
+
+eof
+      EOS
+
+      using_memory_logger do |logger|
+        output = render_embedded_string input
+        assert_xpath '//ul//table', output, 1
+        assert_message logger, :WARN, '<stdin>: line 9: unterminated example block', Hash
+      end
+    end
   end
 
   context 'DSV' do
@@ -1415,11 +1632,11 @@ single cell
 
     test 'should treat trailing colon as an empty cell' do
       input = <<-EOS
-:====
+:===
 A1:
 B1:B2
 C1:C2
-:====
+:===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -1436,11 +1653,11 @@ C1:C2
 
     test 'should treat trailing comma as an empty cell' do
       input = <<-EOS
-,====
+,===
 A1,
 B1,B2
 C1,C2
-,====
+,===
       EOS
       output = render_embedded_string input
       assert_css 'table', output, 1
@@ -1452,6 +1669,36 @@ C1,C2
       assert_xpath '/table/tbody/tr[2]/td[1]/p[text()="B1"]', output, 1
     end
 
+    test 'should preserve newlines in quoted CSV values' do
+      input = <<-EOS
+[cols="1,1,1l"]
+,===
+"A
+B
+C","one
+
+two
+
+three","do
+
+re
+
+me"
+,===
+      EOS
+      output = render_embedded_string input
+      assert_css 'table', output, 1
+      assert_css 'table > colgroup > col', output, 3
+      assert_css 'table > tbody > tr', output, 1
+      assert_xpath '/table/tbody/tr[1]/td', output, 3
+      assert_xpath %(/table/tbody/tr[1]/td[1]/p[text()="A\nB\nC"]), output, 1
+      assert_xpath '/table/tbody/tr[1]/td[2]/p', output, 3
+      assert_xpath '/table/tbody/tr[1]/td[2]/p[1][text()="one"]', output, 1
+      assert_xpath '/table/tbody/tr[1]/td[2]/p[2][text()="two"]', output, 1
+      assert_xpath '/table/tbody/tr[1]/td[2]/p[3][text()="three"]', output, 1
+      assert_xpath %(/table/tbody/tr[1]/td[3]//pre[text()="do\n\nre\n\nme"]), output, 1
+    end
+
     test 'mixed unquoted records and quoted records with escaped quotes, commas, and wrapped lines' do
       input = <<-EOS
 [format="csv",options="header"]
@@ -1473,11 +1720,31 @@ air, moon roof, loaded",4799.00
       assert_css 'table > tbody > tr', output, 6
       assert_xpath '((//tbody/tr)[1]/td)[4]/p[text()="ac, abs, moon"]', output, 1
       assert_xpath %(((//tbody/tr)[2]/td)[3]/p[text()='Venture "Extended Edition"']), output, 1
-      assert_xpath '((//tbody/tr)[4]/td)[4]/p[text()="MUST SELL! air, moon roof, loaded"]', output, 1
+      assert_xpath %(((//tbody/tr)[4]/td)[4]/p[text()="MUST SELL!\nair, moon roof, loaded"]), output, 1
       assert_xpath %(((//tbody/tr)[5]/td)[4]/p[text()='"This one#{decode_char 8217}s gonna to blow you#{decode_char 8217}re socks off," per the sticker']), output, 1
       assert_xpath %(((//tbody/tr)[6]/td)[4]/p[text()='Check it, "this one#{decode_char 8217}s gonna to blow you#{decode_char 8217}re socks off", per the sticker']), output, 1
     end
 
+    test 'should allow quotes around a CSV value to be on their own lines' do
+      input = <<-EOS
+[cols=2*]
+,===
+"
+A
+","
+B
+"
+,===
+      EOS
+      output = render_embedded_string input
+      assert_css 'table', output, 1
+      assert_css 'table > colgroup > col', output, 2
+      assert_css 'table > tbody > tr', output, 1
+      assert_xpath '/table/tbody/tr[1]/td', output, 2
+      assert_xpath '/table/tbody/tr[1]/td[1]/p[text()="A"]', output, 1
+      assert_xpath '/table/tbody/tr[1]/td[2]/p[text()="B"]', output, 1
+    end
+
     test 'csv format shorthand' do
       input = <<-EOS
 ,===
@@ -1582,7 +1849,7 @@ single cell
 |===
       EOS
       output = render_embedded_string input, :backend => 'docbook45'
-      assert output.include?('<?dbfo keep-together="auto"?>')
+      assert_includes output, '<?dbfo keep-together="auto"?>'
     end
 
     test 'table with breakable db5' do
@@ -1595,7 +1862,7 @@ single cell
 |===
       EOS
       output = render_embedded_string input, :backend => 'docbook5'
-      assert output.include?('<?dbfo keep-together="auto"?>')
+      assert_includes output, '<?dbfo keep-together="auto"?>'
     end
 
     test 'table with unbreakable db5' do
@@ -1608,7 +1875,7 @@ single cell
 |===
       EOS
       output = render_embedded_string input, :backend => 'docbook5'
-      assert output.include?('<?dbfo keep-together="always"?>')
+      assert_includes output, '<?dbfo keep-together="always"?>'
     end
 
     test 'table with unbreakable db45' do
@@ -1621,12 +1888,12 @@ single cell
 |===
       EOS
       output = render_embedded_string input, :backend => 'docbook45'
-      assert output.include?('<?dbfo keep-together="always"?>')
+      assert_includes output, '<?dbfo keep-together="always"?>'
     end
 
     test 'no implicit header row if cell in first line is quoted and spans multiple lines' do
       input = <<-EOS
-[cols=2*]
+[cols=2*l]
 ,===
 "A1
 
@@ -1640,7 +1907,7 @@ A2,B2
       assert_css 'table > thead', output, 0
       assert_css 'table > tbody', output, 1
       assert_css 'table > tbody > tr', output, 2
-      assert_xpath '(//td)[1]/p[text()="A1 A1 continued"]', output, 1
+      assert_xpath %((//td)[1]//pre[text()="A1\n\nA1 continued"]), output, 1
     end
   end
 end
diff -pruN 1.5.6.2-2/test/test_helper.rb 1.5.7-1/test/test_helper.rb
--- 1.5.6.2-2/test/test_helper.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/test_helper.rb	2018-05-05 22:54:38.000000000 +0000
@@ -1,5 +1,6 @@
 # encoding: UTF-8
-ASCIIDOCTOR_PROJECT_DIR = File.dirname File.dirname(__FILE__)
+ASCIIDOCTOR_TEST_DIR = File.expand_path File.dirname __FILE__
+ASCIIDOCTOR_PROJECT_DIR = File.dirname ASCIIDOCTOR_TEST_DIR
 Dir.chdir ASCIIDOCTOR_PROJECT_DIR
 
 if RUBY_VERSION < '1.9'
@@ -12,6 +13,7 @@ require File.join(ASCIIDOCTOR_PROJECT_DI
 
 require 'socket'
 require 'nokogiri'
+require 'tempfile'
 require 'tmpdir'
 
 autoload :FileUtils, 'fileutils'
@@ -31,7 +33,7 @@ class Minitest::Test
   end
 
   def disk_root
-    "#{windows? ? File.expand_path(__FILE__).split('/').first : nil}/"
+    %(#{windows? ? ASCIIDOCTOR_PROJECT_DIR.split('/')[0] : ''}/)
   end
 
   def empty_document options = {}
@@ -60,29 +62,20 @@ class Minitest::Test
     fixture_path(name)
   end
 
-  def fixture_path(name)
-    File.join(File.expand_path(File.dirname(__FILE__)), 'fixtures', name)
+  def testdir
+    ASCIIDOCTOR_TEST_DIR
   end
 
-  def example_document(name, opts = {})
-    document_from_string IO.read(sample_doc_path(name)), opts
+  def fixturedir
+    File.join testdir, 'fixtures'
   end
 
-  def assert_difference(expression, difference = 1, message = nil, &block)
-    expressions = [expression]
-
-    exps = expressions.map { |e|
-      e.respond_to?(:call) ? e : lambda { eval(e, block.binding) }
-    }
-    before = exps.map { |e| e.call }
-
-    yield
+  def fixture_path name
+    File.join fixturedir, name
+  end
 
-    expressions.zip(exps).each_with_index do |(code, e), i|
-      error  = "#{code.inspect} didn't change by #{difference}"
-      error  = "#{message}.\n#{error}" if message
-      assert_equal(before[i] + difference, e.call, error)
-    end
+  def example_document(name, opts = {})
+    document_from_string IO.read(sample_doc_path(name)), opts
   end
 
   def xmlnodes_at_css(css, content, count = nil)
@@ -143,6 +136,35 @@ class Minitest::Test
     end
   end
 
+  def assert_message logger, severity, expected_message, kind = String, idx = nil
+    unless idx
+      assert_equal 1, logger.messages.size
+      idx = 0
+    end
+    message = logger.messages[idx]
+    assert_equal severity, message[:severity]
+    assert_kind_of kind, message[:message]
+    if kind == String
+      actual_message = message[:message]
+    else
+      refute_nil message[:message][:source_location]
+      actual_message = message[:message].inspect
+    end
+    if expected_message.start_with? '~'
+      assert_includes actual_message, expected_message[1..-1]
+    else
+      assert_equal expected_message, actual_message
+    end
+  end
+
+  def assert_messages logger, expected_messages
+    assert_equal expected_messages.size, logger.messages.size
+    expected_messages.each_with_index do |expected_message_details, idx|
+      severity, expected_message, kind = expected_message_details
+      assert_message logger, severity, expected_message, (kind || String), idx
+    end
+  end
+
   def xmldoc_from_string(content)
     if content.match(RE_XMLNS_ATTRIBUTE)
       Nokogiri::XML::Document.parse(content)
@@ -173,10 +195,10 @@ class Minitest::Test
   def render_string(src, opts = {})
     keep_namespaces = opts.delete(:keep_namespaces)
     if keep_namespaces
-      document_from_string(src, opts).render
+      document_from_string(src, opts).convert
     else
       # this is required because nokogiri is ignorant
-      result = document_from_string(src, opts).render
+      result = document_from_string(src, opts).convert
       result = result.sub(RE_XMLNS_ATTRIBUTE, '') if result
       result
     end
@@ -184,12 +206,12 @@ class Minitest::Test
 
   def render_embedded_string(src, opts = {})
     opts[:header_footer] = false
-    document_from_string(src, opts).render
+    document_from_string(src, opts).convert
   end
 
   def render_inline_string(src, opts = {})
     opts[:doctype] = :inline
-    document_from_string(src, opts).render
+    document_from_string(src, opts).convert
   end
 
   def parse_header_metadata(source, doc = nil)
@@ -211,7 +233,6 @@ class Minitest::Test
     end
     if (template_dir = ENV['TEMPLATE_DIR'])
       opts[:template_dir] = template_dir unless opts.has_key? :template_dir
-      #opts[:template_dir] = File.join(File.dirname(__FILE__), '..', '..', 'asciidoctor-backends', 'erb') unless opts.has_key? :template_dir
     end
     nil
   end
@@ -230,14 +251,13 @@ class Minitest::Test
   end
 
   def invoke_cli_with_filenames(argv = [], filenames = [], &block)
-
     filepaths = Array.new
 
-    filenames.each { |filename|
-      if filenames.nil?|| ::Pathname.new(filename).absolute?
-        filepaths.push(filename)
+    filenames.each {|filename|
+      if filenames.nil? || ::Pathname.new(filename).absolute?
+        filepaths << filename
       else
-        filepaths.push(File.join(File.dirname(__FILE__), 'fixtures', filename))
+        filepaths << (fixture_path filename)
       end
     }
 
@@ -255,7 +275,7 @@ class Minitest::Test
     if filename.nil? || filename == '-' || ::Pathname.new(filename).absolute?
       filepath = filename
     else
-      filepath = File.join(File.dirname(__FILE__), 'fixtures', filename)
+      filepath = fixture_path filename
     end
     invoker = Asciidoctor::Cli::Invoker.new(argv + [filepath])
     if buffers
@@ -268,9 +288,14 @@ class Minitest::Test
   def redirect_streams
     old_stdout, $stdout = $stdout, (tmp_stdout = ::StringIO.new)
     old_stderr, $stderr = $stderr, (tmp_stderr = ::StringIO.new)
+    old_logger = Asciidoctor::LoggerManager.logger
+    old_logger_level = old_logger.level
+    new_logger = (Asciidoctor::LoggerManager.logger = Asciidoctor::Logger.new $stderr)
+    new_logger.level = old_logger_level
     yield tmp_stdout, tmp_stderr
   ensure
     $stdout, $stderr = old_stdout, old_stderr
+    Asciidoctor::LoggerManager.logger = old_logger
   end
 
   def resolve_localhost
@@ -278,9 +303,29 @@ class Minitest::Test
         Socket.ip_address_list.find {|addr| addr.ipv4? }.ip_address
   end
 
+  def using_memory_logger
+    old_logger = Asciidoctor::LoggerManager.logger
+    memory_logger = Asciidoctor::MemoryLogger.new
+    begin
+      Asciidoctor::LoggerManager.logger = memory_logger
+      yield memory_logger
+    ensure
+      Asciidoctor::LoggerManager.logger = old_logger
+    end
+  end
+
+  def in_verbose_mode
+    begin
+      old_verbose, $VERBOSE = $VERBOSE, true
+      yield
+    ensure
+      $VERBOSE = old_verbose
+    end
+  end
+
   def using_test_webserver host = resolve_localhost, port = 9876
     server = TCPServer.new host, port
-    base_dir = File.expand_path File.dirname __FILE__
+    base_dir = testdir
     t = Thread.new do
       while (session = server.accept)
         request = session.gets
diff -pruN 1.5.6.2-2/test/text_test.rb 1.5.7-1/test/text_test.rb
--- 1.5.6.2-2/test/text_test.rb	2018-04-08 11:16:33.000000000 +0000
+++ 1.5.7-1/test/text_test.rb	2018-05-05 22:54:38.000000000 +0000
@@ -6,25 +6,25 @@ end
 
 context "Text" do
   test "proper encoding to handle utf8 characters in document using html backend" do
-    output = example_document(:encoding).render
+    output = example_document(:encoding).convert
     assert_xpath '//p', output, 4
     assert_xpath '//a', output, 1
   end
 
   test "proper encoding to handle utf8 characters in embedded document using html backend" do
-    output = example_document(:encoding, :header_footer => false).render
+    output = example_document(:encoding, :header_footer => false).convert
     assert_xpath '//p', output, 4
     assert_xpath '//a', output, 1
   end
 
   test "proper encoding to handle utf8 characters in document using docbook45 backend" do
-    output = example_document(:encoding, :attributes => {'backend' => 'docbook45', 'xmlns' => ''}).render
+    output = example_document(:encoding, :attributes => {'backend' => 'docbook45', 'xmlns' => ''}).convert
     assert_xpath '//xmlns:simpara', output, 4
     assert_xpath '//xmlns:ulink', output, 1
   end
 
   test "proper encoding to handle utf8 characters in embedded document using docbook45 backend" do
-    output = example_document(:encoding, :header_footer => false, :attributes => {'backend' => 'docbook45'}).render
+    output = example_document(:encoding, :header_footer => false, :attributes => {'backend' => 'docbook45'}).convert
     assert_xpath '//simpara', output, 4
     assert_xpath '//ulink', output, 1
   end
@@ -37,17 +37,17 @@ context "Text" do
     doc = empty_document
     reader = Asciidoctor::PreprocessorReader.new doc, input, nil, :normalize => true
     block = Asciidoctor::Parser.next_block(reader, doc)
-    assert_xpath '//pre', block.render.gsub(/^\s*\n/, ''), 1
+    assert_xpath '//pre', block.convert.gsub(/^\s*\n/, ''), 1
   end
 
   test 'proper encoding to handle utf8 characters from included file' do
     input = <<-EOS
 include::fixtures/encoding.asciidoc[tags=romé]
     EOS
-    doc = empty_safe_document :base_dir => File.expand_path(File.dirname(__FILE__))
+    doc = empty_safe_document :base_dir => testdir
     reader = Asciidoctor::PreprocessorReader.new doc, input, nil, :normalize => true
     block = Asciidoctor::Parser.next_block(reader, doc)
-    output = block.render
+    output = block.convert
     assert_css '.paragraph', output, 1
   end
 
